/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(he){for(var e=[],u=0,N=he.length;u<N;u++)e[u]=ke[he[u]];return e};define(ke[162],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const L=new Map,R=new Map,M=new Map,b=new Map;function p(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function S(E,v){const a=E.get(v.detail);a&&(a>=0||E.set(v.detail,a+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of A)switch(E.type){case 10:p(L,E);break;case 11:case 12:S(L,E);break;case 21:p(R,E);break;case 22:S(R,E);break;case 33:p(M,E);break;case 34:S(M,E);break;case 31:p(b,E);break;case 32:S(b,E);break}let P=0;M.forEach(E=>P+=E);function $(E){const v=[];return E.forEach((a,m)=>v.push([m,a])),v}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(M),nodeEval:$(b),nodeRequireTotal:P}}static toMarkdownTable(L,R){let M="";const b=[];return L.forEach((p,S)=>{b[S]=p.length}),R.forEach(p=>{p.forEach((S,A)=>{typeof S>"u"&&(S=p[A]="-");const P=S.toString().length;b[A]=Math.max(P,b[A])})}),L.forEach((p,S)=>{M+=`| ${p+" ".repeat(b[S]-p.toString().length)} `}),M+=`|
`,L.forEach((p,S)=>{M+=`| ${"-".repeat(b[S])} `}),M+=`|
`,R.forEach(p=>{p.forEach((S,A)=>{typeof S<"u"&&(M+=`| ${S+" ".repeat(b[A]-S.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[163],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=b,e.$lb=p,e.$nb=A,e.$ob=P,e.$pb=$,e.$qb=E,e.$rb=v;function u(a,m){const o=N(a,m);if(o!==-1)return a[o]}function N(a,m,o=a.length-1){for(let n=o;n>=0;n--){const i=a[n];if(m(i))return n}return-1}function L(a,m){const o=R(a,m);return o===-1?void 0:a[o]}function R(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?i=s+1:r=s}return i-1}function M(a,m){const o=b(a,m);return o===a.length?void 0:a[o]}function b(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?r=s:i=s+1}return i}function p(a,m,o=0,n=a.length){const i=b(a,m,o,n);return i===a.length?-1:i}class S{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=R(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=S;function A(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>0&&(o=i)}return o}function P(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>=0&&(o=i)}return o}function $(a,m){return A(a,(o,n)=>-m(o,n))}function E(a,m){if(a.length===0)return-1;let o=0;for(let n=1;n<a.length;n++){const i=a[n];m(i,a[o])>0&&(o=n)}return o}function v(a,m){for(const o of a){const n=m(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=L,e.$N=R;function u(M,b){const p=Object.create(null);for(const S of M){const A=b(S);let P=p[A];P||(P=p[A]=[]),P.push(S)}return p}function N(M,b){const p=[],S=[];for(const A of M)b.has(A)||p.push(A);for(const A of b)M.has(A)||S.push(A);return{removed:p,added:S}}function L(M,b){const p=[],S=[];for(const[A,P]of M)b.has(A)||p.push(P);for(const[A,P]of b)M.has(A)||S.push(P);return{removed:p,added:S}}function R(M,b){const p=new Set;for(const S of b)M.has(S)&&p.add(S);return p}}),define(ke[55],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=N,e.$Sh=L,e.$Th=R;function u(M){return(b,p,S)=>{let A=null,P=null;if(typeof S.value=="function"?(A="value",P=S.value):typeof S.get=="function"&&(A="get",P=S.get),!P)throw new Error("not supported");S[A]=M(P,p)}}function N(M,b,p){let S=null,A=null;if(typeof p.value=="function"?(S="value",A=p.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",A=p.get),!A)throw new Error("not supported");const P=`$memoize$${b}`;p[S]=function(...$){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[P]}}function L(M,b,p){return u((S,A)=>{const P=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...E){this[$]||(this[$]=p?p():void 0),clearTimeout(this[P]),b&&(this[$]=b(this[$],...E),E=[this[$]]),this[P]=setTimeout(()=>{S.apply(this,E),this[$]=p?p():void 0},M)}})}function R(M,b,p){return u((S,A)=>{const P=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...a){if(this[$]||(this[$]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...a)),this[v])return;const m=this[E]+M;m<=Date.now()?(this[E]=Date.now(),S.apply(this,[this[$]]),this[$]=p?p():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),S.apply(this,[this[$]]),this[$]=p?p():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=b,e.$4=S,e.$6=P,e.$7=$,e.$8=E,e.$0=a;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(s){e.$X.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){S(s)||e.$X.onUnexpectedError(s)}function M(s){S(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const p="Canceled";function S(s){return s instanceof A?!0:s instanceof Error&&s.name===p&&s.message===p}class A extends Error{constructor(){super(p),this.name=this.message}}e.$5=A;function P(){const s=new Error(p);return s.name=s.message,s}function $(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,163]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=b,e.$wb=p,e.$xb=S,e.$yb=A,e.$zb=P,e.$Ab=$,e.$Bb=E,e.$Cb=v,e.$Db=a,e.$Eb=m,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=c,e.$Ob=h,e.$Pb=g,e.$Qb=D,e.$Rb=w,e.$Sb=k,e.$Tb=y,e.$Ub=C,e.$Vb=I,e.$Wb=z,e.$Xb=j,e.$Yb=F,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=H,e.$4b=X,e.$5b=x,e.$6b=Y,e.$7b=ie,e.$8b=pe,e.$$b=U;function L(oe,ae=0){return oe[oe.length-(1+ae)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function M(oe,ae,re=(K,te)=>K===te){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let K=0,te=oe.length;K<te;K++)if(!re(oe[K],ae[K]))return!1;return!0}function b(oe,ae){const re=oe.length-1;ae<re&&(oe[ae]=oe[re]),oe.pop()}function p(oe,ae,re){return S(oe.length,K=>re(oe[K],ae))}function S(oe,ae){let re=0,K=oe-1;for(;re<=K;){const te=(re+K)/2|0,le=ae(te);if(le<0)re=te+1;else if(le>0)K=te-1;else return te}return-(re+1)}function A(oe,ae,re){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const K=ae[Math.floor(ae.length*Math.random())],te=[],le=[],de=[];for(const Ae of ae){const me=re(Ae,K);me<0?te.push(Ae):me>0?le.push(Ae):de.push(Ae)}return oe<te.length?A(oe,te,re):oe<te.length+de.length?de[0]:A(oe-(te.length+de.length),le,re)}function P(oe,ae){const re=[];let K;for(const te of oe.slice(0).sort(ae))!K||ae(K[0],te)!==0?(K=[te],re.push(K)):K.push(te);return re}function*$(oe,ae){let re,K;for(const te of oe)K!==void 0&&ae(K,te)?re.push(te):(re&&(yield re),re=[te]),K=te;re&&(yield re)}function E(oe,ae){for(let re=0;re<=oe.length;re++)ae(re===0?void 0:oe[re-1],re===oe.length?void 0:oe[re])}function v(oe,ae){for(let re=0;re<oe.length;re++)ae(re===0?void 0:oe[re-1],oe[re],re+1===oe.length?void 0:oe[re+1])}function a(oe,ae,re){const K=[];function te(Ae,me,Pe){if(me===0&&Pe.length===0)return;const Re=K[K.length-1];Re&&Re.start+Re.deleteCount===Ae?(Re.deleteCount+=me,Re.toInsert.push(...Pe)):K.push({start:Ae,deleteCount:me,toInsert:Pe})}let le=0,de=0;for(;;){if(le===oe.length){te(le,0,ae.slice(de));break}if(de===ae.length){te(le,oe.length-le,[]);break}const Ae=oe[le],me=ae[de],Pe=re(Ae,me);Pe===0?(le+=1,de+=1):Pe<0?(te(le,1,[]),le+=1):Pe>0&&(te(le,0,[me]),de+=1)}return K}function m(oe,ae,re){const K=a(oe,ae,re),te=[],le=[];for(const de of K)te.push(...oe.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:te,added:le}}function o(oe,ae,re){if(re===0)return[];const K=oe.slice(0,re).sort(ae);return i(oe,ae,K,re,oe.length),K}function n(oe,ae,re,K,te){return re===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Ae=oe.length,me=oe.slice(0,re).sort(ae);for(let Pe=re,Re=Math.min(re+K,Ae);Pe<Ae;Pe=Re,Re=Math.min(Re+K,Ae)){if(Pe>re&&await new Promise(Fe=>setTimeout(Fe)),te&&te.isCancellationRequested)throw new u.$5;i(oe,ae,me,Pe,Re)}return me})().then(le,de)})}function i(oe,ae,re,K,te){for(const le=re.length;K<te;K++){const de=oe[K];if(ae(de,re[le-1])<0){re.pop();const Ae=(0,N.$kb)(re,me=>ae(de,me)<0);re.splice(Ae,0,de)}}}function r(oe){return oe.filter(ae=>!!ae)}function s(oe){let ae=0;for(let re=0;re<oe.length;re++)oe[re]&&(oe[ae]=oe[re],ae+=1);oe.length=ae}function t(oe,ae,re){oe.splice(re,0,oe.splice(ae,1)[0])}function f(oe){return!Array.isArray(oe)||oe.length===0}function d(oe){return Array.isArray(oe)&&oe.length>0}function l(oe,ae=re=>re){const re=new Set;return oe.filter(K=>{const te=ae(K);return re.has(te)?!1:(re.add(te),!0)})}function c(oe){const ae=new Set;return re=>{const K=oe(re);return ae.has(K)?!1:(ae.add(K),!0)}}function h(oe,ae){return oe.length>0?oe[0]:ae}function g(oe,ae){return oe.length>0?oe[oe.length-1]:ae}function D(oe,ae,re=(K,te)=>K===te){let K=0;for(let te=0,le=Math.min(oe.length,ae.length);te<le&&re(oe[te],ae[te]);te++)K++;return K}function w(oe){return[].concat(...oe)}function k(oe,ae){let re=typeof ae=="number"?oe:0;typeof ae=="number"?re=oe:(re=0,ae=oe);const K=[];if(re<=ae)for(let te=re;te<ae;te++)K.push(te);else for(let te=re;te>ae;te--)K.push(te);return K}function y(oe,ae,re){return oe.reduce((K,te)=>(K[ae(te)]=re?re(te):te,K),Object.create(null))}function C(oe,ae){return oe.push(ae),()=>I(oe,ae)}function I(oe,ae){const re=oe.indexOf(ae);if(re>-1)return oe.splice(re,1),ae}function z(oe,ae,re){const K=oe.slice(0,ae),te=oe.slice(ae);return K.concat(re,te)}function j(oe,ae){let re;if(typeof ae=="number"){let K=ae;re=()=>{const te=Math.sin(K++)*179426549;return te-Math.floor(te)}}else re=Math.random;for(let K=oe.length-1;K>0;K-=1){const te=Math.floor(re()*(K+1)),le=oe[K];oe[K]=oe[te],oe[te]=le}}function F(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.unshift(ae))}function O(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.push(ae))}function T(oe,ae){for(const re of ae)oe.push(re)}function B(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}function H(oe){return Array.isArray(oe)?oe:[oe]}function X(oe){return oe[Math.floor(Math.random()*oe.length)]}function x(oe,ae,re){const K=Z(oe,ae),te=oe.length,le=re.length;oe.length=te+le;for(let de=te-1;de>=K;de--)oe[de+le]=oe[de];for(let de=0;de<le;de++)oe[de+K]=re[de]}function Y(oe,ae,re,K){const te=Z(oe,ae);let le=oe.splice(te,re);return le===void 0&&(le=[]),x(oe,te,K),le}function Z(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var ce;(function(oe){function ae(le){return le<0}oe.isLessThan=ae;function re(le){return le<=0}oe.isLessThanOrEqual=re;function K(le){return le>0}oe.isGreaterThan=K;function te(le){return le===0}oe.isNeitherLessOrGreaterThan=te,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ie(oe,ae){return(re,K)=>ae(oe(re),oe(K))}function pe(...oe){return(ae,re)=>{for(const K of oe){const te=K(ae,re);if(!ce.isNeitherLessOrGreaterThan(te))return te}return ce.neitherLessOrGreaterThan}}const Ce=(oe,ae)=>oe-ae;e.$9b=Ce;const _=(oe,ae)=>(0,e.$9b)(oe?1:0,ae?1:0);e.$0b=_;function U(oe){return(ae,re)=>-oe(ae,re)}class ne{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let re=this.c;for(;re<this.g.length&&ae(this.g[re]);)re++;const K=re===this.c?null:this.g.slice(this.c,re);return this.c=re,K}takeFromEndWhile(ae){let re=this.d;for(;re>=0&&ae(this.g[re]);)re--;const K=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const re=this.g.slice(this.c,this.c+ae);return this.c+=ae,re}}e.$_b=ne;class be{static{this.empty=new be(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(re=>(ae(re),!0))}toArray(){const ae=[];return this.iterate(re=>(ae.push(re),!0)),ae}filter(ae){return new be(re=>this.iterate(K=>ae(K)?re(K):!0))}map(ae){return new be(re=>this.iterate(K=>re(ae(K))))}some(ae){let re=!1;return this.iterate(K=>(re=ae(K),!re)),re}findFirst(ae){let re;return this.iterate(K=>ae(K)?(re=K,!1):!0),re}findLast(ae){let re;return this.iterate(K=>(ae(K)&&(re=K),!0)),re}findLastMaxBy(ae){let re,K=!0;return this.iterate(te=>((K||ce.isGreaterThan(ae(te,re)))&&(K=!1,re=te),!0)),re}}e.$ac=be;class De{constructor(ae){this.c=ae}static createSortPermutation(ae,re){const K=Array.from(ae.keys()).sort((te,le)=>re(ae[te],ae[le]));return new De(K)}apply(ae){return ae.map((re,K)=>ae[this.c[K]])}inverse(){const ae=this.c.slice();for(let re=0;re<this.c.length;re++)ae[this.c[re]]=re;return new De(ae)}}e.$bc=De}),define(ke[62],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=b,e.$gd=p;function N(S,A){if(!S)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(S,A="Unreachable"){throw new Error(A)}function R(S){if(!S)throw new u.$cb("Assertion Failed")}function M(S){S||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(S){if(!S()){debugger;S(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function p(S,A){let P=0;for(;P<S.length-1;){const $=S[P],E=S[P+1];if(!A($,E))return!1;P++}return!0}}),define(ke[74],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,L){const R=this;let M=!1,b;return function(){if(M)return b;if(M=!0,L)try{b=N.apply(R,arguments)}finally{L()}else b=N.apply(R,arguments);return b}}}),define(ke[124],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;class u{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$cP=u,e.$dP=new u("id#")}),define(ke[45],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*b(t){yield t}N.single=b;function p(t){return L(t)?t:b(t)}N.wrap=p;function S(t){return t||R}N.from=S;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}N.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=P;function $(t){return t[Symbol.iterator]().next().value}N.first=$;function E(t,f){for(const d of t)if(f(d))return!0;return!1}N.some=E;function v(t,f){for(const d of t)if(f(d))return d}N.find=v;function*a(t,f){for(const d of t)f(d)&&(yield d)}N.filter=a;function*m(t,f){let d=0;for(const l of t)yield f(l,d++)}N.map=m;function*o(...t){for(const f of t)yield*f}N.concat=o;function n(t,f,d){let l=d;for(const c of t)l=f(l,c);return l}N.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}N.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let c=0;c<f;c++){const h=l.next();if(h.done)return[d,N.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}N.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}N.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[164],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=M,e.$zn=P,e.$An=$,e.$Bn=E,e.$Cn=v,e.$Dn=a,e.$En=m,e.$Fn=o,e.$Gn=n,e.$Hn=i,e.$In=r,e.$Jn=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,f=!1){let d=0;const l=t.length;let c="",h=0,g=16,D=0;function w(F){let O=0,T=0;for(;O<F;){const B=t.charCodeAt(d);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;d++,O++}return O<F&&(T=-1),T}function k(F){d=F,c="",h=0,g=16,D=0}function y(){const F=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&S(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&S(t.charCodeAt(d)))for(d++;d<t.length&&S(t.charCodeAt(d));)d++;else return D=3,t.substring(F,d);let O=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&S(t.charCodeAt(d))){for(d++;d<t.length&&S(t.charCodeAt(d));)d++;O=d}else D=3;return t.substring(F,O)}function C(){let F="",O=d;for(;;){if(d>=l){F+=t.substring(O,d),D=2;break}const T=t.charCodeAt(d);if(T===34){F+=t.substring(O,d),d++;break}if(T===92){if(F+=t.substring(O,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=w(4);H>=0?F+=String.fromCharCode(H):D=4;break}default:D=5}O=d;continue}if(T>=0&&T<=31)if(p(T)){F+=t.substring(O,d),D=2;break}else D=6;d++}return F}function I(){if(c="",D=0,h=d,d>=l)return h=l,g=17;let F=t.charCodeAt(d);if(b(F)){do d++,c+=String.fromCharCode(F),F=t.charCodeAt(d);while(b(F));return g=15}if(p(F))return d++,c+=String.fromCharCode(F),F===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),g=14;switch(F){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,c=C(),g=10;case 47:{const O=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!p(t.charCodeAt(d));)d++;return c=t.substring(O,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const T=l-1;let B=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,D=1),c=t.substring(O,d),g=13}return c+=String.fromCharCode(F),d++,g=16}case 45:if(c+=String.fromCharCode(F),d++,d===l||!S(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=y(),g=11;default:for(;d<l&&z(F);)d++,F=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(F),d++,g=16}}function z(F){if(b(F)||p(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let F;do F=I();while(F>=12&&F<=15);return F}return{setPosition:k,getPosition:()=>d,scan:f?j:I,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,f){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(w,k,y,C){h.value=w,h.offset=k,h.length=y,h.type=C,h.colonOffset=void 0,c=h}try{i(t,{onObjectBegin:(w,k)=>{if(f<=w)throw l;c=void 0,g=f>w,d.push("")},onObjectProperty:(w,k,y)=>{if(f<k||(D(w,k,y,"property"),d[d.length-1]=w,f<=k+y))throw l},onObjectEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onArrayBegin:(w,k)=>{if(f<=w)throw l;c=void 0,d.push(0)},onArrayEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onLiteralValue:(w,k,y)=>{if(f<k||(D(w,k,y,s(w)),f<=k+y))throw l},onSeparator:(w,k,y)=>{if(f<=k)throw l;if(w===":"&&c&&c.type==="property")c.colonOffset=k,g=!1,c=void 0;else if(w===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(g=!0,d[d.length-1]=""),c=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:c,isAtPropertyKey:g,matches:w=>{let k=0;for(let y=0;k<w.length&&y<d.length;y++)if(w[k]===d[y]||w[k]==="*")k++;else if(w[k]!=="**")return!1;return k===w.length}}}function $(t,f=[],d=R.DEFAULT){let l=null,c=[];const h=[];function g(w){Array.isArray(c)?c.push(w):l!==null&&(c[l]=w)}return i(t,{onObjectBegin:()=>{const w={};g(w),h.push(c),c=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(c),c=w,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d),c[0]}function E(t,f=[],d=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,k,y)=>{l=h({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:k,length:y,parent:l})},onObjectEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onArrayBegin:(w,k)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onLiteralValue:(w,k,y)=>{h({type:s(w),offset:k,length:y,parent:l,value:w}),c(k+y)},onSeparator:(w,k,y)=>{l.type==="property"&&(w===":"?l.colonOffset=k:w===","&&c(k))},onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d);const D=l.children[0];return D&&delete D.parent,D}function v(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=f;c++){const h=n(l[c],f,d);if(h)return h}return t}}function i(t,f,d=R.DEFAULT){const l=M(t,!1);function c(ie){return ie?()=>ie(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ie){return ie?pe=>ie(pe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=c(f.onObjectBegin),D=h(f.onObjectProperty),w=c(f.onObjectEnd),k=c(f.onArrayBegin),y=c(f.onArrayEnd),C=h(f.onLiteralValue),I=h(f.onSeparator),z=c(f.onComment),j=h(f.onError),F=d&&d.disallowComments,O=d&&d.allowTrailingComma;function T(){for(;;){const ie=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ie){case 12:case 13:F?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return ie}}}function B(ie,pe=[],Ce=[]){if(j(ie),pe.length+Ce.length>0){let _=l.getToken();for(;_!==17;){if(pe.indexOf(_)!==-1){T();break}else if(Ce.indexOf(_)!==-1)break;_=T()}}}function H(ie){const pe=l.getTokenValue();return ie?C(pe):D(pe),T(),!0}function X(){switch(l.getToken()){case 11:{let ie=0;try{ie=JSON.parse(l.getTokenValue()),typeof ie!="number"&&(B(2),ie=0)}catch{B(2)}C(ie);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function x(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(I(":"),T(),ce()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Y(){g(),T();let ie=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ie||B(4,[],[]),I(","),T(),l.getToken()===2&&O)break}else ie&&B(6,[],[]);x()||B(4,[],[2,5]),ie=!0}return w(),l.getToken()!==2?B(7,[2],[]):T(),!0}function Z(){k(),T();let ie=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ie||B(4,[],[]),I(","),T(),l.getToken()===4&&O)break}else ie&&B(6,[],[]);ce()||B(4,[],[4,5]),ie=!0}return y(),l.getToken()!==4?B(8,[4],[]):T(),!0}function ce(){switch(l.getToken()){case 3:return Z();case 1:return Y();case 10:return H(!0);default:return X()}}return T(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):ce()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=M(t),l=[];let c,h=0,g;do switch(g=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==g&&l.push(t.substring(h,g)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(c!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(R){this.element=R,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let R=this.a;for(;R!==u.Undefined;){const M=R.next;R.prev=u.Undefined,R.next=u.Undefined,R=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const b=new u(R);if(this.a===u.Undefined)this.a=b,this.b=b;else if(M){const S=this.b;this.b=b,b.prev=S,S.next=b}else{const S=this.a;this.a=b,b.next=S,S.prev=b}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==u.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==u.Undefined&&R.next!==u.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===u.Undefined&&R.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):R.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):R.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==u.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(ke[27],Ee([1,0]),function(he,e){"use strict";var u,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=b,e.$Ic=n;function R(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function M(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class p{constructor(r,s){this.uri=r,this.value=s}}function S(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(S(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new p(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class P{constructor(r,s){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class E{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=E;class v extends E{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,45]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=P,e.$Mc=$,e.$Nc=a,e.$Oc=m,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const b=!1;let p=null;class S{constructor(){this.b=new Map}static{this.a=0}c(C){let I=this.b.get(C);return I||(I={parent:null,source:null,isSingleton:!1,value:C,idx:S.a++},this.b.set(C,I)),I}trackDisposable(C){const I=this.c(C);I.source||(I.source=new Error().stack)}setParent(C,I){const z=this.c(C);z.parent=I}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,I){const z=I.get(C);if(z)return z;const j=C.parent?this.f(this.c(C.parent),I):C;return I.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,I){let z;if(I)z=I;else{const B=new Map,H=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,B).isSingleton);if(H.length===0)return;const X=new Set(H.map(x=>x.value));if(z=H.filter(x=>!(x.parent&&X.has(x.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function j(B){function H(x,Y){for(;x.length>0&&Y.some(Z=>typeof Z=="string"?Z===x[0]:x[0].match(Z));)x.shift()}const X=B.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return H(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const F=new L.$Hc;for(const B of z){const H=j(B);for(let X=0;X<=H.length;X++)F.add(H.slice(0,X).join(`
`),B)}z.sort((0,u.$7b)(B=>B.idx,u.$9b));let O="",T=0;for(const B of z.slice(0,C)){T++;const H=j(B),X=[];for(let x=0;x<H.length;x++){let Y=H[x];Y=`(shared with ${F.get(H.slice(0,x+1).join(`
`)).size}/${z.length} leaks) at ${Y}`;const ce=F.get(H.slice(0,x).join(`
`)),ie=(0,N.$K)([...ce].map(pe=>j(pe)[x]),pe=>pe);delete ie[H[x]];for(const[pe,Ce]of Object.entries(ie))X.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${pe}`);X.unshift(Y)}O+=`


==================== Leaking disposable ${T}/${z.length}: ${B.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return z.length>C&&(O+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:O}}}e.$Jc=S;function A(y){p=y}if(b){const y="__is_disposable_tracked__";A(new class{trackDisposable(C){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[y]||console.log(I)},3e3)}setParent(C,I){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsSingleton(C){}})}function P(y){return p?.trackDisposable(y),y}function $(y){p?.markAsDisposed(y)}function E(y,C){p?.setParent(y,C)}function v(y,C){if(p)for(const I of y)p.setParent(I,C)}function a(y){return p?.markAsSingleton(y),y}function m(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(M.Iterable.is(y)){const C=[];for(const I of y)if(I)try{I.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const C of y)m(C)&&C.dispose();return[]}function i(...y){const C=r(()=>o(y));return v(y,C),C}function r(y){const C=P({dispose:(0,R.$db)(()=>{$(C),y()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return E(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),E(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,P(this),E(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&E(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&E(C,null),C}}e.$Vc=f;class d{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let I=C;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Yc=c;class h{constructor(){this.a=new Map}acquire(C,...I){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...I)},this.a.set(C,z));const{object:j}=z,F=(0,R.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:j,dispose:F}}}e.$Zc=h;class g{constructor(C){this.a=C}async acquire(C,...I){const z=this.a.acquire(C,...I);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(j){throw z.dispose(),j}}}e.$1c=g;class D{constructor(C){this.object=C}dispose(){}}e.$2c=D;function w(y){const C=new s;try{y(C)}finally{C.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,I,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,I)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),function(he,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(oe,ae){for(var re=0;re<ae.length;re++){var K=ae[re];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(oe,K.key,K)}}function u(oe,ae,re){return ae&&e(oe.prototype,ae),re&&e(oe,re),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function N(oe,ae){if(oe){if(typeof oe=="string")return L(oe,ae);var re=Object.prototype.toString.call(oe).slice(8,-1);if(re==="Object"&&oe.constructor&&(re=oe.constructor.name),re==="Map"||re==="Set")return Array.from(oe);if(re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(re))return L(oe,ae)}}function L(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var re=0,K=new Array(ae);re<ae;re++)K[re]=oe[re];return K}function R(oe,ae){var re=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(re)return(re=re.call(oe)).next.bind(re);if(Array.isArray(oe)||(re=N(oe))||ae&&oe&&typeof oe.length=="number"){re&&(oe=re);var K=0;return function(){return K>=oe.length?{done:!0}:{done:!1,value:oe[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function b(oe){he.defaults=oe}var p=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ae){return $[ae]};function v(oe,ae){if(ae){if(p.test(oe))return oe.replace(S,E)}else if(A.test(oe))return oe.replace(P,E);return oe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(oe){return oe.replace(a,function(ae,re){return re=re.toLowerCase(),re==="colon"?":":re.charAt(0)==="#"?re.charAt(1)==="x"?String.fromCharCode(parseInt(re.substring(2),16)):String.fromCharCode(+re.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var re={replace:function(te,le){return le=le.source||le,le=le.replace(o,"$1"),oe=oe.replace(te,le),re},getRegex:function(){return new RegExp(oe,ae)}};return re}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(oe,ae,re){if(oe){var K;try{K=decodeURIComponent(m(re)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ae&&!r.test(re)&&(re=c(ae,re));try{re=encodeURI(re).replace(/%25/g,"%")}catch{return null}return re}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(oe,ae){t[" "+oe]||(f.test(oe)?t[" "+oe]=oe+"/":t[" "+oe]=w(oe,"/",!0)),oe=t[" "+oe];var re=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?re?ae:oe.replace(d,"$1")+ae:ae.charAt(0)==="/"?re?ae:oe.replace(l,"$1")+ae:oe+ae}var h={exec:function(){}};function g(oe){for(var ae=1,re,K;ae<arguments.length;ae++){re=arguments[ae];for(K in re)Object.prototype.hasOwnProperty.call(re,K)&&(oe[K]=re[K])}return oe}function D(oe,ae){var re=oe.replace(/\|/g,function(le,de,Ae){for(var me=!1,Pe=de;--Pe>=0&&Ae[Pe]==="\\";)me=!me;return me?"|":" |"}),K=re.split(/ \|/),te=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ae)K.splice(ae);else for(;K.length<ae;)K.push("");for(;te<K.length;te++)K[te]=K[te].trim().replace(/\\\|/g,"|");return K}function w(oe,ae,re){var K=oe.length;if(K===0)return"";for(var te=0;te<K;){var le=oe.charAt(K-te-1);if(le===ae&&!re)te++;else if(le!==ae&&re)te++;else break}return oe.slice(0,K-te)}function k(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var re=oe.length,K=0,te=0;te<re;te++)if(oe[te]==="\\")te++;else if(oe[te]===ae[0])K++;else if(oe[te]===ae[1]&&(K--,K<0))return te;return-1}function y(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(oe,ae){if(ae<1)return"";for(var re="";ae>1;)ae&1&&(re+=oe),ae>>=1,oe+=oe;return re+oe}function I(oe,ae,re,K){var te=ae.href,le=ae.title?v(ae.title):null,de=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:re,href:te,title:le,text:de,tokens:K.inlineTokens(de)};return K.state.inLink=!1,Ae}return{type:"image",raw:re,href:te,title:le,text:v(de)}}function z(oe,ae){var re=oe.match(/^(\s+)(?:```)/);if(re===null)return ae;var K=re[1];return ae.split(`
`).map(function(te){var le=te.match(/^\s+/);if(le===null)return te;var de=le[0];return de.length>=K.length?te.slice(K.length):te}).join(`
`)}var j=function(){function oe(re){this.options=re||he.defaults}var ae=oe.prototype;return ae.space=function(K){var te=this.rules.block.newline.exec(K);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ae.code=function(K){var te=this.rules.block.code.exec(K);if(te){var le=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?le:w(le,`
`)}}},ae.fences=function(K){var te=this.rules.block.fences.exec(K);if(te){var le=te[0],de=z(le,te[3]||"");return{type:"code",raw:le,lang:te[2]?te[2].trim():te[2],text:de}}},ae.heading=function(K){var te=this.rules.block.heading.exec(K);if(te){var le=te[2].trim();if(/#$/.test(le)){var de=w(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:le,tokens:this.lexer.inline(le)}}},ae.hr=function(K){var te=this.rules.block.hr.exec(K);if(te)return{type:"hr",raw:te[0]}},ae.blockquote=function(K){var te=this.rules.block.blockquote.exec(K);if(te){var le=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ae.list=function(K){var te=this.rules.block.list.exec(K);if(te){var le,de,Ae,me,Pe,Re,Fe,V,W,Q,J,fe,we=te[1].trim(),ze=we.length>1,Ve={type:"list",raw:"",ordered:ze,start:ze?+we.slice(0,-1):"",loose:!1,items:[]};we=ze?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=ze?we:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(fe=!1,!(!(te=Xe.exec(K))||this.rules.block.hr.test(K)));){if(le=te[0],K=K.substring(le.length),V=te[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(me=2,J=V.trimLeft()):(me=te[2].search(/[^ ]/),me=me>4?1:me,J=V.slice(me),me+=te[1].length),Re=!1,!V&&/^ *$/.test(W)&&(le+=W+`
`,K=K.substring(W.length+1),fe=!0),!fe)for(var st=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");K&&(Q=K.split(`
`,1)[0],V=Q,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(V)||rt.test(V)||st.test(V)||ot.test(K)));){if(V.search(/[^ ]/)>=me||!V.trim())J+=`
`+V.slice(me);else if(!Re)J+=`
`+V;else break;!Re&&!V.trim()&&(Re=!0),le+=Q+`
`,K=K.substring(Q.length+1)}Ve.loose||(Fe?Ve.loose=!0:/\n *\n *$/.test(le)&&(Fe=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(J),de&&(Ae=de[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Ae,loose:!1,text:J}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=J.trimRight(),Ve.raw=Ve.raw.trimRight();var Se=Ve.items.length;for(Pe=0;Pe<Se;Pe++){this.lexer.state.top=!1,Ve.items[Pe].tokens=this.lexer.blockTokens(Ve.items[Pe].text,[]);var Be=Ve.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),Ge=Be.every(function(Le){for(var Ye=Le.raw.split(""),se=0,ue=R(Ye),Ie;!(Ie=ue()).done;){var Ke=Ie.value;if(Ke===`
`&&(se+=1),se>1)return!0}return!1});!Ve.loose&&Be.length&&Ge&&(Ve.loose=!0,Ve.items[Pe].loose=!0)}return Ve}},ae.html=function(K){var te=this.rules.block.html.exec(K);if(te){var le={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},ae.def=function(K){var te=this.rules.block.def.exec(K);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var le=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:te[0],href:te[2],title:te[3]}}},ae.table=function(K){var te=this.rules.block.table.exec(K);if(te){var le={type:"table",header:D(te[1]).map(function(Fe){return{text:Fe}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=te[0];var de=le.align.length,Ae,me,Pe,Re;for(Ae=0;Ae<de;Ae++)/^ *-+: *$/.test(le.align[Ae])?le.align[Ae]="right":/^ *:-+: *$/.test(le.align[Ae])?le.align[Ae]="center":/^ *:-+ *$/.test(le.align[Ae])?le.align[Ae]="left":le.align[Ae]=null;for(de=le.rows.length,Ae=0;Ae<de;Ae++)le.rows[Ae]=D(le.rows[Ae],le.header.length).map(function(Fe){return{text:Fe}});for(de=le.header.length,me=0;me<de;me++)le.header[me].tokens=this.lexer.inline(le.header[me].text);for(de=le.rows.length,me=0;me<de;me++)for(Re=le.rows[me],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=this.lexer.inline(Re[Pe].text);return le}}},ae.lheading=function(K){var te=this.rules.block.lheading.exec(K);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ae.paragraph=function(K){var te=this.rules.block.paragraph.exec(K);if(te){var le=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:le,tokens:this.lexer.inline(le)}}},ae.text=function(K){var te=this.rules.block.text.exec(K);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ae.escape=function(K){var te=this.rules.inline.escape.exec(K);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ae.tag=function(K){var te=this.rules.inline.tag.exec(K);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ae.link=function(K){var te=this.rules.inline.link.exec(K);if(te){var le=te[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=w(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ae=k(te[2],"()");if(Ae>-1){var me=te[0].indexOf("!")===0?5:4,Pe=me+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,Pe).trim(),te[3]=""}}var Re=te[2],Fe="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);V&&(Re=V[1],Fe=V[3])}else Fe=te[3]?te[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),I(te,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ae.reflink=function(K,te){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=te[de.toLowerCase()],!de||!de.href){var Ae=le[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return I(le,de,le[0],this.lexer)}},ae.emStrong=function(K,te,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(K);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=de[1]||de[2]||"";if(!Ae||Ae&&(le===""||this.rules.inline.punctuation.exec(le))){var me=de[0].length-1,Pe,Re,Fe=me,V=0,W=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,te=te.slice(-1*K.length+me);(de=W.exec(te))!=null;)if(Pe=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Pe){if(Re=Pe.length,de[3]||de[4]){Fe+=Re;continue}else if((de[5]||de[6])&&me%3&&!((me+Re)%3)){V+=Re;continue}if(Fe-=Re,!(Fe>0)){if(Re=Math.min(Re,Re+Fe+V),Math.min(me,Re)%2){var Q=K.slice(1,me+de.index+Re);return{type:"em",raw:K.slice(0,me+de.index+Re+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=K.slice(2,me+de.index+Re-1);return{type:"strong",raw:K.slice(0,me+de.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ae.codespan=function(K){var te=this.rules.inline.code.exec(K);if(te){var le=te[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ae=/^ /.test(le)&&/ $/.test(le);return de&&Ae&&(le=le.substring(1,le.length-1)),le=v(le,!0),{type:"codespan",raw:te[0],text:le}}},ae.br=function(K){var te=this.rules.inline.br.exec(K);if(te)return{type:"br",raw:te[0]}},ae.del=function(K){var te=this.rules.inline.del.exec(K);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ae.autolink=function(K,te){var le=this.rules.inline.autolink.exec(K);if(le){var de,Ae;return le[2]==="@"?(de=v(this.options.mangle?te(le[1]):le[1]),Ae="mailto:"+de):(de=v(le[1]),Ae=de),{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ae.url=function(K,te){var le;if(le=this.rules.inline.url.exec(K)){var de,Ae;if(le[2]==="@")de=v(this.options.mangle?te(le[0]):le[0]),Ae="mailto:"+de;else{var me;do me=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(me!==le[0]);de=v(le[0]),le[1]==="www."?Ae="http://"+de:Ae=de}return{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ae.inlineText=function(K,te){var le=this.rules.inline.text.exec(K);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):v(le[0]):le[0]:de=v(this.options.smartypants?te(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},oe}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=n(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=n(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=n(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=n(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=n(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=g({},F),F.gfm=g({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=n(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=g({},F.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(F._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",F._label).getRegex(),O.nolink=n(O.nolink).replace("ref",F._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=g({},O),O.pedantic=g({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=g({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=g({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var ae="",re,K,te=oe.length;for(re=0;re<te;re++)K=oe.charCodeAt(re),Math.random()>.5&&(K="x"+K.toString(16)),ae+="&#"+K+";";return ae}var H=function(){function oe(re){this.tokens=[],this.tokens.links=Object.create(null),this.options=re||he.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:F.normal,inline:O.normal};this.options.pedantic?(K.block=F.pedantic,K.inline=O.pedantic):this.options.gfm&&(K.block=F.gfm,this.options.breaks?K.inline=O.breaks:K.inline=O.gfm),this.tokenizer.rules=K}oe.lex=function(K,te){var le=new oe(te);return le.lex(K)},oe.lexInline=function(K,te){var le=new oe(te);return le.inlineTokens(K)};var ae=oe.prototype;return ae.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ae.blockTokens=function(K,te){var le=this;te===void 0&&(te=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Fe,V,W){return V+"    ".repeat(W.length)});for(var de,Ae,me,Pe;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(de=Fe.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.space(K)){K=K.substring(de.raw.length),de.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(de);continue}if(de=this.tokenizer.code(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(de=this.tokenizer.fences(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.heading(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.hr(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.blockquote(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.list(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.html(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.def(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.lheading(K)){K=K.substring(de.raw.length),te.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,V=K.slice(1),W=void 0;le.options.extensions.startBlock.forEach(function(Q){W=Q.call({lexer:this},V),typeof W=="number"&&W>=0&&(Fe=Math.min(Fe,W))}),Fe<1/0&&Fe>=0&&(me=K.substring(0,Fe+1))}(),this.state.top&&(de=this.tokenizer.paragraph(me))){Ae=te[te.length-1],Pe&&Ae.type==="paragraph"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de),Pe=me.length!==K.length,K=K.substring(de.raw.length);continue}if(de=this.tokenizer.text(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,te},ae.inline=function(K,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:K,tokens:te}),te},ae.inlineTokens=function(K,te){var le=this;te===void 0&&(te=[]);var de,Ae,me,Pe=K,Re,Fe,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)W.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Fe||(V=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(de=J.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.escape(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.tag(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.link(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.emStrong(K,Pe,V)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.codespan(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.br(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.del(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.autolink(K,B)){K=K.substring(de.raw.length),te.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(K,B))){K=K.substring(de.raw.length),te.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,fe=K.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(ze){we=ze.call({lexer:this},fe),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<1/0&&J>=0&&(me=K.substring(0,J+1))}(),de=this.tokenizer.inlineText(me,T)){K=K.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(V=de.raw.slice(-1)),Fe=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},u(oe,null,[{key:"rules",get:function(){return{block:F,inline:O}}}]),oe}(),X=function(){function oe(re){this.options=re||he.defaults}var ae=oe.prototype;return ae.code=function(K,te,le){var de=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,de);Ae!=null&&Ae!==K&&(le=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+v(de,!0)+'">'+(le?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:v(K,!0))+`</code></pre>
`},ae.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ae.html=function(K){return K},ae.heading=function(K,te,le,de){if(this.options.headerIds){var Ae=this.options.headerPrefix+de.slug(le);return"<h"+te+' id="'+Ae+'">'+K+"</h"+te+`>
`}return"<h"+te+">"+K+"</h"+te+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(K,te,le){var de=te?"ol":"ul",Ae=te&&le!==1?' start="'+le+'"':"";return"<"+de+Ae+`>
`+K+"</"+de+`>
`},ae.listitem=function(K){return"<li>"+K+`</li>
`},ae.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(K){return"<p>"+K+`</p>
`},ae.table=function(K,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+te+`</table>
`},ae.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ae.tablecell=function(K,te){var le=te.header?"th":"td",de=te.align?"<"+le+' align="'+te.align+'">':"<"+le+">";return de+K+("</"+le+`>
`)},ae.strong=function(K){return"<strong>"+K+"</strong>"},ae.em=function(K){return"<em>"+K+"</em>"},ae.codespan=function(K){return"<code>"+K+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(K){return"<del>"+K+"</del>"},ae.link=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<a href="'+v(K)+'"';return te&&(de+=' title="'+te+'"'),de+=">"+le+"</a>",de},ae.image=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<img src="'+K+'" alt="'+le+'"';return te&&(de+=' title="'+te+'"'),de+=this.options.xhtml?"/>":">",de},ae.text=function(K){return K},oe}(),x=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(K){return K},ae.em=function(K){return K},ae.codespan=function(K){return K},ae.del=function(K){return K},ae.html=function(K){return K},ae.text=function(K){return K},ae.link=function(K,te,le){return""+le},ae.image=function(K,te,le){return""+le},ae.br=function(){return""},oe}(),Y=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(K,te){var le=K,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[K];do de++,le=K+"-"+de;while(this.seen.hasOwnProperty(le))}return te||(this.seen[K]=de,this.seen[le]=0),le},ae.slug=function(K,te){te===void 0&&(te={});var le=this.serialize(K);return this.getNextSafeSlug(le,te.dryrun)},oe}(),Z=function(){function oe(re){this.options=re||he.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Y}oe.parse=function(K,te){var le=new oe(te);return le.parse(K)},oe.parseInline=function(K,te){var le=new oe(te);return le.parseInline(K)};var ae=oe.prototype;return ae.parse=function(K,te){te===void 0&&(te=!0);var le="",de,Ae,me,Pe,Re,Fe,V,W,Q,J,fe,we,ze,Ve,Xe,st,ot,tt,rt,Se=K.length;for(de=0;de<Se;de++){if(J=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){le+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(W="",V="",Pe=J.header.length,Ae=0;Ae<Pe;Ae++)V+=this.renderer.tablecell(this.parseInline(J.header[Ae].tokens),{header:!0,align:J.align[Ae]});for(W+=this.renderer.tablerow(V),Q="",Pe=J.rows.length,Ae=0;Ae<Pe;Ae++){for(Fe=J.rows[Ae],V="",Re=Fe.length,me=0;me<Re;me++)V+=this.renderer.tablecell(this.parseInline(Fe[me].tokens),{header:!1,align:J.align[me]});Q+=this.renderer.tablerow(V)}le+=this.renderer.table(W,Q);continue}case"blockquote":{Q=this.parse(J.tokens),le+=this.renderer.blockquote(Q);continue}case"list":{for(fe=J.ordered,we=J.start,ze=J.loose,Pe=J.items.length,Q="",Ae=0;Ae<Pe;Ae++)Xe=J.items[Ae],st=Xe.checked,ot=Xe.task,Ve="",Xe.task&&(tt=this.renderer.checkbox(st),ze?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=tt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=tt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:tt}):Ve+=tt),Ve+=this.parse(Xe.tokens,ze),Q+=this.renderer.listitem(Ve,ot,st);le+=this.renderer.list(Q,fe,we);continue}case"html":{le+=this.renderer.html(J.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;de+1<Se&&K[de+1].type==="text";)J=K[++de],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);le+=te?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return le},ae.parseInline=function(K,te){te=te||this.renderer;var le="",de,Ae,me,Pe=K.length;for(de=0;de<Pe;de++){if(Ae=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(me=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){le+=me||"";continue}switch(Ae.type){case"escape":{le+=te.text(Ae.text);break}case"html":{le+=te.html(Ae.text);break}case"link":{le+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{le+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{le+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{le+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{le+=te.codespan(Ae.text);break}case"br":{le+=te.br();break}case"del":{le+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{le+=te.text(Ae.text);break}default:{var Re='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},oe}();function ce(oe,ae,re){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(re=ae,ae=null),ae=g({},ce.defaults,ae||{}),y(ae),re){var K=ae.highlight,te;try{te=H.lex(oe,ae)}catch(Pe){return re(Pe)}var le=function(Re){var Fe;if(!Re)try{ae.walkTokens&&ce.walkTokens(te,ae.walkTokens),Fe=Z.parse(te,ae)}catch(V){Re=V}return ae.highlight=K,Re?re(Re):re(null,Fe)};if(!K||K.length<3||(delete ae.highlight,!te.length))return le();var de=0;ce.walkTokens(te,function(Pe){Pe.type==="code"&&(de++,setTimeout(function(){K(Pe.text,Pe.lang,function(Re,Fe){if(Re)return le(Re);Fe!=null&&Fe!==Pe.text&&(Pe.text=Fe,Pe.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ae(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(Pe.message+"",!0)+"</pre>";throw Pe}try{var me=H.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(ce.walkTokens(me,ae.walkTokens)).then(function(){return Z.parse(me,ae)}).catch(Ae);ce.walkTokens(me,ae.walkTokens)}return Z.parse(me,ae)}catch(Pe){Ae(Pe)}}ce.options=ce.setOptions=function(oe){return g(ce.defaults,oe),b(ce.defaults),ce},ce.getDefaults=M,ce.defaults=he.defaults,ce.use=function(){for(var oe=arguments.length,ae=new Array(oe),re=0;re<oe;re++)ae[re]=arguments[re];var K=g.apply(void 0,[{}].concat(ae)),te=ce.defaults.extensions||{renderers:{},childTokens:{}},le;ae.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Pe=te.renderers?te.renderers[me.name]:null;Pe?te.renderers[me.name]=function(){for(var Re=arguments.length,Fe=new Array(Re),V=0;V<Re;V++)Fe[V]=arguments[V];var W=me.renderer.apply(this,Fe);return W===!1&&(W=Pe.apply(this,Fe)),W}:te.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[me.level]?te[me.level].unshift(me.tokenizer):te[me.level]=[me.tokenizer],me.start&&(me.level==="block"?te.startBlock?te.startBlock.push(me.start):te.startBlock=[me.start]:me.level==="inline"&&(te.startInline?te.startInline.push(me.start):te.startInline=[me.start]))}me.childTokens&&(te.childTokens[me.name]=me.childTokens)})),de.renderer&&function(){var me=ce.defaults.renderer||new X,Pe=function(V){var W=me[V];me[V]=function(){for(var Q=arguments.length,J=new Array(Q),fe=0;fe<Q;fe++)J[fe]=arguments[fe];var we=de.renderer[V].apply(me,J);return we===!1&&(we=W.apply(me,J)),we}};for(var Re in de.renderer)Pe(Re);K.renderer=me}(),de.tokenizer&&function(){var me=ce.defaults.tokenizer||new j,Pe=function(V){var W=me[V];me[V]=function(){for(var Q=arguments.length,J=new Array(Q),fe=0;fe<Q;fe++)J[fe]=arguments[fe];var we=de.tokenizer[V].apply(me,J);return we===!1&&(we=W.apply(me,J)),we}};for(var Re in de.tokenizer)Pe(Re);K.tokenizer=me}(),de.walkTokens){var Ae=ce.defaults.walkTokens;K.walkTokens=function(me){var Pe=[];return Pe.push(de.walkTokens.call(this,me)),Ae&&(Pe=Pe.concat(Ae.call(this,me))),Pe}}le&&(K.extensions=te),ce.setOptions(K)})},ce.walkTokens=function(oe,ae){for(var re=[],K=function(){var Ae=le.value;switch(re=re.concat(ae.call(ce,Ae)),Ae.type){case"table":{for(var me=R(Ae.header),Pe;!(Pe=me()).done;){var Re=Pe.value;re=re.concat(ce.walkTokens(Re.tokens,ae))}for(var Fe=R(Ae.rows),V;!(V=Fe()).done;)for(var W=V.value,Q=R(W),J;!(J=Q()).done;){var fe=J.value;re=re.concat(ce.walkTokens(fe.tokens,ae))}break}case"list":{re=re.concat(ce.walkTokens(Ae.items,ae));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(we){re=re.concat(ce.walkTokens(Ae[we],ae))}):Ae.tokens&&(re=re.concat(ce.walkTokens(Ae.tokens,ae)))}},te=R(oe),le;!(le=te()).done;)K();return re},ce.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=g({},ce.defaults,ae||{}),y(ae);try{var re=H.lexInline(oe,ae);return ae.walkTokens&&ce.walkTokens(re,ae.walkTokens),Z.parseInline(re,ae)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ce.Parser=Z,ce.parser=Z.parse,ce.Renderer=X,ce.TextRenderer=x,ce.Lexer=H,ce.lexer=H.lex,ce.Tokenizer=j,ce.Slugger=Y,ce.parse=ce;var ie=ce.options,pe=ce.setOptions,Ce=ce.use,_=ce.walkTokens,U=ce.parseInline,ne=ce,be=Z.parse,De=H.lex;he.Lexer=H,he.Parser=Z,he.Renderer=X,he.Slugger=Y,he.TextRenderer=x,he.Tokenizer=j,he.getDefaults=M,he.lexer=De,he.marked=ce,he.options=ie,he.parse=ne,he.parseInline=U,he.parser=be,he.setOptions=pe,he.use=Ce,he.walkTokens=_,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=u;function u(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let N=0;const L=new Uint32Array(10);function R(a){if(N=0,M(a,P,4352),N>0||(M(a,$,4449),N>0)||(M(a,E,4520),N>0)||(M(a,v,12593),N))return L.subarray(0,N);if(a>=44032&&a<=55203){const m=a-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<P.length?M(n,P,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<$.length?M(i,$,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),r>=0&&(r<E.length?M(r,E,0):4520+r-12593<v.length&&M(4520+r-12593,v,12593)),N>0)return L.subarray(0,N)}}function M(a,m,o){a>=o&&a<o+m.length&&b(m[a-o])}function b(a){a!==0&&(L[N++]=a&255,a>>8&&(L[N++]=a>>8&255),a>>16&&(L[N++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var S;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(S||(S={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0,e.$5l=L,e.$6l=M;const N=new u.$Ec(1e4);function L(S){return p(S,"NFC",N)}const R=new u.$Ec(1e4);function M(S){return p(S,"NFD",R)}const b=/[^\u0000-\u0080]/;function p(S,A,P){if(!S)return S;const $=P.get(S);if($)return $;let E;return b.test(S)?E=S.normalize(A):E=S,P.set(S,E),E}e.$7l=function(){const S=/[\u0300-\u036f]/g;return function(A){return M(A).replace(S,"")}}()}),define(ke[125],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=u,e.rot=N;function u(b,p,S){return Math.min(Math.max(b,p),S)}function N(b,p){return(p+b%p)%p}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$um=L;class R{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=R;class M{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const S=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=M}),function(){function he(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M(p){R.push(p,Date.now())}function b(){const p=[];for(let S=0;S<R.length;S+=2)p.push({name:R[S],startTime:R[S+1]});return p}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function u(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[167],Ee([1,0,45]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert(p,S,A){this.d(p,P=>P._value=S,A)}mutate(p,S){this.d(p,A=>A._value=S(A._value===N?void 0:A._value))}delete(p){const S=this.c(p);if(!S)return;let A=S.length-1;const P=S[A].node._value;if(P!==N){for(this.b--,S[A].node._value=N;A>0;A--){const{node:$,part:E}=S[A];if($.children?.size||$._value!==N)break;S[A-1].node.children.delete(E)}return P}}*deleteRecursive(p){const S=this.c(p);if(!S)return;const A=S[S.length-1].node;for(let P=S.length-1;P>0;P--){const $=S[P-1];if($.node.children.delete(S[P].part),$.node.children.size>0||$.node._value!==N)break}for(const P of R(A))P._value!==N&&(this.b--,yield P._value)}find(p){let S=this.a;for(const A of p){const P=S.children?.get(A);if(!P)return;S=P}return S._value===N?void 0:S._value}hasKeyOrParent(p){let S=this.a;for(const A of p){const P=S.children?.get(A);if(!P)return!1;if(P._value!==N)return!0;S=P}return!1}hasKeyOrChildren(p){let S=this.a;for(const A of p){const P=S.children?.get(A);if(!P)return!1;S=P}return!0}hasKey(p){let S=this.a;for(const A of p){const P=S.children?.get(A);if(!P)return!1;S=P}return S._value!==N}c(p){const S=[{part:"",node:this.a}];let A=0;for(const P of p){const $=S[A].node.children?.get(P);if(!$)return;S.push({part:P,node:$}),A++}return S}d(p,S,A){let P=this.a;for(const v of p){if(P.children)if(P.children.has(v))P=P.children.get(v);else{const a=new M;P.children.set(v,a),P=a}else{const a=new M;P.children=new Map([[v,a]]),P=a}A?.(P)}const $=P._value===N?0:1;S(P);const E=P._value===N?0:1;this.b+=E-$}*values(){for(const{_value:p}of R(this.a))p!==N&&(yield p)}}e.$YO=L;function*R(b){const p=[b];for(;p.length>0;){const S=p.pop();if(yield S,S.children)for(const A of S.children.values())p.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(p){this._value=p===void 0?N:p}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:he)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function u(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return he[N].call(L.exports,L,L.exports,u),L.l=!0,L.exports}return u.m=he,u.c=e,u.d=function(N,L,R){u.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,L){if(1&L&&(N=u(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(u.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)u.d(R,M,function(b){return N[b]}.bind(null,M));return R},u.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(L,"a",L),L},u.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},u.p="",u(u.s=0)}([function(he,e,u){(function(N){var L;e=he.exports=Ce,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],p=e.src=[],S=0,A=S++;p[A]="0|[1-9]\\d*";var P=S++;p[P]="[0-9]+";var $=S++;p[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=S++;p[E]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var v=S++;p[v]="("+p[P]+")\\.("+p[P]+")\\.("+p[P]+")";var a=S++;p[a]="(?:"+p[A]+"|"+p[$]+")";var m=S++;p[m]="(?:"+p[P]+"|"+p[$]+")";var o=S++;p[o]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var n=S++;p[n]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var i=S++;p[i]="[0-9A-Za-z-]+";var r=S++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var s=S++,t="v?"+p[E]+p[o]+"?"+p[r]+"?";p[s]="^"+t+"$";var f="[v=\\s]*"+p[v]+p[n]+"?"+p[r]+"?",d=S++;p[d]="^"+f+"$";var l=S++;p[l]="((?:<|>)?=?)";var c=S++;p[c]=p[P]+"|x|X|\\*";var h=S++;p[h]=p[A]+"|x|X|\\*";var g=S++;p[g]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var D=S++;p[D]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[n]+")?"+p[r]+"?)?)?";var w=S++;p[w]="^"+p[l]+"\\s*"+p[g]+"$";var k=S++;p[k]="^"+p[l]+"\\s*"+p[D]+"$";var y=S++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=S++;p[C]="(?:~>?)";var I=S++;p[I]="(\\s*)"+p[C]+"\\s+",b[I]=new RegExp(p[I],"g");var z=S++;p[z]="^"+p[C]+p[g]+"$";var j=S++;p[j]="^"+p[C]+p[D]+"$";var F=S++;p[F]="(?:\\^)";var O=S++;p[O]="(\\s*)"+p[F]+"\\s+",b[O]=new RegExp(p[O],"g");var T=S++;p[T]="^"+p[F]+p[g]+"$";var B=S++;p[B]="^"+p[F]+p[D]+"$";var H=S++;p[H]="^"+p[l]+"\\s*("+f+")$|^$";var X=S++;p[X]="^"+p[l]+"\\s*("+t+")$|^$";var x=S++;p[x]="(\\s*)"+p[l]+"\\s*("+f+"|"+p[g]+")",b[x]=new RegExp(p[x],"g");var Y=S++;p[Y]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var Z=S++;p[Z]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ce=S++;p[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)L(ie,p[ie]),b[ie]||(b[ie]=new RegExp(p[ie]));function pe(W,Q){if(W instanceof Ce)return W;if(typeof W!="string"||W.length>R||!(Q?b[d]:b[s]).test(W))return null;try{return new Ce(W,Q)}catch{return null}}function Ce(W,Q){if(W instanceof Ce){if(W.loose===Q)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ce))return new Ce(W,Q);L("SemVer",W,Q),this.loose=Q;var J=W.trim().match(Q?b[d]:b[s]);if(!J)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<M)return we}return fe}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=pe,e.valid=function(W,Q){var J=pe(W,Q);return J?J.version:null},e.clean=function(W,Q){var J=pe(W.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof Ce||(W=new Ce(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ce.prototype.compareMain=function(W){return W instanceof Ce||(W=new Ce(W,this.loose)),U(this.major,W.major)||U(this.minor,W.minor)||U(this.patch,W.patch)},Ce.prototype.comparePre=function(W){if(W instanceof Ce||(W=new Ce(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],fe=W.prerelease[Q];if(L("prerelease compare",Q,J,fe),J===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(J===void 0)return-1;if(J!==fe)return U(J,fe)}while(++Q)},Ce.prototype.inc=function(W,Q){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,Q,J,fe){typeof J=="string"&&(fe=J,J=void 0);try{return new Ce(W,J).inc(Q,fe).version}catch{return null}},e.diff=function(W,Q){if(oe(W,Q))return null;var J=pe(W),fe=pe(Q);if(J.prerelease.length||fe.prerelease.length){for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==fe[we])return we},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(W,Q){var J=_.test(W),fe=_.test(Q);return J&&fe&&(W=+W,Q=+Q),J&&!fe?-1:fe&&!J?1:W<Q?-1:W>Q?1:0}function ne(W,Q,J){return new Ce(W,J).compare(new Ce(Q,J))}function be(W,Q,J){return ne(W,Q,J)>0}function De(W,Q,J){return ne(W,Q,J)<0}function oe(W,Q,J){return ne(W,Q,J)===0}function ae(W,Q,J){return ne(W,Q,J)!==0}function re(W,Q,J){return ne(W,Q,J)>=0}function K(W,Q,J){return ne(W,Q,J)<=0}function te(W,Q,J,fe){var we;switch(Q){case"===":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),we=W===J;break;case"!==":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),we=W!==J;break;case"":case"=":case"==":we=oe(W,J,fe);break;case"!=":we=ae(W,J,fe);break;case">":we=be(W,J,fe);break;case">=":we=re(W,J,fe);break;case"<":we=De(W,J,fe);break;case"<=":we=K(W,J,fe);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function le(W,Q){if(W instanceof le){if(W.loose===Q)return W;W=W.value}if(!(this instanceof le))return new le(W,Q);L("comparator",W,Q),this.loose=Q,this.parse(W),this.semver===de?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,Q){return U(Q,W)},e.major=function(W,Q){return new Ce(W,Q).major},e.minor=function(W,Q){return new Ce(W,Q).minor},e.patch=function(W,Q){return new Ce(W,Q).patch},e.compare=ne,e.compareLoose=function(W,Q){return ne(W,Q,!0)},e.rcompare=function(W,Q,J){return ne(Q,W,J)},e.sort=function(W,Q){return W.sort(function(J,fe){return e.compare(J,fe,Q)})},e.rsort=function(W,Q){return W.sort(function(J,fe){return e.rcompare(J,fe,Q)})},e.gt=be,e.lt=De,e.eq=oe,e.neq=ae,e.gte=re,e.lte=K,e.cmp=te,e.Comparator=le;var de={};function Ae(W,Q){if(W instanceof Ae)return W.loose===Q?W:new Ae(W.raw,Q);if(W instanceof le)return new Ae(W.value,Q);if(!(this instanceof Ae))return new Ae(W,Q);if(this.loose=Q,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function me(W){return!W||W.toLowerCase()==="x"||W==="*"}function Pe(W,Q,J,fe,we,ze,Ve,Xe,st,ot,tt,rt,Se){return((Q=me(J)?"":me(fe)?">="+J+".0.0":me(we)?">="+J+"."+fe+".0":">="+Q)+" "+(Xe=me(st)?"":me(ot)?"<"+(+st+1)+".0.0":me(tt)?"<"+st+"."+(+ot+1)+".0":rt?"<="+st+"."+ot+"."+tt+"-"+rt:"<="+Xe)).trim()}function Re(W,Q){for(var J=0;J<W.length;J++)if(!W[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<W.length;J++)if(L(W[J].semver),W[J].semver!==de&&W[J].semver.prerelease.length>0){var fe=W[J].semver;if(fe.major===Q.major&&fe.minor===Q.minor&&fe.patch===Q.patch)return!0}return!1}return!0}function Fe(W,Q,J){try{Q=new Ae(Q,J)}catch{return!1}return Q.test(W)}function V(W,Q,J,fe){var we,ze,Ve,Xe,st;switch(W=new Ce(W,fe),Q=new Ae(Q,fe),J){case">":we=be,ze=K,Ve=De,Xe=">",st=">=";break;case"<":we=De,ze=re,Ve=be,Xe="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(W,Q,fe))return!1;for(var ot=0;ot<Q.set.length;++ot){var tt=Q.set[ot],rt=null,Se=null;if(tt.forEach(function(Be){Be.semver===de&&(Be=new le(">=0.0.0")),rt=rt||Be,Se=Se||Be,we(Be.semver,rt.semver,fe)?rt=Be:Ve(Be.semver,Se.semver,fe)&&(Se=Be)}),rt.operator===Xe||rt.operator===st||(!Se.operator||Se.operator===Xe)&&ze(W,Se.semver)||Se.operator===st&&Ve(W,Se.semver))return!1}return!0}le.prototype.parse=function(W){var Q=this.loose?b[H]:b[X],J=W.match(Q);if(!J)throw new TypeError("Invalid comparator: "+W);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Ce(J[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===de||(typeof W=="string"&&(W=new Ce(W,this.loose)),te(W,this.operator,this.semver,this.loose))},le.prototype.intersects=function(W,Q){if(!(W instanceof le))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Ae(W.value,Q),Fe(this.value,J,Q);if(W.operator==="")return J=new Ae(this.value,Q),Fe(W.semver,J,Q);var fe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),ze=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Xe=te(this.semver,"<",W.semver,Q)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),st=te(this.semver,">",W.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return fe||we||ze&&Ve||Xe||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(W){var Q=this.loose;W=W.trim(),L("range",W,Q);var J=Q?b[Z]:b[Y];W=W.replace(J,Pe),L("hyphen replace",W),W=W.replace(b[x],"$1$2$3"),L("comparator trim",W,b[x]),W=(W=(W=W.replace(b[I],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var fe=Q?b[H]:b[X],we=W.split(" ").map(function(ze){return function(Ve,Xe){return L("comp",Ve),Ve=function(st,ot){return st.trim().split(/\s+/).map(function(tt){return function(rt,Se){L("caret",rt,Se);var Be=Se?b[B]:b[T];return rt.replace(Be,function(Ge,Le,Ye,se,ue){var Ie;return L("caret",rt,Ge,Le,Ye,se,ue),me(Le)?Ie="":me(Ye)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(se)?Ie=Le==="0"?">="+Le+"."+Ye+".0 <"+Le+"."+(+Ye+1)+".0":">="+Le+"."+Ye+".0 <"+(+Le+1)+".0.0":ue?(L("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=Le==="0"?Ye==="0"?">="+Le+"."+Ye+"."+se+ue+" <"+Le+"."+Ye+"."+(+se+1):">="+Le+"."+Ye+"."+se+ue+" <"+Le+"."+(+Ye+1)+".0":">="+Le+"."+Ye+"."+se+ue+" <"+(+Le+1)+".0.0"):(L("no pr"),Ie=Le==="0"?Ye==="0"?">="+Le+"."+Ye+"."+se+" <"+Le+"."+Ye+"."+(+se+1):">="+Le+"."+Ye+"."+se+" <"+Le+"."+(+Ye+1)+".0":">="+Le+"."+Ye+"."+se+" <"+(+Le+1)+".0.0"),L("caret return",Ie),Ie})}(tt,ot)}).join(" ")}(Ve,Xe),L("caret",Ve),Ve=function(st,ot){return st.trim().split(/\s+/).map(function(tt){return function(rt,Se){var Be=Se?b[j]:b[z];return rt.replace(Be,function(Ge,Le,Ye,se,ue){var Ie;return L("tilde",rt,Ge,Le,Ye,se,ue),me(Le)?Ie="":me(Ye)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(se)?Ie=">="+Le+"."+Ye+".0 <"+Le+"."+(+Ye+1)+".0":ue?(L("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=">="+Le+"."+Ye+"."+se+ue+" <"+Le+"."+(+Ye+1)+".0"):Ie=">="+Le+"."+Ye+"."+se+" <"+Le+"."+(+Ye+1)+".0",L("tilde return",Ie),Ie})}(tt,ot)}).join(" ")}(Ve,Xe),L("tildes",Ve),Ve=function(st,ot){return L("replaceXRanges",st,ot),st.split(/\s+/).map(function(tt){return function(rt,Se){rt=rt.trim();var Be=Se?b[k]:b[w];return rt.replace(Be,function(Ge,Le,Ye,se,ue,Ie){L("xRange",rt,Ge,Le,Ye,se,ue,Ie);var Ke=me(Ye),Me=Ke||me(se),it=Me||me(ue);return Le==="="&&it&&(Le=""),Ke?Ge=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Me&&(se=0),it&&(ue=0),Le===">"?(Le=">=",Me?(Ye=+Ye+1,se=0,ue=0):it&&(se=+se+1,ue=0)):Le==="<="&&(Le="<",Me?Ye=+Ye+1:se=+se+1),Ge=Le+Ye+"."+se+"."+ue):Me?Ge=">="+Ye+".0.0 <"+(+Ye+1)+".0.0":it&&(Ge=">="+Ye+"."+se+".0 <"+Ye+"."+(+se+1)+".0"),L("xRange return",Ge),Ge})}(tt,ot)}).join(" ")}(Ve,Xe),L("xrange",Ve),Ve=function(st,ot){return L("replaceStars",st,ot),st.trim().replace(b[ce],"")}(Ve,Xe),L("stars",Ve),Ve}(ze,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(ze){return!!ze.match(fe)})),we=we.map(function(ze){return new le(ze,Q)})},Ae.prototype.intersects=function(W,Q){if(!(W instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(fe){return W.set.some(function(we){return we.every(function(ze){return fe.intersects(ze,Q)})})})})},e.toComparators=function(W,Q){return new Ae(W,Q).set.map(function(J){return J.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ce(W,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Re(this.set[Q],W))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(W,Q,J){var fe=null,we=null;try{var ze=new Ae(Q,J)}catch{return null}return W.forEach(function(Ve){ze.test(Ve)&&(fe&&we.compare(Ve)!==-1||(we=new Ce(fe=Ve,J)))}),fe},e.minSatisfying=function(W,Q,J){var fe=null,we=null;try{var ze=new Ae(Q,J)}catch{return null}return W.forEach(function(Ve){ze.test(Ve)&&(fe&&we.compare(Ve)!==1||(we=new Ce(fe=Ve,J)))}),fe},e.validRange=function(W,Q){try{return new Ae(W,Q).range||"*"}catch{return null}},e.ltr=function(W,Q,J){return V(W,Q,"<",J)},e.gtr=function(W,Q,J){return V(W,Q,">",J)},e.outside=V,e.prerelease=function(W,Q){var J=pe(W,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(W,Q,J){return W=new Ae(W,J),Q=new Ae(Q,J),W.intersects(Q)},e.coerce=function(W){if(W instanceof Ce)return W;if(typeof W!="string")return null;var Q=W.match(b[y]);return Q==null?null:pe((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(he,e){var u,N,L=he.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(m){if(u===setTimeout)return setTimeout(m,0);if((u===R||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:R}catch{u=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var p,S=[],A=!1,P=-1;function $(){A&&p&&(A=!1,p.length?S=p.concat(S):P=-1,S.length&&E())}function E(){if(!A){var m=b($);A=!0;for(var o=S.length;o;){for(p=S,S=[];++P<o;)p&&p[P].run();P=-1,o=S.length}p=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(m)}}function v(m,o){this.fun=m,this.array=o}function a(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];S.push(new v(m,o)),S.length!==1||A||b(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=a,L.addListener=a,L.once=a,L.off=a,L.removeListener=a,L.removeAllListeners=a,L.emit=a,L.prependListener=a,L.prependOnceListener=a,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[39],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=u&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$8d=N}),define(ke[4],Ee([1,0,13,74,3,75,39]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$0d=e.Event=void 0,e.$$d=E;const b=!1,p=!1,S=!1;var A;(function(y){y.None=()=>L.$Uc.None;function C(le){if(S){const{onDidAddListener:de}=le,Ae=a.create();let me=0;le.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),de?.()}}}function I(le,de){return Y(le,()=>{},0,void 0,!0,void 0,de)}y.defer=I;function z(le){return(de,Ae=null,me)=>{let Pe=!1,Re;return Re=le(Fe=>{if(!Pe)return Re?Re.dispose():Pe=!0,de.call(Ae,Fe)},null,me),Pe&&Re.dispose(),Re}}y.once=z;function j(le,de,Ae){return X((me,Pe=null,Re)=>le(Fe=>me.call(Pe,de(Fe)),null,Re),Ae)}y.map=j;function F(le,de,Ae){return X((me,Pe=null,Re)=>le(Fe=>{de(Fe),me.call(Pe,Fe)},null,Re),Ae)}y.forEach=F;function O(le,de,Ae){return X((me,Pe=null,Re)=>le(Fe=>de(Fe)&&me.call(Pe,Fe),null,Re),Ae)}y.filter=O;function T(le){return le}y.signal=T;function B(...le){return(de,Ae=null,me)=>{const Pe=(0,L.$Rc)(...le.map(Re=>Re(Fe=>de.call(Ae,Fe))));return x(Pe,me)}}y.any=B;function H(le,de,Ae,me){let Pe=Ae;return j(le,Re=>(Pe=de(Pe,Re),Pe),me)}y.reduce=H;function X(le,de){let Ae;const me={onWillAddFirstListener(){Ae=le(Pe.fire,Pe)},onDidRemoveLastListener(){Ae?.dispose()}};de||C(me);const Pe=new s(me);return de?.add(Pe),Pe.event}function x(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function Y(le,de,Ae=100,me=!1,Pe=!1,Re,Fe){let V,W,Q,J=0,fe;const we={leakWarningThreshold:Re,onWillAddFirstListener(){V=le(Ve=>{J++,W=de(W,Ve),me&&!Q&&(ze.fire(W),W=void 0),fe=()=>{const Xe=W;W=void 0,Q=void 0,(!me||J>1)&&ze.fire(Xe),J=0},typeof Ae=="number"?(clearTimeout(Q),Q=setTimeout(fe,Ae)):Q===void 0&&(Q=0,queueMicrotask(fe))})},onWillRemoveListener(){Pe&&J>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,V.dispose()}};Fe||C(we);const ze=new s(we);return Fe?.add(ze),ze.event}y.debounce=Y;function Z(le,de=0,Ae){return y.debounce(le,(me,Pe)=>me?(me.push(Pe),me):[Pe],de,void 0,!0,void 0,Ae)}y.accumulate=Z;function ce(le,de=(me,Pe)=>me===Pe,Ae){let me=!0,Pe;return O(le,Re=>{const Fe=me||!de(Re,Pe);return me=!1,Pe=Re,Fe},Ae)}y.latch=ce;function ie(le,de,Ae){return[y.filter(le,de,Ae),y.filter(le,me=>!de(me),Ae)]}y.split=ie;function pe(le,de=!1,Ae=[],me){let Pe=Ae.slice(),Re=le(W=>{Pe?Pe.push(W):V.fire(W)});me&&me.add(Re);const Fe=()=>{Pe?.forEach(W=>V.fire(W)),Pe=null},V=new s({onWillAddFirstListener(){Re||(Re=le(W=>V.fire(W)),me&&me.add(Re))},onDidAddFirstListener(){Pe&&(de?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return me&&me.add(V),V.event}y.buffer=pe;function Ce(le,de){return(me,Pe,Re)=>{const Fe=de(new U);return le(function(V){const W=Fe.evaluate(V);W!==_&&me.call(Pe,W)},void 0,Re)}}y.chain=Ce;const _=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Ae=>(de(Ae),Ae)),this}filter(de){return this.f.push(Ae=>de(Ae)?Ae:_),this}reduce(de,Ae){let me=Ae;return this.f.push(Pe=>(me=de(me,Pe),me)),this}latch(de=(Ae,me)=>Ae===me){let Ae=!0,me;return this.f.push(Pe=>{const Re=Ae||!de(Pe,me);return Ae=!1,me=Pe,Re?Pe:_}),this}evaluate(de){for(const Ae of this.f)if(de=Ae(de),de===_)break;return de}}function ne(le,de,Ae=me=>me){const me=(...V)=>Fe.fire(Ae(...V)),Pe=()=>le.on(de,me),Re=()=>le.removeListener(de,me),Fe=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return Fe.event}y.fromNodeEventEmitter=ne;function be(le,de,Ae=me=>me){const me=(...V)=>Fe.fire(Ae(...V)),Pe=()=>le.addEventListener(de,me),Re=()=>le.removeEventListener(de,me),Fe=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return Fe.event}y.fromDOMEventEmitter=be;function De(le){return new Promise(de=>z(le)(de))}y.toPromise=De;function oe(le){const de=new s;return le.then(Ae=>{de.fire(Ae)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}y.fromPromise=oe;function ae(le,de,Ae){return de(Ae),le(me=>de(me))}y.runAndSubscribe=ae;class re{constructor(de,Ae){this._observable=de,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Ae||C(me),this.emitter=new s(me),Ae&&Ae.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Ae){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function K(le,de){return new re(le,de).emitter.event}y.fromObservable=K;function te(le){return(de,Ae,me)=>{let Pe=0,Re=!1;const Fe={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(le.reportChanges(),Re&&(Re=!1,de.call(Ae)))},handlePossibleChange(){},handleChange(){Re=!0}};le.addObserver(Fe),le.reportChanges();const V={dispose(){le.removeObserver(Fe)}};return me instanceof L.$Tc?me.add(V):Array.isArray(me)&&me.push(V),V}}y.fromObservableLight=te})(A||(e.Event=A={}));class P{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${P.f++}`,P.all.add(this)}start(C){this.g=new M.$8d,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}e.$0d=P;let $=-1;function E(y){const C=$;return $=y,{dispose(){$=C}}}class v{constructor(C,I=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=I,this.g=0}dispose(){this.f?.clear()}check(C,I){const z=this.threshold;if(z<=0||I<z)return;this.f||(this.f=new Map);const j=this.f.get(C.value)||0;if(this.f.set(C.value,j+1),this.g-=1,this.g<=0){this.g=z*.5;let F,O=0;for(const[T,B]of this.f)(!F||O<B)&&(F=T,O=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${O}):`),console.warn(F)}return()=>{const F=this.f.get(C.value)||0;this.f.set(C.value,F-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(C){this.value=C,this.id=m++}}const n=2,i=(y,C)=>{if(y instanceof o)C(y);else for(let I=0;I<y.length;I++){const z=y[I];z&&C(z)}},r=b?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class s{constructor(C){this.w=0,this.f=C,this.g=$>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const C=this.t;queueMicrotask(()=>{i(C,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,I,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;I&&(C=C.bind(I));const j=new o(C);let F,O;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=a.create(),F=this.g.check(j.stack,this.w+1)),p&&(j.stack=O??a.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,L.$Sc)(()=>{r?.unregister(T),F?.(),this.x(j)});if(z instanceof L.$Tc?z.add(T):Array.isArray(z)&&z.push(T),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(T,B,T)}return T},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,z=I.indexOf(C);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[z]=void 0;const j=this.u.current===this;if(this.w*n<=I.length){let F=0;for(let O=0;O<I.length;O++)I[O]?I[F++]=I[O]:j&&(this.u.end--,F<this.u.i&&this.u.i--);I.length=F}}y(C,I){if(!C)return;const z=this.f?.onListenerError||u.$1;if(!z){C.value(I);return}try{C.value(I)}catch(j){z(j)}}z(C){const I=C.current.t;for(;C.i<C.end;)this.y(I[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,C);else{const I=this.u;I.enqueue(this,C,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$_d=s;const t=()=>new f;e.$ae=t;class f{constructor(){this.i=-1,this.end=0}enqueue(C,I,z){this.i=0,this.end=z,this.current=C,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(C,I,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,j=>this.h.push([j.value,C]));this.h.size>0&&!I.isCancellationRequested;){const[j,F]=this.h.shift(),O=[],T={...F,token:I,waitUntil:B=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,j)),O.push(B)}};try{j(T)}catch(B){(0,u.$1)(B);continue}Object.freeze(O),await Promise.allSettled(O).then(B=>{for(const H of B)H.status==="rejected"&&(0,u.$1)(H.reason)})}}}e.$be=d;class l extends s{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new R.$5c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$ce=l;class c extends l{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$de=c;class h extends s{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$ee=h;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const I={event:C,listener:null};this.h.push(I),this.g&&this.m(I);const z=()=>{this.g&&this.o(I);const j=this.h.indexOf(I);this.h.splice(j,1)};return(0,L.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(I=>this.f.fire(I))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}e.$fe=g;class D{constructor(C,I,z,j){this.f=new L.$Tc;const F=this.f.add(new g),O=this.f.add(new L.$4c);function T(B){O.set(B,F.add(j(B)))}for(const B of C)T(B);this.f.add(I(B=>{T(B)})),this.f.add(z(B=>{O.deleteAndDispose(B)})),this.event=F.event}dispose(){this.f.dispose()}}e.$ge=D;class w{constructor(){this.f=[]}wrapEvent(C){return(I,z,j)=>C(F=>{const O=this.f[this.f.length-1];O?O.push(()=>I.call(z,F)):I.call(z,F)},void 0,j)}bufferEvents(C){const I=[];this.f.push(I);const z=C();return this.f.pop(),I.forEach(j=>j()),z}}e.$he=w;class k{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ie=k}),define(ke[22],Ee([1,0,4]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.CancellationToken=void 0;const N=Object.freeze(function(b,p){const S=setTimeout(b.bind(p),0);return{dispose(){clearTimeout(S)}}});var L;(function(b){function p(S){return S===b.None||S===b.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}b.isCancellationToken=p,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$_d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$je=M}),define(ke[168],Ee([1,0,22]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$We=e.$Ve=e.$Ue=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$je,p=this.b(b.token);return this.a={promise:p,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ue=N;class L{constructor(b,p=JSON.stringify){this.c=b,this.d=p,this.a=void 0,this.b=void 0}get(b){const p=this.d(b);return this.b!==p&&(this.b=p,this.a=this.c(b)),this.a}}e.$Ve=L;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const p=this.b(b);return this.a.set(b,p),p}}e.$We=R}),define(ke[98],Ee([1,0,13,3]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=L,e.$le=R,e.$me=M,e.$ne=b,e.$oe=S,e.$pe=A,e.$qe=P,e.$re=$,e.$se=E,e.$te=v,e.$ue=a,e.$ve=m,e.$we=o,e.$xe=n,e.$ye=i;function L(r){const s=r;return s?typeof s.read=="function":!1}function R(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(r){const s=r;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(r,s){return new p(r,s)}class p{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function P(r,s){return new Promise((t,f)=>{const d=[];$(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function $(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function E(r,s){return new Promise((t,f)=>{const d=new N.$Tc,l=[],c=D=>{if(l.push(D),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=D=>(d.dispose(),f(D)),g=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,N.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,N.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,N.$Sc)(()=>r.removeListener("data",c))),r.on("data",c)})}function v(r,s){const t=b(s);return t.end(r),t}function a(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=b(t);return $(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=b(t);return $(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,46,98]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=S,e.$Be=A,e.$Ce=P,e.$De=$,e.$Ee=E,e.$Fe=v,e.$Ge=a,e.$He=m,e.$Ie=o,e.$Je=n,e.$Ke=i,e.$Le=r,e.$Me=s,e.$Ne=t,e.$Oe=f,e.$Pe=d,e.$Qe=l,e.$Re=c,e.$Se=h,e.$Te=w;const L=typeof Buffer<"u",R=new u.$V(()=>new Uint8Array(256));let M,b;class p{static alloc(y){return L?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&L?new p(Buffer.from(y)):(M||(M=new TextEncoder),new p(M.encode(y)))}static fromByteArray(y){const C=p.alloc(y.length);for(let I=0,z=y.length;I<z;I++)C.buffer[I]=y[I];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let j=0,F=y.length;j<F;j++)C+=y[j].byteLength}const I=p.alloc(C);let z=0;for(let j=0,F=y.length;j<F;j++){const O=y[j];I.set(O,z),z+=O.byteLength}return I}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,C){return new p(this.buffer.subarray(y,C))}set(y,C){if(y instanceof p)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,C){E(this.buffer,y,C)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,C){a(this.buffer,y,C)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,C){o(this.buffer,y,C)}indexOf(y,C=0){return S(this.buffer,y instanceof p?y.buffer:y,C)}}e.$ze=p;function S(k,y,C=0){const I=y.byteLength,z=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(y[0]);if(I>z-C)return-1;const j=R.value;j.fill(y.length);for(let B=0;B<y.length;B++)j[y[B]]=y.length-B-1;let F=C+y.length-1,O=F,T=-1;for(;F<z;)if(k[F]===y[O]){if(O===0){T=F;break}F--,O--}else F+=Math.max(y.length-O,j[k[F]]),O=y.length-1;return T}function A(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function P(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255}function $(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function E(k,y,C){k[C+3]=y,y=y>>>8,k[C+2]=y,y=y>>>8,k[C+1]=y,y=y>>>8,k[C]=y}function v(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function a(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255,y=y>>>8,k[C+2]=y&255,y=y>>>8,k[C+3]=y&255}function m(k,y){return k[y]}function o(k,y,C){k[C]=y}function n(k){return N.$oe(k,y=>p.concat(y))}function i(k){return N.$ve(k)}function r(k){return N.$qe(k,y=>p.concat(y))}async function s(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await r(k.stream)])}function t(k){return N.$te(k,y=>p.concat(y))}function f(k){return N.$we(k,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}function d(k){return N.$ne(y=>p.concat(y),k)}function l(k,y){return N.$xe(k,y,C=>p.concat(C))}function c(k,y){return N.$ye(k,y,C=>p.concat(C))}function h(k){let y=0,C=0,I=0;const z=new Uint8Array(Math.floor(k.length/4*3)),j=O=>{switch(C){case 3:z[I++]=y|O,C=0;break;case 2:z[I++]=y|O>>>2,y=O<<6,C=3;break;case 1:z[I++]=y|O>>>4,y=O<<4,C=2;break;default:y=O<<2,C=1}};for(let O=0;O<k.length;O++){const T=k.charCodeAt(O);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[O]}`)}}const F=I;for(;C>0;)j(0);return p.wrap(z).slice(0,F)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:k},y=!0,C=!1){const I=C?D:g;let z="";const j=k.byteLength%3;let F=0;for(;F<k.byteLength-j;F+=3){const O=k[F+0],T=k[F+1],B=k[F+2];z+=I[O>>>2],z+=I[(O<<4|T>>>4)&63],z+=I[(T<<2|B>>>6)&63],z+=I[B&63]}if(j===1){const O=k[F+0];z+=I[O>>>2],z+=I[O<<4&63],y&&(z+="==")}else if(j===2){const O=k[F+0],T=k[F+1];z+=I[O>>>2],z+=I[(O<<4|T>>>4)&63],z+=I[T<<2&63],y&&(z+="=")}return z}}),define(ke[14],Ee([1,0,168,46]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.GraphemeBreakType=e.$Nf=e.$Gf=e.$zf=e.$yf=void 0,e.$Ze=L,e.$1e=M,e.$2e=p,e.$3e=S,e.$4e=A,e.$5e=P,e.$6e=$,e.$7e=E,e.$8e=v,e.$9e=a,e.$0e=m,e.$$e=o,e.$_e=n,e.$af=i,e.$bf=r,e.$cf=s,e.$df=t,e.$ef=f,e.$ff=d,e.$gf=l,e.$hf=c,e.$if=h,e.$jf=g,e.$kf=D,e.$lf=w,e.$mf=k,e.$nf=y,e.$of=C,e.$pf=I,e.$qf=z,e.$rf=j,e.$sf=F,e.$tf=O,e.$uf=T,e.$vf=B,e.$wf=H,e.$xf=X,e.$Af=ce,e.$Bf=ie,e.$Cf=pe,e.$Df=Ce,e.$Ef=ne,e.$Ff=De,e.$Hf=oe,e.$If=ae,e.$Jf=re,e.$Kf=K,e.$Lf=le,e.$Mf=de,e.$Of=Ae,e.$Pf=me,e.$Qf=Pe,e.$Rf=Re,e.$Sf=Fe,e.$Tf=V,e.$Uf=W,e.$Vf=Q,e.$Wf=Ve;function L(Se){return!Se||typeof Se!="string"?!0:Se.trim().length===0}const R=/{(\d+)}/g;function M(Se,...Be){return Be.length===0?Se:Se.replace(R,function(Ge,Le){const Ye=parseInt(Le,10);return isNaN(Ye)||Ye<0||Ye>=Be.length?Ge:Be[Ye]})}const b=/{([^}]+)}/g;function p(Se,Be){return Object.keys(Be).length===0?Se:Se.replace(b,(Ge,Le)=>Be[Le]??Ge)}function S(Se){return Se.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(Se){return Se.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Se){return Se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(Se,Be){let Ge=0;const Le=Be.charCodeAt(0);for(let Ye=Se.length-1;Ye>=0;Ye--)Se.charCodeAt(Ye)===Le&&Ge++;return Ge}function E(Se,Be,Ge="\u2026"){return Se.length<=Be?Se:`${Se.substr(0,Be)}${Ge}`}function v(Se,Be,Ge="\u2026"){if(Se.length<=Be)return Se;const Le=Math.ceil(Be/2)-Ge.length/2,Ye=Math.floor(Be/2)-Ge.length/2;return`${Se.substr(0,Le)}${Ge}${Se.substr(Se.length-Ye)}`}function a(Se,Be=" "){const Ge=m(Se,Be);return o(Ge,Be)}function m(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length;if(Ge===0||Se.length===0)return Se;let Le=0;for(;Se.indexOf(Be,Le)===Le;)Le=Le+Ge;return Se.substring(Le)}function o(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length,Le=Se.length;if(Ge===0||Le===0)return Se;let Ye=Le,se=-1;for(;se=Se.lastIndexOf(Be,Ye-1),!(se===-1||se+Ge!==Ye);){if(se===0)return"";Ye=se}return Se.substring(0,Ye)}function n(Se){return Se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Se){return Se.replace(/\*/g,"")}function r(Se,Be,Ge={}){if(!Se)throw new Error("Cannot create regex from empty string");Be||(Se=P(Se)),Ge.wholeWord&&(/\B/.test(Se.charAt(0))||(Se="\\b"+Se),/\B/.test(Se.charAt(Se.length-1))||(Se=Se+"\\b"));let Le="";return Ge.global&&(Le+="g"),Ge.matchCase||(Le+="i"),Ge.multiline&&(Le+="m"),Ge.unicode&&(Le+="u"),new RegExp(Se,Le)}function s(Se){return Se.source==="^"||Se.source==="^$"||Se.source==="$"||Se.source==="^\\s*$"?!1:!!(Se.exec("")&&Se.lastIndex===0)}function t(Se){return Se.split(/\r\n|\r|\n/)}function f(Se){const Be=[],Ge=Se.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(Ge.length/2);Le++)Be.push(Ge[2*Le]+(Ge[2*Le+1]??""));return Be}function d(Se){for(let Be=0,Ge=Se.length;Be<Ge;Be++){const Le=Se.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function l(Se,Be=0,Ge=Se.length){for(let Le=Be;Le<Ge;Le++){const Ye=Se.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Se.substring(Be,Le)}return Se.substring(Be,Ge)}function c(Se,Be=Se.length-1){for(let Ge=Be;Ge>=0;Ge--){const Le=Se.charCodeAt(Ge);if(Le!==32&&Le!==9)return Ge}return-1}function h(Se,Be,Ge){const Le=[];let Ye=0;for(const se of Se.matchAll(Be)){if(Le.push(Se.slice(Ye,se.index)),se.index===void 0)throw new Error("match.index should be defined");Ye=se.index+se[0].length,Le.push(Ge(se[0],...se.slice(1),se.index,Se,se.groups))}return Le.push(Se.slice(Ye)),Promise.all(Le).then(se=>se.join(""))}function g(Se,Be){return Se<Be?-1:Se>Be?1:0}function D(Se,Be,Ge=0,Le=Se.length,Ye=0,se=Be.length){for(;Ge<Le&&Ye<se;Ge++,Ye++){const Ke=Se.charCodeAt(Ge),Me=Be.charCodeAt(Ye);if(Ke<Me)return-1;if(Ke>Me)return 1}const ue=Le-Ge,Ie=se-Ye;return ue<Ie?-1:ue>Ie?1:0}function w(Se,Be){return k(Se,Be,0,Se.length,0,Be.length)}function k(Se,Be,Ge=0,Le=Se.length,Ye=0,se=Be.length){for(;Ge<Le&&Ye<se;Ge++,Ye++){let Ke=Se.charCodeAt(Ge),Me=Be.charCodeAt(Ye);if(Ke===Me)continue;if(Ke>=128||Me>=128)return D(Se.toLowerCase(),Be.toLowerCase(),Ge,Le,Ye,se);C(Ke)&&(Ke-=32),C(Me)&&(Me-=32);const it=Ke-Me;if(it!==0)return it}const ue=Le-Ge,Ie=se-Ye;return ue<Ie?-1:ue>Ie?1:0}function y(Se){return Se>=48&&Se<=57}function C(Se){return Se>=97&&Se<=122}function I(Se){return Se>=65&&Se<=90}function z(Se,Be){return Se.length===Be.length&&k(Se,Be)===0}function j(Se,Be){const Ge=Be.length;return Be.length>Se.length?!1:k(Se,Be,0,Ge)===0}function F(Se,Be){const Ge=Math.min(Se.length,Be.length);let Le;for(Le=0;Le<Ge;Le++)if(Se.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return Ge}function O(Se,Be){const Ge=Math.min(Se.length,Be.length);let Le;const Ye=Se.length-1,se=Be.length-1;for(Le=0;Le<Ge;Le++)if(Se.charCodeAt(Ye-Le)!==Be.charCodeAt(se-Le))return Le;return Ge}function T(Se){return 55296<=Se&&Se<=56319}function B(Se){return 56320<=Se&&Se<=57343}function H(Se,Be){return(Se-55296<<10)+(Be-56320)+65536}function X(Se,Be,Ge){const Le=Se.charCodeAt(Ge);if(T(Le)&&Ge+1<Be){const Ye=Se.charCodeAt(Ge+1);if(B(Ye))return H(Le,Ye)}return Le}function x(Se,Be){const Ge=Se.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Le=Se.charCodeAt(Be-2);if(T(Le))return H(Le,Ge)}return Ge}class Y{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=X(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$yf=Y;class Z{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new Y(Be,Ge)}nextGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Le=Ge.offset;let Ye=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const se=Ge.offset,ue=Be.getGraphemeBreakType(Ge.nextCodePoint());if(J(Ye,ue)){Ge.setOffset(se);break}Ye=ue}return Ge.offset-Le}prevGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Le=Ge.offset;let Ye=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const se=Ge.offset,ue=Be.getGraphemeBreakType(Ge.prevCodePoint());if(J(ue,Ye)){Ge.setOffset(se);break}Ye=ue}return Le-Ge.offset}eol(){return this.c.eol()}}e.$zf=Z;function ce(Se,Be){return new Z(Se,Be).nextGraphemeLength()}function ie(Se,Be){return new Z(Se,Be).prevGraphemeLength()}function pe(Se,Be){Be>0&&B(Se.charCodeAt(Be))&&Be--;const Ge=Be+ce(Se,Be);return[Ge-ie(Se,Ge),Ge]}function Ce(Se){const Be=new Z(Se);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let _;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Se){return _||(_=U()),_.test(Se)}const be=/^[\t\n\r\x20-\x7E]*$/;function De(Se){return be.test(Se)}e.$Gf=/[\u2028\u2029]/;function oe(Se){return e.$Gf.test(Se)}function ae(Se){return Se>=11904&&Se<=55215||Se>=63744&&Se<=64255||Se>=65281&&Se<=65374}function re(Se){return Se>=127462&&Se<=127487||Se===8986||Se===8987||Se===9200||Se===9203||Se>=9728&&Se<=10175||Se===11088||Se===11093||Se>=127744&&Se<=128591||Se>=128640&&Se<=128764||Se>=128992&&Se<=129008||Se>=129280&&Se<=129535||Se>=129648&&Se<=129782}function K(Se,Be,Ge=""){const Le=Se.trimStart();if(Le.length<Be)return Le;const Ye=/\b/g;let se=0;for(;Ye.test(Le)&&!(Le.length-Ye.lastIndex<Be);)se=Ye.lastIndex,Ye.lastIndex+=1;return se===0?Le:Ge+Le.substring(se).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(Se){let Be=0;for(const Ge of Se.matchAll(te))Be!==Ge.index&&(yield{isCode:!1,str:Se.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==Se.length&&(yield{isCode:!1,str:Se.substring(Be)})}function de(Se){return Se&&(Se=Se.replace(te,"")),Se}e.$Nf="\uFEFF";function Ae(Se){return!!(Se&&Se.length>0&&Se.charCodeAt(0)===65279)}function me(Se){return Ae(Se)?Se.substr(1):Se}function Pe(Se,Be){if(!Se||!Be||Se.length<Be.length)return!1;const Ge=Be.length,Le=Se.toLowerCase();let Ye=0,se=-1;for(;Ye<Ge;){const ue=Le.indexOf(Be[Ye],se+1);if(ue<0)return!1;se=ue,Ye++}return!0}function Re(Se,Be=!1){return Se?(Be&&(Se=Se.replace(/\\./g,"")),Se.toLowerCase()!==Se):!1}function Fe(Se){return Se.charAt(0).toUpperCase()+Se.slice(1)}function V(Se,Be=1){if(Be===0)return"";let Ge=-1;do Ge=Se.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?Se:(Se[Ge-1]==="\r"&&Ge--,Se.substr(0,Ge))}function W(Se){return Se=Se%(2*26),Se<26?String.fromCharCode(97+Se):String.fromCharCode(65+Se-26)}function Q(Se){return we.getInstance().getGraphemeBreakType(Se)}function J(Se,Be){return Se===0?Be!==5&&Be!==7:Se===2&&Be===3?!1:Se===4||Se===2||Se===3||Be===4||Be===2||Be===3?!0:!(Se===8&&(Be===8||Be===9||Be===11||Be===12)||(Se===11||Se===9)&&(Be===9||Be===10)||(Se===12||Se===10)&&Be===10||Be===5||Be===13||Be===7||Se===1||Se===13&&Be===14||Se===6&&Be===6)}var fe;(function(Se){Se[Se.Other=0]="Other",Se[Se.Prepend=1]="Prepend",Se[Se.CR=2]="CR",Se[Se.LF=3]="LF",Se[Se.Control=4]="Control",Se[Se.Extend=5]="Extend",Se[Se.Regional_Indicator=6]="Regional_Indicator",Se[Se.SpacingMark=7]="SpacingMark",Se[Se.L=8]="L",Se[Se.V=9]="V",Se[Se.T=10]="T",Se[Se.LV=11]="LV",Se[Se.LVT=12]="LVT",Se[Se.ZWJ=13]="ZWJ",Se[Se.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Le=Ge.length/3;let Ye=1;for(;Ye<=Le;)if(Be<Ge[3*Ye])Ye=2*Ye;else if(Be>Ge[3*Ye+1])Ye=2*Ye+1;else return Ge[3*Ye+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Se,Be){if(Se===0)return 0;const Ge=Xe(Se,Be);if(Ge!==void 0)return Ge;const Le=new Y(Be,Se);return Le.prevCodePoint(),Le.offset}function Xe(Se,Be){const Ge=new Y(Be,Se);let Le=Ge.prevCodePoint();for(;st(Le)||Le===65039||Le===8419;){if(Ge.offset===0)return;Le=Ge.prevCodePoint()}if(!re(Le))return;let Ye=Ge.offset;return Ye>0&&Ge.prevCodePoint()===8205&&(Ye=Ge.offset),Ye}function st(Se){return 127995<=Se&&Se<=127999}var ot;(function(Se){Se[Se.zwj=8205]="zwj",Se[Se.emojiVariantSelector=65039]="emojiVariantSelector",Se[Se.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$Xf="\xA0";class tt{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ve(Be=>{function Ge(it){const lt=new Map;for(let wt=0;wt<it.length;wt+=2)lt.set(it[wt],it[wt+1]);return lt}function Le(it,lt){const wt=new Map(it);for(const[It,Ft]of lt)wt.set(It,Ft);return wt}function Ye(it,lt){if(!it)return lt;const wt=new Map;for(const[It,Ft]of it)lt.has(It)&&wt.set(It,Ft);return wt}const se=this.c.value;let ue=Be.filter(it=>!it.startsWith("_")&&it in se);ue.length===0&&(ue=["_default"]);let Ie;for(const it of ue){const lt=Ge(se[it]);Ie=Ye(Ie,lt)}const Ke=Ge(se._common),Me=Le(Ke,Ie);return new tt(Me)})}static getInstance(Be){return tt.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(tt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return tt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Yf=tt;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Be){return rt.e().has(Be)}static get codePoints(){return rt.e()}}e.$Zf=rt}),define(ke[126],Ee([1,0,27,166,14]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.FuzzyScore=e.$pk=e.$ok=void 0,e.or=R,e.$qk=b,e.$rk=p,e.$sk=P,e.$tk=h,e.$uk=g,e.$vk=I,e.$wk=z,e.$xk=j,e.$yk=F,e.$zk=ne,e.$Bk=ae,e.$Ck=te,e.$Dk=le;function R(...me){return function(Pe,Re){for(let Fe=0,V=me.length;Fe<V;Fe++){const W=me[Fe](Pe,Re);if(W)return W}return null}}e.$ok=M.bind(void 0,!1),e.$pk=M.bind(void 0,!0);function M(me,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Fe;return me?Fe=L.$rf(Re,Pe):Fe=Re.indexOf(Pe)===0,Fe?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(me,Pe){const Re=Pe.toLowerCase().indexOf(me.toLowerCase());return Re===-1?null:[{start:Re,end:Re+me.length}]}function p(me,Pe){return S(me.toLowerCase(),Pe.toLowerCase(),0,0)}function S(me,Pe,Re,Fe){if(Re===me.length)return[];if(Fe===Pe.length)return null;if(me[Re]===Pe[Fe]){let V=null;return(V=S(me,Pe,Re+1,Fe+1))?r({start:Fe,end:Fe+1},V):null}return S(me,Pe,Re,Fe+1)}function A(me){return 97<=me&&me<=122}function P(me){return 65<=me&&me<=90}function $(me){return 48<=me&&me<=57}function E(me){return me===32||me===9||me===10||me===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>v.add(me.charCodeAt(0)));function a(me){return E(me)||v.has(me)}function m(me,Pe){return me===Pe||a(me)&&a(Pe)}const o=new Map;function n(me){if(o.has(me))return o.get(me);let Pe;const Re=(0,N.$mk)(me);return Re&&(Pe=Re),o.set(me,Pe),Pe}function i(me){return A(me)||P(me)||$(me)}function r(me,Pe){return Pe.length===0?Pe=[me]:me.end===Pe[0].start?Pe[0].start=me.start:Pe.unshift(me),Pe}function s(me,Pe){for(let Re=Pe;Re<me.length;Re++){const Fe=me.charCodeAt(Re);if(P(Fe)||$(Fe)||Re>0&&!i(me.charCodeAt(Re-1)))return Re}return me.length}function t(me,Pe,Re,Fe){if(Re===me.length)return[];if(Fe===Pe.length)return null;if(me[Re]!==Pe[Fe].toLowerCase())return null;{let V=null,W=Fe+1;for(V=t(me,Pe,Re+1,Fe+1);!V&&(W=s(Pe,W))<Pe.length;)V=t(me,Pe,Re+1,W),W++;return V===null?null:r({start:Fe,end:Fe+1},V)}}function f(me){let Pe=0,Re=0,Fe=0,V=0,W=0;for(let ze=0;ze<me.length;ze++)W=me.charCodeAt(ze),P(W)&&Pe++,A(W)&&Re++,i(W)&&Fe++,$(W)&&V++;const Q=Pe/me.length,J=Re/me.length,fe=Fe/me.length,we=V/me.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:fe,numericPercent:we}}function d(me){const{upperPercent:Pe,lowerPercent:Re}=me;return Re===0&&Pe>.6}function l(me){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Fe,numericPercent:V}=me;return Re>.2&&Pe<.8&&Fe>.6&&V<.2}function c(me){let Pe=0,Re=0,Fe=0,V=0;for(let W=0;W<me.length;W++)Fe=me.charCodeAt(W),P(Fe)&&Pe++,A(Fe)&&Re++,E(Fe)&&V++;return(Pe===0||Re===0)&&V===0?me.length<=30:Pe<=5}function h(me,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!c(me))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Re=f(Pe);if(!l(Re)){if(!d(Re))return null;Pe=Pe.toLowerCase()}let Fe=null,V=0;for(me=me.toLowerCase();V<Pe.length&&(Fe=t(me,Pe,0,V))===null;)V=s(Pe,V+1);return Fe}function g(me,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Fe=null,V=0;for(me=me.toLowerCase(),Pe=Pe.toLowerCase();V<Pe.length&&(Fe=D(me,Pe,0,V,Re),Fe===null);)V=w(Pe,V+1);return Fe}function D(me,Pe,Re,Fe,V){let W=0;if(Re===me.length)return[];if(Fe===Pe.length)return null;if(!m(me.charCodeAt(Re),Pe.charCodeAt(Fe))){const fe=n(me.charCodeAt(Re));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Pe.charCodeAt(Fe+we)))return null;W+=fe.length-1}let Q=null,J=Fe+W+1;if(Q=D(me,Pe,Re+1,J,V),!V)for(;!Q&&(J=w(Pe,J))<Pe.length;)Q=D(me,Pe,Re+1,J,V),J++;if(!Q)return null;if(me.charCodeAt(Re)!==Pe.charCodeAt(Fe)){const fe=n(me.charCodeAt(Re));if(!fe)return Q;for(let we=0;we<fe.length;we++)if(fe[we]!==Pe.charCodeAt(Fe+we))return Q}return r({start:Fe,end:Fe+W+1},Q)}function w(me,Pe){for(let Re=Pe;Re<me.length;Re++)if(a(me.charCodeAt(Re))||Re>0&&a(me.charCodeAt(Re-1)))return Re;return me.length}const k=R(e.$pk,h,b),y=R(e.$pk,h,p),C=new u.$Ec(1e4);function I(me,Pe,Re=!1){if(typeof me!="string"||typeof Pe!="string")return null;let Fe=C.get(me);Fe||(Fe=new RegExp(L.$_e(me),"i"),C.set(me,Fe));const V=Fe.exec(Pe);return V?[{start:V.index,end:V.index+V[0].length}]:Re?y(me,Pe):k(me,Pe)}function z(me,Pe){const Re=ae(me,me.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?F(Re):null}function j(me,Pe,Re,Fe,V,W){const Q=Math.min(13,me.length);for(;Re<Q;Re++){const J=ae(me,Pe,Re,Fe,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,W]}function F(me){if(typeof me>"u")return[];const Pe=[],Re=me[1];for(let Fe=me.length-1;Fe>1;Fe--){const V=me[Fe]+Re,W=Pe[Pe.length-1];W&&W.end===V?W.end=V+1:Pe.push({start:V,end:V+1})}return Pe}const O=128;function T(){const me=[],Pe=[];for(let Re=0;Re<=O;Re++)Pe[Re]=0;for(let Re=0;Re<=O;Re++)me.push(Pe.slice(0));return me}function B(me){const Pe=[];for(let Re=0;Re<=me;Re++)Pe[Re]=0;return Pe}const H=B(2*O),X=B(2*O),x=T(),Y=T(),Z=T(),ce=!1;function ie(me,Pe,Re,Fe,V){function W(J,fe,we=" "){for(;J.length<fe;)J=we+J;return J}let Q=` |   |${Fe.split("").map(J=>W(J,3)).join("|")}
`;for(let J=0;J<=Re;J++)J===0?Q+=" |":Q+=`${Pe[J-1]}|`,Q+=me[J].slice(0,V+1).map(fe=>W(fe.toString(),3)).join("|")+`
`;return Q}function pe(me,Pe,Re,Fe){me=me.substr(Pe),Re=Re.substr(Fe),console.log(ie(Y,me,me.length,Re,Re.length)),console.log(ie(Z,me,me.length,Re,Re.length)),console.log(ie(x,me,me.length,Re,Re.length))}function Ce(me,Pe){if(Pe<0||Pe>=me.length)return!1;const Re=me.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Jf(Re)}}function _(me,Pe){if(Pe<0||Pe>=me.length)return!1;switch(me.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(me,Pe,Re){return Pe[me]!==Re[me]}function ne(me,Pe,Re,Fe,V,W,Q=!1){for(;Pe<Re&&V<W;)me[Pe]===Fe[V]&&(Q&&(H[Pe]=V),Pe+=1),V+=1;return Pe===Re}var be;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(be||(be={}));var De;(function(me){me.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}me.isDefault=Pe})(De||(e.FuzzyScore=De={}));class oe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Re){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Re}}e.$Ak=oe;function ae(me,Pe,Re,Fe,V,W,Q=oe.default){const J=me.length>O?O:me.length,fe=Fe.length>O?O:Fe.length;if(Re>=J||W>=fe||J-Re>fe-W||!ne(Pe,Re,J,V,W,fe,!0))return;re(J,fe,Re,W,Pe,V);let we=1,ze=1,Ve=Re,Xe=W;const st=[!1];for(we=1,Ve=Re;Ve<J;we++,Ve++){const Be=H[Ve],Ge=X[Ve],Le=Ve+1<J?X[Ve+1]:fe;for(ze=Be-W+1,Xe=Be;Xe<Le;ze++,Xe++){let Ye=Number.MIN_SAFE_INTEGER,se=!1;Xe<=Ge&&(Ye=K(me,Pe,Ve,Re,Fe,V,Xe,fe,W,x[we-1][ze-1]===0,st));let ue=0;Ye!==Number.MAX_SAFE_INTEGER&&(se=!0,ue=Ye+Y[we-1][ze-1]);const Ie=Xe>Be,Ke=Ie?Y[we][ze-1]+(x[we][ze-1]>0?-5:0):0,Me=Xe>Be+1&&x[we][ze-1]>0,it=Me?Y[we][ze-2]+(x[we][ze-2]>0?-5:0):0;if(Me&&(!Ie||it>=Ke)&&(!se||it>=ue))Y[we][ze]=it,Z[we][ze]=3,x[we][ze]=0;else if(Ie&&(!se||Ke>=ue))Y[we][ze]=Ke,Z[we][ze]=2,x[we][ze]=0;else if(se)Y[we][ze]=ue,Z[we][ze]=1,x[we][ze]=x[we-1][ze-1]+1;else throw new Error("not possible")}}if(ce&&pe(me,Re,Fe,W),!st[0]&&!Q.firstMatchCanBeWeak)return;we--,ze--;const ot=[Y[we][ze],W];let tt=0,rt=0;for(;we>=1;){let Be=ze;do{const Ge=Z[we][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);tt>1&&Pe[Re+we-1]===V[W+ze-1]&&!U(Be+W-1,Fe,V)&&tt+1>x[we][Be]&&(Be=ze),Be===ze?tt++:tt=1,rt||(rt=Be),we--,ze=Be-1,ot.push(ze)}fe===J&&Q.boostFullMatch&&(ot[0]+=2);const Se=rt-J;return ot[0]-=Se,ot}function re(me,Pe,Re,Fe,V,W){let Q=me-1,J=Pe-1;for(;Q>=Re&&J>=Fe;)V[Q]===W[J]&&(X[Q]=J,Q--),J--}function K(me,Pe,Re,Fe,V,W,Q,J,fe,we,ze){if(Pe[Re]!==W[Q])return Number.MIN_SAFE_INTEGER;let Ve=1,Xe=!1;return Q===Re-Fe?Ve=me[Re]===V[Q]?7:5:U(Q,V,W)&&(Q===0||!U(Q-1,V,W))?(Ve=me[Re]===V[Q]?7:5,Xe=!0):Ce(W,Q)&&(Q===0||!Ce(W,Q-1))?Ve=5:(Ce(W,Q-1)||_(W,Q-1))&&(Ve=5,Xe=!0),Ve>1&&Re===Fe&&(ze[0]=!0),Xe||(Xe=U(Q,V,W)||Ce(W,Q-1)||_(W,Q-1)),Re===Fe?Q>fe&&(Ve-=Xe?3:5):we?Ve+=Xe?2:0:Ve+=Xe?0:1,Q+1===J&&(Ve-=Xe?3:5),Ve}function te(me,Pe,Re,Fe,V,W,Q){return de(me,Pe,Re,Fe,V,W,!0,Q)}function le(me,Pe,Re,Fe,V,W,Q){return de(me,Pe,Re,Fe,V,W,!1,Q)}function de(me,Pe,Re,Fe,V,W,Q,J){let fe=ae(me,Pe,Re,Fe,V,W,J);if(fe&&!Q)return fe;if(me.length>=3){const we=Math.min(7,me.length-1);for(let ze=Re+1;ze<we;ze++){const Ve=Ae(me,ze);if(Ve){const Xe=ae(Ve,Ve.toLowerCase(),Re,Fe,V,W,J);Xe&&(Xe[0]-=3,(!fe||Xe[0]>fe[0])&&(fe=Xe))}}}return fe}function Ae(me,Pe){if(Pe+1>=me.length)return;const Re=me[Pe],Fe=me[Pe+1];if(Re!==Fe)return me.slice(0,Pe)+Fe+Re+me.slice(Pe+2)}}),define(ke[56],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$fj=void 0,e.$bj=N,e.$cj=L,e.$dj=R,e.$ej=b,e.$gj=a;function N(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?p(o,n):S(o,n);case"string":return b(o,n);case"boolean":return M(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function M(o,n){return R(o?433:863,n)}function b(o,n){n=R(149417,n);for(let i=0,r=o.length;i<r;i++)n=R(o.charCodeAt(i),n);return n}function p(o,n){return n=R(104579,n),o.reduce((i,r)=>L(r,i),n)}function S(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=b(r,i),L(o[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$fj=A;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function $(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function E(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function a(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$uf(f))if(d+1<i){const c=n.charCodeAt(d+1);u.$vf(c)?(d++,l=u.$wf(f,c)):l=65533}else{t=f;break}else u.$vf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,$(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,c,h;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,c=1518500249):g<40?(l=s^t^f,c=1859775393):g<60?(l=s&t|s&f|t&f,c=2400959708):(l=s^t^f,c=3395469782),h=$(r,5)+l+d+c+n.getUint32(g*4,!1)&4294967295,d=f,f=t,t=$(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$hj=m}),define(ke[40],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",b="warn",p="info",S="ignore";function A($){return $?u.$qf(R,$)?L.Error:u.$qf(M,$)||u.$qf(b,$)?L.Warning:u.$qf(p,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function P($){switch($){case L.Error:return R;case L.Warning:return M;case L.Info:return p;default:return S}}L.toString=P}(N||(N={})),e.default=N}),define(ke[169],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class L{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),a=this.b.charCodeAt(this.c);return v-a}value(){return this.b[this.c]}}e.$pi=L;class R{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$kf)(E,this.b,0,E.length,this.c,this.d):(0,N.$mf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=R;class M{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const a=this.b.charCodeAt(v);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$kf)(E,this.b,0,E.length,this.d,this.e):(0,N.$mf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=M;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$lf)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$lf)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$jf)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$jf)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=p;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class P{static forUris(E=()=>!1,v=()=>!1){return new P(new p(E,v))}static forPaths(E=!1){return new P(new M(void 0,!E))}static forStrings(){return new P(new L)}static forConfigKeys(){return new P(new R)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const a=v.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m,E)}else{const a=E.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(E,v){const a=this.b.reset(E);let m;this.c||(this.c=new S,this.c.segment=a.value());const o=[];for(m=this.c;;){const i=a.cmp(m.segment);if(i>0)m.left||(m.left=new S,m.left.segment=a.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new S,m.right.segment=a.value()),o.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new S,m.mid.segment=a.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=v,m.key=E;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let a=this.c;for(;a;){const m=v.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else break}return a}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const a=this.b.reset(E),m=[];let o=this.c;for(;o;){const n=a.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(a.hasNext())a.next(),m.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let a=this.c,m;for(;a;){const o=v.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(v.hasNext())v.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(E){return this.g(E,!1)}g(E,v){const a=this.b.reset(E);let m=this.c;for(;m;){const o=a.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,a]of this)E(a,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const a=v.balanceFactor();return a<-1||a>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$ti=P}),define(ke[18],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=u,e.$2f=N,e.$3f=L,e.$4f=R,e.$5f=M,e.$6f=b,e.$7f=p,e.$8f=S,e.$9f=A,e.$0f=P,e.$$f=$,e.$_f=E,e.$ag=v,e.$bg=m,e.$cg=o,e.$dg=n,e.$eg=i,e.$fg=r;function u(s){return typeof s=="string"}function N(s){return Array.isArray(s)&&s.every(t=>u(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function p(s){return s===!0||s===!1}function S(s){return typeof s>"u"}function A(s){return!P(s)}function P(s){return S(s)||s===null}function $(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(P(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!L(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!P(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=L,e.$Ij=R;const N=Object.create(null);function L(M,b){if((0,u.$1f)(b)){const p=N[b];if(p===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=p}return N[M]=b,{id:M}}function R(){return N}}),define(ke[170],Ee([1,0,99]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=void 0,e.$Jj={add:(0,u.$Hj)("add",6e4),plus:(0,u.$Hj)("plus",6e4),gistNew:(0,u.$Hj)("gist-new",6e4),repoCreate:(0,u.$Hj)("repo-create",6e4),lightbulb:(0,u.$Hj)("lightbulb",60001),lightBulb:(0,u.$Hj)("light-bulb",60001),repo:(0,u.$Hj)("repo",60002),repoDelete:(0,u.$Hj)("repo-delete",60002),gistFork:(0,u.$Hj)("gist-fork",60003),repoForked:(0,u.$Hj)("repo-forked",60003),gitPullRequest:(0,u.$Hj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Hj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Hj)("record-keys",60005),keyboard:(0,u.$Hj)("keyboard",60005),tag:(0,u.$Hj)("tag",60006),gitPullRequestLabel:(0,u.$Hj)("git-pull-request-label",60006),tagAdd:(0,u.$Hj)("tag-add",60006),tagRemove:(0,u.$Hj)("tag-remove",60006),person:(0,u.$Hj)("person",60007),personFollow:(0,u.$Hj)("person-follow",60007),personOutline:(0,u.$Hj)("person-outline",60007),personFilled:(0,u.$Hj)("person-filled",60007),gitBranch:(0,u.$Hj)("git-branch",60008),gitBranchCreate:(0,u.$Hj)("git-branch-create",60008),gitBranchDelete:(0,u.$Hj)("git-branch-delete",60008),sourceControl:(0,u.$Hj)("source-control",60008),mirror:(0,u.$Hj)("mirror",60009),mirrorPublic:(0,u.$Hj)("mirror-public",60009),star:(0,u.$Hj)("star",60010),starAdd:(0,u.$Hj)("star-add",60010),starDelete:(0,u.$Hj)("star-delete",60010),starEmpty:(0,u.$Hj)("star-empty",60010),comment:(0,u.$Hj)("comment",60011),commentAdd:(0,u.$Hj)("comment-add",60011),alert:(0,u.$Hj)("alert",60012),warning:(0,u.$Hj)("warning",60012),search:(0,u.$Hj)("search",60013),searchSave:(0,u.$Hj)("search-save",60013),logOut:(0,u.$Hj)("log-out",60014),signOut:(0,u.$Hj)("sign-out",60014),logIn:(0,u.$Hj)("log-in",60015),signIn:(0,u.$Hj)("sign-in",60015),eye:(0,u.$Hj)("eye",60016),eyeUnwatch:(0,u.$Hj)("eye-unwatch",60016),eyeWatch:(0,u.$Hj)("eye-watch",60016),circleFilled:(0,u.$Hj)("circle-filled",60017),primitiveDot:(0,u.$Hj)("primitive-dot",60017),closeDirty:(0,u.$Hj)("close-dirty",60017),debugBreakpoint:(0,u.$Hj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Hj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Hj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Hj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Hj)("primitive-square",60018),edit:(0,u.$Hj)("edit",60019),pencil:(0,u.$Hj)("pencil",60019),info:(0,u.$Hj)("info",60020),issueOpened:(0,u.$Hj)("issue-opened",60020),gistPrivate:(0,u.$Hj)("gist-private",60021),gitForkPrivate:(0,u.$Hj)("git-fork-private",60021),lock:(0,u.$Hj)("lock",60021),mirrorPrivate:(0,u.$Hj)("mirror-private",60021),close:(0,u.$Hj)("close",60022),removeClose:(0,u.$Hj)("remove-close",60022),x:(0,u.$Hj)("x",60022),repoSync:(0,u.$Hj)("repo-sync",60023),sync:(0,u.$Hj)("sync",60023),clone:(0,u.$Hj)("clone",60024),desktopDownload:(0,u.$Hj)("desktop-download",60024),beaker:(0,u.$Hj)("beaker",60025),microscope:(0,u.$Hj)("microscope",60025),vm:(0,u.$Hj)("vm",60026),deviceDesktop:(0,u.$Hj)("device-desktop",60026),file:(0,u.$Hj)("file",60027),fileText:(0,u.$Hj)("file-text",60027),more:(0,u.$Hj)("more",60028),ellipsis:(0,u.$Hj)("ellipsis",60028),kebabHorizontal:(0,u.$Hj)("kebab-horizontal",60028),mailReply:(0,u.$Hj)("mail-reply",60029),reply:(0,u.$Hj)("reply",60029),organization:(0,u.$Hj)("organization",60030),organizationFilled:(0,u.$Hj)("organization-filled",60030),organizationOutline:(0,u.$Hj)("organization-outline",60030),newFile:(0,u.$Hj)("new-file",60031),fileAdd:(0,u.$Hj)("file-add",60031),newFolder:(0,u.$Hj)("new-folder",60032),fileDirectoryCreate:(0,u.$Hj)("file-directory-create",60032),trash:(0,u.$Hj)("trash",60033),trashcan:(0,u.$Hj)("trashcan",60033),history:(0,u.$Hj)("history",60034),clock:(0,u.$Hj)("clock",60034),folder:(0,u.$Hj)("folder",60035),fileDirectory:(0,u.$Hj)("file-directory",60035),symbolFolder:(0,u.$Hj)("symbol-folder",60035),logoGithub:(0,u.$Hj)("logo-github",60036),markGithub:(0,u.$Hj)("mark-github",60036),github:(0,u.$Hj)("github",60036),terminal:(0,u.$Hj)("terminal",60037),console:(0,u.$Hj)("console",60037),repl:(0,u.$Hj)("repl",60037),zap:(0,u.$Hj)("zap",60038),symbolEvent:(0,u.$Hj)("symbol-event",60038),error:(0,u.$Hj)("error",60039),stop:(0,u.$Hj)("stop",60039),variable:(0,u.$Hj)("variable",60040),symbolVariable:(0,u.$Hj)("symbol-variable",60040),array:(0,u.$Hj)("array",60042),symbolArray:(0,u.$Hj)("symbol-array",60042),symbolModule:(0,u.$Hj)("symbol-module",60043),symbolPackage:(0,u.$Hj)("symbol-package",60043),symbolNamespace:(0,u.$Hj)("symbol-namespace",60043),symbolObject:(0,u.$Hj)("symbol-object",60043),symbolMethod:(0,u.$Hj)("symbol-method",60044),symbolFunction:(0,u.$Hj)("symbol-function",60044),symbolConstructor:(0,u.$Hj)("symbol-constructor",60044),symbolBoolean:(0,u.$Hj)("symbol-boolean",60047),symbolNull:(0,u.$Hj)("symbol-null",60047),symbolNumeric:(0,u.$Hj)("symbol-numeric",60048),symbolNumber:(0,u.$Hj)("symbol-number",60048),symbolStructure:(0,u.$Hj)("symbol-structure",60049),symbolStruct:(0,u.$Hj)("symbol-struct",60049),symbolParameter:(0,u.$Hj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Hj)("symbol-type-parameter",60050),symbolKey:(0,u.$Hj)("symbol-key",60051),symbolText:(0,u.$Hj)("symbol-text",60051),symbolReference:(0,u.$Hj)("symbol-reference",60052),goToFile:(0,u.$Hj)("go-to-file",60052),symbolEnum:(0,u.$Hj)("symbol-enum",60053),symbolValue:(0,u.$Hj)("symbol-value",60053),symbolRuler:(0,u.$Hj)("symbol-ruler",60054),symbolUnit:(0,u.$Hj)("symbol-unit",60054),activateBreakpoints:(0,u.$Hj)("activate-breakpoints",60055),archive:(0,u.$Hj)("archive",60056),arrowBoth:(0,u.$Hj)("arrow-both",60057),arrowDown:(0,u.$Hj)("arrow-down",60058),arrowLeft:(0,u.$Hj)("arrow-left",60059),arrowRight:(0,u.$Hj)("arrow-right",60060),arrowSmallDown:(0,u.$Hj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Hj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Hj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Hj)("arrow-small-up",60064),arrowUp:(0,u.$Hj)("arrow-up",60065),bell:(0,u.$Hj)("bell",60066),bold:(0,u.$Hj)("bold",60067),book:(0,u.$Hj)("book",60068),bookmark:(0,u.$Hj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Hj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Hj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Hj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Hj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Hj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Hj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Hj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Hj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Hj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Hj)("briefcase",60076),broadcast:(0,u.$Hj)("broadcast",60077),browser:(0,u.$Hj)("browser",60078),bug:(0,u.$Hj)("bug",60079),calendar:(0,u.$Hj)("calendar",60080),caseSensitive:(0,u.$Hj)("case-sensitive",60081),check:(0,u.$Hj)("check",60082),checklist:(0,u.$Hj)("checklist",60083),chevronDown:(0,u.$Hj)("chevron-down",60084),chevronLeft:(0,u.$Hj)("chevron-left",60085),chevronRight:(0,u.$Hj)("chevron-right",60086),chevronUp:(0,u.$Hj)("chevron-up",60087),chromeClose:(0,u.$Hj)("chrome-close",60088),chromeMaximize:(0,u.$Hj)("chrome-maximize",60089),chromeMinimize:(0,u.$Hj)("chrome-minimize",60090),chromeRestore:(0,u.$Hj)("chrome-restore",60091),circleOutline:(0,u.$Hj)("circle-outline",60092),circle:(0,u.$Hj)("circle",60092),debugBreakpointUnverified:(0,u.$Hj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Hj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Hj)("circle-slash",60093),circuitBoard:(0,u.$Hj)("circuit-board",60094),clearAll:(0,u.$Hj)("clear-all",60095),clippy:(0,u.$Hj)("clippy",60096),closeAll:(0,u.$Hj)("close-all",60097),cloudDownload:(0,u.$Hj)("cloud-download",60098),cloudUpload:(0,u.$Hj)("cloud-upload",60099),code:(0,u.$Hj)("code",60100),collapseAll:(0,u.$Hj)("collapse-all",60101),colorMode:(0,u.$Hj)("color-mode",60102),commentDiscussion:(0,u.$Hj)("comment-discussion",60103),creditCard:(0,u.$Hj)("credit-card",60105),dash:(0,u.$Hj)("dash",60108),dashboard:(0,u.$Hj)("dashboard",60109),database:(0,u.$Hj)("database",60110),debugContinue:(0,u.$Hj)("debug-continue",60111),debugDisconnect:(0,u.$Hj)("debug-disconnect",60112),debugPause:(0,u.$Hj)("debug-pause",60113),debugRestart:(0,u.$Hj)("debug-restart",60114),debugStart:(0,u.$Hj)("debug-start",60115),debugStepInto:(0,u.$Hj)("debug-step-into",60116),debugStepOut:(0,u.$Hj)("debug-step-out",60117),debugStepOver:(0,u.$Hj)("debug-step-over",60118),debugStop:(0,u.$Hj)("debug-stop",60119),debug:(0,u.$Hj)("debug",60120),deviceCameraVideo:(0,u.$Hj)("device-camera-video",60121),deviceCamera:(0,u.$Hj)("device-camera",60122),deviceMobile:(0,u.$Hj)("device-mobile",60123),diffAdded:(0,u.$Hj)("diff-added",60124),diffIgnored:(0,u.$Hj)("diff-ignored",60125),diffModified:(0,u.$Hj)("diff-modified",60126),diffRemoved:(0,u.$Hj)("diff-removed",60127),diffRenamed:(0,u.$Hj)("diff-renamed",60128),diff:(0,u.$Hj)("diff",60129),diffSidebyside:(0,u.$Hj)("diff-sidebyside",60129),discard:(0,u.$Hj)("discard",60130),editorLayout:(0,u.$Hj)("editor-layout",60131),emptyWindow:(0,u.$Hj)("empty-window",60132),exclude:(0,u.$Hj)("exclude",60133),extensions:(0,u.$Hj)("extensions",60134),eyeClosed:(0,u.$Hj)("eye-closed",60135),fileBinary:(0,u.$Hj)("file-binary",60136),fileCode:(0,u.$Hj)("file-code",60137),fileMedia:(0,u.$Hj)("file-media",60138),filePdf:(0,u.$Hj)("file-pdf",60139),fileSubmodule:(0,u.$Hj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Hj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Hj)("file-symlink-file",60142),fileZip:(0,u.$Hj)("file-zip",60143),files:(0,u.$Hj)("files",60144),filter:(0,u.$Hj)("filter",60145),flame:(0,u.$Hj)("flame",60146),foldDown:(0,u.$Hj)("fold-down",60147),foldUp:(0,u.$Hj)("fold-up",60148),fold:(0,u.$Hj)("fold",60149),folderActive:(0,u.$Hj)("folder-active",60150),folderOpened:(0,u.$Hj)("folder-opened",60151),gear:(0,u.$Hj)("gear",60152),gift:(0,u.$Hj)("gift",60153),gistSecret:(0,u.$Hj)("gist-secret",60154),gist:(0,u.$Hj)("gist",60155),gitCommit:(0,u.$Hj)("git-commit",60156),gitCompare:(0,u.$Hj)("git-compare",60157),compareChanges:(0,u.$Hj)("compare-changes",60157),gitMerge:(0,u.$Hj)("git-merge",60158),githubAction:(0,u.$Hj)("github-action",60159),githubAlt:(0,u.$Hj)("github-alt",60160),globe:(0,u.$Hj)("globe",60161),grabber:(0,u.$Hj)("grabber",60162),graph:(0,u.$Hj)("graph",60163),gripper:(0,u.$Hj)("gripper",60164),heart:(0,u.$Hj)("heart",60165),home:(0,u.$Hj)("home",60166),horizontalRule:(0,u.$Hj)("horizontal-rule",60167),hubot:(0,u.$Hj)("hubot",60168),inbox:(0,u.$Hj)("inbox",60169),issueReopened:(0,u.$Hj)("issue-reopened",60171),issues:(0,u.$Hj)("issues",60172),italic:(0,u.$Hj)("italic",60173),jersey:(0,u.$Hj)("jersey",60174),json:(0,u.$Hj)("json",60175),kebabVertical:(0,u.$Hj)("kebab-vertical",60176),key:(0,u.$Hj)("key",60177),law:(0,u.$Hj)("law",60178),lightbulbAutofix:(0,u.$Hj)("lightbulb-autofix",60179),linkExternal:(0,u.$Hj)("link-external",60180),link:(0,u.$Hj)("link",60181),listOrdered:(0,u.$Hj)("list-ordered",60182),listUnordered:(0,u.$Hj)("list-unordered",60183),liveShare:(0,u.$Hj)("live-share",60184),loading:(0,u.$Hj)("loading",60185),location:(0,u.$Hj)("location",60186),mailRead:(0,u.$Hj)("mail-read",60187),mail:(0,u.$Hj)("mail",60188),markdown:(0,u.$Hj)("markdown",60189),megaphone:(0,u.$Hj)("megaphone",60190),mention:(0,u.$Hj)("mention",60191),milestone:(0,u.$Hj)("milestone",60192),gitPullRequestMilestone:(0,u.$Hj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Hj)("mortar-board",60193),move:(0,u.$Hj)("move",60194),multipleWindows:(0,u.$Hj)("multiple-windows",60195),mute:(0,u.$Hj)("mute",60196),noNewline:(0,u.$Hj)("no-newline",60197),note:(0,u.$Hj)("note",60198),octoface:(0,u.$Hj)("octoface",60199),openPreview:(0,u.$Hj)("open-preview",60200),package:(0,u.$Hj)("package",60201),paintcan:(0,u.$Hj)("paintcan",60202),pin:(0,u.$Hj)("pin",60203),play:(0,u.$Hj)("play",60204),run:(0,u.$Hj)("run",60204),plug:(0,u.$Hj)("plug",60205),preserveCase:(0,u.$Hj)("preserve-case",60206),preview:(0,u.$Hj)("preview",60207),project:(0,u.$Hj)("project",60208),pulse:(0,u.$Hj)("pulse",60209),question:(0,u.$Hj)("question",60210),quote:(0,u.$Hj)("quote",60211),radioTower:(0,u.$Hj)("radio-tower",60212),reactions:(0,u.$Hj)("reactions",60213),references:(0,u.$Hj)("references",60214),refresh:(0,u.$Hj)("refresh",60215),regex:(0,u.$Hj)("regex",60216),remoteExplorer:(0,u.$Hj)("remote-explorer",60217),remote:(0,u.$Hj)("remote",60218),remove:(0,u.$Hj)("remove",60219),replaceAll:(0,u.$Hj)("replace-all",60220),replace:(0,u.$Hj)("replace",60221),repoClone:(0,u.$Hj)("repo-clone",60222),repoForcePush:(0,u.$Hj)("repo-force-push",60223),repoPull:(0,u.$Hj)("repo-pull",60224),repoPush:(0,u.$Hj)("repo-push",60225),report:(0,u.$Hj)("report",60226),requestChanges:(0,u.$Hj)("request-changes",60227),rocket:(0,u.$Hj)("rocket",60228),rootFolderOpened:(0,u.$Hj)("root-folder-opened",60229),rootFolder:(0,u.$Hj)("root-folder",60230),rss:(0,u.$Hj)("rss",60231),ruby:(0,u.$Hj)("ruby",60232),saveAll:(0,u.$Hj)("save-all",60233),saveAs:(0,u.$Hj)("save-as",60234),save:(0,u.$Hj)("save",60235),screenFull:(0,u.$Hj)("screen-full",60236),screenNormal:(0,u.$Hj)("screen-normal",60237),searchStop:(0,u.$Hj)("search-stop",60238),server:(0,u.$Hj)("server",60240),settingsGear:(0,u.$Hj)("settings-gear",60241),settings:(0,u.$Hj)("settings",60242),shield:(0,u.$Hj)("shield",60243),smiley:(0,u.$Hj)("smiley",60244),sortPrecedence:(0,u.$Hj)("sort-precedence",60245),splitHorizontal:(0,u.$Hj)("split-horizontal",60246),splitVertical:(0,u.$Hj)("split-vertical",60247),squirrel:(0,u.$Hj)("squirrel",60248),starFull:(0,u.$Hj)("star-full",60249),starHalf:(0,u.$Hj)("star-half",60250),symbolClass:(0,u.$Hj)("symbol-class",60251),symbolColor:(0,u.$Hj)("symbol-color",60252),symbolConstant:(0,u.$Hj)("symbol-constant",60253),symbolEnumMember:(0,u.$Hj)("symbol-enum-member",60254),symbolField:(0,u.$Hj)("symbol-field",60255),symbolFile:(0,u.$Hj)("symbol-file",60256),symbolInterface:(0,u.$Hj)("symbol-interface",60257),symbolKeyword:(0,u.$Hj)("symbol-keyword",60258),symbolMisc:(0,u.$Hj)("symbol-misc",60259),symbolOperator:(0,u.$Hj)("symbol-operator",60260),symbolProperty:(0,u.$Hj)("symbol-property",60261),wrench:(0,u.$Hj)("wrench",60261),wrenchSubaction:(0,u.$Hj)("wrench-subaction",60261),symbolSnippet:(0,u.$Hj)("symbol-snippet",60262),tasklist:(0,u.$Hj)("tasklist",60263),telescope:(0,u.$Hj)("telescope",60264),textSize:(0,u.$Hj)("text-size",60265),threeBars:(0,u.$Hj)("three-bars",60266),thumbsdown:(0,u.$Hj)("thumbsdown",60267),thumbsup:(0,u.$Hj)("thumbsup",60268),tools:(0,u.$Hj)("tools",60269),triangleDown:(0,u.$Hj)("triangle-down",60270),triangleLeft:(0,u.$Hj)("triangle-left",60271),triangleRight:(0,u.$Hj)("triangle-right",60272),triangleUp:(0,u.$Hj)("triangle-up",60273),twitter:(0,u.$Hj)("twitter",60274),unfold:(0,u.$Hj)("unfold",60275),unlock:(0,u.$Hj)("unlock",60276),unmute:(0,u.$Hj)("unmute",60277),unverified:(0,u.$Hj)("unverified",60278),verified:(0,u.$Hj)("verified",60279),versions:(0,u.$Hj)("versions",60280),vmActive:(0,u.$Hj)("vm-active",60281),vmOutline:(0,u.$Hj)("vm-outline",60282),vmRunning:(0,u.$Hj)("vm-running",60283),watch:(0,u.$Hj)("watch",60284),whitespace:(0,u.$Hj)("whitespace",60285),wholeWord:(0,u.$Hj)("whole-word",60286),window:(0,u.$Hj)("window",60287),wordWrap:(0,u.$Hj)("word-wrap",60288),zoomIn:(0,u.$Hj)("zoom-in",60289),zoomOut:(0,u.$Hj)("zoom-out",60290),listFilter:(0,u.$Hj)("list-filter",60291),listFlat:(0,u.$Hj)("list-flat",60292),listSelection:(0,u.$Hj)("list-selection",60293),selection:(0,u.$Hj)("selection",60293),listTree:(0,u.$Hj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Hj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Hj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Hj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Hj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Hj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Hj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Hj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Hj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Hj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Hj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Hj)("symbol-string",60301),debugReverseContinue:(0,u.$Hj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Hj)("debug-step-back",60303),debugRestartFrame:(0,u.$Hj)("debug-restart-frame",60304),debugAlt:(0,u.$Hj)("debug-alt",60305),callIncoming:(0,u.$Hj)("call-incoming",60306),callOutgoing:(0,u.$Hj)("call-outgoing",60307),menu:(0,u.$Hj)("menu",60308),expandAll:(0,u.$Hj)("expand-all",60309),feedback:(0,u.$Hj)("feedback",60310),gitPullRequestReviewer:(0,u.$Hj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Hj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Hj)("ungroup-by-ref-type",60312),account:(0,u.$Hj)("account",60313),gitPullRequestAssignee:(0,u.$Hj)("git-pull-request-assignee",60313),bellDot:(0,u.$Hj)("bell-dot",60314),debugConsole:(0,u.$Hj)("debug-console",60315),library:(0,u.$Hj)("library",60316),output:(0,u.$Hj)("output",60317),runAll:(0,u.$Hj)("run-all",60318),syncIgnored:(0,u.$Hj)("sync-ignored",60319),pinned:(0,u.$Hj)("pinned",60320),githubInverted:(0,u.$Hj)("github-inverted",60321),serverProcess:(0,u.$Hj)("server-process",60322),serverEnvironment:(0,u.$Hj)("server-environment",60323),pass:(0,u.$Hj)("pass",60324),issueClosed:(0,u.$Hj)("issue-closed",60324),stopCircle:(0,u.$Hj)("stop-circle",60325),playCircle:(0,u.$Hj)("play-circle",60326),record:(0,u.$Hj)("record",60327),debugAltSmall:(0,u.$Hj)("debug-alt-small",60328),vmConnect:(0,u.$Hj)("vm-connect",60329),cloud:(0,u.$Hj)("cloud",60330),merge:(0,u.$Hj)("merge",60331),export:(0,u.$Hj)("export",60332),graphLeft:(0,u.$Hj)("graph-left",60333),magnet:(0,u.$Hj)("magnet",60334),notebook:(0,u.$Hj)("notebook",60335),redo:(0,u.$Hj)("redo",60336),checkAll:(0,u.$Hj)("check-all",60337),pinnedDirty:(0,u.$Hj)("pinned-dirty",60338),passFilled:(0,u.$Hj)("pass-filled",60339),circleLargeFilled:(0,u.$Hj)("circle-large-filled",60340),circleLarge:(0,u.$Hj)("circle-large",60341),circleLargeOutline:(0,u.$Hj)("circle-large-outline",60341),combine:(0,u.$Hj)("combine",60342),gather:(0,u.$Hj)("gather",60342),table:(0,u.$Hj)("table",60343),variableGroup:(0,u.$Hj)("variable-group",60344),typeHierarchy:(0,u.$Hj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Hj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Hj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Hj)("git-pull-request-create",60348),runAbove:(0,u.$Hj)("run-above",60349),runBelow:(0,u.$Hj)("run-below",60350),notebookTemplate:(0,u.$Hj)("notebook-template",60351),debugRerun:(0,u.$Hj)("debug-rerun",60352),workspaceTrusted:(0,u.$Hj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Hj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Hj)("workspace-unknown",60355),terminalCmd:(0,u.$Hj)("terminal-cmd",60356),terminalDebian:(0,u.$Hj)("terminal-debian",60357),terminalLinux:(0,u.$Hj)("terminal-linux",60358),terminalPowershell:(0,u.$Hj)("terminal-powershell",60359),terminalTmux:(0,u.$Hj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Hj)("terminal-ubuntu",60361),terminalBash:(0,u.$Hj)("terminal-bash",60362),arrowSwap:(0,u.$Hj)("arrow-swap",60363),copy:(0,u.$Hj)("copy",60364),personAdd:(0,u.$Hj)("person-add",60365),filterFilled:(0,u.$Hj)("filter-filled",60366),wand:(0,u.$Hj)("wand",60367),debugLineByLine:(0,u.$Hj)("debug-line-by-line",60368),inspect:(0,u.$Hj)("inspect",60369),layers:(0,u.$Hj)("layers",60370),layersDot:(0,u.$Hj)("layers-dot",60371),layersActive:(0,u.$Hj)("layers-active",60372),compass:(0,u.$Hj)("compass",60373),compassDot:(0,u.$Hj)("compass-dot",60374),compassActive:(0,u.$Hj)("compass-active",60375),azure:(0,u.$Hj)("azure",60376),issueDraft:(0,u.$Hj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Hj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Hj)("git-pull-request-draft",60379),debugAll:(0,u.$Hj)("debug-all",60380),debugCoverage:(0,u.$Hj)("debug-coverage",60381),runErrors:(0,u.$Hj)("run-errors",60382),folderLibrary:(0,u.$Hj)("folder-library",60383),debugContinueSmall:(0,u.$Hj)("debug-continue-small",60384),beakerStop:(0,u.$Hj)("beaker-stop",60385),graphLine:(0,u.$Hj)("graph-line",60386),graphScatter:(0,u.$Hj)("graph-scatter",60387),pieChart:(0,u.$Hj)("pie-chart",60388),bracket:(0,u.$Hj)("bracket",60175),bracketDot:(0,u.$Hj)("bracket-dot",60389),bracketError:(0,u.$Hj)("bracket-error",60390),lockSmall:(0,u.$Hj)("lock-small",60391),azureDevops:(0,u.$Hj)("azure-devops",60392),verifiedFilled:(0,u.$Hj)("verified-filled",60393),newline:(0,u.$Hj)("newline",60394),layout:(0,u.$Hj)("layout",60395),layoutActivitybarLeft:(0,u.$Hj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Hj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Hj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Hj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Hj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Hj)("layout-panel-right",60401),layoutPanel:(0,u.$Hj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Hj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Hj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Hj)("layout-statusbar",60405),layoutMenubar:(0,u.$Hj)("layout-menubar",60406),layoutCentered:(0,u.$Hj)("layout-centered",60407),target:(0,u.$Hj)("target",60408),indent:(0,u.$Hj)("indent",60409),recordSmall:(0,u.$Hj)("record-small",60410),errorSmall:(0,u.$Hj)("error-small",60411),terminalDecorationError:(0,u.$Hj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Hj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Hj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Hj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Hj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Hj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Hj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Hj)("layout-sidebar-left-off",60418),blank:(0,u.$Hj)("blank",60419),heartFilled:(0,u.$Hj)("heart-filled",60420),map:(0,u.$Hj)("map",60421),mapHorizontal:(0,u.$Hj)("map-horizontal",60421),foldHorizontal:(0,u.$Hj)("fold-horizontal",60421),mapFilled:(0,u.$Hj)("map-filled",60422),mapHorizontalFilled:(0,u.$Hj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Hj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Hj)("circle-small",60423),bellSlash:(0,u.$Hj)("bell-slash",60424),bellSlashDot:(0,u.$Hj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Hj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Hj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Hj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Hj)("search-fuzzy",60429),commentDraft:(0,u.$Hj)("comment-draft",60430),send:(0,u.$Hj)("send",60431),sparkle:(0,u.$Hj)("sparkle",60432),insert:(0,u.$Hj)("insert",60433),mic:(0,u.$Hj)("mic",60434),thumbsdownFilled:(0,u.$Hj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Hj)("thumbsup-filled",60436),coffee:(0,u.$Hj)("coffee",60437),snake:(0,u.$Hj)("snake",60438),game:(0,u.$Hj)("game",60439),vr:(0,u.$Hj)("vr",60440),chip:(0,u.$Hj)("chip",60441),piano:(0,u.$Hj)("piano",60442),music:(0,u.$Hj)("music",60443),micFilled:(0,u.$Hj)("mic-filled",60444),repoFetch:(0,u.$Hj)("repo-fetch",60445),copilot:(0,u.$Hj)("copilot",60446),lightbulbSparkle:(0,u.$Hj)("lightbulb-sparkle",60447),robot:(0,u.$Hj)("robot",60448),sparkleFilled:(0,u.$Hj)("sparkle-filled",60449),diffSingle:(0,u.$Hj)("diff-single",60450),diffMultiple:(0,u.$Hj)("diff-multiple",60451),surroundWith:(0,u.$Hj)("surround-with",60452),share:(0,u.$Hj)("share",60453),gitStash:(0,u.$Hj)("git-stash",60454),gitStashApply:(0,u.$Hj)("git-stash-apply",60455),gitStashPop:(0,u.$Hj)("git-stash-pop",60456),vscode:(0,u.$Hj)("vscode",60457),vscodeInsiders:(0,u.$Hj)("vscode-insiders",60458),codeOss:(0,u.$Hj)("code-oss",60459),runCoverage:(0,u.$Hj)("run-coverage",60460),runAllCoverage:(0,u.$Hj)("run-all-coverage",60461),coverage:(0,u.$Hj)("coverage",60462),githubProject:(0,u.$Hj)("github-project",60463),mapVertical:(0,u.$Hj)("map-vertical",60464),foldVertical:(0,u.$Hj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Hj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Hj)("fold-vertical-filled",60465)}}),define(ke[78],Ee([1,0,99,170]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=void 0,e.$Kj=L;function L(){return Object.values(e.$Mj)}e.$Lj={dialogError:(0,u.$Hj)("dialog-error","error"),dialogWarning:(0,u.$Hj)("dialog-warning","warning"),dialogInfo:(0,u.$Hj)("dialog-info","info"),dialogClose:(0,u.$Hj)("dialog-close","close"),treeItemExpanded:(0,u.$Hj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Hj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Hj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Hj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Hj)("tree-item-loading","loading"),menuSelection:(0,u.$Hj)("menu-selection","check"),menuSubmenu:(0,u.$Hj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Hj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Hj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Hj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Hj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Hj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Hj)("toolbar-more","more"),quickInputBack:(0,u.$Hj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Hj)("drop-down-button",60084),symbolCustomColor:(0,u.$Hj)("symbol-customcolor",60252),exportIcon:(0,u.$Hj)("export",60332),workspaceUnspecified:(0,u.$Hj)("workspace-unspecified",60355),newLine:(0,u.$Hj)("newline",60394),thumbsDownFilled:(0,u.$Hj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Hj)("thumbsup-filled",60436),gitFetch:(0,u.$Hj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Hj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Hj)("debug-breakpoint-pending",60377)},e.$Mj={...N.$Jj,...e.$Lj}}),define(ke[24],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=N,e.$Un=L,e.$Vn=M,e.$Wn=p,e.$Xn=S,e.$Yn=A,e.$Zn=P,e.$1n=$,e.$2n=E,e.$3n=v,e.$4n=a,e.$5n=m;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?N(r):r}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(R.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$4f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function M(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,u.$0f)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,u.$3f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function p(o,n,i=!0){return(0,u.$3f)(o)?((0,u.$3f)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$3f)(o[r])&&(0,u.$3f)(n[r])?p(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function S(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!S(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!S(s,t))return!1;for(i=0;i<s.length;i++)if(!S(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$3f)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function P(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];S(t,f)||(i[s]=f)}),i}function $(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function E(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function a(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[57],Ee([1,0,78]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Nj=L;var N;(function(M){function b(p){return p&&typeof p=="object"&&typeof p.id=="string"}M.isThemeColor=b})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function p(n){const i=b.exec(n.id);if(!i)return p(u.$Mj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=p;function S(n){return p(n).join(" ")}M.asClassName=S;function A(n){return"."+p(n).join(".")}M.asCSSSelector=A;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=P;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function E(n){const i=$.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=E;function v(n){return{id:n}}M.fromId=v;function a(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}M.modify=a;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=p,e.$Fk=A,e.$Gk=$,e.$Hk=E,e.$Ik=a,e.$Jk=m;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function p(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(S,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(P,(n,i,r,s)=>r?n:i||s||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(o){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$vk)(o,r,i);const t=(0,N.$0e)(r," "),f=r.length-t.length,d=(0,u.$vk)(o,t,i);if(d)for(const l of d){const c=s[l.start+f]+f;l.start+=c,l.end+=c}return d}}),define(ke[127],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Xe=N,e.$Ye=L;var u;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return u.test(L)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let p=0;p<b.length;p++)b[p]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,S="";return S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S+="-",S+=M[R[p++]],S+=M[R[p++]],S+="-",S+=M[R[p++]],S+=M[R[p++]],S+="-",S+=M[R[p++]],S+=M[R[p++]],S+="-",S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S+=M[R[p++]],S}}()}),define(ke[172],Ee([1,0,19,45,30]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=R,e.$Et=M,e.$Gt=S;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function M(P,$,E){const v={id:(0,L.$Jg)(),name:P,uri:$,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let $=0;for(const E of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const E=[...this.a.keys()];return N.Iterable.some(this,([v,a])=>a.asFile())&&E.push("files"),A(p($),E)}get($){return this.a.get(this.b($))?.[0]}append($,E){const v=this.a.get($);v?v.push(E):this.a.set(this.b($),[E])}replace($,E){this.a.set(this.b($),[E])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,E]of this.a)for(const v of E)yield[$,v]}b($){return p($)}}e.$Ft=b;function p(P){return P.toLowerCase()}function S(P,$){return A(p(P),$.map(p))}function A(P,$){if(P==="*/*")return $.length>0;if($.includes(P))return!0;const E=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,a,m]=E;return m==="*"?$.some(o=>o.startsWith(a+"/")):!1}e.$Ht=Object.freeze({create:P=>(0,u.$Mb)(P.map($=>$.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Ht.split(P).filter($=>!$.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N,e.$Ng=R;function N(b,p,S,A=1){let P=!1;return new Promise($=>{const E=setTimeout(()=>{if(!P)return P=!0,$(0)},S);L(b,p,A,v=>{if(!P)return P=!0,clearTimeout(E),$(v)})})}function L(b,p,S,A){if(p===0)return A(0);const P=new u.Socket;P.once("connect",()=>(M(P),L(b+S,p-1,S,A))),P.once("data",()=>{}),P.once("error",$=>(M(P),$.code!=="ECONNREFUSED"?L(b+S,p-1,S,A):A(b))),P.connect(b,"127.0.0.1")}e.$Mg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,p,S,A="127.0.0.1"){let P=!1,$,E=1;const v=u.createServer({pauseOnConnect:!0});function a(m,o){P||(P=!0,v.removeAllListeners(),v.close(),$&&clearTimeout($),o(m))}return new Promise(m=>{$=setTimeout(()=>{a(0,m)},S),v.on("listening",()=>{a(b,m)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<p?(b++,E++,v.listen(b,A)):a(0,m)}),v.on("close",()=>{a(0,m)}),v.listen(b,A)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(p){console.error(p)}}}),define(ke[128],Ee([1,0,127]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=void 0;class N{constructor(b){const p=(0,u.$Xe)(b);this.c=p,this.a=N.d(p),this.b=new Map}static d(b){const p=new Uint8Array(256);return p.fill(b),p}set(b,p){const S=(0,u.$Xe)(p);b>=0&&b<256?this.a[b]=S:this.b.set(b,S)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$vt=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$wt=R}),define(ke[174],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=N;var u;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(L){let R=0,M=0,b=0,p=0;for(let S=0,A=L.length;S<A;S++){const P=L.charCodeAt(S);P===13?(R===0&&(M=S),R++,S+1<A&&L.charCodeAt(S+1)===10?(p|=2,S++):p|=3,b=S+1):P===10&&(p|=1,R===0&&(M=S),R++,b=S+1)}return R===0&&(M=L.length),[R,M,L.length-b,p]}}),define(ke[50],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class u{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new u(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return u.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return u.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return u.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,b=R.lineNumber|0;if(M===b){const p=L.column|0,S=R.column|0;return p-S}return M-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new u(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$gt=u}),define(ke[29],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0;class N{constructor(R,M,b,p){R>b||R===b&&M>p?(this.startLineNumber=b,this.startColumn=p,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=b,this.endColumn=p)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let b,p,S,A;return M.startLineNumber<R.startLineNumber?(b=M.startLineNumber,p=M.startColumn):M.startLineNumber===R.startLineNumber?(b=M.startLineNumber,p=Math.min(M.startColumn,R.startColumn)):(b=R.startLineNumber,p=R.startColumn),M.endLineNumber>R.endLineNumber?(S=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(S=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(S=R.endLineNumber,A=R.endColumn),new N(b,p,S,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let b=R.startLineNumber,p=R.startColumn,S=R.endLineNumber,A=R.endColumn;const P=M.startLineNumber,$=M.startColumn,E=M.endLineNumber,v=M.endColumn;return b<P?(b=P,p=$):b===P&&(p=Math.max(p,$)),S>E?(S=E,A=v):S===E&&(A=Math.min(A,v)),b>S||b===S&&p>A?null:new N(b,p,S,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new u.$gt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new u.$gt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const S=R.startLineNumber|0,A=M.startLineNumber|0;if(S===A){const P=R.startColumn|0,$=M.startColumn|0;if(P===$){const E=R.endLineNumber|0,v=M.endLineNumber|0;if(E===v){const a=R.endColumn|0,m=M.endColumn|0;return a-m}return E-v}return P-$}return S-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ht=N}),define(ke[175],Ee([1,0,29]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0;class N{static insert(R,M){return{range:new u.$ht(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$it=N}),define(ke[176],Ee([1,0,50,29]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$ht{constructor(b,p,S,A){super(b,p,S,A),this.selectionStartLineNumber=b,this.selectionStartColumn=p,this.positionLineNumber=S,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,p){return b.selectionStartLineNumber===p.selectionStartLineNumber&&b.selectionStartColumn===p.selectionStartColumn&&b.positionLineNumber===p.positionLineNumber&&b.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,p){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,p):new R(b,p,this.startLineNumber,this.startColumn)}getPosition(){return new u.$gt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$gt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,p){return this.getDirection()===0?new R(b,p,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,p)}static fromPositions(b,p=b){return new R(b.lineNumber,b.column,p.lineNumber,p.column)}static fromRange(b,p){return p===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,p){if(b&&!p||!b&&p)return!1;if(!b&&!p)return!0;if(b.length!==p.length)return!1;for(let S=0,A=b.length;S<A;S++)if(!this.selectionsEqual(b[S],p[S]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,p,S,A,P){return P===0?new R(b,p,S,A):new R(S,A,b,p)}}e.$jt=R}),define(ke[177],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.WordCharacterClass=void 0,e.$yt=b;var L;(function(p){p[p.Regular=0]="Regular",p[p.Whitespace=1]="Whitespace",p[p.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$vt{constructor(S,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,$=S.length;P<$;P++)this.set(S.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,A){let P=null;for(const $ of this.h(S)){if($.index>A)break;P=$}return P}findNextIntlWordAtOrAfterOffset(S,A){for(const P of this.h(S))if(!(P.index<A))return P;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const A=[];for(const P of S)this.k(P)&&A.push(P);return A}k(S){return!!S.isWordLike}}e.$xt=R;const M=new u.$Ec(10);function b(p,S){const A=`${p}/${S.join(",")}`;let P=M.get(A);return P||(P=new R(p,S),M.set(A,P)),P}}),define(ke[129],Ee([1,0,45,3,75]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=void 0,e.$Us=M,e.$Vs=p,e.$Ws=S,e.$Ss="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Ss)P.indexOf(E)>=0||($+="\\"+E);return $+="\\s]+)",new RegExp($,"g")}e.$Ts=R();function M(P){let $=e.$Ts;if(P&&P instanceof RegExp)if(P.global)$=P;else{let E="g";P.ignoreCase&&(E+="i"),P.multiline&&(E+="m"),P.unicode&&(E+="u"),$=new RegExp(P.source,E)}return $.lastIndex=0,$}const b=new L.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(P){const $=b.unshift(P);return(0,N.$Sc)($)}function S(P,$,E,v,a){if($=M($),a||(a=u.Iterable.first(b)),E.length>a.maxLen){let r=P-a.maxLen/2;return r<0?r=0:v+=r,E=E.substring(r,P+a.maxLen/2),S(P,$,E,v,a)}const m=Date.now(),o=P-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=o-a.windowSize*r;$.lastIndex=Math.max(0,s);const t=A($,E,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return $.lastIndex=0,r}return null}function A(P,$,E,v){let a;for(;a=P.exec($);){const m=a.index||0;if(m<=E&&P.lastIndex>=E)return a;if(v>0&&m>v)return null}return null}}),define(ke[179],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let p=0,S=b.notIn.length;p<S;p++)switch(b.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,p){if(b.getTokenCount()===0)return!0;const S=b.findTokenIndexAtOffset(p-2),A=b.getStandardTokenType(S);return this.isOK(A)}g(b,p){for(let S=b;S<=p;S++){const A=String.fromCharCode(S);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=N;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of b)R(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),R(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),R(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),R(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&R(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$$t=L;function R(M,b,p){M.has(b)?M.get(b).push(p):M.set(b,[p])}}),define(ke[180],Ee([1,0,128]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X2=e.$W2=e.State=void 0,e.$Y2=$;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(v,a,m){const o=new Uint8Array(v*a);for(let n=0,i=v*a;n<i;n++)o[n]=m;this.a=o,this.rows=v,this.cols=a}get(v,a){return this.a[v*this.cols+a]}set(v,a,m){this.a[v*this.cols+a]=m}}class R{constructor(v){let a=0,m=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const o=new L(m,a,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];o.set(r,s,t)}this.a=o,this.b=a}nextState(v,a){return a<0||a>=this.b?0:this.a.get(v,a)}}e.$W2=R;let M=null;function b(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var p;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let S=null;function A(){if(S===null){S=new u.$vt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<E.length;a++)S.set(E.charCodeAt(a),1);const v=".,;:";for(let a=0;a<v.length;a++)S.set(v.charCodeAt(a),2)}return S}class P{static a(v,a,m,o,n){let i=n-1;do{const r=a.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>o);if(o>0){const r=a.charCodeAt(o-1),s=a.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:a.substring(o,i+1)}}static computeLinks(v,a=b()){const m=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,c=!1,h=!1,g=!1,D=!1;for(;t<s;){let w=!1;const k=r.charCodeAt(t);if(l===13){let y;switch(k){case 40:c=!0,y=0;break;case 41:y=c?0:1;break;case 91:g=!0,h=!0,y=0;break;case 93:g=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:d===k?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=g?0:1;break;default:y=m.get(k)}y===1&&(o.push(P.a(m,r,n,f,t)),w=!0)}else if(l===12){let y;k===91?(h=!0,y=0):y=m.get(k),y===1?w=!0:l=13}else l=a.nextState(l,k),l===0&&(w=!0);w&&(l=1,c=!1,h=!1,D=!1,f=t+1,d=k),t++}l===13&&o.push(P.a(m,r,n,f,s))}return o}}e.$X2=P;function $(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:P.computeLinks(E)}}),define(ke[79],Ee([1,0,24]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$sv=e.$rv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$tv=v,e.$xv=r;var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var p;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var S;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$Xn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$rv=P;class ${constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$sv=$;var E;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function v(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,d,l,c,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.$uv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$vv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$wv=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.NodeColor=e.$nC=void 0,e.$pC=L,e.$qC=R,e.$rC=S,e.$sC=A,e.$tC=P,e.$uC=$,e.$vC=E,e.$wC=v;class u{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oC)return L(this.right);let m=this;for(;m.parent!==e.$oC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$oC?e.$oC:m.parent}prev(){if(this.left!==e.$oC)return R(this.left);let m=this;for(;m.parent!==e.$oC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$oC?e.$oC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nC=u;var N;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$oC=new u(null,0),e.$oC.parent=e.$oC,e.$oC.left=e.$oC,e.$oC.right=e.$oC,e.$oC.color=0;function L(a){for(;a.left!==e.$oC;)a=a.left;return a}function R(a){for(;a.right!==e.$oC;)a=a.right;return a}function M(a){return a===e.$oC?0:a.size_left+a.piece.length+M(a.right)}function b(a){return a===e.$oC?0:a.lf_left+a.piece.lineFeedCnt+b(a.right)}function p(){e.$oC.parent=e.$oC}function S(a,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$oC&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$oC?a.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function A(a,m){const o=m.left;m.left=o.right,o.right!==e.$oC&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$oC?a.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function P(a,m){let o,n;if(m.left===e.$oC?(n=m,o=n.right):m.right===e.$oC?(n=m,o=n.left):(n=L(m.right),o=n.right),n===a.root){a.root=o,o.color=0,m.detach(),p(),a.root.parent=e.$oC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,v(a,o)):(n.parent===m?o.parent=n:o.parent=n.parent,v(a,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===a.root?a.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$oC&&(n.left.parent=n),n.right!==e.$oC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,v(a,n)),m.detach(),o.parent.left===o){const s=M(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,E(a,o.parent,f,d)}}if(v(a,o.parent),i){p();return}let r;for(;o!==a.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,S(a,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,S(a,o.parent),o=a.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(a,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,S(a,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(a,o.parent),o=a.root));o.color=0,p()}function $(a,m){for(v(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,S(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,S(a,m.parent.parent))}a.root.color=0}function E(a,m,o,n){for(;m!==a.root&&m!==e.$oC;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function v(a,m){let o=0,n=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,o=M(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==a.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ke[182],Ee([1,0,19,127]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=void 0;class L{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,S){p=(0,N.$Ye)(p);const A=this.a,P=this.b,$=S.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,p),0),this.a.set(A.subarray(p),p+$),this.a.set(S,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(p,S){return p=(0,N.$Ye)(p),S=(0,N.$Ye)(S),this.a[p]===S?!1:(this.a[p]=S,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,S){p=(0,N.$Ye)(p),S=(0,N.$Ye)(S);const A=this.a,P=this.b;if(p>=A.length)return!1;const $=A.length-p;return S>=$&&(S=$),S===0?!1:(this.a=new Uint32Array(A.length-S),this.a.set(A.subarray(0,p),0),this.a.set(A.subarray(p+S),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,N.$Ye)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),p>=this.a.length&&(p=this.a.length-1);for(let A=S;A<=p;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let S=0,A=this.a.length-1,P=0,$=0,E=0;for(;S<=A;)if(P=S+(A-S)/2|0,$=this.b[P],E=$-this.a[P],p<E)A=P-1;else if(p>=$)S=P+1;else break;return new M(P,p-E)}}e.$Jv=L;class R{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const S=this.e[p],A=S>0?this.d[S-1]:0;return new M(S,p-A)}removeValues(p,S){this.a.splice(p,S),this.f(p)}insertValues(p,S){this.a=(0,u.$Wb)(this.a,p,S),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,S=this.a.length;p<S;p++){const A=this.a[p],P=p>0?this.d[p-1]:0;this.d[p]=P+A;for(let $=0;$<A;$++)this.e[P+$]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,S){this.a[p]!==S&&(this.a[p]=S,this.f(p))}}e.$Kv=R;class M{constructor(p,S){this.index=p,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=S}}e.$Lv=M}),define(ke[183],Ee([1,0,14,50,182]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=void 0;class R{constructor(b,p,S,A){this.d=b,this.f=p,this.g=S,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const p=b.changes;for(const S of p)this.o(S.range),this.p(new N.$gt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,p=this.f.length,S=new Uint32Array(p);for(let A=0;A<p;A++)S[A]=this.f[A].length+b;this.j=new L.$Jv(S)}}n(b,p){this.f[b]=p,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,p){if(p.length===0)return;const S=(0,u.$df)(p);if(S.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]+this.f[b.lineNumber-1].substring(b.column-1));return}S[S.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]);const A=new Uint32Array(S.length-1);for(let P=1;P<S.length;P++)this.f.splice(b.lineNumber+P-1,0,S[P]),A[P-1]=S[P].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Mv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$AC=e.$xC=void 0,e.$yC=S,e.$zC=A,e.$BC=a;const b=999;class p{constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$bf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$vv(i,this.wordSeparators?(0,N.$yt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$xC=p;function S(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new M.$sv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new M.$sv(o,r)}class P{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class ${static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new m(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let c;if(s){const w=s.findLineFeedCountBeforeOffset(t+f.length)-l;c=d+f.length+w}else c=d+f.length;const h=n.getPositionAt(d),g=n.getPositionAt(c);return new R.$ht(h.lineNumber,h.column,g.lineNumber,g.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new P(d):null,c=[];let h=0,g;for(r.reset(0);g=r.next(d);)if(c[h++]=A(this.a(n,f,d,l,g.index,g[0]),g,s),h>=t)return c;return c}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,c,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let c=i.startLineNumber+1;c<i.endLineNumber&&d<t;c++)d=this.d(r,n.getLineContent(c),c,0,d,f,s,t);if(d<t){const c=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,c,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const c=n.wordSeparators;if(!d&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=i.length;let y=-w;for(;(y=i.indexOf(D,y+w))!==-1;)if((!c||a(c,i,k,y,w))&&(f[t++]=new M.$sv(new R.$ht(r,y+1+s,r,y+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let g;h.reset(0);do if(g=h.next(i),g&&(f[t++]=A(new R.$ht(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new L.$gt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new R.$ht(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),c=n.getEOL()===`\r
`?new P(l):null;r.reset(i.column-1);const h=r.next(l);return h?A(this.a(n,f,l,c,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new L.$gt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let c=1;c<=t;c++){const h=(f+c-1)%t,g=n.getLineContent(h+1),D=this.g(r,g,h+1,1,s);if(D)return D}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new R.$ht(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new R.$ht(1,1,i.lineNumber,i.column),r,s,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new L.$gt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let c=1;c<=t;c++){const h=(t+f-c-1)%t,g=n.getLineContent(h+1),D=this.k(r,g,h+1,s);if(D)return D}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new R.$ht(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$AC=$;function E(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function v(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function a(o,n,i,r,s){return E(o,n,i,r,s)&&v(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$xf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$CC=m}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$GC=e.$FC=void 0,e.$DC=A,e.$EC=P;const b=65535;function p(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class S{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?p(i):i}function P(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,c=n.length;l<c;l++){const h=n.charCodeAt(l);h===13?l+1<c&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new S(p(o),r,s,t,f);return o.length=0,d}class ${constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$FC=$;class E{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$GC=E;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$oC&&n.iterate(n.root,r=>(r!==R.$oC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=R.$oC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const d=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(f<=r||f+h<s)return t+=c,f+=h,!0;const g=t.replace(/\r\n|\r|\n/g,n);return d.push(new E(g,A(g))),t=c,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new E(l,A(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$oC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),c=n.getValueInRange2(d,l);return i+=f,t===c})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==R.$oC;)if(s.left!==R.$oC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==R.$oC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$gt(r+1,d+1)}return new u.$gt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$oC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$gt(r+1,f+1)}else i=i.right;return new u.$gt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+n.remainder,c+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==R.$oC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===R.$oC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,c=this.a[f.bufferIndex].lineStarts,h=f.start.line,g=f.end.line;let D=c[h]+f.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===g)return!this.f&&l.charCodeAt(D+d-1)===13?(s=!0,r+=l.substr(D,d-1)):r+=l.substr(D,d),!0;r+=this.f?l.substring(D,Math.max(D,c[h+1]-this.e)):l.substring(D,c[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<g;w++)r=this.f?l.substring(c[w],c[w+1]-this.e):l.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(c[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(c[g],f.end.column-1)):r=l.substr(c[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,c,h,g){const D=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,f);let C;const I={line:0,column:0};let z,j;i._wordSeparators?(z=D.buffer.substring(k,y),j=F=>F+k,i.reset(0)):(z=D.buffer,j=F=>F,i.reset(k));do if(C=i.next(z),C){if(j(C.index)>=y)return h;this.s(n,j(C.index)-w,I);const F=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+s:I.column+1,T=O+C[0].length;if(g[h++]=(0,M.$zC)(new N.$ht(r+F,O,r+F,T),C,l),j(C.index)+C[0].length>=y||h>=c)return h}while(C);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new M.$CC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const c=this.H(n.endLineNumber,n.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const g=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,g,i,r,s,f,t),t;let D=n.startLineNumber,w=l.node;for(;w!==c.node;){const y=this.t(w.piece.bufferIndex,h,w.piece.end);if(y>=1){const I=this.a[w.piece.bufferIndex].lineStarts,z=this.u(w.piece.bufferIndex,w.piece.start),j=I[h.line+y],F=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(w,d,D,F,h,this.s(w,j-z),i,r,s,f,t),f>=s)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(C,n.endColumn-1);return f=this.n(i,d,I,n.endLineNumber,C,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(D).substr(C),D,C,f,t,r,s),f>=s)return t;D++,l=this.H(D,1),w=l.node,h=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return f=this.n(i,d,C,n.endLineNumber,y,f,t,r,s),t}const k=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(c.node,d,D,k,h,g,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,c){const h=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=r.length;let y=-w;for(;(y=r.indexOf(D,y+w))!==-1;)if((!h||(0,M.$BC)(h,r,k,y,w))&&(d[f++]=new L.$sv(new N.$ht(s,y+1+t,s,y+1+w+t),null),f>=c))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(d[f++]=(0,M.$zC)(new N.$ht(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=c))return f;while(g);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$oC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,c=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<b){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let g=new $(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:g.start.line+1,column:0};g=new $(g.bufferIndex,y,g.end,this.t(g.bufferIndex,y,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,c);else this.C(s,c);const D=this.w(i);g.length>0&&this.S(s,g);let w=s;for(let k=0;k<D.length;k++)w=this.S(w,D[k]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$oC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const D=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$tC)(this,t),this.N(k),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const c=this.s(f,s.remainder);this.D(f,c),f.piece.length===0&&d.push(f);const h=t.next();for(let D=h;D!==R.$oC&&D!==f;D=D.next())d.push(D);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new $(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,R.$vC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let c=s.start.line,h=s.end.line,g=0,D=0,w=0;for(;c<=h&&(g=c+(h-c)/2|0,w=f[g],g!==h);)if(D=f[g+1],l<w)h=g-1;else if(l>=D)c=g+1;else break;return r?(r.line=g,r.column=l-w,null):{line:g,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$tC)(this,n[i])}w(n){if(n.length>b){const h=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let w;D===13||D>=55296&&D<=56319?(w=n.substring(0,b-1),n=n.substring(b-1)):(w=n.substring(0,b),n=n.substring(b));const k=A(w);h.push(new $(this.a.length,{line:0,column:0},{line:k.length-1,column:w.length-k[k.length-1]},k.length-1,w.length)),this.a.push(new E(w,k))}const g=A(n);return h.push(new $(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new E(n,g)),h}let i=this.a[0].buffer.length;const r=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},c=new $(0,s,l,this.t(0,s,l),t-i);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const c=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+c-i)}}else{let f=0;const d=n;for(;r!==R.$oC;)if(r.left!==R.$oC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),c=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(g+l,g+c-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=c.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$oC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==R.$oC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),c=l-s,h=d-t,g=r.length+h;n.piece=new $(r.bufferIndex,r.start,f,l,g),(0,R.$vC)(this,n,h,c)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),c=d-s,h=t-l,g=r.length+h;n.piece=new $(r.bufferIndex,f,r.end,d,g),(0,R.$vC)(this,n,h,c)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,c=i,h=this.t(s.bufferIndex,s.start,c),g=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new $(s.bufferIndex,s.start,c,h,g),(0,R.$vC)(this,n,g-d,h-l);const D=new $(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),w=this.S(n,D);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},c=n.piece.length+i.length,h=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,l),D=g-h;n.piece=new $(n.piece.bufferIndex,n.piece.start,l,g,c),this.g=l,(0,R.$vC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==R.$oC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==R.$oC;)if(r.left!==R.$oC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$oC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$oC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$oC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,d,f),(0,R.$vC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},c=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new $(i.piece.bufferIndex,l,i.piece.end,h,c),(0,R.$vC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let D=0;D<r.length;D++)(0,R.$tC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,R.$tC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new $(s.bufferIndex,t,s.end,d,f),(0,R.$vC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$oC)return i(R.$oC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$oC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new R.$nC(i,1);if(r.left=R.$oC,r.right=R.$oC,r.parent=R.$oC,r.size_left=0,r.lf_left=0,this.root===R.$oC)this.root=r,r.color=0;else if(n.right===R.$oC)n.right=r,r.parent=n;else{const t=(0,R.$pC)(n.right);t.left=r,r.parent=t}return(0,R.$uC)(this,r),r}T(n,i){const r=new R.$nC(i,1);if(r.left=R.$oC,r.right=R.$oC,r.parent=R.$oC,r.size_left=0,r.lf_left=0,this.root===R.$oC)this.root=r,r.color=0;else if(n.left===R.$oC)n.left=r,r.parent=n;else{const s=(0,R.$qC)(n.left);s.right=r,r.parent=s}return(0,R.$uC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$HC=m}),define(ke[184],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0=e.$I0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$I0=u;class N{constructor(R){this.identifier=R}}e.$J0=N}),define(ke[185],Ee([1,0,4,3]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$_d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,p){return this.a.set(b,p),this.handleChange([b]),(0,N.$Sc)(()=>{this.a.get(b)===p&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,p){this.b.get(b)?.dispose();const S=new R(this,b,p);return this.b.set(b,S),(0,N.$Sc)(()=>{const A=this.b.get(b);!A||A!==S||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const p=this.get(b);if(p)return p;const S=this.b.get(b);return!S||S.isResolved?null:(await S.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const S=this.b.get(b);return!!(!S||S.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Jt=L;class R extends N.$Uc{get isResolved(){return this.c}constructor(b,p,S){super(),this.f=b,this.g=p,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[186],Ee([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0,e.$0i=A;class R extends N.$Uc{constructor($,E="",v="",a=!0,m){super(),this.h=this.B(new u.$_d),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=E,this.u=v,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,E){this.C&&await this.C($)}}e.$5i=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$_d),this.onWillRun=this.f.event,this.m=this.B(new u.$_d),this.onDidRun=this.m.event}async run($,E){if(!$.enabled)return;this.f.fire({action:$});let v;try{await this.u($,E)}catch(a){v=a}this.m.fire({action:$,error:v})}async u($,E){await $.run(E)}}e.$6i=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let E=[];for(const v of $)v.length&&(E.length?E=[...E,new b,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$7i=b;class p{get actions(){return this.a}constructor($,E,v,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=E,this.class=a,this.a=v}async run(){}}e.$8i=p;class S extends R{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$9i=S;function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...$)=>P.run(...$),tooltip:P.label}}}),define(ke[188],Ee([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=S,e.$Tm=A,e.$Um=P;const N=60,L=N*60,R=L*24,M=R*7,b=R*30,p=R*365;function S($,E,v,a){typeof $!="number"&&($=$.getTime());const m=Math.round((new Date().getTime()-$)/1e3);if(m<-30)return(0,u.localize)(0,null,S(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,u.localize)(1,null);let o;return m<N?(o=m,E?o===1?v?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):v?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?v?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):v?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):m<L?(o=Math.floor(m/N),E?o===1?v?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):v?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?v?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):v?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):m<R?(o=Math.floor(m/L),E?o===1?v?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):v?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?v?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):v?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):m<M?(o=Math.floor(m/R),E?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):m<b?(o=Math.floor(m/M),E?o===1?v?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):v?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?v?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):v?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):m<p?(o=Math.floor(m/b),E?o===1?v?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):v?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?v?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):v?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(m/p),E?o===1?v?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):v?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?v?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):v?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function A($,E){const v=Math.abs($/1e3);return v<1?E?(0,u.localize)(54,null,$):(0,u.localize)(55,null,$):v<N?E?(0,u.localize)(56,null,Math.round($)/1e3):(0,u.localize)(57,null,Math.round($)/1e3):v<L?E?(0,u.localize)(58,null,Math.round($/(1e3*N))):(0,u.localize)(59,null,Math.round($/(1e3*N))):v<R?E?(0,u.localize)(60,null,Math.round($/(1e3*L))):(0,u.localize)(61,null,Math.round($/(1e3*L))):(0,u.localize)(62,null,Math.round($/(1e3*R)))}function P($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=p,e.$_i=S,e.$aj=A;function R(P,$){return $&&(P.stack||P.stacktrace)?L.localize(0,null,b(P),M(P.stack)||M(P.stacktrace)):b(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?L.localize(1,null,P.message):P.message||L.localize(2,null)}function p(P=null,$=!1){if(!P)return L.localize(3,null);if(Array.isArray(P)){const E=u.$Hb(P),v=p(E[0],$);return E.length>1?L.localize(4,null,v,E.length):v}if(N.$1f(P))return P;if(P.detail){const E=P.detail;if(E.error)return R(E.error,$);if(E.exception)return R(E.exception,$)}return P.stack?R(P,$):P.message?P.message:L.localize(5,null)}function S(P){const $=P;return $ instanceof Error&&Array.isArray($.actions)}function A(P,$){let E;return typeof P=="string"?E=new Error(P):E=P,E.actions=$,E}}),define(ke[191],Ee([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=D,e.$J=w,e.$g="en";let N=!1,L=!1,R=!1,M=!1,b=!1,p=!1,S=!1,A=!1,P=!1,$=!1,E,v=e.$g,a=e.$g,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=r,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const y=JSON.parse(k),C=y.availableLanguages["*"];E=y.locale,a=y.osLocale,v=C||e.$g,m=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,p=!0,E=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=E,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;L?d=1:N?d=3:R&&(d=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=b,e.$n=S,e.$o=p,e.$p=p&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=P,e.$u=d,e.$v=o,e.$w=v;var l;(function(k){function y(){return e.$w}k.value=y;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=C;function I(){return e.$w==="en"}k.isDefault=I})(l||(e.Language=l={})),e.$x=E,e.$y=a,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let I=0,z=k.length;I<z;I++){const j=k[I];if(j.id===C.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let y=0;return C=>{const I=++y;k.push({id:I,callback:C}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var c;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=L||A?2:N?1:3;let h=!0,g=!1;function D(){if(!g){g=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,h=new Uint16Array(k.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(k){return parseFloat(k)>=20}}),define(ke[51],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,51]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,b=46,p=47,S=92,A=58,P=63;class $ extends Error{constructor(f,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${h} ${c} of type ${d}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,f){if(t===null||typeof t!="object")throw new $(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new $(f,"string",t)}const a=u.$ec==="win32";function m(t){return t===p||t===S}function o(t){return t===p}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,f,d,l){let c="",h=0,g=-1,D=0,w=0;for(let k=0;k<=t.length;++k){if(k<t.length)w=t.charCodeAt(k);else{if(l(w))break;w=p}if(l(w)){if(!(g===k-1||D===1))if(D===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const y=c.lastIndexOf(d);y===-1?(c="",h=0):(c=c.slice(0,y),h=c.length-1-c.lastIndexOf(d)),g=k,D=0;continue}else if(c.length!==0){c="",h=0,g=k,D=0;continue}}f&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(g+1,k)}`:c=t.slice(g+1,k),h=k-g-1;g=k,D=0}else w===b&&D!==-1?++D:D=-1}return c}function r(t,f){E(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],v(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${f}\\`));const g=h.length;let D=0,w="",k=!1;const y=h.charCodeAt(0);if(g===1)m(y)&&(D=1,k=!0);else if(m(y))if(k=!0,m(h.charCodeAt(1))){let C=2,I=C;for(;C<g&&!m(h.charCodeAt(C));)C++;if(C<g&&C!==I){const z=h.slice(I,C);for(I=C;C<g&&m(h.charCodeAt(C));)C++;if(C<g&&C!==I){for(I=C;C<g&&!m(h.charCodeAt(C));)C++;(C===g||C!==I)&&(w=`\\\\${z}\\${h.slice(I,C)}`,D=C)}}}else D=1;else n(y)&&h.charCodeAt(1)===A&&(w=h.slice(0,2),D=2,g>2&&m(h.charCodeAt(2))&&(k=!0,D=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(l){if(f.length>0)break}else if(d=`${h.slice(D)}\\${d}`,l=k,k&&f.length>0)break}return d=i(d,!l,"\\",m),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(m(h))if(c=!0,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){const k=t.slice(w,D);for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${k}\\${t.slice(w)}\\`;D!==w&&(l=`\\\\${k}\\${t.slice(w,D)}`,d=D)}}}else d=1;else n(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(c=!0,d=3));let g=d<f?i(t.slice(d),!c,"\\",m):"";return g.length===0&&!c&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?c?`\\${g}`:g:c?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&n(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const g=t[h];v(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++c;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++c,h>2&&(m(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<f.length&&m(f.charCodeAt(c));)c++;c>=2&&(f=`\\${f.slice(c)}`)}return e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===S;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===S;)h--;const g=h-c;let D=0;for(;D<f.length&&f.charCodeAt(D)===S;)D++;let w=f.length;for(;w-1>D&&f.charCodeAt(w-1)===S;)w--;const k=w-D,y=g<k?g:k;let C=-1,I=0;for(;I<y;I++){const j=t.charCodeAt(c+I);if(j!==f.charCodeAt(D+I))break;j===S&&(C=I)}if(I!==y){if(C===-1)return l}else{if(k>y){if(f.charCodeAt(D+I)===S)return l.slice(D+I+1);if(I===2)return l.slice(D+I)}g>y&&(t.charCodeAt(c+I)===S?C=I:I===2&&(C=3)),C===-1&&(C=0)}let z="";for(I=c+C+1;I<=h;++I)(I===h||t.charCodeAt(I)===S)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${l.slice(D,w)}`:(l.charCodeAt(D)===S&&++D,l.slice(D,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const d=f.charCodeAt(2);if(d!==P&&d!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(f===1)return m(c)?t:".";if(m(c)){if(d=l=1,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==w&&(d=l=D+1)}}}}else n(c)&&t.charCodeAt(1)===A&&(d=f>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,g=!0;for(let D=f-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!g){h=D;break}}else g=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=0,d=-1,l=0,c=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let D=t.length-1;D>=f;--D){const w=t.charCodeAt(D);if(m(w)){if(!h){l=D+1;break}continue}c===-1&&(h=!1,c=D+1),w===b?d===-1?d=D:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||c===-1||g===0||g===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return m(c)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(c)){if(l=1,m(t.charCodeAt(1))){let C=2,I=C;for(;C<d&&!m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&!m(t.charCodeAt(C));)C++;C===d?l=C:C!==I&&(l=C+1)}}}}else if(n(c)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,g=l,D=-1,w=!0,k=t.length-1,y=0;for(;k>=l;--k){if(c=t.charCodeAt(k),m(c)){if(!w){g=k+1;break}continue}D===-1&&(w=!1,D=k+1),c===b?h===-1?h=k:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===g+1?f.base=f.name=t.slice(g,D):(f.name=t.slice(g,h),f.base=t.slice(g,D),f.ext=t.slice(h,D))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:s();v(c,"path"),c.length!==0&&(f=`${c}/${f}`,d=c.charCodeAt(0)===p)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p,d=t.charCodeAt(t.length-1)===p;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,c=l-d,h=1,g=f.length-h,D=c<g?c:g;let w=-1,k=0;for(;k<D;k++){const C=t.charCodeAt(d+k);if(C!==f.charCodeAt(h+k))break;C===p&&(w=k)}if(k===D)if(g>D){if(f.charCodeAt(h+k)===p)return f.slice(h+k+1);if(k===0)return f.slice(h+k)}else c>D&&(t.charCodeAt(d+k)===p?w=k:k===0&&(w=0));let y="";for(k=d+w+1;k<=l;++k)(k===l||t.charCodeAt(k)===p)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===p){if(!l){d=c;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===p){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===p){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=-1,d=0,l=-1,c=!0,h=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===p){if(!c){d=g+1;break}continue}l===-1&&(c=!1,l=g+1),D===b?f===-1?f=g:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===p;let l;d?(f.root="/",l=1):l=0;let c=-1,h=0,g=-1,D=!0,w=t.length-1,k=0;for(;w>=l;--w){const y=t.charCodeAt(w);if(y===p){if(!D){h=w+1;break}continue}g===-1&&(D=!1,g=w+1),y===b?c===-1?c=w:k!==1&&(k=1):c!==-1&&(k=-1)}if(g!==-1){const y=h===0&&d?1:h;c===-1||k===0||k===1&&c===g-1&&c===h+1?f.base=f.name=t.slice(y,g):(f.name=t.slice(y,c),f.base=t.slice(y,g),f.ext=t.slice(c,g))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=b,e.$9q=p,e.$0q=S,e.$$q=A,e.$_q=P,e.$ar=$,e.$br=E,e.$cr=v,e.$dr=a,e.$er=m,e.$fr=c,e.$gr=h,e.$hr=g;const L=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,w,k=!1){const y=D||"",C=w||"",I=L.value.collator.compare(y,C);return L.value.collatorIsNumeric&&I===0&&y!==C?y<C?-1:1:I}function p(D,w){const k=R.value.collator;return D=D||"",w=w||"",r(k,D,w)}function S(D,w){const k=R.value.collator;return D=D||"",w=w||"",d(D,w)||r(k,D,w)}function A(D,w){const k=R.value.collator;return D=D||"",w=w||"",f(D,w)||r(k,D,w)}function P(D,w){return D=D||"",w=w||"",D===w?0:D<w?-1:1}function $(D,w){const[k,y]=n(D),[C,I]=n(w);let z=L.value.collator.compare(y,I);if(z===0){if(L.value.collatorIsNumeric&&y!==I)return y<I?-1:1;if(z=L.value.collator.compare(k,C),L.value.collatorIsNumeric&&z===0&&k!==C)return k<C?-1:1}return z}function E(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||r(C,D,w)}function v(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||d(D,w)||r(C,D,w)}function a(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||f(D,w)||r(C,D,w)}function m(D,w){D=D||"",w=w||"";const k=i(D).toLowerCase(),y=i(w).toLowerCase();return k!==y?k<y?-1:1:D!==w?D<w?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(D,w=!1){const k=D?o.exec(D):[];let y=[k&&k[1]||"",k&&k[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const w=D?o.exec(D):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(D,w,k){const y=D.compare(w,k);return y!==0?y:w.length!==k.length?w.length<k.length?-1:1:0}function s(D){const w=D.charAt(0);return w.toLocaleUpperCase()!==w}function t(D){const w=D.charAt(0);return w.toLocaleLowerCase()!==w}function f(D,w){return s(D)&&t(w)?-1:t(D)&&s(w)?1:0}function d(D,w){return t(D)&&s(w)?-1:s(D)&&t(w)?1:0}function l(D,w,k=!1){return k||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase()),D===w?0:D<w?-1:1}function c(D,w,k=!1){const y=D.split(N.sep),C=w.split(N.sep),I=y.length-1,z=C.length-1;let j,F;for(let O=0;;O++){if(j=I===O,F=z===O,j&&F)return b(y[O],C[O],k);if(j)return-1;if(F)return 1;const T=l(y[O],C[O],k);if(T!==0)return T}}function h(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=g(D,w,k);if(I)return I;const z=y.endsWith(k),j=C.endsWith(k);if(z!==j)return z?-1:1;const F=b(y,C);return F!==0?F:y.localeCompare(C)}function g(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=y.startsWith(k),z=C.startsWith(k);if(I!==z)return I?-1:1;if(I&&z){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=M,e.$hg=b,e.$ig=p,e.$jg=S,e.$kg=A,e.$lg=v,e.$mg=a,e.$ng=m,e.$og=o,e.$pg=n,e.$qg=i,e.$rg=r,e.$sg=s,e.$tg=t,e.$ug=f,e.$vg=c;function M(h){return h===47||h===92}function b(h){return h.replace(/[\\/]/g,u.$hc.sep)}function p(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function S(h,g=u.$hc.sep){if(!h)return"";const D=h.length,w=h.charCodeAt(0);if(M(w)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!M(h.charCodeAt(y));y++);if(C!==y&&!M(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(w)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let k=h.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(M(h.charCodeAt(k)))return h.slice(0,k+1)}return""}function A(h){if(!N.$i||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let D=2;const w=D;for(;D<h.length&&(g=h.charCodeAt(D),g!==92);D++);return!(w===D||(g=h.charCodeAt(D+1),isNaN(g)||g===92))}const P=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,g=N.$i){const D=g?P:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||g&&E.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}function a(h,g,D){const w=h===g;return!D||w?w:!h||!g?!1:(0,L.$qf)(h,g)}function m(h,g,D,w=u.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(D){if(!(0,L.$rf)(h,g))return!1;if(g.length===h.length)return!0;let y=g.length;return g.charAt(g.length-1)===w&&y--,h.charAt(y)===w}return g.charAt(g.length-1)!==w&&(g+=w),h.indexOf(g)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,g){return N.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(g,h)),h=(0,u.$ic)(h),N.$i?(h=(0,L.$$e)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,L.$$e)(h,u.sep),h||(h=u.sep)),h}function i(h){const g=(0,u.$ic)(h);return N.$i?h.length>3?!1:r(g)&&(h.length===2||g.charCodeAt(2)===92):g===u.$hc.sep}function r(h,g=N.$i){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,g=N.$i){return r(h,g)?h[0]:void 0}function t(h,g,D){return g.length>h.length?-1:h===g?0:(D&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}function f(h){const g=h.split(":");let D,w,k;for(const y of g){const C=Number(y);(0,R.$5f)(C)?w===void 0?w=C:k===void 0&&(k=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:w!==void 0?w:void 0,column:k!==void 0?k:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,g,D=8){let w="";for(let y=0;y<D;y++){let C;y===0&&N.$i&&!g&&(D===3||D===4)?C=l:C=d,w+=C.charAt(Math.floor(Math.random()*C.length))}let k;return g?k=`${g}-${w}`:k=w,h?(0,u.$kc)(h,k):k}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=A,e.$jr=m,e.$kr=d,e.$lr=k,e.$mr=F,e.$nr=T;const p=0,S=[p,[]];function A(B,H,X,x){if(!B||!H)return S;const Y=B.length,Z=H.length;if(Y<Z)return S;const ce=B.toLowerCase();return P(H,X,Z,B,ce,Y,x)}function P(B,H,X,x,Y,Z,ce){const ie=[],pe=[];for(let ne=0;ne<X;ne++){const be=ne*Z,De=be-Z,oe=ne>0,ae=B[ne],re=H[ne];for(let K=0;K<Z;K++){const te=K>0,le=be+K,de=le-1,Ae=De+K-1,me=te?ie[de]:0,Pe=oe&&te?ie[Ae]:0,Re=oe&&te?pe[Ae]:0;let Fe;!Pe&&oe?Fe=0:Fe=$(ae,re,x,Y,K,Re),Fe&&Pe+Fe>=me&&(ce||oe||Y.startsWith(H,K))?(pe[le]=Re+1,ie[le]=Pe+Fe):(pe[le]=p,ie[le]=me)}}const Ce=[];let _=X-1,U=Z-1;for(;_>=0&&U>=0;){const ne=_*Z+U;pe[ne]===p||(Ce.push(U),_--),U--}return[ie[X*Z-1],Ce.reverse()]}function $(B,H,X,x,Y,Z){let ce=0;if(!E(H,x[Y]))return ce;if(ce+=1,Z>0&&(ce+=Z*5),B===X[Y]&&(ce+=1),Y===0)ce+=8;else{const ie=v(X.charCodeAt(Y-1));ie?ce+=ie:(0,N.$sk)(X.charCodeAt(Y))&&Z===0&&(ce+=2)}return ce}function E(B,H){return B===H?!0:B==="/"||B==="\\"?H==="/"||H==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(B,H,X=0,x=0){const Y=H;return Y.values&&Y.values.length>1?o(B,Y.values,X,x):n(B,H,X,x)}function o(B,H,X,x){let Y=0;const Z=[];for(const ce of H){const[ie,pe]=n(B,ce,X,x);if(typeof ie!="number")return a;Y+=ie,Z.push(...pe)}return[Y,D(Z)]}function n(B,H,X,x){const Y=(0,N.$Bk)(H.original,H.originalLowercase,X,B,B.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,N.$yk)(Y)]:a}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,H,X,x){const Y=x.values?x.values:[x];return(0,L.$bj)({[x.normalized]:{values:Y.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:H,allowNonContiguousMatches:X}})}function d(B,H,X,x,Y){if(!B||!H.normalized)return i;const Z=x.getItemLabel(B);if(!Z)return i;const ce=x.getItemDescription(B),ie=f(Z,ce,X,H),pe=Y[ie];if(pe)return pe;const Ce=l(Z,ce,x.getItemPath(B),H,X);return Y[ie]=Ce,Ce}function l(B,H,X,x,Y){const Z=!X||!x.containsPathSeparator;return X&&(M.$k?x.pathNormalized===X:(0,b.$qf)(x.pathNormalized,X))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:x.values&&x.values.length>1?c(B,H,X,x.values,Z,Y):h(B,H,X,x,Z,Y)}function c(B,H,X,x,Y,Z){let ce=0;const ie=[],pe=[];for(const Ce of x){const{score:_,labelMatch:U,descriptionMatch:ne}=h(B,H,X,Ce,Y,Z);if(_===p)return i;ce+=_,U&&ie.push(...U),ne&&pe.push(...ne)}return{score:ce,labelMatch:D(ie),descriptionMatch:D(pe)}}function h(B,H,X,x,Y,Z){if(Y||!H){const[ce,ie]=A(B,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ce){const pe=(0,N.$pk)(x.normalized,B);let Ce;if(pe){Ce=s;const _=Math.round(x.normalized.length/B.length*100);Ce+=_}else Ce=t;return{score:Ce+ce,labelMatch:pe||g(ie)}}}if(H){let ce=H;X&&(ce=`${H}${R.sep}`);const ie=ce.length,pe=`${ce}${B}`,[Ce,_]=A(pe,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(Ce){const U=g(_),ne=[],be=[];return U.forEach(De=>{De.start<ie&&De.end>ie?(ne.push({start:0,end:De.end-ie}),be.push({start:De.start,end:ie})):De.start>=ie?ne.push({start:De.start-ie,end:De.end-ie}):be.push(De)}),{score:Ce,labelMatch:ne,descriptionMatch:be}}}return i}function g(B){const H=[];if(!B)return H;let X;for(const x of B)X&&X.end===x?X.end+=1:(X={start:x,end:x+1},H.push(X));return H}function D(B){const H=B.sort((Y,Z)=>Y.start-Z.start),X=[];let x;for(const Y of H)!x||!w(x,Y)?(x=Y,X.push(Y)):(x.start=Math.min(x.start,Y.start),x.end=Math.max(x.end,Y.end));return X}function w(B,H){return!(B.end<H.start||H.end<B.start)}function k(B,H,X,x,Y,Z){const ce=d(B,X,x,Y,Z),ie=d(H,X,x,Y,Z),pe=ce.score,Ce=ie.score;if((pe===r||Ce===r)&&pe!==Ce)return pe===r?-1:1;if(pe>t||Ce>t){if(pe!==Ce)return pe>Ce?-1:1;if(pe<s&&Ce<s){const ae=C(ce.labelMatch,ie.labelMatch);if(ae!==0)return ae}const De=Y.getItemLabel(B)||"",oe=Y.getItemLabel(H)||"";if(De.length!==oe.length)return De.length-oe.length}if(pe!==Ce)return pe>Ce?-1:1;const _=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const ne=y(B,ce,Y),be=y(H,ie,Y);return ne&&be&&ne!==be?be>ne?-1:1:I(B,H,X,Y)}function y(B,H,X){let x=-1,Y=-1;if(H.descriptionMatch&&H.descriptionMatch.length?x=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(x=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(Y=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const Z=X.getItemDescription(B);Z&&(Y+=Z.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(Y=H.descriptionMatch[H.descriptionMatch.length-1].end);return Y-x}function C(B,H){if(!B&&!H||(!B||!B.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,Y=B[B.length-1].end-X,Z=H[0].start,ie=H[H.length-1].end-Z;return Y===ie?0:ie<Y?1:-1}function I(B,H,X,x){const Y=x.getItemLabel(B)||"",Z=x.getItemLabel(H)||"",ce=x.getItemDescription(B),ie=x.getItemDescription(H),pe=Y.length+(ce?ce.length:0),Ce=Z.length+(ie?ie.length:0);if(pe!==Ce)return pe-Ce;const _=x.getItemPath(B),U=x.getItemPath(H);return _&&U&&_.length!==U.length?_.length-U.length:Y!==Z?(0,u.$gr)(Y,Z,X.normalized):ce&&ie&&ce!==ie?(0,u.$gr)(ce,ie,X.normalized):_&&U&&_!==U?(0,u.$gr)(_,U,X.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function F(B){typeof B!="string"&&(B="");const H=B.toLowerCase(),{pathNormalized:X,normalized:x,normalizedLowercase:Y}=O(B),Z=X.indexOf(R.sep)>=0,ce=z(B);let ie;const pe=B.split(j);if(pe.length>1)for(const Ce of pe){const _=z(Ce),{pathNormalized:U,normalized:ne,normalizedLowercase:be}=O(Ce);ne&&(ie||(ie=[]),ie.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:be,expectContiguousMatch:_}))}return{original:B,originalLowercase:H,pathNormalized:X,normalized:x,normalizedLowercase:Y,values:ie,containsPathSeparator:Z,expectContiguousMatch:ce}}function O(B){let H;M.$i?H=B.replace(/\//g,R.sep):H=B.replace(/\\/g,R.sep);const X=(0,b.$af)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:X,normalizedLowercase:X.toLowerCase()}}function T(B){return Array.isArray(B)?F(B.map(H=>H.original).join(j)):F(B.original)}}),define(ke[101],Ee([1,0,17]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Fs=R,e.$Gs=M,e.$Hs=b,e.$Is=S,e.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const P=(0,u.$pc)(A),$=N[P.toLowerCase()];return $!==void 0?$:M(A)}function M(A){const P=(0,u.$pc)(A);return L[P.toLowerCase()]}function b(A){for(const P in L)if(L[P]===A)return P}const p=/^(.+)\/(.+?)(;.+)?$/;function S(A,P){const $=p.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:P?void 0:A}}),define(ke[102],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$dm=R,e.$em=M;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(b,...p){const S=p.reduce(($,E)=>($[E]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!S[$]).forEach($=>{for(let E=0;E<A.length;E++)if($.search(A[E])!==-1){delete b[$];break}})}function M(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(l,c){return!l&&!c?"file":l}function S(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==P&&(c=P+c):c=P;break}return c}const A="",P="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(c){return c instanceof E?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,g,D,w,k=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=p(c,k),this.authority=h||A,this.path=S(this.scheme,g||A),this.query=D||A,this.fragment=w||A,b(this,k))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:g,path:D,query:w,fragment:k}=c;return h===void 0?h=this.scheme:h===null&&(h=A),g===void 0?g=this.authority:g===null&&(g=A),D===void 0?D=this.path:D===null&&(D=A),w===void 0?w=this.query:w===null&&(w=A),k===void 0?k=this.fragment:k===null&&(k=A),h===this.scheme&&g===this.authority&&D===this.path&&w===this.query&&k===this.fragment?this:new m(h,g,D,w,k)}static parse(c,h=!1){const g=$.exec(c);return g?new m(g[2]||A,d(g[4]||A),d(g[5]||A),d(g[7]||A),d(g[9]||A),h):new m(A,A,A,A,A)}static file(c){let h=A;if(N.$i&&(c=c.replace(/\\/g,P)),c[0]===P&&c[1]===P){const g=c.indexOf(P,2);g===-1?(h=c.substring(2),c=P):(h=c.substring(2,g),c=c.substring(g)||P)}return new m("file",h,c,A,A)}static from(c,h){return new m(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return N.$i&&c.scheme==="file"?g=E.file(u.$gc.join(r(c,!0),...h)).path:g=u.$hc.join(c.path,...h),c.with({path:g})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof E)return c;{const h=new m(c);return h._formatted=c.external??null,h._fsPath=c._sep===a?c.fsPath??null:null,h}}else return c}}e.URI=E;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const a=N.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,c,h){let g,D=-1;for(let w=0;w<l.length;w++){const k=l.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||c&&k===47||h&&k===91||h&&k===93||h&&k===58)D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g!==void 0&&(g+=l.charAt(w));else{g===void 0&&(g=l.substr(0,w));const y=o[k];y!==void 0?(D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g+=y):D===-1&&(D=w)}}return D!==-1&&(g+=encodeURIComponent(l.substring(D))),g!==void 0?g:l}function i(l){let c;for(let h=0;h<l.length;h++){const g=l.charCodeAt(h);g===35||g===63?(c===void 0&&(c=l.substr(0,h)),c+=o[g]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function r(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,N.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,c){const h=c?i:n;let g="",{scheme:D,authority:w,path:k,query:y,fragment:C}=l;if(D&&(g+=D,g+=":"),(w||D==="file")&&(g+=P,g+=P),w){let I=w.indexOf("@");if(I!==-1){const z=w.substr(0,I);w=w.substr(I+1),I=z.lastIndexOf(":"),I===-1?g+=h(z,!1,!1):(g+=h(z.substr(0,I),!1,!1),g+=":",g+=h(z.substr(I+1),!1,!0)),g+="@"}w=w.toLowerCase(),I=w.lastIndexOf(":"),I===-1?g+=h(w,!1,!0):(g+=h(w.substr(0,I),!1,!0),g+=w.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}g+=h(k,!0,!1)}return y&&(g+="?",g+=h(y,!1,!1)),C&&(g+="#",g+=c?C:n(C,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,c=>t(c)):l}}),define(ke[192],Ee([1,0,2]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=N,e.$Lq=L,e.$Mq=R,e.log=b;function N(S){const A=S;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(S){const A=[];let P;try{const $=JSON.parse(S.arguments),E=$[$.length-1];E&&E.__$stack&&($.pop(),P=E.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",S.arguments)}return{args:A,stack:P}}function R(S){if(typeof S!="string")return R(L(S).stack);const A=S;if(A){const P=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if($&&$.length===4)return{uri:u.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function M(S){if(!S)return S;const A=S.indexOf(`
`);return A===-1?S:S.substring(0,A)}function b(S,A){const{args:P,stack:$}=L(S),E=typeof P[0]=="string"&&P.length===1;let v=M($);v&&(v=`(${v.trim()})`);let a=[];if(typeof P[0]=="string"?v&&E?a=[`%c[${A}] %c${P[0]} %c${v}`,p("blue"),p(""),p("grey")]:a=[`%c[${A}] %c${P[0]}`,p("blue"),p(""),...P.slice(1)]:a=[`%c[${A}]%`,p("blue"),...P],v&&!E&&a.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,a)}function p(S){return`color: ${S}`}}),define(ke[58],Ee([1,0,21,2]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=L,e.$Vh=R,e.$Wh=b;function L(p){return JSON.stringify(p,M)}function R(p){let S=JSON.parse(p);return S=b(S),S}function M(p,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function b(p,S=0){if(!p||S>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return N.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof u.$ze||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let A=0;A<p.length;++A)p[A]=b(p[A],S+1);else for(const A in p)Object.hasOwnProperty.call(p,A)&&(p[A]=b(p[A],S+1))}return p}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=p,e.$xg=S,e.$Bg=P;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function p(v,a){return R.URI.isUri(v)?(0,L.$qf)(v.scheme,a):(0,L.$rf)(v,a+":")}function S(v,...a){return a.some(m=>p(v,m))}e.$yg="vscode-tkn",e.$zg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=P(a,m)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(a,m,o){this.a[a]=m,this.b[a]=o}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return u.$1(s),a}const m=a.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(r+=`&${e.$zg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$Ag=new A;function P(v,a){return M.$hc.join(a??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class ${static{this.a=e.$Gg}asBrowserUri(a){const m=this.b(a,he);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===b.vscodeRemote?e.$Ag.rewrite(a):a.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${$.a}`)?a.with({scheme:b.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,he);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===b.vscodeFileResource?a.with({scheme:b.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Hg=new $;var E;(function(v){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:R.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}v.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}v.addSearchParam=n})(E||(e.COI=E={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=A;class M{constructor($,E,v){this.id=$,this.dependencies=E,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,E,v)=>{typeof $!="string"&&(v=E,E=$,$=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new M($,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const E=await(this.a?this.i($):this.b?this.h($):this.j($));if(!E)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h($){return new Promise((E,v)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",o),a.removeEventListener("error",n)},o=i=>{m(),E(this.c.pop())},n=i=>{m(),v(i)};a.addEventListener("load",o),a.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),a.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(a)})}i($){return new Promise((E,v)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),E(this.c.pop())}catch(a){v(a)}})}async j($){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=R.URI.parse($).fsPath,o=E.readFileSync(m).toString(),n=a.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const p=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function A(P,$,E){if(u.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[P]&&(P=S[P]);const v=`${P}/${$}`;if(p.has(v))return p.get(v);let a;if(/^\w[\w\d+.-]*:\/\//.test(v))a=v;else{const i=`${E&&!L.$o?N.$Eg:N.$Dg}/${v}`;a=N.$Hg.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(a);return p.set(v,m),m}else return await new Promise((v,a)=>{he([P],v,a)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=p,e.$0g=A,e.$$g=$;function p(E){return(0,b.$xc)(E,!0)}class S{constructor(v){this.a=v}compare(v,a,m=!1){return v===a?0:(0,M.$jf)(this.getComparisonKey(v,m),this.getComparisonKey(a,m))}isEqual(v,a,m=!1){return v===a?!0:!v||!a?!1:this.getComparisonKey(v,m)===this.getComparisonKey(a,m)}getComparisonKey(v,a=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,a,m=!1){if(v.scheme===a.scheme){if(v.scheme===N.Schemas.file)return u.$ng(p(v),p(a),this.a(v))&&v.query===a.query&&(m||v.fragment===a.fragment);if((0,e.$6g)(v.authority,a.authority))return u.$ng(v.path,a.path,this.a(v),"/")&&v.query===a.query&&(m||v.fragment===a.fragment)}return!1}joinPath(v,...a){return b.URI.joinPath(v,...a)}basenameOrAuthority(v){return(0,e.$Xg)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let a;return v.scheme===N.Schemas.file?a=b.URI.file(L.$nc(p(v))).path:(a=L.$hc.dirname(v.path),v.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),a="/")),v.with({path:a})}normalizePath(v){if(!v.path.length)return v;let a;return v.scheme===N.Schemas.file?a=b.URI.file(L.$ic(p(v))).path:a=L.$hc.normalize(v.path),v.with({path:a})}relativePath(v,a){if(v.scheme!==a.scheme||!(0,e.$6g)(v.authority,a.authority))return;if(v.scheme===N.Schemas.file){const n=L.$mc(p(v),p(a));return R.$i?u.$hg(n):n}let m=v.path||"/";const o=a.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return L.$hc.relative(m,o)}resolvePath(v,a){if(v.scheme===N.Schemas.file){const m=b.URI.file(L.$lc(p(v),a));return v.with({authority:m.authority,path:m.path})}return a=u.$ig(a),v.with({path:L.$hc.resolve(v.path,a)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,a){return v===a||v!==void 0&&a!==void 0&&(0,M.$qf)(v,a)}hasTrailingPathSeparator(v,a=L.sep){if(v.scheme===N.Schemas.file){const m=p(v);return m.length>u.$jg(m).length&&m[m.length-1]===a}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,a=L.sep){return(0,e.$7g)(v,a)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,a=L.sep){let m=!1;if(v.scheme===N.Schemas.file){const o=p(v);m=o!==void 0&&o.length===u.$jg(o).length&&o[o.length-1]===a}else{a="/";const o=v.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$7g)(v,a)?v.with({path:v.path+"/"}):v}}e.$Pg=S,e.$Qg=new S(()=>!1),e.$Rg=new S(E=>E.scheme===N.Schemas.file?!R.$k:!0),e.$Sg=new S(E=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function A(E,v){const a=[];for(let m=0;m<E.length;m++){const o=v(E[m]);E.some((n,i)=>i===m?!1:(0,e.$Ug)(o,v(n)))||a.push(E[m])}return a}var P;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&m.set(E.META_DATA_MIME,n),m}E.parseMetaData=v})(P||(e.DataUri=P={}));function $(E,v,a){if(v){let m=E.path;return m&&m[0]!==L.$hc.sep&&(m=L.$hc.sep+m),E.with({scheme:a,authority:v,path:m})}return E.with({scheme:a})}}),define(ke[7],Ee([1,0,22,13,4,3,23,11,169,46]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=A,e.$ah=P,e.$bh=$,e.$ch=E,e.$dh=v,e.$eh=a,e.$fh=m,e.$gh=o,e.$oh=h,e.$ph=g,e.$qh=D,e.$rh=w,e.$sh=k,e.$Hh=Y,e.$Ph=oe;function A(re){return!!re&&typeof re.then=="function"}function P(re){const K=new u.$je,te=re(K.token),le=new Promise((de,Ae)=>{const me=K.token.onCancellationRequested(()=>{me.dispose(),Ae(new N.$5)});Promise.resolve(te).then(Pe=>{me.dispose(),K.dispose(),de(Pe)},Pe=>{me.dispose(),K.dispose(),Ae(Pe)})});return new class{cancel(){K.cancel(),K.dispose()}then(de,Ae){return le.then(de,Ae)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function $(re,K,te){return new Promise((le,de)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),le(te)});re.then(le,de).finally(()=>Ae.dispose())})}function E(re,K){return new Promise((te,le)=>{const de=K.onCancellationRequested(()=>{de.dispose(),le(new N.$5)});re.then(te,le).finally(()=>de.dispose())})}async function v(re){let K=-1;const te=re.map((le,de)=>le.then(Ae=>(K=de,Ae)));try{return await Promise.race(te)}finally{re.forEach((le,de)=>{de!==K&&le.cancel()})}}function a(re,K,te){let le;const de=setTimeout(()=>{le?.(void 0),te?.()},K);return Promise.race([re.finally(()=>clearTimeout(de)),new Promise(Ae=>le=Ae)])}function m(re){return new Promise((K,te)=>{const le=re();A(le)?le.then(K,te):K(le)})}function o(){let re,K;return{promise:new Promise((le,de)=>{re=le,K=de}),resolve:re,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const te=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(te,te).then(le)})}return new Promise((te,le)=>{this.b.then(te,le)})}return this.a=K(),new Promise((te,le)=>{this.a.then(de=>{this.a=null,te(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$hh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$ih=i;class r{constructor(){this.a=new Map}queue(K,te){const de=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(K)===de&&this.a.delete(K)});return this.a.set(K,de),de}}e.$jh=r;const s=(re,K)=>{let te=!0;const le=setTimeout(()=>{te=!1,K()},re);return{isTriggered:()=>te,dispose:()=>{clearTimeout(le),te=!1}}},t=re=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,re())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class f{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,te=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((de,Ae)=>{this.d=de,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=te===p.$9d?t(le):s(te,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=f;class d{constructor(K){this.a=new f(K),this.b=new n}trigger(K,te){return this.a.trigger(()=>this.b.queue(K),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=d;class l{constructor(){this.a=!1,this.b=new Promise((K,te)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=l;class c extends l{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$nh=c;function h(re,K){return K?new Promise((te,le)=>{const de=setTimeout(()=>{Ae.dispose(),te()},re),Ae=K.onCancellationRequested(()=>{clearTimeout(de),Ae.dispose(),le(new N.$5)})}):P(te=>h(re,te))}function g(re,K=0,te){const le=setTimeout(()=>{re(),te&&de.dispose()},K),de=(0,R.$Sc)(()=>{clearTimeout(le),te?.deleteAndLeak(de)});return te?.add(de),de}function D(re){const K=[];let te=0;const le=re.length;function de(){return te<le?re[te++]():null}function Ae(me){me!=null&&K.push(me);const Pe=de();return Pe?Pe.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function w(re,K=le=>!!le,te=null){let le=0;const de=re.length,Ae=()=>{if(le>=de)return Promise.resolve(te);const me=re[le++];return Promise.resolve(me()).then(Re=>K(Re)?Promise.resolve(Re):Ae())};return Ae()}function k(re,K=le=>!!le,te=null){if(re.length===0)return Promise.resolve(te);let le=re.length;const de=()=>{le=-1;for(const Ae of re)Ae.cancel?.()};return new Promise((Ae,me)=>{for(const Pe of re)Pe.then(Re=>{--le>=0&&K(Re)?(de(),Ae(Re)):le===0&&Ae(te)}).catch(Re=>{--le>=0&&(de(),me(Re))})})}class y{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new L.$_d}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,le)=>{this.g.push({factory:K,c:te,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const te=K.factory();te.then(K.c,K.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=y;class C extends y{constructor(){super(1)}}e.$uh=C;class I{constructor(){this.a=new Z,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$vh=I;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new pe;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,te=M.$Qg){const le=te.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,te,le=M.$Qg){const de=le.getComparisonKey(K);let Ae=this.a.get(de);if(!Ae){Ae=new C;const me=this.f++,Pe=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(me,Pe),this.a.set(de,Ae)}return Ae.queue(te)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=z;class j{constructor(K,te){this.a=-1,typeof K=="function"&&typeof te=="number"&&this.setIfNotSet(K,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},te)}setIfNotSet(K,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},te))}}e.$xh=j;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,te,le=globalThis){this.cancel();const de=le.setInterval(()=>{K()},te);this.d=(0,R.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$yh=F;class O{constructor(K,te){this.b=-1,this.a=K,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=O;class T{constructor(K,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=K,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=T;class B extends O{constructor(K,te){super(K,te),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Bh=B;class H extends R.$Uc{constructor(K,te){super(),this.g=K,this.h=te,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of K)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(re,K)=>{(0,b.$B)(()=>{if(te)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Eh=(re,K,te)=>{const le=re.requestIdleCallback(K,typeof te=="number"?{timeout:te}:void 0);let de=!1;return{dispose(){de||(de=!0,re.cancelIdleCallback(le))}}},e.$Dh=re=>(0,e.$Eh)(globalThis,re)}();class X{constructor(K,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Eh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=X;class x extends X{constructor(K){super(globalThis,K)}}e.$Gh=x;async function Y(re,K,te){let le;for(let de=0;de<te;de++)try{return await re()}catch(Ae){le=Ae,await h(K)}throw le}class Z{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,te,le){return this.a={taskId:K,cancel:()=>le?.(),promise:te},te.then(()=>this.d(K),()=>this.d(K)),te}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:te,resolve:le,reject:de}=o();this.b={run:K,promise:te,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=Z;class ce{constructor(K,te=()=>Date.now()){this.d=K,this.f=te,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Jh=ce;var ie;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})(ie||(ie={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,te)=>{this.a=K,this.b=te})}complete(K){return new Promise(te=>{this.a(K),this.d={outcome:0,value:K},te()})}error(K){return new Promise(te=>{this.b(K),this.d={outcome:1,value:K},te()})}cancel(){return this.error(new N.$5)}}e.$Kh=pe;var Ce;(function(re){async function K(le){let de;const Ae=await Promise.all(le.map(me=>me.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return Ae}re.settled=K;function te(le){return new Promise(async(de,Ae)=>{try{await le(de,Ae)}catch(me){Ae(me)}})}re.withAsyncBody=te})(Ce||(e.Promises=Ce={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=_;class U{constructor(K){this.b=K,this.a=new S.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=U;var ne;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ne||(ne={}));class be{static fromArray(K){return new be(te=>{te.emitMany(K)})}static fromPromise(K){return new be(async te=>{te.emitMany(await K)})}static fromPromises(K){return new be(async te=>{await Promise.all(K.map(async le=>te.emitOne(await le)))})}static merge(K){return new be(async te=>{await Promise.all(K.map(async le=>{for await(const de of le)te.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new L.$_d,queueMicrotask(async()=>{const te={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(te)),this.j()}catch(le){this.k(le)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(K,te){return new be(async le=>{for await(const de of K)le.emitOne(te(de))})}map(K){return be.map(this,K)}static filter(K,te){return new be(async le=>{for await(const de of K)te(de)&&le.emitOne(de)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,te=>!!te)}coalesce(){return be.coalesce(this)}static async toPromise(K){const te=[];for await(const le of K)te.push(le);return te}toPromise(){return be.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Nh=be;class De extends be{constructor(K,te){super(te),this.l=K}cancel(){this.l.cancel()}}e.$Oh=De;function oe(re){const K=new u.$je,te=re(K.token);return new De(K,async le=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),K.dispose(),le.reject(new N.$5)});try{for await(const Ae of te){if(K.token.isCancellationRequested)return;le.emitOne(Ae)}de.dispose(),K.dispose()}catch(Ae){de.dispose(),K.dispose(),le.reject(Ae)}})}class ae{constructor(){this.a=new pe,this.b=new be(le=>{if(K){le.reject(K);return}return te&&le.emitMany(te),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let K,te;this.f=le=>{te||(te=[]),te.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Qh=ae}),define(ke[35],Ee([1,0,19,7,34,27,17,11,14]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=S,e.$fk=v,e.$gk=C,e.$hk=I,e.$ik=z,e.$jk=j,e.$kk=F,e.$lk=H;function S(){return Object.create(null)}e.$dk="**",e.$ek="/";const A="[/\\\\]",P="[^/\\\\]",$=/\//g;function E(X,x){switch(X){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${x?`|${A}${P}+`:""})*?`}}function v(X,x){if(!X)return[];const Y=[];let Z=!1,ce=!1,ie="";for(const pe of X){switch(pe){case x:if(!Z&&!ce){Y.push(ie),ie="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=pe}return ie&&Y.push(ie),Y}function a(X){if(!X)return"";let x="";const Y=v(X,e.$ek);if(Y.every(Z=>Z===e.$dk))x=".*";else{let Z=!1;Y.forEach((ce,ie)=>{if(ce===e.$dk){if(Z)return;x+=E(2,ie===Y.length-1)}else{let pe=!1,Ce="",_=!1,U="";for(const ne of ce){if(ne!=="}"&&pe){Ce+=ne;continue}if(_&&(ne!=="]"||!U)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!U?be="^":ne===e.$ek?be="":be=(0,p.$5e)(ne),U+=be;continue}switch(ne){case"{":pe=!0;continue;case"[":_=!0;continue;case"}":{const De=`(?:${v(Ce,",").map(oe=>a(oe)).join("|")})`;x+=De,pe=!1,Ce="";break}case"]":{x+="["+U+"]",_=!1,U="";break}case"?":x+=P;continue;case"*":x+=E(1);continue;default:x+=(0,p.$5e)(ne)}}ie<Y.length-1&&(Y[ie+1]!==e.$dk||ie+2<Y.length)&&(x+=A)}Z=ce===e.$dk})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(X,x){if(!X)return d;let Y;typeof X!="string"?Y=X.pattern:Y=X,Y=Y.trim();const Z=`${Y}_${!!x.trimForExclusions}`;let ce=t.get(Z);if(ce)return c(ce,X);let ie;return m.test(Y)?ce=g(Y.substr(4),Y):(ie=o.exec(h(Y,x)))?ce=D(ie[1],Y):(x.trimForExclusions?i:n).test(Y)?ce=w(Y,x):(ie=r.exec(h(Y,x)))?ce=k(ie[1].substr(1),Y,!0):(ie=s.exec(h(Y,x)))?ce=k(ie[1],Y,!1):ce=y(Y),t.set(Z,ce),c(ce,X)}function c(X,x){if(typeof x=="string")return X;const Y=function(Z,ce){return(0,L.$ng)(Z,x.base,!b.$k)?X((0,p.$0e)(Z.substr(x.base.length),M.sep),ce):null};return Y.allBasenames=X.allBasenames,Y.allPaths=X.allPaths,Y.basenames=X.basenames,Y.patterns=X.patterns,Y}function h(X,x){return x.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function g(X,x){return function(Y,Z){return typeof Y=="string"&&Y.endsWith(X)?x:null}}function D(X,x){const Y=`/${X}`,Z=`\\${X}`,ce=function(pe,Ce){return typeof pe!="string"?null:Ce?Ce===X?x:null:pe===X||pe.endsWith(Y)||pe.endsWith(Z)?x:null},ie=[X];return ce.basenames=ie,ce.patterns=[x],ce.allBasenames=ie,ce}function w(X,x){const Y=B(X.slice(1,-1).split(",").map(Ce=>l(Ce,x)).filter(Ce=>Ce!==d),X),Z=Y.length;if(!Z)return d;if(Z===1)return Y[0];const ce=function(Ce,_){for(let U=0,ne=Y.length;U<ne;U++)if(Y[U](Ce,_))return X;return null},ie=Y.find(Ce=>!!Ce.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const pe=Y.reduce((Ce,_)=>_.allPaths?Ce.concat(_.allPaths):Ce,[]);return pe.length&&(ce.allPaths=pe),ce}function k(X,x,Y){const Z=M.sep===M.$hc.sep,ce=Z?X:X.replace($,M.sep),ie=M.sep+ce,pe=M.$hc.sep+X;let Ce;return Y?Ce=function(_,U){return typeof _=="string"&&(_===ce||_.endsWith(ie)||!Z&&(_===X||_.endsWith(pe)))?x:null}:Ce=function(_,U){return typeof _=="string"&&(_===ce||!Z&&_===X)?x:null},Ce.allPaths=[(Y?"*/":"./")+X],Ce}function y(X){try{const x=new RegExp(`^${a(X)}$`);return function(Y){return x.lastIndex=0,typeof Y=="string"&&x.test(Y)?X:null}}catch{return d}}function C(X,x,Y){return!X||typeof x!="string"?!1:I(X)(x,void 0,Y)}function I(X,x={}){if(!X)return f;if(typeof X=="string"||z(X)){const Y=l(X,x);if(Y===d)return f;const Z=function(ce,ie){return!!Y(ce,ie)};return Y.allBasenames&&(Z.allBasenames=Y.allBasenames),Y.allPaths&&(Z.allPaths=Y.allPaths),Z}return O(X,x)}function z(X){const x=X;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function j(X){return X.allBasenames||[]}function F(X){return X.allPaths||[]}function O(X,x){const Y=B(Object.getOwnPropertyNames(X).map(Ce=>T(Ce,X[Ce],x)).filter(Ce=>Ce!==d)),Z=Y.length;if(!Z)return d;if(!Y.some(Ce=>!!Ce.requiresSiblings)){if(Z===1)return Y[0];const Ce=function(ne,be){let De;for(let oe=0,ae=Y.length;oe<ae;oe++){const re=Y[oe](ne,be);if(typeof re=="string")return re;(0,N.$_g)(re)&&(De||(De=[]),De.push(re))}return De?(async()=>{for(const oe of De){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},_=Y.find(ne=>!!ne.allBasenames);_&&(Ce.allBasenames=_.allBasenames);const U=Y.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return U.length&&(Ce.allPaths=U),Ce}const ce=function(Ce,_,U){let ne,be;for(let De=0,oe=Y.length;De<oe;De++){const ae=Y[De];ae.requiresSiblings&&U&&(_||(_=(0,M.$oc)(Ce)),ne||(ne=_.substr(0,_.length-(0,M.$pc)(Ce).length)));const re=ae(Ce,_,ne,U);if(typeof re=="string")return re;(0,N.$_g)(re)&&(be||(be=[]),be.push(re))}return be?(async()=>{for(const De of be){const oe=await De;if(typeof oe=="string")return oe}return null})():null},ie=Y.find(Ce=>!!Ce.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const pe=Y.reduce((Ce,_)=>_.allPaths?Ce.concat(_.allPaths):Ce,[]);return pe.length&&(ce.allPaths=pe),ce}function T(X,x,Y){if(x===!1)return d;const Z=l(X,Y);if(Z===d)return d;if(typeof x=="boolean")return Z;if(x){const ce=x.when;if(typeof ce=="string"){const ie=(pe,Ce,_,U)=>{if(!U||!Z(pe,Ce))return null;const ne=ce.replace("$(basename)",()=>_),be=U(ne);return(0,N.$_g)(be)?be.then(De=>De?X:null):be?X:null};return ie.requiresSiblings=!0,ie}}return Z}function B(X,x){const Y=X.filter(Ce=>!!Ce.basenames);if(Y.length<2)return X;const Z=Y.reduce((Ce,_)=>{const U=_.basenames;return U?Ce.concat(U):Ce},[]);let ce;if(x){ce=[];for(let Ce=0,_=Z.length;Ce<_;Ce++)ce.push(x)}else ce=Y.reduce((Ce,_)=>{const U=_.patterns;return U?Ce.concat(U):Ce},[]);const ie=function(Ce,_){if(typeof Ce!="string")return null;if(!_){let ne;for(ne=Ce.length;ne>0;ne--){const be=Ce.charCodeAt(ne-1);if(be===47||be===92)break}_=Ce.substr(ne)}const U=Z.indexOf(_);return U!==-1?ce[U]:null};ie.basenames=Z,ie.patterns=ce,ie.allBasenames=Z;const pe=X.filter(Ce=>!Ce.basenames);return pe.push(ie),pe}function H(X,x){return(0,u.$ub)(X,x,(Y,Z)=>typeof Y=="string"&&typeof Z=="string"?Y===Z:typeof Y!="string"&&typeof Z!="string"?Y.base===Z.base&&Y.pattern===Z.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.MarkdownStringTextNewlineStyle=void 0,e.$Lk=S,e.$Mk=A,e.$Nk=P,e.$Ok=$,e.$Pk=E,e.$Qk=v,e.$Rk=a,e.$Sk=m;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class p{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,N.$Ek)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${E(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,R.$5e)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Kk=p;function S(o){return A(o)?!o.value:Array.isArray(o)?o.every(S):!0}function A(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function P(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.$Tg)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function $(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function a(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),c=isFinite(parseInt(f));l&&n.push(`width="${d}"`),c&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=p,e.$mw=A,e.$nw=$,e.$ow=E,e.$pw=o,e.$qw=i,e.$rw=r,e.$sw=s,e.$tw=t,e.$uw=f;function p(l,c){const{os:h,tildify:g,relative:D}=c;if(D){const y=S(l,D,h);if(typeof y=="string")return y}let w=l.fsPath;if(h===1&&!R.$i?w=w.replace(/\//g,"\\"):h!==1&&R.$i&&(w=w.replace(/\\/g,"/")),h!==1&&g?.userHome){const y=g.userHome.fsPath;let C;l.scheme!==g.userHome.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep?C=g.userHome.with({path:l.path}).fsPath:C=w,w=$(C,y,h)}return(h===1?L.$gc:L.$hc).normalize(A(w,h===1))}function S(l,c,h){const g=h===1?L.$gc:L.$hc,D=h===3?M.$Qg:M.$Sg,w=c.getWorkspace(),k=(0,u.$Ob)(w.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep&&(l=k.uri.with({path:l.path}));const y=c.getWorkspaceFolder(l);if(!y)return;let C;if(D.isEqual(y.uri,l)?C="":C=D.relativePath(y.uri,l)??"",C&&(C=g.normalize(C)),w.folders.length>1&&!c.noPrefix){const I=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${I} \u2022 ${C}`:I}return C}function A(l,c=R.$i){return(0,N.$rg)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}let P=Object.create(null);function $(l,c,h=R.OS){if(h===1||!l||!c)return l;let g=P.original===c?P.normalized:void 0;g||(g=c,R.$i&&(g=(0,N.$hg)(g)),g=`${(0,b.$$e)(g,L.$hc.sep)}${L.$hc.sep}`,P={original:c,normalized:g});let D=l;return R.$i&&(D=(0,N.$hg)(D)),(h===3?D.startsWith(g):(0,b.$rf)(D,g))?`~/${D.substr(g.length)}`:l}function E(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}const v="\u2026",a="\\\\",m="~";function o(l,c=L.sep){const h=new Array(l.length);let g=!1;for(let D=0;D<l.length;D++){const w=l[D];if(w===""){h[D]=`.${c}`;continue}if(!w){h[D]=w;continue}g=!0;let k="",y=w;y.indexOf(a)===0?(k=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(c)===0?(k=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(m)===0&&(k=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const C=y.split(c);for(let I=1;g&&I<=C.length;I++)for(let z=C.length-I;g&&z>=0;z--){g=!1;let j=C.slice(z,z+I).join(c);for(let F=0;!g&&F<l.length;F++)if(F!==D&&l[F]&&l[F].indexOf(j)>-1){const O=z+I===C.length,T=z>0&&l[F].indexOf(c)>-1?c+j:j,B=l[F].endsWith(T);g=!O||B}if(!g){let F="";(C[0].endsWith(":")||k!=="")&&(z===1&&(z=0,I++,j=C[0]+c+j),z>0&&(F=C[0]+c),F=k+F),z>0&&(F=F+v+c),F=F+j,z+I<C.length&&(F=F+c+v),h[D]=F}}g&&(h[D]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,c=Object.create(null)){const h=[];let g=!1,D="";for(const w of l)if(w==="$"||g&&w==="{")D&&h.push({value:D,type:n.TEXT}),D="",g=!0;else if(w==="}"&&g){const k=c[D];if(typeof k=="string")k.length&&h.push({value:k,type:n.VARIABLE});else if(k){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:k.label,type:n.SEPARATOR})}D="",g=!1}else D+=w;return D&&!g&&h.push({value:D,type:n.TEXT}),h.filter((w,k)=>{if(w.type===n.SEPARATOR){const y=h[k-1],C=h[k+1];return[y,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c)),g=l.substring(c);return{name:h.name+g,parentPath:h.parentPath}}}return d(l)}function d(l){const c=l.indexOf("/")!==-1?L.$hc:L.$gc,h=c.basename(l),g=c.dirname(l);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=b,e.$sn=S,e.$tn=A;function L(P){return P.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const E=this.a.transformIncoming($);return E===$?$:L(N.URI.from(E))}transformOutgoing($){const E=this.a.transformOutgoing($);return E===$?$:L(N.URI.from(E))}transformOutgoingURI($){const E=this.a.transformOutgoing($);return E===$?$:N.URI.from(E)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$pn=R,e.$qn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function M(P,$,E){if(!P||E>200)return null;if(typeof P=="object"){if(P instanceof N.URI)return $.transformOutgoing(P);for(const v in P)if(Object.hasOwnProperty.call(P,v)){const a=M(P[v],$,E+1);a!==null&&(P[v]=a)}}return null}function b(P,$){const E=M(P,$,0);return E===null?P:E}function p(P,$,E,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return E?N.URI.revive($.transformIncoming(P)):$.transformIncoming(P);if(P instanceof u.$ze)return null;for(const a in P)if(Object.hasOwnProperty.call(P,a)){const m=p(P[a],$,E,v+1);m!==null&&(P[a]=m)}}return null}function S(P,$){const E=p(P,$,!1,0);return E===null?P:E}function A(P,$){const E=p(P,$,!0,0);return E===null?P:E}}),define(ke[31],Ee([1,0,52,64,396,7,34,76,17,11,23,2]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=D;var $;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function E(T,B=$.UNLINK,H){if((0,M.$qg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===$.UNLINK?a(T):v(T,H)}async function v(T,B=(0,M.$vg)((0,N.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(H){return H.code==="ENOENT"?void 0:a(T)}a(B).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function a(T){return(0,L.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,M.$qg)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function o(T,B){return r(await(B?n(T):(0,L.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],H=await o(T);for(const X of H){let x=!1,Y=!1,Z=!1;try{const ce=await e.Promises.lstat((0,p.$kc)(T,X));x=ce.isFile(),Y=ce.isDirectory(),Z=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}B.push({name:X,isFile:()=>x,isDirectory:()=>Y,isSymbolicLink:()=>Z})}return B}function i(T){return r(u.readdirSync(T))}function r(T){return T.map(B=>typeof B=="string"?S.$j?(0,b.$5l)(B):B:(B.name=S.$j?(0,b.$5l)(B.name):B.name,B))}async function s(T){const B=await o(T),H=[];for(const X of B)await f.existsDirectory((0,p.$kc)(T,X))&&H.push(X);return H}function t(T,B=1e3){return new Promise(H=>{let X=!1;const x=setInterval(()=>{X||(X=!0,u.access(T,Y=>{X=!1,Y&&(clearInterval(x),H(void 0))}))},B)})}var f;(function(T){async function B(x){let Y;try{if(Y=await e.Promises.lstat(x),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(S.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ce}throw Z}}T.stat=B;async function H(x){try{const{stat:Y,symbolicLink:Z}=await T.stat(x);return Y.isFile()&&Z?.dangling!==!0}catch{}return!1}T.existsFile=H;async function X(x){try{const{stat:Y,symbolicLink:Z}=await T.stat(x);return Y.isDirectory()&&Z?.dangling!==!0}catch{}return!1}T.existsDirectory=X})(f||(e.SymlinkSupport=f={}));const d=new R.$wh;function l(T,B,H){return d.queueFor(P.URI.file(T),()=>{const X=w(H);return new Promise((x,Y)=>g(T,B,X,Z=>Z?Y(Z):x()))},A.$Rg)}let c=!0;function h(T){c=T}function g(T,B,H,X){if(!c)return u.writeFile(T,B,{mode:H.mode,flag:H.flag},X);u.open(T,H.flag,H.mode,(x,Y)=>{if(x)return X(x);u.writeFile(Y,B,Z=>{if(Z)return u.close(Y,()=>X(Z));u.fdatasync(Y,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),u.close(Y,ie=>X(ie))))})})}function D(T,B,H){const X=w(H);if(!c)return u.writeFileSync(T,B,{mode:X.mode,flag:X.flag});const x=u.openSync(T,X.flag,X.mode);try{u.writeFileSync(x,B);try{u.fdatasyncSync(x)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{u.closeSync(x)}}function w(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,B,H=6e4){if(T!==B)try{S.$i&&typeof H=="number"?await y(T,B,Date.now(),H):await(0,L.promisify)(u.rename)(T,B)}catch(X){if(T.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||T.endsWith("."))await C(T,B,{preserveSymlinks:!1}),await E(T,$.MOVE);else throw X}}async function y(T,B,H,X,x=0){try{return await(0,L.promisify)(u.rename)(T,B)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-H>=X)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Y}`),Y;if(x===0){let Z=!1;try{const{stat:ce}=await f.stat(B);ce.isFile()||(Z=!0)}catch{}if(Z)throw Y}return await(0,R.$oh)(Math.min(100,x*10)),y(T,B,H,X,x+1)}}async function C(T,B,H){return z(T,B,{root:{source:T,target:B},options:H,handledSourcePaths:new Set})}const I=511;async function z(T,B,H){if(H.handledSourcePaths.has(T))return;H.handledSourcePaths.add(T);const{stat:X,symbolicLink:x}=await f.stat(T);if(x){if(H.options.preserveSymlinks)try{return await O(T,B,H)}catch{}if(x.dangling)return}return X.isDirectory()?j(T,B,X.mode&I,H):F(T,B,X.mode&I)}async function j(T,B,H,X){await e.Promises.mkdir(B,{recursive:!0,mode:H});const x=await o(T);for(const Y of x)await z((0,p.$kc)(T,Y),(0,p.$kc)(B,Y),X)}async function F(T,B,H){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,H)}async function O(T,B,H){let X=await e.Promises.readlink(T);(0,M.$ng)(X,H.root.source,!S.$k)&&(X=(0,p.$kc)(H.root.target,X.substr(H.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,L.promisify)(u.access)}get stat(){return(0,L.promisify)(u.stat)}get lstat(){return(0,L.promisify)(u.lstat)}get utimes(){return(0,L.promisify)(u.utimes)}get read(){return(T,B,H,X,x)=>new Promise((Y,Z)=>{u.read(T,B,H,X,x,(ce,ie,pe)=>ce?Z(ce):Y({bytesRead:ie,buffer:pe}))})}get readFile(){return(0,L.promisify)(u.readFile)}get write(){return(T,B,H,X,x)=>new Promise((Y,Z)=>{u.write(T,B,H,X,x,(ce,ie,pe)=>ce?Z(ce):Y({bytesWritten:ie,buffer:pe}))})}get appendFile(){return(0,L.promisify)(u.appendFile)}get fdatasync(){return(0,L.promisify)(u.fdatasync)}get truncate(){return(0,L.promisify)(u.truncate)}get copyFile(){return(0,L.promisify)(u.copyFile)}get open(){return(0,L.promisify)(u.open)}get close(){return(0,L.promisify)(u.close)}get symlink(){return(0,L.promisify)(u.symlink)}get readlink(){return(0,L.promisify)(u.readlink)}get chmod(){return(0,L.promisify)(u.chmod)}get mkdir(){return(0,L.promisify)(u.mkdir)}get unlink(){return(0,L.promisify)(u.unlink)}get rmdir(){return(0,L.promisify)(u.rmdir)}get realpath(){return(0,L.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return E}get rename(){return k}get copy(){return C}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=b,e.$Tq=p,e.$Uq=S,e.$Vq=A;function b($){if(L.$k)return $;const E=(0,N.$nc)($);if($===E)return $;const v=((0,N.$oc)($)||$).toLowerCase();try{const m=(0,M.readdirSync)(E).filter(o=>o.toLowerCase()===v);if(m.length===1){const o=b(E);if(o)return(0,N.$kc)(o,m[0])}else if(m.length>1){const o=m.indexOf(v);if(o>=0){const n=b(E);if(n)return(0,N.$kc)(n,m[o])}}}catch{}return null}async function p($,E){if(L.$k)return $;const v=(0,N.$nc)($);if($===v)return $;const a=((0,N.$oc)($)||$).toLowerCase();try{if(E?.isCancellationRequested)return null;const o=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===a);if(o.length===1){const n=await p(v,E);if(n)return(0,N.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(a);if(n>=0){const i=await p(v,E);if(i)return(0,N.$kc)(i,o[n])}}}catch{}return null}async function S($){try{return await M.Promises.realpath($)}catch{const v=P($);return await M.Promises.access(v,u.constants.R_OK),v}}function A($){try{return u.realpathSync($)}catch{const v=P($);return u.accessSync(v,u.constants.R_OK),v}}function P($){return(0,R.$$e)((0,N.$ic)($),N.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$fm=p,e.$gm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(P=L.env){return P.comspec||"cmd.exe"}function S(P){let $=[],E=!1;const v=function(a){if(E){$.push(a);return}(!P.send(a,o=>{if(o&&console.error(o),E=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>v(i))}})||N.$i)&&(E=!0)};return{send:v}}var A;(function(P){async function $(E,v,a){if(u.$jc(E))return E;if(v===void 0&&(v=L.cwd()),u.$nc(E)!=="."||(a===void 0&&M.$1f(L.env.PATH)&&(a=L.env.PATH.split(u.$uc)),a===void 0||a.length===0))return u.$kc(v,E);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of a){let i;if(u.$jc(n)?i=u.$kc(n,E):i=u.$kc(v,n,E),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(v,E)}P.findExecutable=$})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(he,e,u,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(he,e,u,N);else for(var b=he.length-1;b>=0;b--)(M=he[b])&&(R=(L<3?M(R):L>3?M(e,u,R):M(e,u))||R);return L>3&&R&&Object.defineProperty(e,u,R),R};define(ke[81],Ee([1,0,19,7,21,22,55,13,4,3,58,14,18]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.ProxyChannel=e.$8h=e.$5h=e.$4h=e.$3h=e.RequestInitiator=e.$2h=e.$Yh=e.$Xh=void 0,e.$Zh=h,e.$1h=g,e.$6h=I,e.$7h=z;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E||(E={}));function v(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(a||(a={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(o||(o={}));function n(x){let Y=0;for(let Z=0;;Z+=7){const ce=x.read(1);if(Y|=(ce.buffer[0]&127)<<Z,!(ce.buffer[0]&128))return Y}}const i=d(0);function r(x,Y){if(Y===0){x.write(i);return}let Z=0;for(let ie=Y;ie!==0;ie=ie>>>7)Z++;const ce=L.$ze.alloc(Z);for(let ie=0;Y!==0;ie++)ce.buffer[ie]=Y&127,Y=Y>>>7,Y>0&&(ce.buffer[ie]|=128);x.write(ce)}class s{constructor(Y){this.b=Y,this.a=0}read(Y){const Z=this.b.slice(this.a,this.a+Y);return this.a+=Z.byteLength,Z}}e.$Xh=s;class t{constructor(){this.a=[]}get buffer(){return L.$ze.concat(this.a)}write(Y){this.a.push(Y)}}e.$Yh=t;var f;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(f||(f={}));function d(x){const Y=L.$ze.alloc(1);return Y.writeUInt8(x,0),Y}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},c=typeof Buffer<"u";function h(x,Y){if(typeof Y>"u")x.write(l.Undefined);else if(typeof Y=="string"){const Z=L.$ze.fromString(Y);x.write(l.String),r(x,Z.byteLength),x.write(Z)}else if(c&&Buffer.isBuffer(Y)){const Z=L.$ze.wrap(Y);x.write(l.Buffer),r(x,Z.byteLength),x.write(Z)}else if(Y instanceof L.$ze)x.write(l.VSBuffer),r(x,Y.byteLength),x.write(Y);else if(Array.isArray(Y)){x.write(l.Array),r(x,Y.length);for(const Z of Y)h(x,Z)}else if(typeof Y=="number"&&(Y|0)===Y)x.write(l.Uint),r(x,Y);else{const Z=L.$ze.fromString(JSON.stringify(Y));x.write(l.Object),r(x,Z.byteLength),x.write(Z)}}function g(x){switch(x.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return x.read(n(x)).toString();case f.Buffer:return x.read(n(x)).buffer;case f.VSBuffer:return x.read(n(x));case f.Array:{const Z=n(x),ce=[];for(let ie=0;ie<Z;ie++)ce.push(g(x));return ce}case f.Object:return JSON.parse(x.read(n(x)).toString());case f.Int:return n(x)}}class D{constructor(Y,Z,ce=null,ie=1e3){this.h=Y,this.j=Z,this.k=ce,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(Y,Z){this.b.set(Y,Z),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const Z=this.o([Y.type]);this.k?.logOutgoing(Z,0,1,m(Y.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(Z,Y.id,1,m(Y.type),Y.data);return}}}o(Y,Z=void 0){const ce=new t;return h(ce,Y),h(ce,Z),this.p(ce.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const Z=new s(Y),ce=g(Z),ie=g(Z),pe=ce[0];switch(pe){case 100:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(pe)}: ${ce[2]}.${ce[3]}`,ie),this.s({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 102:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(pe)}: ${ce[2]}.${ce[3]}`,ie),this.t({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 101:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(pe)}`),this.u({type:pe,id:ce[1]});case 103:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(pe)}`),this.u({type:pe,id:ce[1]})}}s(Y){const Z=this.b.get(Y.channelName);if(!Z){this.v(Y);return}const ce=new R.$je;let ie;try{ie=Z.call(this.j,Y.name,Y.arg,ce.token)}catch(_){ie=Promise.reject(_)}const pe=Y.id;ie.then(_=>{this.m({id:pe,data:_,type:201})},_=>{_ instanceof Error?this.m({id:pe,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:pe,data:_,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(Y.id)});const Ce=(0,S.$Sc)(()=>ce.cancel());this.d.set(Y.id,Ce)}t(Y){const Z=this.b.get(Y.channelName);if(!Z){this.v(Y);return}const ce=Y.id,pe=Z.listen(this.j,Y.name,Y.arg)(Ce=>this.m({id:ce,data:Ce,type:204}));this.d.set(Y.id,pe)}u(Y){const Z=this.d.get(Y.id);Z&&(Z.dispose(),this.d.delete(Y.id))}v(Y){let Z=this.g.get(Y.channelName);Z||(Z=[],this.g.set(Y.channelName,Z));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Y,timeoutTimer:ce})}w(Y){const Z=this.g.get(Y);if(Z){for(const ce of Z)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$2h=D;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class k{constructor(Y,Z=null){this.l=Y,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Z}getChannel(Y){const Z=this;return{call(ce,ie,pe){return Z.a?Promise.reject(new b.$5):Z.m(Y,ce,ie,pe)},listen(ce,ie){return Z.a?p.Event.None:Z.o(Y,ce,ie)}}}m(Y,Z,ce,ie=R.CancellationToken.None){const pe=this.g++,_={id:pe,type:100,channelName:Y,name:Z,arg:ce};if(ie.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((be,De)=>{if(ie.isCancellationRequested)return De(new b.$5);const oe=()=>{const te=le=>{switch(le.type){case 201:this.f.delete(pe),be(le.data);break;case 202:{this.f.delete(pe);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,De(de);break}case 203:this.f.delete(pe),De(le.data);break}};this.f.set(pe,te),this.p(_)};let ae=null;this.b===o.Idle?oe():(ae=(0,N.$ah)(te=>this.u()),ae.then(()=>{ae=null,oe()}));const re=()=>{ae?(ae.cancel(),ae=null):this.p({id:pe,type:101}),De(new b.$5)},K=ie.onCancellationRequested(re);U=(0,S.$Rc)((0,S.$Sc)(re),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,Z,ce){const ie=this.g++,Ce={id:ie,type:102,channelName:Y,name:Z,arg:ce};let _=null;const U=new p.$_d({onWillAddFirstListener:()=>{_=(0,N.$ah)(be=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(Ce)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:ie,type:103}))}}),ne=be=>U.fire(be.data);return this.f.set(ie,ne),U.event}p(Y){switch(Y.type){case 100:case 102:{const Z=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(Z,Y.id,0,`${v(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const Z=this.q([Y.type,Y.id]);this.j?.logOutgoing(Z,Y.id,0,v(Y.type));return}}}q(Y,Z=void 0){const ce=new t;return h(ce,Y),h(ce,Z),this.r(ce.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const Z=new s(Y),ce=g(Z),ie=g(Z),pe=ce[0];switch(pe){case 200:return this.j?.logIncoming(Y.byteLength,0,0,m(pe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ce[1],0,m(pe),ie),this.t({type:ce[0],id:ce[1],data:ie})}}t(Y){if(Y.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$3h=k,Je([M.$Rh],k.prototype,"onDidInitializePromise",null);class y{get connections(){const Y=[];return this.f.forEach(Z=>Y.push(Z)),Y}constructor(Y,Z,ce){this.a=new Map,this.f=new Set,this.g=new p.$_d,this.onDidAddConnection=this.g.event,this.h=new p.$_d,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(Y(({protocol:ie,onDidClientDisconnect:pe})=>{const Ce=p.Event.once(ie.onMessage);this.j.add(Ce(_=>{const U=new s(_),ne=g(U),be=new D(ie,ne,Z,ce),De=new k(ie,Z);this.a.forEach((ae,re)=>be.registerChannel(re,ae));const oe={channelServer:be,channelClient:De,ctx:ne};this.f.add(oe),this.g.fire(oe),this.j.add(pe(()=>{be.dispose(),De.dispose(),this.f.delete(oe),this.h.fire(oe)}))}))}))}getChannel(Y,Z){const ce=this;return{call(ie,pe,Ce){let _;if((0,$.$cg)(Z)){const ne=(0,u.$4b)(ce.connections.filter(Z));_=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(ce.onDidAddConnection,Z))}else _=Z.routeCall(ce,ie,pe);const U=_.then(ne=>ne.channelClient.getChannel(Y));return I(U).call(ie,pe,Ce)},listen(ie,pe){if((0,$.$cg)(Z))return ce.k(Y,Z,ie,pe);const Ce=Z.routeEvent(ce,ie,pe).then(_=>_.channelClient.getChannel(Y));return I(Ce).listen(ie,pe)}}}k(Y,Z,ce,ie){const pe=this;let Ce;const _=new p.$_d({onWillAddFirstListener:()=>{Ce=new S.$Tc;const U=new p.$fe,ne=new Map,be=oe=>{const re=oe.channelClient.getChannel(Y).listen(ce,ie),K=U.add(re);ne.set(oe,K)},De=oe=>{const ae=ne.get(oe);ae&&(ae.dispose(),ne.delete(oe))};pe.connections.filter(Z).forEach(be),p.Event.filter(pe.onDidAddConnection,Z)(be,void 0,Ce),pe.onDidRemoveConnection(De,void 0,Ce),U.event(_.fire,_,Ce),Ce.add(U)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return _.event}registerChannel(Y,Z){this.a.set(Y,Z);for(const ce of this.f)ce.channelServer.registerChannel(Y,Z)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$4h=y;class C{constructor(Y,Z,ce=null){const ie=new t;h(ie,Z),Y.send(ie.buffer),this.a=new k(Y,ce),this.d=new D(Y,Z,ce)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,Z){this.d.registerChannel(Y,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5h=C;function I(x){return{call(Y,Z,ce){return x.then(ie=>ie.call(Y,Z,ce))},listen(Y,Z){const ce=new p.$ie;return x.then(ie=>ce.input=ie.listen(Y,Z)),ce.event}}}function z(x){let Y=!1;return{call(Z,ce,ie){return Y?x.call(Z,ce,ie):(0,N.$oh)(0).then(()=>Y=!0).then(()=>x.call(Z,ce,ie))},listen(Z,ce){if(Y)return x.listen(Z,ce);const ie=new p.$ie;return(0,N.$oh)(0).then(()=>Y=!0).then(()=>ie.input=x.listen(Z,ce)),ie.event}}}class j{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const Z of Y.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await p.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$8h=j;var F;(function(x){function Y(pe,Ce,_){const U=pe,ne=_&&_.disableMarshalling,be=new Map;for(const De in U)ce(De)&&be.set(De,p.Event.buffer(U[De],!0,void 0,Ce));return new class{listen(De,oe,ae){const re=be.get(oe);if(re)return re;const K=U[oe];if(typeof K=="function"){if(ie(oe))return K.call(U,ae);if(ce(oe))return be.set(oe,p.Event.buffer(U[oe],!0,void 0,Ce)),be.get(oe)}throw new b.$bb(`Event not found: ${oe}`)}call(De,oe,ae){const re=U[oe];if(typeof re=="function"){if(!ne&&Array.isArray(ae))for(let te=0;te<ae.length;te++)ae[te]=(0,A.$Wh)(ae[te]);let K=re.apply(U,ae);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${oe}`)}}}x.fromService=Y;function Z(pe,Ce){const _=Ce&&Ce.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return Ce?.properties?.has(ne)?Ce.properties.get(ne):ie(ne)?function(be){return pe.listen(ne,be)}:ce(ne)?pe.listen(ne):async function(...be){let De;Ce&&!(0,$.$0f)(Ce.context)?De=[Ce.context,...be]:De=be;const oe=await pe.call(ne,De);return _?oe:(0,A.$Wh)(oe)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}x.toService=Z;function ce(pe){return pe[0]==="o"&&pe[1]==="n"&&P.$pf(pe.charCodeAt(2))}function ie(pe){return/^onDynamic/.test(pe)&&P.$pf(pe.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Y=x.toString();if(Y!=="[object Object]")return Y}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function H(x,Y,Z,ce,ie,pe,Ce){Ce=B(Ce);const _=O[ie],U=_[ce%_.length];let ne=[`%c[${x}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(pe)?(ne=ne.concat(Ce),ne.push(")")):ne.push(Ce),console.log.apply(console,ne)}class X{constructor(Y,Z){this.d=Y,this.f=Z,this.a=0,this.b=0}logOutgoing(Y,Z,ce,ie,pe){this.b+=Y,H(this.d,this.b,Y,Z,ce,ie,pe)}logIncoming(Y,Z,ce,ie,pe){this.a+=Y,H(this.f,this.a,Y,Z,ce,ie,pe)}}e.$9h=X}),define(ke[82],Ee([1,0,21,4,3,81]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.ProtocolConstants=e.$0h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function g(w,k){if(!c.has(w)){const y=String(++h);c.set(w,y)}return c.get(w)}function D(w,k,y,C){if(!l.enableDiagnostics)return;const I=g(w,k);if(C instanceof u.$ze||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=u.$ze.alloc(C.byteLength);z.set(C),l.records.push({timestamp:Date.now(),id:I,label:k,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:I,label:k,type:y,data:C})}l.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var p;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let S=null;function A(){return S||(S=u.$ze.alloc(0)),S}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const k=this.a[0];return h&&(this.a.shift(),this.b-=c),k}if(this.a[0].byteLength>c){const k=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),k}const g=u.$ze.alloc(c);let D=0,w=0;for(;c>0;){const k=this.a[w];if(k.byteLength>c){const y=k.slice(0,c);g.set(y,D),D+=c,h&&(this.a[w]=k.slice(c),this.b-=c),c-=c}else g.set(k,D),D+=k.byteLength,h?(this.a.shift(),this.b-=k.byteLength):w++,c-=k.byteLength}return g}}e.$0h=P;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function E(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class a{constructor(c,h,g,D){this.type=c,this.id=h,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Uc{constructor(c){super(),this.f=this.B(new N.$_d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,D=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new a(g,D,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$ze.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const g=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,g}h(){const c=u.$ze.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends L.$Uc{constructor(c){super(),this.f=new N.$_d,this.onMessage=this.f.event,this.g=new N.$_d,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new a(1,0,0,c))}}e.$$h=n;class i extends R.$5h{static fromSocket(c,h){return new i(new n(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,g=null){super(c,h,g),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$_h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$_d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ai=r;class s{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,g=this.a;for(;g;)c[h++]=g.data,g=g.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<f.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+f.a)*1e3;let g=0;for(let D=0;D<f.a;D++)c-this.c[D]<=h&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??f.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new a(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new a(7,0,0,A());this.p.write(c)}sendResume(){const c=new a(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new a(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const g=new a(1,h,this.h,c);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(c){const h=new a(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,g=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&g>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const w=Math.max(2e4-h,2e4-g,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new a(9,0,this.h,A());this.p.write(c)}}e.$bi=d}),define(ke[194],Ee([1,0,53,7,21,22,192,13,4,3,24,105,102,81]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class v extends E.$2h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",n=>L.$ze.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Oq=v;class a{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new p.$_d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$kh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,N.$ah)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,S.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return p.Event.None;this.b.cancel();let r;const s=new p.$_d({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Tn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$em)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new p.$_d,s=p.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$Kq)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$ze.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,P.$gm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new E.$3h(l);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,g)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:g})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pq=a}),define(ke[195],Ee([1,0,7,4,3,58,18]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.StorageState=e.StorageHint=void 0,e.$Mp=p;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function p($){const E=$;return E?.changed instanceof Map||E?.deleted instanceof Set}var S;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(S||(e.StorageState=S={}));class A extends L.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new N.$ce),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new u.$lh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,a)=>this.w(a,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===S.Closed)return;let a=!1;(0,M.$0f)(v)?a=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),a=!0),a&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const a=this.f.get(E);return(0,M.$0f)(a)?v:a}getBoolean(E,v){const a=this.get(E);return(0,M.$0f)(a)?v:a==="true"}getNumber(E,v){const a=this.get(E);return(0,M.$0f)(a)?v:parseInt(a,10)}getObject(E,v){const a=this.get(E);return(0,M.$0f)(a)?v:(0,R.$Vh)(a)}async set(E,v,a=!1){if(this.c===S.Closed)return;if((0,M.$0f)(v))return this.delete(E,a);const m=(0,M.$3f)(v)||Array.isArray(v)?(0,R.$Uh)(v):String(v);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:a}),this.D()}async delete(E,v=!1){if(!(this.c===S.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Np=A;class P{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,a)=>this.a.set(a,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Op=P}),define(ke[196],Ee([1,0,14,11,21]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=A,e.$rt=P;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function p(){return b||(b=new TextDecoder("UTF-16BE")),b}let S;function A(){return S||(S=N.$D()?M():p()),S}function P(v,a,m){const o=new Uint16Array(v.buffer,a,m);return m>0&&(o[0]===65279||o[0]===65534)?$(v,a,m):M().decode(o)}function $(v,a,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=L.$Be(v,a);a+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class E{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||u.$uf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let o=0;o<m;o++)this.b[this.d++]=a.charCodeAt(o)}}e.$st=E}),define(ke[197],Ee([1,0,21,196]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=M;function L(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,A,P,$){this.oldPosition=S,this.oldText=A,this.newPosition=P,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,A,P){const $=A.length;u.$Ee(S,$,P),P+=4;for(let E=0;E<$;E++)u.$Ce(S,A.charCodeAt(E),P),P+=2;return P}static d(S,A){const P=u.$De(S,A);return A+=4,(0,N.$rt)(S,A,P)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(S,A){return u.$Ee(S,this.oldPosition,A),A+=4,u.$Ee(S,this.newPosition,A),A+=4,A=R.c(S,this.oldText,A),A=R.c(S,this.newText,A),A}static read(S,A,P){const $=u.$De(S,A);A+=4;const E=u.$De(S,A);A+=4;const v=R.d(S,A);A+=R.a(v);const a=R.d(S,A);return A+=R.a(a),P.push(new R($,v,E,a)),A}}e.$tt=R;function M(p,S){return p===null||p.length===0?S:new b(p,S).compress()}class b{constructor(S,A){this.a=S,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,A=0,P=this.n(S),$=this.l(A);for(;S<this.f||A<this.h;){if(P===null){this.k($),$=this.l(++A);continue}if($===null){this.m(P),P=this.n(++S);continue}if($.oldEnd<=P.newPosition){this.k($),$=this.l(++A);continue}if(P.newEnd<=$.oldPosition){this.m(P),P=this.n(++S);continue}if($.oldPosition<P.newPosition){const[o,n]=b.r($,P.newPosition-$.oldPosition);this.k(o),$=n;continue}if(P.newPosition<$.oldPosition){const[o,n]=b.q(P,$.oldPosition-P.newPosition);this.m(o),P=n;continue}let a,m;if($.oldEnd===P.newEnd)a=P,m=$,P=this.n(++S),$=this.l(++A);else if($.oldEnd<P.newEnd){const[o,n]=b.q(P,$.oldLength);a=o,m=$,P=n,$=this.l(++A)}else{const[o,n]=b.r($,P.newLength);a=P,m=o,P=this.n(++S),$=n}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const E=b.s(this.d);return b.t(E)}k(S){this.d[this.e++]=b.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=b.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,A){return new R(A.oldPosition-S,A.oldText,A.newPosition,A.newText)}static p(S,A){return new R(A.oldPosition,A.oldText,A.newPosition+S,A.newText)}static q(S,A){const P=S.newText.substr(0,A),$=S.newText.substr(A);return[new R(S.oldPosition,S.oldText,S.newPosition,P),new R(S.oldEnd,"",S.newPosition+A,$)]}static r(S,A){const P=S.oldText.substr(0,A),$=S.oldText.substr(A);return[new R(S.oldPosition,P,S.newPosition,S.newText),new R(S.oldPosition+A,$,S.newEnd,"")]}static s(S){if(S.length===0)return S;const A=[];let P=0,$=S[0];for(let E=1;E<S.length;E++){const v=S[E];$.oldEnd===v.oldPosition?$=new R($.oldPosition,$.oldText+v.oldText,$.newPosition,$.newText+v.newText):(A[P++]=$,$=v)}return A[P++]=$,A}static t(S){if(S.length===0)return S;const A=[];let P=0;for(let $=0;$<S.length;$++){const E=S[$];E.oldText!==E.newText&&(A[P++]=E)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=L,e.$St=R;function L(M,b,p,S,A,P){if(Array.isArray(M)){let $=0;for(const E of M){const v=L(E,b,p,S,A,P);if(v===10)return v;v>$&&($=v)}return $}else{if(typeof M=="string")return S?M==="*"?5:M===p?10:0:0;if(M){const{language:$,pattern:E,scheme:v,hasAccessToAllModels:a,notebookType:m}=M;if(!S&&!a)return 0;m&&A&&(b=A);let o=0;if(v)if(v===b.scheme)o=10;else if(v==="*")o=5;else return 0;if($)if($===p)o=10;else if($==="*")o=Math.max(o,5);else return 0;if(m)if(m===P)o=10;else if(m==="*"&&P!==void 0)o=Math.max(o,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,N.$ic)(E.base)},n===b.fsPath||(0,u.$gk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class A extends S.$Uc{constructor($,E,v,a,m,o,n){super(),this.m=this.B(new u.$_d),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=a,this.h=m,this.c=new M.$HC($,v,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,E){return this.c.getOffsetAt($,E)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,E){const v=$+E,a=this.getPositionAt($),m=this.getPositionAt(v);return new L.$ht(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange($,E=0){if($.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange($,v)}getValueLengthInRange($,E=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const v=this.getOffsetAt($.startLineNumber,$.startColumn),a=this.getOffsetAt($.endLineNumber,$.endColumn);let m=0;const o=this.n(E),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=$.endLineNumber-$.startLineNumber;m=i*r}return a-v+m}getCharacterCountInRange($,E=0){if(this.j){let v=0;const a=$.startLineNumber,m=$.endLineNumber;for(let o=a;o<=m;o++){const n=this.getLineContent(o),i=o===a?$.startColumn-1:0,r=o===m?$.endColumn-1:n.length;for(let s=i;s<r;s++)N.$uf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(E).length*(m-a),v}return this.getValueLengthInRange($,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,E){return this.c.getLineCharCode($,E)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const E=N.$ff(this.getLineContent($));return E===-1?0:E+1}getLineLastNonWhitespaceColumn($){const E=N.$hf(this.getLineContent($));return E===-1?0:E+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,E,v){let a=this.g,m=this.h,o=this.j,n=!0,i=[];for(let c=0;c<$.length;c++){const h=$[c];n&&h._isTracked&&(n=!1);const g=h.range;if(h.text){let C=!0;o||(C=!N.$Ff(h.text),o=C),!a&&C&&(a=N.$Ef(h.text)),!m&&C&&(m=N.$Hf(h.text))}let D="",w=0,k=0,y=0;if(h.text){let C;[w,k,y,C]=(0,b.$Kt)(h.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,I)}i[c]={sortIndex:c,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:w,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let c=0,h=i.length-1;c<h;c++){const g=i[c].range.getEndPosition(),D=i[c+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||E?A._getInverseEditRanges(i):[],t=[];if(E)for(let c=0;c<i.length;c++){const h=i[c],g=s[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let w="";D===g.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),N.$ff(w)!==-1)||t.push({lineNumber:D,oldContent:w})}}let f=null;if(v){let c=0;f=[];for(let h=0;h<i.length;h++){const g=i[h],D=s[h],w=this.getValueInRange(g.range),k=g.rangeOffset+c;c+=g.text.length-w.length,f[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:w,textChange:new p.$tt(g.rangeOffset,w,k,g.text)}}r||f.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=a,this.h=m,this.j=o;const d=this.t(i);let l=null;if(E&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const g=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===g)continue;const D=t[c].oldContent,w=this.getLineContent(g);w.length===0||w===D||N.$ff(w)!==-1||l.push(g)}}return this.m.fire(),new R.$wv(f,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let E=!1;const v=$[0].range,a=$[$.length-1].range,m=new L.$ht(v.startLineNumber,v.startColumn,a.endLineNumber,a.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=$.length;d<l;d++){const c=$[d],h=c.range;E=E||c.forceMoveMarkers,i.push(this.getValueInRange(new L.$ht(o,n,h.startLineNumber,h.startColumn))),c.text.length>0&&i.push(c.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,b.$Kt)(r);return{sortIndex:0,identifier:$[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const E=[];for(let v=0;v<$.length;v++){const a=$[v],m=a.range.startLineNumber,o=a.range.startColumn,n=a.range.endLineNumber,i=a.range.endColumn;if(m===n&&o===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new L.$ht(m,o,n,i);E.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return E}findMatchesLineByLine($,E,v,a){return this.c.findMatchesLineByLine($,E,v,a)}getPieceTree(){return this.c}static _getInverseEditRange($,E){const v=$.startLineNumber,a=$.startColumn,[m,o,n]=(0,b.$Kt)(E);let i;if(E.length>0){const r=m+1;r===1?i=new L.$ht(v,a,v,a+o):i=new L.$ht(v,a,v+r-1,n+1)}else i=new L.$ht(v,a,v,a);return i}static _getInverseEditRanges($){const E=[];let v=0,a=0,m=null;for(let o=0,n=$.length;o<n;o++){const i=$[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=v,s=a+(i.range.startColumn-m.range.endColumn)):(r=v+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new L.$ht(r,s,r,s+i.firstLineLength):t=new L.$ht(r,s,r+f-1,i.lastLineLength+1)}else t=new L.$ht(r,s,r,s);v=t.endLineNumber,a=t.endColumn,E.push(t),m=i}return E}static u($,E){const v=L.$ht.compareRangesUsingEnds($.range,E.range);return v===0?$.sortIndex-E.sortIndex:v}static w($,E){const v=L.$ht.compareRangesUsingEnds($.range,E.range);return v===0?E.sortIndex-$.sortIndex:-v}}e.$IC=A}),define(ke[200],Ee([1,0,14,130,199]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=void 0;class R{constructor(p,S,A,P,$,E,v,a,m){this.a=p,this.b=S,this.c=A,this.d=P,this.e=$,this.f=E,this.g=v,this.h=a,this.j=m}k(p){const S=this.c+this.d+this.e,A=this.c+this.e;return S===0?p===1?`
`:`\r
`:A>S/2?`\r
`:`
`}create(p){const S=this.k(p),A=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let $=0,E=A.length;$<E;$++){const v=A[$].buffer.replace(/\r\n|\r|\n/g,S),a=(0,N.$DC)(v);A[$]=new N.$GC(v,a)}const P=new L.$IC(A,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&u.$Of(p)&&(this.b=u.$Nf,p=p.substr(1));const S=p.charCodeAt(p.length-1);S===13||S>=55296&&S<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=S):(this.m(p,!1),this.c=!1,this.d=S)}m(p,S){!S&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const S=(0,N.$EC)(this.e,p);this.a.push(new N.$GC(p,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Ef(p)),this.k||(this.k=u.$Hf(p)))}finish(p=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const S=(0,N.$DC)(p.buffer);p.lineStarts=S,this.d===13&&this.f++}}}e.$JC=M}),define(ke[134],Ee([1,0,21,11]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbb=p,e.$ebb=A;var L;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(L||(L={}));function R(P){for(let $=0,E=P.length;$<E;$+=4){const v=P[$+0],a=P[$+1],m=P[$+2],o=P[$+3];P[$+0]=o,P[$+1]=m,P[$+2]=a,P[$+3]=v}}function M(P){const $=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return N.$D()||R($),u.$ze.wrap($)}function b(P){const $=P.buffer;if(N.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const E=new Uint8Array($.byteLength);return E.set($),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(P){const $=new Uint32Array(S(P));let E=0;if($[E++]=P.id,P.type==="full")$[E++]=1,$[E++]=P.data.length,$.set(P.data,E),E+=P.data.length;else{$[E++]=2,$[E++]=P.deltas.length;for(const v of P.deltas)$[E++]=v.start,$[E++]=v.deleteCount,v.data?($[E++]=v.data.length,$.set(v.data,E),E+=v.data.length):$[E++]=0}return M($)}function S(P){let $=0;if($+=2,P.type==="full")$+=1+P.data.length;else{$+=1,$+=3*P.deltas.length;for(const E of P.deltas)E.data&&($+=E.data.length)}return $}function A(P){const $=b(P);let E=0;const v=$[E++];if($[E++]===1){const n=$[E++],i=$.subarray(E,E+n);return E+=n,{id:v,type:"full",data:i}}const m=$[E++],o=[];for(let n=0;n<m;n++){const i=$[E++],r=$[E++],s=$[E++];let t;s>0&&(t=$.subarray(E,E+s),E+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:o}}}),define(ke[201],Ee([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=de;var p;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=S;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,Ie,Ke,Me){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Me}applyUpdate(ue,Ie){return E(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class ${constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=$;function E(se,ue){if(typeof se!="object"||typeof ue!="object"||!se||!ue)return new $(ue,se!==ue);if(Array.isArray(se)||Array.isArray(ue)){const Ke=Array.isArray(se)&&Array.isArray(ue)&&u.$ub(se,ue);return new $(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Me=E(se[Ke],ue[Ke]);Me.didChange&&(se[Ke]=Me.newValue,Ie=!0)}return new $(se,Ie)}class v{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return E(ue,Ie)}validate(ue){return this.defaultValue}}class a{constructor(ue,Ie,Ke,Me){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Me}applyUpdate(ue,Ie){return E(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function m(se,ue){return typeof se>"u"?ue:se==="false"?!1:!!se}class o extends a{constructor(ue,Ie,Ke,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ke),super(ue,Ie,Ke,Me)}validate(ue){return m(ue,this.defaultValue)}}function n(se,ue,Ie,Ke){if(typeof se>"u")return ue;let Me=parseInt(se,10);return isNaN(Me)?ue:(Me=Math.max(Ie,Me),Me=Math.min(Ke,Me),Me|0)}class i extends a{static clampedInt(ue,Ie,Ke,Me){return n(ue,Ie,Ke,Me)}constructor(ue,Ie,Ke,Me,it,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ke,lt.minimum=Me,lt.maximum=it),super(ue,Ie,Ke,lt),this.minimum=Me,this.maximum=it}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(se,ue,Ie,Ke){if(typeof se>"u")return ue;const Me=s.float(se,ue);return s.clamp(Me,Ie,Ke)}class s extends a{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Me,it){typeof it<"u"&&(it.type="number",it.default=Ke),super(ue,Ie,Ke,it),this.validationFn=Me}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ke),super(ue,Ie,Ke,Me)}validate(ue){return t.string(ue,this.defaultValue)}}function f(se,ue,Ie,Ke){return typeof se!="string"?ue:Ke&&se in Ke?Ke[se]:Ie.indexOf(se)===-1?ue:se}class d extends a{constructor(ue,Ie,Ke,Me,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Me,it.default=Ke),super(ue,Ie,Ke,it),this.c=Me}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends P{constructor(ue,Ie,Ke,Me,it,lt,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=it,wt.default=Me),super(ue,Ie,Ke,wt),this.c=it,this.d=lt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class g extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function w(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(se){switch(se){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(se){switch(se){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ue,Ie,Ke){const Me=["monaco-editor"];return Ie.get(39)&&Me.push(Ie.get(39)),ue.extraEditorClassName&&Me.push(ue.extraEditorClassName),Ie.get(74)==="default"?Me.push("mouse-default"):Ie.get(74)==="copy"&&Me.push("mouse-copy"),Ie.get(111)&&Me.push("showUnused"),Ie.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class j extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class F extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?F.OFF:ue==="true"?F.ON:ue:ue?F.ON:F.OFF}}e.EditorFontLigatures=F;class O extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.TRANSLATE:ue:ue?O.TRANSLATE:O.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class B extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ie=s.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class H extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class X extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:f(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??f(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??f(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??f(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??f(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??f(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var Y;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class Z extends v{constructor(){super(145)}compute(ue,Ie,Ke){return Z.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Me=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Me=Math.max(Me,Ie-1));const it=(Ke+ue.viewLineCount+Me)/(ue.pixelRatio*ue.height),lt=Math.floor(ue.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Me,desiredRatio:it,minimapLineCount:lt}}static c(ue,Ie){const Ke=ue.outerWidth,Me=ue.outerHeight,it=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const lt=Ie.stableMinimapLayoutInput,wt=lt&&ue.outerHeight===lt.outerHeight&&ue.lineHeight===lt.lineHeight&&ue.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===lt.pixelRatio&&ue.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ue.paddingTop===lt.paddingTop&&ue.paddingBottom===lt.paddingBottom&&ue.minimap.enabled===lt.minimap.enabled&&ue.minimap.side===lt.minimap.side&&ue.minimap.size===lt.minimap.size&&ue.minimap.showSlider===lt.minimap.showSlider&&ue.minimap.renderCharacters===lt.minimap.renderCharacters&&ue.minimap.maxColumn===lt.minimap.maxColumn&&ue.minimap.scale===lt.minimap.scale&&ue.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ue.isViewportWrapping===lt.isViewportWrapping,It=ue.lineHeight,Ft=ue.typicalHalfwidthCharacterWidth,qt=ue.scrollBeyondLastLine,xt=ue.minimap.renderCharacters;let St=it>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Wt=ue.minimap.maxColumn,Gt=ue.minimap.size,et=ue.minimap.side,ri=ue.verticalScrollbarWidth,_t=ue.viewLineCount,ft=ue.remainingWidth,$t=ue.isViewportWrapping,ei=xt?2:3;let ti=Math.floor(it*Me);const zt=ti/it;let gt=!1,Bt=!1,ii=ei*St,Ot=St/it,xe=1;if(Gt==="fill"||Gt==="fit"){const{typicalViewportLineCount:Ht,extraLinesBeforeFirstLine:Jt,extraLinesBeyondLastLine:Qt,desiredRatio:oi,minimapLineCount:At}=Z.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:qt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Me,lineHeight:It,pixelRatio:it});if(_t/At>1)gt=!0,Bt=!0,St=1,ii=1,Ot=St/it;else{let Pt=!1,Dt=St+1;if(Gt==="fit"){const bt=Math.ceil((Jt+_t+Qt)*ii);$t&&wt&&ft<=Ie.stableFitRemainingWidth?(Pt=!0,Dt=Ie.stableFitMaxMinimapScale):Pt=bt>ti}if(Gt==="fill"||Pt){gt=!0;const bt=St;ii=Math.min(It*it,Math.max(1,Math.floor(1/oi))),$t&&wt&&ft<=Ie.stableFitRemainingWidth&&(Dt=Ie.stableFitMaxMinimapScale),St=Math.min(Dt,Math.max(1,Math.floor(ii/ei))),St>bt&&(xe=Math.min(2,St/bt)),Ot=St/it/xe,ti=Math.ceil(Math.max(Ht,Jt+_t+Qt)*ii),$t?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=ft,Ie.stableFitMaxMinimapScale=St):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const si=Math.floor(Wt*Ot),Kt=Math.min(si,Math.max(0,Math.floor((ft-ri-2)*Ot/(Ft+Ot)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(it*Kt);const mt=Ut/it;Ut=Math.floor(Ut*xe);const Tt=xt?1:2,Lt=et==="left"?0:Ke-Kt-ri;return{renderMinimap:Tt,minimapLeft:Lt,minimapWidth:Kt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Bt,minimapScale:St,minimapLineHeight:ii,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:ti,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Me=Ie.outerHeight|0,it=Ie.lineHeight|0,lt=Ie.lineNumbersDigitCount|0,wt=Ie.typicalHalfwidthCharacterWidth,It=Ie.maxDigitWidth,Ft=Ie.pixelRatio,qt=Ie.viewLineCount,xt=ue.get(137),St=xt==="inherit"?ue.get(136):xt,Wt=St==="inherit"?ue.get(132):St,Gt=ue.get(135),et=Ie.isDominatedByLongLines,ri=ue.get(57),_t=ue.get(68).renderType!==0,ft=ue.get(69),$t=ue.get(105),ei=ue.get(84),ti=ue.get(73),zt=ue.get(103),gt=zt.verticalScrollbarSize,Bt=zt.verticalHasArrows,ii=zt.arrowSize,Ot=zt.horizontalScrollbarSize,xe=ue.get(43),si=ue.get(110)!=="never";let Kt=ue.get(66);xe&&si&&(Kt+=16);let Ut=0;if(_t){const li=Math.max(lt,ft);Ut=Math.round(li*It)}let mt=0;ri&&(mt=it*Ie.glyphMarginDecorationLaneCount);let Tt=0,Lt=Tt+mt,Ht=Lt+Ut,Jt=Ht+Kt;const Qt=Ke-mt-Ut-Kt;let oi=!1,At=!1,Nt=-1;St==="inherit"&&et?(oi=!0,At=!0):Wt==="on"||Wt==="bounded"?At=!0:Wt==="wordWrapColumn"&&(Nt=Gt);const Pt=Z.c({outerWidth:Ke,outerHeight:Me,lineHeight:it,typicalHalfwidthCharacterWidth:wt,pixelRatio:Ft,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:ti,verticalScrollbarWidth:gt,viewLineCount:qt,remainingWidth:Qt,isViewportWrapping:At},Ie.memory||new A);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Tt+=Pt.minimapWidth,Lt+=Pt.minimapWidth,Ht+=Pt.minimapWidth,Jt+=Pt.minimapWidth);const Dt=Qt-Pt.minimapWidth,bt=Math.max(1,Math.floor((Dt-gt-2)/wt)),Ct=Bt?ii:0;return At&&(Nt=Math.max(1,bt),Wt==="bounded"&&(Nt=Math.min(Nt,Gt))),{width:Ke,height:Me,glyphMarginLeft:Tt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Lt,lineNumbersWidth:Ut,decorationsLeft:Ht,decorationsWidth:Kt,contentLeft:Jt,contentWidth:Dt,minimap:Pt,viewportColumn:bt,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Ot,overviewRuler:{top:Ct,width:gt,height:Me-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Z;class ce extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}var ie;(function(se){se.Off="off",se.OnCode="onCode",se.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class pe extends P{constructor(){const ue={enabled:ie.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:ue.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class Ce extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:f(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?i.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ne extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:b.localize(66,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class be extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ue.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:f(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ie.side,this.defaultValue.side,["right","left"]),showSlider:f(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(Ie.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(Ie.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ie.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function De(se){return se==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class oe extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class ae extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class re extends v{constructor(){super(143)}compute(ue,Ie,Ke){return ue.pixelRatio}}class K extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:b.localize(88,null)},comments:{anyOf:Ie,default:ue.comments,description:b.localize(89,null)},other:{anyOf:Ie,default:ue.other,description:b.localize(90,null)}},default:ue,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Ft=ue?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Me}=ue,it=["on","inline","off"];let lt,wt,It;return typeof Ie=="boolean"?lt=Ie?"on":"off":lt=f(Ie,this.defaultValue.other,it),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=f(Ke,this.defaultValue.comments,it),typeof Me=="boolean"?It=Me?"on":"off":It=f(Me,this.defaultValue.strings,it),{other:lt,comments:wt,strings:It}}}var te;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class le extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function de(se){const ue=se.get(98);return ue==="editable"?se.get(91):ue!=="on"}class Ae extends P{constructor(){const ue=[],Ie={type:"number",description:b.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ue,description:b.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Me=Ke;Ie.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Ie.sort((Ke,Me)=>Ke.column-Me.column),Ie}return this.defaultValue}}class me extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(se,ue){if(typeof se!="string")return ue;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Me,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(N.$Xn(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(N.$Xn(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Me=super.applyUpdate(ue,Ie);return Ke?new $(Me.newValue,!0):Me}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:fe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Me,it]of Object.entries(ue))it===!0&&(Ke[Me]=!0);return Ke}}class V extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:f(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class W extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:b.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends P{constructor(){const ue={enabled:R.$Rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ue.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ue.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:fe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(se,ue,Ie){const Ke=Ie.indexOf(se);return Ke===-1?ue:Ie[Ke]}class we extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ue.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ue.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:f(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:f(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Ie.push(Ke)}catch{}return Ie}return this.defaultValue}}var Xe;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(Xe||(e.WrappingIndent=Xe={}));class st extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class ot extends v{constructor(){super(146)}compute(ue,Ie,Ke){const Me=Ie.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class tt extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:f(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class rt extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:f(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Se="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?Ge:Se,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(se){return e.editorOptionsRegistry[se.id]=se,se}var Ye;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.ariaRequired=5]="ariaRequired",se[se.autoClosingBrackets=6]="autoClosingBrackets",se[se.autoClosingComments=7]="autoClosingComments",se[se.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",se[se.autoClosingDelete=9]="autoClosingDelete",se[se.autoClosingOvertype=10]="autoClosingOvertype",se[se.autoClosingQuotes=11]="autoClosingQuotes",se[se.autoIndent=12]="autoIndent",se[se.automaticLayout=13]="automaticLayout",se[se.autoSurround=14]="autoSurround",se[se.bracketPairColorization=15]="bracketPairColorization",se[se.guides=16]="guides",se[se.codeLens=17]="codeLens",se[se.codeLensFontFamily=18]="codeLensFontFamily",se[se.codeLensFontSize=19]="codeLensFontSize",se[se.colorDecorators=20]="colorDecorators",se[se.colorDecoratorsLimit=21]="colorDecoratorsLimit",se[se.columnSelection=22]="columnSelection",se[se.comments=23]="comments",se[se.contextmenu=24]="contextmenu",se[se.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",se[se.cursorBlinking=26]="cursorBlinking",se[se.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",se[se.cursorStyle=28]="cursorStyle",se[se.cursorSurroundingLines=29]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",se[se.cursorWidth=31]="cursorWidth",se[se.disableLayerHinting=32]="disableLayerHinting",se[se.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",se[se.domReadOnly=34]="domReadOnly",se[se.dragAndDrop=35]="dragAndDrop",se[se.dropIntoEditor=36]="dropIntoEditor",se[se.emptySelectionClipboard=37]="emptySelectionClipboard",se[se.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",se[se.extraEditorClassName=39]="extraEditorClassName",se[se.fastScrollSensitivity=40]="fastScrollSensitivity",se[se.find=41]="find",se[se.fixedOverflowWidgets=42]="fixedOverflowWidgets",se[se.folding=43]="folding",se[se.foldingStrategy=44]="foldingStrategy",se[se.foldingHighlight=45]="foldingHighlight",se[se.foldingImportsByDefault=46]="foldingImportsByDefault",se[se.foldingMaximumRegions=47]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=49]="fontFamily",se[se.fontInfo=50]="fontInfo",se[se.fontLigatures=51]="fontLigatures",se[se.fontSize=52]="fontSize",se[se.fontWeight=53]="fontWeight",se[se.fontVariations=54]="fontVariations",se[se.formatOnPaste=55]="formatOnPaste",se[se.formatOnType=56]="formatOnType",se[se.glyphMargin=57]="glyphMargin",se[se.gotoLocation=58]="gotoLocation",se[se.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",se[se.hover=60]="hover",se[se.inDiffEditor=61]="inDiffEditor",se[se.inlineSuggest=62]="inlineSuggest",se[se.inlineEdit=63]="inlineEdit",se[se.letterSpacing=64]="letterSpacing",se[se.lightbulb=65]="lightbulb",se[se.lineDecorationsWidth=66]="lineDecorationsWidth",se[se.lineHeight=67]="lineHeight",se[se.lineNumbers=68]="lineNumbers",se[se.lineNumbersMinChars=69]="lineNumbersMinChars",se[se.linkedEditing=70]="linkedEditing",se[se.links=71]="links",se[se.matchBrackets=72]="matchBrackets",se[se.minimap=73]="minimap",se[se.mouseStyle=74]="mouseStyle",se[se.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=76]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",se[se.multiCursorModifier=78]="multiCursorModifier",se[se.multiCursorPaste=79]="multiCursorPaste",se[se.multiCursorLimit=80]="multiCursorLimit",se[se.occurrencesHighlight=81]="occurrencesHighlight",se[se.overviewRulerBorder=82]="overviewRulerBorder",se[se.overviewRulerLanes=83]="overviewRulerLanes",se[se.padding=84]="padding",se[se.pasteAs=85]="pasteAs",se[se.parameterHints=86]="parameterHints",se[se.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",se[se.quickSuggestions=89]="quickSuggestions",se[se.quickSuggestionsDelay=90]="quickSuggestionsDelay",se[se.readOnly=91]="readOnly",se[se.readOnlyMessage=92]="readOnlyMessage",se[se.renameOnType=93]="renameOnType",se[se.renderControlCharacters=94]="renderControlCharacters",se[se.renderFinalNewline=95]="renderFinalNewline",se[se.renderLineHighlight=96]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=98]="renderValidationDecorations",se[se.renderWhitespace=99]="renderWhitespace",se[se.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",se[se.roundedSelection=101]="roundedSelection",se[se.rulers=102]="rulers",se[se.scrollbar=103]="scrollbar",se[se.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=105]="scrollBeyondLastLine",se[se.scrollPredominantAxis=106]="scrollPredominantAxis",se[se.selectionClipboard=107]="selectionClipboard",se[se.selectionHighlight=108]="selectionHighlight",se[se.selectOnLineNumbers=109]="selectOnLineNumbers",se[se.showFoldingControls=110]="showFoldingControls",se[se.showUnused=111]="showUnused",se[se.snippetSuggestions=112]="snippetSuggestions",se[se.smartSelect=113]="smartSelect",se[se.smoothScrolling=114]="smoothScrolling",se[se.stickyScroll=115]="stickyScroll",se[se.stickyTabStops=116]="stickyTabStops",se[se.stopRenderingLineAfter=117]="stopRenderingLineAfter",se[se.suggest=118]="suggest",se[se.suggestFontSize=119]="suggestFontSize",se[se.suggestLineHeight=120]="suggestLineHeight",se[se.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",se[se.suggestSelection=122]="suggestSelection",se[se.tabCompletion=123]="tabCompletion",se[se.tabIndex=124]="tabIndex",se[se.unicodeHighlighting=125]="unicodeHighlighting",se[se.unusualLineTerminators=126]="unusualLineTerminators",se[se.useShadowDOM=127]="useShadowDOM",se[se.useTabStops=128]="useTabStops",se[se.wordBreak=129]="wordBreak",se[se.wordSegmenterLocales=130]="wordSegmenterLocales",se[se.wordSeparators=131]="wordSeparators",se[se.wordWrap=132]="wordWrap",se[se.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=135]="wordWrapColumn",se[se.wordWrapOverride1=136]="wordWrapOverride1",se[se.wordWrapOverride2=137]="wordWrapOverride2",se[se.wrappingIndent=138]="wrappingIndent",se[se.wrappingStrategy=139]="wrappingStrategy",se[se.showDeprecated=140]="showDeprecated",se[se.inlayHints=141]="inlayHints",se[se.editorClassName=142]="editorClassName",se[se.pixelRatio=143]="pixelRatio",se[se.tabFocusMode=144]="tabFocusMode",se[se.layoutInfo=145]="layoutInfo",se[se.wrappingInfo=146]="wrappingInfo",se[se.defaultColorDecorators=147]="defaultColorDecorators",se[se.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",se[se.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Le(new Q),bracketPairGuides:Le(new J),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Le(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Le(new g),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Le(new l(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new tt),stickyScroll:Le(new Ce),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new s(40,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:b.localize(271,null)})),find:Le(new j),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Le(new T),fontLigatures2:Le(new F),fontSize:Le(new B),fontWeight:Le(new H),fontVariations:Le(new O),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Le(new X),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Le(new x),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>s.clamp(se,-5,20),{description:b.localize(285,null)})),lightbulb:Le(new pe),lineDecorationsWidth:Le(new U),lineHeight:Le(new ne),lineNumbers:Le(new le),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Le(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Le(new d(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Le(new be),mouseStyle:Le(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new s(75,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Le(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Le(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Le(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new oe),pasteAs:Le(new rt),parameterHints:Le(new ae),peekWidgetDefaultFocus:Le(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Le(new K),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new me),renameOnType:Le(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Le(new d(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Le(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Le(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Le(new Ae),scrollbar:Le(new Re),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Le(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Le(new _),snippetSuggestions:Le(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new we),inlineSuggest:Le(new V),inlineEdit:Le(new W),inlineCompletionsAccessibilityVerbose:Le(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Le(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Le(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Fe),unusualLineTerminators:Le(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Le(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Le(new Ve),wordSeparators:Le(new t(131,"wordSeparators",M.$Ss,{description:b.localize(359,null)})),wordWrap:Le(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Le(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new I),defaultColorDecorators:Le(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Le(new re),tabFocusMode:Le(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Le(new Z),wrappingInfo:Le(new ot),wrappingIndent:Le(new st),wrappingStrategy:Le(new ce)}}),define(ke[202],Ee([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$5t=e.$4t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$3t=e.$2t=e.SymbolKinds=e.SymbolTag=e.$Zt=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Xt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Wt=e.$Vt=e.$Ut=void 0,e.$Yt=f,e.$1t=l;class p{constructor(X,x,Y){this.offset=X,this.type=x,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ut=p;class S{constructor(X,x){this.tokens=X,this.endState=x,this._tokenizationResultBrand=void 0}}e.$Vt=S;class A{constructor(X,x){this.tokens=X,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$Wt=A;var P;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var $;(function(H){const X=new Map;X.set(0,u.$Mj.symbolMethod),X.set(1,u.$Mj.symbolFunction),X.set(2,u.$Mj.symbolConstructor),X.set(3,u.$Mj.symbolField),X.set(4,u.$Mj.symbolVariable),X.set(5,u.$Mj.symbolClass),X.set(6,u.$Mj.symbolStruct),X.set(7,u.$Mj.symbolInterface),X.set(8,u.$Mj.symbolModule),X.set(9,u.$Mj.symbolProperty),X.set(10,u.$Mj.symbolEvent),X.set(11,u.$Mj.symbolOperator),X.set(12,u.$Mj.symbolUnit),X.set(13,u.$Mj.symbolValue),X.set(15,u.$Mj.symbolEnum),X.set(14,u.$Mj.symbolConstant),X.set(15,u.$Mj.symbolEnum),X.set(16,u.$Mj.symbolEnumMember),X.set(17,u.$Mj.symbolKeyword),X.set(27,u.$Mj.symbolSnippet),X.set(18,u.$Mj.symbolText),X.set(19,u.$Mj.symbolColor),X.set(20,u.$Mj.symbolFile),X.set(21,u.$Mj.symbolReference),X.set(22,u.$Mj.symbolCustomColor),X.set(23,u.$Mj.symbolFolder),X.set(24,u.$Mj.symbolTypeParameter),X.set(25,u.$Mj.account),X.set(26,u.$Mj.issues);function x(ce){let ie=X.get(ce);return ie||(console.info("No codicon found for CompletionItemKind "+ce),ie=u.$Mj.symbolProperty),ie}H.toIcon=x;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function Z(ce,ie){let pe=Y.get(ce);return typeof pe>"u"&&!ie&&(pe=9),pe}H.fromString=Z})($||(e.CompletionItemKinds=$={}));var E;(function(H){H[H.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var v;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var a;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(X,x,Y,Z){this.range=X,this.text=x,this.completionKind=Y,this.isSnippetText=Z}equals(X){return R.$ht.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}e.$Xt=n;var i;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(H){return H&&N.URI.isUri(H.uri)&&R.$ht.isIRange(H.range)&&(R.$ht.isIRange(H.originSelectionRange)||R.$ht.isIRange(H.targetSelectionRange))}var d;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$Zt={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(H,X){return(0,b.localize)(26,null,H,e.$Zt[X])}var c;(function(H){H[H.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var h;(function(H){const X=new Map;X.set(0,u.$Mj.symbolFile),X.set(1,u.$Mj.symbolModule),X.set(2,u.$Mj.symbolNamespace),X.set(3,u.$Mj.symbolPackage),X.set(4,u.$Mj.symbolClass),X.set(5,u.$Mj.symbolMethod),X.set(6,u.$Mj.symbolProperty),X.set(7,u.$Mj.symbolField),X.set(8,u.$Mj.symbolConstructor),X.set(9,u.$Mj.symbolEnum),X.set(10,u.$Mj.symbolInterface),X.set(11,u.$Mj.symbolFunction),X.set(12,u.$Mj.symbolVariable),X.set(13,u.$Mj.symbolConstant),X.set(14,u.$Mj.symbolString),X.set(15,u.$Mj.symbolNumber),X.set(16,u.$Mj.symbolBoolean),X.set(17,u.$Mj.symbolArray),X.set(18,u.$Mj.symbolObject),X.set(19,u.$Mj.symbolKey),X.set(20,u.$Mj.symbolNull),X.set(21,u.$Mj.symbolEnumMember),X.set(22,u.$Mj.symbolStruct),X.set(23,u.$Mj.symbolEvent),X.set(24,u.$Mj.symbolOperator),X.set(25,u.$Mj.symbolTypeParameter);function x(Y){let Z=X.get(Y);return Z||(console.info("No codicon found for SymbolKind "+Y),Z=u.$Mj.symbolProperty),Z}H.toIcon=x})(h||(e.SymbolKinds=h={}));class g{static asEditOperation(X){return L.$it.replace(R.$ht.lift(X.range),X.text)}}e.$2t=g;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(X){switch(X){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(X)}constructor(X){this.value=X}}e.$3t=D;var w;(function(H){H[H.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var k;(function(H){function X(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}H.is=X})(k||(e.Command=k={}));var y;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var C;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var I;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var z;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var j;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(j||(e.CommentState=j={}));var F;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class O{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$4t=O,e.$5t=new M.$Jt;var T;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[219],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[220],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[221],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[222],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[223],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[224],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[225],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[226],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[227],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[228],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[229],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[230],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[231],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[232],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[233],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[234],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[235],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[236],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[237],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[238],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[239],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[240],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[241],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[242],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[243],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[244],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[245],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[246],Ee([1,0,13,205]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const M=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,$=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:$};this.g.push({offset:P,lexeme:$,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),$=p.b.get(P);$?this.k($):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(P)P=!1;else if(v===47&&!$){A++;break}else v===91?$=!0:v===92?P=!0:v===93&&($=!1);A++}for(;A<this.c.length&&p.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=p}),define(ke[247],Ee([1,0,23,40,208,397]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=p,e.$yp=S,e.$zp=A,e.$Ap=P,e.$Bp=$,e.$Cp=E,e.$Dp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||M.test(o)}function S(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,c,h,g]=l;d=Date.UTC(Number(c),Number(h)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function P(o,n,i){let r;typeof o=="string"?r=A(S(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(S(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let c=t.majorBase,h=t.minorBase,g=t.patchBase;const D=t.notBefore;let w=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>c?!0:f<c?!1:d>h?!0:d<h||s&&s<D?!1:l>=g:(f===1&&c===0&&(!w||!k||!y)&&(c=1,h=0,g=0,w=!0,k=!1,y=!1),f<c?!1:f>c?!w:d<h?!1:d>h?!k:l<g?!1:l>g?!y:!(s&&s<D))}function $(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const l=(0,u.$1g)(i,r.main);(0,u.$Ug)(l,i)||t.push([N.default.Warning,L.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const l=(0,u.$1g)(i,r.browser);(0,u.$Ug)(l,i)||t.push([N.default.Warning,L.localize(12,null,l.path,i.path)])}}if(!R.valid(r.version))return t.push([N.default.Error,L.localize(13,null)]),t;const f=[];if(!E(o,n,r,s,f))for(const l of f)t.push([N.default.Error,l]);return t}function E(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||a(n,i,o)}function a(o,n,i,r=[]){const s=A(S(i));if(!s)return r.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return P(o,n,s)?!0:(r.push(L.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class u{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ki=u}),define(ke[84],Ee([1,0,106]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=R,e.$ms=M;const N=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(b,p,S){p instanceof u.$ki||(p=new u.$ki(p,[],!!S)),N.push([b,p])}function M(){return N}}),define(ke[248],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class u{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$2q=u;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(M);b.outgoing.set(p.key,p),p.incoming.set(b.key,b)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let b=this.a.get(M);return b||(b=new u(M,R),this.a.set(M,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,b]of this.a)R.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const b=new Set([R]),p=this.c(M,b);if(p)return p}}c(R,M){for(const[b,p]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const S=this.c(p,M);if(S)return S;M.delete(b)}}}e.$3q=N}),define(ke[5],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=L,e.$oi=R;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(p){return p[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(u||(e._util=u={})),e.$mi=L("instantiationService");function N(M,b,p){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:M,index:p}):(b[u.DI_DEPENDENCIES]=[{id:M,index:p}],b[u.DI_TARGET]=b)}function L(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const b=function(p,S,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,p,A)};return b.toString=()=>M,u.serviceIds.set(M,b),b}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=R,e.$Vi=M,e.$Wi=p,e.$Xi=S,e.$Yi=A,e.$Zi=P,e.$1i=$,e.$2i=v,e.$3i=a,e.$4i=m,e.$Ti=(0,L.$ni)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)P(i,r,o[r],n);return i}function P(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let c=f[l];switch(typeof c){case"undefined":c=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}f=c}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function $(o,n){const i=n.split(".");E(o,i)}function E(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,n),Object.keys(r).length===0&&delete o[i])}}function v(o,n,i){function r(f,d){let l=f;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function a(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$3f(o[r])&&u.$3f(n[r])?a(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ke[37],Ee([1,0,11,14,246,5,204,13]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=S,e.$mj=f,e.$nj=d,e.$Gj=ie;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",u.$j),p.set("isLinux",u.$k),p.set("isWindows",u.$i),p.set("isWeb",u.$o),p.set("isMacNative",u.$j&&!u.$o),p.set("isEdge",u.$H),p.set("isFirefox",u.$F),p.set("isChrome",u.$E),p.set("isSafari",u.$G);function S(_,U){if(p.get(_)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(_,U)}const A=Object.prototype.hasOwnProperty;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const $={regexParsingWithErrorRecovery:!0},E=(0,M.localize)(0,null),v=(0,M.localize)(1,null),a=(0,M.localize)(2,null),m=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new L.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const be=this.D(),De=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:L.$ij.getLexeme(be),additionalInfo:De}),s.c}return ne}catch(ne){if(ne!==s.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,m),ne?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,m),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const De=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),De.type!==10)throw this.B("REGEX",De);const oe=De.lexeme,ae=oe.lastIndexOf("/"),re=ae===oe.length-1?void 0:this.w(oe.substring(ae+1));let K;try{K=new RegExp(oe.substring(1,ae),re)}catch{throw this.B("REGEX",De)}return T.create(ne,K)}switch(De.type){case 10:case 19:{const oe=[De.lexeme];this.z();let ae=this.D(),re=0;for(let Ae=0;Ae<De.lexeme.length;Ae++)De.lexeme.charCodeAt(Ae)===40?re++:De.lexeme.charCodeAt(Ae)===41&&re--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let Ae=0;Ae<ae.lexeme.length;Ae++)ae.lexeme.charCodeAt(Ae)===40?re++:De.lexeme.charCodeAt(Ae)===41&&re--}if(re<0)break;oe.push(L.$ij.getLexeme(ae)),this.z(),ae=this.D()}const K=oe.join(""),te=K.lastIndexOf("/"),le=te===K.length-1?void 0:this.w(K.substring(te+1));let de;try{de=new RegExp(K.substring(1,te),le)}catch{throw this.B("REGEX",De)}return t.regex(ne,de)}case 18:{const oe=De.lexeme;this.z();let ae=null;if(!(0,N.$Ze)(oe)){const re=oe.indexOf("/"),K=oe.lastIndexOf("/");if(re!==K&&re>=0){const te=oe.slice(re+1,K),le=oe[K+1]==="i"?"i":"";try{ae=new RegExp(te,le)}catch{throw this.B("REGEX",De)}}}if(ae===null)throw this.B("REGEX",De);return T.create(ne,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const De=this.u();return t.notIn(ne,De)}switch(this.D().type){case 3:{this.z();const De=this.u();if(this.x().type===18)return t.equals(ne,De);switch(De){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,De)}}case 4:{this.z();const De=this.u();if(this.x().type===18)return t.notEquals(ne,De);switch(De){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,De)}}case 5:return this.z(),F.create(ne,this.u());case 6:return this.z(),O.create(ne,this.u());case 7:return this.z(),z.create(ne,this.u());case 8:return this.z(),j.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,be){const De=(0,M.localize)(8,null,U,L.$ij.getLexeme(ne)),oe=ne.offset,ae=L.$ij.getLexeme(ne);return this.h.push({message:De,offset:oe,lexeme:ae,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=s;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return y.create(U,ne)}static regex(U,ne){return T.create(U,ne)}static in(U,ne){return w.create(U,ne)}static notIn(U,ne){return k.create(U,ne)}static not(U){return C.create(U)}static and(...U){return X.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,ne){return z.create(U,ne)}static greaterEquals(U,ne){return j.create(U,ne)}static smaller(U,ne){return F.create(U,ne)}static smallerEquals(U,ne){return O.create(U,ne)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$lj=t;function f(_){const U=new s({regexParsingWithErrorRecovery:!1});return _.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(_,U){const ne=_?_.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}function l(_,U){return _.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$oj=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$pj=h;class g{static create(U,ne=null){const be=p.get(U);return typeof be=="boolean"?be?h.INSTANCE:c.INSTANCE:new g(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=p.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$qj=g;class D{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?g.create(U,be):C.create(U,be);const De=p.get(U);return typeof De=="boolean"?ne===(De?"true":"false")?h.INSTANCE:c.INSTANCE:new D(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$rj=D;class w{static create(U,ne){return new w(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$sj=w;class k{static create(U,ne){return new k(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=w.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=k;class y{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?C.create(U,be):g.create(U,be);const De=p.get(U);return typeof De=="boolean"?ne===(De?"true":"false")?c.INSTANCE:h.INSTANCE:new y(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$uj=y;class C{static create(U,ne=null){const be=p.get(U);return typeof be=="boolean"?be?c.INSTANCE:h.INSTANCE:new C(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=p.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$vj=C;function I(_,U){if(typeof _=="string"){const ne=parseFloat(_);isNaN(ne)||(_=ne)}return typeof _=="string"||typeof _=="number"?U(_):c.INSTANCE}class z{static create(U,ne,be=null){return I(ne,De=>new z(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$wj=z;class j{static create(U,ne,be=null){return I(ne,De=>new j(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$xj=j;class F{static create(U,ne,be=null){return I(ne,De=>new F(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$yj=F;class O{static create(U,ne,be=null){return I(ne,De=>new O(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$zj=O;class T{static create(U,ne){return new T(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return ne<be?-1:ne>be?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ne===be}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Aj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Bj=B;function H(_){let U=null;for(let ne=0,be=_.length;ne<be;ne++){const De=_[ne].substituteConstants();if(_[ne]!==De&&U===null){U=[];for(let oe=0;oe<ne;oe++)U[oe]=_[oe]}U!==null&&(U[ne]=De)}return U===null?_:U}class X{static create(U,ne,be){return X.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const De=l(this.expr[ne],U.expr[ne]);if(De!==0)return De}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,be){const De=[];let oe=!1;for(const ae of U)if(ae){if(ae.type===1){oe=!0;continue}if(ae.type===0)return c.INSTANCE;if(ae.type===6){De.push(...ae.expr);continue}De.push(ae)}if(De.length===0&&oe)return h.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(l);for(let ae=1;ae<De.length;ae++)De[ae-1].equals(De[ae])&&(De.splice(ae,1),ae--);if(De.length===1)return De[0];for(;De.length>1;){const ae=De[De.length-1];if(ae.type!==9)break;De.pop();const re=De.pop(),K=De.length===0,te=x.create(ae.expr.map(le=>X.create([le,re],null,be)),null,K);te&&(De.push(te),De.sort(l))}if(De.length===1)return De[0];if(be){for(let ae=0;ae<De.length;ae++)for(let re=ae+1;re<De.length;re++)if(De[ae].negate().equals(De[re]))return c.INSTANCE;if(De.length===1)return De[0]}return new X(De,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new X(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Cj=X;class x{static create(U,ne,be){return x.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const De=l(this.expr[ne],U.expr[ne]);if(De!==0)return De}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,be){let De=[],oe=!1;if(U){for(let ae=0,re=U.length;ae<re;ae++){const K=U[ae];if(K){if(K.type===0){oe=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){De=De.concat(K.expr);continue}De.push(K)}}if(De.length===0&&oe)return c.INSTANCE;De.sort(l)}if(De.length!==0){if(De.length===1)return De[0];for(let ae=1;ae<De.length;ae++)De[ae-1].equals(De[ae])&&(De.splice(ae,1),ae--);if(De.length===1)return De[0];if(be){for(let ae=0;ae<De.length;ae++)for(let re=ae+1;re<De.length;re++)if(De[ae].negate().equals(De[re]))return h.INSTANCE;if(De.length===1)return De[0]}return new x(De,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new x(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),be=U.shift(),De=[];for(const oe of Ce(ne))for(const ae of Ce(be))De.push(X.create([oe,ae],null,!1));U.unshift(x.create(De,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Dj=x;class Y extends g{static{this.d=[]}static all(){return Y.d.values()}constructor(U,ne,be){super(U,null),this.f=ne,typeof be=="object"?Y.d.push({...be,key:U}):be!==!0&&Y.d.push({key:U,description:be,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Ej=Y,e.$Fj=(0,R.$ni)("contextKeyService");function Z(_,U){return _<U?-1:_>U?1:0}function ce(_,U,ne,be){return _<ne?-1:_>ne?1:U<be?-1:U>be?1:0}function ie(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?pe(_.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(ie(_,ne))return!0;return!1}if(_.type===6){if(U.type===6)return pe(U.expr,_.expr);for(const ne of _.expr)if(ie(ne,U))return!0;return!1}return _.equals(U)}function pe(_,U){let ne=0,be=0;for(;ne<_.length&&be<U.length;){const De=_[ne].cmp(U[be]);if(De<0)return!1;De===0&&ne++,be++}return ne===_.length}function Ce(_){return _.type===9?_.expr:[_]}}),define(ke[249],Ee([1,0,23,40,206,5,103,11,24]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$xw=e.$ww=e.$vw=void 0,e.$yw=E,e.$zw=v,e.$vw=(0,R.$ni)("dialogService");var S;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(S||(S={}));class A{a(m){return this.d(m,S.Confirmation)}b(m){return this.d(m,S.Prompt)}c(m){return this.d(m,S.Input)}d(m,o){const n=[];switch(o){case S.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case S.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case S.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$ww=A,e.$xw=(0,R.$ni)("fileDialogService");var P;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const $=10;function E(a){const m=[];return m.push(...a.slice(0,$).map(o=>typeof o=="string"?o:(0,u.$Xg)(o))),a.length>$&&(a.length-$===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,a.length-$))),m.push(""),m.join(`
`)}function v(a,m){const o=(0,p.$Tn)(a);let n=(o.buttons??[]).map(t=>(0,M.$sw)(t)),i=(a.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,u.$ni)("environmentService"),e.$vi=(0,u.$oi)(e.$ui)}),define(ke[137],Ee([1,0,207,5]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=L,e.$Ro=R,e.$So=M,e.$To=b,e.$Uo=p,e.$Vo=S,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function p(i,r,s){return b(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var $;(function(i){i.Install="install",i.Uninstall="uninstall"})($||(e.StatisticType=$={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Wo=(0,N.$ni)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Xo=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Yo=n,e.$Zo=(0,N.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,N.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,N.$ni)("IExtensionTipsService"),e.$5o=(0,u.localize2)(0,"Extensions"),e.$6o=(0,u.localize2)(1,"Preferences")}),define(ke[250],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=void 0,e.$a6b=(0,u.$ni)("externalTerminal"),e.$b6b="Terminal.app"}),define(ke[251],Ee([1,0,53,55,15,17,11,102,31,105,209,250]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=e.$ibc=void 0;const $=A.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,S.$fm(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const c=R.$oc(l,".exe").toLowerCase();if(c==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),c==="wt"&&h.push("-d ."),new Promise((g,D)=>{const w=o(process),k=s.spawn(f,h,{cwd:d,env:w,detached:!0});k.on("error",D),k.on("exit",()=>g())})}async runInTerminal(s,t,f,d,l){const c="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((g,D)=>{const w=`"${t} - ${$}"`,k=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),d);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const C={cwd:t,env:y,windowsVerbatimArguments:!0};let I,z;R.$oc(c,".exe")==="wt"?(I=c,z=["-d",".",v.b,"/c",k]):h?(I=h,z=["-d",".",c,"/c",k]):(I=v.b,z=["/c","start",w,"/wait",c,"/c",`"${k}"`]),u.spawn(I,z,C).on("error",F=>{D(n(F))}),g(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await S.win32.findExecutable("wt");return await p.Promises.exists(s)?s:void 0}catch{return}}}e.$ibc=v,Je([N.$Rh],v,"f",null);class a extends E{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.osxExec||P.$b6b;return new Promise((h,g)=>{if(c===P.$b6b||c==="iTerm.app"){const D=c===P.$b6b?"TerminalHelper":"iTermHelper",k=[L.$Hg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||$,"-w",t];for(const I of f)k.push("-a"),k.push(I);if(d){const I=Object.assign({},o(process),d);for(const z in I){const j=I[z];j===null?(k.push("-u"),k.push(z)):(k.push("-e"),k.push(`${z}=${j}`))}}let y="";const C=u.spawn(a.b,k);C.on("error",I=>{g(n(I))}),C.stderr.on("data",I=>{y+=I.toString()}),C.on("exit",I=>{if(I===0)h(void 0);else if(y){const z=y.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(1,null,D,I)))})}else g(new Error(A.localize(2,null,c)))})}spawnTerminal(s,t,f){const d=t.osxExec||P.$b6b;return new Promise((l,c)=>{const h=["-a",d];f&&h.push(f);const g=o(process),D=s.spawn("/usr/bin/open",h,{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})}}e.$jbc=a;class m extends E{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const D=[];c.then(w=>{w.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(f)}; echo; read -p "${m.b}" -n1;`;D.push(`''${k}''`);const y=Object.assign({},o(process),d);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const C={cwd:t,env:y};let I="";const z=u.spawn(w,D,C);z.on("error",j=>{g(n(j))}),z.stderr.on("data",j=>{I+=j.toString()}),z.on("exit",j=>{if(j===0)h(void 0);else if(I){const F=I.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const s=await p.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{d.then(h=>{const g=o(process),D=s.spawn(h,[],{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})})}}e.$kbc=m;function o(r){const s={...r.env};return(0,b.$dm)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=$,e.$Vk=a,e.$Wk=o,e.$Xk=n,e.$Yk=i,e.$Zk=r,e.$1k=s,e.$2k=t,e.$3k=f,e.$4k=d,e.$5k=l,e.$7k=g,e.$8k=D,e.$9k=w,e.$0k=k,e.$$k=y,e.$bl=F,e.$nl=x,e.$ol=Y,e.$ql=ce,e.$Tk=(0,p.$ni)("fileService");function $(ie){return ie.create===!0}var E;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function a(ie){const pe=ie;return!!pe&&typeof pe.onDidChange=="function"}var m;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(ie){return!!(ie.capabilities&2)}function n(ie){return!!(ie.capabilities&8)}function i(ie){return!!(ie.capabilities&131072)}function r(ie){return!!(ie.capabilities&4)}function s(ie){return!!(ie.capabilities&16)}function t(ie){return o(ie)?!!(ie.capabilities&16384):!1}function f(ie){return o(ie)?!!(ie.capabilities&32768):!1}function d(ie){return!!(ie.capabilities&65536)}function l(ie){return!!(ie.capabilities&2048)}var c;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(pe,Ce){const _=new h(pe.toString(),Ce);return w(_,Ce),_}constructor(pe,Ce){super(pe),this.code=Ce}}e.$6k=h;function g(ie,pe){return h.create(ie,pe)}function D(ie){return ie||g((0,b.localize)(0,null),c.Unknown)}function w(ie,pe){return ie.name=pe?`${pe} (FileSystemError)`:"FileSystemError",ie}function k(ie){if(!ie)return c.Unknown;if(ie instanceof h)return ie.code;const pe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!pe)return c.Unknown;switch(pe[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function y(ie){if(ie instanceof O)return ie.fileOperationResult;switch(k(ie)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var C;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class I{constructor(pe,Ce,_){this.resource=pe,this.operation=Ce,this.target=_}isOperation(pe){return this.operation===pe}}e.$_k=I;var z;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class j{static{this.a=null}constructor(pe,Ce){this.c=Ce,this.b=void 0,this.d=new P.$V(()=>{const _=u.$ti.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new P.$V(()=>{const _=u.$ti.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new P.$V(()=>{const _=u.$ti.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of pe){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==j.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(pe,...Ce){return this.h(pe,{includeChildren:!1},...Ce)}affects(pe,...Ce){return this.h(pe,{includeChildren:!0},...Ce)}h(pe,Ce,..._){if(!pe)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get(pe)||Ce.includeChildren&&this.d.value.findSuperstr(pe))||(!U||_.includes(0))&&(this.f.value.get(pe)||Ce.includeChildren&&this.f.value.findSuperstr(pe))||(!U||_.includes(2))&&(this.g.value.findSubstr(pe)||Ce.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$al=j;function F(ie,pe,Ce){return!ie||!pe||ie===pe||pe.length>ie.length?!1:(pe.charAt(pe.length-1)!==N.sep&&(pe+=N.sep),Ce?(0,L.$rf)(ie,pe):ie.indexOf(pe)===0)}class O extends Error{constructor(pe,Ce,_){super(pe),this.fileOperationResult=Ce,this.options=_}}e.$cl=O;class T extends O{constructor(pe,Ce,_,U){super(pe,Ce,U),this.fileOperationResult=Ce,this.size=_}}e.$dl=T;class B extends O{constructor(pe,Ce,_){super(pe,2,_),this.stat=Ce}}e.$el=B;var H;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var X;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$ml="";function x(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function Y(ie,pe){if(!pe.hasProvider(M.URI.from({scheme:ie.scheme})))return new Promise(Ce=>{const _=pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ie.scheme&&U.added&&(_.dispose(),Ce())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(pe){return(0,R.$5f)(pe)||(pe=0),pe<Z.KB?(0,b.localize)(1,null,pe.toFixed(0)):pe<Z.MB?(0,b.localize)(2,null,(pe/Z.KB).toFixed(2)):pe<Z.GB?(0,b.localize)(3,null,(pe/Z.MB).toFixed(2)):pe<Z.TB?(0,b.localize)(4,null,(pe/Z.GB).toFixed(2)):(0,b.localize)(5,null,(pe/Z.TB).toFixed(2))}}e.$pl=Z;function ce(ie){const pe=typeof ie=="string"||ie?.scheme===A.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===A.Schemas.file?1024*Z.MB:pe?10*Z.MB:S.$o?50*Z.MB:1024*Z.MB}}),define(ke[252],Ee([1,0,21,13,211,32]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=M;async function M(A,P,$,E,v,a){let m;try{await b(A,P,$,E,v,a)}catch(o){m=o}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&$.error(m),$.end()}}async function b(A,P,$,E,v,a){p(a);const m=await A.open(P,{create:!1});try{p(a);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$ze.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await $.write(E(r)),r=u.$ze.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&p(a)&&S(o,v));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),$.write(E(r.slice(0,f)))}}catch(o){throw(0,R.$8k)(o)}finally{await A.close(m)}}function p(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function S(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,R.$7k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=void 0,e.$Aq=p,e.$Bq=S,e.$Fq=E,e.$Gq=v,e.$Hq=a,e.$Iq=m;function p(n){return typeof n.correlationId=="number"}function S(n){return n.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const i=new N.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cq=A;class P extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$Dq=P;class $ extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$Eq=$;function E(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function a(n,i){return typeof i=="string"&&!i.startsWith(u.$dk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$hk)(a(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,b.$bl)(s.resource.fsPath,t,!R.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[253],Ee([1,0,52,3,65,4,2,7]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class p extends N.$Uc{constructor(){super(),this.a=this.B(new R.$_d),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$_d),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$_d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new b.$Kh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Aq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Kh;try{this.h.clear(),this.g.clear();for(const P of A)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const P=new N.$Tc;this.j.set(A.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(A,P),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,P){this.C(A,P)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,P),this.m.add(A.correlationId))}C(A,P){const $=this.L?.subscribe(A.path,(E,v)=>{P.isDisposed||(E?this.z(A,P):v?.type===1&&this.F(A))});return $?(P.add($),!0):!1}D(A,P){let $=!1;const E=(v,a)=>{if(P.isDisposed)return;const m=this.G(v),o=this.G(a),n=$;$=m,!m&&(o||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.watchFile)(A.path,{persistent:!1,interval:this.n},E)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}P.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.unwatchFile)(A.path,E)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const P={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([P]),this.H(P,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,P){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof P.correlationId=="number"?`${$} (correlationId: ${P.correlationId})`:$)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Rq=p}),define(ke[254],Ee([1,0,52,7,22,34,3,76,17,11,23,2,104,31,65]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,e.$Xq=m;class a extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,r,s,t,f){super(),this.r=n,this.s=i,this.t=r,this.u=s,this.w=t,this.y=f,this.c=this.B(new N.$Ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.t(d))),this.f=this.B(new N.$Bh(d=>this.L(d),a.b)),this.g=(0,v.$Iq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Iq)(this.r.path,this.r.includes):void 0,this.j=new L.$je,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await E.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await E.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$Tq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const r=new M.$Tc;return this.G(n,i,r)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,r)),r}G(n,i,r){if(i)return!1;const s=P.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(f,d)=>{if(!r.isDisposed)if(f){const l=await this.F(n,i);r.isDisposed?l.dispose():r.add(l)}else d&&(typeof d.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:s,type:d.type,cId:this.r.correlationId}])});return t?(r.add(t),!0):!1}async H(n,i,r){if(S.$j&&(0,R.$ng)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new L.$je(this.j.token);r.add((0,M.$Sc)(()=>s.dispose(!0)));const t=new M.$Tc;r.add(t);try{const f=P.URI.file(this.r.path),d=(0,p.$oc)(n),l=(0,u.watch)(n);t.add((0,M.$Sc)(()=>{l.removeAllListeners(),l.close()})),this.P(`Started watching: '${n}'`);const c=new Set;if(i)try{for(const g of await E.Promises.readdir(n))c.add(g)}catch(g){this.N(g)}if(s.token.isCancellationRequested)return;const h=new Map;t.add((0,M.$Sc)(()=>{for(const[,g]of h)g.dispose();h.clear()})),l.on("error",(g,D)=>{s.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${g}, ${D})`),this.C())}),l.on("change",(g,D)=>{if(s.token.isCancellationRequested)return;this.P(`[raw] ["${g}"] ${D}`);let w="";if(D&&(w=D.toString(),S.$j&&(w=(0,b.$5l)(w))),!(!w||g!=="change"&&g!=="rename"))if(i)if(g==="rename"){h.get(w)?.dispose();const k=setTimeout(async()=>{if(h.delete(w),w===d&&!await E.Promises.exists(n)){this.I(f);return}if(s.token.isCancellationRequested)return;const y=await this.M((0,p.$kc)(n,w));if(s.token.isCancellationRequested)return;let C;y?c.has(w)?C=0:(C=1,c.add(w)):(c.delete(w),C=2),this.J({resource:(0,A.$1g)(f,w),type:C,cId:this.r.correlationId})},a.a);h.set(w,(0,M.$Sc)(()=>clearTimeout(k)))}else{let k;c.has(w)?k=0:(k=1,c.add(w)),this.J({resource:(0,A.$1g)(f,w),type:k,cId:this.r.correlationId})}else if(g==="rename"||w!==d){const k=setTimeout(async()=>{const y=await E.Promises.exists(n);s.token.isCancellationRequested||(y?(this.J({resource:f,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(f))},a.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(k)))}else this.J({resource:f,type:0,cId:this.r.correlationId},!0)})}catch(f){s.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Gq)(n);if(i.length>0){if(this.y)for(const s of i)this.P(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(S.$k)return E.Promises.exists(n);try{const i=(0,p.$oc)(n);return(await E.Promises.readdir((0,p.$nc)(n))).some(s=>s===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Wq=a;async function m(o,n,i,r,s=512){const t=await E.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new L.$je(r);let l,c=!1;const h={path:o,excludes:[],recursive:!1},g=new a(h,void 0,D=>{(async()=>{for(const{type:w}of D)if(w===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(t,f,0,s,null);if(!k||d.token.isCancellationRequested)break;n(f.slice(0,k))}}catch(k){l=new Error(k),d.dispose(!0)}finally{c=!1}}})()});return await g.ready,i(),new Promise((D,w)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await E.Promises.close(t)}catch(k){l=new Error(k)}l?w(l):D()})})}}),define(ke[255],Ee([1,0,4,35,253,11,254,34]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class p extends L.$Rq{constructor(A){super(),this.L=A,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const P=[],$=new Set(Array.from(this.watchers));for(const E of A){const v=this.R(E);v&&(0,N.$lk)(v.request.excludes,E.excludes)&&(0,N.$lk)(v.request.includes,E.includes)?$.delete(v):P.push(E)}P.length&&this.M(`Request to start watching: ${P.map(E=>this.I(E)).join(",")}`),$.size&&this.M(`Request to stop watching: ${Array.from($).map(E=>this.I(E.request)).join(",")}`);for(const E of $)this.U(E);for(const E of P)this.S(E)}R(A){for(const P of this.watchers)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,b.$mg)(P.request.path,A.path,!R.$k))return P}S(A){const P=new M.$Wq(A,this.L,E=>this.a.fire(E),()=>this.c.fire(A),E=>this.b.fire(E),this.O),$={request:A,instance:P};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const P=new Map;for(const $ of A){const E=R.$k?$.path:$.path.toLowerCase();let v=P.get($.correlationId);v||(v=new Map,P.set($.correlationId,v)),v.has(E)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I($)}`),v.set(E,$)}return Array.from(P.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){this.O=A;for(const P of this.watchers)P.instance.setVerboseLogging(A)}M(A,P){this.O&&this.b.fire({type:"trace",message:this.Z(A,P)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,P){return P?`[File Watcher (node.js)] ${A} (${this.I(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$Yq=p}),define(ke[256],Ee([1,0,65,255]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class L extends u.$Dq{constructor(M,b,p){super(M,b,p),this.s()}r(M){return M.add(new N.$Yq(void 0))}}e.$Zq=L}),define(ke[257],Ee([1,0,15,81,194,65]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class M extends R.$Eq{constructor(p,S,A){super(p,S,A),this.s()}r(p){const S=p.add(new L.$Pq(u.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(S.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),N.ProxyChannel.toService((0,N.$7h)(S.getChannel("watcher")))}}e.$Qq=M}),define(ke[107],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class u{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$li=u}),define(ke[258],Ee([1,0,7,13,3,106,248,5,107,75]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const A=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class ${constructor(m=new p.$li,o=!1,n,i=A){this.i=m,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$mi,this),this._globalGraph=i?n?._globalGraph??new M.$3q(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,L.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const o=new class extends ${dispose(){this.h.delete(o),super.dispose()}}(m,this.j,this,this.l);return this.h.add(o),o}invokeFunction(m,...o){this.m();const n=v.traceInvocation(this.l,m);let i=!1;try{return m({get:s=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){this.m();let n,i;return m instanceof R.$ki?(n=v.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,m),i=this.o(m,o,n)),n.stop(),i}o(m,o=[],n){const i=b._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.s(t.id,n);f||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}q(m,o){if(this.i.get(m)instanceof R.$ki)this.i.set(m,o);else if(this.k)this.k.q(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const o=this.i.get(m);return!o&&this.k?this.k.r(m):o}s(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.r(m);return n instanceof R.$ki?this.u(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}u(m,o,n){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,o,n)}finally{this.t.delete(m)}}v(m,o,n){const i=new M.$3q(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new P(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const d=this.r(f.id);if(d||this.y(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof R.$ki){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:f}of t){if(this.r(f.id)instanceof R.$ki){const l=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,l)}i.removeNode(f)}}return this.r(m)}w(m,o,n=[],i,r){if(this.i.get(m)instanceof R.$ki)return this.x(m,o,n,i,r,this.g);if(this.k)return this.k.w(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(m,o,n=[],i,r,s){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(m);const f=new Map,d=new u.$Gh(()=>{const l=t.o(o,n,r);for(const[c,h]of f){const g=l[c];if(typeof g=="function")for(const D of h)D.disposable=g.apply(l,D.listener)}return f.clear(),s.add(l),l});return new Proxy(Object.create(null),{get(l,c){if(!d.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let D=f.get(c);return D||(D=new S.$5c,f.set(c,D)),(k,y,C)=>{if(d.isInitialized)return d.value[c](k,y,C);{const I={listener:[k,y,C],disposable:void 0},z=D.push(I);return(0,L.$Sc)(()=>{z(),I.disposable?.dispose()})}}}if(c in l)return l[c];const h=d.value;let g=h[c];return typeof g!="function"||(g=g.bind(h),l[c]=g),g},set(l,c,h){return d.value[c]=h,!0},getPrototypeOf(l){return o.prototype}})}else{const t=this.o(o,n,r);return s.add(t),t}}y(m,o){if(o&&console.warn(m),this.j)throw new Error(m)}}e.$4q=$;var E;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,o){return m?new v(1,o.name):v.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const n=new v(3,m.toString());return this.h.push([m,o,n]),n}stop(){const m=Date.now()-this.g;v.f+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,c]of s.h)if(l&&c){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,c);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||o)&&v.all.add(i.join(`
`))}}e.$5q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=a,e.log=o,e.$8j=g,e.$9j=D,e.$0j=w,e.$$j=k,e.$Tj=(0,E.$ni)("logService"),e.$Uj=(0,E.$ni)("loggerService");function v(){return new Date().toISOString()}function a(y){return(0,A.$5f)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Wj=m.Info;function o(y,C,I){switch(C){case m.Trace:y.trace(I);break;case m.Debug:y.debug(I);break;case m.Info:y.info(I);break;case m.Warning:y.warn(I);break;case m.Error:y.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let I="";for(let z=0;z<y.length;z++){let j=y[z];if(j instanceof Error&&(j=(0,N.$$i)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(z>0?" ":"")+j}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new L.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$Yj=i;class r extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(m.Trace)&&this.g(m.Trace,n([C,...I],!0))}debug(C,...I){this.f(m.Debug)&&this.g(m.Debug,n([C,...I]))}info(C,...I){this.f(m.Info)&&this.g(m.Info,n([C,...I]))}warn(C,...I){this.f(m.Warning)&&this.g(m.Warning,n([C,...I]))}error(C,...I){if(this.f(m.Error))if(C instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=C.stack,this.g(m.Error,n(z))}else this.g(m.Error,n([C,...I]))}flush(){}}e.$Zj=r;class s extends i{constructor(C=e.$Wj){super(),this.setLevel(C),this.g=!p.$i}trace(C,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...I):console.warn(`[main ${v()}]`,C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...I):console.error(`[main ${v()}]`,C,...I))}flush(){}}e.$1j=s;class t extends i{constructor(C=e.$Wj,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$2j=t;class f extends i{constructor(C,I=e.$Wj){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...I])}debug(C,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...I])}info(C,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...I])}warn(C,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...I])}error(C,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,N.$$i)(C,this.f(m.Trace))}flush(){}}e.$3j=f;class d extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const z of this.g)z.trace(C,...I)}debug(C,...I){for(const z of this.g)z.debug(C,...I)}info(C,...I){for(const z of this.g)z.info(C,...I)}warn(C,...I){for(const z of this.g)z.warn(C,...I)}error(C,...I){for(const z of this.g)z.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$4j=d;class l extends M.$Uc{constructor(C,I,z){if(super(),this.h=C,this.j=I,this.b=new b.$Bc,this.c=this.B(new L.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$_d),this.onDidChangeVisibility=this.g.event,z)for(const j of z)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,A.$1f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const z=this.n(C),j=(0,A.$1f)(C)?C:I?.id??(0,R.$bj)(z.toString()).toString(16);let F=this.b.get(z)?.logger;const O=I?.logLevel==="always"?m.Trace:I?.logLevel;F||(F=this.s(z,O??this.getLogLevel(z)??this.h,{...I,id:j}));const T={logger:F,info:{resource:z,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(z,T),F}n(C){return(0,A.$1f)(C)?(0,S.$1g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(P.URI.isUri(C)){const z=C,j=I,F=this.b.get(z);F&&j!==F.info.logLevel&&(F.info.logLevel=j===this.h?void 0:j,F.logger?.setLevel(j),this.b.set(F.info.resource,F),this.f.fire([z,j]))}else{this.h=C;for(const[z,j]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const z=this.m(C);z&&I!==!z.info.hidden&&(z.info.hidden=!I,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=l;class c{constructor(){this.onDidChangeLogLevel=new L.$_d().event}setLevel(C){}getLevel(){return m.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$6j=c;class h extends c{}e.$7j=h;function g(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const C=k(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Wj}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function k(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$_j=new $.$Ej("logLevel",D(m.Info))}),define(ke[259],Ee([1,0,19,7,13,4,3,17,65,12]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class A extends M.$Uc{constructor($,E){super(),this.a=$,this.b=E,this.c=this.B(new R.$_d),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$_d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$lh(0)),this.w=[],this.y=this.B(new N.$lh(0))}watch($,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n($,E):this.z($,E)}n($,E){const v={path:this.I($),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},a=(0,u.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$1)($))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,p.$Fq)(E)),E=>this.G(E),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const E of this.j)(0,p.$Bq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const E of this.j)(0,p.$Bq)(E)&&$.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,E){const v={path:this.I($),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},a=(0,u.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,p.$Fq)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,b.$ic)($.fsPath)}}e.$Jq=A}),define(ke[260],Ee([1,0,52,398,7,27,21,4,34,3,17,11,23,98,31,212,32,252,259,47,257,256]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$$i)(f)}`)}})();class t extends n.$Jq{static{this.J=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.O=new R.$Bc(c=>$.$Rg.getComparisonKey(c)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,P.$k&&(this.L|=1024)),this.L}async stat(d){try{const{stat:l,symbolicLink:c}=await v.SymlinkSupport.stat(this.I(d));return{type:this.N(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.gb(l)}}async M(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.I(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,$.$1g)(d,h.name))).type:g=this.N(h),c.push([h.name,g])}catch(g){this.a.trace(g)}})),c}catch(l){throw this.gb(l)}}N(d,l){let c;return l?.dangling?c=m.FileType.Unknown:d.isFile()?c=m.FileType.File:d.isDirectory()?c=m.FileType.Directory:c=m.FileType.Unknown,l&&(c|=m.FileType.SymbolicLink),c}async P(d){const l=this.I(d);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.O.get(d);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new L.$mh;return this.O.set(d,h),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.O.get(d)===h&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.O.delete(d)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),c=await this.P(d));const h=this.I(d);return await v.Promises.readFile(h)}catch(h){throw this.gb(h)}finally{c?.dispose()}}Q(d){t.J&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,E.$ne)(g=>M.$ze.concat(g.map(D=>M.$ze.wrap(D))).buffer);return(0,o.$yq)(this,d,h,g=>g.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.R(d)?this.S(d,(0,$.$1g)((0,$.$Zg)(d),`${(0,$.$Xg)(d)}${c.atomic.postfix}`),l,c):this.U(d,l,c)}async R(d){try{const l=this.I(d),{symbolicLink:c}=await v.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async S(d,l,c,h){const g=new S.$Tc;try{g.add(await this.P(d)),g.add(await this.P(l)),await this.U(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async U(d,l,c,h){let g;try{const D=this.I(d);if(!c.create||!c.overwrite){if(await v.Promises.exists(D)){if(!c.overwrite)throw(0,m.$7k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,m.$7k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(g,0,l,0,l.byteLength)}catch(D){throw await this.hb(d,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.Z=!0}static configureFlushOnWrite(d){t.Z=d}async open(d,l,c){const h=this.I(d);let g;(0,m.$Uk)(l)&&!c&&(g=await this.P(d));let D;try{if((0,m.$Uk)(l)&&l.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(h);k.mode&128||await v.Promises.chmod(h,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let w;if((0,m.$Uk)(l)){if(P.$i)try{await v.Promises.truncate(h,0),w="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}w||(w="w")}else w="r";D=await v.Promises.open(h,w)}catch(w){throw g?.dispose(),(0,m.$Uk)(l)?await this.hb(d,w):this.gb(w)}if(this.W.set(D,0),(0,m.$Uk)(l)&&this.Y.set(D,d),g){const w=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.X.set(D,g),w&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),w.dispose())}return D}async close(d){const l=this.X.get(d);try{if(this.W.delete(d),this.Y.delete(d)&&t.Z)try{await v.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await v.Promises.close(d)}catch(c){throw this.gb(c)}finally{l&&(this.X.get(d)===l&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.X.delete(d)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.read(d,c,h,g,D)).bytesRead}catch(k){throw this.gb(k)}finally{this.ab(d,D,w)}return w}$(d,l){return l===this.W.get(d)?null:l}ab(d,l,c){const h=this.W.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.W.set(d,h+c):this.W.delete(d)))}async write(d,l,c,h,g){return(0,L.$Hh)(()=>this.bb(d,l,c,h,g),100,3)}async bb(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.write(d,c,h,g,D)).bytesWritten}catch(k){throw await this.hb(this.Y.get(d),k)}finally{this.ab(d,D,w)}return w}async mkdir(d){try{await v.Promises.mkdir(this.I(d))}catch(l){throw this.gb(l)}}async delete(d,l){try{const c=this.I(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$kc)((0,A.$nc)(c),`${(0,A.$oc)(c)}${l.atomic.postfix}`)),await v.Promises.rm(c,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:w}=await v.SymlinkSupport.stat(c);g=D.isDirectory()&&!w}catch{}if(g)await v.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.gb(c)}}async rename(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"move",c.overwrite),await v.Promises.rename(h,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(2,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async copy(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"copy",c.overwrite),await v.Promises.copy(h,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(3,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async cb(d,l,c,h){const g=this.I(d),D=this.I(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,p.$mg)(g,D,!0)),w){if(c==="copy")throw(0,m.$7k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const y=await this.M(d);if(!y)throw(0,m.$7k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.M(l);if(C){if(!h)throw(0,m.$7k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.db(d,l,!1)}async db(d,l,c){const h=this.I(d),g=this.I(l),D=!!(this.capabilities&1024);if((0,p.$mg)(h,g,!D))return;const w=new S.$Tc;try{w.add(await this.P(d)),w.add(await this.P(l)),c&&await v.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await v.Promises.copyFile(h,g)}catch(k){if(k.code==="ENOENT"&&!c)return this.db(d,l,!0);throw this.gb(k)}finally{w.dispose()}}t(d,l,c){return new r.$Qq(h=>d(h),h=>l(h),c)}F(d,l,c){return new s.$Zq(h=>d(h),h=>l(h),c)}gb(d){if(d instanceof m.$6k)return d;let l=d,c;switch(d.code){case"ENOENT":c=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=m.FileSystemProviderErrorCode.Unknown;break;default:c=m.FileSystemProviderErrorCode.Unknown}return(0,m.$7k)(l,c)}async hb(d,l){let c=this.gb(l);if(d&&c.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.I(d));h.mode&128||(c=(0,m.$7k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$1q=t}),define(ke[261],Ee([1,0,3,12]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class L extends u.$Uc{constructor(M,b=[]){super(),this.a=new N.$4j([M,...b]),this.B(M.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$vQ=L}),define(ke[262],Ee([1,0,32,12]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function R(S,A,P,$,E){try{const v=await new Promise((m,o)=>{he(["@vscode/spdlog"],m,o)});v.setFlushOn(L.Trace);const a=await v.createAsyncRotatingLogger(S,A,P,$);return E?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(v){console.error(v)}return null}function M(S,A,P){switch(A){case N.LogLevel.Trace:S.trace(P);break;case N.LogLevel.Debug:S.debug(P);break;case N.LogLevel.Info:S.info(P);break;case N.LogLevel.Warning:S.warn(P);break;case N.LogLevel.Error:S.error(P);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(S,A){switch(A){case N.LogLevel.Trace:S.setLevel(L.Trace);break;case N.LogLevel.Debug:S.setLevel(L.Debug);break;case N.LogLevel.Info:S.setLevel(L.Info);break;case N.LogLevel.Warning:S.setLevel(L.Warning);break;case N.LogLevel.Error:S.setLevel(L.Error);break;case N.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class p extends N.$Zj{constructor(A,P,$,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,P,$,E),this.B(this.onDidChangeLogLevel(a=>{this.r&&b(this.r,a)}))}async s(A,P,$,E){const v=$?6:1,a=30/v*u.$pl.MB,m=await R(A,P,a,v,E);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(A,P){this.r?M(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kQ=p}),define(ke[138],Ee([1,0,40,214,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(p){function S(v,a){return a-v}p.compare=S;const A=Object.create(null);A[p.Error]=(0,N.localize)(0,null),A[p.Warning]=(0,N.localize)(1,null),A[p.Info]=(0,N.localize)(2,null);function P(v){return A[v]||""}p.toString=P;function $(v){switch(v){case u.default.Error:return p.Error;case u.default.Warning:return p.Warning;case u.default.Info:return p.Info;case u.default.Ignore:return p.Hint}}p.fromSeverity=$;function E(v){switch(v){case p.Error:return u.default.Error;case p.Warning:return u.default.Warning;case p.Info:return u.default.Info;case p.Hint:return u.default.Ignore}}p.toSeverity=E}(M||(e.MarkerSeverity=M={}));var b;(function(p){const S="";function A($){return P($,!0)}p.makeKey=A;function P($,E){const v=[S];return $.source?v.push($.source.replace("\xA6","\\\xA6")):v.push(S),$.code?typeof $.code=="string"?v.push($.code.replace("\xA6","\\\xA6")):v.push($.code.value.replace("\xA6","\\\xA6")):v.push(S),$.severity!==void 0&&$.severity!==null?v.push(M.toString($.severity)):v.push(S),$.message&&E?v.push($.message.replace("\xA6","\\\xA6")):v.push(S),$.startLineNumber!==void 0&&$.startLineNumber!==null?v.push($.startLineNumber.toString()):v.push(S),$.startColumn!==void 0&&$.startColumn!==null?v.push($.startColumn.toString()):v.push(S),$.endLineNumber!==void 0&&$.endLineNumber!==null?v.push($.endLineNumber.toString()):v.push(S),$.endColumn!==void 0&&$.endColumn!==null?v.push($.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}p.makeKeyOptionalMessage=P})(b||(e.IMarkerData=b={})),e.$Qt=(0,L.$ni)("markerService")}),define(ke[263],Ee([1,0,4,40,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qv=e.Severity=void 0,e.$Rv=b,e.Severity=N.default,e.$Qv=(0,L.$ni)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(P){if(P){const $=P;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var p;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class S{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$Sv=S;class A{infinite(){}done(){}total($){}worked($){}}e.$Tv=A}),define(ke[264],Ee([1,0,51]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,u.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(u,N){e(u,N,he)}};define(ke[108],Ee([1,0,7,22,3,5]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.ProgressLocation=e.$Uv=void 0,e.$Uv=(0,R.$ni)("progressService");var M;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Vv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$Wv=b;class p{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const E=this.d;this.d=()=>{E?.(),$()}}):Promise.resolve()}}e.$Xv=p;let S=class extends L.$Uc{constructor($,E){super(),this.a=new u.$Kh,E.withProgress($,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$Yv=S,e.$Yv=S=Je([We(1,e.$Uv)],S);class A extends L.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Tc)}start($){this.stop();const E=++this.a,v=new N.$je;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$Zv=A,e.$1v=(0,R.$ni)("editorProgressService")}),define(ke[38],Ee([1,0,62,18]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class L{constructor(){this.a=new Map}add(M,b){u.ok(N.$1f(M)),u.ok(N.$3f(b)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$6n=new L}),define(ke[109],Ee([1,0,4,38]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new u.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,S){this.a[L(p)]=S,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$6n.add(e.$7n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,38]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=a,e.$ko=m,e.$lo=o,e.$mo=i,e.$no=r;var S;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$$n={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const P=p.$6n.as(b.$7n.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$_d,this.onDidSchemaChange=this.i.event,this.j=new N.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(f.add(h),e.$io.test(h)){const g=this.a.get(h),D=g?.valuesSources??new Map;if(c)for(const C of Object.keys(l[h]))D.set(C,c);const w={...g?.value||{},...l[h]};this.a.set(h,{source:c,value:w,valuesSources:D});const k=(0,M.$4i)(h),y={type:"object",default:w,description:R.localize(1,null,k),$ref:e.$fo,defaultDefaultValue:w,source:L.$1f(c)?void 0:c,defaultValueSource:c};d.push(...a(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:c});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),g=L.$1f(l)?l:l?.id,D=L.$1f(h?.source)?h?.source:h?.source?.id;if(g===D)if(f.add(c),this.a.delete(c),e.$io.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const c in l.properties){f.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,f=!0,d,l,c=3,h){c=L.$0f(t.scope)?c:t.scope;const g=t.properties;if(g)for(const w in g){const k=g[w];if(f&&i(w,k)){delete g[w];continue}if(k.source=d,k.defaultDefaultValue=g[w].default,this.w(w,k),e.$io.test(w)?k.scope=void 0:(k.scope=L.$0f(k.scope)?c:k.scope,k.restricted=L.$0f(k.restricted)?!!l?.includes(w):k.restricted),g[w].hasOwnProperty("included")&&!g[w].included){this.f[w]=g[w],delete g[w];continue}else this.d[w]=g[w],g[w].policy?.name&&this.e.set(g[w].policy.name,w);!g[w].deprecationMessage&&g[w].markdownDeprecationMessage&&(g[w].deprecationMessage=g[w].markdownDeprecationMessage),h.add(w)}const D=t.allOf;if(D)for(const w of D)this.p(w,f,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$_n.properties[t]=f,f.scope){case 1:e.$ao.properties[t]=f;break;case 2:e.$bo.properties[t]=f;break;case 6:e.$co.properties[t]=f;break;case 3:e.$do.properties[t]=f;break;case 4:e.$eo.properties[t]=f;break;case 5:e.$eo.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$_n.properties[t],f.scope){case 1:delete e.$ao.properties[t];break;case 2:delete e.$bo.properties[t];break;case 6:delete e.$co.properties[t];break;case 3:delete e.$do.properties[t];break;case 4:case 5:delete e.$eo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$fo};this.w(f,d),e.$_n.properties[f]=d,e.$ao.properties[f]=d,e.$bo.properties[f]=d,e.$co.properties[f]=d,e.$do.properties[f]=d,e.$eo.properties[f]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=t,e.$ao.patternProperties[e.$ho]=t,e.$bo.patternProperties[e.$ho]=t,e.$co.patternProperties[e.$ho]=t,e.$do.patternProperties[e.$ho]=t,e.$eo.patternProperties[e.$ho]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,c=d?.source;L.$8f(l)&&(l=f.defaultDefaultValue,c=void 0),L.$8f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=c}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$ho=`^(${E})+$`,e.$io=new RegExp(e.$ho);function a(s){const t=[];if(e.$io.test(s)){let f=v.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=v.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;p.$6n.add(e.$$n.Configuration,n);function i(s,t){return s.trim()?e.$io.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[265],Ee([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=i;function E(f){return Object.isFrozen(f)?f:b.$Un(f)}class v{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$2i)(this.contents,d):this.contents}inspect(d,l){const c=this;return{get value(){return E(c.rawConfiguration.getValue(d))},get override(){return l?E(c.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return E(l?c.rawConfiguration.override(l).getValue(d):c.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:g,identifiers:D,keys:w}of c.rawConfiguration.overrides){const k=new v(g,w).getValue(d);k!==void 0&&h.push({identifiers:D,value:k})}return h.length?E(h):void 0}}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,A.$2i)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$Tn(this.contents),c=b.$Tn(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of d)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(l,D.contents);for(const w of D.overrides){const[k]=c.filter(y=>u.$ub(y.identifiers,w.identifiers));k?(this.h(k.contents,w.contents),k.keys.push(...w.keys),k.keys=u.$Mb(k.keys)):c.push(b.$Tn(w))}for(const w of D.keys)h.indexOf(w)===-1&&h.push(w)}return new v(l,h,c,g.every(D=>D instanceof v)?void 0:g)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[h];const D=l[h];D&&(typeof g=="object"&&typeof D=="object"?(g=b.$Tn(g),this.h(g,D)):g=D),c[h]=g}return new v(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&p.$3f(d[c])&&p.$3f(l[c])){this.h(d[c],l[c]);continue}d[c]=b.$Tn(l[c])}}i(d){let l=null,c=null;const h=g=>{g&&(c?this.h(c,g):c=b.$Tn(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?l=g.contents:g.identifiers.includes(d)&&h(g.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$1i)(this.contents,d),P.$io.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>u.$ub(c.identifiers,(0,P.$jo)(d))),1))}j(d,l,c){(0,A.$Zi)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),P.$io.test(d)&&this.overrides.push({identifiers:(0,P.$jo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Yi)(this.contents[d],h=>console.error(h))})}}e.$oo=v;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!p.$0f(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:g,restricted:D,hasExcludedProperties:w}=this.h(d,l);this.b=new v(c,h,g,w?[d]:void 0),this.c=D||[]}g(d){let l={},c=null,h=[];const g=[],D=[];function w(y){Array.isArray(h)?h.push(y):c!==null&&(h[c]=y)}const k={onObjectBegin:()=>{const y={};w(y),g.push(h),h=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const y=[];w(y),g.push(h),h=y,c=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(y,C,I)=>{D.push({error:y,offset:C,length:I})}};if(d)try{L.$Hn(d,k),l=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(d,l){const c=$.$6n.as(P.$$n.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const g=(0,A.$Yi)(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(d),w=this.j(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:g,keys:D,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const D={},w=[];for(const k in d)if(P.$io.test(k)&&c){const y=this.i(d[k],l,!1,h);D[k]=y.raw,g=g||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=l[k],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(k),!h.exclude?.includes(k)&&(h.include?.includes(k)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&y?.restricted))?D[k]=d[k]:g=!0}return{raw:D,restricted:w,hasExcludedProperties:g}}j(d,l){const c=[];for(const h of Object.keys(d))if(P.$io.test(h)){const g={};for(const D in d[h])g[D]=d[h][D];c.push({identifiers:(0,P.$jo)(h),keys:Object.keys(g),contents:(0,A.$Yi)(g,l)})}return c}}e.$po=a;class m extends R.$Uc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new N.$_d),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&c.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=m;class o{constructor(d,l,c,h,g,D,w,k,y,C,I,z,j){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=g,this.f=D,this.g=w,this.h=k,this.i=y,this.j=C,this.k=I,this.l=z,this.m=j}get value(){return E(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,c,h,g=new v,D=new v,w=new M.$Bc,k=new v,y=new M.$Bc){this.c=d,this.d=l,this.f=c,this.g=h,this.h=g,this.i=D,this.j=w,this.l=k,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new v,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),g=this.t(l.resource,c),D=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const k of h.overrides)for(const y of k.identifiers)h.getOverrideValue(d,y)!==void 0&&w.add(y);return new o(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,g||void 0,D)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:g,removed:D}=s(this.c,d);l=[...h,...g,...D]}for(const h of l)for(const g of(0,P.$jo)(h)){const D=this.c.getKeysForOverrideIdentifier(g),w=d.getKeysForOverrideIdentifier(g),k=[...w.filter(y=>D.indexOf(y)===-1),...D.filter(y=>w.indexOf(y)===-1),...D.filter(y=>!b.$Xn(this.c.override(g).getValue(y),d.override(g).getValue(y)))];c.push([g,k])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=s(this.d,d),g=[...l,...c,...h];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.applicationConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.localUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.remoteUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.workspaceConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:g,removed:D,overrides:w}=s(c,l),k=[...h,...g,...D];return(k.length||!c)&&this.updateFolderConfiguration(d,l),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:g,overrides:D}=s(l,void 0);return{keys:[...c,...h,...g],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const g=this.m.get(d);g&&(c=c.merge(g))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:g}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),g=this.w(d.user),D=this.w(d.workspace),w=d.folders.reduce((k,y)=>(k.set(S.URI.revive(y[0]),this.w(y[1])),k),new M.$Bc);return new n(l,c,h,g,new v,D,w,new v,new M.$Bc)}static w(d){return new v(d.contents,d.keys,d.overrides)}}e.$ro=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(g=>d.add(g)),h.overrides.forEach(([g,D])=>{const w=(0,M.$yc)(l,g,new Set);D.forEach(k=>w.add(k))});const c=[];return l.forEach((h,g)=>c.push([g,[...h.values()]])),{keys:[...d.values()],overrides:c}}class r{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const D of g)this.affectedKeys.add(D);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const g=h+c.length;if(g>=this.d.length)return!1;const D=this.d.charCodeAt(g);if(D!==this.b&&D!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,k=this.g.getValue(d,l,this.h);return!b.$Xn(w,k)}return!0}}e.$to=r;function s(f,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],D=f?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const k=w.filter(y=>!D.includes(y));for(const y of k)g.push([y,d.getKeysForOverrideIdentifier(y)])}if(f){const k=D.filter(y=>!w.includes(y));for(const y of k)g.push([y,f.getKeysForOverrideIdentifier(y)])}if(d&&f){for(const k of D)if(w.includes(k)){const y=t({contents:f.getOverrideValue(void 0,k)||{},keys:f.getKeysForOverrideIdentifier(k)},{contents:d.getOverrideValue(void 0,k)||{},keys:d.getKeysForOverrideIdentifier(k)});g.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:c,updated:h,overrides:g}}function t(f,d){const l=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],c=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],h=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const D=(0,A.$2i)(d.contents,g),w=(0,A.$2i)(f.contents,g);b.$Xn(D,w)||h.push(g)}}return{added:l,removed:c,updated:h}}}),define(ke[266],Ee([1,0,21,4,3,82]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksb=e.$isb=e.$hsb=void 0,e.$jsb=b;const M=(S,A,P)=>{const $=new Uint8Array(16);for(let a=0;a<16;a++)$[a]=Math.round(Math.random()*256);const E=(0,u.$Te)(u.$ze.wrap($));return[`GET ws://localhost${S}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$hsb=M,e.$isb=u.$ze.fromString(`\r
\r
`);async function b(S,A,P,$,E){S.write(u.$ze.fromString((0,e.$hsb)(A,P,$)));const v=new L.$Tc;try{return await new Promise((a,m)=>{let o;v.add(S.onData(n=>{o?o=u.$ze.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$isb);if(i===-1)return;a(S),S.pauseData();const r=o.slice(i+e.$isb.byteLength);r.byteLength&&E.onData.fire(r)})),v.add(S.onClose(n=>m(n??new Error("socket closed")))),v.add(S.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw S.dispose(),a}finally{v.dispose()}}class p extends L.$Uc{constructor(A,P){super(),this.g=A,this.a=this.B(new N.$ce),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$_d),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event($=>this.a.fire($))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ksb=p}),define(ke[66],Ee([1,0,13,5]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=S,e.$yl=(0,N.$ni)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=R;class M{constructor(P,$){this.host=P,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class p extends u.$bb{static isNotAvailable(P){return P instanceof p&&P._code===b.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof p&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof p&&P._code===b.NoResolverFound}static isInvalidAuthority(P){return P instanceof p&&P._code===b.InvalidAuthority}static isHandled(P){return P instanceof p&&P.isHandled}constructor(P,$=b.Unknown,E){super(P),this._message=P,this._code=$,this._detail=E,this.isHandled=$===b.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Bl=p;function S(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(ke[267],Ee([1,0,7,21,22,13,4,3,15,59,39,30,82,66]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Hl=D,e.$Il=w,e.$Jl=y;const v=30*1e3;var a;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(_){const U=new L.$je;return setTimeout(()=>U.cancel(),_),U.token}function n(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ne=new L.$je;return _.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$gh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(_,U){const ne=new i(U);return ne.registerDisposable(_.onControlMessage(be=>{const De=JSON.parse(be.toString()),oe=Y(De);oe?ne.reject(oe):ne.resolve(De)})),ne.promise}function s(_,U,ne,be,De,oe,ae,re){const K=new i(re),te=A.$8d.create(!1);return _.info(`Creating a socket (${ae})...`),S.mark(`code/willCreateSocket/${oe}`),U.connect(ne,be,De,ae).then(le=>{K.didTimeout?(S.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${ae}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(S.mark(`code/didCreateSocketOK/${oe}`),_.info(`Creating a socket (${ae}) was successful after ${te.elapsed()} ms.`),K.resolve(le))},le=>{S.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${ae}) returned an error after ${te.elapsed()} ms.`),_.error(le),K.reject(le)}),K.promise}function t(_,U){const ne=new i(U);return _.then(be=>{ne.didTimeout||ne.resolve(be)},be=>{ne.didTimeout||ne.reject(be)}),ne.promise}async function f(_,U,ne,be){const De=pe(_,U);_.logService.trace(`${De} 1/6. invoking socketFactory.connect().`);let oe;try{oe=await s(_.logService,_.remoteSocketFactoryService,_.connectTo,p.$Ag.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${_.reconnectionToken}`,be)}catch(le){throw _.logService.error(`${De} socketFactory.connect() failed or timed out. Error:`),_.logService.error(le),le}_.logService.trace(`${De} 2/6. socketFactory.connect() was successful.`);let ae,re;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(oe,null),ae=_.reconnectionProtocol,re=!1):(ae=new $.$bi({socket:oe}),re=!0),_.logService.trace(`${De} 3/6. sending AuthRequest control message.`);const K=await t(_.signService.createNewMessage((0,P.$Jg)()),be),te={type:"auth",auth:_.connectionToken||"00000000000000000000",data:K.data};ae.sendControl(N.$ze.fromString(JSON.stringify(te)));try{const le=await r(ae,n(be,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(_.logService.trace(`${De} 4/6. received SignRequest control message.`),!await t(_.signService.validate(K,le.signedData),be)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Ae=await t(_.signService.sign(le.data),be),me={type:"connectionType",commit:_.commit,signedData:Ae,desiredConnectionType:U};return ne&&(me.args=ne),_.logService.trace(`${De} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(N.$ze.fromString(JSON.stringify(me))),{protocol:ae,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(_.logService.error(`${De} the handshake timed out. Error:`),_.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${De} received error control message when negotiating connection. Error:`),_.logService.error(le)),re&&x(ae),le}}async function d(_,U,ne,be){const De=Date.now(),oe=pe(_,U),{protocol:ae,ownsProtocol:re}=await f(_,U,ne,be),K=new i(be);return K.registerDisposable(ae.onControlMessage(te=>{const le=JSON.parse(te.toString()),de=Y(le);de?(_.logService.error(`${oe} received error control message when negotiating connection. Error:`),_.logService.error(de),re&&x(ae),K.reject(de)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${Ce(De)}!`),K.resolve({protocol:ae,firstMessage:le}))})),K.promise}async function l(_,U){const{protocol:ne}=await d(_,1,void 0,U);return{protocol:ne}}async function c(_,U,ne){const{protocol:be,firstMessage:De}=await d(_,2,U,ne),oe=De&&De.debugPort;return{protocol:be,debugPort:oe}}async function h(_,U,ne){const be=Date.now(),De=pe(_,3),{protocol:oe}=await f(_,3,U,ne);return _.logService.trace(`${De} 6/6. handshake finished, connection is up and running after ${Ce(be)}!`),oe}async function g(_,U,ne){const{connectTo:be,connectionToken:De}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:be,connectionToken:De,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function D(_,U,ne){return k(_,async be=>{const{protocol:De}=await l(be,L.CancellationToken.None);return new H(_,U,ne,be.reconnectionToken,De)})}async function w(_,U){return k(_,async ne=>{const{protocol:be,debugPort:De}=await c(ne,U,L.CancellationToken.None);return new X(_,U,ne.reconnectionToken,be,De)})}async function k(_,U){for(let be=1;;be++)try{const De=(0,P.$Jg)(),oe=await g(_,De,null);return await U(oe)}catch(De){if(be<5)_.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(De);else throw _.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(De),B.triggerPermanentFailure(0,0,E.$Bl.isHandled(De)),De}}async function y(_,U,ne){const be=await g(_,(0,P.$Jg)(),null);return await h(be,{host:U,port:ne},L.CancellationToken.None)}function C(_){return(0,u.$ah)(U=>new Promise((ne,be)=>{const De=setTimeout(ne,_*1e3);U.onCancellationRequested(()=>{clearTimeout(De),ne()})}))}var I;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class z{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$Kl=z;class j{constructor(U,ne,be,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=be,this.c=De,this.type=1}skipWait(){this.c.cancel()}}e.$Ll=j;class F{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=2}}e.$Ml=F;class O{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=4}}e.$Nl=O;class T{constructor(U,ne,be,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.handled=De,this.type=3}}e.$Ol=T;class B extends b.$Uc{static triggerPermanentFailure(U,ne,be){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=be,this.j.forEach(De=>De.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ne,be,De,oe){super(),this.t=U,this.u=ne,this.reconnectionToken=be,this.protocol=De,this.w=oe,this.m=this.B(new M.$_d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(De.onSocketClose(ae=>{const re=ie(this.t,this.reconnectionToken,!0);ae?ae.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(De.onSocketTimeout(ae=>{const re=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const ae=B.j.indexOf(this);ae>=0&&B.j.splice(ae,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const De=be<ne.length?ne[be]:ne[ne.length-1];try{if(De>0){const ae=C(De);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),De,ae)),this.u.logService.info(`${U} waiting for ${De} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const oe=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${oe.connectTo}...`),await this.G(oe,o(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(oe){if(oe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(E.$Bl.isTemporarilyNotAvailable(oe)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((oe.code==="ETIMEDOUT"||oe.code==="ENETUNREACH"||oe.code==="ECONNREFUSED"||oe.code==="ECONNRESET")&&oe.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((0,R.$4)(oe)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if(oe instanceof E.$Bl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,E.$Bl.isHandled(oe));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,be){this.w?B.triggerPermanentFailure(U,ne,be):this.D(U,ne,be)}D(U,ne,be){this.m.fire(new T(this.reconnectionToken,U,ne,be)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Pl=B;class H extends B{constructor(U,ne,be,De,oe){super(1,U,De,oe,!0),this.client=this.B(new $.$_h(oe,{remoteAuthority:ne,clientId:be},U.ipcLogger))}async G(U,ne){await l(U,ne)}}e.$Ql=H;class X extends B{constructor(U,ne,be,De,oe){super(2,U,be,De,!1),this.H=ne,this.debugPort=oe}async G(U,ne){await c(U,this.H,ne)}}e.$Rl=X;function x(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function Y(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Z(_,U){for(;_.length<U;)_+=" ";return _}function ce(_,U){return`[remote-connection][${Z(m(_),13)}][${U.substr(0,5)}\u2026]`}function ie(_,U,ne){return`${ce(_,U)}[${ne?"reconnect":"initial"}]`}function pe(_,U){return`${ie(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function Ce(_){return`${Date.now()-_} ms`}}),define(ke[86],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=N,e.$zm=L,e.$Am=R,e.$Bm=M;function N(p){return p.scheme===u.Schemas.vscodeRemote?p.authority:void 0}function L(p){if(!p)return;const S=p.indexOf("+");return S<0?p:p.substr(0,S)}function R(p){const{host:S,port:A}=b(p);if(typeof A>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:A}}function M(p,S){let{host:A,port:P}=b(p);return typeof P>"u"&&(P=S),{host:A,port:P}}function b(p){const S=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const A=p.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=p.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:p,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=R,e.$Lm=P,e.$Mm=$,e.$Nm=E,e.$Om=v,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return u.$qf(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Im=p;class S{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(p.toKey(m))}delete(m){return this.c.delete(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}}e.$Jm=S;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(p.toKey(m))}get(m){return this.c.get(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}set(m,o){this.c.set(p.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=A;function P(a){return $(a)}function $(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function E(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function v(a,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.$zm)(m)}`;return!!a.activationEvents?.includes(o)}return!1}e.$Pm=(0,N.$ni)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const p of M){const S=this.readActivationEvents(p);S.length>0&&(b[N.$Im.toKey(p.identifier)]=S)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let p=0;p<b.length;p++)b[p]==="onUri"&&(b[p]=`onUri:${N.$Im.toKey(M.identifier)}`);if(!M.contributes)return b;for(const p in M.contributes){const S=this.a.get(p);if(!S)continue;const A=M.contributes[p],P=Array.isArray(A)?A:[A];try{S(P,b)}catch($){(0,u.$1)($)}}return b}}e.$_F=L,e.$aG=new L}),define(ke[268],Ee([1,0,3,5]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0,e.$Dl=(0,N.$ni)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,u.$Sc)(()=>{const p=this.a[M]?.indexOf(b);typeof p=="number"&&p>=0&&this.a[M]?.splice(p,1)})}b(M){return(this.a[M.type]||[]).find(p=>p.supports(M))}connect(M,b,p,S){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,p,S)}}e.$El=L}),define(ke[269],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(u.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$B0b=u}),define(ke[110],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=void 0,e.$Fl="signService",e.$Gl=(0,u.$ni)(e.$Fl)}),define(ke[141],Ee([1,0,269]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class N extends u.$B0b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>he(["vsda"],R,M))}}e.$xcc=N}),define(ke[270],Ee([1,0,11,51,30]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=M,e.$8o=b;function R(p){if(u.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function M(p,S,A,P,$,E,v,a,m){const o=Object.create(null);o["common.machineId"]=E,o["common.sqmId"]=v,o.sessionID=(0,L.$Jg)()+Date.now(),o.commitHash=P,o.version=$,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=N.$ec,o["common.nodeArch"]=A,o["common.product"]=m||"desktop",a&&(o["common.msftInternal"]=a);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=R(S);return r&&(o["common.platformDetail"]=r),o}function b(p){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const A=S.toLowerCase();return p.some(P=>A===P)}}),define(ke[271],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,u.$ni)("telemetryService"),e.$Tl=(0,u.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,270,271]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=A,e.$ep=P,e.$fp=$,e.$gp=E,e.$hp=a,e.$ip=o,e.$jp=n,e.$kp=s;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$9o=b;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=p,e.$$o=new p;class S{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$_o=S,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function P(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const f=t.getValue(M.$1l),d=t.getValue(M.$2l);if(t.getValue(M.$3l)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const f={},d={},l={};m(t,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const h=l[c];typeof h=="number"?d[c]=h:typeof h=="boolean"?d[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),f[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[c]=h)}return{properties:f,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,L.$zm)(t);return v.has(f)?f:"other"}function m(t,f,d=0,l){if(t)for(const c of Object.getOwnPropertyNames(t)){const h=t[c],g=l?l+c:c;Array.isArray(h)?f[g]=(0,u.$Yn)(h):h instanceof Date?f[g]=h.toISOString():(0,N.$3f)(h)?d<2?m(h,f,d+1,g+"."):f[g]=(0,u.$Yn)(h):f[g]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,R.$8o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const D of f)for(;;){const w=D.exec(t);if(!w)break;l.push([w.index,D.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const D=h.exec(t);if(!D)break;const w=l.some(([k,y])=>D.index<y&&k<h.lastIndex);!c.test(D[0])&&!w&&(d+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Vn)(t,d=>{if(d instanceof b||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const c of f)l=l.replace(c,"");return l=r(l),l}})}}),define(ke[272],Ee([1,0,14,137,25,11,2,13,51,87]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=A,e.$np=v,e.$op=a,e.$pp=m,e.$qp=o,e.$rp=n,e.$sp=i,e.$tp=r,e.$vp=s,e.$wp=f;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$lf)(d.id,l.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,c,h)}static parse(l){const c=P.exec(l);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$mp=$;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=E.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function o(d,l){return m(a(d??L.$Em,l))}function n(d,l){const c=[],h=g=>{for(const D of c)if(D.some(w=>A(l(w),l(g))))return D;return null};for(const g of d){const D=h(g);D?D.push(g):c.push([g])}return c}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new S.$9o(d.identifier.id),name:new S.$9o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$up=new L.$Im("pprice.better-merge");function s(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&c.every(D=>!A(D.identifier,{id:g}))){const D=d.filter(w=>A(w.identifier,{id:g}));D.length===1&&(c.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,l){if(!R.$k)return!1;let c;try{c=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,b.$0)(g))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const c=await t(d,l),h=(0,N.$So)(c?"alpine":R.$u,p.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[273],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=u,e.$as=N,e.$bs=L,e.$cs=R,e.$ds=M,e.$es=b;function u(p){return[...p.entries()]}function N(p){return p?[...p.entries()]:[]}function L(p){return new Map(p)}function R(p){return new Map(p??[])}function M(p){return Array.from(p.entries()).map(S=>[S[0],u(S[1].map),N(S[1].descriptionMap)])}function b(p){return new Map(p.map(S=>[S[0],{map:L(S[1]),descriptionMap:R(S[2])}]))}}),define(ke[274],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Csb=void 0;class u{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const b=R(p=>{const S=typeof p=="string"?p:p.data;let A=this.a.get(L);if(A){A.data.push(S);return}const P=setTimeout(()=>this.flushBuffer(L),M);A={data:[S],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(L),b.dispose()}},this.a.set(L,A)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Csb=u}),define(ke[275],Ee([1,0,7,78,99,57,4,18,2,215,109,38]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$6w=e.$5w=e.$4w=e.$3w=e.$2w=e.IconFontDefinition=e.IconContribution=e.$Yw=void 0,e.$Zw=m,e.$1w=o,e.$Yw={IconContribution:"base.contributions.icons"};var $;(function(s){function t(f,d){let l=f.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const c=a.getIcon(l.id);if(!c)return;l=c.defaults}return l}s.getDefinition=t})($||(e.IconContribution=$={}));var E;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=c=>(0,b.$1f)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,b.$1f)(c.format)&&(0,b.$1f)(c.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(c=>({format:c.format,location:p.URI.parse(c.location)}))}}s.fromJSONObject=f})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new M.$_d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const c=this.b[t];if(c){if(d&&!c.description){c.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return c}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(c,h)=>c.id.localeCompare(h.id),f=c=>{for(;R.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(c=>this.b[c]);for(const c of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|${R.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of l.filter(h=>!R.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|`);return d.join(`
`)}}const a=new v;P.$6n.add(e.$Yw.IconContribution,a);function m(s,t,f,d){return a.registerIcon(s,t,f,d)}function o(){return a}function n(){const s=(0,L.$Ij)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}n(),e.$2w="vscode://schemas/icons";const i=P.$6n.as(A.$7n.JSONContribution);i.registerSchema(e.$2w,a.getIconSchema());const r=new u.$zh(()=>i.notifySchemaChanged(e.$2w),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$3w=m("widget-close",N.$Mj.close,(0,S.localize)(2,null)),e.$4w=m("goto-previous-location",N.$Mj.arrowUp,(0,S.localize)(3,null)),e.$5w=m("goto-next-location",N.$Mj.arrowDown,(0,S.localize)(4,null)),e.$6w=R.ThemeIcon.modify(N.$Mj.sync,"spin"),e.$7w=R.ThemeIcon.modify(N.$Mj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=S,e.$5v=P,e.$6v=$,e.$8v=E,e.$0v=v,e.$$v=a,e.$2v=(0,R.$ni)("tunnelService"),e.$3v=(0,R.$ni)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var p;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(p||(e.TunnelPrivacyId=p={}));function S(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=P(N.URI.parse(s));if(t)return t}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.$7v.indexOf(n)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$9v.indexOf(n)>=0}function a(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=m;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$_d,this.onTunnelOpened=this.a.event,this.b=new u.$_d,this.onTunnelClosed=this.b.event,this.c=new u.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||E(i))&&(i=e.$7v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(h,r,s,t,f,d,l,c);return g?g.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];E(i)?(s.push(...e.$7v),s.push(...e.$9v)):v(i)&&s.push(...e.$9v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!P(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const c=s;this.j.add(c);const h=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(h):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==p.Private:void 0,protocol:l},w=i.forwardPort(D,g);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),w}};e.$aw=o,e.$aw=o=Je([We(0,M.$Tj),We(1,L.$Ti)],o)}),define(ke[276],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=void 0,e.$rl=(0,u.$ni)("IUriIdentityService")}),define(ke[277],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bw=void 0,e.$bw=(0,u.$ni)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[278],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=N,e.$kM=L,e.$lM=R,e.$mM=M,e.$nM=b;function N(p){return p.scheme!==u.Schemas.file&&p.scheme!==u.Schemas.vscodeRemote}function L(p){if(p.folders.length)return p.folders.every(S=>N(S.uri))?p.folders[0].uri:void 0;if(p.configuration&&N(p.configuration))return p.configuration}function R(p){return L(p)?.scheme}function M(p){return L(p)?.authority}function b(p){return L(p)!==void 0}}),define(ke[41],Ee([1,0,217,17,77,23,2,5,15]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=S,e.$yi=A,e.$Bi=P,e.$Ci=$,e.$Di=E,e.$Ei=a,e.$Fi=m,e.$Ii=i,e.$Ni=r,e.$Oi=s,e.$Qi=t,e.$Ri=f,e.$Si=d,e.$wi=(0,b.$ni)("contextService");function S(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.uri)}function A(l){return typeof l?.id=="string"&&!S(l)&&!$(l)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function P(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$oc)(l)}:c?e.$zi:e.$Ai;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.configPath)}function E(l){const c=l;if(c?.uri)return{id:c.id,uri:M.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function a(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(l){const c=l;return!!(c&&typeof c=="object"&&M.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class o{constructor(c,h,g,D,w){this.h=c,this.j=g,this.k=D,this.l=w,this.c=L.$ti.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=L.$ti.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=o;class n{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$1g)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=n;function i(l){return new n({uri:l,index:0,name:(0,R.$Wg)(l)},{uri:l.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,u.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function r(l,c){return R.$Rg.isEqualOrParent(l,c.untitledWorkspacesHome)}function s(l){let c;return M.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===p.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Pi}function f(l,c){return!r(l,c)&&!s(l)}function d(l){return(typeof l=="string"?(0,N.$pc)(l):(0,R.$Yg)(l))===e.$Ki}}),define(ke[279],Ee([1,0,56,4,3,23,2,216,136,32,5,12,41,27,276,7,30,14,18]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$tl=e.ProfileResourceType=void 0,e.$sl=r,e.$ul=s,e.$vl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&M.URI.isUri(c.location)&&M.URI.isUri(c.globalStorageHome)&&M.URI.isUri(c.settingsResource)&&M.URI.isUri(c.keybindingsResource)&&M.URI.isUri(c.tasksResource)&&M.URI.isUri(c.snippetsHome)&&M.URI.isUri(c.extensionsResource))}e.$tl=(0,A.$ni)("IUserDataProfilesService");function s(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:c}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,c,h,g,D,w){return{id:l,name:c,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:w&&D?.useDefaultFlags?.globalState?w.globalStorageHome:(0,R.$1g)(h,"globalStorage"),settingsResource:w&&D?.useDefaultFlags?.settings?w.settingsResource:(0,R.$1g)(h,"settings.json"),keybindingsResource:w&&D?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,R.$1g)(h,"keybindings.json"),tasksResource:w&&D?.useDefaultFlags?.tasks?w.tasksResource:(0,R.$1g)(h,"tasks.json"),snippetsHome:w&&D?.useDefaultFlags?.snippets?w.snippetsHome:(0,R.$1g)(h,"snippets"),extensionsResource:w&&D?.useDefaultFlags?.extensions?w.extensionsResource:(0,R.$1g)(h,"extensions.json"),cacheHome:(0,R.$1g)(g,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,g,D){super(),this.t=c,this.u=h,this.w=g,this.y=D,this.f=!0,this.h=this.B(new N.$_d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$_d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$_d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$_d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$1g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$1g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$1f)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,R.$Xg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const g=new E.$Bc,D=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[k,y]of Object.entries(w.workspaces)){const C=M.URI.parse(k),I=h.find(z=>z.id===y);I&&g.set(C,I)}if(w.emptyWindows)for(const[k,y]of Object.entries(w.emptyWindows)){const C=h.find(I=>I.id===y);C&&D.set(k,C)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:g,emptyWindows:D}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",g=new RegExp(`${(0,o.$5e)(h)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const y=g.exec(k.name),C=y?parseInt(y[1]):0;D=C>D?C:D}const w=`${h} ${D+1}`;return this.createProfile((0,u.$bj)((0,m.$Jg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,h,g){return this.createProfile((0,u.$bj)((0,m.$Jg)()).toString(16),c,h,g)}async createProfile(c,h,g,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,h,g);return D&&await this.setProfileForWorkspace(D,w),w}async F(c,h,g){if(!(0,n.$1f)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{if(this.profiles.find(C=>C.name===h||C.id===c))throw new Error(`Profile with ${h} name already exists`);const k=t(c,h,(0,R.$1g)(this.profilesHome,c),this.g,g,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(C){y.push(C)}}),await a.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===c.id);if(!g)throw new Error(`Profile '${c.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const g=[];this.m.fire({profile:h,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,S.$$k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,g)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,$.$xi)(c)?c.uri:(0,$.$Ci)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,g){const D=[...this.profiles,...c],w=[];this.s.profiles=[];for(let k of D)k.isDefault||h.some(y=>k.id===y.id)||(k=g.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):w.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,h,g)}J(c,h,g){this.h.fire({added:c,removed:h,updated:g,all:this.profiles})}L(c,h,g){g=h?.isTransient?!0:g,g||this.L(c,void 0,!0);const D=this.G(c),w=g?this.s:this.C;M.URI.isUri(D)?(w.workspaces.delete(D),h&&w.workspaces.set(D,h)):(w.emptyWindows.delete(D),h&&w.emptyWindows.set(D,h)),g||this.M()}M(){const c={};for(const[g,D]of this.C.workspaces.entries())c[g.toString()]=D.id;const h={};for(const[g,D]of this.C.emptyWindows.entries())h[g.toString()]=D.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},g=this.D();if(c.workspaces)for(const[w,k]of Object.entries(c.workspaces)){const y=M.URI.parse(k);h[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}const D={};if(c.emptyWindows)for(const[w,k]of Object.entries(c.emptyWindows)){const y=M.URI.parse(k);D[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$wl=f,e.$wl=f=Je([We(0,p.$ui),We(1,S.$Tk),We(2,v.$rl),We(3,P.$Tj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$xl=d}),define(ke[280],Ee([1,0,7,4,3,59,18,195,5,279]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Tp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Rp=e.$Qp=e.$Pp=void 0,e.$Sp=E,e.$Up=a,e.$Wp=o,e.$Pp="__$__isNewStorageMarker",e.$Qp="__$__targetStorageMarker",e.$Rp=(0,p.$ni)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function E(n){const i=n.get(e.$Qp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ce),this.c=this.B(new N.$ce),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$_d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$zh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return N.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$Dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Qp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,M.$0f)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Qp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Qp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Pp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,S.$sl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||a(r)&&a(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Tp=v;function a(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Vp=m;async function o(n,i,r,s,t,f){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,c=new Map;n.forEach((C,I)=>{l.set(I,C),c.set(I,d(C))});const h=new Map,g=new Map;i.forEach((C,I)=>{h.set(I,C),g.set(I,d(C))});const D=new Map,w=new Map;r.forEach((C,I)=>{D.set(I,C),w.set(I,d(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const k=[];if(l.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(c),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((I,z)=>{C.push({key:z,value:I})}),console.table(C),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((C,I)=>{y.push({key:I,value:C})}),console.table(y),console.groupEnd(),console.log(w)}}),define(ke[111],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class u{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Yjc=u}),define(ke[60],Ee([1,0,15,23,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class R{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Pg(b=>{const p=this.b.get(b.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(b,p){p===null?this.b.delete(b.scheme):this.b.set(b.scheme,p)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$4jc=R,e.$5jc=(0,L.$ni)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=void 0,e.$nP=(0,u.$ni)("IExtHostInitDataService")}),define(ke[281],Ee([1,0,223,12,261,28]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let M=class extends L.$vQ{constructor(p,S,A){const P=A.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",$=A.remote.isRemote?(0,u.localize)(0,null):p?(0,u.localize)(1,null):(0,u.localize)(2,null);super(S.createLogger(P,{name:$}))}};e.$$lc=M,e.$$lc=M=Je([We(1,N.$Uj),We(2,R.$nP)],M)}),define(ke[282],Ee([1,0,7]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class N{constructor(M,b,p){this.h=new Map,this.a=M,this.b=b,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new u.$zh(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of S.values())A.complete()}catch(A){for(const P of S.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let p=this.f[M];return typeof p>"u"&&(p=b),p}update(M,b){this.f[M]=b;const p=this.h.get(M);if(p!==void 0)return p.p;const S=new u.$Kh;return this.h.set(M,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$Jkc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Kkc=L}),define(ke[283],Ee([1,0,4,2]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class L{constructor(M){this.c=M,this.a=new u.$_d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$_d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,p,S){const P=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(b.value,p,S);this.b.fire(P)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$ylc=L}),define(ke[20],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0,e.$0O=(0,u.$ni)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$$O=N}),define(ke[284],Ee([1,0,25,4]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class L{#e;constructor(M,b){this.b=new N.$_d,this.onDidChange=this.b.event,this.a=u.$Im.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Tkc=L}),define(ke[67],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0,e.$hkc=(0,u.$ni)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$ikc=N}),define(ke[285],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnb=L,e.$Unb=M;class N{constructor(){this.buffers=[]}add(p){let S=this.buffers.indexOf(p);return S<0&&(S=this.buffers.length,this.buffers.push(p)),S}}function L(b,p){if(p.serializeBuffersForPostMessage){const S=new N,P=JSON.stringify(b,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const a=R(v);if(a)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:a,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),$=S.buffers.map(E=>{const v=new Uint8Array(E);return u.$ze.wrap(v)});return{message:P,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,p){const S=p.map($=>{const E=new ArrayBuffer($.byteLength);return new Uint8Array(E).set($.buffer),E}),A=p.length?($,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:a}=v,m=S[a];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(b,A),arrayBuffers:S}}}),define(ke[286],Ee([1,0,287,399,400,63,2,12,401]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=A;const S=!1;function A(i,r,s,t,f,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return p.LogLevel.Trace;case b.LogLevel.Debug:return p.LogLevel.Debug;case b.LogLevel.Info:return p.LogLevel.Info;case b.LogLevel.Warning:return p.LogLevel.Warning;case b.LogLevel.Error:return p.LogLevel.Error;case b.LogLevel.Off:return p.LogLevel.Off;default:return k(w)}function k(y){return t.error("Unknown log level",y),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,p.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(k)}return(await Promise.all(w)).flat()},env:process.env},g=(0,p.createProxyResolver)(h),D=P(h,g);return a(s,D)}function P(i,r){return{http:Object.assign(u,(0,p.createHttpPatch)(i,u,r)),https:Object.assign(N,(0,p.createHttpPatch)(i,N,r)),net:Object.assign(R,(0,p.createNetPatch)(i,R)),tls:Object.assign(L,(0,p.createTlsPatch)(i,L))}}function $(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}function E(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}const v=new Map;function a(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,c,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(M.URI.file(c.filename));let D=v.get(g);if(D||v.set(g,D={}),!D[l]){const w=r[l];D[l]={...w}}return D[l]}})}async function m(i,r,s,t,f,d,l,c){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const g=l||h,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,D,f),D.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((z,j)=>{he(["kerberos"],z,j)}),k=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[288],Ee([1,0,133]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new u.$pn(N(R))}}),define(ke[142],Ee([1,0,233,18,2,3,5,38,32,15,47,187,40]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$yF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$pF=e.EditorInputCapabilities=e.$oF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0,e.$fF=a,e.$gF=m,e.$hF=o,e.$iF=n,e.$jF=i,e.$kF=r,e.$lF=s,e.$mF=t,e.$nF=f,e.$qF=D,e.$rF=k,e.$sF=y,e.$tF=C,e.$uF=I,e.$vF=z,e.$wF=j,e.$xF=X,e.$zF=Z,e.$AF=ie,e.$BF=pe,e.$CF=Ce,e.$aF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$cF="workbench.editor.sidebysideEditor",e.$dF="workbench.editors.textDiffEditor",e.$eF="workbench.editors.binaryResourceDiffEditor";var E;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function a(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(_,U,ne){for(const be of ne.visibleEditorPanes)if(be.group.id===U&&_.matches(be.input))return be.getViewState()}function n(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.resource)}function i(_){if(D(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function r(_){if(D(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(_){if(D(_)||i(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(D(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function f(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var d;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class c{constructor(){this.a=new Map}registerSource(U,ne){let be=this.a.get(U);return be||(be={source:U,label:ne},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$oF=new c;var h;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class g extends R.$Uc{}e.$pF=g;function D(_){return _ instanceof g}function w(_){const U=_;return L.URI.isUri(U?.preferredResource)}function k(_){const U=_;return D(U?.primary)&&D(U?.secondary)}function y(_){const U=_;return D(U?.modified)&&D(U?.original)}function C(_,U,ne,be,De){return Ce(be,[(0,P.$0i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const oe={...ne,limits:{size:Number.MAX_VALUE}};_.openEditor(U,oe)}}),(0,P.$0i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>De.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(_){return D(_?.editor)}function z(_){const U=_;return I(_)&&U?.group!==void 0}function j(_){const U=_;return typeof U?.groupId=="number"&&D(U.editor)}var F;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var O;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ne){if(!U)return;if(f(U))return e.$yF.getOriginalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:De,secondary:oe}=this.a(U);if(De&&oe){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(De,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getOriginalUri(De,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?De:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=w(U)?U.preferredResource:U.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}a(U){return k(U)||s(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ne){if(!U)return;if(f(U))return e.$yF.getCanonicalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:De,secondary:oe}=this.a(U);if(De&&oe){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(De,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getCanonicalUri(De,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?De:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}b(U,ne){if(Array.isArray(ne)){if(ne.some(be=>U.scheme===be))return U}else if(ne===U.scheme)return U}}var H;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(H||(e.EditorCloseMethod=H={}));function X(_,U,ne,be){if(!_.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ne===H.MOUSE||ne===H.KEYBOARD;case"mouse":return ne===H.MOUSE;case"keyboard":return ne===H.KEYBOARD}return!1}e.$yF=new B;var x;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(U){const ne=this.a=U.get(M.$mi);for(const[be,De]of this.c)this.e(be,De,ne);this.c.clear()}e(U,ne,be){const De=be.createInstance(ne);this.d.set(U,De)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$_f)(this.b)}registerEditorSerializer(U,ne){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ne,this.a):this.c.set(U,ne),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$6n.add(e.$aF.EditorFactory,new Y);async function Z(_,U,ne){return!_||!_.length?[]:await Promise.all(_.map(async be=>{const De=L.URI.revive(be.fileUri);if(!De){ne.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(De)){ne.info("Cannot resolve the path because it cannot be handled",be);return}let ae=be.exists,re=be.type;if(typeof ae!="boolean"||typeof re!="number")try{re=(await U.stat(De)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ae=!0}catch(te){ne.error(te),ae=!1}if(!ae&&be.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",be);return}if(re===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return ae?{resource:De,options:K}:{resource:De,options:K,forceUntitled:!0}}))}var ce;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ie(_){const U=_;if(!U)return!1;const ne=U;if(ne.modified)return ie(ne.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function pe(_){return(0,A.$_i)(_)}function Ce(_,U,ne){const be=(0,A.$aj)(_,U);return be.forceMessage=ne?.forceMessage,be.forceSeverity=ne?.forceSeverity,be.allowDialog=ne?.allowDialog,be}}),define(ke[289],Ee([1,0,4,234,5,3,27,38,19,24,78,275]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IF=e.ViewContentGroups=e.$GF=e.ViewContainerLocation=e.Extensions=e.$FF=e.$EF=e.$DF=void 0,e.$HF=v,e.$DF="views",e.$EF=(0,N.localize)(0,null),e.$FF=(0,P.$Zw)("default-view-icon",A.$Mj.window,(0,N.localize)(1,null));var $;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var E;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$GF=[0,1,2];function v(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$_d),this.onDidRegister=this.c.event,this.f=this.B(new u.$_d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const g=d;return g.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$yc)(this.g,l,[]).push(g),c?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$6n.add($.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,d){const l=f.group??m.More,c=d.group??m.More;return l!==c?l.localeCompare(c):(f.order??5)-(d.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$_d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$_d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$_d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$_d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,R.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,g]of l)this.n.add(d,g),c.set(h,(0,R.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(o)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,N.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],g=[];for(const D of c)d.includes(D)?h.push(D):g.push(D);return h.length&&(g.length?this.m.set(l,g):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$6n.add($.ViewsRegistry,new n),e.$IF=(0,L.$ni)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,S.$Wn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JF=s;class t extends Error{constructor(d){super((0,N.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$KF=t}),define(ke[290],Ee([1,0,235,37]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0,e.$OF=new N.$Ej("chatSessionResponseVote","",{type:"string",description:(0,u.localize)(0,null)}),e.$PF=new N.$Ej("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,u.localize)(1,null)}),e.$QF=new N.$Ej("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,u.localize)(2,null)}),e.$RF=new N.$Ej("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,u.localize)(3,null)}),e.$SF=new N.$Ej("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,u.localize)(4,null)}),e.$TF=new N.$Ej("chatResponse",!1,{type:"boolean",description:(0,u.localize)(5,null)}),e.$UF=new N.$Ej("chatRequest",!1,{type:"boolean",description:(0,u.localize)(6,null)}),e.$VF=new N.$Ej("chatInputHasText",!1,{type:"boolean",description:(0,u.localize)(7,null)}),e.$WF=new N.$Ej("chatInputHasFocus",!1,{type:"boolean",description:(0,u.localize)(8,null)}),e.$XF=new N.$Ej("inChatInput",!1,{type:"boolean",description:(0,u.localize)(9,null)}),e.$YF=new N.$Ej("inChat",!1,{type:"boolean",description:(0,u.localize)(10,null)}),e.$ZF=new N.$Ej("hasChatProvider",!1,{type:"boolean",description:(0,u.localize)(11,null)}),e.$1F=new N.$Ej("chatCursorAtTop",!1),e.$2F=new N.$Ej("chatInputHasAgent",!1),e.$3F=new N.$Ej("chatLocation",void 0)}),define(ke[291],Ee([1,0,4,45,3,37,5,290]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=e.$ZG=e.ChatAgentLocation=void 0;var p;(function(P){P.Panel="panel",P.Terminal="terminal",P.Notebook="notebook",P.Editor="editor"})(p||(e.ChatAgentLocation=p={})),function(P){function $(E){switch(E){case"panel":return P.Panel;case"terminal":return P.Terminal;case"notebook":return P.Notebook;case"editor":return P.Editor}return P.Panel}P.fromRaw=$}(p||(e.ChatAgentLocation=p={})),e.$ZG=(0,M.$ni)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor($){this.f=$,this.b=[],this.d=new u.$_d,this.onDidChangeAgents=this.d.event,this.e=b.$ZF.bindTo(this.f)}registerAgent($,E){if(this.getAgent($))throw new Error(`Agent already registered: ${JSON.stringify($)}`);const a=this,m=E.slashCommands;E={...E,get slashCommands(){return m.filter(n=>!n.when||a.f.contextMatchesRules(R.$lj.deserialize(n.when)))}};const o={data:E};return this.b.push(o),(0,L.$Sc)(()=>{this.b=this.b.filter(n=>n!==o),this.d.fire(void 0)})}registerAgentImplementation($,E){const v=this.g($);if(!v)throw new Error(`Unknown agent: ${JSON.stringify($)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify($)}`);return v.data.isDefault&&this.e.set(!0),v.impl=E,this.d.fire(new A(v.data,E)),(0,L.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent($,E){const v={data:$,impl:E};return this.b.push(v),this.d.fire(new A($,E)),(0,L.$Sc)(()=>{this.b=this.b.filter(a=>a!==v),this.d.fire(void 0)})}updateAgent($,E){const v=this.g($);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify($)} registered`);v.data.metadata={...v.data.metadata,...E},this.d.fire(new A(v.data,v.impl))}getDefaultAgent($){return this.getActivatedAgents().find(E=>!!E.isDefault&&E.locations.includes($))}getContributedDefaultAgent($){return this.getAgents().find(E=>!!E.isDefault&&E.locations.includes($))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),$=>!!$.data.metadata.isSecondary)?.data}g($){return this.b.find(E=>E.data.id===$)}getAgent($){return this.g($)?.data}getAgents(){return this.b.map($=>$.data)}getActivatedAgents(){return Array.from(this.b.values()).filter($=>!!$.impl).map($=>new A($.data,$.impl))}getAgentsByName($){return this.getAgents().filter(E=>E.name===$)}async invokeAgent($,E,v,a,m){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return await o.impl.invoke(E,v,a,m)}async getFollowups($,E,v,a,m){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return o.impl?.provideFollowups?o.impl.provideFollowups(E,v,a,m):[]}};e.$1G=S,e.$1G=S=Je([We(0,R.$Fj)],S);class A{constructor($,E){this.b=$,this.d=E}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke($,E,v,a){return this.d.invoke($,E,v,a)}async provideFollowups($,E,v,a){return this.d.provideFollowups?this.d.provideFollowups($,E,v,a):[]}provideWelcomeMessage($){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage($)}provideSampleQuestions($){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions($)}}e.$2G=A}),define(ke[292],Ee([1,0,2,29,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.$0F=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$8F=R,e.$9F=M;function R(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof u.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$ht.isIRange)}function M(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(R)}var b;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var p;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$0F=(0,L.$ni)("IChatService"),e.$$F="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,7,236]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new u.$_d,this.o=new u.$_d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,p,S,A){const P={command:b};if(p&&Object.keys(p).length>0&&(P.arguments=p),this.u("request",P),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const E=this.f.get(P.seq);if(E){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};E(v)}},A)}return S&&this.f.set(P.seq,S),P.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,p){return b.type!=="event"||p.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$oh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const p=b,S=this.f.get(p.request_seq);S&&(this.f.delete(p.request_seq),S(p));break}}}}u(b,p){p.type=b,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((p,S)=>b.set(S,p)),await(0,N.$oh)(500),b.forEach((p,S)=>{p({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$oob=R}),define(ke[293],Ee([1,0,2,237,37,5]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$fJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$dJ=e.MemoryRangeType=e.State=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=void 0,e.$cJ=p,e.$eJ=A,e.$3H="workbench.view.debug",e.$4H="workbench.debug.variablesView",e.$5H="workbench.debug.watchExpressionsView",e.$6H="workbench.debug.callStackView",e.$7H="workbench.debug.loadedScriptsView",e.$8H="workbench.debug.breakPointsView",e.$9H="workbench.debug.disassemblyView",e.$0H="workbench.panel.repl",e.$$H="workbench.panel.repl.view",e.$_H=new L.$Ej("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$aI=new L.$Ej("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$bI=new L.$Ej("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$cI="debugUx",e.$dI=new L.$Ej(e.$cI,"default",{type:"string",description:N.localize(3,null)}),e.$eI=new L.$Ej("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$fI=new L.$Ej("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$gI=new L.$Ej("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$hI=new L.$Ej("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$iI=new L.$Ej("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$jI=new L.$Ej("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$kI=new L.$Ej("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$lI=new L.$Ej("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$mI=new L.$Ej("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$nI=new L.$Ej("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$oI=new L.$Ej("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$pI=new L.$Ej("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$qI=new L.$Ej("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$rI=new L.$Ej("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$sI=new L.$Ej("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$tI=new L.$Ej("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$uI=new L.$Ej("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$vI=new L.$Ej("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$wI=new L.$Ej("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$xI=new L.$Ej("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$yI=new L.$Ej("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$zI=new L.$Ej("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$AI=new L.$Ej("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$BI=new L.$Ej("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$CI=new L.$Ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$DI=new L.$Ej("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$EI=new L.$Ej("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$FI=new L.$Ej("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$GI=new L.$Ej("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$HI=new L.$Ej("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$II=new L.$Ej("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$JI=new L.$Ej("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$KI=new L.$Ej("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$LI=new L.$Ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$MI=new L.$Ej("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$NI=new L.$Ej("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$OI=new L.$Ej("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$PI=new L.$Ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$QI=new L.$Ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$RI=new L.$Ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$SI=new L.$Ej("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$TI=new L.$Ej("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$UI=new L.$Ej("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$VI=new L.$Ej("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$WI=new L.$Ej("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$XI=new L.$Ej("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$YI=new L.$Ej("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$ZI=new L.$Ej("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$1I=new L.$Ej("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$2I=new L.$Ej("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$3I=new L.$Ej("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$4I=new L.$Ej("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$5I=new L.$Ej("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$6I=new L.$Ej("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$7I=new L.$Ej("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$8I=new L.$Ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$9I=new L.$Ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$0I=M,e.$$I="editor.contrib.debug",e.$_I="editor.contrib.breakpoint",e.$aJ="debug",e.$bJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function p(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$dJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$fJ=(0,R.$ni)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:u.URI.revive(r.iconPath.light),dark:u.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(n||(e.IDebugVisualization=n={}))}),define(ke[294],Ee([1,0,14,2,17,24,15,29,22,19]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eH=void 0,e.$5G=P,e.$6G=$,e.$7G=E,e.$8G=v,e.$9G=a,e.$0G=m,e.$$G=o,e.$_G=i,e.$aH=t,e.$bH=f,e.$cH=l,e.$dH=h;const A=/{([^}]+)}/g;function P(D,w,k){return D.replace(A,function(y,C){return w&&C.length>0&&C[0]!=="_"?y:k&&k.hasOwnProperty(C)?k[C]:y})}function $(D){const w={};for(const k of Object.keys(D))k.startsWith("!")||(w[k]=D[k]);return w}function E(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||E(D.parentSession))}function v(D){let w=D.configuration.type;if(w)return w==="vslsShare"&&(w=D.configuration.adapterProxy.configuration.type),(0,u.$qf)(w,"extensionhost")||(0,u.$qf)(w,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,w,k){let y,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=I.exec(D);){const j=z.index+1,F=j+z[0].length;if(j<=w&&F>=k){y=z[0],C=j;break}}if(y){const j=/\w+/g;let F=null;for(;(F=j.exec(y))&&!(F.index+1+C+F[0].length>=k););F&&(y=y.substring(0,j.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function o(D,w,k,y){if(D.evaluatableExpressionProvider.has(w)){const C=D.evaluatableExpressionProvider.ordered(w),I=(0,S.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(w,k,y??p.CancellationToken.None)}catch{return}})));if(I.length>0){let z=I[0].expression;const j=I[0].range;return z||(z=w.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:z}}}else{const C=w.getLineContent(k.lineNumber),{start:I,end:z}=m(C,k.column,k.column),j=C.substring(I-1,z);return{matchingExpression:j,range:new b.$ht(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,L.$jc)(D.path))return N.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const w=N.URI.revive(D.path);if(w)return w.scheme===M.Schemas.file?w.fsPath:w.toString()}return D.path}function t(D,w){const k=w?r:s,y=(0,R.$Tn)(D);return d(y,(C,I)=>{C&&I&&(I.path=k(I))}),y}function f(D,w){const k=w?r:s,y=(0,R.$Tn)(D);return d(y,(C,I)=>{!C&&I&&(I.path=k(I))}),y}function d(D,w){switch(D.type){case"event":{const k=D;switch(k.event){case"output":w(!1,k.body.source);break;case"loadedSource":w(!1,k.body.source);break;case"breakpoint":w(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":w(!0,k.arguments.source);break;case"breakpointLocations":w(!0,k.arguments.source);break;case"source":w(!0,k.arguments.source);break;case"gotoTargets":w(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>w(!1,y));break;case"scopes":k.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(C=>w(!1,C.location));break;default:break}break}}}function l(D){return D.filter(w=>!w.presentation?.hidden).sort((w,k)=>w.presentation?k.presentation?w.presentation.group?k.presentation.group?w.presentation.group!==k.presentation.group?w.presentation.group.localeCompare(k.presentation.group):c(w.presentation.order,k.presentation.order):-1:k.presentation.group?1:c(w.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function c(D,w){return typeof D!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:D-w}async function h(D,w){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(k!=="none"&&(await w.saveAll(),k==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const g=(D,w)=>!D||!w?D===w:D.name===w.name&&D.path===w.path&&D.sourceReference===w.sourceReference;e.$eH=g}),define(ke[295],Ee([1,0,53,63,24,17,11,14,31,238,143]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$hmc=e.$gmc=e.$fmc=e.$emc=void 0;class P extends A.$oob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(P.b);for(const s of r){const t=s.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$emc=P;class $ extends P{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$fmc=$;class E extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$gmc=E;class v extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$hmc=v;class a extends P{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$jc(o)){if(!await p.Promises.exists(o))throw new Error(S.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.$Wn(L.$Tn(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(S.localize(2,null,n[0]));this.x=f}else throw new Error(S.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$jc(o.program)?i.program=o.program:i.program=R.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=a.A(r.win,n)),r.winx86&&(i.winx86=a.A(r.winx86,n)),r.windows&&(i.windows=a.A(r.windows,n)),r.osx&&(i.osx=a.A(r.osx,n)),r.linux&&(i.linux=a.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$qf(h.type,n)).forEach(h=>{const g=a.A(h,l.extensionLocation.fsPath);i=L.$Wn(i,g,l.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$imc=a}),define(ke[296],Ee([1,0,53,34,11]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=M,e.$kmc=p;function R(S,A){return new Promise((P,$)=>{let E="";const v=u.spawn(S,A);v.pid&&v.stdout.on("data",a=>{E+=a.toString()}),v.on("error",a=>{$(a)}),v.on("close",a=>{P(E)})})}async function M(S){if(S)if(L.$i){const A=await new Promise((P,$)=>{he(["@vscode/windows-process-tree"],P,$)});return new Promise(P=>{A.getProcessTree(S,$=>{P(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(S)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(b||(b={}));function p(S,A,P,$){S=S.trim().toLowerCase();let E;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?E=1:S.indexOf("cmd.exe")>=0?E=0:S.indexOf("bash")>=0?E=2:L.$i?E=0:E=2;let v,a=" ";switch(E){case 1:if(v=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),$){const m=(0,N.$sg)($);m&&(a+=`${m}:; `),a+=`cd ${v($)}; `}if(A.length>0){const m=A.shift(),o=P?m:v(m);a+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of A)a+=n==="<"||n===">"||P?n:v(n),a+=" "}break;case 0:if(v=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),$){const m=(0,N.$sg)($);m&&(a+=`${m}: && `),a+=`cd ${v($)} && `}for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break;case 2:{v=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),$&&(a+=`cd ${v($)} ; `);for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break}}return a}}),define(ke[297],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$sK=(0,u.$ni)("INotebookExecutionService")}),define(ke[298],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iib=e.$hib=e.ProxyKernelState=e.$gib=void 0,e.$gib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$hib=(0,u.$ni)("INotebookKernelService"),e.$iib=(0,u.$ni)("INotebookKernelHistoryService")}),define(ke[299],Ee([1,0,3,29,200,100]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Vb=void 0;class M extends u.$Uc{constructor(p,S,A){super(),this._source=p,this.b=S,this.c=A,this.a=void 0}f(p){const S=p.getLineCount();return new N.$ht(1,1,S,this.g(p,S))}g(p,S){if(S<1||S>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const p=new L.$JC;p.acceptChunk(this._source);const S=p.finish(!0),{textBuffer:A,disposable:P}=S.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const S=new L.$JC;S.acceptChunk(p);const A=S.finish(!0),{textBuffer:P,disposable:$}=A.create(1);return this.B($),P})),this.a}findInInputs(p){const A=new R.$xC(p,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(p){const A=new R.$xC(p,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const $=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if($.length!==0)return{textBuffer:P,matches:$}}).filter(P=>!!P):[]}}e.$$Vb=M}),define(ke[68],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(R){R.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,b,p=M.parent){if(M._isRoot)return new L([b]);const S=[M.id];for(let A=p;A&&A.id!==b;A=A.parent)S.push(A.id);return S.push(b),new L(S.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new L(M.split("\0"))}static join(M,b){return new L([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:L.isChild(M,b)?2:L.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$yL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$GL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$FL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$EL=e.$DL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$CL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$BL=e.$AL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$zL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$zL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var p;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$AL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$BL=S;var A;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:L.$ht.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var P;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(P||(e.TestMessageType=P={}));var $;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})($||(e.ITestErrorMessage=$={}));const E=(O,T)=>`${T?"s":"e"}${O}`;e.$CL=E;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var a;(function(O){O.serialize=T=>T.type===0?$.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?$.deserialize(T,B):v.deserialize(T,B)})(a||(e.ITestMessage=a={}));var m;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(a.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(H=>a.deserialize(T,H))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(O,T)=>O+o+T;e.$DL=n;const i=O=>{const T=O.indexOf(o);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$EL=i;var r;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?L.$ht.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:R.$yL.root(B.item.extId),expand:B.expand,item:r.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$ht.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$FL=d;var l;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(H=>m.deserialize(T,H)),retired:!0})})(l||(e.TestResultItem=l={}));var c;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(c||(e.ICoverageCount=c={}));var h;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function g(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$gt.isIPosition(O.location)?N.$gt.lift(O.location):L.$ht.lift(O.location):void 0,O}e.$GL=3;var w;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(w||(e.DetailType=w={}));var k;(function(O){O.serialize=T=>T.type===0?C.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?C.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var y;(function(O){O.serialize=g,O.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(O){O.serialize=g,O.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var I;(function(O){O.serialize=T=>({...g(T),branches:T.branches?.map(y.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(I||(e.IStatementCoverage=I={}));var z;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var j;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:f.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class F{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const H of T)switch(H.op){case 0:this.l(t.deserialize(this.k,H.item),B);break;case 1:this.o(f.deserialize(H.item),B);break;case 3:this.p(H.itemId,B);break;case 5:this.q(H.itemId);break;case 4:this.updatePendingRoots(H.amount);break;case 6:this.c.set(H.tag.id,H.tag);break;case 7:this.c.delete(H.id);break}B.complete?.()}l(T,B){const H=R.$yL.parentId(T.item.extId)?.toString();let X;if(!H)X=this.w(T),this.g.add(X),this.f.set(T.item.extId,X);else if(this.f.has(H)){const x=this.f.get(H);x.children.add(T.item.extId),X=this.w(T,x),this.f.set(T.item.extId,X)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(X),T.expand===2&&this.h++,X}o(T,B){const H=this.f.get(T.extId);if(H)return T.expand!==void 0&&(H.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$FL)(H,T),B.update?.(H),H}p(T,B){const H=this.f.get(T);if(!H)return;const X=R.$yL.parentId(H.item.extId)?.toString();X?this.f.get(X).children.delete(H.item.extId):this.g.delete(H);const x=[[T]];for(;x.length;)for(const Y of x.pop()){const Z=this.f.get(Y);Z&&(x.push(Z.children),this.f.delete(Y),B.remove?.(Z,Z!==H),Z.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$HL=F}),define(ke[112],Ee([1,0,7,4,3,62,89,68]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.TestItemEventOp=void 0;var p;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const S=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),$=(n,i)=>{let r;for(const[s,t]of P)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class E extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$zh(()=>this.flushDiff(),200)),this.g=this.B(new N.$_d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$FL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$FL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(b.$yL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=b.$yL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,c=$(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.resolveBarrier=void 0,f.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete c.tags),this.w(f,{op:4,update:c})),this.I(i,f,r);for(const[g,D]of d)this.s.getChildren(i).get(D.id)||this.O(b.$yL.joinToString(s,D.id));const h=f.expandLevels;h!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(s.toString(),h))}),this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,M.$DL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$DL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$DL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(b.$yL.joinToString(i.fullId,f.id),r);(0,u.$_g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$mh;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$mh,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$_g)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$yL.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$ZO=E;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$1O=v;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2O=a;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$3O=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new a(c.id);const h=i(c).controllerId;if(h!==n.controllerId)throw new m(c.id,h,n.controllerId);if(f.has(c.id))throw new v(c.id);f.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$4O=o}),define(ke[144],Ee([1,0,112]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;const N=new WeakMap,L=(M,b)=>{const p={controllerId:b};return N.set(M,p),p};e.$5O=L;const R=M=>{const b=N.get(M);if(!b)throw new u.$2O(M?.id||"<unknown>");return b};e.$6O=R}),define(ke[113],Ee([1,0,15,2]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cxb=e.$Bxb=e.$Axb=void 0,e.$Dxb=L,e.$Exb=M,e.$Axb="vscode-cdn.net",e.$Bxb=`vscode-resource.${e.$Axb}`,e.$Cxb=`'self' https://*.${e.$Axb}`;function L(b,p){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:(p&&p.authority&&p.isRemote&&b.scheme===u.Schemas.file&&(b=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:p.authority,path:b.path})),N.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$Bxb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,p=>{const S=p.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?p:"-"+S.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(p,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[300],Ee([1,0,4,3,113]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class R{constructor(b,p,S){this.d=b,this.e=p,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const A=p.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,p,S,A,P){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){$=i;break}if(!$)throw new Error("not a visible editor");const E=this,v=this.a++,a=new u.$_d,m=new u.$_d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$Dxb)(i,E.f)}get cspSource(){return L.$Cxb}set options(i){this.b=i,E.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return E.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=p,this.height=S,this.webview=o,this.onDidDispose=m.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(v,$.id,$.value.document.uri,p+1,S,A||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(b){const p=this.c.get(b);p&&p.inset.dispose()}$onDidReceiveMessage(b,p){this.c.get(b)?.onDidReceiveMessage.fire(p)}}e.$fkc=R}),define(ke[145],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.$OL=void 0,e.$OL="__",e.$PL=(0,u.$ni)("IAuthenticationService"),e.$QL=(0,u.$ni)("IAuthenticationExtensionsService")}),define(ke[301],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.VariableKind=e.$VP=void 0,e.$VP=(0,u.$ni)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,b){super(b),this.variable=M}}e.$WP=L}),define(ke[302],Ee([1,0,17,51,18,24,11,103,241,301,14]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,a,m){this.h=new Map,this.a=E,this.b=v,this.g=a,m&&(this.c=m.then(o=>this.i(o)))}i(E){if(M.$i){const v=Object.create(null);return Object.keys(E).forEach(a=>{v[a.toLowerCase()]=E[a]}),v}return E}resolveWithEnvironment(E,v,a){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,a)}async resolveAsync(E,v){const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,v)}async j(E,v,a,m){const o=R.$Tn(v);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,o,a,m)}async resolveAnyAsync(E,v,a){return this.j(E,v,a)}async resolveAnyMap(E,v,a){const m=new Map;return{newConfig:await this.j(E,v,a,m),resolvedVariables:m}}resolveWithInteractionReplace(E,v,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,a,m,o){if(L.$1f(a))return this.m(E,v,a,m,o);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(E,v,n,m,o)));if(L.$3f(a)){const n=Object.create(null),i=await Promise.all(Object.keys(a).map(async r=>[await this.m(E,v,r,m,o),await this.l(E,v,a[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return a}m(E,v,a,m,o){return(0,A.$if)(a,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let r=await this.o(E,n,i,v,m);return o?.set(i,r),r!==n&&L.$1f(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(E,v,r,m,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,a,m,o){let n;const i=a.split(":");i.length>1&&(a=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,b.$mw)(d);throw new S.$WP(f,(0,p.localize)(0,null,v))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$mw)(l)}throw new S.$WP(f,(0,p.localize)(1,null,v,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new S.$WP(f,(0,p.localize)(2,null,v,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new S.$WP(f,(0,p.localize)(3,null,v)):new S.$WP(f,(0,p.localize)(4,null,v))};switch(a){case"env":if(n){if(E.env){const f=E.env[M.$i?n.toLowerCase():n];if(L.$1f(f))return f}return""}throw new S.$WP(S.VariableKind.Env,(0,p.localize)(5,null,v));case"config":if(n){const f=this.a.getConfigurationValue(m,n);if(L.$0f(f))throw new S.$WP(S.VariableKind.Config,(0,p.localize)(6,null,v,n));if(L.$3f(f))throw new S.$WP(S.VariableKind.Config,(0,p.localize)(7,null,v,n));return f}throw new S.$WP(S.VariableKind.Config,(0,p.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,o,"command");case"input":return this.p(S.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new S.$WP(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,v,n));return this.n(f.extensionLocation)}throw new S.$WP(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,v));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,b.$mw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.$mw)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$mw)(u.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new S.$WP(S.VariableKind.UserHome,(0,p.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new S.$WP(S.VariableKind.LineNumber,(0,p.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new S.$WP(S.VariableKind.SelectedText,(0,p.localize)(13,null,v))}case"file":return r(S.VariableKind.File);case"fileWorkspaceFolder":return s(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(S.VariableKind.RelativeFile)),r(S.VariableKind.RelativeFile)):r(S.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(S.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(S.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(S.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(S.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(S.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${a}:${n}`:a;return this.p(S.VariableKind.Unknown,v,f,o,void 0)}catch{return v}}}}p(E,v,a,m,o){if(a&&m){const n=o===void 0?m[a]:m[o+":"+a];if(typeof n=="string")return n;throw new S.$WP(E,(0,p.localize)(14,null,v))}return v}}e.$_P=P}),define(ke[146],Ee([1,0,5,142]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FD=void 0,e.$GD=S,e.$HD=$,e.$ID=E,e.$FD=(0,u.$ni)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var p;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function S(v){const a=v;return(0,N.$qF)(a?.editor)&&(0,N.$qF)(a?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function $(v){const a=v;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[303],Ee([1,0,5,146]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$ND=L,e.$JD=(0,u.$ni)("editorService"),e.$KD=-1,e.$LD=-2,e.$MD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$HD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=void 0,e.$0L=(0,u.$oi)(N.$ui)}),define(ke[148],Ee([1,0,25,4,17,3,7]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=e.$C$b=e.$B$b=e.$A$b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$A$b=b;class p{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$_d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new u.$Km,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=p.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const c=i.getArcs(d);for(let h=0;h<c.length;h++)if(!l.has(c[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Km;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Im.toKey(d.identifier),u.$Im.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$B$b=p;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$C$b=S;class A{constructor(n){this.d=new E,this.c=new p(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$D$b=A;class P extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$E$b=P;class ${constructor(n){this.name=n;const i=(0,M.$gh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function a(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=L.$hc.basename(o.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new u.$Jm(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[304],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=b,e.$fn=p;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[N.ENV_KEY]=this.pipeName}}e.$bn=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[L.ENV_KEY]="1"}}e.$cn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$dn=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function b(A,P){M(P),A.serialize(P)}function p(A){if(A[N.ENV_KEY])return S(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return S(A,new L);if(A[R.ENV_KEY])return S(A,new R);throw new Error("No connection information defined in environment!")}function S(A,P){return M(A),P}}),define(ke[114],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Qm=M,e.$Rm=b;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(S){const A=u.$ze.alloc(1);switch(S){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(S,A){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var p;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$pP=e.$oP=void 0,e.$qP=a;let E=class extends P.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new N.$_d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$_d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:p.$bp,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Vj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$zm)((0,p.$hp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$oP=E,e.$oP=E=Je([We(0,R.$nP),We(1,L.$Uj)],E);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new N.$_d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,p.$kp)(n,[]),this.c&&(n=(0,S.$Wn)(n,this.c)),this.b||(n=(0,S.$Wn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,p.$kp)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$pP=v;function a(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$rP=(0,u.$ni)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,272,140,25,5]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.ActivationKind=e.$xG=e.$wG=e.$tG=e.ExtensionHostStartup=e.$sG=e.$rG=e.$qG=e.$pG=void 0,e.$uG=$,e.$vG=E,e.$yG=o,e.$zG=n,e.$pG=Object.freeze({identifier:new M.$Im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qG="extensions.webWorker",e.$rG=(0,b.$ni)("extensionService");class p{constructor(s){this.dependency=s}}e.$sG=p;var S;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$aG.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],c=[],h=[],g=P(this.d),D=P(t),w=(z,j)=>z.extensionLocation.toString()===j.extensionLocation.toString()||z.isBuiltin===j.isBuiltin||z.isUserBuiltin===j.isUserBuiltin||z.isUnderDevelopment===j.isUnderDevelopment;for(const z of this.d){const j=D.get(z.identifier);if(!j){d.push(z.identifier),g.delete(z.identifier);continue}if(!w(z,j)){d.push(z.identifier),g.delete(z.identifier);continue}}for(const z of t){const j=g.get(z.identifier);if(!j){l.push(z);continue}if(!w(j,z)){d.push(j.identifier),g.delete(j.identifier);continue}}const k=new M.$Jm(this.e),y=new M.$Jm(f);for(const z of this.e)y.has(z)||c.push(z);for(const z of f)k.has(z)||h.push(z);const C=R.$aG.createActivationEventsMap(l),I={versionId:s,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:c,myToAdd:h};return this.delta(I),I}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,c=new M.$Jm(t),h=new M.$Jm(d);for(let g=0;g<this.d.length;g++)c.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of l)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Im.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$aG.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$tG=A;function P(r){const s=new M.$Km;for(const t of r)s.set(t.identifier,t);return s}function $(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function E(r,s){if(!$(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$wG=v;class a{constructor(s,t){this.description=s,this.value=t}}e.$xG=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$qp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new M.$Im((0,L.$op)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AG=i}),define(ke[305],Ee([1,0,13,148,25,26,12,7]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=e.$Bkc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Bkc=p;class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ckc=S;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$Dkc=A;class P extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ekc=P;class $ extends A{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=$;class E extends A{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new L.$Km,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(s));return this.c.onExtensionActivationError(o.id,s,new R.$sG(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),c=this.k(o,n.displayName,[],new E(l));return this.c.onExtensionActivationError(n.identifier,l,new R.$sG(s)),c}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new a(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return N.$B$b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Gkc=v,e.$Gkc=v=Je([We(3,M.$Tj)],v);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new b.$mh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new E(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};a=Je([We(6,M.$Tj)],a)}),define(ke[306],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[307],Ee([1,0,243,13,40,137,109,38,25,306,139,140]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0;const $=b.$6n.as(M.$7n.JSONContribution);class E{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(L.default.Error,s)}warn(s){this.d(L.default.Warning,s)}info(s){this.d(L.default.Info,s)}}e.$jG=E;class v{static a(s){const t=new p.$Jm;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),c=s.filter(h=>!d.has(h.description.identifier));return new v(l,c)}constructor(s,t){this.added=s,this.removed=t}}e.$kG=v;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,N.$1)(s)}}}e.$lG=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$mG={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Hm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Ko}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Ko}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&P.$aG.register(s.extensionPoint,s.activationEventsGenerator),e.$mG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,$.registerSchema(o,e.$mG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$nG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$6n.add(i.ExtensionsRegistry,new n),e.$oG=b.$6n.as(i.ExtensionsRegistry),$.registerSchema(o,e.$mG),$.registerSchema(A.$bk,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[308],Ee([1,0,239,18,24,307,37,4]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RH=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var S;(function($){function E(v,a,m){if(!v)return;const o=N.$1f(v.type)?v.type:void 0;if(!o||o.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$1f(i)&&n.push(i);return{extensionId:a.value,taskType:o,required:n,properties:v.properties?L.$Tn(v.properties):{},when:v.when?M.$lj.deserialize(v.when):void 0}}$.from=E})(S||(S={}));const A=R.$oG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,E)=>{for(const v of $)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:p}});class P{constructor(){this.d=new b.$_d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=S.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const a={type:"object",additionalProperties:!1};v.required.length>0&&(a.required=v.required.slice(0)),v.properties!==void 0?a.properties=L.$Tn(v.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[v.taskType]},E.push(a)}this.c={oneOf:E}}return this.c}}e.$RH=new P}),define(ke[309],Ee([1,0,240,18,23,24,37,308]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2H=e.JsonSchemaVersion=e.ExecutionEngine=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VH=e.ShellQuoting=e.$UH=e.$TH=e.$SH=void 0,e.$SH="settings",e.$TH=new M.$Ej("taskRunning",!1,u.localize(0,null)),e.$UH=u.localize2(2,"Tasks");var p;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$VH="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}(p||(e.ShellQuoting=p={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(A||(e.RevealKind=A={}));var P;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(P||(e.RevealProblemKind=P={}));var $;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})($||(e.PanelKind=$={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}($||(e.PanelKind=$={}));var E;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(H){switch(H.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(H){switch(H){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var a;(function(O){function T(B){return N.$1f(B)?B:B.value}O.value=T})(a||(e.CommandString=a={}));var m;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(H){return H===O.Clean._id||H===O.Build._id||H===O.Rebuild._id||H===O.Test._id}O.is=T;function B(H){if(H!==void 0)return N.$1f(H)?T(H)?{_id:H,isDefault:!1}:void 0:H}O.from=B})(m||(e.TaskGroup=m={}));var o;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(T,B,H,X,x,Y){this._label="",this._id=T,B&&(this._label=B),H&&(this.type=H),this.runOptions=X,this.configurationProperties=x,this._source=Y}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$1f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$WH=t;class f extends t{constructor(T,B,H,X,x,Y,Z,ce){super(T,H,void 0,Z,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=Y,x&&(this.command=x)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof f}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$SH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const H={type:e.$VH,folder:T,id:B};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Xg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new f(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$XH=f;class d extends t{constructor(T,B,H,X,x,Y,Z){super(T,H,X,Y,Z,B),this._source=B,this.configures=x}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Xg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$SH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const H={type:e.$VH,folder:T,id:B};return JSON.stringify(H)}}e.$YH=d;class l extends t{constructor(T,B,H,X,x,Y,Z,ce,ie){super(T,H,X,ce,ie,B),this.defines=x,this.hasDefinedMatchers=Z,this.command=Y,this.icon=ie.icon,this.hide=ie.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof l}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new l(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$ZH=l;class c extends t{constructor(T,B,H,X,x,Y){super(T,H,X,x,Y,B),this._source=B}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$1H=c;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const H=T.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(H&&X){let x=this.c.get(H.uri.toString());x=x===void 0?0:x+1;let Y=this.c.get(X.uri.toString());return Y=Y===void 0?0:Y+1,x===Y?T._label.localeCompare(B._label):x-Y}else return!H&&X?-1:H&&!X?1:0}}e.$2H=D;var w;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(w||(e.TaskEventKind=w={}));var k;(function(O){O.SingleRun="singleRun",O.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(O){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function B(ce,ie,pe){return{...T(ce),kind:"start",terminalId:ie,resolvedVariables:pe}}O.start=B;function H(ce,ie,pe){return{...T(ce),kind:"processStarted",terminalId:ie,processId:pe}}O.processStarted=H;function X(ce,ie,pe){return{...T(ce),kind:"processEnded",terminalId:ie,exitCode:pe}}O.processEnded=X;function x(ce,ie,pe){return{...T(ce),kind:"terminated",exitReason:pe,terminalId:ie}}O.terminated=x;function Y(ce,ie,pe){return{...T(ie),kind:ce,terminalId:pe}}O.general=Y;function Z(){return{kind:"changed"}}O.changed=Z})(C||(e.TaskEvent=C={}));var I;(function(O){function T(H){const X=Object.keys(H).sort();let x="";for(const Y of X){let Z=H[Y];Z instanceof Object?Z=T(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),x+=Y+","+Z+","}return x}function B(H){const x={_key:T(H),type:H.taskType};return Object.assign(x,H),x}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var z;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var F;(function(O){function T(B,H){const X=b.$RH.get(B.type);if(X===void 0){const ce=R.$Tn(B);return delete ce._key,I.create(ce)}const x=Object.create(null);x.type=X.taskType;const Y=new Set;X.required.forEach(ce=>Y.add(ce));const Z=X.properties;for(const ce of Object.keys(Z)){const ie=B[ce];if(ie!=null)x[ce]=ie;else if(Y.has(ce)){const pe=Z[ce];if(pe.default!==void 0)x[ce]=R.$Tn(pe.default);else switch(pe.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:H.error(u.localize(1,null,JSON.stringify(B,void 0,0),ce));return}}}return I.create(x)}O.createTaskIdentifier=T})(F||(e.TaskDefinition=F={}))}),define(ke[310],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$F$b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$G$b=L}),define(ke[48],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$gw=void 0,e.$hw=L,e.$iw=R;class u{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++u.count}}e.$gw=u;const N=[];function L(b){const p=new u(b);return N[p.nid]=p,p}function R(b){return N[b].sid}class M{constructor(p){this.value=p}}e.$jw=M}),define(ke[6],Ee([1,0,48]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$LM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var S;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(m){return m._id=P.a++,m}}e.$LM=P;var $;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$MM={MainThreadAuthentication:(0,u.$hw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$hw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$hw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$hw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$hw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$hw)("MainThreadClipboard"),MainThreadCommands:(0,u.$hw)("MainThreadCommands"),MainThreadComments:(0,u.$hw)("MainThreadComments"),MainThreadConfiguration:(0,u.$hw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$hw)("MainThreadConsole"),MainThreadDebugService:(0,u.$hw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$hw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$hw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$hw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$hw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$hw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$hw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$hw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$hw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$hw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$hw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$hw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$hw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$hw)("MainThreadLanguages"),MainThreadLogger:(0,u.$hw)("MainThreadLogger"),MainThreadMessageService:(0,u.$hw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$hw)("MainThreadOutputService"),MainThreadProgress:(0,u.$hw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$hw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$hw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$hw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$hw)("MainThreadSecretState"),MainThreadStorage:(0,u.$hw)("MainThreadStorage"),MainThreadSpeech:(0,u.$hw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$hw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$hw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$hw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$hw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$hw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$hw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$hw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$hw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$hw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$hw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$hw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$hw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$hw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$hw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$hw)("MainThreadSCM"),MainThreadSearch:(0,u.$hw)("MainThreadSearch"),MainThreadShare:(0,u.$hw)("MainThreadShare"),MainThreadTask:(0,u.$hw)("MainThreadTask"),MainThreadWindow:(0,u.$hw)("MainThreadWindow"),MainThreadLabelService:(0,u.$hw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$hw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$hw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$hw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$hw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$hw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$hw)("MainThreadInteractive"),MainThreadInlineChat:(0,u.$hw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$hw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$hw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$hw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$hw)("MainThreadTimeline"),MainThreadTesting:(0,u.$hw)("MainThreadTesting"),MainThreadLocalization:(0,u.$hw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$hw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$hw)("MainThreadAiEmbeddingVector")},e.$NM={ExtHostCommands:(0,u.$hw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$hw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$hw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$hw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$hw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$hw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$hw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$hw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$hw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$hw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$hw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$hw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$hw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$hw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$hw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$hw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$hw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$hw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$hw)("ExtHostStatusBar"),ExtHostShare:(0,u.$hw)("ExtHostShare"),ExtHostExtensionService:(0,u.$hw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$hw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$hw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$hw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$hw)("ExtHostSCM"),ExtHostSearch:(0,u.$hw)("ExtHostSearch"),ExtHostTask:(0,u.$hw)("ExtHostTask"),ExtHostWorkspace:(0,u.$hw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$hw)("ExtHostWindow"),ExtHostWebviews:(0,u.$hw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$hw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$hw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$hw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$hw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$hw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$hw)("ExtHostProgress"),ExtHostComments:(0,u.$hw)("ExtHostComments"),ExtHostSecretState:(0,u.$hw)("ExtHostSecretState"),ExtHostStorage:(0,u.$hw)("ExtHostStorage"),ExtHostUrls:(0,u.$hw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$hw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$hw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$hw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$hw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$hw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$hw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$hw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$hw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$hw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$hw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$hw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$hw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,u.$hw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$hw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$hw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$hw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$hw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$hw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$hw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$hw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$hw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$hw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$hw)("ExtHostTimeline"),ExtHostTesting:(0,u.$hw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$hw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$hw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=e.$1jc=void 0,e.$1jc=(0,u.$ni)("IExtHostApiDeprecationService");let M=class{constructor(p,S){this.c=S,this.a=new Set,this.b=p.getProxy(L.$MM.MainThreadTelemetry)}report(p,S,A){const P=this.d(p,S);this.a.has(P)||(this.a.add(P),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:p}))}d(p,S){return`${p}-${S.identifier.value}`}};e.$2jc=M,e.$2jc=M=Je([We(0,R.$0O),We(1,N.$Tj)],M),e.$3jc=Object.freeze(new class{report(b,p,S){}})}),define(ke[311],Ee([1,0,6]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class N{constructor(R){const M=R.getProxy(u.$MM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$dkc=N}),define(ke[312],Ee([1,0,24,6,28,20]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let M=class{constructor(A,P){this.a=A.getProxy(N.$MM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const $=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,P,E,arguments)}})}e(A,P,$,E){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:p(E,this.b)}),this.c&&this.f(A,$,E)}};e.$0lc=M,e.$0lc=M=Je([We(0,R.$0O),We(1,L.$nP)],M);const b=1e5;function p(S,A){const P=[];if(S.length)for(let $=0;$<S.length;$++){let E=S[$];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}P.push(E)}if(A){const $=new Error().stack;$&&P.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,u.$Yn)(P);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[313],Ee([1,0,2,6,26]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class R{constructor(b){this.a=b.getProxy(N.$MM.MainThreadDialogs)}showOpenDialog(b,p){return p?.allowUIResources&&(0,L.$vG)(b,"showLocal"),this.a.$showOpenDialog(p).then(S=>S?S.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(p=>p?u.URI.revive(p):void 0)}}e.$alc=R}),define(ke[314],Ee([1,0,3,6]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$MM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$ulc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0;let A=class{constructor($,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(b.$MM.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===u.$g}getMessage($,E){const{message:v,args:a,comment:m}=E;if(this.c)return(0,N.$2e)(v,a??{});let o=v;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get($)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$2e)(n??v,a??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let E;const v=await this.g($);if(!v){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(v),m=JSON.parse(a);E=$.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${$.identifier.value} from ${v}: ${a.message}`);return}E&&this.d.set($.identifier.value,{contents:E,uri:v})}async g($){if($.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(E)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ukc=A,e.$Ukc=A=Je([We(0,p.$nP),We(1,S.$0O),We(2,M.$Tj)],A),e.$Vkc=(0,R.$ni)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;let p=class extends u.$5j{constructor(P,$){super($.logLevel,$.logsLocation,$.loggers.map(E=>(0,b.$Wh)(E))),this.r=P.getProxy(N.$MM.MainThreadLogger)}$setLogLevel(P,$){$?this.setLogLevel(M.URI.revive($),P):this.setLogLevel(P)}setVisibility(P,$){super.setVisibility(P,$),this.r.$setVisibility(P,$)}s(P,$,E){return new S(this.r,P,$,E)}};e.$9lc=p,e.$9lc=p=Je([We(0,R.$0O),We(1,L.$nP)],p);class S extends u.$Zj{constructor(P,$,E,v){super(v?.logLevel==="always"),this.r=P,this.s=$,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger($,v).then(()=>{this.u(this.n),this.m=!0})}g(P,$){const E=[[P,$]];this.m?this.u(E):this.n.push(...E)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0,e.$Wkc=(0,N.$ni)("IExtHostManagedSockets");let b=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(u.$MM.MainThreadManagedSockets)}setFactory(P,$){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(P,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const $=++this.b,E=await this.c.makeConnection(),v=new L.$Tc;return this.d.set($,new S($,E,v)),v.add((0,L.$Sc)(()=>this.d.delete($))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),v.dispose()})),v.add(E.onDidClose(a=>{this.a.$onDidManagedSocketClose($,a?.stack??a?.message),v.dispose()})),v.add(E.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData($,M.$ze.wrap(a)))),$}$remoteSocketWrite(P,$){this.d.get(P)?.actual.send($.buffer)}$remoteSocketEnd(P){const $=this.d.get(P);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Xkc=b,e.$Xkc=b=Je([We(0,R.$0O)],b);class p{constructor(P,$){this.socketFactoryId=P,this.makeConnection=$}}class S extends L.$Uc{constructor(P,$,E){super(),this.socketId=P,this.actual=$,this.B(E)}}}),define(ke[315],Ee([1,0,6,12,26]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;function R(b){return b&&b.title}let M=class{constructor(p,S){this.b=S,this.a=p.getProxy(u.$MM.MainThreadMessageService)}showMessage(p,S,A,P,$){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let v;typeof P=="string"||R(P)?v=[P,...$]:(E.modal=P?.modal,E.useCustom=P?.useCustom,E.detail=P?.detail,v=$),E.useCustom&&(0,L.$vG)(p,"resolvers");const a=[];let m=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")a.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;a.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,A,E,a).then(o=>{if(typeof o=="number")return v[o]})}};e.$wlc=M,e.$wlc=M=Je([We(1,N.$Tj)],M)}),define(ke[316],Ee([1,0,3,18,2,26,6]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class b{constructor(S){this.b=new Map,this.a=S.getProxy(M.$MM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,A,P){if((0,R.$vG)(S,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,S.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(S,A,P,$){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(A,P,$)}async $readProfile(S,A,P){const $=this.b.get(S);if(!$)throw new Error(`Unknown handler with id: ${S}`);return $.readProfile((0,N.$1f)(A)?A:L.URI.revive(A),P)}}e.$Flc=b}),define(ke[117],Ee([1,0,6,4,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=void 0;class R{constructor(b){this.b=new N.$_d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$MM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,p){return this.a.$getPassword(b,p)}store(b,p,S){return this.a.$setPassword(b,p,S)}delete(b,p){return this.a.$deletePassword(b,p)}}e.$Rkc=R,e.$Skc=(0,L.$ni)("IExtHostSecretState")}),define(ke[317],Ee([1,0,22,3,6]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(L.$MM.MainThreadSpeech)}async $createSpeechToTextSession(b,p,S){const A=this.c.get(b);if(!A)return;const P=new N.$Tc,$=new u.$je;this.d.set(p,$);const E=P.add(A.provideSpeechToTextSession($.token,S?{language:S}:void 0));P.add(E.onDidChange(v=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,v)})),P.add($.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,p){const S=this.c.get(b);if(!S)return;const A=new N.$Tc,P=new u.$je;this.d.set(p,P);const $=A.add(S.provideKeywordRecognitionSession(P.token));A.add($.onDidChange(E=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,p,S){const A=R.a++;return this.c.set(A,S),this.b.$registerProvider(A,p,{extension:b,displayName:b.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Mlc=R}),define(ke[118],Ee([1,0,6,4,5]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;class R{constructor(b,p){this.c=p,this.b=new N.$_d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$MM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,p){this.a.$registerExtensionStorageKeysToSync(b,p)}async initializeExtensionStorage(b,p,S){const A=await this.a.$initializeExtensionStorage(b,p);let P;return A&&(P=this.d(b,p,A)),P||S}setValue(b,p,S){return this.a.$setValue(b,p,S)}$acceptValue(b,p,S){const A=this.d(b,p,S);A&&this.b.fire({shared:b,key:p,value:A})}d(b,p,S){try{return JSON.parse(S)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${b}): ${A}`)}}}e.$Hkc=R,e.$Ikc=(0,L.$ni)("IExtHostStorage")}),define(ke[318],Ee([1,0,3,15,2,6]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(R.$MM.MainThreadUriOpeners)}registerExternalUriOpener(p,S,A,P){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const $=P.schemes.find(E=>!M.a.has(E));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(S,A),this.b.$registerUriOpener(S,P.schemes,p,P.label),(0,u.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri(p,S,A){const P=this.c.get(p);if(!P)throw new Error(`Unknown opener with id: ${p}`);const $=L.URI.revive(S);return P.canOpenExternalUri($,A)}async $openUri(p,S,A){const P=this.c.get(p);if(!P)throw new Error(`Unknown opener id: '${p}'`);return P.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},A)}}e.$3lc=M}),define(ke[319],Ee([1,0,6,2,3,13,25]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class b{static{this.a=0}constructor(S){this.c=new M.$Jm,this.d=new Map,this.b=S.getProxy(u.$MM.MainThreadUrls)}registerUriHandler(S,A){const P=S.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const $=b.a++;return this.c.add(P),this.d.set($,A),this.b.$registerUriHandler($,P,S.displayName||S.name),(0,L.$Sc)(()=>{this.c.delete(P),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(S,A){const P=this.d.get(S);if(!P)return Promise.resolve(void 0);try{P.handleUri(N.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$4lc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,247,285,113,6]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=e.$skc=void 0,e.$tkc=$,e.$vkc=a,e.$wkc=m;class P{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$_d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$_d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=$(l),this.#d=E(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,S.$Dxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+S.$Cxb}return S.$Cxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),R.$Xn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,p.$Tnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,S.$Dxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,S.$Dxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`})}}e.$skc=P;function $(i){try{const r=(0,b.$zp)((0,b.$yp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,b.$zp)((0,b.$yp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(A.$MM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,p.$Unb)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new P(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$ukc=v;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(he,e,u,N,L,R,M,b,p,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const v=this.d;return{get focused(){return v.focused},get active(){return(0,S.$vG)(E,"windowActivity"),v.active}}}constructor(E){this.c=new u.$_d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(N.$MM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:a})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this.d[E]&&(this.d={...this.d,[E]:v},this.c.fire(this.d))}openUri(E,v){let a;if(typeof E=="string"){a=E;try{E=L.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,M.$Ze)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,a,v)}async asExternalUri(E,v){if((0,M.$Ze)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(E,v);return L.URI.from(a)}};e.$6lc=P,e.$6lc=P=A=Je([We(0,p.$0O)],P),e.$7lc=(0,b.$ni)("IExtHostWindow")}),define(ke[320],Ee([1,0,312,28,20]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;const R=1024*1024;let M=class extends u.$0lc{constructor(p,S){super(p,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,S,A){const P=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),S.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,S){const A=process[p],P=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,v,a)=>{if(!this.g){$+=E.toString(v);const m=$.length>R?$.length:$.lastIndexOf(`
`);m!==-1&&(console[S]($.slice(0,m)),$=$.slice(m+1))}P.call(A,E,v,a)}})}};e.$Imc=M,e.$Imc=M=Je([We(0,L.$0O),We(1,N.$nP)],M)}),define(ke[321],Ee([1,0,149,15,262,30]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;class M extends u.$9lc{s(p,S,A){return p.scheme===N.Schemas.file?new L.$kQ(A?.name||(0,R.$Jg)(),p.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,S):super.s(p,S,A)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Umc=M}),define(ke[322],Ee([1,0,7,21,22,13,4,3,133,310,48]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$H$b=m,e.$I$b=o;function $(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class a{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function m(y,C=null,I=!1){const z=[];return{jsonString:(I?$:JSON.stringify)(y,(F,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$ze){const T=z.push(O)-1;return{[E]:T}}if(C)return C(F,O)}return O}),referencedBuffers:z}}function o(y,C,I){return JSON.parse(y,(z,j)=>{if(j){const F=j[E];if(typeof F=="number")return C[F];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Uc{static{P=f}static{this.a=3*1e3}constructor(C,I=null,z=null){super(),this[P]=!0,this.b=this.B(new M.$_d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,F=A.$gw.count;j<F;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$zh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,p.$sn)(C,this.g):C}getProxy(C){const{nid:I,sid:z}=C;return this.s[I]||(this.s[I]=this.J(I,z)),this.s[I]}J(C,I){const z={get:(j,F)=>(typeof F=="string"&&!j[F]&&F.charCodeAt(0)===36&&(j[F]=(...O)=>this.U(C,F,O)),F===d?I:j[F])};return new Proxy(Object.create(null),z)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,z=C.length;I<z;I++){const j=C[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,z=h.read(C,0),j=z.readUInt8(),F=z.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(z);this.g&&(B=(0,p.$sn)(B,this.g)),this.M(I,F,O,T,B,j===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(z);this.g&&(B=(0,p.$sn)(B,this.g)),this.M(I,F,O,T,B,j===4);break}case 5:{this.f?.logIncoming(I,F,0,"ack"),this.G(F);break}case 6:{this.N(I,F);break}case 7:{this.O(I,F,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(z);this.g&&(O=(0,p.$sn)(O,this.g)),this.O(I,F,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(I,F,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(z);this.O(I,F,O);break}case 11:{let O=D.deserializeReplyErrError(z);this.g&&(O=(0,p.$sn)(O,this.g)),this.P(I,F,O);break}case 12:{this.P(I,F,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,z,j,F,O){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,A.$iw)(z)}.${j}(`,F);const T=String(I);let B,H;if(O){const x=new L.$je;F.push(x.token),B=this.Q(z,j,F),H=()=>x.cancel()}else B=this.Q(z,j,F),H=t;this.u[T]=H;const X=D.serializeAcknowledged(I);this.f?.logOutgoing(X.byteLength,I,1,"ack"),this.c.send(X),B.then(x=>{delete this.u[T];const Y=D.serializeReplyOK(I,x,this.h);this.f?.logOutgoing(Y.byteLength,I,1,"reply:",x),this.c.send(Y)},x=>{delete this.u[T];const Y=D.serializeReplyErr(I,x);this.f?.logOutgoing(Y.byteLength,I,1,"replyErr:",x),this.c.send(Y)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const z=String(I);this.u[z]?.()}O(C,I,z){this.f?.logIncoming(C,I,0,"receiveReply:",z);const j=String(I);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j],F.resolveOk(z)}P(C,I,z){this.f?.logIncoming(C,I,0,"receiveReplyErr:",z);const j=String(I);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j];let O;z&&(z.$isError?(O=new Error,O.name=z.name,O.message=z.message,O.stack=z.stack):O=z),F.resolveErr(O)}Q(C,I,z){try{return Promise.resolve(this.S(C,I,z))}catch(j){return Promise.reject(j)}}S(C,I,z){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,A.$iw)(C));const F=j[I];if(typeof F!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$iw)(C));return F.apply(j,z)}U(C,I,z){if(this.j)return new S.$G$b;let j=null;if(z.length>0&&L.CancellationToken.isCancellationToken(z[z.length-1])&&(j=z.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const F=D.serializeRequestArguments(z,this.h),O=++this.t,T=String(O),B=new S.$F$b,H=new b.$Tc;j&&H.add(j.onCancellationRequested(()=>{const x=D.serializeCancel(O);this.f?.logOutgoing(x.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new c(B,H),this.F(O);const X=D.serializeRequest(O,C,I,F,!!j);return this.f?.logOutgoing(X.byteLength,O,0,`request: ${(0,A.$iw)(C)}.${I}(`,z),this.c.send(X),B}}e.$J$b=l;class c{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,I,z){const j=new h(N.$ze.alloc(z+1+4),0);return j.writeUInt8(C),j.writeUInt32(I),j}static read(C,I){return new h(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let z=0,j=C.length;z<j;z++){const F=C[z];switch(I+=1,F.type){case 1:I+=this.sizeLongString(F.value);break;case 2:I+=this.sizeVSBuffer(F.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)I+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,z=C.length;I<z;I++){const j=C[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let F=0;F<j.buffers.length;++F)this.writeBuffer(j.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:I[z]=this.readLongString();break;case 2:I[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<F;++B)T.push(this.readVSBuffer());I[z]=new A.$jw(o(O,T,null));break}case 4:I[z]=void 0;break}return I}}var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class D{static a(C){for(let I=0,z=C.length;I<z;I++)if(C[I]instanceof N.$ze||C[I]instanceof A.$jw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const z=[];for(let j=0,F=C.length;j<F;j++){const O=C[j];if(O instanceof N.$ze)z[j]={type:2,value:O};else if(typeof O>"u")z[j]={type:4};else if(O instanceof A.$jw){const{jsonString:T,referencedBuffers:B}=m(O.value,I);z[j]={type:3,value:N.$ze.fromString(T),buffers:B}}else z[j]={type:1,value:N.$ze.fromString(n(O,I))}}return{type:1,args:z}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,z,j,F){switch(j.type){case 0:return this.b(C,I,z,j.args,F);case 1:return this.c(C,I,z,j.args,F)}}static b(C,I,z,j,F){const O=N.$ze.fromString(z),T=N.$ze.fromString(j);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(O),B+=h.sizeLongString(T);const H=h.alloc(F?2:1,C,B);return H.writeUInt8(I),H.writeShortString(O),H.writeLongString(T),H.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),z=C.readShortString(),j=C.readLongString();return{rpcId:I,method:z,args:JSON.parse(j)}}static c(C,I,z,j,F){const O=N.$ze.fromString(z);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(O),T+=h.sizeMixedArray(j);const B=h.alloc(F?4:3,C,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),z=C.readShortString(),j=C.readMixedArray(),F=new Array(j.length);for(let O=0,T=j.length;O<T;O++){const B=j[O];typeof B=="string"?F[O]=JSON.parse(B):F[O]=B}return{rpcId:I,method:z,args:F}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,I,z){if(typeof I>"u")return this.d(C);if(I instanceof N.$ze)return this.e(C,I);if(I instanceof A.$jw){const{jsonString:j,referencedBuffers:F}=m(I.value,z,!0);return this.g(C,j,F)}else return this.f(C,$(I,z))}static d(C){return h.alloc(7,C,0).buffer}static e(C,I){let z=0;z+=h.sizeVSBuffer(I);const j=h.alloc(8,C,z);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const z=N.$ze.fromString(I);let j=0;j+=h.sizeLongString(z);const F=h.alloc(9,C,j);return F.writeLongString(z),F.buffer}static g(C,I,z){const j=N.$ze.fromString(I);let F=0;F+=h.sizeUInt32,F+=h.sizeLongString(j);for(const T of z)F+=h.sizeVSBuffer(T);const O=h.alloc(10,C,F);O.writeUInt32(z.length),O.writeLongString(j);for(const T of z)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const z=C.readUInt32(),j=C.readLongString(),F=[];for(let O=0;O<z;++O)F.push(C.readVSBuffer());return new A.$jw(o(j,F,I))}static serializeReplyErr(C,I){const z=I?$(R.$3(I),null):void 0;if(typeof z!="string")return this.h(C);const j=N.$ze.fromString(z);let F=0;F+=h.sizeLongString(j);const O=h.alloc(11,C,F);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return h.alloc(12,C,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[323],Ee([1,0,21,27,15,84,5]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=void 0,e.$pK=A,e.$qK=P,e.$oK=(0,M.$ni)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${b.join("")}]+`),S=7;function A(E){if(E.scheme!==L.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const a=parseInt(E.fragment.substring(0,v).replace(p,""),S),m=(0,u.$Se)(E.fragment.substring(v+1)).toString();if(!isNaN(a))return{handle:a,notebook:E.with({scheme:m,fragment:null})}}function P(E,v){const a=v.toString(S),o=`${a.length<b.length?b[a.length-1]:"z"}${a}s${(0,u.$Te)(u.$ze.fromString(E.scheme),!0,!0)}`;return E.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class ${constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const a=A(v);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$rK=$,(0,R.$ls)(e.$oK,$,1)}),define(ke[119],Ee([1,0,21,35,45,101,15,17,11,37,323]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$IK=e.CellStatusbarAlignment=e.$HK=e.NotebookEditorPriority=e.$EK=e.$DK=e.$BK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AK=e.$zK=e.$yK=e.$xK=e.CellKind=e.$wK=e.$vK=e.$uK=void 0,e.$CK=f,e.$FK=l,e.$GK=c,e.$JK=D,e.$KK=k,e.$uK="workbench.editor.notebook",e.$vK="workbench.editor.notebookTextDiffEditor",e.$wK="workbench.editor.interactive";var P;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(P||(e.CellKind=P={})),e.$xK=["application/json","application/javascript","text/html","image/svg+xml",R.$Es.latex,R.$Es.markdown,"image/png","image/jpeg",R.$Es.text],e.$yK=[R.$Es.latex,R.$Es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Es.text],e.$zK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AK="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function H(ie,pe){return(0,A.$qK)(ie,pe)}B.generate=H;function X(ie){return(0,A.$pK)(ie)}B.parse=X;function x(ie,pe){return ie.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${ie.scheme!==M.Schemas.file?ie.scheme:""}`})}B.generateCellOutputUri=x;function Y(ie){if(ie.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!pe)return;const Ce=pe[1]&&pe[1]!==""?pe[1]:void 0,_=pe[2];return{outputId:Ce,notebook:ie.with({scheme:_||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=Y;function Z(ie,pe,Ce){return B.generate(ie,pe).with({scheme:Ce})}B.generateCellPropertyUri=Z;function ce(ie,pe){if(ie.scheme===pe)return B.parse(ie.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=B=>p.$i?B.replace(/\//g,"\\"):B;class t{constructor(H=[],X=e.$xK){this.e=X,this.d=[...new Set(H)].map(x=>({pattern:x,matches:N.$hk(s(x))}))}sort(H){const X=new Map(L.Iterable.map(H,Y=>[Y,s(Y)]));let x=[];for(const{matches:Y}of this.d)for(const[Z,ce]of X)if(Y(ce)){x.push(Z),X.delete(Z);break}return X.size&&(x=x.concat([...X.keys()].sort((Y,Z)=>this.e.indexOf(Y)-this.e.indexOf(Z)))),x}prioritize(H,X){const x=this.f(H);if(x===-1){this.d.unshift({pattern:H,matches:N.$hk(s(H))});return}const Y=new Set(X.map(ce=>this.f(ce,x)));Y.delete(-1);const Z=Array.from(Y).sort();this.d.splice(x+1,0,...Z.map(ce=>this.d[ce]));for(let ce=Z.length-1;ce>=0;ce--)this.d.splice(Z[ce],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,X=this.d.length){const x=s(H);for(let Y=0;Y<X;Y++)if(this.d[Y].matches(x))return Y;return-1}}e.$BK=t;function f(B,H,X,x=(Y,Z)=>Y===Z){const Y=[];function Z(pe,Ce,_){if(Ce===0&&_.length===0)return;const U=Y[Y.length-1];U&&U.start+U.deleteCount===pe?(U.deleteCount+=Ce,U.toInsert.push(..._)):Y.push({start:pe,deleteCount:Ce,toInsert:_})}let ce=0,ie=0;for(;;){if(ce===B.length){Z(ce,0,H.slice(ie));break}if(ie===H.length){Z(ce,B.length-ce,[]);break}const pe=B[ce],Ce=H[ie];if(x(pe,Ce)){ce+=1,ie+=1;continue}X(Ce)?(Z(ce,1,[]),ce+=1):(Z(ce,0,[Ce]),ie+=1)}return Y}e.$DK=new S.$Ej("notebookEditorCursorAtBoundary","none"),e.$EK=new S.$Ej("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const H=B;return!!((typeof H.include=="string"||N.$ik(H.include))&&(typeof H.exclude=="string"||N.$ik(H.exclude)))}function c(B,H,X){if(Array.isArray(B.viewType)&&B.viewType.indexOf(H)>=0||B.viewType===H)return!0;if(B.filenamePattern){const x=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Y=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$gk(x,(0,b.$oc)(X.fsPath).toLowerCase()))return!(Y&&N.$gk(Y,(0,b.$oc)(X.fsPath).toLowerCase()))}return!1}e.$HK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static{this.d="notebook/"}static create(H){return`${g.d}${H}`}static parse(H){if(H.startsWith(g.d))return H.substring(g.d.length)}}e.$IK=g;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function k(B){const H=[];let X=!1;for(const ce of B)(H.length===0||X)&&(H.push(ce),X=!0);let x=I(H);const Y=u.$ze.concat(H.map(ce=>u.$ze.wrap(ce))),Z=T(Y);return x=x||Z.byteLength!==Y.byteLength,{data:Z,didCompression:x}}e.$LK="\x1B[A";const y=e.$LK.split("").map(B=>B.charCodeAt(0)),C=10;function I(B){let H=!1;return B.forEach((X,x)=>{if(x===0||X.length<e.$LK.length)return;const Y=B[x-1],Z=X.subarray(0,e.$LK.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const ce=Y.lastIndexOf(C);if(ce===-1)return;H=!0,B[x-1]=Y.subarray(0,ce),B[x]=X.subarray(e.$LK.length)}}),H}function z(B){let H=B;do B=H,H=B.replace(/[^\n]\x08/gm,"");while(H.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const H=B.match(/^(.*)\r+/m)[1];let X=B.match(/\r+(.*)$/m)[1];X=X+H.slice(X.length,H.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return B}const F=8,O=13;function T(B){return!B.buffer.includes(F)&&!B.buffer.includes(O)?B:u.$ze.fromString(j(z(w.decode(B.buffer))))}}),define(ke[8],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";var a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$XO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$WO=e.$VO=e.$UO=e.$TO=e.ChatLocation=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$JO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$wO=e.$vO=e.$uO=e.$tO=e.$rO=e.$qO=e.$pO=e.$oO=e.TestRunProfileKind=e.TestResultState=e.$nO=e.$mO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$lO=e.NotebookVariablesRequestKind=e.$kO=e.$jO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$iO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.ColorThemeKind=e.$cO=e.$bO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$aO=e.$_N=e.DebugConsoleMode=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$6N=e.$5N=e.FileChangeType=e.$4N=e.NewSymbolNameTag=e.$3N=e.$2N=e.$1N=e.$ZN=e.InlineCompletionTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$MN=e.ConfigurationTarget=e.$LN=e.$KN=e.$JN=e.$IN=e.DocumentPasteTriggerKind=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BN=e.ViewBadge=e.ProgressLocation=e.$AN=e.$zN=e.TaskScope=e.ShellQuoting=e.$yN=e.$xN=e.$wN=e.TaskPanelKind=e.TaskRevealKind=e.$vN=e.TerminalLocation=e.$uN=e.$tN=e.$sN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rN=e.$qN=e.$pN=e.$oN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iN=e.$hN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.LanguageStatusSeverity=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.CodeActionTriggerKind=e.$8M=e.$7M=e.SymbolTag=e.SymbolKind=e.$6M=e.$5M=e.DocumentHighlightKind=e.$4M=e.$3M=e.$2M=e.$1M=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZM=e.$YM=e.FileEditType=e.$XM=e.$WM=e.$VM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$nN=lt,e.$NN=ye,e.$sO=yt;function y(G){return Object.assign(G,{apply:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const Te=$e.length===1?[]:$e[1];return Reflect.construct(G,Te,$e[0].constructor)}},call:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const[Te,...Ze]=$e;return Reflect.construct(G,Ze,Te.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let z=a=class{static from(...q){let $e=q;return new a(function(){if($e){for(const Te of $e)Te&&typeof Te.dispose=="function"&&Te.dispose();$e=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$OM=z,e.$OM=z=a=Je([y],z);let j=m=class{static Min(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let Te=1;Te<q.length;Te++){const Ze=q[Te];Ze.isBefore($e)&&($e=Ze)}return $e}static Max(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let Te=1;Te<q.length;Te++){const Ze=q[Te];Ze.isAfter($e)&&($e=Ze)}return $e}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:$e,character:Te}=q;return typeof $e=="number"&&typeof Te=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,$e){if(q<0)throw(0,N.$7)("line must be non-negative");if($e<0)throw(0,N.$7)("character must be non-negative");this.c=q,this.e=$e}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,$e=0){if(q===null||$e===null)throw(0,N.$7)();let Te;return typeof q>"u"?Te=0:typeof q=="number"?Te=q:(Te=typeof q.lineDelta=="number"?q.lineDelta:0,$e=typeof q.characterDelta=="number"?q.characterDelta:0),Te===0&&$e===0?this:new m(this.line+Te,this.character+$e)}with(q,$e=this.character){if(q===null||$e===null)throw(0,N.$7)();let Te;return typeof q>"u"?Te=this.line:typeof q=="number"?Te=q:(Te=typeof q.line=="number"?q.line:this.line,$e=typeof q.character=="number"?q.character:this.character),Te===this.line&&$e===this.character?this:new m(Te,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$PM=j,e.$PM=j=m=Je([y],j);let F=o=class{static isRange(q){return q instanceof o?!0:q?j.isPosition(q.start)&&j.isPosition(q.end):!1}static of(q){if(q instanceof o)return q;if(this.isRange(q))return new o(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,$e,Te,Ze){let nt,dt;if(typeof q=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof Ze=="number"?(nt=new j(q,$e),dt=new j(Te,Ze)):j.isPosition(q)&&j.isPosition($e)&&(nt=j.of(q),dt=j.of($e)),!nt||!dt)throw new Error("Invalid arguments");nt.isBefore(dt)?(this.c=nt,this.e=dt):(this.c=dt,this.e=nt)}contains(q){return o.isRange(q)?this.contains(q.start)&&this.contains(q.end):j.isPosition(q)?!(j.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const $e=j.Max(q.start,this.c),Te=j.Min(q.end,this.e);if(!$e.isAfter(Te))return new o($e,Te)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const $e=j.Min(q.start,this.c),Te=j.Max(q.end,this.end);return new o($e,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,$e=this.end){if(q===null||$e===null)throw(0,N.$7)();let Te;return q?j.isPosition(q)?Te=q:(Te=q.start||this.start,$e=q.end||this.end):Te=this.start,Te.isEqual(this.c)&&$e.isEqual(this.end)?this:new o(Te,$e)}toJSON(){return[this.start,this.end]}};e.$QM=F,e.$QM=F=o=Je([y],F);let O=n=class extends F{static isSelection(q){return q instanceof n?!0:q?F.isRange(q)&&j.isPosition(q.anchor)&&j.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,$e,Te,Ze){let nt,dt;if(typeof q=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof Ze=="number"?(nt=new j(q,$e),dt=new j(Te,Ze)):j.isPosition(q)&&j.isPosition($e)&&(nt=j.of(q),dt=j.of($e)),!nt||!dt)throw new Error("Invalid arguments");super(nt,dt),this.f=nt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$RM=O,e.$RM=O=n=Je([y],O);const T=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e,Te){if(typeof q!="string"||q.length===0)throw(0,N.$7)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,N.$7)("port");typeof Te<"u"&&T(Te),this.host=q,this.port=Math.round($e),this.connectionToken=Te}}e.$SM=B;class H{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e){this.makeConnection=q,this.connectionToken=$e,typeof $e<"u"&&T($e)}}e.$TM=H;class X extends Error{static NotAvailable(q,$e){return new X(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(q){return new X(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,$e=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(q),this._message=q,this._code=$e,this._detail=Te,Object.setPrototypeOf(this,X.prototype)}}e.$UM=X;var x;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var Y;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let Z=i=class{static isTextEdit(q){return q instanceof i?!0:q?F.isRange(q)&&typeof q.newText=="string":!1}static replace(q,$e){return new i(q,$e)}static insert(q,$e){return i.replace(new F(q,q),$e)}static delete(q){return i.replace(q,"")}static setEndOfLine(q){const $e=new i(new F(new j(0,0),new j(0,0)),"");return $e.newEol=q,$e}get range(){return this.c}set range(q){if(q&&!F.isRange(q))throw(0,N.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$7)("newEol");this.f=q}constructor(q,$e){this.c=q,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VM=Z,e.$VM=Z=i=Je([y],Z);let ce=r=class{static isNotebookCellEdit(q){return q instanceof r?!0:q?fi.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,$e){return new r(q,$e)}static insertCells(q,$e){return new r(new fi(q,q),$e)}static deleteCells(q){return new r(q,[])}static updateCellMetadata(q,$e){const Te=new r(new fi(q,q),[]);return Te.newCellMetadata=$e,Te}static updateNotebookMetadata(q){const $e=new r(new fi(0,0),[]);return $e.newNotebookMetadata=q,$e}constructor(q,$e){this.range=q,this.newCells=$e}};e.$WM=ce,e.$WM=ce=r=Je([y],ce);class ie{static isSnippetTextEdit(q){return q instanceof ie?!0:q?F.isRange(q.range)&&_.isSnippetString(q.snippet):!1}static replace(q,$e){return new ie(q,$e)}static insert(q,$e){return ie.replace(new F(q,q),$e)}constructor(q,$e){this.range=q,this.snippet=$e}}e.$XM=ie;var pe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,$e,Te,Ze){this.c.push({_type:1,from:q,to:$e,options:Te,metadata:Ze})}createFile(q,$e,Te){this.c.push({_type:1,from:void 0,to:q,options:$e,metadata:Te})}deleteFile(q,$e,Te){this.c.push({_type:1,from:q,to:void 0,options:$e,metadata:Te})}e(q,$e,Te){this.c.push({_type:3,metadata:Te,uri:q,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(q,$e,Te,Ze){const nt=$e.start,dt=$e.end;(nt!==dt||Te.length>0)&&this.c.push({_type:5,uri:q,index:nt,count:dt-nt,cells:Te,metadata:Ze})}g(q,$e,Te,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:$e,metadata:Te}})}replace(q,$e,Te,Ze){this.c.push({_type:2,uri:q,edit:new Z($e,Te),metadata:Ze})}insert(q,$e,Te,Ze){this.replace(q,new F($e,$e),Te,Ze)}delete(q,$e,Te){this.replace(q,$e,"",Te)}has(q){return this.c.some($e=>$e._type===2&&$e.uri.toString()===q.toString())}set(q,$e){if($e)for(const Te of $e){if(!Te)continue;let Ze,nt;Array.isArray(Te)?(Ze=Te[0],nt=Te[1]):Ze=Te,ce.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,nt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,nt):this.f(q,Ze.range,Ze.newCells,nt):ie.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:nt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:nt})}else{for(let Te=0;Te<this.c.length;Te++){const Ze=this.c[Te];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Te]=void 0);break}}(0,u.$Ib)(this.c)}}get(q){const $e=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===q.toString()&&$e.push(Te.edit);return $e}entries(){const q=new R.$Bc;for(const $e of this.c)if($e._type===2){let Te=q.get($e.uri);Te||(Te=[$e.uri,[]],q.set($e.uri,Te)),Te[1].push($e.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YM=Ce,e.$YM=Ce=Je([y],Ce);let _=s=class{static isSnippetString(q){return q instanceof s?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=s.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,$e=this.e++){if(typeof q=="function"){const Te=new s;Te.e=this.e,q(Te),this.e=Te.e,q=Te.value}else q=s.c(q);return this.value+="${",this.value+=$e,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,$e=this.e++){const Te=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(q,$e){if(typeof $e=="function"){const Te=new s;Te.e=this.e,$e(Te),this.e=Te.e,$e=Te.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$ZM=_,e.$ZM=_=s=Je([y],_);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let be=t=class{static isLocation(q){return q instanceof t?!0:q?F.isRange(q.range)&&S.URI.isUri(q.uri):!1}constructor(q,$e){if(this.uri=q,$e)if(F.isRange($e))this.range=F.of($e);else if(j.isPosition($e))this.range=new F($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1M=be,e.$1M=be=t=Je([y],be);let De=class{static is(q){return q?typeof q.message=="string"&&q.location&&F.isRange(q.location.range)&&S.URI.isUri(q.location.uri):!1}constructor(q,$e){this.location=q,this.message=$e}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.location.range.isEqual($e.location.range)&&q.location.uri.toString()===$e.location.uri.toString()}};e.$2M=De,e.$2M=De=Je([y],De);let oe=class{constructor(q,$e,Te=ne.Error){if(!F.isRange(q))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=q,this.message=$e,this.severity=Te}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.severity===$e.severity&&q.code===$e.code&&q.severity===$e.severity&&q.source===$e.source&&q.range.isEqual($e.range)&&(0,u.$ub)(q.tags,$e.tags)&&(0,u.$ub)(q.relatedInformation,$e.relatedInformation,De.isEqual)}};e.$3M=oe,e.$3M=oe=Je([y],oe);let ae=class{constructor(q,$e){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=$e}};e.$4M=ae,e.$4M=ae=Je([y],ae);var re;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let K=class{constructor(q,$e=re.Text){this.range=q,this.kind=$e}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$5M=K,e.$5M=K=Je([y],K);let te=class{constructor(q,$e){this.uri=q,this.highlights=$e}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$6M=te,e.$6M=te=Je([y],te);var le;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(G){G[G.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ae=f=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,$e,Te,Ze,nt){this.name=q,this.kind=$e,this.containerName=nt,typeof Te=="string"&&(this.containerName=Te),Ze instanceof be?this.location=Ze:Te instanceof F&&(this.location=new be(Ze,Te)),f.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$7M=Ae,e.$7M=Ae=f=Je([y],Ae);let me=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,$e,Te,Ze,nt){this.name=q,this.detail=$e,this.kind=Te,this.range=Ze,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$8M=me,e.$8M=me=d=Je([y],me);var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Re=class{constructor(q,$e){this.title=q,this.kind=$e}};e.$9M=Re,e.$9M=Re=Je([y],Re);let Fe=class{static{l=this}static{this.c="."}constructor(q){this.value=q}append(q){return new l(this.value?this.value+l.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+l.c)}};e.$0M=Fe,e.$0M=Fe=l=Je([y],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let V=class{constructor(q,$e){if(this.range=q,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$M=V,e.$$M=V=Je([y],V);class W{constructor(q,$e,Te,Ze,nt,dt){this.kind=q,this.name=$e,this.detail=Te,this.uri=Ze,this.range=nt,this.selectionRange=dt}}e.$_M=W;class Q{constructor(q,$e){this.fromRanges=$e,this.from=q}}e.$aN=Q;class J{constructor(q,$e){this.fromRanges=$e,this.to=q}}e.$bN=J;var fe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(fe||(e.LanguageStatusSeverity=fe={}));let we=class{constructor(q,$e){this.range=q,this.command=$e}get isResolved(){return!!this.command}};e.$cN=we,e.$cN=we=Je([y],we);let ze=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,$e=!1){this.#e=new L.$Kk(q,{supportThemeIcons:$e})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,$e){return this.#e.appendCodeblock($e??"",q),this}};e.$dN=ze,e.$dN=ze=c=Je([y],ze);let Ve=class{constructor(q,$e){this.label=q,this.documentation=$e}};e.$eN=Ve,e.$eN=Ve=Je([y],Ve);let Xe=class{constructor(q,$e){this.label=q,this.documentation=$e,this.parameters=[]}};e.$fN=Xe,e.$fN=Xe=Je([y],Xe);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gN=st,e.$gN=st=Je([y],st);var ot;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var tt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let rt=class{constructor(q){this.value=q}};e.$hN=rt,e.$hN=rt=Je([y],rt);let Se=class{constructor(q,$e,Te){this.position=q,this.label=$e,this.kind=Te}};e.$iN=Se,e.$iN=Se=Je([y],Se);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Le;(function(G){G[G.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Ye=class{constructor(q,$e){this.label=q,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jN=Ye,e.$jN=Ye=Je([y],Ye);let se=class{constructor(q=[],$e=!1){this.items=q,this.isIncomplete=$e}};e.$kN=se,e.$kN=se=Je([y],se);let ue=class{constructor(q,$e,Te){this.insertText=q,this.range=$e,this.command=Te}};e.$lN=ue,e.$lN=ue=Je([y],ue);let Ie=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$mN=Ie,e.$mN=Ie=Je([y],Ie);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var Me;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Me||(e.ViewColumn=Me={}));var it;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function lt(G,q){return`${P.$Im.toKey(G)}.${q}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var It;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var Ft;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var qt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(qt||(e.TextEditorSelectionChangeKind=qt={}));var xt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var St;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(St||(e.DecorationRangeBehavior=St={})),function(G){function q($e){switch($e){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(qt||(e.TextEditorSelectionChangeKind=qt={}));var Wt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(G){function q($e){switch($e){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Wt||(e.SyntaxTokenType=Wt={}));let Gt=class{constructor(q,$e){if($e&&!S.URI.isUri($e))throw(0,N.$7)("target");if(!F.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.target=$e}};e.$oN=Gt,e.$oN=Gt=Je([y],Gt);let et=class{constructor(q,$e,Te,Ze){this.red=q,this.green=$e,this.blue=Te,this.alpha=Ze}};e.$pN=et,e.$pN=et=Je([y],et);let ri=class{constructor(q,$e){if($e&&!($e instanceof et))throw(0,N.$7)("color");if(!F.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.color=$e}};e.$qN=ri,e.$qN=ri=Je([y],ri);let _t=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$7)("label");this.label=q}};e.$rN=_t,e.$rN=_t=Je([y],_t);var ft;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ft||(e.ColorFormat=ft={}));var $t;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));class ti{constructor(q,$e,Te){if(this.startIndex=q,this.length=$e,this.tooltip=Te,typeof q!="number"||q<0)throw(0,N.$7)("startIndex");if(typeof $e!="number"||$e<1)throw(0,N.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,N.$7)("tooltip")}}e.$sN=ti;class zt{constructor(q){this.uri=q}}e.$tN=zt;class gt{constructor(q){this.terminalCommand=q}}e.$uN=gt;var Bt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class ii{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$7)("options")}}e.$vN=ii;var Ot;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ot||(e.TaskRevealKind=Ot={}));var xe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(xe||(e.TaskPanelKind=xe={}));let si=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,$e){if(this.label=$e,typeof q!="string"||typeof $e!="string")throw(0,N.$7)("name");this.c=q}get id(){return this.c}};e.$wN=si,e.$wN=si=h=Je([y],si);function Kt(G){let q="";for(let $e=0;$e<G.length;$e++)q+=G[$e].replace(/,/g,",,")+",";return q}let Ut=class{constructor(q,$e,Te){if(typeof q!="string")throw(0,N.$7)("process");this.e=[],this.c=q,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=Te):this.f=$e)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)q.push($e);return Kt(q)}};e.$xN=Ut,e.$xN=Ut=Je([y],Ut);let mt=class{constructor(q,$e,Te){if(this.f=[],Array.isArray($e)){if(!q)throw(0,N.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q,this.f=$e,this.g=Te}else{if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q,this.g=$e}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)q.push(typeof $e=="string"?$e:$e.value);return Kt(q)}};e.$yN=mt,e.$yN=mt=Je([y],mt);var Tt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Tt||(e.ShellQuoting=Tt={}));var Lt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Lt||(e.TaskScope=Lt={}));class Ht{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$Jg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$zN=Ht;let Jt=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,$e,Te,Ze,nt,dt){this.k=!1,this.l=this.definition=q;let pt;typeof $e=="string"?(this.o=this.name=$e,this.w=this.source=Te,this.execution=Ze,pt=nt,this.k=!0):$e===Lt.Global||$e===Lt.Workspace?(this.target=$e,this.o=this.name=Te,this.w=this.source=Ze,this.execution=nt,pt=dt):(this.target=$e,this.o=this.name=Te,this.w=this.source=Ze,this.execution=nt,pt=dt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof mt?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,A.$Jg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,N.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const $e=this.l.type;(g.g===$e||g.e===$e||g.f===$e||g.c===$e)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$AN=Jt,e.$AN=Jt=g=Je([y],Jt);var Qt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var oi;(function(G){function q($e){const Te=$e;return(0,p.$5f)(Te.value)?Te.tooltip&&!(0,p.$1f)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=q})(oi||(e.ViewBadge=oi={}));let At=D=class{static isTreeItem(q,$e){const Te=q;if(Te.checkboxState!==void 0){const Ze=(0,p.$5f)(Te.checkboxState)?Te.checkboxState:(0,p.$3f)(Te.checkboxState)&&(0,p.$5f)(Te.checkboxState.state)?Te.checkboxState.state:void 0,nt=!(0,p.$5f)(Te.checkboxState)&&(0,p.$3f)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Pt.Checked&&Ze!==Pt.Unchecked||nt!==void 0&&!(0,p.$1f)(nt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(q instanceof D)return!0;if(Te.label!==void 0&&!(0,p.$1f)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,p.$1f)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,p.$1f)(Te.iconPath)&&!S.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,p.$1f)(Te.iconPath.id))){const Ze=Te.iconPath;if(!Ze||!(0,p.$1f)(Ze.light)&&!S.URI.isUri(Ze.light)&&!(0,p.$1f)(Ze.dark)&&!S.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,p.$1f)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!S.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,p.$1f)(Te.tooltip)&&!(Te.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Nt.None&&Te.collapsibleState>Nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,p.$1f)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(q,$e=Nt.None){this.collapsibleState=$e,S.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$BN=At,e.$BN=At=D=Je([y],At);var Nt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Nt||(e.TreeItemCollapsibleState=Nt={}));var Pt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$CN=Dt,e.$CN=Dt=Je([y],Dt);class bt extends Dt{}e.$DN=bt;class Ct extends bt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$EN=Ct;class li{constructor(q,$e,Te,Ze){this.name=q,this.uri=$e,this._itemId=Te,this.c=Ze}data(){return this.c()}}e.$FN=li;let kt=class{#e=new Map;constructor(q){for(const[$e,Te]of q??[]){const Ze=this.#e.get(this.#t($e));Ze?Ze.push(Te):this.#e.set(this.#t($e),[Te])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,$e){this.#e.set(this.#t(q),[$e])}forEach(q,$e){for(const[Te,Ze]of this.#e)for(const nt of Ze)q.call($e,nt,Te,this)}*[Symbol.iterator](){for(const[q,$e]of this.#e)for(const Te of $e)yield[q,Te]}#t(q){return q.toLowerCase()}};e.$GN=kt,e.$GN=kt=Je([y],kt);let hi=class{constructor(q,$e,Te){this.insertText=q,this.title=$e,this.kind=Te}};e.$HN=hi,e.$HN=hi=Je([y],hi);var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(Yt||(e.DocumentPasteTriggerKind=Yt={}));class ai{static{this.c="."}constructor(q){this.value=q}append(...q){return new ai((this.value?[this.value,...q]:q).join(ai.c))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+ai.c)}}e.$IN=ai,ai.Empty=new ai("");class pi{constructor(q,$e,Te){this.title=$e,this.insertText=q,this.kind=Te}}e.$JN=pi;let ni=class{constructor(q,$e){this.id=q,this.color=$e}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$KN=ni,e.$KN=ni=Je([y],ni),ni.File=new ni("file"),ni.Folder=new ni("folder");let Rt=class{constructor(q){this.id=q}};e.$LN=Rt,e.$LN=Rt=Je([y],Rt);var yi;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let Ne=class{get base(){return this.c}set base(q){this.c=q,this.e=S.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,$e){if(typeof q!="string"&&(!q||!S.URI.isUri(q)&&!S.URI.isUri(q.uri)))throw(0,N.$7)("base");if(typeof $e!="string")throw(0,N.$7)("pattern");typeof q=="string"?this.baseUri=S.URI.file(q):S.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$MN=Ne,e.$MN=Ne=Je([y],Ne);const je=new WeakMap;function ye(G,q){je.set(G,q)}let ee=class{constructor(q,$e,Te,Ze,nt){this.enabled=typeof q=="boolean"?q:!0,typeof $e=="string"&&(this.condition=$e),typeof Te=="string"&&(this.hitCondition=Te),typeof Ze=="string"&&(this.logMessage=Ze),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=je.get(this)??(0,A.$Jg)()),this.c}};e.$ON=ee,e.$ON=ee=Je([y],ee);let Oe=class extends ee{constructor(q,$e,Te,Ze,nt,dt){if(super($e,Te,Ze,nt,dt),q===null)throw(0,N.$7)("location");this.location=q}};e.$PN=Oe,e.$PN=Oe=Je([y],Oe);let qe=class extends ee{constructor(q,$e,Te,Ze,nt,dt){super($e,Te,Ze,nt,dt),this.functionName=q}};e.$QN=qe,e.$QN=qe=Je([y],qe);let _e=class extends ee{constructor(q,$e,Te,Ze,nt,dt,pt,Vt){if(super(Ze,nt,dt,pt,Vt),!$e)throw(0,N.$7)("dataId");this.label=q,this.dataId=$e,this.canPersist=Te}};e.$RN=_e,e.$RN=_e=Je([y],_e);let Qe=class{constructor(q,$e,Te){this.command=q,this.args=$e||[],this.options=Te}};e.$SN=Qe,e.$SN=Qe=Je([y],Qe);let ht=class{constructor(q,$e){this.port=q,this.host=$e}};e.$TN=ht,e.$TN=ht=Je([y],ht);let Et=class{constructor(q){this.path=q}};e.$UN=Et,e.$UN=Et=Je([y],Et);let jt=class{constructor(q){this.implementation=q}};e.$VN=jt,e.$VN=jt=Je([y],jt);class Xt{constructor(q,$e,Te){this.session=q,this.threadId=$e,this.frameId=Te}}e.$WN=Xt;class ut{constructor(q,$e){this.session=q,this.threadId=$e}}e.$XN=ut;let Zt=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$YN=Zt,e.$YN=Zt=Je([y],Zt);var mi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let bi=class{constructor(q,$e){this.range=q,this.text=$e}};e.$ZN=bi,e.$ZN=bi=Je([y],bi);let Si=class{constructor(q,$e,Te=!0){this.range=q,this.variableName=$e,this.caseSensitiveLookup=Te}};e.$1N=Si,e.$1N=Si=Je([y],Si);let Mi=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$2N=Mi,e.$2N=Mi=Je([y],Mi);let Li=class{constructor(q,$e){this.frameId=q,this.stoppedLocation=$e}};e.$3N=Li,e.$3N=Li=Je([y],Li);var Vi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Vi||(e.NewSymbolNameTag=Vi={}));class qi{constructor(q,$e){this.newSymbolName=q,this.tags=$e}}e.$4N=qi;var Gi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Di=w=class extends Error{static FileExists(q){return new w(q,$.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,$.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,$.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,$.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,$.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,$.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,$e=$.FileSystemProviderErrorCode.Unknown,Te){super(S.URI.isUri(q)?q.toString(!0):q),this.code=Te?.name??"Unknown",(0,$.$9k)(this,$e),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$5N=Di,e.$5N=Di=w=Je([y],Di);let Ni=class{constructor(q,$e,Te){this.start=q,this.end=$e,this.kind=Te}};e.$6N=Ni,e.$6N=Ni=Je([y],Ni);var Ci;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Pi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Pi||(e.CommentThreadCollapsibleState=Pi={}));var Ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Ji;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var vi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));var Qi;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(q,$e=[]){this.tokenTypes=q,this.tokenModifiers=$e}}e.$7N=un;function ln(G){return typeof G>"u"||(0,p.$2f)(G)}class ki{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let $e=0,Te=q.tokenTypes.length;$e<Te;$e++)this.k.set(q.tokenTypes[$e],$e);for(let $e=0,Te=q.tokenModifiers.length;$e<Te;$e++)this.l.set(q.tokenModifiers[$e],$e)}}push(q,$e,Te,Ze,nt){if(typeof q=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof Ze=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(q,$e,Te,Ze,nt);if(F.isRange(q)&&typeof $e=="string"&&ln(Te))return this.o(q,$e,Te);throw(0,N.$7)()}o(q,$e,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has($e))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,nt=q.start.character,dt=q.end.character-q.start.character,pt=this.k.get($e);let Vt=0;if(Te)for(const ui of Te){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(ui);Vt|=1<<gi>>>0}this.q(Ze,nt,dt,pt,Vt)}q(q,$e,Te,Ze,nt){if(this.f&&(q<this.c||q===this.c&&$e<this.e)){this.f=!1;const Vt=this.g.length/5|0;let ui=0,gi=0;for(let $i=0;$i<Vt;$i++){let wi=this.g[5*$i],Hi=this.g[5*$i+1];wi===0?(wi=ui,Hi+=gi):wi+=ui,this.g[5*$i]=wi,this.g[5*$i+1]=Hi,ui=wi,gi=Hi}}let dt=q,pt=$e;this.f&&this.j>0&&(dt-=this.c,dt===0&&(pt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=pt,this.g[this.j++]=Te,this.g[this.j++]=Ze,this.g[this.j++]=nt,this.c=q,this.e=$e}static r(q){const $e=[],Te=q.length/5|0;for(let pt=0;pt<Te;pt++)$e[pt]=pt;$e.sort((pt,Vt)=>{const ui=q[5*pt],gi=q[5*Vt];if(ui===gi){const $i=q[5*pt+1],wi=q[5*Vt+1];return $i-wi}return ui-gi});const Ze=new Uint32Array(q.length);let nt=0,dt=0;for(let pt=0;pt<Te;pt++){const Vt=5*$e[pt],ui=q[Vt+0],gi=q[Vt+1],$i=q[Vt+2],wi=q[Vt+3],Hi=q[Vt+4],Mn=ui-nt,or=Mn===0?gi-dt:gi,Wi=5*pt;Ze[Wi+0]=Mn,Ze[Wi+1]=or,Ze[Wi+2]=$i,Ze[Wi+3]=wi,Ze[Wi+4]=Hi,nt=ui,dt=gi}return Ze}build(q){return this.f?new Oi(new Uint32Array(this.g),q):new Oi(ki.r(this.g),q)}}e.$8N=ki;class Oi{constructor(q,$e){this.resultId=$e,this.data=q}}e.$9N=Oi;class Yi{constructor(q,$e,Te){this.start=q,this.deleteCount=$e,this.data=Te}}e.$0N=Yi;class hn{constructor(q,$e){this.resultId=$e,this.edits=q}}e.$$N=hn;var Ti;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Ti||(e.DebugConsoleMode=Ti={}));class dn{constructor(q){this.name=q}}e.$_N=dn;let ji=class{static{this.Back={iconPath:new ni("arrow-left")}}constructor(){}};e.$aO=ji,e.$aO=ji=Je([y],ji);var Xi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Zi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Ii;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Ii||(e.ExtensionKind=Ii={}));class xi{static validate(q){if(typeof q.badge=="string"){let $e=(0,b.$Af)(q.badge,0);if($e<q.badge.length&&($e+=(0,b.$Af)(q.badge,$e)),q.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!ni.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,$e,Te){this.badge=q,this.tooltip=$e,this.color=Te}}e.$bO=xi;let He=class{constructor(q){this.kind=q}};e.$cO=He,e.$cO=He=Je([y],He);var di;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(di||(e.ColorThemeKind=di={}));class fi{static isNotebookRange(q){return q instanceof fi?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,$e){if(q<0)throw(0,N.$7)("start must be positive");if($e<0)throw(0,N.$7)("end must be positive");q<=$e?(this.c=q,this.e=$e):(this.c=$e,this.e=q)}with(q){let $e=this.c,Te=this.e;return q.start!==void 0&&($e=q.start),q.end!==void 0&&(Te=q.end),$e===this.c&&Te===this.e?this:new fi($e,Te)}}e.$dO=fi;class at{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every($e=>at.isNotebookCellData($e))}static isNotebookCellData(q){return!0}constructor(q,$e,Te,Ze,nt,dt,pt){this.kind=q,this.value=$e,this.languageId=Te,this.mime=Ze,this.outputs=nt??[],this.metadata=dt,this.executionSummary=pt,at.validate(this)}}e.$eO=at;class vt{constructor(q){this.cells=q}}e.$fO=vt;class ci{static isNotebookCellOutputItem(q){return q instanceof ci?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const $e={name:q.name,message:q.message,stack:q.stack};return ci.json($e,"application/vnd.code.notebook.error")}static stdout(q){return ci.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return ci.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,$e="application/octet-stream"){return new ci(q,$e)}static#e=new TextEncoder;static text(q,$e=M.$Es.text){const Te=ci.#e.encode(String(q));return new ci(Te,$e)}static json(q,$e="text/x-json"){const Te=JSON.stringify(q,void 0,"	");return ci.text(Te,$e)}constructor(q,$e){this.data=q,this.mime=$e;const Te=(0,M.$Is)($e,!0);if(!Te)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$gO=ci;class Ai{static isNotebookCellOutput(q){return q instanceof Ai?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,$e=!1){const Te=new Set,Ze=new Set;for(let nt=0;nt<q.length;nt++){const dt=q[nt],pt=(0,M.$Is)(dt.mime);if(!Te.has(pt)||(0,v.$JK)(pt)){Te.add(pt);continue}Ze.add(nt),$e&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?q:q.filter((nt,dt)=>!Ze.has(dt))}constructor(q,$e,Te){this.items=Ai.ensureUniqueMimeTypes(q,!0),typeof $e=="string"?(this.id=$e,this.metadata=Te):(this.id=(0,A.$Jg)(),this.metadata=$e??Te)}}e.$hO=Ai;var Fi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var _i;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Ei;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ei||(e.NotebookCellStatusBarAlignment=Ei={}));var en;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(q,$e){this.text=q,this.alignment=$e}}e.$iO=fn;var tn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var zi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(zi||(e.NotebookControllerAffinity2=zi={}));class gn{constructor(q,$e=[]){this.uri=q,this.provides=(0,u.$3b)($e)}}e.$jO=gn;class mn{constructor(q){this.label=q}}e.$kO=mn;var nn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Bi=class{constructor(q,$e){this.label=q,this.timestamp=$e}};e.$lO=Bi,e.$lO=Bi=Je([y],Bi);var rn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(q,$e){this.ranges=q,this.wordPattern=$e}}e.$mO=$n;class pn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$nO=pn;var an;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let ge=class{constructor(q=void 0,$e=void 0,Te=void 0,Ze=!1){this.include=q,this.exclude=$e,this.profile=Te,this.continuous=Ze}};e.$oO=ge,e.$oO=ge=Je([y],ge);let ve=k=class{static diff(q,$e,Te){const Ze=new k(q);return Ze.expectedOutput=$e,Ze.actualOutput=Te,Ze}constructor(q){this.message=q}};e.$pO=ve,e.$pO=ve=k=Je([y],ve);let Ue=class{constructor(q){this.id=q}};e.$qO=Ue,e.$qO=Ue=Je([y],Ue);class ct{constructor(q,$e){this.covered=q,this.total=$e,yt(this)}}e.$rO=ct;function yt(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class Mt{static fromDetails(q,$e){const Te=new ct(0,0),Ze=new ct(0,0),nt=new ct(0,0);for(const pt of $e)if("branches"in pt){Te.total+=1,Te.covered+=pt.executed?1:0;for(const Vt of pt.branches)Ze.total+=1,Ze.covered+=Vt.executed?1:0}else nt.total+=1,nt.covered+=pt.executed?1:0;const dt=new Mt(q,Te,Ze.total>0?Ze:void 0,nt.total>0?nt:void 0);return dt.detailedCoverage=$e,dt}constructor(q,$e,Te,Ze){this.uri=q,this.statementCoverage=$e,this.branchCoverage=Te,this.declarationCoverage=Ze}}e.$tO=Mt;class Ui{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,Te=[]){this.executed=q,this.location=$e,this.branches=Te}}e.$uO=Ui;class Ln{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,Te){this.executed=q,this.location=$e,this.label=Te}}e.$vO=Ln;class Nn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,Te){this.name=q,this.executed=$e,this.location=Te}}e.$wO=Nn;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var wn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class On{constructor(q,$e,Te,Ze,nt,dt){this.kind=q,this.name=$e,this.detail=Te,this.uri=Ze,this.range=nt,this.selectionRange=dt}}e.$xO=On;class Tn{constructor(q){this.uri=q}}e.$yO=Tn;class jn{constructor(q,$e){this.original=q,this.modified=$e}}e.$zO=jn;class Fn{constructor(q,$e,Te,Ze){this.base=q,this.input1=$e,this.input2=Te,this.result=Ze}}e.$AO=Fn;class zn{constructor(q,$e){this.uri=q,this.viewType=$e}}e.$BO=zn;class Bn{constructor(q){this.viewType=q}}e.$CO=Bn;class Un{constructor(q,$e){this.uri=q,this.notebookType=$e}}e.$DO=Un;class Hn{constructor(q,$e,Te){this.original=q,this.modified=$e,this.notebookType=Te}}e.$EO=Hn;class Wn{constructor(){}}e.$FO=Wn;class Vn{constructor(q,$e){this.uri=q,this.inputBoxUri=$e}}e.$GO=Vn;class qn{constructor(){}}e.$HO=qn;class Gn{constructor(q){this.textDiffs=q}}e.$IO=Gn;var yn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Kn{constructor(q,$e){this.label=q,this.values=$e}}e.$JO=Kn;var Sn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Jn{constructor(q){this.value=typeof q=="string"?new ze(q):q}}e.$KO=Jn;class Qn{constructor(q,$e){this.value=q,this.baseUri=$e}}e.$LO=Qn;class Yn{constructor(q,$e){this.value=q,this.title=$e}}e.$MO=Yn;class Xn{constructor(q){this.value=q}}e.$NO=Xn;class Zn{constructor(q){this.value=q}}e.$OO=Zn;class xn{constructor(q){this.value=q}}e.$PO=xn;class _n{constructor(q,$e){this.uri=q,this.edits=Array.isArray($e)?$e:[$e]}}e.$QO=_n;class er{constructor(q,$e,Te,Ze){this.prompt=q,this.command=$e,this.variables=Te,this.participant=Ze}}e.$RO=er;class tr{constructor(q,$e,Te,Ze){this.response=q,this.result=$e,this.participant=Te,this.command=Ze}}e.$SO=tr;var Cn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class ir{constructor(q){this.content=q}}e.$TO=ir;class nr{constructor(q,$e){this.content=q,this.name=$e}}e.$UO=nr;class rr{constructor(q,$e){this.content=q,this.name=$e}}e.$VO=rr;class Ri extends Error{static NotFound(q){return new Ri(q,Ri.NotFound.name)}static NoPermissions(q){return new Ri(q,Ri.NoPermissions.name)}constructor(q,$e,Te){super(q,{cause:Te}),this.name="LanguageModelError",this.code=$e??""}}e.$WO=Ri;var Pn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var An;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class sr{constructor(q,$e){this.text=q,this.range=$e}}e.$XO=sr;var Rn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[324],Ee([1,0,6,8]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$MM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,p){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(M);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(b,p)??[]}getRelatedInformation(M,b,p){return this.c.$getAiRelatedInformation(b,p)}registerRelatedInformationProvider(M,b,p){const S=this.b;return this.b++,this.a.set(S,p),this.c.$registerAiRelatedInformationProvider(S,b),new N.$OM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$Zjc=L}),define(ke[120],Ee([1,0,4,6,8,25,145,5,20]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=void 0,e.$$jc=(0,b.$ni)("IExtHostAuthentication");let S=class{constructor($){this.b=new Map,this.c=new u.$_d,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(N.$MM.MainThreadAuthentication)}async getSession($,E,v,a={}){const m=R.$Im.toKey($.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const n=$.displayName||$.name;return this.a.$getSession(E,v,m,n,a)})}async getSessions($,E,v){const a=R.$Im.toKey($.identifier),m=[...v].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(E);const o=$.displayName||$.name;return this.a.$getSessions(E,v,a,o)})}async removeSession($,E){const v=this.b.get($);return v?v.provider.removeSession(E):this.a.$removeSession($,E)}registerAuthenticationProvider($,E,v,a){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:E,provider:v,options:a??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions($,o));return this.a.$registerAuthenticationProvider($,E,a?.supportsMultipleAccounts??!1),new L.$OM(()=>{m.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}$createSession($,E,v){const a=this.b.get($);if(a)return Promise.resolve(a.provider.createSession(E,v));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,E){const v=this.b.get($);if(v)return Promise.resolve(v.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,E){const v=this.b.get($);if(v)return Promise.resolve(v.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,E){return $.startsWith(M.$OL)||this.c.fire({provider:{id:$,label:E}}),Promise.resolve()}};e.$_jc=S,e.$_jc=S=Je([We(0,p.$0O)],S);class A{constructor(){this.a=new Map}getOrCreate($,E){const v=this.a.get($);if(v)return v;const a=E().finally(()=>this.a.delete($));return this.a.set($,a),a}}}),define(ke[151],Ee([1,0,2,6,8,5,20,12,19,14,17,26]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=e.$$kc=void 0;let E=class{static{$=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(N.$MM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const o=$.c++;this.f.set(o,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$3b)(i);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,S.$6e)(d.path,"/")})),t=(0,p.$zb)(s,(d,l)=>d.rank-l.rank||(0,S.$jf)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const c of d){const h=(0,A.$nc)(c.uri.path);if(l!==h&&(l=h,f.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,f)});return new L.$OM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(a,m,o){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{L.$bO.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$vG)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$$kc=E,e.$$kc=E=$=Je([We(0,M.$0O),We(1,b.$Tj)],E),e.$_kc=(0,R.$ni)("IExtHostDecorations")}),define(ke[325],Ee([1,0,13,2,8,6,15,22,14]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class S{static{this.a=0}constructor(P,$,E){this.d=$,this.e=E,this.b=new Map,this.c=P.getProxy(R.$MM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,$){if(Object.keys(M.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const E=S.a++;this.b.set(E,$),this.c.$registerTextContentProvider(E,P);let v;if(typeof $.onDidChange=="function"){let a;v=$.onDidChange(async m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const o=this.$provideTextDocumentContent(E,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,p.$df)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{a===o&&(a=void 0)});a=o})}return new L.$OM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,$){const E=this.b.get(P);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$blc=S}),define(ke[152],Ee([1,0,62,15,14,183,129,8,19]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$_O=A;const S=new Map;function A(v,a){a?S.set(v,a):S.delete(v)}function P(v){return S.get(v)}class $ extends R.$Mv{constructor(a,m,o,n,i,r,s){super(m,o,n,i),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,p.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===N.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,o){return a.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,u.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,u.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(o)}t(a){let m;if(a instanceof b.$PM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),o=this.f[m.index].length;return new b.$PM(m.index,Math.min(m.remainder,o))}w(a){if(!(a instanceof b.$QM))throw new Error("Invalid argument");const m=this.x(a.start),o=this.x(a.end);return m===a.start&&o===a.end?a:new b.$QM(m.line,m.character,o.line,o.character)}x(a){if(!(a instanceof b.$PM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:o}=a,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,n=!0;else{const i=this.f[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$PM(m,o):a}y(a,m){const o=this.x(a);if(!m)m=P(this.m);else if((0,L.$cf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,M.$Ws)(o.character+1,(0,M.$Us)(m),this.f[o.line],0);if(n)return new b.$QM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$aP=$;class E{constructor(a,m,o){this.a=a,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$QM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$QM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bP=E}),define(ke[326],Ee([1,0,6,8]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$MM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(M);if(!S)throw new Error("Embedding vector provider not found");const A=await S.provideEmbeddingVector(b,p);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,p){const S=this.b;return this.b++,this.a.set(S,p),this.c.$registerAiEmbeddingVectorProvider(b,S),new N.$OM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$dlc=L}),define(ke[69],Ee([1,0,6,32,8,21,5,20,60,3,7,23,15]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=void 0;let v=E=class{constructor(m,o){this.b=new Map,this.c=new A.$wh,this.a=m.getProxy(u.$MM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$ze.wrap(r))}catch(s){return E.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return E.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&N.FileType.Directory))throw L.$5N.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$0k(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(N.$0k(s)!==N.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof L.$5N)throw m;if(m instanceof N.$6k)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$5N.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$5N.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$5N.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$5N.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$5N.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$5N.Unavailable(m.message);default:throw new L.$5N(m.message,m.name)}if(!(m instanceof Error))throw new L.$5N(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.$5N.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$5N.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$5N.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$5N.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$5N.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$5N.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$5N.Unavailable(m.message);default:throw new L.$5N(m.message,m.name)}}addFileSystemProvider(m,o,n){return this.b.set(m,{impl:o,extUri:n?.isCaseSensitive?P.$Qg:P.$Sg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??P.$Qg}};e.$okc=v,e.$okc=v=E=Je([We(0,b.$0O),We(1,p.$5jc)],v),e.$pkc=(0,M.$ni)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0,e.$qkc=(0,u.$ni)("IExtensionStoragePaths");let b=class{constructor(S,A,P){this.d=A,this.f=P,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then($=>this.c=$)}async g(S){return M.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,A=await this.g(S);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(S){if(this.c)return M.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return M.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$rkc=b,e.$rkc=b=Je([We(0,N.$nP),We(1,L.$Tj),We(2,R.$pkc)],b)}),define(ke[327],Ee([1,0,8,20,4]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;let R=class{constructor(b){this.a=new u.$cO(u.ColorThemeKind.Dark),this.b=new L.$_d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let p;switch(b){case"light":p=u.ColorThemeKind.Light;break;case"hcDark":p=u.ColorThemeKind.HighContrast;break;case"hcLight":p=u.ColorThemeKind.HighContrastLight;break;default:p=u.ColorThemeKind.Dark}this.a=new u.$cO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ylc=R,e.$Ylc=R=Je([We(0,N.$0O)],R)}),define(ke[70],Ee([1,0,22,4,3,229,5,12,88,6,28,20,8]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mCb=e.$lCb=e.TunnelDtoConverter=void 0;class E extends p.$_v{}var v;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$lCb=(0,M.$ni)("IExtHostTunnelService");let a=class extends L.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$_d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(S.$MM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new $.$OM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(c,i,r,s)}return{providedAttributes:h,port:c}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$mCb=a,e.$mCb=a=Je([We(0,P.$0O),We(1,A.$nP),We(2,b.$Tj)],a)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,291,119,68,89,303,26,8]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$7O=B,e.$8O=X,e.$9O=x;var g;(function(Ne){function je(ee){const{selectionStartLineNumber:Oe,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Qe}=ee,ht=new h.$PM(Oe-1,qe-1),Et=new h.$PM(_e-1,Qe-1);return new h.$RM(ht,Et)}Ne.to=je;function ye(ee){const{anchor:Oe,active:qe}=ee;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Ne.from=ye})(g||(e.Selection=g={}));var D;(function(Ne){function je(ee){if(!ee)return;const{start:Oe,end:qe}=ee;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Ne.from=je;function ye(ee){if(!ee)return;const{startLineNumber:Oe,startColumn:qe,endLineNumber:_e,endColumn:Qe}=ee;return new h.$QM(Oe-1,qe-1,_e-1,Qe-1)}Ne.to=ye})(D||(e.Range=D={}));var w;(function(Ne){function je(ee){return{uri:ee.uri,range:D.from(ee.range)}}Ne.from=je;function ye(ee){return new h.$1M(a.URI.revive(ee.uri),D.to(ee.range))}Ne.to=ye})(w||(e.Location=w={}));var k;(function(Ne){function je(ye){switch(ye){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Ne.to=je})(k||(e.TokenType=k={}));var y;(function(Ne){function je(ee){return new h.$PM(ee.lineNumber-1,ee.column-1)}Ne.to=je;function ye(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ne.from=ye})(y||(e.Position=y={}));var C;(function(Ne){function je(Oe,qe,_e){return(0,u.$Hb)((0,u.$3b)(Oe).map(Qe=>ye(Qe,qe,_e)))}Ne.from=je;function ye(Oe,qe,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ee(Oe.scheme,qe),pattern:Ie.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Oe,qe){return qe&&typeof Oe=="string"?qe.transformOutgoingScheme(Oe):Oe}})(C||(e.DocumentSelector=C={}));var I;(function(Ne){function je(ee){switch(ee){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Ne.from=je;function ye(ee){switch(ee){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Ne.to=ye})(I||(e.DiagnosticTag=I={}));var z;(function(Ne){function je(ee){let Oe;return ee.code&&((0,v.$1f)(ee.code)||(0,v.$5f)(ee.code)?Oe=String(ee.code):Oe={value:String(ee.code.value),target:ee.code.target}),{...D.from(ee.range),message:ee.message,source:ee.source,code:Oe,severity:F.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(j.from),tags:Array.isArray(ee.tags)?(0,u.$Hb)(ee.tags.map(I.from)):void 0}}Ne.from=je;function ye(ee){const Oe=new h.$3M(D.to(ee),ee.message,F.to(ee.severity));return Oe.source=ee.source,Oe.code=(0,v.$1f)(ee.code)?ee.code:ee.code?.value,Oe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(j.to),Oe.tags=ee.tags&&(0,u.$Hb)(ee.tags.map(I.to)),Oe}Ne.to=ye})(z||(e.Diagnostic=z={}));var j;(function(Ne){function je(ee){return{...D.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Ne.from=je;function ye(ee){return new h.$2M(new h.$1M(ee.resource,D.to(ee)),ee.message)}Ne.to=ye})(j||(e.DiagnosticRelatedInformation=j={}));var F;(function(Ne){function je(ee){switch(ee){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ne.from=je;function ye(ee){switch(ee){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Ne.to=ye})(F||(e.DiagnosticSeverity=F={}));var O;(function(Ne){function je(ee){return typeof ee=="number"&&ee>=h.ViewColumn.One?ee-1:ee===h.ViewColumn.Beside?l.$LD:l.$KD}Ne.from=je;function ye(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ye})(O||(e.ViewColumn=O={}));function T(Ne){return typeof Ne.range<"u"}function B(Ne){return Ne.length===0?!0:!!T(Ne[0])}var H;(function(Ne){function je(Qe){return Qe.map(Ne.from)}Ne.fromMany=je;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let ht;if(ye(Qe)){const{language:ut,value:Zt}=Qe;ht={value:"```"+ut+`
`+Zt+"\n```\n"}}else h.$dN.isMarkdownString(Qe)?ht={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ht={value:Qe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const jt=ut=>{try{let Zt=a.URI.parse(ut,!0);Zt=Zt.with({query:Oe(Zt.query,Et)}),Et[ut]=Zt}catch{}return""},Xt=new p.marked.Renderer;return Xt.link=jt,Xt.image=ut=>typeof ut=="string"?jt(M.$Sk(ut).href):"",(0,p.marked)(ht.value,{renderer:Xt}),ht}Ne.from=ee;function Oe(Qe,ht){if(!Qe)return Qe;let Et;try{Et=(0,S.$Vh)(Qe)}catch{}if(!Et)return Qe;let jt=!1;return Et=(0,P.$Vn)(Et,Xt=>{if(a.URI.isUri(Xt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[ut]=Xt,jt=!0,ut}else return}),jt?JSON.stringify(Et):Qe}function qe(Qe){const ht=new h.$dN(Qe.value,Qe.supportThemeIcons);return ht.isTrusted=Qe.isTrusted,ht.supportHtml=Qe.supportHtml,ht.baseUri=Qe.baseUri?a.URI.from(Qe.baseUri):void 0,ht}Ne.to=qe;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Ne.from(Qe)}Ne.fromStrict=_e})(H||(e.MarkdownString=H={}));function X(Ne){return B(Ne)?Ne.map(je=>({range:D.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?H.fromMany(je.hoverMessage):je.hoverMessage?H.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ne.map(je=>({range:D.from(je)}))}function x(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?a.URI.file(Ne):Ne}var Y;(function(Ne){function je(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?x(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Ne.from=je})(Y||(e.ThemableDecorationAttachmentRenderOptions=Y={}));var Z;(function(Ne){function je(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Y.from(ye.before):void 0,after:ye.after?Y.from(ye.after):void 0}}Ne.from=je})(Z||(e.ThemableDecorationRenderOptions=Z={}));var ce;(function(Ne){function je(ye){if(typeof ye>"u")return ye;switch(ye){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=je})(ce||(e.DecorationRangeBehavior=ce={}));var ie;(function(Ne){function je(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ce.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Z.from(ye.light):void 0,dark:ye.dark?Z.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Y.from(ye.before):void 0,after:ye.after?Y.from(ye.after):void 0}}Ne.from=je})(ie||(e.DecorationRenderOptions=ie={}));var pe;(function(Ne){function je(ee){return{text:ee.newText,eol:ee.newEol&&Ge.from(ee.newEol),range:D.from(ee.range)}}Ne.from=je;function ye(ee){const Oe=new h.$VM(D.to(ee.range),ee.text);return Oe.newEol=typeof ee.eol>"u"?void 0:Ge.to(ee.eol),Oe}Ne.to=ye})(pe||(e.TextEdit=pe={}));var Ce;(function(Ne){function je(ee,Oe){const qe={edits:[]};if(ee instanceof h.$YM){const _e=new b.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&a.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let ht;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ht={type:"base64",value:(0,N.$Te)(N.$ze.wrap(Qe.options.contents))}:ht={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ht},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:pe.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:D.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(qt.from)}})}return qe}Ne.from=je;function ye(ee){const Oe=new h.$YM,qe=new b.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,ht=a.URI.revive(Qe.resource),Et=D.to(Qe.textEdit.range),jt=Qe.textEdit.text,Xt=Qe.textEdit.insertAsSnippet;let ut;Xt?ut=h.$XM.replace(Et,new h.$ZM(jt)):ut=h.$VM.replace(Et,jt);const Zt=qe.get(ht);Zt?Zt.push(ut):qe.set(ht,[ut])}else Oe.renameFile(a.URI.revive(_e.oldResource),a.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of qe)Oe.set(_e,Qe);return Oe}Ne.to=ye})(Ce||(e.WorkspaceEdit=Ce={}));var _;(function(Ne){const je=Object.create(null);je[h.SymbolKind.File]=0,je[h.SymbolKind.Module]=1,je[h.SymbolKind.Namespace]=2,je[h.SymbolKind.Package]=3,je[h.SymbolKind.Class]=4,je[h.SymbolKind.Method]=5,je[h.SymbolKind.Property]=6,je[h.SymbolKind.Field]=7,je[h.SymbolKind.Constructor]=8,je[h.SymbolKind.Enum]=9,je[h.SymbolKind.Interface]=10,je[h.SymbolKind.Function]=11,je[h.SymbolKind.Variable]=12,je[h.SymbolKind.Constant]=13,je[h.SymbolKind.String]=14,je[h.SymbolKind.Number]=15,je[h.SymbolKind.Boolean]=16,je[h.SymbolKind.Array]=17,je[h.SymbolKind.Object]=18,je[h.SymbolKind.Key]=19,je[h.SymbolKind.Null]=20,je[h.SymbolKind.EnumMember]=21,je[h.SymbolKind.Struct]=22,je[h.SymbolKind.Event]=23,je[h.SymbolKind.Operator]=24,je[h.SymbolKind.TypeParameter]=25;function ye(Oe){return typeof je[Oe]=="number"?je[Oe]:6}Ne.from=ye;function ee(Oe){for(const qe in je)if(je[qe]===Oe)return Number(qe);return h.SymbolKind.Property}Ne.to=ee})(_||(e.SymbolKind=_={}));var U;(function(Ne){function je(ee){switch(ee){case h.SymbolTag.Deprecated:return 1}}Ne.from=je;function ye(ee){switch(ee){case 1:return h.SymbolTag.Deprecated}}Ne.to=ye})(U||(e.SymbolTag=U={}));var ne;(function(Ne){function je(ee){return{name:ee.name,kind:_.from(ee.kind),tags:ee.tags&&ee.tags.map(U.from),containerName:ee.containerName,location:re.from(ee.location)}}Ne.from=je;function ye(ee){const Oe=new h.$7M(ee.name,_.to(ee.kind),ee.containerName,re.to(ee.location));return Oe.tags=ee.tags&&ee.tags.map(U.to),Oe}Ne.to=ye})(ne||(e.WorkspaceSymbol=ne={}));var be;(function(Ne){function je(ee){const Oe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),kind:_.from(ee.kind),tags:ee.tags?.map(U.from)??[]};return ee.children&&(Oe.children=ee.children.map(je)),Oe}Ne.from=je;function ye(ee){const Oe=new h.$8M(ee.name,ee.detail,_.to(ee.kind),D.to(ee.range),D.to(ee.selectionRange));return(0,u.$Lb)(ee.tags)&&(Oe.tags=ee.tags.map(U.to)),ee.children&&(Oe.children=ee.children.map(ye)),Oe}Ne.to=ye})(be||(e.DocumentSymbol=be={}));var De;(function(Ne){function je(ee){const Oe=new h.$_M(_.to(ee.kind),ee.name,ee.detail||"",a.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ne.to=je;function ye(ee,Oe,qe){if(Oe=Oe??ee._sessionId,qe=qe??ee._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,name:ee.name,detail:ee.detail,kind:_.from(ee.kind),uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Ne.from=ye})(De||(e.CallHierarchyItem=De={}));var oe;(function(Ne){function je(ye){return new h.$aN(De.to(ye.from),ye.fromRanges.map(ee=>D.to(ee)))}Ne.to=je})(oe||(e.CallHierarchyIncomingCall=oe={}));var ae;(function(Ne){function je(ye){return new h.$bN(De.to(ye.to),ye.fromRanges.map(ee=>D.to(ee)))}Ne.to=je})(ae||(e.CallHierarchyOutgoingCall=ae={}));var re;(function(Ne){function je(ee){return{range:ee.range&&D.from(ee.range),uri:ee.uri}}Ne.from=je;function ye(ee){return new h.$1M(a.URI.revive(ee.uri),D.to(ee.range))}Ne.to=ye})(re||(e.location=re={}));var K;(function(Ne){function je(ee){const Oe=ee,qe=ee;return{originSelectionRange:Oe.originSelectionRange?D.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:qe.uri,range:D.from(Oe.targetRange?Oe.targetRange:qe.range),targetSelectionRange:Oe.targetSelectionRange?D.from(Oe.targetSelectionRange):void 0}}Ne.from=je;function ye(ee){return{targetUri:a.URI.revive(ee.uri),targetRange:D.to(ee.range),targetSelectionRange:ee.targetSelectionRange?D.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?D.to(ee.originSelectionRange):void 0}}Ne.to=ye})(K||(e.DefinitionLink=K={}));var te;(function(Ne){function je(ee){return{range:D.from(ee.range),contents:H.fromMany(ee.contents)}}Ne.from=je;function ye(ee){return new h.$4M(ee.contents.map(H.to),D.to(ee.range))}Ne.to=ye})(te||(e.Hover=te={}));var le;(function(Ne){function je(ee){return{range:D.from(ee.range),expression:ee.expression}}Ne.from=je;function ye(ee){return new h.$YN(D.to(ee.range),ee.expression)}Ne.to=ye})(le||(e.EvaluatableExpression=le={}));var de;(function(Ne){function je(ee){if(ee instanceof h.$ZN)return{type:"text",range:D.from(ee.range),text:ee.text};if(ee instanceof h.$1N)return{type:"variable",range:D.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof h.$2N)return{type:"expression",range:D.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=je;function ye(ee){switch(ee.type){case"text":return{range:D.to(ee.range),text:ee.text};case"variable":return{range:D.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:D.to(ee.range),expression:ee.expression}}}Ne.to=ye})(de||(e.InlineValue=de={}));var Ae;(function(Ne){function je(ee){return{frameId:ee.frameId,stoppedLocation:D.from(ee.stoppedLocation)}}Ne.from=je;function ye(ee){return new h.$3N(ee.frameId,D.to(ee.stoppedLocation))}Ne.to=ye})(Ae||(e.InlineValueContext=Ae={}));var me;(function(Ne){function je(ee){return{range:D.from(ee.range),kind:ee.kind}}Ne.from=je;function ye(ee){return new h.$5M(D.to(ee.range),ee.kind)}Ne.to=ye})(me||(e.DocumentHighlight=me={}));var Pe;(function(Ne){function je(ee){return{uri:ee.uri,highlights:ee.highlights.map(me.from)}}Ne.from=je;function ye(ee){return new h.$6M(a.URI.revive(ee.uri),ee.highlights.map(me.to))}Ne.to=ye})(Pe||(e.MultiDocumentHighlight=Pe={}));var Re;(function(Ne){function je(ye){switch(ye){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Ne.to=je})(Re||(e.CompletionTriggerKind=Re={}));var Fe;(function(Ne){function je(ye){return{triggerKind:Re.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Ne.to=je})(Fe||(e.CompletionContext=Fe={}));var V;(function(Ne){function je(ee){switch(ee){case h.CompletionItemTag.Deprecated:return 1}}Ne.from=je;function ye(ee){switch(ee){case 1:return h.CompletionItemTag.Deprecated}}Ne.to=ye})(V||(e.CompletionItemTag=V={}));var W;(function(Ne){const je=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ye(qe){return je.get(qe)??9}Ne.from=ye;const ee=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Oe(qe){return ee.get(qe)??h.CompletionItemKind.Property}Ne.to=Oe})(W||(e.CompletionItemKind=W={}));var Q;(function(Ne){function je(ye,ee){const Oe=new h.$jN(ye.label);return Oe.insertText=ye.insertText,Oe.kind=W.to(ye.kind),Oe.tags=ye.tags?.map(V.to),Oe.detail=ye.detail,Oe.documentation=M.$Mk(ye.documentation)?H.to(ye.documentation):ye.documentation,Oe.sortText=ye.sortText,Oe.filterText=ye.filterText,Oe.preselect=ye.preselect,Oe.commitCharacters=ye.commitCharacters,m.$ht.isIRange(ye.range)?Oe.range=D.to(ye.range):typeof ye.range=="object"&&(Oe.range={inserting:D.to(ye.range.insert),replacing:D.to(ye.range.replace)}),Oe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Oe.insertText=new h.$ZM(ye.insertText):(Oe.insertText=ye.insertText,Oe.textEdit=Oe.range instanceof h.$QM?new h.$VM(Oe.range,Oe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ye.additionalTextEdits.map(qe=>pe.to(qe))),Oe.command=ee&&ye.command?ee.fromInternal(ye.command):void 0,Oe}Ne.to=je})(Q||(e.CompletionItem=Q={}));var J;(function(Ne){function je(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:H.fromStrict(ee.documentation)}}Ne.from=je;function ye(ee){return{label:ee.label,documentation:M.$Mk(ee.documentation)?H.to(ee.documentation):ee.documentation}}Ne.to=ye})(J||(e.ParameterInformation=J={}));var fe;(function(Ne){function je(ee){return{label:ee.label,documentation:H.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.from):[],activeParameter:ee.activeParameter}}Ne.from=je;function ye(ee){return{label:ee.label,documentation:M.$Mk(ee.documentation)?H.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.to):[],activeParameter:ee.activeParameter}}Ne.to=ye})(fe||(e.SignatureInformation=fe={}));var we;(function(Ne){function je(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(fe.from):[]}}Ne.from=je;function ye(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(fe.to):[]}}Ne.to=ye})(we||(e.SignatureHelp=we={}));var ze;(function(Ne){function je(ye,ee){const Oe=new h.$iN(y.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(Ve.to.bind(void 0,ye)),ee.kind&&Xe.to(ee.kind));return Oe.textEdits=ee.textEdits&&ee.textEdits.map(pe.to),Oe.tooltip=M.$Mk(ee.tooltip)?H.to(ee.tooltip):ee.tooltip,Oe.paddingLeft=ee.paddingLeft,Oe.paddingRight=ee.paddingRight,Oe}Ne.to=je})(ze||(e.InlayHint=ze={}));var Ve;(function(Ne){function je(ye,ee){const Oe=new h.$hN(ee.label);return Oe.tooltip=M.$Mk(ee.tooltip)?H.to(ee.tooltip):ee.tooltip,o.Command.is(ee.command)&&(Oe.command=ye.fromInternal(ee.command)),ee.location&&(Oe.location=re.to(ee.location)),Oe}Ne.to=je})(Ve||(e.InlayHintLabelPart=Ve={}));var Xe;(function(Ne){function je(ee){return ee}Ne.from=je;function ye(ee){return ee}Ne.to=ye})(Xe||(e.InlayHintKind=Xe={}));var st;(function(Ne){function je(ee){return{range:D.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ne.from=je;function ye(ee){let Oe;if(ee.url)try{Oe=typeof ee.url=="string"?a.URI.parse(ee.url,!0):a.URI.revive(ee.url)}catch{}return new h.$oN(D.to(ee.range),Oe)}Ne.to=ye})(st||(e.DocumentLink=st={}));var ot;(function(Ne){function je(ee){const Oe=new h.$rN(ee.label);return ee.textEdit&&(Oe.textEdit=pe.to(ee.textEdit)),ee.additionalTextEdits&&(Oe.additionalTextEdits=ee.additionalTextEdits.map(qe=>pe.to(qe))),Oe}Ne.to=je;function ye(ee){return{label:ee.label,textEdit:ee.textEdit?pe.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Oe=>pe.from(Oe)):void 0}}Ne.from=ye})(ot||(e.ColorPresentation=ot={}));var tt;(function(Ne){function je(ee){return new h.$pN(ee[0],ee[1],ee[2],ee[3])}Ne.to=je;function ye(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ne.from=ye})(tt||(e.Color=tt={}));var rt;(function(Ne){function je(ee){return{range:D.from(ee.range)}}Ne.from=je;function ye(ee){return new h.$$M(D.to(ee.range))}Ne.to=ye})(rt||(e.SelectionRange=rt={}));var Se;(function(Ne){function je(ye){switch(ye){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Ne.to=je})(Se||(e.TextDocumentSaveReason=Se={}));var Be;(function(Ne){function je(ee){switch(ee){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=je;function ye(ee){switch(ee){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Ne.to=ye})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ge;(function(Ne){function je(ee){if(ee===h.EndOfLine.CRLF)return 1;if(ee===h.EndOfLine.LF)return 0}Ne.from=je;function ye(ee){if(ee===1)return h.EndOfLine.CRLF;if(ee===0)return h.EndOfLine.LF}Ne.to=ye})(Ge||(e.EndOfLine=Ge={}));var Le;(function(Ne){function je(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=je})(Le||(e.ProgressLocation=Le={}));var Ye;(function(Ne){function je(ee){const Oe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Oe.kind=se.from(ee.kind)),Oe}Ne.from=je;function ye(ee){const Oe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Oe.kind=se.to(ee.kind)),Oe}Ne.to=ye})(Ye||(e.FoldingRange=Ye={}));var se;(function(Ne){function je(ee){if(ee)switch(ee){case h.FoldingRangeKind.Comment:return o.$3t.Comment;case h.FoldingRangeKind.Imports:return o.$3t.Imports;case h.FoldingRangeKind.Region:return o.$3t.Region}}Ne.from=je;function ye(ee){if(ee)switch(ee.value){case o.$3t.Comment.value:return h.FoldingRangeKind.Comment;case o.$3t.Imports.value:return h.FoldingRangeKind.Imports;case o.$3t.Region.value:return h.FoldingRangeKind.Region}}Ne.to=ye})(se||(e.FoldingRangeKind=se={}));var ue;(function(Ne){function je(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?D.from(ye.selection):void 0,override:typeof ye.override=="boolean"?r.$bF.id:void 0}}Ne.from=je})(ue||(e.TextEditorOpenOptions=ue={}));var Ie;(function(Ne){function je(qe){return qe instanceof h.$MN?qe.toJSON():typeof qe=="string"?qe:ye(qe)||ee(qe)?new h.$MN(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Ne.from=je;function ye(qe){const _e=qe;return _e?a.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(qe){return typeof qe=="string"?qe:new h.$MN(a.URI.revive(qe.baseUri),qe.pattern)}Ne.to=Oe})(Ie||(e.GlobPattern=Ie={}));var Ke;(function(Ne){function je(ye){if(ye){if(Array.isArray(ye))return ye.map(je);if(typeof ye=="string")return ye;{const ee=ye;return{language:ee.language,scheme:ee.scheme,pattern:Ie.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Ne.from=je})(Ke||(e.LanguageSelector=Ke={}));var Me;(function(Ne){function je(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&a.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof h.$QM)))}Ne.is=je;function ye(ee){return{documents:ee.documents.map(Oe=>Oe.map(qe=>({uri:a.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>D.from(_e))})))}}Ne.from=ye})(Me||(e.MappedEditsContext=Me={}));var it;(function(Ne){function je(ee){return{start:ee.start,end:ee.end}}Ne.from=je;function ye(ee){return new h.$dO(ee.start,ee.end)}Ne.to=ye})(it||(e.NotebookRange=it={}));var lt;(function(Ne){function je(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ne.to=je;function ye(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Ne.from=ye})(lt||(e.NotebookCellExecutionSummary=lt={}));var wt;(function(Ne){function je(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Ne.to=je})(wt||(e.NotebookCellExecutionState=wt={}));var It;(function(Ne){function je(ee){switch(ee){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Ne.from=je;function ye(ee){switch(ee){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Ne.to=ye})(It||(e.NotebookCellKind=It={}));var Ft;(function(Ne){function je(ee){const Oe={metadata:ee.metadata??Object.create(null),cells:[]};for(const qe of ee.cells)h.$eO.validate(qe),Oe.cells.push(qt.from(qe));return Oe}Ne.from=je;function ye(ee){const Oe=new h.$fO(ee.cells.map(qt.to));return(0,v.$bg)(ee.metadata)||(Oe.metadata=ee.metadata),Oe}Ne.to=ye})(Ft||(e.NotebookData=Ft={}));var qt;(function(Ne){function je(ee){return{cellKind:It.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:lt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(St.from):[]}}Ne.from=je;function ye(ee){return new h.$eO(It.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(St.to):void 0,ee.metadata,ee.internalMetadata?lt.to(ee.internalMetadata):void 0)}Ne.to=ye})(qt||(e.NotebookCellData=qt={}));var xt;(function(Ne){function je(ee){return{mime:ee.mime,valueBytes:N.$ze.wrap(ee.data)}}Ne.from=je;function ye(ee){return new h.$gO(ee.valueBytes.buffer,ee.mime)}Ne.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var St;(function(Ne){function je(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Ne.from=je;function ye(ee){const Oe=ee.items.map(xt.to);return new h.$hO(Oe,ee.outputId,ee.metadata)}Ne.to=ye})(St||(e.NotebookCellOutput=St={}));var Wt;(function(Ne){function je(Oe){return ee(Oe)?{include:Ie.from(Oe.include)??void 0,exclude:Ie.from(Oe.exclude)??void 0}:Ie.from(Oe)??void 0}Ne.from=je;function ye(Oe){return ee(Oe)?{include:Ie.to(Oe.include),exclude:Ie.to(Oe.exclude)}:Ie.to(Oe)}Ne.to=ye;function ee(Oe){const qe=Oe;return qe?!(0,v.$0f)(qe.include)&&!(0,v.$0f)(qe.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Gt;(function(Ne){function je(ye,ee,Oe){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(qe,Oe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Ne.from=je})(Gt||(e.NotebookStatusBarItem=Gt={}));var et;(function(Ne){function je(ye,ee,Oe){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ee.toInternal(qe,Oe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Ne.from=je})(et||(e.NotebookKernelSourceAction=et={}));var ri;(function(Ne){function je(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Ne.from=je})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(Ne){function je(ee){return{uri:ee.uri,provides:ee.provides}}Ne.from=je;function ye(ee){return new h.$jO(a.URI.revive(ee.uri),ee.provides)}Ne.to=ye})(_t||(e.NotebookRendererScript=_t={}));var ft;(function(Ne){function je(ee){return{message:H.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:D.from(ee.location.range),uri:ee.location.uri}}}Ne.from=je;function ye(ee){const Oe=new h.$pO(typeof ee.message=="string"?ee.message:H.to(ee.message));return Oe.actualOutput=ee.actual,Oe.expectedOutput=ee.expected,Oe.contextValue=ee.contextValue,Oe.location=ee.location?re.to(ee.location):void 0,Oe}Ne.to=ye})(ft||(e.TestMessage=ft={}));var $t;(function(Ne){Ne.namespace=d.$DL,Ne.denamespace=d.$EL})($t||(e.TestTag=$t={}));var ei;(function(Ne){function je(ee){const Oe=(0,i.$6O)(ee).controllerId;return{extId:f.$yL.fromExtHostTestItem(ee,Oe).toString(),label:ee.label,uri:a.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(qe=>$t.namespace(Oe,qe.id)),range:m.$ht.lift(D.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&H.fromStrict(ee.error)||null}}Ne.from=je;function ye(ee){return{parent:void 0,error:void 0,id:f.$yL.fromString(ee.extId).localId,label:ee.label,uri:a.URI.revive(ee.uri),tags:(ee.tags||[]).map(Oe=>{const{tagId:qe}=$t.denamespace(Oe);return new h.$qO(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Ne.toPlain=ye})(ei||(e.TestItem=ei={})),function(Ne){function je(ee){return{id:ee.id}}Ne.from=je;function ye(ee){return new h.$qO(ee.id)}Ne.to=ye}($t||(e.TestTag=$t={}));var ti;(function(Ne){const je=(ee,Oe)=>{const qe=ee.value;if(!qe)return;const _e={...ei.toPlain(qe.item),parent:Oe,taskStates:qe.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const ht=je(Qe,_e);ht&&_e.children.push(ht)}return _e};function ye(ee){const Oe=new $.$YO;for(const Qe of ee.items)Oe.insert(f.$yL.fromString(Qe.item.extId).path,Qe);const qe=[Oe.nodes],_e=[];for(;qe.length;)for(const Qe of qe.pop())Qe.value?_e.push(Qe):Qe.children&&qe.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>je(Qe)).filter(v.$9f)}}Ne.to=ye})(ti||(e.TestResults=ti={}));var zt;(function(Ne){function je(qe){return{covered:qe.covered,total:qe.total}}function ye(qe){return"line"in qe?y.from(qe):D.from(qe)}function ee(qe){if(typeof qe.executed=="number"&&qe.executed<0)throw new Error(`Invalid coverage count ${qe.executed}`);return"branches"in qe?{count:qe.executed,location:ye(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:ye(qe.location)}}Ne.fromDetails=ee;function Oe(qe,_e){return h.$sO(_e.statementCoverage),h.$sO(_e.branchCoverage),h.$sO(_e.declarationCoverage),{id:qe,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Ne.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var gt;(function(Ne){function je(ye){switch(ye){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Ne.to=je})(gt||(e.CodeActionTriggerKind=gt={}));var Bt;(function(Ne){function je(ee){const Oe=new h.$xO(_.to(ee.kind),ee.name,ee.detail||"",a.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ne.to=je;function ye(ee,Oe,qe){if(Oe=Oe??ee._sessionId,qe=qe??ee._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,kind:_.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Ne.from=ye})(Bt||(e.TypeHierarchyItem=Bt={}));var ii;(function(Ne){function je(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Ne.from=je})(ii||(e.ViewBadge=ii={}));var Ot;(function(Ne){function je(qe,_e,Qe){const ht=_e.fileData;return ht?new h.$EN(new h.$FN(ht.name,a.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Qe(ht.id)))):qe===A.$Es.uriList&&_e.uriListData?new h.$DN(Oe(_e.uriListData)):new h.$DN(_e.asString)}Ne.to=je;async function ye(qe,_e){const Qe=await _e.asString();if(qe===A.$Es.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const ht=_e.asFile();return{asString:Qe,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ne.from=ye;function ee(qe){return L.$Ht.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return a.URI.parse(_e)}catch{}return _e})}function Oe(qe){return L.$Ht.create(qe.map(_e=>typeof _e=="string"?_e:a.URI.revive(_e)))}})(Ot||(e.DataTransferItem=Ot={}));var xe;(function(Ne){function je(ee,Oe){const qe=ee.items.map(([_e,Qe])=>[_e,Ot.to(_e,Qe,Oe)]);return new h.$GN(qe)}Ne.toDataTransfer=je;async function ye(ee){const Oe={items:[]},qe=[];for(const[_e,Qe]of ee)qe.push((async()=>{Oe.items.push([_e,await Ot.from(_e,Qe)])})());return await Promise.all(qe),Oe}Ne.from=ye})(xe||(e.DataTransfer=xe={}));var si;(function(Ne){function je(ee,Oe){return{kind:"reply",agentId:ee.participant??Oe?.agentId??"",subCommand:ee.command??Oe?.command,message:ee.prompt,title:ee.label}}Ne.from=je;function ye(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Ne.to=ye})(si||(e.ChatFollowup=si={}));var Kt;(function(Ne){function je(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Ne.from=je})(Kt||(e.ChatInlineFollowup=Kt={}));var Ut;(function(Ne){function je(ee){switch(ee.role){case 0:return new h.$TO(ee.content);case 1:return new h.$UO(ee.content);case 2:return new h.$VO(ee.content)}}Ne.to=je;function ye(ee){if(ee instanceof h.$TO)return{role:0,content:ee.content};if(ee instanceof h.$UO)return{role:1,content:ee.content};if(ee instanceof h.$VO)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ye})(Ut||(e.LanguageModelMessage=Ut={}));var mt;(function(Ne){function je(Oe){const qe={};for(const _e of Object.keys(Oe))qe[_e]=Oe[_e].map(Ne.to);return qe}Ne.objectTo=je;function ye(Oe){return{level:Tt.to(Oe.level),kind:Oe.kind,value:(0,a.$wc)(Oe.value)?a.URI.revive(Oe.value):Oe.value,description:Oe.description}}Ne.to=ye;function ee(Oe){return{level:Tt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Ne.from=ee})(mt||(e.ChatVariable=mt={}));var Tt;(function(Ne){function je(ee){switch(ee){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Ne.to=je;function ye(ee){switch(ee){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Ne.from=ye})(Tt||(e.ChatVariableLevel=Tt={}));var Lt;(function(Ne){function je(ye){switch(ye){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=je})(Lt||(e.InteractiveEditorResponseFeedbackKind=Lt={}));var Ht;(function(Ne){function je(ee){return{kind:"markdownContent",content:H.from(ee.value)}}Ne.from=je;function ye(ee){return new h.$KO(H.to(ee.content))}Ne.to=ye})(Ht||(e.ChatResponseMarkdownPart=Ht={}));var Jt;(function(Ne){function je(ee){const{value:Oe,baseUri:qe}=ee;function _e(Qe,ht){return Qe.map(Et=>{const jt=a.URI.joinPath(ht,Et.name);return{label:Et.name,uri:jt,children:Et.children&&_e(Et.children,jt)}})}return{kind:"treeData",treeData:{label:(0,E.$Xg)(qe),uri:qe,children:_e(Oe,qe)}}}Ne.from=je;function ye(ee){const Oe=(0,S.$Wh)(ee.treeData);function qe(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&qe(Et.children)}))}const _e=Oe.uri,Qe=Oe.children?qe(Oe.children):[];return new h.$LO(Qe,_e)}Ne.to=ye})(Jt||(e.ChatResponseFilesPart=Jt={}));var Qt;(function(Ne){function je(ee){return{kind:"inlineReference",name:ee.title,inlineReference:a.URI.isUri(ee.value)?ee.value:w.from(ee.value)}}Ne.from=je;function ye(ee){const Oe=(0,S.$Wh)(ee);return new h.$MO(a.URI.isUri(Oe.inlineReference)?Oe.inlineReference:w.to(Oe.inlineReference),ee.name)}Ne.to=ye})(Qt||(e.ChatResponseAnchorPart=Qt={}));var oi;(function(Ne){function je(ee){return{kind:"progressMessage",content:H.from(ee.value)}}Ne.from=je;function ye(ee){return new h.$NO(ee.content.value)}Ne.to=ye})(oi||(e.ChatResponseProgressPart=oi={}));var At;(function(Ne){function je(ee,Oe,qe){return{kind:"command",command:Oe.toInternal(ee.value,qe)??{command:ee.value.command,title:ee.value.title}}}Ne.from=je;function ye(ee,Oe){return new h.$OO(Oe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Ne.to=ye})(At||(e.ChatResponseCommandButtonPart=At={}));var Nt;(function(Ne){function je(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Oe=>pe.from(Oe))}}Ne.from=je;function ye(ee){return new h.$QO(a.URI.revive(ee.uri),ee.edits.map(Oe=>pe.to(Oe)))}Ne.to=ye})(Nt||(e.ChatResponseTextEditPart=Nt={}));var Pt;(function(Ne){function je(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:a.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:w.from(ee.value.value)}}:{kind:"reference",reference:a.URI.isUri(ee.value)?ee.value:w.from(ee.value)}}Ne.from=je;function ye(ee){const Oe=(0,S.$Wh)(ee),qe=_e=>a.URI.isUri(_e)?_e:w.to(_e);return new h.$PO("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&qe(Oe.reference.value)}:qe(Oe.reference))}Ne.to=ye})(Pt||(e.ChatResponseReferencePart=Pt={}));var Dt;(function(Ne){function je(Oe,qe,_e){return Oe instanceof h.$KO?Ht.from(Oe):Oe instanceof h.$MO?Qt.from(Oe):Oe instanceof h.$PO?Pt.from(Oe):Oe instanceof h.$NO?oi.from(Oe):Oe instanceof h.$LO?Jt.from(Oe):Oe instanceof h.$OO?At.from(Oe,qe,_e):Oe instanceof h.$QO?Nt.from(Oe):{kind:"content",content:""}}Ne.from=je;function ye(Oe,qe){switch(Oe.kind){case"reference":return Pt.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Oe,qe)}}Ne.to=ye;function ee(Oe,qe){switch(Oe.kind){case"markdownContent":return Ht.to(Oe);case"inlineReference":return Qt.to(Oe);case"progressMessage":return;case"treeData":return Jt.to(Oe);case"command":return At.to(Oe,qe)}}Ne.toContent=ee})(Dt||(e.ChatResponsePart=Dt={}));var bt;(function(Ne){function je(ee,Oe){return"markdownContent"in Oe?((0,c.$vG)(ee,"chatParticipantAdditions"),{content:H.from(Oe.markdownContent),kind:"markdownContent"}):"content"in Oe?"vulnerabilities"in Oe&&Oe.vulnerabilities?((0,c.$vG)(ee,"chatParticipantAdditions"),{content:Oe.content,vulnerabilities:Oe.vulnerabilities,kind:"vulnerability"}):typeof Oe.content=="string"?{content:Oe.content,kind:"content"}:((0,c.$vG)(ee,"chatParticipantAdditions"),{content:H.from(Oe.content),kind:"markdownContent"}):"documents"in Oe?{documents:Oe.documents.map(qe=>({uri:qe.uri,version:qe.version,ranges:qe.ranges.map(_e=>D.from(_e))})),kind:"usedContext"}:"reference"in Oe?{reference:"uri"in Oe.reference?{uri:Oe.reference.uri,range:D.from(Oe.reference.range)}:Oe.reference,kind:"reference"}:"inlineReference"in Oe?{inlineReference:"uri"in Oe.inlineReference?{uri:Oe.inlineReference.uri,range:D.from(Oe.inlineReference.range)}:Oe.inlineReference,name:Oe.title,kind:"inlineReference"}:"participant"in Oe?((0,c.$vG)(ee,"chatParticipantAdditions"),{agentId:Oe.participant,command:Oe.command,kind:"agentDetection"}):"message"in Oe?{content:H.from(Oe.message),kind:"progressMessage"}:void 0}Ne.from=je;function ye(ee,Oe){switch(ee.kind){case"markdownContent":return{content:ee.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(ee.inlineReference)?a.URI.revive(ee.inlineReference):w.to(ee.inlineReference),title:ee.name};case"command":return{command:Oe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title}};default:return}}Ne.toProgressContent=ye})(bt||(e.ChatResponseProgress=bt={}));var Ct;(function(Ne){function je(ye){return{prompt:ye.message,command:ye.command,variables:ye.variables.variables.map(kt.to),location:li.to(ye.location)}}Ne.to=je})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Ne){function je(ye){switch(ye){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return h.ChatLocation.Editor}}Ne.to=je})(li||(e.ChatLocation=li={}));var kt;(function(Ne){function je(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(mt.to)}}Ne.to=je})(kt||(e.ChatAgentResolvedVariable=kt={}));var hi;(function(Ne){function je(ye){return{label:ye.label,values:ye.values.map(mt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Ne.from=je})(hi||(e.ChatAgentCompletionItem=hi={}));var Yt;(function(Ne){function je(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Ne.to=je})(Yt||(e.ChatAgentResult=Yt={}));var ai;(function(Ne){function je(ye,ee,Oe){if(ee.action.kind==="vote")return;const qe=Yt.to(ye);return ee.action.kind==="command"?{action:{kind:"command",commandButton:bt.toProgressContent(ee.action.commandButton,Oe)},result:qe}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:si.to(ee.action.followup)},result:qe}:{action:ee.action,result:qe}}Ne.to=je})(ai||(e.ChatAgentUserActionEvent=ai={}));var pi;(function(Ne){function je(ye,ee,Oe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ee.toInternal(ye,Oe)}Ne.from=je})(pi||(e.TerminalQuickFix=pi={}));var ni;(function(Ne){function je(ye){return{kind:Rt.to(ye.kind)}}Ne.to=je})(ni||(e.PartialAcceptInfo=ni={}));var Rt;(function(Ne){function je(ye){switch(ye){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Ne.to=je})(Rt||(e.PartialAcceptTriggerKind=Rt={}));var yi;(function(Ne){function je(ye,ee){return{id:ee,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Ne.from=je})(yi||(e.DebugTreeItem=yi={}))}),define(ke[328],Ee([1,0,6,20,16,48]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;let M=class{constructor(p,S){this.a=p.getProxy(u.$MM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>S.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,S,A){const P=new R.$jw(L.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,A?.isRefactoring??!1)}};e.$akc=M,e.$akc=M=Je([We(0,N.$0O)],M)}),define(ke[329],Ee([1,0,19,7,47,4,45,3,39,18,2,218,25,6,16,8,292,26]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class n{constructor(t,f,d,l,c,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.n=h,this.b=p.$8d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,l),c}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const c=new a.$KO(l),h=v.ChatResponseMarkdownPart.from(c);return d(h),this},filetree(l,c){f(this.filetree);const h=new a.$LO(l,c),g=v.ChatResponseFilesPart.from(h);return d(g),this},anchor(l,c){f(this.anchor);const h=new a.$MO(l,c),g=v.ChatResponseAnchorPart.from(h);return d(g),this},button(l){f(this.anchor);const c=new a.$OO(l),h=v.ChatResponseCommandButtonPart.from(c,t.m,t.n);return d(h),this},progress(l){f(this.progress);const c=new a.$NO(l),h=v.ChatResponseProgressPart.from(c);return d(h),this},reference(l){if(f(this.reference),"variableName"in l&&!l.value){const c=t.j.variables.variables.find(h=>h.name===l.variableName);if(c){let h;if(c.references?.length)h=c.references.map(g=>({kind:"reference",reference:{variableName:l.variableName,value:g.reference}}));else{const g=new a.$PO(l);h=[v.ChatResponseReferencePart.from(g)]}return h.forEach(g=>d(g)),this}}else{const c=new a.$PO(l),h=v.ChatResponseReferencePart.from(c);d(h)}return this},textEdit(l,c){f(this.textEdit),(0,o.$vG)(t.i,"chatParticipantAdditions");const h=new a.$QO(l,c),g=v.ChatResponseTextEditPart.from(h);return d(g),this},push(l){if(f(this.push),l instanceof a.$QO&&(0,o.$vG)(t.i,"chatParticipantAdditions"),l instanceof a.$PO)this.reference(l.value);else{const c=v.ChatResponsePart.from(l,t.m,t.n);d(c)}return this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const c=v.ChatResponseProgress.from(t.i,l);if(!c){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(c),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(E.$MM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,f,d){const l=i.b++,c=new r(t,f,this.d,l,d);return this.c.set(l,c),this.d.$registerAgent(l,t.identifier,f,{},void 0),c.apiAgent}createDynamicChatAgent(t,f,d,l,c){const h=i.b++,g=new r(t,f,this.d,h,c);return this.c.set(h,g),this.d.$registerAgent(h,t.identifier,f,{isSticky:!0},{name:d,description:l}),g.apiAgent}async $invokeAgent(t,f,d,l){const c=this.c.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new b.$Tc,this.g.set(f.sessionId,h));const g=new n(c.extension,f,this.d,this.i,this.j.converter,h);try{const D=await this.k(f.agentId,d),w=c.invoke(v.ChatAgentRequest.to(f),{history:D},g.apiObject,l);return await(0,N.$bh)(Promise.resolve(w).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${C}`,c.extension),{errorDetails:{message:C},timings:g.timings}}return{errorDetails:k?.errorDetails,timings:g.timings,metadata:k?.metadata}}),l)}catch(D){return this.i.error(D,c.extension),{errorDetails:{message:(0,P.localize)(0,null,(0,L.$$i)(D)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const l of f.history){const c=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?c:{...c,metadata:void 0};d.push(new a.$RO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),l.request.agentId));const g=(0,u.$Hb)(l.response.map(D=>v.ChatResponsePart.toContent(D,this.j.converter)));d.push(new a.$SO(g,h,l.request.agentId,l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,c){const h=this.c.get(f);if(!h)return Promise.resolve([]);const g=await this.k(h.id,l),D=v.ChatAgentResult.to(d);return(await h.provideFollowups(D,{history:g},c)).filter(w=>{const k=!w.participant||M.Iterable.some(this.c.values(),y=>y.id===w.participant&&$.$Im.equals(y.extension.identifier,h.extension.identifier));return k||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),k}).map(w=>v.ChatFollowup.from(w,t))}$acceptFeedback(t,f,d,l){const c=this.c.get(t);if(!c)return;const h=v.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(l?{result:h,kind:g,reportIssue:l}:{result:h,kind:g}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(f,d,this.j.converter);c&&l.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$bkc=i;class r{constructor(t,f,d,l,c){this.extension=t,this.id=f,this.u=d,this.w=l,this.x=c,this.n=new R.$_d,this.o=new R.$_d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof a.$KN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.c??l.extension.displayName??l.extension.name},set fullName(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.c=c,d()},get iconPath(){return l.d},set iconPath(c){l.d=c,d()},get requestHandler(){return l.x},set requestHandler(c){(0,S.$$f)(typeof c=="function","Invalid request handler"),l.x=c},get followupProvider(){return l.b},set followupProvider(c){l.b=c,d()},get isDefault(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.g},set isDefault(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.g=c,d()},get helpTextPrefix(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.i},set helpTextPrefix(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.i=c,d()},get helpTextVariablesPrefix(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.j},set helpTextVariablesPrefix(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.j=c,d()},get helpTextPostfix(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.k},set helpTextPostfix(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.k=c,d()},get isSecondary(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.m},set isSecondary(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.m=c,d()},get sampleRequest(){return l.l},set sampleRequest(c){l.l=c,d()},get supportIssueReporting(){return(0,o.$vG)(l.extension,"chatParticipantAdditions"),l.p},set supportIssueReporting(c){(0,o.$vG)(l.extension,"chatParticipantAdditions"),l.p=c,d()},get onDidReceiveFeedback(){return l.n.event},set participantVariableProvider(c){if((0,o.$vG)(l.extension,"chatParticipantAdditions"),l.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");l.u.$registerAgentCompletionsProvider(l.w,c.triggerCharacters)}else l.u.$unregisterAgentCompletionsProvider(l.w)},get participantVariableProvider(){return(0,o.$vG)(l.extension,"chatParticipantAdditions"),l.q},set welcomeMessageProvider(c){(0,o.$vG)(l.extension,"defaultChatParticipant"),l.s=c,d()},get welcomeMessageProvider(){return(0,o.$vG)(l.extension,"defaultChatParticipant"),l.s},onDidPerformAction:(0,o.$uG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){l.t=c,d()},get requester(){return l.t},dispose(){t=!0,l.b=void 0,l.n.dispose(),l.u.$unregisterAgent(l.w)}}}invoke(t,f,d,l){return this.x(t,f,d,l)}}}),define(ke[330],Ee([1,0,13,3,6,16,8,26]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class p{static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(L.$MM.MainThreadChatVariables)}async $resolveVariable(P,$,E,v){const a=this.b.get(P);if(a)try{if(a.resolver.resolve2){(0,b.$vG)(a.extension,"chatParticipantAdditions");const m=new S($,this.c),o=await a.resolver.resolve2(a.data.name,{prompt:E},m.apiObject,v);if(o)return o.map(R.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:E},v);if(m)return m.map(R.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(P,$,E,v){const a=p.a++;return this.b.set(a,{extension:P,data:{name:$,description:E},resolver:v}),this.c.$registerVariable(a,{name:$,description:E}),(0,N.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$ckc=p;class S{constructor(P,$){this.c=P,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(v){if(P.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,v),a}};const P=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){$(this.progress);const a=new M.$NO(v),m=R.ChatResponseProgressPart.from(a);return E(m),this},reference(v){$(this.reference);const a=new M.$PO(v),m=R.ChatResponseReferencePart.from(a);return E(m),this},push(v){return $(this.push),v instanceof M.$PO?E(R.ChatResponseReferencePart.from(v)):v instanceof M.$NO&&E(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[331],Ee([1,0,7,55,4,3,2,83,25,16,8,6,26]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=E;function E(v,a,m){const o=v.getProxy(P.$MM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Km,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,w=this.b.get(D.commentControlHandle);if(!w)return D;const k=w.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);return w?g.$mid===8?w.value:{thread:w.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.commentUniqueId,y=w.getCommentByUniqueId(k);return y||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.text,y=g.commentUniqueId,C=w.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=k:C.body=new A.$dN(k),C):g}return g}})}createCommentController(g,D,w){const k=n.a++,y=new r(g,k,D,w);this.b.set(y.handle,y);const C=this.c.get(g.identifier)||[];return C.push(y),this.c.set(g.identifier,C),y.value}async $createCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$createCommentThreadTemplate(D,w)}async $setActiveComment(g,D){const w=this.b.get(g);w&&w.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$updateCommentThreadTemplate(D,w)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,w){const k=this.b.get(g);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(M.URI.revive(D));return(0,u.$fh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(y.document,w);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(z=>S.Range.from(z)),fileComments:C.fileComments}),I})}$toggleReaction(g,D,w,k,y){const C=this.b.get(g);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,u.$fh)(()=>{const I=C.getCommentThread(D);if(I){const z=I.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&z&&C.reactionHandler)return C.reactionHandler(z,f(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,$.$vG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,w,k,y,C,I,z){this.m=D,this.n=w,this.o=k,this.p=y,this.q=C,this.extensionDescription=I,this.r=z,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$_d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),o.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(F){j.range=F},get comments(){return j.comments},set comments(F){j.comments=F},get collapsibleState(){return j.collapsibleState},set collapsibleState(F){j.collapsibleState=F},get canReply(){return j.canReply},set canReply(F){j.canReply=F},get contextValue(){return j.contextValue},set contextValue(F){j.contextValue=F},get label(){return j.label},set label(F){j.label=F},get state(){return j.state},set state(F){j.state=F},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const g=w=>Object.prototype.hasOwnProperty.call(this.b,w),D={};g("range")&&(D.range=S.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=d(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=l(this.h)),g("applicability")&&(D.applicability=c(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const w=D[0],k=D[1];if(g===k)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,N.$Sh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,$.$vG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$vG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$vG)(this.h,"activeComment"),this.f}constructor(g,D,w,k){this.h=g,this.i=D,this.j=w,this.k=k,this.a=new Map,o.$registerCommentController(this.handle,w,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,I,z){return y.createCommentThread(C,I,z).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,w){D===void 0&&(0,$.$vG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,g,D,w,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const D=this.a.get(g.commentThreadHandle);D&&(this.e=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(g,D){const w=new i(this.id,this.handle,void 0,M.URI.revive(g),S.Range.to(D),[],this.h,!0);return w.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(g,D){const w=this.a.get(g);w&&(w.range=S.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(h,g,D,w){let k=D.get(g);return k||(k=++h.commentHandle,D.set(g,k)),g.state!==void 0&&(0,$.$vG)(w,"commentsDraftState"),g.reactions?.some(y=>y.reactors!==void 0)&&(0,$.$vG)(w,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:k,body:typeof g.body=="string"?g.body:S.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(y=>t(y)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?S.$9O(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(g=>g.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(g=>({name:g}))}}function d(h){if(h!==void 0)switch(h){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(h){let g;if(typeof h=="object"?g=h.resolved:g=h,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function c(h){let g;if(typeof h=="object"&&(g=h.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[332],Ee([1,0,22,56,3,15,23,2,16,92,111,6,8]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class E{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$Yjc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,M.$1g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const c=this.b(f,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new E(d,l);return this.a.set(c,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:c}),new $.$OM(()=>this.a.delete(d))}}class o{constructor(f,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new m,this.c=new v,this.a=f.getProxy(P.$MM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,c){const h=new L.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,S.$vkc)(f),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,S.$tkc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(g=>{const D=this.i(d,g.document.uri);if(r(g)){const w=D.addEdit(g);this.a.$onDidEdit(g.document.uri,d,w,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,S.$vkc)(f),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,S.$tkc)(f))),$.$OM.from(h,new $.$OM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,c,h){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=b.URI.revive(f),w=await g.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:c?.buffer},h);let k;return n(g.provider)&&this.f&&(k=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,w,k),{editable:n(g.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=b.URI.revive(f),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,c,h,g){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const w=p.ViewColumn.to(h),k=this.g.createNewWebview(d,c.contentOptions,D.extension),y=this.h.createNewWebviewPanel(d,l,c.title,w,c.options,k,c.active),C=b.URI.revive(f);switch(D.type){case 1:{const{document:I}=this.i(l,C);return D.provider.resolveCustomEditor(I,y,g)}case 0:{const I=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(I,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const g=b.URI.revive(d),D=this.d.getDocument(g);await c.provider.moveCustomTextEditor(D,h,u.CancellationToken.None)}async $undo(f,d,l,c){return this.i(d,f).undo(l,c)}async $redo(f,d,l,c){return this.i(d,f).redo(l,c)}async $revert(f,d,l){const c=this.i(d,f);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(f,d,l){const c=this.i(d,f);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(f,d,l,c){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),c)}async $backup(f,d,l){const c=this.i(d,f),g=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(g),g.id}i(f,d){const l=this.c.get(f,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$ykc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$bj)(f)+""}}),define(ke[333],Ee([1,0,219,138,2,6,8,16,4,12,27,60]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class E{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this.d=m,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let n=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(E.k);for(const t of m){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of f)if(c.severity===d[l]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$6jc=E;let v=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(m){const o=new A.$Bc;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new p.$de({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,$._mapper),this.f=m.getProxy(R.$MM.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,g){i.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,g.length===0?"CLEARING":g)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+$.c++;while(n.has(l))}return new class extends E{constructor(){super(o,l,$.e,$.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let o=[];for(const n of this.g.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",n=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of m)this.n.set(L.URI.revive(o),n.map(b.Diagnostic.to))}};e.$7jc=v,e.$7jc=v=$=Je([We(1,S.$Tj),We(2,P.$5jc)],v)}),define(ke[334],Ee([1,0,2,13,8,16,75,48]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class p{constructor(A,P,$,E={timeout:1500,errors:3}){this.c=A,this.d=P,this.f=$,this.g=E,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(P,$,E)=>{const a={dispose:this.a.push([P,$,A])};return Array.isArray(E)&&E.push(a),a}}async $participateInSave(A,P){const $=u.URI.revive(A);let E=!1;const v=setTimeout(()=>E=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(E)break;const o=this.d.getDocument($),n=await this.h(m,{document:o,reason:R.TextDocumentSaveReason.to(P)});a.push(n)}}finally{clearTimeout(v)}return a}h([A,P,$],E){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i($,A,P,E).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(A);this.b.set(A,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,P,$,E){const v=[],a=Date.now(),{document:m,reason:o}=E,{version:n}=m,i=Object.freeze({document:m,reason:o,waitUntil(r){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{P.apply($,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),r(f)}).catch(f=>{clearTimeout(t),s(f)})}).then(r=>{const s={edits:[]};for(const t of r)if(Array.isArray(t)&&t.every(f=>f instanceof L.$VM))for(const{newText:f,newEol:d,range:l}of t)s.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:f,eol:d&&R.EndOfLine.from(d)}});if(s.edits.length!==0)return n===m.version?this.f.$tryApplyWorkspaceEdit(new b.$jw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$clc=p}),define(ke[335],Ee([1,0,4,3,2,6,152,16,18,24,8]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class P{constructor(E,v){this.a=new u.$_d,this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=E.getProxy(R.$MM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let a=this.h.get(E.toString());return a||(a=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const o=L.URI.revive(m);return(0,p.$_f)(this.g.getDocument(o))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),a)),a}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(E,v){const a=L.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(E){const v=L.URI.revive(E),a=this.g.getDocument(v);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(E,v){const a=L.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,a){const m=L.URI.revive(E),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(a),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Un)({document:o.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(E,v){(0,M.$_O)(E,v)}}e.$8jc=P}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,8]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=e.$zkc=void 0,e.$zkc=(0,M.$ni)("IExtHostEditorTabs");class P{constructor(m,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$yO(R.URI.revive(this.b.input.uri));case 2:return new A.$zO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$AO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$BO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$CO(this.b.input.viewType);case 4:return new A.$DO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$EO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$FO;case 9:return new A.$GO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$HO;case 11:return new A.$IO(this.b.input.diffEditors.map(m=>new A.$zO(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class ${constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return S.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const o=this.c.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new N.$_d,this.c=new N.$_d,this.e=[],this.a=m.getProxy(b.$MM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,L.$_f)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new $(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,L.$_f)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(m,o){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$Akc=E,e.$Akc=E=Je([We(0,p.$0O)],E);function v(a){return a.tabs!==void 0}}),define(ke[336],Ee([1,0,2,6,3,8,16,180,14,21,26,80]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class ${constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let o,n,i=14,r=14;for(const s of a){let t=o?(0,p.$sf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new b.$W2(m)}}provideDocumentLinks(a){this.c();const m=[],o=b.$X2.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&m.push(i)}return m}}class E{constructor(a,m){this.i=m,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(N.$MM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,o,n={}){if(E.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$vG)(a,"fsChunks"),r+=4);let s;n.isReadonly&&(0,P.$Mk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:c,type:h}=l;if(c.scheme!==m)continue;let g;switch(h){case R.FileChangeType.Changed:g=0;break;case R.FileChangeType.Created:g=1;break;case R.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:g})}this.a.$onFileSystemChange(i,d)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=a;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(u.URI.revive(m))).then(o=>E.k(o))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(u.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(u.URI.revive(m))).then(o=>S.$ze.wrap(o))}$writeFile(a,m,o,n){return Promise.resolve(this.l(a).writeFile(u.URI.revive(m),o.buffer,n))}$delete(a,m,o){return Promise.resolve(this.l(a).delete(u.URI.revive(m),o))}$rename(a,m,o,n){return Promise.resolve(this.l(a).rename(u.URI.revive(m),u.URI.revive(o),n))}$copy(a,m,o,n){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(o),n))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(u.URI.revive(m)))}$watch(a,m,o,n){const i=this.l(a).watch(u.URI.revive(o),n);this.f.set(m,i)}$unwatch(a,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(a,m,o){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),o))}$close(a,m){const o=this.l(a);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(a,m,o,n){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=S.$ze.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(a,m,o,n){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}l(a){const m=this.c.get(a);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$elc=E}),define(ke[337],Ee([1,0,4,35,2,6,16,8,46]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,a,m,o,n){this.a=Math.random(),this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$hk)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$OM.from(this.i(E,a,o,n,n?.correlate),this.b,this.c,this.d,t)}i(E,v,a,m,o){const n=b.$OM.from();if(typeof a=="string")return n;const i=E.getProxy(R.$MM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(N.$dk)||a.pattern.includes(N.$ek))&&(r=!0),i.$watch(v.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),b.$OM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(E){this.a=E,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(L.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(E,v,a){this.j=E,this.k=v,this.l=a,this.a=new u.$_d,this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.g=new u.$be,this.h=new u.$be,this.i=new u.$be,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,a,m){return new S(this.j,E,v,this.a.event,M.GlobPattern.from(a),m)}$onFileEvent(E){this.a.fire(new A(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(a,m,o)=>{const n=function(r){a.call(m,r)};return n.extension=E,v.event(n,void 0,o)}}async $onWillRunFileOperation(E,v,a,m){switch(E){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},a,m);case 1:return await this.n(this.i,{files:v.map(o=>L.URI.revive(o.target))},a,m);case 0:case 3:return await this.n(this.h,{files:v.map(o=>L.URI.revive(o.target))},a,m)}}async n(E,v,a,m){const o=new Set,n=[];if(await E.fireAsync(v,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.$YM&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$flc=P}),define(ke[338],Ee([1,0,19,7,22,13,124,3,24,39,14,18,2,29,176,83,134,221,25,16,8,26,111,6]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class d{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const Q=this.d.getDocument(V),J=await this.e.provideDocumentSymbols(Q,W);if(!(0,u.$Kb)(J))return J[0]instanceof r.$8M?J.map(i.DocumentSymbol.from):d.f(J)}static f(V){V=V.slice(0).sort((J,fe)=>{let we=J.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(J.location.range.end)),we});const W=[],Q=[];for(const J of V){const fe={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(fe),W.push(fe);break}const we=Q[Q.length-1];if(E.$ht.containsRange(we.range,fe.range)&&!E.$ht.equalsRange(we.range,fe.range)){we.children?.push(fe),Q.push(fe);break}Q.pop()}}return W}}class l{constructor(V,W,Q,J,fe,we){this.f=V,this.g=W,this.h=Q,this.j=J,this.k=fe,this.l=we,this.d=new t.$Yjc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const Q=this.f.getDocument(V),J=await this.h.provideCodeLenses(Q,W);if(!J||W.isCancellationRequested)return;const fe=this.d.add(J),we=new b.$Tc;this.e.set(fe,we);const ze={cacheId:fe,lenses:[]};for(let Ve=0;Ve<J.length;Ve++)ze.lenses.push({cacheId:[fe,Ve],range:i.Range.from(J[Ve].range),command:this.g.toInternal(J[Ve].command,we)});return ze}async resolveCodeLens(V,W){const Q=V.cacheId&&this.d.get(...V.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,W),J||(J=Q),W.isCancellationRequested)return;const fe=V.cacheId&&this.e.get(V.cacheId[0]);if(fe){if(!J.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(J.command,fe),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function c(Fe){return Array.isArray(Fe)?Fe.map(i.DefinitionLink.from):Fe?[i.DefinitionLink.from(Fe)]:[]}class h{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideDefinition(J,fe,Q);return c(we)}}class g{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideDeclaration(J,fe,Q);return c(we)}}class D{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideImplementation(J,fe,Q);return c(we)}}class w{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideTypeDefinition(J,fe,Q);return c(we)}}class k{constructor(V,W){this.d=V,this.e=W}async provideHover(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideHover(J,fe,Q);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$QM(fe,fe)),i.Hover.from(we)}}class y{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideEvaluatableExpression(J,fe,Q);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,Q,J){const fe=this.d.getDocument(V),we=await this.e.provideInlineValues(fe,i.Range.to(W),i.InlineValueContext.to(Q),J);if(Array.isArray(we))return we.map(ze=>i.InlineValue.from(ze))}}class I{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideDocumentHighlights(J,fe,Q);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class z{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,Q,J){const fe=this.d.getDocument(V),we=Q.map(Xe=>this.d.getDocument(Xe)),ze=i.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(fe,ze,we,J);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class j{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,Q){const J=this.d.getDocument(V),fe=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(J,fe,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class F{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,Q,J){const fe=this.d.getDocument(V),we=i.Position.to(W),ze=await this.e.provideReferences(fe,we,Q,J);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(V,W,Q,J,fe,we,ze){this.g=V,this.h=W,this.j=Q,this.k=J,this.l=fe,this.m=we,this.n=ze,this.e=new t.$Yjc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,Q,J){const fe=this.g.getDocument(V),we=v.$jt.isISelection(W)?i.Selection.to(W):i.Range.to(W),ze=[];for(const rt of this.j.getDiagnostics(V))if(we.intersection(rt.range)&&ze.push(rt)>O.d)break;const Ve={diagnostics:ze,only:Q.only?new r.$0M(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Xe=await this.k.provideCodeActions(fe,we,Ve,J);if(!(0,u.$Lb)(Xe)||J.isCancellationRequested)return;const st=this.e.add(Xe),ot=new b.$Tc;this.f.set(st,ot);const tt=[];for(let rt=0;rt<Xe.length;rt++){const Se=Xe[rt];if(Se)if(O.o(Se))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Se.title,command:this.h.toInternal(Se,ot)});else{Ve.only&&(Se.kind?Ve.only.contains(Se.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${Se.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Se.ranges??[];tt.push({cacheId:[st,rt],title:Se.title,command:Se.command&&this.h.toInternal(Se.command,ot),diagnostics:Se.diagnostics&&Se.diagnostics.map(i.Diagnostic.from),edit:Se.edit&&i.WorkspaceEdit.from(Se.edit,void 0),kind:Se.kind&&Se.kind.value,isPreferred:Se.isPreferred,isAI:(0,s.$uG)(this.m,"codeActionAI")?Se.isAI:!1,ranges:(0,s.$uG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Se.disabled?.reason})}}return{cacheId:st,actions:tt}}async resolveCodeAction(V,W){const[Q,J]=V,fe=this.e.get(Q,J);if(!fe||O.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,W)??fe;let ze;we.edit&&(ze=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Xe=this.f.get(Q);Xe&&(Ve=this.h.toInternal(we.command,Xe))}return{edit:ze,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class T{constructor(V,W,Q,J,fe){this.e=V,this.f=W,this.g=Q,this.h=J,this.j=fe,this.d=new t.$Yjc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,Q,J){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(V),we=W.map(Xe=>i.Range.to(Xe)),ze=i.DataTransfer.toDataTransfer(Q,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(fe,we,ze,J),J.isCancellationRequested)return;const Ve=Array.from(ze).filter(([,Xe])=>!(Xe instanceof r.$DN));return i.DataTransfer.from(Ve)}async providePasteEdits(V,W,Q,J,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(W),Ve=Q.map(tt=>i.Range.to(tt)),Xe=i.DataTransfer.toDataTransfer(J,async tt=>(await this.e.$resolvePasteFileData(this.h,V,tt)).buffer),st=await this.g.provideDocumentPasteEdits(ze,Ve,Xe,{only:fe.only?new r.$IN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!st||we.isCancellationRequested)return[];const ot=this.d.add(st);return st.map((tt,rt)=>({_cacheId:[ot,rt],title:tt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(Se=>Se.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[Q,J]=V,fe=this.d.get(Q,J);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,W)??fe;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,Q){const J=this.d.getDocument(V),fe=await this.e.provideDocumentFormattingEdits(J,W,Q);if(Array.isArray(fe))return fe.map(i.TextEdit.from)}}class H{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,Q,J){const fe=this.d.getDocument(V),we=i.Range.to(W),ze=await this.e.provideDocumentRangeFormattingEdits(fe,we,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,Q,J){(0,P.$$f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(V),we=W.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(fe,we,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class X{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,Q,J,fe){const we=this.d.getDocument(V),ze=i.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(we,ze,Q,J,fe);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class x{constructor(V,W){this.e=V,this.f=W,this.d=new t.$Yjc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const Q=await this.e.provideWorkspaceSymbols(V,W);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),fe={cacheId:J,symbols:[]};for(let we=0;we<Q.length;we++){const ze=Q[we];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}fe.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[J,we]})}return fe}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Q=this.d.get(...V.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,W);return J&&(0,p.$Wn)(V,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class Y{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,Q){this.d=V,this.e=W,this.f=Q}async provideRenameEdits(V,W,Q,J){const fe=this.d.getDocument(V),we=i.Position.to(W);try{const ze=await this.e.provideRenameEdits(fe,we,Q,J);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const Ve=Y.g(ze);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(V,W,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(V),fe=i.Position.to(W);try{const we=await this.e.prepareRename(J,fe,Q);let ze,Ve;if(r.$QM.isRange(we)?(ze=we,Ve=J.getText(we)):(0,P.$3f)(we)&&(ze=we.range,Ve=we.placeholder),!ze||!Ve)return;if(ze.start.line>fe.line||ze.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:Ve}}catch(we){const ze=Y.g(we);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class Z{constructor(V,W,Q){this.d=V,this.e=W,this.f=Q}async provideNewSymbolNames(V,W,Q){const J=this.d.getDocument(V),fe=i.Range.to(W);try{const we=await this.e.provideNewSymbolNames(J,fe,Q);return we?we.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(we){this.f.error(Z.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ce{constructor(V,W){this.resultId=V,this.tokens=W}}class ie{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,Q){const J=this.f.getDocument(V),fe=W!==0?this.d.get(W):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,fe.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return fe&&this.d.delete(W),we?(we=ie.h(we),this.o(ie.n(fe,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ie.j(V)?ie.k(V)?V:new r.$9N(new Uint32Array(V.data),V.resultId):ie.l(V)?ie.m(V)?V:new r.$$N(V.edits.map(W=>new r.$0N(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!ie.j(W)||!V||!V.tokens)return W;const Q=V.tokens,J=Q.length,fe=W.data,we=fe.length;let ze=0;const Ve=Math.min(J,we);for(;ze<Ve&&Q[ze]===fe[ze];)ze++;if(ze===J&&ze===we)return new r.$$N([],W.resultId);let Xe=0;const st=Ve-ze;for(;Xe<st&&Q[J-Xe-1]===fe[we-Xe-1];)Xe++;return new r.$$N([{start:ze,deleteCount:J-ze-Xe,data:fe.subarray(ze,we-Xe)}],W.resultId)}o(V,W){if(ie.j(V)){const Q=this.e++;return this.d.set(Q,new ce(V.resultId,V.data)),(0,m.$dbb)({id:Q,type:"full",data:V.data})}if(ie.l(V)){const Q=this.e++;return ie.j(W)?this.d.set(Q,new ce(W.resultId,W.data)):this.d.set(Q,new ce(V.resultId)),(0,m.$dbb)({id:Q,type:"delta",deltas:(V.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class pe{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,Q){const J=this.d.getDocument(V),fe=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(W),Q);return fe?this.f(fe):null}f(V){return(0,m.$dbb)({id:0,type:"full",data:V.data})}}class Ce{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,Q,J,fe){this.f=V,this.g=W,this.h=Q,this.j=J,this.k=fe,this.d=new t.$Yjc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,Q,J){const fe=this.f.getDocument(V),we=i.Position.to(W),ze=fe.getWordRangeAtPosition(we)||new r.$QM(we,we),Ve=ze.with({end:we}),Xe=new S.$8d,st=await this.h.provideCompletionItems(fe,we,J,i.CompletionContext.to(Q));if(!st||J.isCancellationRequested)return;const ot=Array.isArray(st)?new r.$kN(st):st,tt=Ce.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),rt=new b.$Tc;this.e.set(tt,rt);const Se=[],Be={x:tt,b:Se,a:{replace:i.Range.from(ze),insert:i.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Xe.elapsed()};for(let Ge=0;Ge<ot.items.length;Ge++){const Le=ot.items[Ge],Ye=this.l(Le,[tt,Ge],Ve,ze);Se.push(Ye)}return Be}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=this.l(Q,V),fe=await this.h.resolveCompletionItem(Q,W);if(!fe)return;const we=this.l(fe,V);return(J.h!==we.h||J.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==we.n||J.o!==we.o||!(0,p.$Xn)(J.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,Q,J){const fe=this.e.get(W[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,fe),ze={x:W,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=V.textEdit.newText):typeof V.insertText=="string"?ze.h=V.insertText:V.insertText instanceof r.$ZM&&(ze.h=V.insertText.value,ze.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),r.$QM.isRange(Ve)?ze.j=i.Range.from(Ve):Ve&&(!Q?.isEqual(Ve.inserting)||!J?.isEqual(Ve.replacing))&&(ze.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),ze}}class _{async provideInlineCompletions(V,W,Q,J){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,Q){}handlePartialAccept(V,W,Q,J){}}class U extends _{constructor(V,W,Q,J){super(),this.f=V,this.g=W,this.h=Q,this.j=J,this.d=new be,this.e=(0,s.$uG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$uG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,Q,J){const fe=this.g.getDocument(V),we=i.Position.to(W),ze=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!ze||J.isCancellationRequested)return;const Ve=Array.isArray(ze)?ze:ze.items,Xe=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],st=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((rt,Se)=>{let Be;rt.command&&(ot||(ot=new b.$Tc),Be=this.j.toInternal(rt.command,ot));const Ge=rt.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:Be,idx:Se,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Xe.map(rt=>(ot||(ot=new b.$Tc),this.j.toInternal(rt,ot))),suppressSuggestions:!1,enableForwardStability:st}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,Q){const J=this.d.get(V)?.items[W];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(V,W,Q,J){const fe=this.d.get(V)?.items[W];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Q),this.h.handleDidPartiallyAcceptCompletionItem(fe,i.PartialAcceptInfo.to(J)))}}class ne{async provideInlineEdits(V,W,Q){const J=this.f.getDocument(V),fe=await this.g.provideInlineEdit(J,{triggerKind:this.e[W.triggerKind]},Q);if(!fe||Q.isCancellationRequested)return;let we;const ze=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ve;fe.accepted&&(we||(we=new b.$Tc),Ve=this.h.toInternal(fe.accepted,we));let Xe;return fe.rejected&&(we||(we=new b.$Tc),Xe=this.h.toInternal(fe.rejected,we)),{pid:ze,text:fe.text,range:i.Range.from(fe.range),accepted:Ve,rejected:Xe}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,Q,J){this.f=W,this.g=Q,this.h=J,this.d=new be,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class De{constructor(V,W){this.e=V,this.f=W,this.d=new t.$Yjc("SignatureHelp")}async provideSignatureHelp(V,W,Q,J){const fe=this.e.getDocument(V),we=i.Position.to(W),ze=this.g(Q),Ve=await this.f.provideSignatureHelp(fe,we,J,ze);if(Ve){const Xe=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Xe}}}g(V){let W;if(V.activeSignatureHelp){const Q=i.SignatureHelp.to(V.activeSignatureHelp),J=this.d.get(V.activeSignatureHelp.id,0);J?(W=J,W.activeSignature=Q.activeSignature,W.activeParameter=Q.activeParameter):W=Q}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class oe{constructor(V,W,Q,J,fe){this.f=V,this.g=W,this.h=Q,this.j=J,this.k=fe,this.d=new t.$Yjc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,Q){const J=this.f.getDocument(V),fe=i.Range.to(W),we=await this.h.provideInlayHints(J,fe,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(Q.isCancellationRequested)return;const ze=this.d.add(we);this.e.set(ze,new b.$Tc);const Ve={hints:[],cacheId:ze};for(let Xe=0;Xe<we.length;Xe++)this.l(we[Xe],fe)&&Ve.hints.push(this.m(we[Xe],[ze,Xe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.h.resolveInlayHint(Q,W);if(J&&this.l(J))return this.m(J,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const Q=this.e.get(W[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")J.label=V.label;else{const fe=[];J.label=fe;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};r.$1M.isLocation(we.location)&&(ze.location=i.location.from(we.location)),we.command&&(ze.command=this.g.toInternal(we.command,Q)),fe.push(ze)}}return J}}class ae{constructor(V,W){this.e=V,this.f=W,this.d=new t.$Yjc("DocumentLink")}async provideLinks(V,W){const Q=this.e.getDocument(V),J=await this.f.provideDocumentLinks(Q,W);if(!(!Array.isArray(J)||J.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ae.g).map(i.DocumentLink.from)};{const fe=this.d.add(J),we={links:[],cacheId:fe};for(let ze=0;ze<J.length;ze++){if(!ae.g(J[ze]))continue;const Ve=i.DocumentLink.from(J[ze]);Ve.cacheId=[fe,ze],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,W);if(!(!J||!ae.g(J)))return i.DocumentLink.from(J)}releaseLinks(V){this.d.delete(V)}}class re{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const Q=this.d.getDocument(V),J=await this.e.provideDocumentColors(Q,W);return Array.isArray(J)?J.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,W,Q){const J=this.d.getDocument(V),fe=i.Range.to(W.range),we=i.Color.to(W.color),ze=await this.e.provideColorPresentations(we,{document:J,range:fe},Q);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class K{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,Q){const J=this.d.getDocument(V),fe=await this.e.provideFoldingRanges(J,W,Q);if(Array.isArray(fe))return fe.map(i.FoldingRange.from)}}class te{constructor(V,W,Q){this.d=V,this.e=W,this.f=Q}async provideSelectionRanges(V,W,Q){const J=this.d.getDocument(V),fe=W.map(i.Position.to),we=await this.e.provideSelectionRanges(J,fe,Q);if(!(0,u.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let Ve=0;Ve<fe.length;Ve++){const Xe=[];ze.push(Xe);let st=fe[Ve],ot=we[Ve];for(;;){if(!ot.range.contains(st))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(ot)),!ot.parent)break;st=ot.range,ot=ot.parent}}return ze}}class le{constructor(V,W){this.f=V,this.g=W,this.d=new M.$cP(""),this.e=new Map}async prepareSession(V,W,Q){const J=this.f.getDocument(V),fe=i.Position.to(W),we=await this.g.prepareCallHierarchy(J,fe,Q);if(!we)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(we)?we.map(Ve=>this.h(ze,Ve)):[this.h(ze,we)]}async provideCallsTo(V,W,Q){const J=this.j(V,W);if(!J)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(fe)return fe.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(V,W,Q){const J=this.j(V,W);if(!J)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(fe)return fe.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(V){this.e.delete(V)}h(V,W){const Q=this.e.get(V),J=i.CallHierarchyItem.from(W,V,Q.size.toString(36));return Q.set(J._itemId,W),J}j(V,W){return this.e.get(V)?.get(W)}}class de{constructor(V,W){this.f=V,this.g=W,this.d=new M.$cP(""),this.e=new Map}async prepareSession(V,W,Q){const J=this.f.getDocument(V),fe=i.Position.to(W),we=await this.g.prepareTypeHierarchy(J,fe,Q);if(!we)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(we)?we.map(Ve=>this.h(ze,Ve)):[this.h(ze,we)]}async provideSupertypes(V,W,Q){const J=this.j(V,W);if(!J)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(J,Q);if(fe)return fe.map(we=>this.h(V,we))}async provideSubtypes(V,W,Q){const J=this.j(V,W);if(!J)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(J,Q);if(fe)return fe.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,W){const Q=this.e.get(V),J=i.TypeHierarchyItem.from(W,V,Q.size.toString(36));return Q.set(J._itemId,W),J}j(V,W){return this.e.get(V)?.get(W)}}class Ae{constructor(V,W,Q,J,fe){this.e=V,this.f=W,this.g=Q,this.h=J,this.j=fe,this.d=new t.$Yjc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,Q,J,fe){const we=this.f.getDocument(W),ze=i.Position.to(Q),Ve=i.DataTransfer.toDataTransfer(J,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,tt)).buffer),Xe=await this.g.provideDocumentDropEdits(we,ze,Ve,fe);if(!Xe)return;const st=(0,u.$3b)(Xe),ot=this.d.add(st);return st.map((tt,rt)=>({_cacheId:[ot,rt],title:tt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(Se=>Se.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[Q,J]=V,fe=this.d.get(Q,J);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,W)??fe;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class me{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,Q,J){const fe=$.URI.revive(V),we=this.d.getDocument(fe),ze=Q.documents.map(st=>st.map(ot=>({uri:$.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(tt=>i.Range.to(tt))}))),Ve={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(we,W,Ve,J);return Xe?i.WorkspaceEdit.from(Xe):null}}class Pe{constructor(V,W){this.adapter=V,this.extension=W}}class Re{static{this.d=0}constructor(V,W,Q,J,fe,we,ze,Ve){this.g=W,this.h=Q,this.j=J,this.k=fe,this.l=we,this.m=ze,this.n=Ve,this.f=new Map,this.e=V.getProxy(f.$MM.MainThreadLanguageFeatures)}o(V,W){return i.DocumentSelector.from(V,this.g,W)}p(V){return new r.$OM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Re.d++}async s(V,W,Q,J,fe,we=!1){const ze=this.f.get(V);if(!ze||!(ze.adapter instanceof W))return J;const Ve=Date.now();we||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Xe=Q(ze.adapter,ze.extension);return Promise.resolve(Xe).catch(st=>{(0,R.$4)(st)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(st),this.n.onExtensionError(ze.extension.identifier,st))}).finally(()=>{we||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(fe)?(0,N.$ch)(Xe,fe):Xe}t(V,W){const Q=this.q();return this.f.set(Q,new Pe(V,W)),Q}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,W,Q,J){const fe=this.t(new d(this.h,Q),V),we=J&&J.label||Re.u(V);return this.e.$registerDocumentSymbolProvider(fe,this.o(W,V),we),this.p(fe)}$provideDocumentSymbols(V,W,Q){return this.s(V,d,J=>J.provideDocumentSymbols($.URI.revive(W),Q),void 0,Q)}registerCodeLensProvider(V,W,Q){const J=this.q(),fe=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Pe(new l(this.h,this.j.converter,Q,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(J,this.o(W,V),fe);let we=this.p(J);if(fe!==void 0){const ze=Q.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(fe));we=r.$OM.from(we,ze)}return we}$provideCodeLenses(V,W,Q){return this.s(V,l,J=>J.provideCodeLenses($.URI.revive(W),Q),void 0,Q)}$resolveCodeLens(V,W,Q){return this.s(V,l,J=>J.resolveCodeLens(W,Q),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,l,Q=>Promise.resolve(Q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,Q){const J=this.t(new h(this.h,Q),V);return this.e.$registerDefinitionSupport(J,this.o(W,V)),this.p(J)}$provideDefinition(V,W,Q,J){return this.s(V,h,fe=>fe.provideDefinition($.URI.revive(W),Q,J),[],J)}registerDeclarationProvider(V,W,Q){const J=this.t(new g(this.h,Q),V);return this.e.$registerDeclarationSupport(J,this.o(W,V)),this.p(J)}$provideDeclaration(V,W,Q,J){return this.s(V,g,fe=>fe.provideDeclaration($.URI.revive(W),Q,J),[],J)}registerImplementationProvider(V,W,Q){const J=this.t(new D(this.h,Q),V);return this.e.$registerImplementationSupport(J,this.o(W,V)),this.p(J)}$provideImplementation(V,W,Q,J){return this.s(V,D,fe=>fe.provideImplementation($.URI.revive(W),Q,J),[],J)}registerTypeDefinitionProvider(V,W,Q){const J=this.t(new w(this.h,Q),V);return this.e.$registerTypeDefinitionSupport(J,this.o(W,V)),this.p(J)}$provideTypeDefinition(V,W,Q,J){return this.s(V,w,fe=>fe.provideTypeDefinition($.URI.revive(W),Q,J),[],J)}registerHoverProvider(V,W,Q,J){const fe=this.t(new k(this.h,Q),V);return this.e.$registerHoverProvider(fe,this.o(W,V)),this.p(fe)}$provideHover(V,W,Q,J){return this.s(V,k,fe=>fe.provideHover($.URI.revive(W),Q,J),void 0,J)}registerEvaluatableExpressionProvider(V,W,Q,J){const fe=this.t(new y(this.h,Q),V);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(W,V)),this.p(fe)}$provideEvaluatableExpression(V,W,Q,J){return this.s(V,y,fe=>fe.provideEvaluatableExpression($.URI.revive(W),Q,J),void 0,J)}registerInlineValuesProvider(V,W,Q,J){const fe=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,Q),V);this.e.$registerInlineValuesProvider(we,this.o(W,V),fe);let ze=this.p(we);if(fe!==void 0){const Ve=Q.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(fe));ze=r.$OM.from(ze,Ve)}return ze}$provideInlineValues(V,W,Q,J,fe){return this.s(V,C,we=>we.provideInlineValues($.URI.revive(W),Q,J,fe),void 0,fe)}registerDocumentHighlightProvider(V,W,Q){const J=this.t(new I(this.h,Q),V);return this.e.$registerDocumentHighlightProvider(J,this.o(W,V)),this.p(J)}registerMultiDocumentHighlightProvider(V,W,Q){const J=this.t(new z(this.h,Q),V);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(W,V)),this.p(J)}$provideDocumentHighlights(V,W,Q,J){return this.s(V,I,fe=>fe.provideDocumentHighlights($.URI.revive(W),Q,J),void 0,J)}$provideMultiDocumentHighlights(V,W,Q,J,fe){return this.s(V,z,we=>we.provideMultiDocumentHighlights($.URI.revive(W),Q,J.map(ze=>$.URI.revive(ze)),fe),void 0,fe)}registerLinkedEditingRangeProvider(V,W,Q){const J=this.t(new j(this.h,Q),V);return this.e.$registerLinkedEditingRangeProvider(J,this.o(W,V)),this.p(J)}$provideLinkedEditingRanges(V,W,Q,J){return this.s(V,j,async fe=>{const we=await fe.provideLinkedEditingRanges($.URI.revive(W),Q,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(V,W,Q){const J=this.t(new F(this.h,Q),V);return this.e.$registerReferenceSupport(J,this.o(W,V)),this.p(J)}$provideReferences(V,W,Q,J,fe){return this.s(V,F,we=>we.provideReferences($.URI.revive(W),Q,J,fe),void 0,fe)}registerCodeActionProvider(V,W,Q,J){const fe=new b.$Tc,we=this.t(new O(this.h,this.j.converter,this.k,Q,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(W,V),{providedKinds:J?.providedCodeActionKinds?.map(ze=>ze.value),documentation:J?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,fe)}))},Re.u(V),!!Q.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(V,W,Q,J,fe){return this.s(V,O,we=>we.provideCodeActions($.URI.revive(W),Q,J,fe),void 0,fe)}$resolveCodeAction(V,W,Q){return this.s(V,O,J=>J.resolveCodeAction(W,Q),{},void 0)}$releaseCodeActions(V,W){this.s(V,O,Q=>Promise.resolve(Q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,Q){const J=this.t(new B(this.h,Q),V);return this.e.$registerDocumentFormattingSupport(J,this.o(W,V),V.identifier,V.displayName||V.name),this.p(J)}$provideDocumentFormattingEdits(V,W,Q,J){return this.s(V,B,fe=>fe.provideDocumentFormattingEdits($.URI.revive(W),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(V,W,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",fe=this.t(new H(this.h,Q),V);return this.e.$registerRangeFormattingSupport(fe,this.o(W,V),V.identifier,V.displayName||V.name,J),this.p(fe)}$provideDocumentRangeFormattingEdits(V,W,Q,J,fe){return this.s(V,H,we=>we.provideDocumentRangeFormattingEdits($.URI.revive(W),Q,J,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(V,W,Q,J,fe){return this.s(V,H,we=>we.provideDocumentRangesFormattingEdits($.URI.revive(W),Q,J,fe),void 0,fe)}registerOnTypeFormattingEditProvider(V,W,Q,J){const fe=this.t(new X(this.h,Q),V);return this.e.$registerOnTypeFormattingSupport(fe,this.o(W,V),J,V.identifier),this.p(fe)}$provideOnTypeFormattingEdits(V,W,Q,J,fe,we){return this.s(V,X,ze=>ze.provideOnTypeFormattingEdits($.URI.revive(W),Q,J,fe,we),void 0,we)}registerWorkspaceSymbolProvider(V,W){const Q=this.t(new x(W,this.l),V);return this.e.$registerNavigateTypeSupport(Q,typeof W.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(V,W,Q){return this.s(V,x,J=>J.provideWorkspaceSymbols(W,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(V,W,Q){return this.s(V,x,J=>J.resolveWorkspaceSymbol(W,Q),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,x,Q=>Q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,Q){const J=this.t(new Y(this.h,Q,this.l),V);return this.e.$registerRenameSupport(J,this.o(W,V),Y.supportsResolving(Q)),this.p(J)}$provideRenameEdits(V,W,Q,J,fe){return this.s(V,Y,we=>we.provideRenameEdits($.URI.revive(W),Q,J,fe),void 0,fe)}$resolveRenameLocation(V,W,Q,J){return this.s(V,Y,fe=>fe.resolveRenameLocation($.URI.revive(W),Q,J),void 0,J)}registerNewSymbolNamesProvider(V,W,Q){const J=this.t(new Z(this.h,Q,this.l),V);return this.e.$registerNewSymbolNamesProvider(J,this.o(W,V)),this.p(J)}$provideNewSymbolNames(V,W,Q,J){return this.s(V,Z,fe=>fe.provideNewSymbolNames($.URI.revive(W),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(V,W,Q,J){const fe=this.t(new ie(this.h,Q),V),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(W,V),J,we);let ze=this.p(fe);if(we){const Ve=Q.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(we));ze=r.$OM.from(ze,Ve)}return ze}$provideDocumentSemanticTokens(V,W,Q,J){return this.s(V,ie,fe=>fe.provideDocumentSemanticTokens($.URI.revive(W),Q,J),null,J)}$releaseDocumentSemanticTokens(V,W){this.s(V,ie,Q=>Q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,Q,J){const fe=this.t(new pe(this.h,Q),V);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(W,V),J),this.p(fe)}$provideDocumentRangeSemanticTokens(V,W,Q,J){return this.s(V,pe,fe=>fe.provideDocumentRangeSemanticTokens($.URI.revive(W),Q,J),null,J)}registerCompletionItemProvider(V,W,Q,J){const fe=this.t(new Ce(this.h,this.j.converter,Q,this.m,V),V);return this.e.$registerCompletionsProvider(fe,this.o(W,V),J,Ce.supportsResolving(Q),V.identifier),this.p(fe)}$provideCompletionItems(V,W,Q,J,fe){return this.s(V,Ce,we=>we.provideCompletionItems($.URI.revive(W),Q,J,fe),void 0,fe)}$resolveCompletionItem(V,W,Q){return this.s(V,Ce,J=>J.resolveCompletionItem(W,Q),void 0,Q)}$releaseCompletionItems(V,W){this.s(V,Ce,Q=>Q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,Q,J){const fe=new U(V,this.h,Q,this.j.converter),we=this.t(fe,V);return this.e.$registerInlineCompletionsSupport(we,this.o(W,V),fe.supportsHandleEvents,n.$Im.toKey(V.identifier.value),J?.yieldTo?.map(ze=>n.$Im.toKey(ze))||[]),this.p(we)}$provideInlineCompletions(V,W,Q,J,fe){return this.s(V,_,we=>we.provideInlineCompletions($.URI.revive(W),Q,J,fe),void 0,fe)}$handleInlineCompletionDidShow(V,W,Q,J){this.s(V,_,async fe=>{fe.handleDidShowCompletionItem(W,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,Q,J,fe){this.s(V,_,async we=>{we.handlePartialAccept(W,Q,J,fe)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,_,async Q=>{Q.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,Q){const J=new ne(V,this.h,Q,this.j.converter),fe=this.t(J,V);return this.e.$registerInlineEditProvider(fe,this.o(W,V),V.identifier),this.p(fe)}$provideInlineEdit(V,W,Q,J){return this.s(V,ne,fe=>fe.provideInlineEdits($.URI.revive(W),Q,J),void 0,J)}$freeInlineEdit(V,W){this.s(V,ne,async Q=>{Q.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,Q,J){const fe=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new De(this.h,Q),V);return this.e.$registerSignatureHelpProvider(we,this.o(W,V),fe),this.p(we)}$provideSignatureHelp(V,W,Q,J,fe){return this.s(V,De,we=>we.provideSignatureHelp($.URI.revive(W),Q,J,fe),void 0,fe)}$releaseSignatureHelp(V,W){this.s(V,De,Q=>Q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new oe(this.h,this.j.converter,Q,this.l,V),V);this.e.$registerInlayHintsProvider(fe,this.o(W,V),typeof Q.resolveInlayHint=="function",J,Re.u(V));let we=this.p(fe);if(J!==void 0){const ze=Q.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(J));we=r.$OM.from(we,ze)}return we}$provideInlayHints(V,W,Q,J){return this.s(V,oe,fe=>fe.provideInlayHints($.URI.revive(W),Q,J),void 0,J)}$resolveInlayHint(V,W,Q){return this.s(V,oe,J=>J.resolveInlayHint(W,Q),void 0,Q)}$releaseInlayHints(V,W){this.s(V,oe,Q=>Q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,Q){const J=this.t(new ae(this.h,Q),V);return this.e.$registerDocumentLinkProvider(J,this.o(W,V),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(V,W,Q){return this.s(V,ae,J=>J.provideLinks($.URI.revive(W),Q),void 0,Q,W.scheme==="output")}$resolveDocumentLink(V,W,Q){return this.s(V,ae,J=>J.resolveLink(W,Q),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,ae,Q=>Q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,Q){const J=this.t(new re(this.h,Q),V);return this.e.$registerDocumentColorProvider(J,this.o(W,V)),this.p(J)}$provideDocumentColors(V,W,Q){return this.s(V,re,J=>J.provideColors($.URI.revive(W),Q),[],Q)}$provideColorPresentations(V,W,Q,J){return this.s(V,re,fe=>fe.provideColorPresentations($.URI.revive(W),Q,J),void 0,J)}registerFoldingRangeProvider(V,W,Q){const J=this.q(),fe=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Pe(new K(this.h,Q),V)),this.e.$registerFoldingRangeProvider(J,this.o(W,V),V.identifier,fe);let we=this.p(J);if(fe!==void 0){const ze=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$OM.from(we,ze)}return we}$provideFoldingRanges(V,W,Q,J){return this.s(V,K,fe=>fe.provideFoldingRanges($.URI.revive(W),Q,J),void 0,J)}registerSelectionRangeProvider(V,W,Q){const J=this.t(new te(this.h,Q,this.l),V);return this.e.$registerSelectionRangeProvider(J,this.o(W,V)),this.p(J)}$provideSelectionRanges(V,W,Q,J){return this.s(V,te,fe=>fe.provideSelectionRanges($.URI.revive(W),Q,J),[],J)}registerCallHierarchyProvider(V,W,Q){const J=this.t(new le(this.h,Q),V);return this.e.$registerCallHierarchyProvider(J,this.o(W,V)),this.p(J)}$prepareCallHierarchy(V,W,Q,J){return this.s(V,le,fe=>Promise.resolve(fe.prepareSession($.URI.revive(W),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(V,W,Q,J){return this.s(V,le,fe=>fe.provideCallsTo(W,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(V,W,Q,J){return this.s(V,le,fe=>fe.provideCallsFrom(W,Q,J),void 0,J)}$releaseCallHierarchy(V,W){this.s(V,le,Q=>Promise.resolve(Q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,Q){const J=this.t(new de(this.h,Q),V);return this.e.$registerTypeHierarchyProvider(J,this.o(W,V)),this.p(J)}$prepareTypeHierarchy(V,W,Q,J){return this.s(V,de,fe=>Promise.resolve(fe.prepareSession($.URI.revive(W),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(V,W,Q,J){return this.s(V,de,fe=>fe.provideSupertypes(W,Q,J),void 0,J)}$provideTypeHierarchySubtypes(V,W,Q,J){return this.s(V,de,fe=>fe.provideSubtypes(W,Q,J),void 0,J)}$releaseTypeHierarchy(V,W){this.s(V,de,Q=>Promise.resolve(Q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,Q,J){const fe=this.q();return this.f.set(fe,new Pe(new Ae(this.e,this.h,Q,fe,V),V)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(W,V),(0,s.$uG)(V,"documentPaste")&&J?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(V,W,Q,J,fe,we){return this.s(V,Ae,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(W,$.URI.revive(Q),J,fe,we)),void 0,void 0)}$resolveDropEdit(V,W,Q){return this.s(V,Ae,J=>J.resolveDropEdit(W,Q),{},void 0)}$releaseDropEdits(V,W){this.s(V,Ae,Q=>Promise.resolve(Q.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,Q){const J=this.t(new me(this.h,Q),V);return this.e.$registerMappedEditsProvider(J,this.o(W,V)),this.p(J)}$provideMappedEdits(V,W,Q,J,fe){return this.s(V,me,we=>Promise.resolve(we.provideMappedEdits(W,Q,J,fe)),null,fe)}registerDocumentPasteEditProvider(V,W,Q,J){const fe=this.q();return this.f.set(fe,new Pe(new T(this.e,this.h,Q,fe,V),V)),this.e.$registerPasteEditProvider(fe,this.o(W,V),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(V,W,Q,J,fe){return this.s(V,T,we=>we.prepareDocumentPaste($.URI.revive(W),Q,J,fe),void 0,fe)}$providePasteEdits(V,W,Q,J,fe,we,ze){return this.s(V,T,Ve=>Ve.providePasteEdits(W,$.URI.revive(Q),J,fe,we,ze),void 0,ze)}$resolvePasteEdit(V,W,Q){return this.s(V,T,J=>J.resolvePasteEdit(W,Q),{},void 0)}$releasePasteEdits(V,W){this.s(V,T,Q=>Promise.resolve(Q.releasePasteEdits(W)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Re.w(V.decreaseIndentPattern),increaseIndentPattern:Re.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Re.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Re.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Re.w(V.beforeText),afterText:V.afterText?Re.w(V.afterText):void 0,previousLineText:V.previousLineText?Re.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Re.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>r.SyntaxTokenType.toString(W)):void 0}}static D(V){return V.map(Re.C)}setLanguageConfiguration(V,W,Q){const{wordPattern:J}=Q;if(J&&(0,A.$cf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(W,J):this.h.setWordDefinitionFor(W,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Re.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Re.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Re.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Re.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,W,we),this.p(fe)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$9jc=Re}),define(ke[121],Ee([1,0,3,6,16,8,108,25,7,4,222,145,13,5,20,120,12]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=e.$Pkc=void 0,e.$Pkc=(0,E.$ni)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new p.$Qh,this.stream=f??new p.$Qh}}class i{constructor(){this.a=new Map,this.b=new p.$Qh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new S.$_d,this.d=new S.$_d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Km,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$MM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const c=o.a++;this.f.set(c,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(c,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(c),this.b.$unregisterProvider(c)})}async $provideLanguageModelResponse(t,f,d,l,c,h){const g=this.f.get(t);if(!g)return;const D=new M.$Wv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(l.map(L.LanguageModelMessage.to),c,b.$Im.toKey(d),D,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[c,h]of this.i)h.languageModelId===l&&(h.res.reject(new $.$5),this.i.delete(c))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:c}of t){const h=this.h.get(d)??new b.$Jm;if(h.has(l)!==c){c?h.add(l):h.delete(l),this.h.set(d,h);const D={from:d,to:l};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,d,l,c){const h=t.identifier,g=await this.b.$prepareChatAccess(h,f,l.justification);if(!g||!this.g.has(f))throw R.$WO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(g.extension)))throw R.$WO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(h,f,D,d.map(L.LanguageModelMessage.from),l.modelOptions??{},c),k=new p.$mh,y=new i;this.i.set(D,{languageModelId:f,res:y});let C;if(w.catch(I=>{k.isOpen()?y.reject(I):C=I}).finally(()=>{this.i.delete(D),y.resolve(),k.open()}),await k.wait(),C)throw new R.$WO(`Language model '${f}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const c=P.$OL+f.identifier.value;if(await this.k.getSession(t,c,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,c,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!b.$Im.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=S.Event.signal(S.Event.filter(this.c.event,c=>b.$Im.equals(c.from,t.identifier))),l=S.Event.signal(this.d.event);return{get onDidChange(){return S.Event.any(d,l)},canSendRequest(c){const h=f.g.get(c);if(!h)return;if(!f.m(t.identifier,h))return!0;const g=f.h.get(t.identifier);if(g)return g.has(h.extension)}}}};e.$Qkc=r,e.$Qkc=r=o=Je([We(0,v.$0O),We(1,m.$Tj),We(2,a.$$jc)],r)}),define(ke[339],Ee([1,0,6,16,8,40,7,3,26]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class S{constructor(P,$,E,v){this.c=$,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(u.$MM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,$){await this.a.$changeLanguage(P,$);const E=this.c.getDocumentData(P);if(!E)throw new Error(`document '${P.toString()}' NOT found`);return E.document}async tokenAtPosition(P,$){const E=P.version,v=N.Position.from($),a=await this.a.$tokensAtPosition(P.uri,v),m={type:L.StandardTokenType.Other,range:P.getWordRangeAtPosition($)??new L.$QM($.line,$.character,$.line,$.character)};if(!a)return m;const o={range:N.Range.to(a.range),type:N.TokenType.to(a.type)};return!o.range.contains($)||E!==P.version?m:o}createLanguageStatusItem(P,$,E){const v=this.f++,a=this.a,m=this.g,o=`${P.identifier.value}/${$}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);m.add(o);const n={selector:E,id:$,name:P.displayName??P.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.$Tc,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${$}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$ph)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),a.$removeLanguageStatus(v),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,p.$vG)(P,"languageStatusText"),n.text=f,s()},get text2(){return(0,p.$vG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$vlc=S}),define(ke[340],Ee([1,0,15,2,16,8,119]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=e.$hlc=void 0;class b{constructor(P,$,E,v){this.start=P,this.deletedCount=$,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new R.$dO(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,$,E){this.notebook=P,this.h=$,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(L.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(E)}return this.f}setOutputs(P){this.a=P.map(L.NotebookCellOutput.to)}setOutputItems(P,$,E){const v=E.map(L.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===P);if(a&&($||(a.items.length=0),a.items.push(...v),a.items.length>1&&a.items.every(m=>M.$JK(m.mime)))){const m=new Map,o=[];a.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),a.items.length=0,o.forEach(n=>{const i=M.$KK(m.get(n));a.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$hlc=p;class S{static{this.a=0}constructor(P,$,E,v,a){this.k=P,this.l=$,this.m=E,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,$={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===u.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(E){return E=P.n(E),P.b[E].apiCell},getCells(E){return(E?P.p(E):P.b).map(a=>a.apiCell)},save(){return P.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,$,E){this.g=P.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},a=[];for(const o of P.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),a.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),a.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<a.length;o++){const n=a[o],i=m.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let $=P.start|0,E=P.end|0;return $<0&&($=0),E>this.b.length&&(E=this.b.length),P.with({start:$,end:E})}p(P){P=this.o(P);const $=[];for(let E=P.start;E<P.end;E++)$.push(this.b[E]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,$,E){if(this.j)return;const v=[],a=[],m=[];if(P.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new p(this,this.l,t);return $||a.push(p.asModelAddData(t)),f}),r=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),E)for(const o of v)E.push(o.asApiEvent())}s(P,$,E,v){const a=this.b.splice(P,$);this.b.splice(E,0,...a);const m=[new b(P,$,a.map(o=>o.apiCell),[]),new b(E,0,[],a)];for(const o of m)v.push(o.asApiEvent())}t(P,$){this.b[P].setOutputs($)}u(P,$,E,v){this.b[P].setOutputItems($,E,v)}v(P,$){const E=this.b[P];E.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(E.uri,$)}w(P,$){const E=this.b[P];E.apiCell.mime=$}x(P,$){this.b[P].setMetadata($)}y(P,$){this.b[P].setInternalMetadata($)}getCellFromApiCell(P){return this.b.find($=>$.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find($=>$.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$ilc=S}),define(ke[341],Ee([1,0,4,2,16,8,48]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class b{constructor(S,A,P,$={timeout:1500,errors:3}){this.b=S,this.c=A,this.d=P,this.f=$,this.a=new u.$be}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(A,P,$)=>{const E=function(a){A.call(P,a)};return E.extension=S,this.a.event(E,void 0,$)}}async $participateInSave(S,A,P){const $=N.URI.revive(S),E=this.c.getNotebookDocument($);if(!E)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},P,async(m,o)=>{const n=Date.now(),i=await await Promise.resolve(m);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof R.$YM?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const a={edits:[]};for(const m of v){const{edits:o}=L.WorkspaceEdit.from(m);a.edits=a.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$jw(a))}}e.$xlc=b}),define(ke[153],Ee([1,0,13,16,8]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,p,S,A,P,$){this.id=b,this.f=p,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(p){this.selections=[p]},get selections(){return b.a},set selections(p){if(!Array.isArray(p)||!p.every(L.$dO.isNotebookRange))throw(0,u.$7)("selections");b.a=p,b.g(p)},get visibleRanges(){return b.b},revealRange(p,S){b.f.$tryRevealRange(b.id,N.NotebookRange.from(p),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$jlc=R}),define(ke[342],Ee([1,0,4,12,16]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;let R=class{constructor(b,p){this.c=b,this.d=p,this.a=new u.$_d,this.b=new u.$_d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,p);const S=this.d.getEditorById(b);p.visibleRanges&&S._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&S._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const p in b)this.d.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(b[p]))}};e.$zlc=R,e.$zlc=R=Je([We(0,N.$Tj)],R)}),define(ke[343],Ee([1,0,4,6,153]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class R{constructor(b,p){this.c=p,this.a=new Map,this.b=b.getProxy(N.$MM.MainThreadNotebookRenderers)}$postRendererMessage(b,p,S){const A=this.c.getEditorById(b);this.a.get(p)?.fire({editor:A.apiEditor,message:S})}createRendererMessaging(b,p){if(!b.contributes?.notebookRenderer?.some(A=>A.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(A,P,$)=>this.d(p).event(A,P,$),postMessage:(A,P)=>{L.$jlc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const $=P&&L.$jlc.apiEditorsToExtHost.get(P);return this.b.$postMessage($?.id,p,A)}}}d(b){let p=this.a.get(b);return p||(p=new u.$_d({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(b)}}),this.a.set(b,p),p)}}e.$Clc=R}),define(ke[344],Ee([1,0,16,108,22,55,13]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class b{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,$,E){const v=this.b++,{title:a,location:m,cancellable:o}=$,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(m),title:a,source:n,cancellable:o},P.isUnderDevelopment?void 0:P.identifier.value).catch(M.$2),this.d(v,E,!!o)}d(P,$,E){let v;E&&(v=new L.$je,this.c.set(P,v));const a=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let m;try{m=$(new S(this.a,P),E&&v?v.token:L.CancellationToken.None)}catch(o){throw a(P),o}return m.then(o=>a(P),o=>a(P)),m}$acceptProgressCanceled(P){const $=this.c.get(P);$&&($.cancel(),this.c.delete(P))}}e.$Glc=b;function p(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class S extends N.$Wv{constructor(P,$){super(E=>this.throttledReport(E)),this.c=P,this.d=$}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,R.$Th)(100,(A,P)=>p(A,P),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[345],Ee([1,0,2,6,7,16]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class M{static{this.a=0}constructor(p,S){this.d=S,this.c=new Map,this.b=p.getProxy(N.$MM.MainThreadQuickDiff)}$provideOriginalResource(p,S,A){const P=u.URI.revive(S),$=this.c.get(p);return $?(0,L.$fh)(()=>$.provideOriginalResource(P,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,S,A,P){const $=M.a++;return this.c.set($,S),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(p,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Hlc=M}),define(ke[346],Ee([1,0,22,4,3,6,2,8,13,19,40,57,26,16]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=v;function v(a,m,o){const n=a.getProxy(R.$MM.MainThreadQuickOpen);class i{constructor(g,D){this.e=new Map,this.f=0,this.a=g,this.b=D}showQuickPick(g,D,w,k=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,I=n.$show(C,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},k),z={},j=I.then(()=>z);return Promise.race([j,y]).then(F=>{if(F===z)return;const O=(0,$.$uG)(g,"quickPickItemTooltip");return y.then(T=>{const B=[];for(let H=0;H<T.length;H++){const X=T[H];if(typeof X=="string")B.push({label:X,handle:H});else if(X.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:X.label});else{X.tooltip&&!O&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const x=X.iconPath?d(X.iconPath):void 0;B.push({label:X.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,tooltip:O?E.MarkdownString.fromStrict(X.tooltip):void 0,handle:H})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=H=>{w.onDidSelectItem(T[H])}),n.$setItems(C,B),I.then(H=>{if(typeof H=="number")return T[H];if(Array.isArray(H))return H.map(X=>T[X])})})}).then(void 0,F=>{if(!(0,p.$4)(F))return n.$setError(C,F),Promise.reject(F)})}$onItemSelected(g){this.c?.(g)}showInput(g,D=u.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",D).then(void 0,w=>{if(!(0,p.$4)(w))return Promise.reject(w)})}async $validateInput(g){if(!this.d)return;const D=await this.d(g);if(!D||typeof D=="string")return D;let w;switch(D.severity){case b.InputBoxValidationSeverity.Info:w=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:w}}async showWorkspaceFolderPick(g,D=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!w)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(g){const D=new l(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(g){const D=new c(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(g,D){this.e.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this.e.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,w){const k=this.e.get(g);k instanceof l&&k._fireDidTriggerItemButton(D,w)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{static{this.a=1}constructor(g,D){this.x=g,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$_d,this.q=new N.$_d,this.r=new N.$_d,this.s=new N.$_d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((D,w)=>{const k=D===b.$aO.Back?-1:w;this.o.set(k,D)}),this.z({buttons:g.map((D,w)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===b.$aO.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const D=this.o.get(g);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const D of Object.keys(g)){const w=g[D];this.u[D]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof b.$KN)return{id:h.id};const g=f(h),D=t(h);return{dark:typeof g=="string"?M.URI.file(g):g,light:typeof D=="string"?M.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const g=s(h);let D,w;return"id"in g?w=P.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:w}}class l extends r{constructor(g,D){super(g.identifier,D),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$_d,this.L=[],this.M=new N.$_d,this.N=new N.$_d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const D=(0,$.$uG)(this.O,"quickPickItemTooltip"),w=[];for(let k=0;k<g.length;k++){const y=g[k];if(y.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?d(y.iconPath):void 0;w.push({handle:k,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((I,z)=>({...d(I.iconPath),tooltip:I.tooltip,handle:z}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(g){const D=(0,S.$Hb)(g.map(w=>this.C.get(w)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(g){const D=(0,S.$Hb)(g.map(w=>this.C.get(w)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(g,D){const w=this.C.get(g);if(!w||!w.buttons||!w.buttons.length)return;const k=w.buttons[D];k&&this.N.fire({button:k,item:w})}}class c extends r{constructor(g,D){super(g.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(m,o)}}),define(ke[347],Ee([1,0,2,4,55,3,7,6,19,131,12,25,57,16,26,15,11]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;function n(C){return C instanceof u.URI}function i(C,I){return C.scheme===a.Schemas.file&&I.scheme===a.Schemas.file&&m.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function r(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||$.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if($.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const z=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$fr)(z,j)}function f(C,I){let z=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(z=t(C,I),z!==0)return z;if(C.light&&I.light)z=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(z!==0)return z;if(C.dark&&I.dark)z=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return z}function d(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let z=0;z<C.arguments.length;z++){const j=C.arguments[z],F=I.arguments[z];if(j!==F&&!(n(j)&&n(F)&&i(j,F)))return j<F?-1:1}return 0}function l(C,I){let z=(0,S.$fr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(z!==0)return z;if(C.command&&I.command)z=d(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(z!==0)return z;if(C.decorations&&I.decorations)z=f(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)z=(0,S.$fr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)z=(0,S.$fr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return z}function c(C,I){for(let z=0;z<C.length;z++)if(C[z]!==I[z])return!1;return!0}function h(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?c(C.arguments,I.arguments):C.arguments===I.arguments)}function g(C,I){return(0,p.$ub)(C,I,h)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$vG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$vG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$vG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,z,j,F,O){this.k=I,this.l=F,this.m=O,this.d="",this.e=new N.$_d,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=j}showValidationMessage(I,z){(0,v.$vG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,z)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Jlc=D;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,z,j,F,O,T,B){this.q=I,this.s=z,this.t=j,this.u=F,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$_d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$_d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,z){const j=this.h.get(I);return j?(0,M.$fh)(()=>this.s.executeCommand(j.command,...j.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(l),j=(0,p.$Db)(this.o,I,l).map(T=>{const B=T.toInsert.map(H=>{const X=this.e++;this.g.set(X,H);const x=H.resourceUri;let Y;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"||H.command.command==="vscode.changes"){const re=new R.$Tc;Y=this.s.converter.toInternal(H.command,re),this.j.set(X,re)}else this.h.set(X,H.command);const Z=(0,v.$uG)(this.w,"scmMultiDiffEditor"),ce=Z?H.multiDiffEditorOriginalUri:void 0,ie=Z?H.multiFileDiffEditorModifiedUri:void 0,pe=r(H.decorations),Ce=H.decorations&&r(H.decorations.light)||pe,_=H.decorations&&r(H.decorations.dark)||pe,U=[Ce,_],ne=H.decorations&&H.decorations.tooltip||"",be=H.decorations&&!!H.decorations.strikeThrough,De=H.decorations&&!!H.decorations.faded,oe=H.contextValue||"";return{rawResource:[X,x,U,ne,be,De,oe,Y,ce,ie],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),F=j.map(({start:T,deleteCount:B,toInsert:H})=>[T,B,H.map(X=>X.rawResource)]),O=j.reverse();for(const{start:T,deleteCount:B,toInsert:H}of O){const X=H.map(Y=>Y.handle),x=this.n.splice(T,B,...X);for(const Y of x)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=I,F}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let z;(0,v.$uG)(this.x,"quickDiffProvider")&&(z=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:z})}get historyProvider(){return(0,v.$vG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$vG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const z=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,v.$vG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$vG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const z=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(F=>this.y.converter.toInternal(F,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&g(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const z=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(I,z,j,F,O,T,B){this.x=I,this.y=F,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$_d,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const H=u.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,z,this.#e,this.w,H),this.#e.$registerSourceControl(this.w,O,T,B,H)}createResourceGroup(I,z,j){const F=(0,v.$uG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new w(this.#e,this.y,this.w,I,z,F,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],z=[];for(const[j,F]of this.C){F.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&z.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,z),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(z=>{const j=z._takeResourceStateSnapshot();j.length!==0&&I.push([z.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Sh)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Sh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,z,j,F){this.l=z,this.m=j,this.n=F,this.g=new Map,this.h=new P.$Km,this.j=new N.$_d,this.e=I.getProxy(b.$MM.MainThreadSCM),this.f=I.getProxy(b.$MM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,z,j,F){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,z,j,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=o.d++,T=new k(I,this.m,this.e,this.l,z,j,F);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const z=this.h.get(I.identifier),j=z&&z[z.length-1];return j&&j.inputBox}$provideOriginalResource(I,z,j){const F=u.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",I,F.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$fh)(()=>O.quickDiffProvider.provideOriginalResource(F,j)).then(T=>T||null)}$onInputBoxValueChange(I,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(I,z,j,F){this.n.trace("ExtHostSCM#$executeResourceCommand",I,z,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(z);return T?T.$executeResourceCommand(j,F):Promise.resolve(void 0)}$validateInput(I,z,j){this.n.trace("ExtHostSCM#$validateInput",I);const F=this.g.get(I);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,M.$fh)(()=>F.inputBox.validateInput(z,j)).then(O=>{if(!O)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,z,j,F){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,j,F)??void 0}async $provideHistoryItems(I,z,j,F){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(z,j,F))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(I,z,j,F){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(z,j,F);return T?{...T,icon:s(T)}:void 0}async $provideHistoryItemChanges(I,z,j,F){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(z,j,F)??void 0}};e.$Klc=y,e.$Klc=y=o=Je([We(3,A.$Tj)],y)}),define(ke[348],Ee([1,0,6,16,2]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class R{static{this.a=0}constructor(b,p){this.d=p,this.c=new Map,this.b=b.getProxy(u.$MM.MainThreadShare)}async $provideShare(b,p,S){return await this.c.get(b)?.provideShare({selection:N.Range.to(p.selection),resourceUri:L.URI.revive(p.resourceUri)},S)??void 0}registerShareProvider(b,p){const S=R.a++;return this.c.set(S,p),this.b.$registerShareProvider(S,N.DocumentSelector.from(b,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$Llc=R}),define(ke[349],Ee([1,0,8,6,225,3,16,18]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=e.$Nlc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$LN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$LN("statusBarItem.warningForeground")]])}#e;#t;constructor($,E,v,a,m,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=$,this.#t=E,m&&a){this.c=(0,u.$nN)(a.identifier,m);const i=v.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=a,this.f=m,this.g=o,this.h=this.u(n)}u($){if((0,b.$5f)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!p.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let E;this.m?E=this.m:E=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=p.b.get(this.o.id));const a=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,E,this.k,a,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Nlc=p;class S{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const E={message:$};return this.b.unshift(E),this.c(),new u.$OM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,E){this.e=new Map,this.a=$.getProxy(N.$MM.MainThreadStatusBar),this.b=E,this.c=new S(this)}$acceptStaticEntries($){for(const E of $)this.e.set(E.entryId,E)}createStatusBarEntry($,E,v,a){return new p(this.a,this.b,this.e,$,E,v,a)}setStatusBarMessage($,E){const v=this.c.setMessage($);let a;return typeof E=="number"?a=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new u.$OM(()=>{v.dispose(),clearTimeout(a)})}}e.$Olc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=void 0;const S=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},A=(i,r)=>i===r,P={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},$=i=>r=>({op:4,update:i(r)}),E=(i,r)=>({range:(()=>{let s;const t=$(f=>({range:u.$ht.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),P.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:S(i,r,P.label,$(s=>({label:s}))),description:S(i,void 0,P.description,$(s=>({description:s}))),sortText:S(i,void 0,P.sortText,$(s=>({sortText:s}))),canResolveChildren:S(i,!1,P.canResolveChildren,s=>({op:2,state:s})),busy:S(i,!1,P.busy,$(s=>({busy:s}))),error:S(i,void 0,P.error,$(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:S(i,[],P.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const r=L.$yL.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$EL)(t).tagId})),s},a=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,N.$6O)(t).parent=r,r=t}return r};e.$jP=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,N.$5O)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$4O)(d,N.$6O,m),enumerable:!0,writable:!1},...E(d,t)})}}e.$kP=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$lP=o;class n extends R.$ZO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:N.$6O,getChildren:f=>f.children,root:new o(r,s),toITestItem:b.TestItem.from})}}e.$mP=n}),define(ke[33],Ee([1,0,18,8,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,39,87,90,30]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=void 0;let d=class{#e;#t;#i;constructor(w,k,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(M.$MM.MainThreadCommands),this.d=k,this.#i=y,this.#t=w.getProxy(M.$MM.MainThreadTelemetry),this.converter=new l(this,C=>{const I=this.c.get(C);return I?.result===h.Void?I:void 0},k),this.f=[{processArgument(C){return(0,S.$Wh)(C)}},{processArgument(C){return(0,R.$Vn)(C,function(I){if(A.$ht.isIRange(I))return L.Range.to(I);if(P.$gt.isIPosition(I))return L.Position.to(I);if(A.$ht.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof o.$ze)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const k=this.registerCommand(!1,w.id,async(...y)=>{const C=w.args.map((z,j)=>{if(!z.validate(y[j]))throw new Error(`Invalid argument '${z.name}' when running '${w.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return z.convert(y[j])}),I=await this.executeCommand(w.internalId,...C);return w.result.convert(I,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$OM(()=>{k.dispose(),this.c.delete(w.id)})}registerCommand(w,k,y,C,I,z){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:C,metadata:I,extension:z}),w&&this.#e.$registerCommand(k),new N.$OM(()=>{this.b.delete(k)&&w&&this.#e.$unregisterCommand(k)})}executeCommand(w,...k){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,k,!0)}async g(w,k,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,k,!1);{let C=!1;const I=(0,R.$Vn)(k,function(z){if(z instanceof N.$PM)return L.Position.from(z);if(z instanceof N.$QM)return L.Range.from(z);if(z instanceof N.$1M)return L.location.from(z);if(N.$dO.isNotebookRange(z))return L.NotebookRange.from(z);if(z instanceof ArrayBuffer)return C=!0,o.$ze.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return C=!0,o.$ze.wrap(z);if(z instanceof o.$ze)return C=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(w,C?new n.$jw(I):I,y);return(0,S.$Wh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(w,k,!1);throw z}}}async h(w,k,y){const C=this.b.get(w);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:z,metadata:j}=C;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,u.$fg)(k[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const F=r.$8d.create();try{return await I.apply(z,k)}catch(O){if(w===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&(w=T.command)}if(this.d.error(O,w,C.extension?.identifier),!y)throw O;if(C.extension?.identifier){const T=this.#i.onExtensionError(C.extension.identifier,O);this.d.trace("forwarded error to extension?",T,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$$i)(O)),this.id=w,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,w,F.elapsed())}}j(w,k,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$9o(k),duration:y})}$executeContributedCommand(w,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(k=k.map(C=>this.f.reduce((I,z)=>z.processArgument(I,y.extension?.identifier),C)),this.h(w,k,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(k=>(w&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[k,y]of this.b){const{metadata:C}=y;C&&(w[k]=C)}return Promise.resolve(w)}};e.$sP=d,e.$sP=d=Je([We(0,a.$0O),We(1,p.$Tj),We(2,t.$rP)],d),e.$tP=(0,v.$ni)("IExtHostCommands");class l{constructor(w,k,y){this.d=w,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Jg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,k){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const C=this.f(w.command);if(C)y.id=C.internalId,y.arguments=C.args.map((I,z)=>I.convert(w.arguments&&w.arguments[z]));else if((0,b.$Lb)(w.arguments)){const I=`${w.command} /${++this.c}`;this.b.set(I,w),k.add((0,E.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),y.$ident=I,y.id=this.delegatingCommandId,y.arguments=[I],this.g.trace("CommandsConverter#CREATE",w.command,I)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const k=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$uP=l;class c{static{this.Uri=new c("uri","Uri of a text document",w=>$.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>N.$PM.isPosition(w),L.Position.from)}static{this.Range=new c("range","A range in a text document",w=>N.$QM.isRange(w),L.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>N.$RM.isSelection(w),L.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,k=>Array.isArray(k)&&k.every(y=>w.validate(y)),k=>k.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof N.$_M,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof N.$xO,L.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof m.$kP,L.TestItem.from)}constructor(w,k,y,C){this.name=w,this.description=k,this.validate=y,this.convert=C}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,k){return new c(w??this.name,k??this.description,this.validate,this.convert)}}e.$vP=c;class h{static{this.Void=new h("no result",w=>w)}constructor(w,k){this.description=w,this.convert=k}}e.$wP=h;class g{constructor(w,k,y,C,I){this.id=w,this.internalId=k,this.description=y,this.args=C,this.result=I}}e.$xP=g}),define(ke[350],Ee([1,0,19,15,2,83,134,37,33,16,8]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;const P=[new p.$xP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of DocumentHighlight-instances.",E(S.DocumentHighlight.to))),new p.$xP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$vP.Uri],new p.$wP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,u.$Kb)(a))return;class o extends A.$7M{static to(i){const r=new o(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new A.$1M(m[0],S.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=S.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return a.map(o.to)})),new p.$xP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$vP.Uri,new p.$vP("options","Formatting options",a=>!0,a=>a)],new p.$wP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$xP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$vP.Uri,p.$vP.Range,new p.$vP("options","Formatting options",a=>!0,a=>a)],new p.$wP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$xP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$vP.Uri,p.$vP.Position,new p.$vP("ch","Trigger character",a=>typeof a=="string",a=>a),new p.$vP("options","Formatting options",a=>!0,a=>a)],new p.$wP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$xP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$xP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$xP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$xP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$xP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Location-instances.",E(S.location.to))),new p.$xP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of Hover-instances.",E(S.Hover.to))),new p.$xP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$vP.Uri,new p.$vP("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$PM.isPosition(m)),a=>a.map(S.Position.from))],new p.$wP("A promise that resolves to an array of ranges.",a=>a.map(m=>{let o;for(const n of m.reverse())o=new A.$$M(S.Range.to(n),o);return o}))),new p.$xP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$vP.String.with("query","Search string")],new p.$wP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(S.WorkspaceSymbol.to))),new p.$xP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(S.CallHierarchyItem.to))),new p.$xP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$vP.CallHierarchyItem],new p.$wP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(S.CallHierarchyIncomingCall.to))),new p.$xP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$vP.CallHierarchyItem],new p.$wP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(S.CallHierarchyOutgoingCall.to))),new p.$xP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:S.Range.to(a.range),placeholder:a.text}})),new p.$xP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$vP.Uri,p.$vP.Position,p.$vP.String.with("newName","The new symbol name")],new p.$wP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return S.WorkspaceEdit.to(a)}})),new p.$xP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$vP.Uri,p.$vP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$wP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(S.DocumentLink.to))),new p.$xP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$vP.Uri],new p.$wP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$7N(a.tokenTypes,a.tokenModifiers)})),new p.$xP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$vP.Uri],new p.$wP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$ebb)(a);if(m.type==="full")return new A.$9N(m.data,void 0)})),new p.$xP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$vP.Uri,p.$vP.Range.optional()],new p.$wP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$7N(a.tokenTypes,a.tokenModifiers)})),new p.$xP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$vP.Uri,p.$vP.Range],new p.$wP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$ebb)(a);if(m.type==="full")return new A.$9N(m.data,void 0)})),new p.$xP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$vP.Uri,p.$vP.Position,p.$vP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$vP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$wP("A promise that resolves to a CompletionList-instance.",(a,m,o)=>{if(!a)return new A.$kN([]);const n=a.suggestions.map(i=>S.CompletionItem.to(i,o));return new A.$kN(n,a.incomplete)})),new p.$xP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$vP.Uri,p.$vP.Position,p.$vP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$wP("A promise that resolves to SignatureHelp.",a=>{if(a)return S.SignatureHelp.to(a)})),new p.$xP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$vP.Uri,p.$vP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$wP("A promise that resolves to an array of CodeLens-instances.",(a,m,o)=>E(n=>new A.$cN(S.Range.to(n.range),n.command&&o.fromInternal(n.command)))(a))),new p.$xP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$vP.Uri,new p.$vP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$QM.isRange(a),a=>A.$RM.isSelection(a)?S.Selection.from(a):S.Range.from(a)),p.$vP.String.with("kind","Code action kind to return code actions for").optional(),p.$vP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$wP("A promise that resolves to an array of Command-instances.",(a,m,o)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$9M(n.title,n.kind?new A.$0M(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(a))),new p.$xP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$vP.Uri],new p.$wP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$qN(S.Range.to(m.range),S.Color.to(m.color))):[])),new p.$xP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$vP("color","The color to show and insert",a=>a instanceof A.$pN,S.Color.from),new p.$vP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:S.Range.from(a.range)}))],new p.$wP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(S.ColorPresentation.to):[])),new p.$xP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$vP.Uri,p.$vP.Range],new p.$wP("A promise that resolves to an array of Inlay objects",(a,m,o)=>a.map(S.InlayHint.to.bind(void 0,o)))),new p.$xP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$vP.Uri],new p.$wP("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(S.FoldingRange.to)})),new p.$xP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$wP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>S.NotebookExclusiveDocumentPattern.to(m))})))),new p.$xP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$vP.Uri,p.$vP.Range,new p.$vP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$QM,a=>S.InlineValueContext.from(a))],new p.$wP("A promise that resolves to an array of InlineValue objects",a=>a.map(S.InlineValue.to))),new p.$xP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$vP("uriOrString","Uri-instance or string (only http/https)",a=>L.URI.isUri(a)||typeof a=="string"&&(0,N.$xg)(a,N.Schemas.http,N.Schemas.https),a=>a),new p.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[S.ViewColumn.from(a),void 0]:[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)])).optional(),p.$vP.String.with("label","").optional()],p.$wP.Void),new p.$xP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$vP.Uri.with("resource","Resource to open"),p.$vP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[S.ViewColumn.from(a),void 0]:[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)])).optional()],p.$wP.Void),new p.$xP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$vP.Uri.with("left","Left-hand side resource of the diff editor"),p.$vP.Uri.with("right","Right-hand side resource of the diff editor"),p.$vP.String.with("title","Human readable title for the diff editor").optional(),new p.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)]).optional()],p.$wP.Void),new p.$xP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$vP.String.with("title","Human readable title for the changes editor"),new p.$vP("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[o,n,i]=m;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],p.$wP.Void),new p.$xP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$vP.Uri,p.$vP.Position],new p.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new p.$xP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$vP.TypeHierarchyItem],new p.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new p.$xP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$vP.TypeHierarchyItem],new p.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new p.$xP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$vP.TestItem],p.$wP.Void),new p.$xP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$vP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$wP.Void),new p.$xP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$vP.String.with("name","The context key name"),new p.$vP("value","The context key value",()=>!0,a=>a)],p.$wP.Void),new p.$xP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$vP.Uri,p.$vP.StringArray,new p.$vP("MappedEditsContext","Mapped Edits Context",a=>S.MappedEditsContext.is(a),a=>S.MappedEditsContext.from(a))],new p.$wP("A promise that resolves to a workspace edit or null",a=>a?S.WorkspaceEdit.to(a):null))];class ${static register(m){P.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",b.$mj)}}e.$0jc=$;function E(a){return m=>{if(Array.isArray(m))return m.map(a)}}function v(a){if(!Array.isArray(a))return;const m=[];for(const o of a)R.$Yt(o)?m.push(S.DefinitionLink.to(o)):m.push(S.location.to(o));return m}}),define(ke[351],Ee([1,0,7,3,2,6,33,16,8]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class S{static{this.a=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=S.a++}}class A{constructor(E){this.session=E,this.responses=[]}}class P{static{this.a=0}constructor(E,v,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(R.$MM.MainThreadInlineChat),v.registerApiCommand(new M.$xP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$vP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:p.$RM.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],M.$wP.Void))}registerProvider(E,v,a){const m=new S(E,v);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??E.displayName??E.name,E.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",a?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,v,a,m){const o=this.b.get(E);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=b.Selection.to(a),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=P.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,v,a,m){const o=this.b.get(E);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:a.prompt,selection:b.Selection.to(a.selection),wholeRange:b.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(L.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async D=>{if(!a.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$dN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,u.$bh)(t,m)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!P.h(f))return{...l,id:d,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:c,contents:h}=f,g=h!==void 0?b.MarkdownString.from(h):void 0;return c instanceof p.$YM?{...l,id:d,type:"bulkEdit",edits:b.WorkspaceEdit.from(c),message:g}:{...l,id:d,type:"editorEdit",edits:c.map(b.TextEdit.from),message:g}}async $provideFollowups(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,u.$bh)(r,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(E,v){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$glc=P}),define(ke[352],Ee([1,0,2,33]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class L{constructor(M,b,p,S,A){this.a=b,this.b=p,this.c=S;const P=new N.$xP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$vP("showOptions","Show Options",$=>!0,$=>$),new N.$vP("resource","Interactive resource Uri",$=>!0,$=>$),new N.$vP("controllerId","Notebook controller Id",$=>!0,$=>$),new N.$vP("title","Interactive editor title",$=>!0,$=>$)],new N.$wP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const E=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(M,b,p,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:p,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$tlc=L}),define(ke[353],Ee([1,0,19,7,22,4,3,27,2,25,12,6,33,16,8,113,297,26,48,298]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0,e.$Blc=c;let r=class{constructor(g,D,w,k,y){this.m=D,this.n=w,this.o=k,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$_d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(P.$MM.MainThreadNotebookKernels);const C=new $.$xP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$vP("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const j=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:j}}else if(z&&"notebookEditor"in z){const j=this.n.getIdByEditor(z.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return z})],$.$wP.Void),I=new $.$xP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$vP.Uri],new $.$wP("A promise that resolves to an array of variables",(z,j)=>z.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(g,D,w,k,y,C){for(const pe of this.j.values())if(pe.controller.id===D&&S.$Im.equals(g.identifier,pe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,z=this;this.q.trace(`NotebookController[${I}], CREATED by ${g.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let F=!1;const O=new R.$_d,T=new R.$_d,B={id:c(g.identifier,D),notebookType:w,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:k||g.identifier.value,preloads:C?C.map(E.NotebookRendererScript.from):[]};let H=y??j,X,x;this.a.$addKernel(I,B).catch(pe=>{console.log(pe),F=!0});let Y=0;const Z=()=>{if(F)return;const pe=++Y;Promise.resolve().then(()=>{pe===Y&&this.a.$updateKernel(I,B)})},ce=new b.$Bc,ie={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(pe){B.label=pe??g.displayName??g.name,Z()},get detail(){return B.detail??""},set detail(pe){B.detail=pe,Z()},get description(){return B.description??""},set description(pe){B.description=pe,Z()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(pe){B.supportedLanguages=pe,Z()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){B.supportsExecutionOrder=pe,Z()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(pe){H=pe??j},get interruptHandler(){return X},set interruptHandler(pe){X=pe,B.supportsInterrupt=!!pe,Z()},set variableProvider(pe){(0,o.$vG)(g,"notebookVariableProvider"),x=pe,B.hasVariableProvider=!!pe,pe?.onDidChangeVariables(Ce=>z.a.$variablesUpdated(Ce.uri)),Z()},get variableProvider(){return x},createNotebookCellExecution(pe){if(F)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.notebook.uri))throw z.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return z._createNotebookCellExecution(pe,c(g.identifier,this.id))},createNotebookExecution(pe){if((0,o.$vG)(g,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.uri))throw z.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return z._createNotebookExecution(pe,c(g.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${I}], DISPOSED`),F=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(pe,Ce){Ce===v.NotebookControllerAffinity2.Hidden&&(0,o.$vG)(g,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(I,pe.uri,Ce)},onDidReceiveMessage:T.event,postMessage(pe,Ce){return(0,o.$vG)(g,"notebookMessaging"),z.a.$postMessage(I,Ce&&z.n.getIdByEditor(Ce),pe)},asWebviewUri(pe){return(0,o.$vG)(g,"notebookMessaging"),(0,a.$Dxb)(pe,z.m.remote)}};return this.j.set(I,{extensionId:g.identifier,controller:ie,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ce}),ie}getIdByController(g){for(const[D,w]of this.j)if(w.controller===g)return c(w.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const w=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(w,D);const y={dispose:()=>{this.f.delete(w),k.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(g,D,w){const k=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,w),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return y!==void 0&&(I=w.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(g,D){const w=this.h.get(g);if(w){const k=new M.$Tc;return(await w.provideNotebookKernelSourceActions(D)??[]).map(C=>E.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(g,D,w){const k=this.j.get(g);if(k){const y=this.n.getNotebookDocument(p.URI.revive(D));w?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),w),k.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(D)),C=[];for(const I of w){const z=y.getCell(I);z&&C.push(z.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,y.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${g}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const C of w){const I=y.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(y.uri);w.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(g,D,w,k,y,C,I){const z=this.j.get(g);if(!z)return;const j=this.n.getNotebookDocument(p.URI.revive(w)),F=z.controller.variableProvider;if(!F)return;let O;if(k!==void 0){if(O=this.s[k],!O)return}else this.s={};const T=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=F.provideVariables(j.apiNotebook,O,T,C,I);let H=0;for await(const X of B){if(I.isCancellationRequested)return;const x={id:this.r++,name:X.variable.name,value:X.variable.value,type:X.variable.type,interfaces:X.variable.interfaces,language:X.variable.language,expression:X.variable.expression,hasNamedChildren:X.hasNamedChildren,indexedChildrenCount:X.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[x.id]=X.variable,this.a.$receiveVariable(D,x),H++>=i.$gib)return}}$acceptKernelMessageFromRenderer(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(g,D,w){const y=this.n.getNotebookDocument(p.URI.revive(g)).getCell(D);if(y){const C=w?E.NotebookCellExecutionState.to(w):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(D,k,this.a);this.b.set(k.uri,y);const C=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),C.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(g,D){const w=this.n.getNotebookDocument(g.uri),k=g.getCells().find(I=>{const z=w.getCellFromApiCell(I);return z&&this.b.has(z.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new d(D,w,this.a),C=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),C.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,C]),y.asApiObject()}};e.$Alc=r,e.$Alc=r=Je([We(4,A.$Tj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.m=D,this.n=w,this.b=t.a++,this.c=new R.$_d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new L.$je),this.h=new l(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$jw(D))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const w=v.$hO.ensureUniqueMimeTypes(D.items,!0);return w===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:w,id:D.id,metadata:D.metadata})})}async z(g,D,w){const k=this.w(D),y=this.y((0,u.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:k,append:w,outputs:y})}async C(g,D,w){return g=v.$hO.ensureUniqueMimeTypes((0,u.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(E.NotebookCellOutputItem.from),outputId:D.id,append:w})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(w){g.j=w,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(w){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,k,y){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;g.n.$completeExecution(g.b,new n.$jw({runEndTime:k,lastRunSuccess:w,error:C}))},clearOutput(w){return g.t(),g.z([],w,!1)},appendOutput(w,k){return g.t(),g.z(w,k,!0)},replaceOutput(w,k){return g.t(),g.z(w,k,!1)},appendOutputItems(w,k){return g.t(),g.C(w,k,!0)},replaceOutputItems(w,k){return g.t(),g.C(w,k,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.h=D,this.j=w,this.b=d.a++,this.c=new R.$_d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$je),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new N.$Kh,this.b=Date.now(),(0,N.$oh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function c(h,g){return`${h.value}/${g}`}}),define(ke[42],Ee([1,0,4,6,5,2,20,3,8,227,13,273,22,30,274,57,7,16,33]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,L.$ni)("IExtHostTerminalService");class i extends b.$Uc{constructor(w,k,y,C){super(),this.u=w,this._id=k,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$_d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(z=>this.g=z);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(z,j=!0){I.C(),I.u.$sendText(I._id,z,j)},show(z){I.C(),I.u.$show(I._id,z)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??k?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:a.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(w.location,k?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,k,y,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:a.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,k){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in w?{viewColumn:o.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,k){this.j=Object.freeze({code:w,reason:k})}setDimensions(w,k){return w===this.f&&k===this.h||w===0||k===0?!1:(this.f=w,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(k=>{k!==w&&(this.b=Promise.resolve(w))})}}e.$Mkc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$_d,this.onProcessData=this.a.event,this.b=new u.$_d,this.d=new u.$_d,this.onDidChangeProperty=this.d.event,this.f=new u.$_d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,k){this.g.setDimensions?.({columns:w,rows:k})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$_d,this.onDidCloseTerminal=this.H.event,this.I=new u.$_d,this.onDidOpenTerminal=this.I.event,this.J=new u.$_d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$_d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$_d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$_d,this.onDidChangeShell=this.N.event,this.O=new u.$_d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$_d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$MM.MainThreadTerminalService),this.y=new v.$Csb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:C=>{const I=z=>{const j=z;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=I(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,k){const y=new i(this.a,(0,E.$Jg)(),w,w.name),C=new r(w.pty);return y.createExtensionTerminal(w.location,k,this.R(w,k).resolvedExtHostIdentifier,c(w.iconPath),h(w.color)).then(I=>{const z=this.S(I,C);this.h[I]=z}),this.f.push(y),y.value}R(w,k){if(k=k||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const C=this.f.find(I=>I.value===y);C&&(k.resolvedExtHostIdentifier=C._id)}}else w.location&&typeof w.location!="object"?k.location=w.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(w,k){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const C=new r(k),I=this.S(w,C);this.h[w]=I}async $acceptActiveTerminalChanged(w){const k=this.b;if(w===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(w);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,k){const y=this.getTerminalById(w);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions(w,k,y){const C=this.getTerminalById(w);C&&C.setDimensions(k,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(w,k){const y=this.getTerminalById(w);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions(w,k,y){this.g.get(w)?.resize(k,y)}async $acceptTerminalTitleChange(w,k){const y=this.getTerminalById(w);y&&(y.name=k)}async $acceptTerminalClosed(w,k,y){const C=this.X(this.f,w);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(k,y),this.H.fire(I.value)}}$acceptTerminalOpened(w,k,y,C){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=w,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new i(this.a,w,I,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,k){this.getTerminalById(w)?._setProcessId(k)}async $startExtensionTerminal(w,k){const y=this.getTerminalById(w);if(!y)return{message:(0,S.localize)(0,null,w)};y.isOpen||await new Promise(I=>{const z=this.onDidOpenTerminal(async j=>{j===y.value&&(z.dispose(),I())})});const C=this.g.get(w);C?C.startSendingEvents(k):this.j[w]={initialDimensions:k}}S(w,k){const y=new b.$Tc;y.add(k.onProcessReady(I=>this.a.$sendProcessReady(w,I.pid,I.cwd,I.windowsPty))),y.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(w,I))),this.y.startBuffering(w,k.onProcessData),y.add(k.onProcessExit(I=>this.U(w,I))),this.g.set(w,k);const C=this.j[w];return C&&k instanceof r&&(k.startSendingEvents(C.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,k){this.g.get(w)?.acknowledgeDataEvent(k)}$acceptProcessInput(w,k){this.g.get(w)?.input(k)}$acceptTerminalInteraction(w){const k=this.getTerminalById(w);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(w,k){this.getTerminalById(w)?.setSelection(k)}$acceptProcessResize(w,k,y){try{this.g.get(w)?.resize(k,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(w,k){this.g.get(w)?.shutdown(k)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(k=>this.a.$sendProcessProperty(w,{type:"cwd",value:k}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new p.$OM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,w.identifier.value),new p.$OM(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(w,k,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,k),new p.$OM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,k){const y=new $.$je().token;if(y.isCancellationRequested)return;const C=this.D.get(w);if(!C)return;const I=await C.provideTerminalQuickFixes(k,y);if(I===null||Array.isArray(I)&&I.length===0)return;const z=new b.$Tc;if(this.w.value=z,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,z):void 0;const j=[];for(const F of I){const O=o.TerminalQuickFix.from(F,this.Q.converter,z);O&&j.push(O)}return j}async $createContributedProfileTerminal(w,k){const y=new $.$je().token;let C=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks(w,k){const y=this.getTerminalById(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const I=new $.$je;this.G.set(w,I);const z=[],j={terminal:y.value,line:k},F=[];for(const B of this.z)F.push(m.Promises.withAsyncBody(async H=>{I.token.onCancellationRequested(()=>H({provider:B,links:[]}));const X=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||H({provider:B,links:X})}));const O=await Promise.all(F);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&z.push(...B.links.map(H=>{const X={id:s++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return T.set(X.id,{provider:B.provider,link:H}),X}));return this.F.set(w,T),z}$activateLink(w,k){const y=this.F.get(w)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U(w,k){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,k)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const k=this.f.findIndex(y=>y.value===w);return k>=0?k:null}W(w,k){const y=this.X(w,k);return y!==null?w[y]:null}X(w,k){const y=w.findIndex(C=>C._id===k);return y>=0?y:null}getEnvironmentVariableCollection(w){let k=this.n.get(w.identifier.value);return k||(k=new f,this.Z(w.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(w,k){const y=(0,P.$_r)(k.map),C=(0,P.$as)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(w,k.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(w){w.forEach(k=>{const y=k[0],C=new f(k[1]);this.Z(y,C)})}$acceptDefaultProfile(w,k){const y=this.s;this.s=w,this.u=k,y?.path!==w.path&&this.N.fire(w.path)}Z(w,k){this.n.set(w,k),k.onDidChangeCollection(()=>{this.Y(w,k)})}};e.$Nkc=t,e.$Nkc=t=Je([We(1,n.$tP),We(2,M.$0O)],t);class f{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$_d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const k=this.h(w);let y=this.a.get(k);return y||(y=new d(this,w),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(w,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,k.scope),C=this.map.get(y),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const z=this.g(w,k.scope),j={variable:w,...k,options:I};this.map.set(z,j),this.d.fire()}}get(w,k){const y=this.g(w,k),C=this.map.get(y);return C?g(C):void 0}g(w,k){const y=this.h(k);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const k=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(w)&&k.set(C.variable,g(C));return k}delete(w,k){const y=this.g(w,k);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(k);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,k){const y=this.h(k),C=this.descriptionMap.get(y);if(!C||C.description!==w){let I;typeof w=="string"?I=w:I=w?.value.split(`

`)[0];const z={description:I,scope:k};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(w){const k=this.h(w);return this.descriptionMap.get(k)?.description}k(w){const k=this.h(w);this.descriptionMap.delete(k)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,k){this.b=w,this.d=k,this.a=new u.$_d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,k,y){this.b.replace(w,k,y,this.d)}append(w,k,y){this.b.append(w,k,y,this.d)}prepend(w,k,y){this.b.prepend(w,k,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,k){this.b.getVariableMap(this.d).forEach((y,C)=>w.call(k,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,k){super(!1,w,k)}createTerminal(w,k,y){throw new A.$_}createTerminalFromOptions(w,k){throw new A.$_}};e.$Okc=l,e.$Okc=l=Je([We(0,n.$tP),We(1,M.$0O)],l);function c(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return a.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const w={...D};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[155],Ee([1,0,3,5,6,20,42,4,2,7]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=void 0,e.$Slc=(0,N.$ni)("IExtHostTerminalShellIntegration");let A=class extends u.$Uc{constructor(a,m){super(),this.h=m,this.b=new Map,this.c=new b.$_d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$_d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$_d,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(L.$MM.MainThreadTerminalShellIntegration),this.B((0,u.$Sc)(()=>{for(const[o,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(a){const m=this.h.getTerminalById(a);if(!m)return;const o=m.value;let n=this.b.get(a);n||(n=new P(m.value,this.f),this.b.set(a,n),n.store.add(m.onWillDispose(()=>this.b.get(a)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this.a.$executeCommand(a,i))),n.store.add(n.onDidRequestEndExecution(i=>this.g.fire(i))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),m.shellIntegration=n.value),this.c.fire({terminal:o,shellIntegration:n.value})}$shellExecutionStart(a,m,o){this.b.has(a)||this.$shellIntegrationChange(a),this.b.get(a)?.startShellExecution(m,o)}$shellExecutionEnd(a,m,o){this.b.get(a)?.endShellExecution(m,o)}$shellExecutionData(a,m){this.b.get(a)?.emitData(m)}$cwdChange(a,m){this.b.get(a)?.setCwd(m)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$Tlc=A,e.$Tlc=A=Je([We(0,R.$0O),We(1,M.$Lkc)],A);class P extends u.$Uc{get currentExecution(){return this.a}constructor(a,m){super(),this.j=a,this.m=m,this.b=!1,this.store=this.B(new u.$Tc),this.f=this.B(new b.$_d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$_d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$_d),this.onDidRequestEndExecution=this.h.event;const o=this;this.value={get cwd(){return o.c},executeCommand(n){o.g.fire(n);const i=o.startShellExecution(n,o.c,!0).value;return o.b=!0,i}}}startShellExecution(a,m,o){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const n=this.a=new $(this.j,a,m);o?queueMicrotask(()=>this.m.fire(n.value)):this.m.fire(this.a.value)}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this.a&&(this.a.endExecution(a,m),this.h.fire({execution:this.a.value,exitCode:m}),this.a=void 0)}setCwd(a){let m=!1;p.URI.isUri(this.c)?m=!p.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(m=!0),m&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class ${constructor(a,m,o){this.terminal=a,this.c=m,this.cwd=o,this.b=!1;const n=this;this.value={get terminal(){return n.terminal},get commandLine(){return n.c},get cwd(){return n.cwd},readData(){return n.d()}}}d(){if(!this.a){if(this.b)return S.$Nh.EMPTY;this.a=new E}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a,m){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class E extends u.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const a=this.a=new S.$mh;return new S.$Nh(async o=>{this.b.push(o),await a.wait()})}emitData(a){for(const m of this.b)m.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[354],Ee([1,0,7,21,22,4,74,56,3,18,30,12,6,20,154,16,8,68,112,89]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=e.$Vlc=e.$Ulc=void 0;let r=class extends p.$Uc{constructor(I,z,j,F){super(),this.w=F,this.f=this.B(new R.$_d),this.g=new Map,this.s=this.B(new R.$_d),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$MM.MainThreadTesting),this.m=new D(this.h),this.j=new d(this.h,z),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(o.$yL.root(B))?.collection.tree.get(B)?.actual??(0,v.$jP)(O)}case 18:{const{test:T,message:B}=O,H=T.item.extId;return{test:this.g.get(o.$yL.root(H))?.collection.tree.get(H)?.actual??(0,v.$jP)({$mid:16,tests:[T]}),message:a.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),T=B=>{const H=this.g.get(o.$yL.root(B));if(H)return o.$yL.isRoot(B)?H.controller:H.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$9f)||[],exclude:O?.exclude.map(T).filter(S.$9f)||[]}})}createTestController(I,z,j,F){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const O=new p.$Tc,T=O.add(new v.$mP(z,j,this.w));T.root.label=j;const B=new Map,H=new Set,X=this.h,x={items:T.root.children,get label(){return j},set label(Z){j=Z,T.root.label=Z,X.$updateController(z,{label:j})},get refreshHandler(){return F},set refreshHandler(Z){F=Z,X.$updateController(z,{canRefresh:!!Z})},get id(){return z},createRunProfile:(Z,ce,ie,pe,Ce,_)=>{let U=(0,b.$bj)(Z);for(;B.has(U);)U++;return new k(this.h,B,H,this.s.event,z,U,Z,ce,ie,pe,Ce,_)},createTestItem(Z,ce,ie){return new v.$kP(z,Z,ce,ie)},createTestRun:(Z,ce,ie=!0)=>this.j.createTestRun(z,T,Z,ce,ie),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const ce=Z instanceof Array?Z:[Z];this.h.$markTestRetired(ce.map(ie=>o.$yL.fromExtHostTestItem(ie,z).toString()))}},set resolveHandler(Z){T.resolveHandler=Z},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};X.$registerTestController(z,j,!!F),O.add((0,p.$Sc)(()=>X.$unregisterTestController(z)));const Y={controller:x,collection:T,profiles:B,extension:I,activeProfiles:H};return this.g.set(z,Y),O.add((0,p.$Sc)(()=>this.g.delete(z))),O.add(T.onDidGenerateDiff(Z=>X.$publishDiff(z,Z.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(I,z=L.CancellationToken.None){const j=l(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.g.get(j.controllerId);if(!F)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>o.$yL.fromExtHostTestItem(O,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:y[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},z)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,z){return(await this.j.getCoverageDetails(I,z))?.map(a.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,z){this.g.get(I)?.profiles.get(z)?.configureHandler?.()}$setDefaultRunProfiles(I){const z=new Map;for(const[j,F]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const T=new Map,B=F.filter(X=>!O.activeProfiles.has(X)),H=[...O.activeProfiles].filter(X=>!F.includes(X));for(const X of B)T.set(X,!0),O.activeProfiles.add(X);for(const X of H)T.set(X,!1),O.activeProfiles.delete(X);T.size&&z.set(j,T)}this.s.fire(z)}async $refreshTests(I,z){await this.g.get(I)?.controller.refreshHandler?.(z)}$publishTestResults(I){this.results=Object.freeze(I.map(a.TestResults.to).concat(this.results).sort((z,j)=>j.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,z){const j=this.g.get(o.$yL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,z<0?1/0:z),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(z=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},z)))}async $runControllerTests(I,z){return Promise.all(I.map(j=>this.y(j,!1,z)))}async $startContinuousRun(I,z){const j=new L.$je(z),F=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!z.isCancellationRequested&&!F.some(O=>O.error)&&await new Promise(O=>z.onCancellationRequested(O)),j.dispose(!0),F}async y(I,z,j){const F=this.g.get(I.controllerId);if(!F)return{};const{collection:O,profiles:T}=F,B=T.get(I.profileId);if(!B)return{};const H=I.testIds.map(Z=>O.tree.get(Z)).filter(S.$9f),X=I.excludeExtIds.map(Z=>F.collection.tree.get(Z)).filter(S.$9f).filter(Z=>H.some(ce=>ce.fullId.compare(Z.fullId)===2));if(!H.length)return{};const x=new m.$oO(H.some(Z=>Z.actual instanceof v.$lP)?void 0:H.map(Z=>Z.actual),X.map(Z=>Z.actual),B,z),Y=(0,i.$BL)(I)&&this.j.prepareForMainThreadTestRun(x,c.fromInternal(I,F.collection),B,j);try{return await B.runHandler(x,j),{}}catch(Z){return{error:String(Z)}}finally{Y&&Y.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(Y.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Ulc=r,e.$Ulc=r=Je([We(0,E.$0O),We(1,P.$Tj)],r);const s=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class f extends p.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,z,j,F,O){super(),this.y=I,this.z=z,this.C=j,this.D=F,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$_d),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$je(O));const T=this.B(new u.$zh(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new R.$_d;this.s=B.event,this.B((0,p.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,z){const[,j,F]=o.$yL.fromString(I).path,O=this.w.get(F);if(!O)return[];const T=this.g.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,z)??[]}createRun(I){const z=this.y.id,j=this.y.controllerId,F=(0,A.$Jg)(),O=X=>(x,...Y)=>{if(B){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.H(x),X(x,...Y))},T=(X,x)=>{const Y=x instanceof Array?x.map(a.TestMessage.from):[a.TestMessage.from(x)];if(X.uri&&X.range){const Z={range:a.Range.from(X.range),uri:X.uri};for(const ce of Y)ce.location=ce.location||Z}this.z.$appendTestMessagesInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),Y)};let B=!1;const H={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:X=>{const x=X.uri.toString(),Y=new o.$yL([z,F,x]).toString();this.w.set(x,X),this.z.$appendCoverage(z,F,a.TestCoverage.fromFile(Y,X))},enqueued:O(X=>{this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),1)}),skipped:O(X=>{this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),5)}),started:O(X=>{this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),2)}),errored:O((X,x,Y)=>{T(X,x),this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),6,Y)}),failed:O((X,x,Y)=>{T(X,x),this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,j).toString(),4,Y)}),passed:O((X,x)=>{this.z.$updateTestStateInRun(z,F,o.$yL.fromExtHostTestItem(X,this.y.controllerId).toString(),3,x)}),appendOutput:(X,x,Y)=>{B||(Y&&(this.y.isIncluded(Y)?this.H(Y):Y=void 0),this.z.$appendOutputToRun(z,F,N.$ze.fromString(X),x&&a.location.from(x),Y&&o.$yL.fromExtHostTestItem(Y,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(z,F),--this.f||this.G())}};return this.f++,this.g.set(F,{run:H}),this.z.$startedTestRunTask(z,{id:F,name:I,running:!0}),H}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$kP))throw new n.$2O(I.id);if(this.h.has(o.$yL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const z=[],j=this.y.colllection.root;for(;;){const F=a.TestItem.from(I);if(z.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,z)}dispose(){this.G(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(I,z){this.g=I,this.h=z,this.c=new Map,this.f=new Map}getCoverageDetails(I,z){const j=o.$yL.root(I);return this.f.get(j)?.getCoverageDetails(I,z)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[z,{id:j}]of this.c)j===I&&this.c.delete(z)}prepareForMainThreadTestRun(I,z,j,F){return this.j(I,z,j,F)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,z,j,F,O){const T=this.c.get(j);if(T)return T.createRun(F);const B=c.fromPublic(I,z,j,O),H=l(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:H&&{group:y[H.kind],id:H.profileId},exclude:j.exclude?.map(x=>o.$yL.fromExtHostTestItem(x,z.root.id).toString())??[],id:B.id,include:j.include?.map(x=>o.$yL.fromExtHostTestItem(x,z.root.id).toString())??[z.root.id],persist:O});const X=this.j(j,B,j.profile);return R.Event.once(X.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),X.createRun(F)}j(I,z,j,F){const O=new f(z,this.g,this.h,j,F);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$Vlc=d;const l=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class c{static fromPublic(I,z,j,F){return new c(I,(0,A.$Jg)(),j.include?.map(O=>o.$yL.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>o.$yL.fromExtHostTestItem(O,I).toString())??[],F,z)}static fromInternal(I,z){return new c(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,z)}constructor(I,z,j,F,O,T){this.controllerId=I,this.id=z,this.isPersisted=O,this.colllection=T,this.c=j.map(B=>B+"\0"),this.f=F.map(B=>B+"\0")}isIncluded(I){const z=o.$yL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(z===j||z.startsWith(j))return!1;for(const j of this.c)if(z===j||z.startsWith(j))return!0;return!1}}e.$Wlc=c;class h{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,a.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const z=o.$yL.parentId(I.item.extId);if(z&&this.h.has(z.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:z,g:j}=this;return{get added(){return[...I].map(F=>F.revived)},get updated(){return[...z].map(F=>F.revived)},get removed(){return[...j].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends i.$HL{constructor(){super(...arguments),this.s=new R.$_d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,z){return{...I,revived:a.TestItem.toPlain(I.item),depth:z?z.depth+1:0,children:new Set}}v(){return new h(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(z=>z.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new g({asCanonicalUri:z=>z});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const w=(C,I,z,j)=>{z?Object.assign(z,j):I.$updateTestRunConfig(C.controllerId,C.profileId,j)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,w(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,w(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),w(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,w(this,this.#e,this.#n,{tag:I?a.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,w(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(S.$9f))}constructor(I,z,j,F,O,T,B,H,X,x=!1,Y=void 0,Z=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=H,this.runHandler=X,this._tag=Y,this.g=Z,this.#e=I,this.#s=z,this.#t=j,this.#i=F,z.set(T,this);const ce=y[H];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);x&&j.add(T),this.#n={profileId:T,controllerId:O,tag:Y?a.TestTag.namespace(this.controllerId,Y.id):null,label:B,group:ce,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Z},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Xlc=k;const y={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,8]),function(he,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=e.$eP=void 0;class b{static{this.c=new L.$cP("TextEditorDecorationType")}constructor($,E,v){const a=b.c.nextId();$.$registerTextEditorDecorationType(E.identifier,a,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:a,dispose(){$.$removeTextEditorDecorationType(a)}})}}e.$eP=b;class p{constructor($,E){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,E){this.k();let v=null;if($ instanceof M.$PM)v=new M.$QM($,$);else if($ instanceof M.$QM)v=$;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert($,E){this.k(),this.l(new M.$QM($,$),E,!0)}delete($){this.k();let E=null;if($ instanceof M.$QM)E=$;else throw new Error("Unrecognized location");this.l(E,null,!0)}l($,E,v){const a=this.c.validateRange($);this.g.push({range:a,text:E,forceMoveMarkers:v})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=$}}class S{constructor($,E,v,a){this.c=$,this.d=E,this._accept(v),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const E=Math.floor($);return E>0?E:null}if(typeof $=="string"){const E=parseInt($,10);return isNaN(E)?null:E>0?E:null}return null}n($){const E=this.m($);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const E=Math.floor($);return E>0?E:null}if(typeof $=="string"){const E=parseInt($,10);return isNaN(E)?null:E>0?E:null}return null}p($){const E=this.o($);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const E=this.q($);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const E={};let v=!1;if(typeof $.tabSize<"u"){const a=this.m($.tabSize);a==="auto"?(v=!0,E.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,v=!0,E.tabSize=a)}if(typeof $.indentSize<"u"){const a=this.o($.indentSize);a==="tabSize"?(v=!0,E.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,v=!0,E.indentSize=a)}if(typeof $.insertSpaces<"u"){const a=this.q($.insertSpaces);a==="auto"?(v=!0,E.insertSpaces=a):this.j!==a&&(this.j=a,v=!0,E.insertSpaces=a)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,v=!0,E.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,v=!0,E.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v($,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(v)})}}e.$fP=S;class A{constructor($,E,v,a,m,o,n,i){this.id=$,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new S(this.j,this.id,o,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof M.$RM))throw(0,N.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$RM)))throw(0,N.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new N.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(a.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>R.Range.from(l));else if(t instanceof M.$PM){const{lineNumber:l,column:c}=R.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof M.$QM)d=[R.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$QM)d.push(R.Range.from(l));else{const{lineNumber:c,column:h}=R.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return E.$tryInsertSnippet($,a.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(R.$7O(t))return E.$trySetDecorations($,s.key,R.$8O(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return E.$trySetDecorationsFast($,s.key,d)}}))},revealRange(s,t){r.n(()=>E.$tryRevealRange($,R.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){E.$tryShowEditor($,R.ViewColumn.from(s))},hide(){E.$tryHideEditor($)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions($){(0,u.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,u.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,u.ok)(!this.g),this.f=$}_acceptSelections($){(0,u.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const E=$.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(m=>m.range);v.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=v.length-1;m<o;m++){const n=v[m].end;if(v[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=E.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,a,{setEndOfLine:typeof E.setEndOfLine=="number"?R.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$gP=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,45,46]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new N.$_d,this.e=new N.$_d,this.f=new N.$_d,this.g=new N.$_d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=R.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),s.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=R.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new o(new p.$aP(this.h.getProxy(b.$MM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=R.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new A.$gP(d.id,this.h.getProxy(b.$MM.MainThreadTextEditors),this.i,new m.$V(()=>c.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(g=>P.Range.to(g)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Pc)(s),(0,L.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$hP=n,e.$hP=n=Je([We(0,S.$0O),We(1,$.$Tj)],n),e.$iP=(0,M.$ni)("IExtHostDocumentsAndEditors")}),define(ke[355],Ee([1,0,19,4,6,156,16,8]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class p{constructor(A,P){this.i=P,this.a=new N.$_d,this.b=new N.$_d,this.c=new N.$_d,this.d=new N.$_d,this.f=new N.$_d,this.g=new N.$_d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$MM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map($=>$.value)}async showTextDocument(A,P,$){let E;typeof P=="number"?E={position:M.ViewColumn.from(P),preserveFocus:$}:typeof P=="object"?E={position:M.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?M.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,E),a=v&&this.i.getEditor(v);if(a)return a.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new R.$eP(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(P.options&&$._acceptOptions(P.options),P.selections){const E=P.selections.selections.map(M.Selection.to);$._acceptSelections(E)}if(P.visibleRanges){const E=u.$Hb(P.visibleRanges.map(M.Range.to));$._acceptVisibleRanges(E)}if(P.options&&this.b.fire({textEditor:$.value,options:{...P.options,lineNumbers:M.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const E=b.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(M.Selection.to);this.a.fire({textEditor:$.value,selections:v,kind:E})}if(P.visibleRanges){const E=u.$Hb(P.visibleRanges.map(M.Range.to));this.c.fire({textEditor:$.value,visibleRanges:E})}}$acceptEditorPositionData(A){for(const P in A){const $=this.i.getEditor(P);if(!$)throw new Error("Unknown text editor");const E=M.ViewColumn.to(A[P]);$.value.viewColumn!==E&&($._acceptViewColumn(E),this.d.fire({textEditor:$.value,viewColumn:E}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$ekc=p}),define(ke[356],Ee([1,0,2,5,6,3,8,16,25,18]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=e.$Zlc=void 0,e.$Zlc=(0,N.$ni)("IExtHostTimeline");class A{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$MM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&p.$Im.equals(m,this.b.get(a.source)?.extension)){const o=a.uri===void 0?void 0:u.URI.revive(a.uri);return this.c.get(a.source)?.get(P(o))?.get(a.handle)}else return;return a}})}async $getTimeline(E,v,a,m){return this.b.get(E)?.provider.provideTimeline(u.URI.revive(v),a,m)}registerTimelineProvider(E,v,a,m){const o=new R.$Tc,n=this.d(v.id,m,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},a)}d(E,v,a){return(m,o)=>{let n;if(o?.cacheResults){let i=this.c.get(E);i===void 0&&(i=new Map,this.c.set(E,i));const r=P(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${E}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof M.$KN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let c;return M.$dN.isMarkdownString(s.tooltip)?c=b.MarkdownString.from(s.tooltip):(0,S.$1f)(s.tooltip)?c=s.tooltip:M.$dN.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(s.detail)):(0,S.$1f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=s.detail),{...s,id:s.id??void 0,handle:t,source:E,command:i.command?v.toInternal(i.command,a):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:i.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,R.$Sc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$1lc=A;function P($){return $?.toString()}}),define(ke[357],Ee([1,0,228,23,2,4,3,289,7,8,18,19,16,80,22,184,26]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;function o(r,s){if((0,A.$1f)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new a.$I0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,D),k={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$vG)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$vG)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,E.$Mk)(y)&&(0,m.$vG)(f,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,C)=>g.reveal(y,C),dispose:async()=>{await w,this.a.delete(s),g.dispose()}};return this.B(k),k}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new b.$KF(s))}async $handleDrop(s,t,f,d,l,c,h,g){const D=this.a.get(s);if(!D)return Promise.reject(new b.$KF(s));const w=$.DataTransfer.toDataTransfer(f,async k=>(await this.f.$resolveDropFileData(s,t,k)).buffer);return h===s&&g&&await this.j(w,D,g,l,c),D.onDrop(w,d,l)}async j(s,t,f,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,g)=>{h&&s.set(g,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new b.$KF(s));const c=await this.j(new S.$GN,l,t,d,f);if(!(!c||d.isCancellationRequested))return $.DataTransfer.from(c)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$KF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new b.$KF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new b.$KF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$2lc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$0f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,c){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$_d),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$_d),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$_d),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$_d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$_d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$_d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$_d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$je,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const k of c.contributes.views[w])k.id===s&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,g;const D=R.Event.debounce(this.F.event,(w,k)=>(w||(w={message:!1,elements:[]}),k.element!==!1&&(h||(h=new Promise(y=>g=y),this.G=this.G.then(()=>h)),Array.isArray(k.element)?w.elements.push(...k.element):w.elements.push(k.element)),k.message&&(w.message=!0),w),200,!0);this.B(D(({message:w,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=g;return h=null,this.$(k).then(()=>y())})),w&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$0f)(t.select)?!0:t.select,d=(0,A.$0f)(t.focus)?!1:t.focus,l=(0,A.$0f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(c=>this.W(s,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(g=>g.item)},{select:f,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=$.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,P.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,p.$fh)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$fh)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,p.$fh)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$je(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,P.$Hb)(d||[]),c=await Promise.all((0,P.$Hb)(l).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=c.map((g,D)=>g?this.db(l[D],g,f):null);return(0,P.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$je,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&f.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$fh)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return S.$dN.isMarkdownString(s)?$.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!S.$BN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new M.$Tc),l=this.kb(s,t,f),c=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$0f)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof S.$KN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,c){if(t)return`${i.b}/${t}`;const h=o(f,this.N),g=l?l.item.handle:i.a;let D=h?h.label:d?(0,N.$Xg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,k=this.X(l)||[];let y,C=0;do{if(y=`${g}/${C}:${D}`,c||!this.j.has(y)||w===y)break;C++}while(C<=k.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof S.$KN))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof S.$KN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return L.URI.isUri(s)?s:L.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===f.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[358],Ee([1,0,4,3,2,30,16,92,6,8]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;class A extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,a,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$_d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$_d),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=a,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends N.$Uc{static c(){return(0,R.$Jg)()}constructor(v,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy(p.$MM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,a,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$tkc)(v),t=P.c();this.f.$createWebviewPanel((0,b.$vkc)(v),t,a,{title:m,panelOptions:$(n),webviewOptions:(0,b.$wkc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,a,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(v){const a=Object.keys(v);a.sort((m,o)=>{const n=v[m],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of a){const o=this.getWebviewPanel(m);if(!o)continue;const n=v[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:v}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,b.$tkc)(v)}),new S.$OM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(v,a,m,o){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,m.webviewOptions,r),t=this.createNewWebviewPanel(v,a,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(v,a,m,o,n,i,r){const s=new A(v,this.f,i,{viewType:a,title:m,viewColumn:o,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$xkc=P;function $(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[359],Ee([1,0,4,3,92,16,6,8]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class p extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(P,$,E,v,a,m){super(),this.#s=!1,this.#u=this.B(new u.$_d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$_d),this.onDidDispose=this.#l.event,this.#i=E,this.#a=v,this.#e=P,this.#t=$,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(P,$){this.d=$,this.b=new Map,this.c=new Map,this.a=P.getProxy(M.$MM.MainThreadWebviewViews)}registerWebviewViewProvider(P,$,E,v){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:E,extension:P}),this.a.$registerWebviewViewProvider((0,L.$vkc)(P),$,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$tkc)(P)}),new b.$OM(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(P,$,E,v,a){const m=this.b.get($);if(!m)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:n}=m,i=this.d.createNewWebview(P,{},n),r=new p(P,this.a,$,E,i,!0);this.c.set(P,r),await o.resolveWebviewView(r,{state:v},a)}async $onDidChangeWebviewViewVisibility(P,$){this.e(P)._setVisible($)}async $disposeWebviewView(P){const $=this.e(P);this.c.delete(P),$.dispose(),this.d.deleteWebview(P)}e(P){const $=this.c.get(P);if(!$)throw new Error("No webview found");return $}}e.$5lc=S}),define(ke[360],Ee([1,0,69,15,12,260,32,11]),function(he,e,u,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;let p=class{constructor(P,$){P.addFileSystemProvider(N.Schemas.file,new S($),{isCaseSensitive:b.$k})}};e.$Jmc=p,e.$Jmc=p=Je([We(0,u.$pkc),We(1,L.$Tj)],p);class S{constructor(P){this.b=P,this.a=new R.$1q(this.b)}async stat(P){const $=await this.a.stat(P);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,$,E){return this.a.writeFile(P,$,{...E,unlock:!1,atomic:!1})}delete(P,$){return this.a.delete(P,{...$,useTrash:!1,atomic:!1})}rename(P,$,E){return this.a.rename(P,$,E)}copy(P,$,E){return this.a.copy(P,$,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,$){throw new Error("Method not implemented.")}}}),define(ke[361],Ee([1,0,17,64,30,33,3,6,2,20]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;let A=class extends M.$Uc{constructor($,E){super();const v=$.getProxy(b.$MM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=p.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,L.$Jg)()));return await v.$download(a,m),m})}};e.$Hmc=A,e.$Hmc=A=Je([We(0,S.$0O),We(1,R.$tP)],A)}),define(ke[362],Ee([1,0,52,17,2,93,3,15,7,31]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class A extends R.$rkc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==b.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await P(c);const h=N.$kc(c,"vscode.lock"),g=await a(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),L.URI.file(c);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Tmc=A;async function P(s){try{await S.Promises.stat(s);return}catch{}try{await S.Promises.mkdir(s,{recursive:!0})}catch{}}const $=1e3,E=10*60*1e3;class v extends M.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new p.$yh),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function a(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function m(s,t){let f;try{f=await S.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await S.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,p.$oh)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=E)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$oh)(2e3);const c=await o(s,t),h=Date.now()-c;return h<=E?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(ke[363],Ee([1,0,30,20,42,33]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;let M=class extends L.$Nkc{constructor(p,S){super(!0,p,S)}createTerminal(p,S,A){return this.createTerminalFromOptions({name:p,shellPath:S,shellArgs:A})}createTerminalFromOptions(p,S){const A=new L.$Mkc(this.a,(0,u.$Jg)(),p,p.name);return this.f.push(A),A.create(p,this.R(p,S)),A.value}};e.$cmc=M,e.$cmc=M=Je([We(0,R.$tP),We(1,N.$0O)],M)}),define(ke[364],Ee([1,0,4,38,37,5]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=e.OutputChannelUpdateMode=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0,e.$UL="text/x-code-output",e.$VL="output",e.$WL="Log",e.$XL="text/x-code-log-output",e.$YL="log",e.$ZL="workbench.panel.output",e.$1L=new L.$Ej("inOutput",!1),e.$2L=new L.$Ej("activeLogOutput",!1),e.$3L=new L.$Ej("activeLogOutput.levelSettable",!1),e.$4L=new L.$Ej("activeLogOutput.level",""),e.$5L=new L.$Ej("activeLogOutput.levelIsDefault",!1),e.$6L=new L.$Ej("outputView.scrollLock",!1),e.$7L=(0,R.$ni)("outputService");var M;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$8L={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$_d,this.onDidRegisterChannel=this.b.event,this.c=new u.$_d,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(A=>S.push(A)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$6n.add(e.$8L.OutputChannels,new b),e.$9L=new L.$Ej("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,364,69,28,60,189,21,18,32,4,3]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=e.$Dlc=void 0;class o extends M.$Zj{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=$.$ze.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,c){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$MM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,E.$1f)(t)?t:void 0;if((0,E.$1f)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([D])=>R.$Im.equals(f.identifier,D))?.[1];h&&(c=(0,M.$$j)(h));const g=d?this.o(s,c,f):this.n(s,l,f);return g.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(s,c??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,c,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,g=this.l.createLogger(c,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,v.$0k)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new a.$_d);function h(g){t=g,c.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&h(g.logLevel),d.add(g.onDidChangeLogLevel(D=>h(D)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(g,...D){l(),f.then(w=>w.trace(g,...D))},debug(g,...D){l(),f.then(w=>w.debug(g,...D))},info(g,...D){l(),f.then(w=>w.info(g,...D))},warn(g,...D){l(),f.then(w=>w.warn(g,...D))},error(g,...D){l(),f.then(w=>w.error(g,...D))},dispose(){d.dispose()}}}};e.$Dlc=i,e.$Dlc=i=Je([We(0,L.$0O),We(1,S.$nP),We(2,p.$pkc),We(3,A.$5jc),We(4,M.$Uj),We(5,M.$Tj)],i),e.$Elc=(0,N.$ni)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,7]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$0m=(0,u.$ni)("remoteAgentService"),e.$$m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const p=await L.getRoundTripTime();if(p===void 0)return;R=Math.min(R,p/2),await(0,N.$oh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((b,p)=>b+p,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((b,p)=>b+p,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[365],Ee([1,0,232,85,38,41,54,3,4,158,11,24,7]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$nJ=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$oJ=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$pJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$qJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$rJ={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new p.$_d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new E;L.$6n.add(e.$rJ.ConfigurationMigration,v);let a=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const c=await this.h(n,t,d.value,i,void 0);for(const h of c??[])l.push([h,[]])}for(const{identifiers:c,value:h}of d.overrides??[])if(h!==void 0){const g=await this.h(n,t,h,i,c);for(const D of g??[])l.push([D,c])}l.length&&await Promise.allSettled(l.map(async([[c,h],g])=>this.a.updateValue(c,h.value,{resource:i,overrideIdentifiers:g},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,P.$Xn)(g,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$sJ=a,e.$sJ=a=Je([We(0,M.$Ti),We(1,R.$wi)],a);let m=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Kh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$6n.as(N.$$n.Configuration).registerConfiguration({...e.$pJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$tJ=m,e.$tJ=m=Je([We(0,S.$0m)],m)}),define(ke[366],Ee([1,0,35,15,17,23,242,365,85,5,38]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$ggb=e.$fgb=void 0,e.$hgb=a,e.$igb=m,e.$fgb=(0,S.$ni)("editorResolverService"),e.$ggb="workbench.editorAssociations";const P=A.$6n.as(p.$$n.Configuration),$={...b.$oJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration($);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function a(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function m(o,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$Xg)(n);return u.$gk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[367],Ee([1,0,34,15,17,11,23,2,5,278,41,147,158]),function(he,e,u,N,L,R,M,b,p,S,A,P,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=void 0,e.$oM=(0,p.$ni)("pathService");let v=E=class{constructor(m,o,n,i){this.d=m,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(m,i,o)):this.h(m,o,n)}h(m,o,n){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,u.$lg)(n??(0,M.$Xg)(m),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$lM)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?L.$gc:L.$hc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$pM=v,e.$pM=v=E=Je([We(1,$.$0m),We(2,P.$0L),We(3,A.$wi)],v)}),define(ke[368],Ee([1,0,244,19,55,4,56,3,2,54,249,12,66,280,88,41,147,26,22,18,24,37]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.OnPortForward=e.$cM=e.$bM=e.TunnelSource=e.TunnelCloseReason=e.$_L=e.$$L=void 0,e.$aM=c,e.$dM=D,e.$eM=w,e.$fM=k,e.$gM=C;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$$L="onTunnel",e.$_L=new s.$Ej("forwardedPortsViewEnabled",!1,u.localize(0,null));function c(j){const F=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}var h;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$bM={source:g.User,description:u.localize(1,null)},e.$cM={source:g.Auto,description:u.localize(2,null)};function D(j,F,O){const T=j.get(k(F,O));if(T)return T;if((0,v.$8v)(F))for(const B of v.$7v){const H=k(B,O);if(j.has(H))return j.get(H)}else if((0,v.$0v)(F))for(const B of v.$9v){const H=k(B,O);if(j.has(H))return j.get(H)}}function w(j,F,O){const T=D(j,F,O);if(T)return T;const B=(0,v.$0v)(F)?"localhost":(0,v.$8v)(F)?"0.0.0.0":void 0;if(B)return D(j,B,O)}function k(j,F){return j+":"+F}var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function C(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new R.$_d,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,O,T){let B=this.w(F,O,T,this.j,0);const H={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const X=this.j[B];X.key===F?(H.onAutoForward=X.onAutoForward??H.onAutoForward,H.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:H.elevateIfNeeded,H.label=X.label??H.label,H.requireLocalPort=X.requireLocalPort,H.protocol=X.protocol):(H.onAutoForward=H.onAutoForward??X.onAutoForward,H.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:X.elevateIfNeeded,H.label=H.label??X.label,H.requireLocalPort=H.requireLocalPort!==void 0?H.requireLocalPort:void 0,H.protocol=H.protocol??X.protocol),B=this.w(F,O,T,this.j,B+1)}return H.onAutoForward!==void 0||H.elevateIfNeeded!==void 0||H.label!==void 0||H.requireLocalPort!==void 0||H.protocol!==void 0?H:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,i.$1f)(F.host)&&(0,i.$5f)(F.port)}w(F,O,T,B,H){if(H>=B.length)return-1;const X=!(0,v.$8v)(O)&&!(0,v.$0v)(O),Y=B.slice(H).findIndex(Z=>(0,i.$5f)(Z.key)?X?!1:Z.key===F:this.t(Z.key)?X?!1:F>=Z.key.start&&F<=Z.key.end:this.u(Z.key)?F===Z.key.port&&O===Z.key.host:T?Z.key.test(T):!1);return Y>=0?Y+H:-1}y(){const F=this.r.getValue(I.c);if(!F||!(0,i.$3f)(F))return[];const O=[];for(const B in F){if(B===void 0)continue;const H=F[B];let X;if(Number(B))X=Number(B);else if((0,i.$1f)(B))if(I.g.test(B)){const x=B.match(I.g);X={start:Number(x[1]),end:Number(x[2])}}else if(I.h.test(B)){const x=B.match(I.h);X={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(B)}catch{}x&&(X=x)}X&&O.push({key:X,elevateIfNeeded:H.elevateIfNeeded,onAutoForward:H.onAutoForward,label:H.label,requireLocalPort:H.requireLocalPort,protocol:H.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(F){function O(T,B){return(0,i.$5f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return F.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(F){switch(F){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,O,T){const H=this.r.inspect(I.c).userRemoteValue;let X;!H||!(0,i.$3f)(H)?X={}:X=(0,r.$Tn)(H),X[`${F}`]||(X[`${F}`]={});for(const x in O)X[`${F}`][x]=O[x];return this.r.updateValue(I.c,X,T)}}e.$hM=I;let z=class extends b.$Uc{constructor(F,O,T,B,H,X,x,Y,Z,ce){super(),this.H=F,this.I=O,this.J=T,this.L=B,this.M=H,this.N=X,this.O=x,this.P=Y,this.Q=Z,this.R=ce,this.c=new Map,this.g=new R.$_d,this.onForwardPort=this.g.event,this.h=new R.$_d,this.onClosePort=this.h.event,this.j=new R.$_d,this.onPortName=this.j.event,this.n=new R.$_d,this.onCandidatesChanged=this.n.event,this.t=new R.$_d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$_d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ie=>{const pe=await this.getAttributes(ie.map(Ce=>({port:Ce.tunnelRemotePort,host:Ce.tunnelRemoteHost})));for(const Ce of ie)if(Ce.localAddress){const _=k(Ce.tunnelRemoteHost,Ce.tunnelRemotePort),U=w(this.m??new Map,Ce.tunnelRemoteHost,Ce.tunnelRemotePort);this.forwarded.set(_,{remotePort:Ce.tunnelRemotePort,remoteHost:Ce.tunnelRemoteHost,localAddress:Ce.localAddress,protocol:pe?.get(Ce.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Ce.localAddress,pe?.get(Ce.tunnelRemotePort)),localPort:Ce.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Ce.privacy,source:e.$bM}),this.f.set(_,Ce)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ie=>{const pe=k(ie.tunnelRemoteHost,ie.tunnelRemotePort);if(!w(this.forwarded,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!w(this.detected,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!w(this.c,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&ie.localAddress){const Ce=w(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort),_=(await this.getAttributes([{port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost}]))?.get(ie.tunnelRemotePort);this.forwarded.set(pe,{remoteHost:ie.tunnelRemoteHost,remotePort:ie.tunnelRemotePort,localAddress:ie.localAddress,protocol:_?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,_),localPort:ie.tunnelLocalPort,closeable:!0,runningProcess:Ce?.detail,hasRunningProcess:!!Ce,pid:Ce?.pid,privacy:ie.privacy,source:e.$bM})}await this.cb(),this.f.set(pe,ie),this.g.fire(this.forwarded.get(pe))})),this.B(this.H.onTunnelClosed(ie=>this.W(ie,h.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$$L))?(this.R.createKey(e.$_L.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,O){const T=k(F.host,F.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(F))}X(F,O){if(F.startsWith("http"))return p.URI.parse(F);const T=O?.protocol??"http";return p.URI.parse(`${T}://${F}`)}async Y(F){const O=this.N.getWorkspace(),T=O.configuration?(0,M.$bj)(O.configuration.path):O.folders.length>0?(0,M.$bj)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const F=this.I.get(f,1);if(F)return this.I.remove(f,1),await this.cb(),F;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const O=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=w(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!B||T.source.source===g.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!B&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(O=>O.startsWith(d));for(const O of F){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(d,f);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),O=F.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let T;F.length>0&&(T=JSON.stringify(O));const B=await this.Z(),H=await this.$();!T&&B&&H?(this.I.remove(B,0),this.I.remove(H,0)):T!==this.y&&B&&H&&(this.I.store(B,T,0,0),this.I.store(H,Date.now()+l,0,0)),this.y=T}}async eb(F,O,T){if(!F.tunnelLocalPort||!T?.requireLocalPort||F.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const H=u.localize(3,null,O,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(H)}async forward(F,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(F,O)}async fb(F,O){await this.Q.activateByEvent(e.$$L);const T=w(this.forwarded,F.remote.host,F.remote.port);O=O??(O!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const B=F.local!==void 0?F.local:F.remote.port;let H;if(T)return this.hb(T,F,O);{const X=this.L.remoteAuthority,x=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,Y=k(F.remote.host,F.remote.port);this.c.set(Y,!0),F=this.gb(Y,F);const Z=await this.H.openTunnel(x,F.remote.host,F.remote.port,void 0,B,F.elevateIfNeeded?F.elevateIfNeeded:O?.elevateIfNeeded,F.privacy,O?.protocol);if(typeof Z=="string")H=Z;else if(Z&&Z.localAddress){const ce=w(this.m??new Map,F.remote.host,F.remote.port),ie=Z.protocol?Z.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,pe={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:O?.label??F.name,closeable:!0,localAddress:Z.localAddress,protocol:ie,localUri:await this.X(Z.localAddress,O),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:F.source??e.$bM,privacy:Z.privacy};return this.forwarded.set(Y,pe),this.f.set(Y,Z),this.c.delete(Y),await this.cb(),await this.eb(Z,B,O),this.g.fire(pe),Z}this.c.delete(Y)}return H}gb(F,O){const T=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(T){const B=T.get(F);T.delete(F),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(F,O,T){const B=T?.label??O.name;let H;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(H||(H={}));let X=H.None;switch(B!==F.name&&(F.name=B,X=H.Fire),(T?.protocol||F.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==F.protocol&&(O.source=F.source,X=H.Reopen),O.privacy&&F.privacy!==O.privacy&&(X=H.Reopen),X){case H.Fire:{this.g.fire();break}case H.Reopen:await this.close(F.remoteHost,F.remotePort,h.User),await this.fb(O,T)}return w(this.f,O.remote.host,O.remote.port)}async name(F,O,T){const B=w(this.forwarded,F,O),H=k(F,O);if(B){B.name=T,await this.cb(),this.j.fire({host:F,port:O});return}else this.detected.has(H)&&(this.detected.get(H).name=T,this.j.fire({host:F,port:O}))}async close(F,O,T){const B=k(F,O),H=this.forwarded.get(B);return T===h.AutoForwardEnd&&H&&H.source.source===g.Auto&&this.F.set(B,{local:H.localPort,name:H.name,privacy:H.privacy}),await this.H.closeTunnel(F,O),this.W({host:F,port:O},T)}address(F,O){const T=k(F,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const O of F){const T=w(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:k(O.localAddress.host,O.localAddress.port);this.detected.set(k(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let O=F;this.r&&(O=await this.r(F));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(F){const O=this.m??new Map,T=new Map;return this.m=T,F.forEach(B=>{const H=k(B.host,B.port);T.set(H,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(H)&&O.delete(H);const X=w(this.forwarded,B.host,B.port);X&&(X.runningProcess=B.detail,X.hasRunningProcess=!0,X.pid=B.pid)}),O.forEach((B,H)=>{const X=c(H);if(!X)return;const x=w(this.forwarded,X.host,X.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const Y=w(this.detected,X.host,X.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),O=await this.getAttributes(F.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of F){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(F,O=!0){const T=new Map,B=new Map;F.forEach(Z=>{const ce=w(this.m??new Map,v.$7v[0],Z.port)??Z;if(ce){T.set(Z.port,ce);const ie=C(ce)?ce.pid:void 0;B.has(ie)||B.set(ie,[]),B.get(ie)?.push(Z.port)}});const H=new Map;if(F.forEach(Z=>{const ce=this.configPortsAttributes.getAttributes(Z.port,Z.host,T.get(Z.port)?.detail);ce&&H.set(Z.port,ce)}),this.G.length===0||!O)return H.size>0?H:void 0;const X=await Promise.all((0,N.$Rb)(this.G.map(Z=>Array.from(B.entries()).map(ce=>{const ie=ce[1],pe=T.get(ie[0]);return Z.providePortAttributes(ie,pe?.pid,pe?.detail,n.CancellationToken.None)})))),x=new Map;if(X.forEach(Z=>Z.forEach(ce=>{ce&&x.set(ce.port,ce)})),!H&&!x)return;const Y=new Map;return F.forEach(Z=>{const ce=H.get(Z.port),ie=x.get(Z.port);Y.set(Z.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??I.providedActionToAction(ie?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Y}addAttributesProvider(F){this.G.push(F)}};e.$iM=z,Je([(0,L.$Sh)(1e3)],z.prototype,"cb",null),e.$iM=z=Je([We(0,v.$2v),We(1,E.$Rp),We(2,S.$Ti),We(3,m.$0L),We(4,$.$yl),We(5,a.$wi),We(6,P.$Tj),We(7,A.$vw),We(8,o.$rG),We(9,s.$Fj)],z)}),define(ke[94],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$UK=e.$TK=void 0;class u{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new u(0,0)}with(M){return new u(0,0)}}e.$TK=u;class N{constructor(M,b,p,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,b),this.end=new u(p,S)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$UK=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,7]),function(he,e,u,N,L,R,M,b,p,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$fL=e.$$K=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$8K=e.$7K=e.$6K=e.$5K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.TextSearchCompleteMessageType=void 0,e.$2K=o,e.$3K=n,e.$4K=i,e.$9K=g,e.$0K=D,e.$_K=y,e.$aL=C,e.$bL=I,e.$cL=z,e.$dL=j,e.$eL=F,e.$gL=T,e.$iL=X,e.$jL=x,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$VK="workbench.view.search",e.$WK="workbench.panel.search",e.$XK="workbench.view.search",e.$YK="search-result",e.$ZK="search.exclude";const $="\u27EA ",E=" characters skipped \u27EB",v=($.length+E.length+5)*2;e.$1K=(0,b.$ni)("searchService");var a;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Z){return!!Z.preview}function n(Z){return!!Z.resource}function i(Z){return!!Z.message}var r;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$5K=s;class t{constructor(ce,ie,pe,Ce){this.ranges=ie,this.webviewIndex=Ce;const _=Array.isArray(ie)?ie:[ie];if(pe&&pe.matchLines===1&&f(_)){ce=(0,M.$Tf)(ce,pe.matchLines);let U="",ne=0,be=0;const De=Math.floor(pe.charsPerLine/5),oe=[];for(const ae of _){const re=Math.max(ae.startColumn-De,0),K=ae.startColumn+pe.charsPerLine;if(re>be+De+v){const te=$+(re-be)+E;U+=te+ce.slice(re,K),ne+=re-(be+te.length)}else U+=ce.slice(be,K);oe.push(new l(0,ae.startColumn-ne,ae.endColumn-ne)),be=K}this.preview={text:U,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const U=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,u.$2b)(ie,ne=>new d(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$6K=t;function f(Z){const ce=Z[0].startLineNumber;for(const ie of Z)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,ie,pe,Ce){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=pe,this.endColumn=Ce}}e.$7K=d;class l extends d{constructor(ce,ie,pe){super(ce,ie,ce,pe)}}e.$8K=l;var c;(function(Z){Z.List="list",Z.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(Z,ce=!0){const ie=Z&&Z.files&&Z.files.exclude,pe=ce&&Z&&Z.search&&Z.search.exclude;if(!ie&&!pe)return;if(!ie||!pe)return ie||pe;let Ce=Object.create(null);return Ce=L.$Wn(Ce,L.$Tn(ie)),Ce=L.$Wn(Ce,L.$Tn(pe),!0),Ce}function D(Z,ce){return Z.excludePattern&&N.$gk(Z.excludePattern,ce)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&N.$gk(Z.includePattern,ce)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ie=>{const pe=ie.folder.fsPath;if(R.$ng(ce,pe)){const Ce=p.$mc(pe,ce);return!ie.includePattern||!!N.$gk(ie.includePattern,Ce)}else return!1}):!1:!0}var w;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class k extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.$$K=k;function y(Z){const ce=Z.message;if((0,S.$4)(Z))return new k(ce,w.canceled);try{const ie=JSON.parse(ce);return new k(ie.message,ie.code)}catch{return new k(ce,w.other)}}function C(Z){const ce={message:Z.message,code:Z.code};return new Error(JSON.stringify(ce))}function I(Z){return Z.type==="error"?!0:Z.type==="success"}function z(Z){return Z.type==="success"}function j(Z){return!!Z.path}function F(Z,ce,ie=!0){const pe=Z.searchPath?Z.searchPath:Z.relativePath;return ie?(0,M.$Qf)(pe,ce):N.$gk(ce,pe)}class O{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fL=O;function T(Z,ce){const ie={...Z||{},...ce||{}};return Object.keys(ie).filter(pe=>{const Ce=ie[pe];return typeof Ce=="boolean"&&Ce})}class B{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=N.$hk(this.a);let pe=ce.includePattern;ie.includePattern&&(pe?pe={...pe,...ie.includePattern}:pe=ie.includePattern),pe&&(this.c=N.$hk(pe))}matchesExcludesSync(ce,ie,pe){return!!(this.b&&this.b(ce,ie,pe))}includedInQuerySync(ce,ie,pe){return!(this.b&&this.b(ce,ie,pe)||this.c&&!this.c(ce,ie,pe))}includedInQuery(ce,ie,pe){const Ce=this.b(ce,ie,pe),_=()=>this.c?!!this.c(ce,ie,pe):!0;return(0,P.$_g)(Ce)?Ce.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return H(this.a)}}e.$hL=B;function H(Z){for(const ce in Z)if(typeof Z[ce]!="boolean")return!0;return!1}function X(Z){if(!Z)return;let ce;return ie=>(ce||(ce=(Z()||Promise.resolve([])).then(pe=>pe?Y(pe):{})),ce.then(pe=>!!pe[ie]))}function x(Z){if(!Z)return;let ce;return ie=>{if(!ce){const pe=Z();ce=pe?Y(pe):{}}return!!ce[ie]}}function Y(Z){const ce={};for(const ie of Z)ce[ie]=!0;return ce}}),define(ke[43],Ee([1,0,19,7,22,4,3,77,15,125,23,14,2,230,5,12,263,41,60,28,20,16,8,67,36,6,58]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0;function h(z,j,F){return new A.$Pg(O=>k(O,F)).isEqual(z,j)}function g(z,j,F){return h(z.uri,j.uri,F)?0:(0,P.$jf)(z.uri.toString(),j.uri.toString())}function D(z,j,F){return z.index!==j.index?z.index<j.index?-1:1:h(z.uri,j.uri,F)?(0,P.$jf)(z.name,j.name):(0,P.$jf)(z.uri.toString(),j.uri.toString())}function w(z,j,F,O){const T=z.slice(0).sort((H,X)=>F(H,X,O)),B=j.slice(0).sort((H,X)=>F(H,X,O));return(0,u.$Eb)(T,B,(H,X)=>F(H,X,O))}function k(z,j){const F=j.getCapabilities(z.scheme);return!(F&&F&1024)}class y extends o.$Gi{static toExtHostWorkspace(j,F,O,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:H,folders:X,configuration:x,transient:Y,isUntitled:Z}=j,ce=[],ie=F;F?X.forEach((U,ne)=>{const be=$.URI.revive(U.uri),De=y.o(O||F,be,T);De?(De.name=U.name,De.index=U.index,ce.push(De)):ce.push({uri:be,name:U.name,index:ne})}):ce.push(...X.map(({uri:U,name:ne,index:be})=>({uri:$.URI.revive(U),name:ne,index:be}))),ce.sort((U,ne)=>U.index<ne.index?-1:1);const pe=new y(B,H,ce,!!Y,x?$.URI.revive(x):null,!!Z,U=>k(U,T)),{added:Ce,removed:_}=w(ie?ie.workspaceFolders:[],pe.workspaceFolders,g,T);return{workspace:pe,added:Ce,removed:_}}static o(j,F,O){for(let T=0;T<j.folders.length;T++){const B=j.workspaceFolders[T];if(h(B.uri,F,O))return B}}constructor(j,F,O,T,B,H,X){super(j,O.map(x=>new o.$Hi(x)),T,B,X),this.t=F,this.u=H,this.q=[],this.s=b.$ti.forUris(X),O.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,F){return F&&this.s.get(j)&&(j=(0,A.$Zg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,F,O,T,B){this.c=new R.$_d,this.onDidChangeWorkspace=this.c.event,this.g=new R.$_d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$be,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$um,this.k=new N.$mh,this.o=j.getProxy(l.$MM.MainThreadWorkspace),this.q=j.getProxy(l.$MM.MainThreadMessageService);const H=F.workspace;this.l=H?new y(H.id,H.name,[],!!H.transient,H.configuration?$.URI.revive(H.configuration):null,!!H.isUntitled,X=>k(X,O)):void 0}$initializeWorkspace(j,F){this.v=F,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:p.Schemas.untitled,path:(0,A.$Xg)((0,A.$Zg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,F,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(Z=>{$.URI.isUri(Z.uri)&&!B.some(ce=>h(ce.uri,Z.uri,this.s))&&B.push({uri:Z.uri,name:Z.name||(0,A.$Wg)(Z.uri)})}),this.n||[F,O].some(Z=>typeof Z!="number"||Z<0)||O===0&&B.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(F+O>H.length)return!1;const X=H.slice(0);X.splice(F,O,...B.map(Z=>({uri:Z.uri,name:Z.name||(0,A.$Wg)(Z.uri),index:void 0})));for(let Z=0;Z<X.length;Z++){const ce=X[Z];if(X.some((ie,pe)=>pe!==Z&&h(ce.uri,ie.uri,this.s)))return!1}X.forEach((Z,ce)=>Z.index=ce);const{added:x,removed:Y}=w(H,X,D,this.s);if(x.length===0&&Y.length===0)return!1;if(this.o){const Z=j.displayName||j.name;this.o.$updateWorkspaceFolders(Z,F,O,B).then(void 0,ce=>{this.n=void 0;const ie={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Z,ce.toString()),ie,[])})}return this.y(X),!0}getWorkspaceFolder(j,F){if(this.x)return this.x.getWorkspaceFolder(j,F)}async getWorkspaceFolder2(j,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,F)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,F){let O,T="";if(typeof j=="string"?(O=$.URI.file(j),T=j):typeof j<"u"&&(O=j,T=j.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let H=(0,A.$3g)(B.uri,O);return F&&B.name&&(H=`${B.name}/${H}`),H}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:F,added:O,removed:T}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(j,F,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let H="",X=!0;return F===null?X=!1:F!==void 0&&(typeof F=="string"?H=F:H=F.pattern),this.z(j,void 0,{exclude:H,maxResults:O,useDefaultExcludes:X,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,F={},O,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,F,T)}async z(j,F,O,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,H={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let X;if(j){const{includePattern:x,folder:Y}=I(s.GlobPattern.from(j));X=Y,H.includePattern=x}else{const{includePattern:x,folder:Y}=I(s.GlobPattern.from(F));X=Y,H.filePattern=x}return this.o.$startFileSearch(X??null,H,T).then(x=>Array.isArray(x)?x.map(Y=>$.URI.revive(Y)):[])}async findTextInFiles(j,F,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),X=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:x,folder:Y}=I(s.GlobPattern.from(F.include)),Z=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ce={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:X,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:x,excludePattern:Z},ie=!1;if(this.u[H]=pe=>{if(ie)return;const Ce=$.URI.revive(pe.resource);pe.results.forEach(_=>{const U=(0,c.$Wh)(_);(0,d.$2K)(U)?O({uri:Ce,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ne=>new t.$QM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,u.$2b)(U.ranges,ne=>new t.$QM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):O({uri:Ce,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(j,Y??null,ce,H,B);return delete this.u[H],pe||{}}catch(pe){throw delete this.u[H],pe}}$handleTextSearchResult(j,F){this.u[F]?.(j)}async save(j){const F=await this.o.$save(j,{saveAs:!1});return $.URI.revive(F)}async saveAs(j){const F=await this.o.$save(j,{saveAs:!0});return $.URI.revive(F)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,F){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,F);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,M.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder($.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,F);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,F,O,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder($.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const H=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!H),!H)return;const X=await H.provideEditSessionIdentityMatch?.(F,O,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(j){return(F,O,T)=>{const B=function(X){F.call(O,X)};return B.extension=j,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(j,F,O){const T=await this.resolveWorkspaceFolder($.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},F,async(B,H)=>{const X=Date.now();await Promise.resolve(B),Date.now()-X>O&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(j,F){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,F);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,M.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,F,O){const T=this.C.get(j.scheme);if(!T)return;const B=await T.provideCanonicalUri?.($.URI.revive(j),F,O);if(B)return B}async $provideCanonicalUri(j,F,O){return this.provideCanonicalUri($.URI.revive(j),{targetScheme:F},O)}};e.$jkc=C,e.$jkc=C=Je([We(0,r.$0O),We(1,i.$nP),We(2,n.$5jc),We(3,a.$Tj),We(4,f.$hkc)],C),e.$kkc=(0,v.$ni)("IExtHostWorkspace");function I(z){let j,F;return z&&(typeof z=="string"?j=z:(j=z.pattern,F=$.URI.revive(z.baseUri))),{includePattern:j,folder:F}}}),define(ke[44],Ee([1,0,24,4,43,6,8,265,85,18,7,5,20,12,2]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=e.$lkc=void 0;function a(f,d){if(d){const l=d.split(".");let c=f;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function m(f){return f instanceof v.URI}function o(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,c){this.a=d.getProxy(R.$MM.MainThreadConfiguration),this.c=l,this.b=c,this.d=new A.$mh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$lkc=s,e.$lkc=s=Je([We(0,$.$0O),We(1,L.$kkc),We(2,E.$Tj)],s);class t{constructor(d,l,c,h){this.a=new N.$_d,this.b=d,this.f=h,this.c=l,this.e=b.$ro.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$ro.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=r(l)||{},g=this.g(d?a(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(k){return typeof a(g,k)<"u"},get:(k,y)=>{this.h(d?`${d}.${k}`:k,h,c?.identifier);let C=a(g,k);if(typeof C>"u")C=y;else{let I;const z=(j,F)=>{if((0,S.$3f)(j)){let O;const T=()=>{I=I||(0,u.$Tn)(g),O=O||a(I,F)};return new Proxy(j,{get:(B,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||a(I,F),O[H];const X=B[H];return typeof H=="string"?z(X,`${F}.${H}`):X},set:(B,H,X)=>(T(),O&&(O[H]=X),!0),deleteProperty:(B,H)=>(T(),O&&delete O[H],!0),defineProperty:(B,H,X)=>(T(),O&&Object.defineProperty(O,H,X),!0)})}return Array.isArray(j)?(0,u.$Tn)(j):j};C=z(C,k)}return C},update:(k,y,C,I)=>{k=d?`${d}.${k}`:k;const z=D(C);return y!==void 0?this.b.$updateConfigurationOption(z,k,y,h,I):this.b.$removeConfigurationOption(z,k,h,I)},inspect:k=>{k=d?`${d}.${k}`:k;const y=this.e.inspect(k,h,this.c.workspace);if(y)return{key:k,defaultValue:(0,u.$Tn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Tn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Tn)(y.workspace?.value),workspaceFolderValue:(0,u.$Tn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Tn)(y.default?.override),globalLanguageValue:(0,u.$Tn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Tn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Tn)(y.workspaceFolder?.override),languageIds:(0,u.$Tn)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,u.$Wn)(w,g,!1),Object.freeze(w)}g(d){const l=c=>(0,S.$3f)(c)?new Proxy(c,{get:(h,g)=>l(h[g]),set:(h,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=p.$io.test(d)?4:this.d.get(d),g=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new b.$to(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,r(g))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$mkc=t,e.$nkc=(0,P.$ni)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,7,4,6,8,43,72,44,22,42,20,28,5,15,11,12,91,309,13]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=e.$Qlc=e.$Plc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(z){function j(O){if(O!=null)return O}z.from=j;function F(O){if(O!=null)return O}z.to=F})(s||(s={}));var t;(function(z){function j(O){if(O!=null)return O}z.from=j;function F(O){if(O!=null)return O}z.to=F})(t||(t={}));var f;(function(z){function j(O){if(O!=null)return O}z.from=j;function F(O){if(O!=null)return O}z.to=F})(f||(f={}));var d;(function(z){function j(T){if(T){const B=T;return B&&!!B.process}else return!1}z.is=j;function F(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=f.from(T.options)),B}z.from=F;function O(T){if(T!=null)return new M.$xN(T.process,T.args,T.options)}z.to=O})(d||(d={}));var l;(function(z){function j(O){if(O!=null)return O}z.from=j;function F(O){if(O!=null)return O}z.to=F})(l||(l={}));var c;(function(z){function j(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=j;function F(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=l.from(T.options)),B}z.from=F;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$yN(T.commandLine,T.options):new M.$yN(T.command,T.args?T.args:[],T.options)}z.to=O})(c||(c={}));var h;(function(z){function j(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}z.is=j;function F(T){return{customExecution:"customExecution"}}z.from=F;function O(T,B){return B.get(T)}z.to=O})(h||(e.CustomExecutionDTO=h={}));var g;(function(z){function j(F,O){let T;return F.scope!==void 0&&typeof F.scope!="number"?T=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$SH),{id:F._id,workspaceFolder:T}}z.from=j})(g||(e.TaskHandleDTO=g={}));var D;(function(z){function j(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=j})(D||(D={}));var w;(function(z){function j(T,B){if(T==null)return[];const H=[];for(const X of T){const x=F(X,B);x&&H.push(x)}return H}z.fromMany=j;function F(T,B){if(T==null)return;let H;T.execution instanceof M.$xN?H=d.from(T.execution):T.execution instanceof M.$yN?H=c.from(T.execution):T.execution&&T.execution instanceof M.$zN&&(H=h.from(T.execution));const X=s.from(T.definition);let x;return T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=M.TaskScope.Workspace,!X||!x?void 0:{_id:T._id,definition:X,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:x},execution:H,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}z.from=F;async function O(T,B,H){if(T==null)return;let X;d.is(T.execution)?X=d.to(T.execution):c.is(T.execution)?X=c.to(T.execution):h.is(T.execution)&&(X=h.to(T._id,H));const x=s.to(T.definition);let Y;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Y=T.source.scope:Y=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):Y=M.TaskScope.Workspace),!x||!Y)return;const Z=new M.$AN(x,Y,T.name,T.source.label,X,T.problemMatchers);return T.isBackground!==void 0&&(Z.isBackground=T.isBackground),T.group!==void 0&&(Z.group=M.$wN.from(T.group._id),Z.group&&T.group.isDefault&&(Z.group=new M.$wN(Z.group.id,Z.group.label),T.group.isDefault===!0&&(Z.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Z.presentationOptions=t.to(T.presentationOptions)),T._id&&(Z._id=T._id),T.detail&&(Z.detail=T.detail),Z}z.to=O})(w||(e.TaskDTO=w={}));var k;(function(z){function j(O){return O}z.from=j;function F(O){if(O)return Object.assign(Object.create(null),O)}z.to=F})(k||(k={}));class y{#e;constructor(j,F,O){this._id=F,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,F,O,T,B,H,X,x){this.q=new L.$_d,this.r=new L.$_d,this.s=new L.$_d,this.u=new L.$_d,this.a=j.getProxy(R.$MM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=H,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,F,O){if(!O)return new M.$OM(()=>{});const T=this.x();return this.j.set(T,{type:F,provider:O,extension:j}),this.a.$registerTaskProvider(T,F),new M.$OM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,F){this.a.$registerTaskSystem(j,F)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async F=>{const O=[];for(const T of F){const B=await w.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(F=>j.push(F)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,F,O){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(F,await T.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const F=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const F=await this.z(j.id);this.s.fire({execution:F,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const F=await this.z(j.id);this.u.fire({execution:F,exitCode:j.exitCode})}$provideTasks(j,F){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$fh)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(H=>this.v(F,T,O,H));return new Promise(H=>{B.then(X=>{Promise.all(T).then(()=>{H(X)})})})}async $resolveTask(j,F){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(F.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await w.to(F,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,O);const H=w.from(B,O.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(H.execution)&&await this.y(H,B,!0),await this.w(H)}x(){return this.h++}async y(j,F,O){const T=await this.a.$createTaskId(j);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,F.execution)),this.m.set(T,F.execution)}async z(j,F){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let T;return F?T=Promise.resolve(new y(this,j.id,F)):T=w.to(j.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,j.id,B)}),this.l.set(j.id,T),T.then(B=>(this.k.set(j.id,B),B))}A(j,F){j._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$Plc=C,e.$Plc=C=Je([We(0,$.$0O),We(1,E.$nP),We(2,b.$kkc),We(3,p.$iP),We(4,S.$nkc),We(5,P.$Lkc),We(6,o.$Tj),We(7,n.$1jc)],C);let I=class extends C{constructor(j,F,O,T,B,H,X,x){super(j,F,O,T,B,H,X,x),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const O=w.from(F,j);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.y(O,F,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(O),F);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(j,F,O,T){const B=[];if(T)for(const H of T){if(this.A(H,O),!H.definition||!j[H.definition.type]){const x=H.source?H.source:"No task source";this.f.warn(`The task [${x}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=w.from(H,O.extension);X&&h.is(X.execution)?(B.push(X),F.push(this.y(X,H,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(h.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,F,O){}};e.$Qlc=I,e.$Qlc=I=Je([We(0,$.$0O),We(1,E.$nP),We(2,b.$kkc),We(3,p.$iP),We(4,S.$nkc),We(5,P.$Lkc),We(6,o.$Tj),We(7,n.$1jc)],I),e.$Rlc=(0,v.$ni)("IExtHostTask")}),define(ke[369],Ee([1,0,36,29]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=void 0,e.$pL=L,e.$rL=R;function L(M){return"cellResults"in M}e.$qL="rawCell#";function R(M,b){let p=-1;const S=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==p&&A.length>0&&(S.push([...A]),A=[]),A.push($),p=$.range.endLineNumber}),A.length>0&&S.push([...A]),S.map($=>{const E=[],v=$[0].range.startLineNumber,a=$[$.length-1].range.endLineNumber;for(let m=v;m<=a;m++)E.push(b.getLineContent(m));return new u.$6K(E.join(`
`)+`
`,$.map(m=>new N.$ht(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[370],Ee([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,8,48,340,153,24,15,299,369,366]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,h,g,D,w,k){this.q=g,this.r=D,this.s=w,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$_d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$_d,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$_d,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$_d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Yjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy($.$MM.MainThreadNotebook),this.c=c.getProxy($.$MM.MainThreadNotebookDocuments),this.d=c.getProxy($.$MM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,I=y.cell.handle,j=this.g.get(C)?.getCell(I);if(j)return j.apiCell}if(y&&y.$mid===14){const C=y.uri,I=this.g.get(C);if(I)return I.apiNotebook}return y}}),d.B(h)}getEditorById(c){const h=this.h.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(c){for(const[h,g]of this.h)if(g.apiEditor===c)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,h){const g=this.g.get(c);if(!g&&!h)throw new Error(`NO notebook document for '${c}'`);return g}static u(c,h){if(!h)return;const g=h.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,h,g){const D=d.a++,w=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(D,g),this.b.$registerNotebookCellStatusBarItemProvider(D,w,h);let k;return w!==void 0&&(k=g.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new a.$OM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,w),k?.dispose()})}async createNotebookDocument(c){const h=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&v.NotebookData.from(c.content)});return S.URI.revive(h)}async openNotebookDocument(c){const h=this.g.get(c);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(c),D=this.g.get(S.URI.revive(g));return(0,p.$_f)(D?.apiNotebook)}async showNotebookDocument(c,h){S.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let g;typeof h=="object"?g={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,g),w=D&&this.h.get(D)?.apiEditor;if(w)return w;throw D?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,h,g,D){const w=this.f.get(c),k=S.URI.revive(h),y=this.g.get(k);if(!y||!w)return;const C=y.getCellFromIndex(g);if(!C)return;const I=await w.provideCellStatusBarItems(C.apiCell,D);if(!I)return;const z=new R.$Tc,j=this.p.add([z]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,z));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,h,g,D,w){if((0,b.$Ze)(h))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:h,serializer:g,options:D}),this.b.$registerNotebookSerializer(k,{id:c.identifier,location:c.extensionLocation},h,v.NotebookDocumentContentOptions.from(D),d.u(c,w)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.deserializeNotebook(h.buffer,g);return new m.$jw(v.NotebookData.from(w))}async $notebookToData(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.serializeNotebook(v.NotebookData.to(h.value),g);return N.$ze.wrap(w)}async $saveNotebook(c,h,g,D,w){const k=S.URI.revive(h),y=this.x.get(c);if(!y)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$cl((0,u.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$2n)(C.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of C.apiNotebook.getCells()){const B=new a.$eO(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$2n)(T.metadata,H=>!(y.options?.transientCellMetadata??{})[H]),I.cells.push(B)}const z=await y.serializer.serializeNotebook(I,w);await this.s.value.writeFile(k,z);const j=this.s.getFileSystemProviderExtUri(k.scheme),F=await this.s.value.stat(k);return{name:j.basename(k),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$nl({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(c,h,g,D,w){const k=this.x.get(c)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(F,O,T)=>{await Promise.all(F.map(async B=>await Promise.all(B.filenamePatterns.map(H=>{const X={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:H};return this.t.doInternalFileSearchWithCustomCallback(X,O,x=>{x.forEach(Y=>{y.has(Y)||D.some(ce=>B.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(ie=>(0,f.$igb)(ie,Y)))||y.add(Y)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})(g,w,h);const I=new M.$Bc;let z=!1;const j=Array.from(y).map(async F=>{const O=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...I.values()].reduce((X,x)=>X+x.cellResults.length,0)>h.maxResults){z=!0;return}const T=[],B=this.g.get(F);if(B)B.apiNotebook.getCells().forEach(x=>T.push({input:x.document.getText(),outputs:x.outputs.flatMap(Y=>Y.items.map(Z=>Z.data.toString()))}));else{const X=await this.s.value.readFile(F),x=N.$ze.fromString(X.toString()),Y=await k.deserializeNotebook(x.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(Y).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(ie=>ie.items.map(pe=>pe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;T.forEach((X,x)=>{const Y=h.contentPattern.pattern,Z=new s.$$Vb(X.input,void 0,X.outputs),ce=Z.findInInputs(Y),ie=Z.findInOutputs(Y),pe=ie.flatMap(Ce=>(0,t.$rL)(Ce.matches,Ce.textBuffer)).map((Ce,_)=>(Ce.webviewIndex=_,Ce));if(ce.length>0||ie.length>0){const Ce={index:x,contentResults:(0,t.$rL)(ce,Z.inputTextBuffer),webviewResults:pe};O.push(Ce)}});const H={resource:F,cellResults:O};I.set(F,H);return}catch{return}});return await Promise.all(j),{limitHit:z,results:[...I.values()]}}async y(c,h){const g=await this.s.value.stat(c);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$ml&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==A.$nl({mtime:h.mtime,size:g.size}))throw new A.$cl((0,u.localize)(1,null),3,h)}z(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}A(c,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new n.$jlc(h,this.d,c,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const g of c.value.removedDocuments){const D=S.URI.revive(g),w=this.g.get(D);w&&(w.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(w.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(c.value.addedDocuments){const g=[];for(const D of c.value.addedDocuments){const w=S.URI.revive(D.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const k=new o.$ilc(this.c,this.q,this.r,w,D);g.push(...D.cells.map(y=>o.$hlc.asModelAddData(y))),this.g.get(w)?.dispose(),this.g.set(w,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(k.apiNotebook)}}if(c.value.addedEditors)for(const g of c.value.addedEditors){if(this.h.has(g.id))return;const D=S.URI.revive(g.documentUri),w=this.g.get(D);w&&this.A(w,g.id,g)}const h=[];if(c.value.removedEditors)for(const g of c.value.removedEditors){const D=this.h.get(g);D&&(this.h.delete(g),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const g=new Set;this.l.forEach(D=>g.add(D.id));for(const D of this.h.values()){const w=g.has(D.id);D._acceptVisibility(w)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const h=E.$vP.String.with("notebookType","A notebook type"),g=new E.$xP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.$vP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>N.$ze.wrap(w))],new E.$wP("Notebook Data",w=>v.NotebookData.to(w.value))),D=new E.$xP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.$vP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$jw(v.NotebookData.from(w)))],new E.$wP("Bytes",w=>w.buffer));c.registerApiCommand(g),c.registerApiCommand(D)}}e.$slc=d}),define(ke[371],Ee([1,0,17,22,47,35,23,39,36]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class S{constructor($,E,v){this.k=$,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$hk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$hk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const E=this.k.folderQueries||[];return new Promise((v,a)=>{const m=o=>{this.f++,$(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,m))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{a(new Error((0,L.$$i)(o)))})})}async p($,E){const v=new N.$je,a=this.q($),m=this.r(),o=new p.$hL(this.k,$),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$8d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,v.token),s=i.elapsed(),t=b.$8d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative($.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(E,{base:$.folder,relativePath:d,basename:l});return}this.s(m,$.folder,d,E)}),this.g&&!this.e)?null:(this.u(m,o,E),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q($){const E=(0,p.$gL)(this.k.includePattern,$.includePattern),v=(0,p.$gL)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:v,includes:E,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},E,v,a){if(v===this.a){const o=u.$oc(this.a);this.v(a,{base:E,relativePath:this.a,basename:o})}function m(o){const n=u.$oc(o),i=u.$nc(o);let r=$[i];r||(r=$[i]=[],m(i)),r.push({base:E,relativePath:o,basename:n})}m(v)}u({rootEntries:$,pathToEntries:E},v,a){const m=this,o=this.a;function n(i){const r=(0,p.$jL)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(v.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const c=E[d];if(c)n(c);else{if(d===o)continue;m.v(a,f)}if(m.e)break}}n($)}v($,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,E,v,a){const m=this.c($.cacheKey),o=new S($,E,m&&m.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(o,A.a,i,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new N.$je),this.b.get($)}d($){return $.relativePath?{resource:M.$1g($.base,$.relativePath)}:{resource:$.base}}e($,E,v,a){const m=a.onCancellationRequested(()=>{$.cancel()}),o=i=>{i&&(n.push(i),E>0&&n.length>=E&&(v(n),n=[]))};let n=[];return $.search(o).then(i=>(n.length&&v(n),m.dispose(),i),i=>(n.length&&v(n),m.dispose(),Promise.reject(i)))}}e.$klc=A}),define(ke[372],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,245,54,12,41,146,367,36]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$rM=D;let s=class{constructor(k,y,C,I,z){this.a=k,this.b=y,this.c=C,this.d=I,this.e=z}text(k,y,C={}){k=this.f(k,C);const I=this.a.getValue(),z=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(o.$Ii),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,y){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,y)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),I}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(c):c(k),y?this.parseSearchPaths(k):{pattern:f(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),I=this.g(y.excludePattern,y.expandPatterns),z=k.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,y,I)):k.map(T=>this.r(T,y,I,z))).filter(T=>!!T),F={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(X=>X.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(X=>(0,r.$0K)(F,X.fsPath)),H=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...F,...H}}const O=y.extraFileResources&&y.extraFileResources.filter(T=>(0,r.$0K)(F,T.fsPath));return F.extraFileResources=O&&O.length?O:void 0,F}i(k){const y=[],C=new M.$Bc,I={};let z=!1;return k.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,S.$5g)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:p.$nc(j.fsPath)});let T=C.get(O);T||(z=!0,T={folder:O,includePattern:{}},y.push(T),C.set(O,T));const B=p.$mc(O.fsPath,j.fsPath);(0,P.$_f)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(z=!0,I[j.fsPath]=!0)}),{folderQueries:y,includePattern:I,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(A.$Rf(k.pattern,!0))return!0}else if(A.$Rf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$yC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=H=>p.$jc(H)||/^\.\.?([\/\\]|$)/.test(H),I=(Array.isArray(k)?k:d(k)).map(H=>{const X=this.e.resolvedUserHome;return X?(0,R.$ow)(H,X.scheme===b.Schemas.file?X.fsPath:X.path):H}),z=N.$K(I,H=>y(H)?"searchPaths":"exprSegments"),j=(z.exprSegments||[]).map(H=>A.$$e(H,"/")).map(H=>A.$$e(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),l(H))),F={},O=this.m(z.searchPaths||[]);O&&O.length&&(F.searchPaths=O);const T=u.$Rb(j),B=f(...T);return B&&(F.pattern=B),F}l(k,y){return y.disregardExcludeSettings?void 0:(0,r.$9K)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(I=>{let{pathPortion:z,globPortion:j}=t(I);return j&&(j=h(j)),this.n(z).flatMap(O=>this.o(O,j))}),C=new Map;return y.forEach(I=>{const z=I.searchPath.toString(),j=C.get(z);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):C.set(z,{searchPath:I.searchPath,pattern:I.pattern?f(I.pattern):void 0})}),Array.from(C.values())}n(k){if(p.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:$.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=c(k),k.startsWith("../")||k===".."){const I=p.$hc.resolve(y.path,k);return[{searchPath:y.with({path:I})}]}const C=h(k);return[{searchPath:y,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(z=>{const j=y.match(new RegExp(`^${A.$5e(z.name)}(?:/(.*)|$)`));return j?{match:j,folder:z}:null}).filter(P.$9f);if(I.length)return I.map(z=>{const j=z.match[1];return{searchPath:z.folder.uri,pattern:j&&h(j)}});{const z=k.match(/\.[\/\\](.+)[\/\\]?/),j=z?z[1]:k,F=v.localize(0,null,j);throw new Error(F)}}}}o(k,y){const C=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,I=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:C+"/**"}),I}q(k,y,C){const I=this.r((0,o.$Ii)(k.searchPath),y,C,!1);return I?{...I,includePattern:k.pattern}:null}r(k,y,C,I){let z;const j=$.URI.isUri(k)?k:k.uri;if(C.searchPaths){const H=C.searchPaths.filter(X=>(0,S.$Tg)(X.searchPath,j))[0];if(H&&!H.pattern)return null;H&&(z=H.pattern)}const F=this.a.getValue({resource:j}),T={...this.l(F,y)||{},...z||{}},B=$.URI.isUri(k)?(0,S.$Xg)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$qM=s,e.$qM=s=Je([We(0,a.$Ti),We(1,o.$wi),We(2,n.$FD),We(3,m.$Tj),We(4,i.$oM)],s);function t(w){const k=w.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,C=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let I=w.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:w.substr((C.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function d(w){return L.$fk(w,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function h(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(w){return w.replace(/([?*[\]])/g,"[$1]")}function D(w,k){w=u.$Mb(w,I=>I.toString());const y=[],C=k.getWorkspace();return w&&w.forEach(I=>{let z;if(k.getWorkbenchState()===2)z=(0,S.$3g)(C.folders[0].uri,I),z&&z!=="."&&(z="./"+z);else{const j=k.getWorkspaceFolder(I);if(j){const F=j.name;if(C.folders.filter(T=>T.name===F).length===1){const T=(0,S.$3g)(j.uri,I);T===""?z=`./${j.name}`:z=`./${j.name}/${T}`}else z=I.fsPath}}z&&y.push(g(z))}),y}}),define(ke[373],Ee([1,0,23,2,22,13,5,372,36,41,7]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jtb=$,e.$ktb=a;const P=7e3;function $(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const c of n)if(/^workspaceContains:/.test(c)){const h=c.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$gh)(),f=c=>t({activationEvent:c}),d=Promise.all(i.map(c=>E(m,c,f))).then(()=>{}),l=v(m,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function E(m,o,n){for(const i of m.folders)if(await m.exists(u.$1g(N.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.$je,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let f=!1;try{f=await s}catch(d){R.$4(d)||R.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function a(m,o,n,i){const r=m.get(M.$mi),s=m.get(p.$1K),f=r.createInstance(b.$qM).file(o.map(d=>(0,S.$Ii)(N.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[49],Ee([1,0,220,17,59,23,7,3,77,2,12,6,44,305,118,43,26,148,13,25,21,282,8,66,5,28,93,20,107,70,42,121,4,373,117,284,15,115,39,11,116]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,z,j,F,O,T,B){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=e.$1kc=e.$Zkc=e.$Ykc=void 0,e.$Ykc=(0,d.$ni)("IHostUtils");let X=H=class extends b.$Uc{constructor(U,ne,be,De,oe,ae,re,K,te,le,de,Ae,me){super(),this.Y=Ae,this.Z=me,this.a=this.B(new y.$_d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ne,this.g=be,this.f=re,this.j=De,this.m=oe,this.s=ae,this.t=te,this.u=le,this.w=de,this.y=this.g.getProxy(P.$MM.MainThreadWorkspace),this.z=this.g.getProxy(P.$MM.MainThreadTelemetry),this.C=this.g.getProxy(P.$MM.MainThreadExtensionService),this.D=new M.$mh,this.F=new M.$mh,this.G=new M.$mh,this.H=new M.$mh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$B$b(this.I,this.f.extensions.allExtensions);const Pe=new i.$Jm(this.f.extensions.myExtensions);this.J=new o.$B$b(this.I,ie(this.L,Pe)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new v.$Hkc(this.g,this.s),this.N=new I.$Rkc(this.g),this.O=K,this.h=U.createChild(new g.$li([v.$Ikc,this.M],[I.$Skc,this.N])),this.P=this.B(new E.$Gkc(this.J,this.L,{onExtensionActivationError:(Re,Fe,V)=>{this.C.$onExtensionActivationError(Re,n.$3(Fe),V)},actualActivateExtension:async(Re,Fe)=>{if(o.$B$b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Fe),new E.$Fkc;const V=this.J.getExtensionDescription(Re);return this.fb(V,Fe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this.eb(oe))}catch{}await Promise.all(U)}terminate(U,ne=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(De=>{this.s.error(De)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$oh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ne=await this.C.$getExtension(U);return ne&&{...ne,identifier:new i.$Im(ne.identifier.value),extensionLocation:S.URI.revive(ne.extensionLocation)}}ab(U,ne){return this.P.activateByEvent(U,ne)}bb(U,ne){return this.P.activateById(U,ne)}activateByIdWithErrors(U,ne){return this.bb(U,ne).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ne=U.fsPath;this.R.has(ne)||this.R.set(ne,this.c.fsRealpath(ne));const be=await this.R.get(ne);return S.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new pe(U))),this.Q}async db(U){const ne=p.$ti.forUris(be=>R.$Rg.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const De=await this.cb(be.extensionLocation);ne.set(De,be)}})),ne}eb(U){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ne;const be=this.P.getActivatedExtension(U);if(!be)return ne;try{typeof be.module.deactivate=="function"&&(ne=Promise.resolve(be.module.deactivate()).then(void 0,De=>(this.s.error(De),Promise.resolve(void 0))))}catch(De){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(De)}try{(0,b.$Pc)(be.subscriptions)}catch(De){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(De)}return ne}async fb(U,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ne).then(be=>{const De=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,ne),this.gb(U,ne,"success",De),be},be=>{throw this.gb(U,ne,"failure"),be})}gb(U,ne,be,De){const oe=Y(U,ne);this.z.$publicLog2("extensionActivationTimes",{...oe,...De||{},outcome:be})}hb(U,ne){const be=Y(U,ne);this.z.$publicLog2("activatePlugin",be);const De=this.wb(U);if(!De)return Promise.resolve(new E.$Ekc(E.$Bkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${U.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const oe=new E.$Ckc(ne.startup);return Promise.all([this.xb(U,(0,R.$1g)(U.extensionLocation,De),oe),this.ib(U)]).then(ae=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),H.jb(this.s,U.identifier,ae[0],ae[1],oe))).then(ae=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ae))}ib(U){const ne=this.Z.createLanguageModelAccessInformation(U),be=new s.$Kkc(U,this.M),De=new s.$Jkc(U.identifier.value,!1,this.M),oe=new z.$Tkc(U,this.N),ae=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,De.whenReady,this.O.whenReady]).then(()=>{const K=this;let te,le;const de=(0,m.$uG)(U,"ipc")?this.f.messagePorts?.get(i.$Im.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:De,secrets:oe,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return N.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return N.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return ae},get extension(){return te===void 0&&(te=new ce(K,U.identifier,U,re,!1)),te},get extensionRuntime(){return(0,m.$vG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!le){if(!de)return;const Ae=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",me=>me.data));de.start(),le={onDidReceiveMessage:Ae,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(U,ne,be,De,oe){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ne,be,De,oe).then(ae=>new E.$Dkc(!1,null,oe.build(),be,ae,De.subscriptions))}static kb(U,ne,be,De,oe){if(typeof be.activate=="function")try{oe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const ae=typeof global=="object"?global:self,re=be.activate.apply(ae,[De]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(re).then(K=>(oe.activateResolveStop(),K))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(be)}lb(U,ne){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ne}).then(void 0,be=>{this.s.error(be)})}mb(U,ne=0){const De=Date.now();(0,T.$B)(()=>{for(let oe=ne;oe<U.length;oe+=1){const ae=U[oe];for(const re of ae.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-De>50){this.mb(U,oe);break}else this.lb(ae,re)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ne=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ne)this.mb(be);else for(const De of be)if(De.activationEvents)for(const oe of De.activationEvents)oe==="onStartupFinished"&&this.lb(De,oe)})}ob(){const U=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const ne=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ne),De=this.rb(),oe=Promise.all([De,U,be]).then(()=>{});return Promise.race([oe,(0,M.$oh)(1e4)]).then(()=>{this.nb()}),oe}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.qb(U,ne))).then(()=>{})}async qb(U,ne){if(this.isActivated(ne.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,De={logService:this.s,folders:U.map(ae=>ae.uri),forceUsingSearch:be||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,re,K)=>this.y.$checkExists(ae,re,K)},oe=await(0,C.$jtb)(De,ne);if(oe)return this.bb(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:oe.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ne}=this.f.environment;if(!U||!ne)throw new Error(u.localize(0,null));const be=await this.xb(null,ne,new E.$Ckc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ne.toString()));return new Promise((De,oe)=>{const ae=(te,le)=>{te?(T.$t&&this.s.error("Test runner called back with error",te),oe(te)):(T.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),De(typeof le=="number"&&le>0?1:0))},re=(0,R.$Og)(ne),K=be.run(re,ae);K&&K.then&&K.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),De(0)}).catch(te=>{T.$t&&this.s.error("Test runner finished with error",te),oe(te instanceof Error&&te.stack?te.stack:String(te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$oh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ne){return this.S[U]=ne,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ne}=await this.ub(U);return ne?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ne=U.indexOf("+");if(ne===-1)throw new t.$UM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ne);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ne){const be=O.$8d.create(!1),De=()=>`[resolveAuthority(${(0,f.$Cl)(U)},${ne})][${be.elapsed()}ms] `,oe=W=>this.s.info(`${De()}${W}`),ae=W=>this.s.warn(`${De()}${W}`),re=(W,Q=void 0)=>this.s.error(`${De()}${W}`,Q),K=W=>{if(W instanceof t.$UM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},te=async W=>{oe(`activating resolver for ${W}...`);const{resolver:Q,authorityPrefix:J}=await this.ub(W);if(!Q)throw re(`no resolver for ${J}`),new t.$UM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:W}},le=U.split(/@|%40/g).reverse();oe(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(te)).catch(async W=>{if(!(W instanceof t.$UM)||W._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return ae(`resolving nested authorities failed: ${W.message}`),[await te(U)]})}catch(W){return K(W)}const Ae=new M.$yh;Ae.cancelAndSet(()=>oe("waiting..."),1e3);let me,Pe;for(const[W,{authorityPrefix:Q,resolver:J,remoteAuthority:fe}]of de.entries())try{if(W===de.length-1)oe("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${Q}`),me=await J.resolve(fe,{resolveAttempt:ne,execServer:Pe}),L.mark(`code/extHost/didResolveAuthorityOK/${Q}`),oe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$TM.isManagedResolvedAuthority(me)?me:void 0));else{if(oe(`invoking resolveExecServer() for ${fe}`),L.mark(`code/extHost/willResolveExecServer/${Q}`),Pe=await J.resolveExecServer?.(fe,{resolveAttempt:ne,execServer:Pe}),!Pe)throw new t.$UM(`Exec server was not available for ${fe}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${Q}`),re("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Re={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures?{elevation:me.tunnelFeatures.elevation,privacyOptions:me.tunnelFeatures.privacyOptions,protocol:me.tunnelFeatures.protocol===void 0?!0:me.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};oe(`returned ${t.$TM.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let V;if(t.$TM.isManagedResolvedAuthority(me)){const W=ne;this.Y.setFactory(W,me.makeConnection),V={authority:U,connectTo:new f.$zl(W),connectionToken:me.connectionToken}}else V={authority:U,connectTo:new f.$Al(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:V,options:Fe,tunnelInformation:Re}}}async $getCanonicalURI(U,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Cl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const De=S.URI.revive(ne);if(typeof be.getCanonicalURI>"u")return De;const oe=await(0,M.$fh)(()=>be.getCanonicalURI(De));return oe||De}async $startExtensionHost(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ne,myExtensions:be}=x(this.I,this.L,this.J,U),De=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.tb()}$activateByEvent(U,ne){return ne===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ne){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ne),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ne,myExtensions:be}=x(this.I,this.L,this.J,U),De=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ne=r.$ze.alloc(U),be=Math.random()%256;for(let De=0;De<U;De++)ne.writeUInt8(be,De);return ne}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$Zkc=X,e.$Zkc=X=H=Je([We(0,d.$mi),We(1,e.$Ykc),We(2,h.$0O),We(3,a.$kkc),We(4,$.$nkc),We(5,A.$Tj),We(6,l.$nP),We(7,c.$qkc),We(8,D.$lCb),We(9,w.$Lkc),We(10,F.$Vkc),We(11,B.$Wkc),We(12,k.$Pkc)],X);function x(_,U,ne,be){_.addActivationEvents(be.addActivationEvents);const De=new o.$B$b(_,U.getAllExtensionDescriptions());De.deltaExtensions(be.toAdd,be.toRemove);const oe=new i.$Jm(ne.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of be.myToRemove)oe.delete(re);for(const re of be.myToAdd)oe.add(re);const ae=ie(De,oe);return{globalRegistry:De,myExtensions:ae}}function Y(_,U){return{id:_.identifier.value,name:_.name,extensionVersion:_.version,publisherDisplayName:_.publisher,activationEvents:_.activationEvents?_.activationEvents.join(","):null,isBuiltin:_.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Z(_){return _.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$1kc=(0,d.$ni)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(U,ne,be,De,oe){this.#e=U,this.#t=ne,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,R.$Og)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=De,this.isFromDifferentExtensionHost=oe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$2kc=ce;function ie(_,U){return _.getAllExtensionDescriptions().filter(ne=>U.has(ne.identifier))}class pe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$3kc=pe;class Ce{constructor(U){this.a=new i.$Km,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ne of Object.keys(U))this.a.set(ne,U[ne])}}}),define(ke[374],Ee([1,0,59,2,6,44,26,25,20,28,5,49,12,14]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let a=class{constructor(r,s,t,f,d,l,c){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$_lc=a,e.$_lc=a=Je([We(2,A.$mi),We(3,R.$nkc),We(4,P.$1kc),We(5,S.$nP),We(6,$.$Tj)],a);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,E.$5e)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=v.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=v=Je([We(0,S.$nP)],m);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new b.$Km}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$pG,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$MM.MainThreadTelemetry);const f=t.getProxy(L.$MM.MainThreadWindow);this.c=(d,l)=>{const c=N.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?f.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?f.$openUri(c,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,p.$0O)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,8,43,302,44]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,M.$ni)("IExtHostVariableResolverProvider");class v extends $.$_P{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const c=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$zO||c.input instanceof A.$EO)return c.input.modified;if(c.input instanceof A.$yO||c.input instanceof A.$DO||c.input instanceof A.$BO)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>s.getConfiguration(void 0,l).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return L.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const c=n.getWorkspaceFolder(l);if(c)return L.$ic(c.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let a=class extends N.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$5kc=a,e.$5kc=a=Je([We(0,S.$1kc),We(1,P.$kkc),We(2,b.$iP),We(3,E.$nkc),We(4,p.$zkc)],a)}),define(ke[96],Ee([1,0,7,4,2,25,5,6,71,49,20,8,43,143,294,44,61,3,57,33,16]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=e.$8kc=e.$7kc=e.$6kc=void 0,e.$6kc=(0,M.$ni)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,D,w,k,y,C,I){this.N=D,this.O=w,this.P=k,this.Q=y,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$_d,this.o=new N.$_d,this.q=new N.$_d,this.w=new N.$_d,this.l=g.getProxy(b.$MM.MainThreadDebugService),this.A=new N.$_d,this.C=new N.$_d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(z=>{z.onDidChange(j=>{this.V(z)}),this.V(z)})}async $getVisualizerTreeItem(g,D){const w=this.W(D);if(!w)return;const k=await this.H.get(g)?.getTreeItem?.(w);return k?this.U(g,k):void 0}registerDebugVisualizationTree(g,D,w){const k=R.$Im.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,w),this.l.$registerDebugVisualizerTree(y,!!w.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const w=this.J.get(D)?.item;return w?(await this.H.get(g)?.getChildren?.(w))?.map(y=>this.U(g,y))||[]:[]}async $editVisualizerTreeItem(g,D){const w=this.J.get(g);if(!w)return;const k=await this.H.get(w.provider)?.editItem?.(w.item,D);return this.U(w.provider,k||w.item)}$disposeVisualizedTree(g){const D=this.J.get(g);if(!D)return;const w=[D.children];for(const k of w)if(k)for(const y of k)w.push(this.J.get(y)?.children),this.J.delete(y)}U(g,D){let w=this.I.get(D);return w||(w=this.F++,this.I.set(D,w),this.J.set(w,{provider:g,item:D})),r.DebugTreeItem.from(D,w)}asDebugSourceUri(g,D){const w=g;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let k=`debug:${encodeURIComponent(w.path||"")}`,y="?";return D&&(k+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),k+=`${y}ref=${w.sourceReference}`,L.URI.parse(k)}else{if(w.path)return L.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const D=[];for(const w of g.getAllExtensionDescriptions())if(w.contributes){const k=w.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,v.$9G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const w=this.L.get(g);if(!w)throw new Error(`No debug visualizer found with id '${g}'`);let{v:k,provider:y,extensionId:C}=w;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,D)||k,w.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(g){const D=this.L.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const w=D.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(g){const D=this.m.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,w,k){const y=this.W(w),C=this.jb(g,D),I=this.G.get(C);if(!y||!I)return[];const z=await I.provideDebugVisualization(y,k);return z?z.map(j=>{const F=++this.M;this.L.set(F,{v:j,provider:I,extensionId:g});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:F,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(g,j.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this.L.delete(D)}registerDebugVisualizationProvider(g,D,w){if(!g.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=R.$Im.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,w),this.l.$registerDebugVisualizer(k,D),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(g){const D=g.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const w=[],k=new Map;for(const y of D)if(y instanceof P.$PN){let C=k.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),C),w.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof P.$QN&&w.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(g){const D=g.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const w=D.filter(C=>C instanceof P.$PN).map(C=>C.id),k=D.filter(C=>C instanceof P.$QN).map(C=>C.id),y=D.filter(C=>C instanceof P.$RN).map(C=>C.id);return this.l.$unregisterBreakpoints(w,k,y)}startDebugging(g,D,w){return this.l.$startDebugging(g?g.uri:void 0,D,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,w){if(!D)return new P.$OM(()=>{});const k=this.d++;return this.f.push({type:g,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(g,w,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new P.$OM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(g,D,w){if(!w)return new P.$OM(()=>{});if(!this.cb(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new P.$OM(()=>{this.h=this.h.filter(y=>y.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new P.$OM(()=>{});const w=this.j++;return this.k.push({type:g,handle:w,factory:D}),new P.$OM(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let w;const k=await this.ib(g);return k&&(w={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,D)}X(g,D){if(g.type==="implementation")return new l(g.implementation)}Y(){}async $startDASession(g,D){const w=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(y),I=this.X(C,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const z=I;return this.D.set(g,z),this.db(k).then(j=>(j&&this.E.set(g,j),z.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const O=F,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},z.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,z.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(F),F=(0,v.$bH)(F,!0),w.l.$acceptDAMessage(g,F)}),z.onError(F=>{j&&j.onError&&j.onError(F),this.l.$acceptDAError(g,F.name,F.message,F.stack)}),z.onExit(F=>{j&&j.onExit&&j.onExit(F??void 0,void 0),this.l.$acceptDAExit(g,F??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),z.startSession()))})}$sendDAMessage(g,D){D=(0,v.$aH)(D,!1);const w=this.E.get(g);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(D),this.D.get(g)?.sendMessage(D)}$stopDASession(g){const D=this.E.get(g);this.E.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const w=this.D.get(g);return this.D.delete(g),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],w=[],k=[];if(g.added)for(const y of g.added){const C=y.id;if(C&&!this.z.has(C)){let I;if(y.type==="function")I=new P.$QN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")I=new P.$RN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=L.URI.revive(y.uri);I=new P.$PN(new P.$1M(z,new P.$PM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,P.$NN)(I,C),this.z.set(C,I),D.push(I)}}if(g.removed)for(const y of g.removed){const C=this.z.get(y);C&&(this.z.delete(y),w.push(C))}if(g.changed){for(const y of g.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof P.$QN&&y.type==="function"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.functionName=y.functionName}else if(C instanceof P.$PN&&y.type==="source"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.location=new P.$1M(L.URI.revive(y.uri),new P.$PM(y.line,y.character))}k.push(C)}}}this.gb(D,w,k)}async $acceptStackFrameFocus(g){let D;if(g){const w=await this.hb(g.sessionId);g.kind==="thread"?D=new P.$XN(w.api,g.threadId):D=new P.$WN(w.api,g.threadId,g.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(g,D,w){return(0,u.$fh)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return k.provideDebugConfigurations(y,w)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(g,D,w,k){return(0,u.$fh)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,w,k)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,w,k){return(0,u.$fh)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,w,k)})}async $provideDebugAdapter(g,D){const w=this.ab(g);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(w,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(g){const D=await this.hb(g);this.n.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.hb(g);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.hb(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const k={session:(await this.hb(g)).api,event:D.event,body:D.body};this.w.fire(k)}Z(g){if(g instanceof P.$SN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.$TN)return{type:"server",port:g.port,host:g.host};if(g instanceof P.$UN)return{type:"pipeServer",path:g.path};if(g instanceof P.$VN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const D=this.h.filter(w=>w.type===g);if(D.length>0)return D[0].factory}ab(g){const D=this.h.filter(w=>w.handle===g);if(D.length>0)return D[0].factory}bb(g){const D=this.f.filter(w=>w.handle===g);if(D.length>0)return D[0].provider}cb(g,D){if(g.contributes){const w=g.contributes.debuggers;if(w&&w.length>0){for(const k of w)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(g){const w=g.configuration.type,k=this.k.filter(y=>y.type===w||y.type==="*").map(y=>(0,u.$fh)(()=>y.factory.createDebugAdapterTracker(g.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(y=>{const C=y.filter(I=>!!I);if(C.length>0)return new d(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(g,D){const w=D.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new P.$TN(w));if(g){const y=await this.O.getExtensionRegistry();return(0,u.$fh)(()=>g.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(g,D){}gb(g,D,w){(g.length>0||D.length>0||w.length>0)&&this.A.fire(Object.freeze({added:g,removed:D,changed:w}))}async hb(g){if(g)if(typeof g=="string"){const D=this.m.get(g);if(D)return D}else{let D=this.m.get(g.id);if(!D){const w=await this.ib(g.folderUri),k=g.parent?this.m.get(g.parent):void 0;D=new t(this.l,g.id,g.type,g.name,w,g.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(g){if(g){const D=L.URI.revive(g);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(g,D){return`${g}\0${D}`}kb(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const D=this.mb(g);let w,k;return"id"in D?k=n.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:k}}mb(g){if(g instanceof P.$KN)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,w=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof w=="string"?L.URI.file(w):w}}};e.$7kc=s,e.$7kc=s=Je([We(0,A.$0O),We(1,$.$kkc),We(2,S.$1kc),We(3,a.$nkc),We(4,p.$zkc),We(5,m.$4kc),We(6,i.$tP)],s);class t{constructor(g,D,w,k,y,C,I){this.f=g,this.g=D,this.h=w,this.j=k,this.k=y,this.l=C,this.m=I}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(D){g.j=D,g.f.$setDebugSessionName(g.g,D)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(D,w){return g.f.$customDebugAdapterRequest(g.g,D,w)},getDebugProtocolBreakpoint(D){return g.f.$getDebugProtocolBreakpoint(g.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$8kc=t;class f{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$9kc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.d.forEach(w=>w.onExit?w.onExit(g,D):void 0)}}class l extends E.$oob{constructor(g){super(),this.h=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends s{constructor(g,D,w,k,y,C,I){super(g,D,w,k,y,C,I)}};e.$0kc=c,e.$0kc=c=Je([We(0,A.$0O),We(1,$.$kkc),We(2,S.$1kc),We(3,a.$nkc),We(4,p.$zkc),We(5,m.$4kc),We(6,i.$tP)],c)}),define(ke[375],Ee([1,0,13,59,2,6,322,12,84,107,28,258,20,67,49,90]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.$Tj),t=i.get($.$0O).getProxy(R.$MM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(b.$Tj),s=i.get($.$0O),t=i.get(v.$1kc),f=i.get(a.$rP),d=s.getProxy(R.$MM.MainThreadExtensionService),l=s.getProxy(R.$MM.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function g(k,y){if(h.has(k))return h.get(k).stack;let C="",I,z;for(const F of y)C+=`
	at ${F.toString()}`,z=F.getFileName(),!I&&z&&(I=c.findSubstr(L.URI.file(z)));const j=`${k.name||"Error"}: ${k.message||""}${C}`;return h.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let w=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(k){if(k===g||!k||k[D]){w=k||g;return}w=function(y,C){return g(y,C),k.call(Error,y,C)},Object.assign(w,{[D]:!0})}}),u.setUnexpectedErrorHandler(k=>{r.error(k);const y=u.$3(k),C=h.get(k);if(!C?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(C.extensionIdentifier,y);const I=f.onExtensionError(C.extensionIdentifier,k);r.trace("forwarded error to extension?",I,C)})}}e.$amc=m;class o{constructor(i,r,s,t,f){this.a=s,this.b=new M.$J$b(i,null,t),r=o.e(r,this.b);const d=new S.$li(...(0,p.$ms)());d.set(A.$nP,{_serviceBrand:void 0,...r,messagePorts:f}),d.set($.$0O,new $.$$O(this.b)),d.set(E.$hkc,new E.$ikc(t)),d.set(v.$Ykc,s);const l=new P.$4q(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(b.$Tj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(c=>c.get(v.$1kc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(R.$MM.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$bmc=o}),define(ke[376],Ee([1,0,7,11,231,251,141,96,71,49,20,42,8,61,43,295,296,44,33,377]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;let r=class extends b.$7kc{constructor(c,h,g,D,w,k,y,C){super(c,h,g,D,k,y,C),this.pb=w,this.nb=new d}X(c,h){switch(c.type){case"server":return new a.$gmc(c);case"pipeServer":return new a.$hmc(c);case"executable":return new a.$imc(c,h.type)}return super.X(c,h)}fb(c,h){const g=a.$imc.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(g)return new $.$SN(g.command,g.args,g.options)}Y(){return new M.$xcc}async $runInTerminal(c,h){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(T=>{this.nb.onTerminalClosed(T)}));const g=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),k=c.title||L.localize(0,null),y=s(D,w,c);let C=await this.nb.checkout(y,k,!0),I,z=!1;if(C)I=c.cwd;else{const T={shellPath:D,shellArgs:w,cwd:c.cwd,name:k,iconPath:new $.$KN("debug"),env:c.env};z=!0,C=this.pb.createTerminalFromOptions(T,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,y)}C.show(!0);const j=await C.processId;z?await new Promise(T=>setTimeout(T,1e3)):(C.state.isInteractedWith&&C.sendText(""),g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):N.$i?C.sendText("cls"):C.sendText("clear")));const F=(0,m.$kmc)(D,c.args,!!c.argsCanBeInterpretedByShell,I);C.sendText(F);const O=this.onDidTerminateDebugSession(T=>{T.id===h&&(this.nb.free(C),O.dispose())});return j}else if(c.kind==="external")return f(c,await this.P.getConfigProvider());return super.$runInTerminal(c,h)}};e.$lmc=r,e.$lmc=r=Je([We(0,A.$0O),We(1,v.$kkc),We(2,S.$1kc),We(3,o.$nkc),We(4,P.$Lkc),We(5,p.$zkc),We(6,E.$4kc),We(7,n.$tP)],r);function s(l,c,h){const g=(0,i.createHash)("sha256");return g.update(JSON.stringify({shell:l,shellArgs:c})),g.update(JSON.stringify(Object.entries(h.env||{}).sort(([D],[w])=>D.localeCompare(w)))),g.digest("base64")}let t;function f(l,c){if(!t)if(N.$i)t=new R.$ibc;else if(N.$j)t=new R.$jbc;else if(N.$k)t=new R.$kbc;else throw new Error("external terminals not supported on this platform");const h=c.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,h,g=!1){const w=[...this.b.entries()].map(([k,y])=>(0,u.$ah)(async C=>{if(k.name!==h||y.lastUsedAt!==-1&&await(0,m.$jmc)(await k.processId))return null;const I=Date.now();return y.lastUsedAt+d.a>I||C.isCancellationRequested?null:y.config!==c?(g&&k.dispose(),null):(y.lastUsedAt=I,k)}));return await(0,u.$sh)(w,k=>!!k)}insert(c,h){this.b.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this.b.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(ke[378],Ee([1,0,17,2,105,43,72,44,41,42,20,28,95,15,12,91,23,64,61]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let i=class extends $.$Plc{constructor(s,t,f,d,l,c,h,g,D){super(s,t,f,d,l,c,h,g),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=$.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=$.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const c of d){this.A(c,f),(!c.definition||!s[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(c,f.extension);h&&(l.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,c,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=N.URI.file((0,o.homedir)());t=new p.$Hi({uri:f,name:m.$Xg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=N.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),c=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const D of t.variables)d.variables[D]=await h.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let w=0;w<D.length;w++)D[w]=await h.resolveAsync(g,D[w])}d.process=await L.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return L.win32.findExecutable(s,t,f)}};e.$dmc=i,e.$dmc=i=Je([We(0,A.$0O),We(1,P.$nP),We(2,R.$kkc),We(3,M.$iP),We(4,b.$nkc),We(5,S.$Lkc),We(6,v.$Tj),We(7,a.$1jc),We(8,n.$4kc)],i)}),define(ke[379],Ee([1,0,64,61]),function(he,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class L extends N.$5kc{m(){return(0,u.homedir)()}}e.$Vmc=L}),define(ke[159],Ee([1,0,19,7,22,47,15,17,23,2,36]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$mlc=e.$llc=void 0,e.$nlc=a;class P{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new L.$je(i);return new Promise((t,f)=>{this.a=new E(n);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const g=this.h(c);a(c)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),c=this.j(c,this.g.maxResults-this.c));const D=this.h(c);this.c+=D,(D>0||!a(c))&&this.a.add(c,h)}};Promise.all(r.map((c,h)=>this.k(c,g=>l(g,h),s.token))).then(c=>{s.dispose(),this.a.flush();const h=c.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(c.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},c=>{s.dispose();const h=(0,R.$$i)(c);f(new Error(h))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new A.$hL(this.g,n),t=[],f={report:c=>{if(!this.l(c))return;const h=n.folder.scheme===M.Schemas.file?(0,A.$iL)(()=>this.e.readdir(p.$Zg(c.uri))):void 0,g=p.$3g(n.folder,c.uri);if(g){const D=s.includedInQuery(g,b.$oc(g),h);(0,N.$_g)(D)?t.push(D.then(w=>{w&&i(c)})):D&&i(c)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$gL)(this.g.includePattern,n.includePattern),r=(0,A.$gL)(this.g.excludePattern,n.excludePattern),s={folder:S.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$llc=P;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!p.$Tg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$mlc=E;function v(o){return a(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function a(o){return!!o.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$olc=m}),define(ke[97],Ee([1,0,3,6,5,371,20,67,12,2,159]),function(he,e,u,N,L,R,M,b,p,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=void 0,e.$rlc=$,e.$plc=(0,L.$ni)("IExtHostSearch");let P=class{constructor(a,m,o){this.n=a,this.o=m,this.q=o,this.c=this.n.getProxy(N.$MM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$klc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.g.delete(a),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.i.delete(a),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.k.delete(a),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(a,m,o,n){const i=$(o),r=this.j.get(a);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,o){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,o,n){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=$(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$provideAITextSearchResults(a,m,o,n){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=$(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$enableExtensionHostSearch(){}t(a,m){return new A.$llc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(a,m){return new A.$llc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$qlc=P,e.$qlc=P=Je([We(0,M.$0O),We(1,b.$hkc),We(2,p.$Tj)],P);function $(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(a=>S.URI.revive(a))}}function E(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[380],Ee([1,0,22,13,4,3,15,40,2,135,198,179,79,25,32,12,86,87,277,6,324,350,91,120,328,329,330,311,300,33,331,44,332,96,151,333,313,325,334,335,72,71,326,49,336,69,337,60,28,351,352,314,338,121,339,115,116,315,370,341,283,342,353,343,157,316,344,345,346,20,347,97,117,348,317,349,118,93,95,90,42,155,354,355,327,356,357,70,16,8,318,67,319,92,358,359,150,43,293,114,26,94]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,z,j,F,O,T,B,H,X,x,Y,Z,ce,ie,pe,Ce,_,U,ne,be,De,oe,ae,re,K,te,le,de,Ae,me,Pe,Re,Fe,V,W,Q,J,fe,we,ze,Ve,Xe,st,ot,tt,rt,Se,Be,Ge,Le,Ye,se,ue,Ie,Ke,Me,it,lt,wt,It,Ft,qt,xt,St,Wt,Gt,et,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=_t;function _t(ft){const $t=ft.get(pe.$nP),ei=ft.get(ie.$5jc),ti=ft.get(Z.$pkc),zt=ft.get(x.$1kc),gt=ft.get(St.$kkc),Bt=ft.get(rt.$rP),ii=ft.get(k.$nkc),Ot=ft.get(lt.$hkc),xe=ft.get(Q.$0O),si=ft.get(st.$Ikc),Kt=ft.get(ot.$qkc),Ut=ft.get(a.$Uj),mt=ft.get(a.$Tj),Tt=ft.get(Ie.$lCb),Lt=ft.get(t.$1jc),Ht=ft.get(xt.$7lc),Jt=ft.get(we.$Skc),Qt=ft.get(H.$zkc),oi=ft.get(ae.$Wkc),At=ft.get(f.$$jc),Nt=ft.get(be.$Pkc);xe.set(i.$NM.ExtHostFileSystemInfo,ei),xe.set(i.$NM.ExtHostLogLevelServiceShape,Ut),xe.set(i.$NM.ExtHostWorkspace,gt),xe.set(i.$NM.ExtHostConfiguration,ii),xe.set(i.$NM.ExtHostExtensionService,zt),xe.set(i.$NM.ExtHostStorage,si),xe.set(i.$NM.ExtHostTunnelService,Tt),xe.set(i.$NM.ExtHostWindow,Ht),xe.set(i.$NM.ExtHostSecretState,Jt),xe.set(i.$NM.ExtHostTelemetry,Bt),xe.set(i.$NM.ExtHostEditorTabs,Qt),xe.set(i.$NM.ExtHostManagedSockets,oi),xe.set(i.$NM.ExtHostAuthentication,At),xe.set(i.$NM.ExtHostChatProvider,Nt);const Pt=xe.set(i.$NM.ExtHostDecorations,ft.get(I.$_kc)),Dt=xe.set(i.$NM.ExtHostDocumentsAndEditors,ft.get(B.$iP)),bt=xe.set(i.$NM.ExtHostCommands,ft.get(D.$tP)),Ct=xe.set(i.$NM.ExtHostTerminalService,ft.get(Se.$Lkc)),li=xe.set(i.$NM.ExtHostTerminalShellIntegration,ft.get(Be.$Slc)),kt=xe.set(i.$NM.ExtHostDebugService,ft.get(C.$6kc)),hi=xe.set(i.$NM.ExtHostSearch,ft.get(fe.$plc)),Yt=xe.set(i.$NM.ExtHostTask,ft.get(tt.$Rlc)),ai=xe.set(i.$NM.ExtHostOutputService,ft.get(Pe.$Elc)),pi=xe.set(i.$NM.ExtHostLocalization,ft.get(oe.$Vkc)),ni=xe.set(i.$NM.ExtHostUrls,new wt.$4lc(xe)),Rt=xe.set(i.$NM.ExtHostDocuments,new T.$8jc(xe,Dt)),yi=xe.set(i.$NM.ExtHostDocumentContentProviders,new F.$blc(xe,Dt,mt)),Ne=xe.set(i.$NM.ExtHostDocumentSaveParticipant,new O.$clc(mt,Rt,xe.getProxy(i.$MM.MainThreadBulkEdits))),je=xe.set(i.$NM.ExtHostNotebook,new K.$slc(xe,bt,Dt,Rt,ti,hi)),ye=xe.set(i.$NM.ExtHostNotebookDocuments,new le.$ylc(je)),ee=xe.set(i.$NM.ExtHostNotebookEditors,new de.$zlc(mt,je)),Oe=xe.set(i.$NM.ExtHostNotebookKernels,new Ae.$Alc(xe,$t,je,bt,mt)),qe=xe.set(i.$NM.ExtHostNotebookRenderers,new me.$Clc(xe,je)),_e=xe.set(i.$NM.ExtHostNotebookDocumentSaveParticipant,new te.$xlc(mt,je,xe.getProxy(i.$MM.MainThreadBulkEdits))),Qe=xe.set(i.$NM.ExtHostEditors,new Le.$ekc(xe,Dt)),ht=xe.set(i.$NM.ExtHostTreeViews,new ue.$2lc(xe.getProxy(i.$MM.MainThreadTreeViews),bt,mt)),Et=xe.set(i.$NM.ExtHostEditorInsets,new g.$fkc(xe.getProxy(i.$MM.MainThreadEditorInsets),Qe,$t.remote)),jt=xe.set(i.$NM.ExtHostDiagnostics,new z.$7jc(xe,mt,ei,Dt)),Xt=xe.set(i.$NM.ExtHostLanguages,new De.$vlc(xe,Rt,bt.converter,Ot)),ut=xe.set(i.$NM.ExtHostLanguageFeatures,new ne.$9jc(xe,Ot,Rt,bt,jt,mt,Lt,Bt)),Zt=xe.set(i.$NM.ExtHostFileSystem,new Y.$elc(xe,ut)),mi=xe.set(i.$NM.ExtHostFileSystemEventService,new ce.$flc(xe,mt,Dt)),bi=xe.set(i.$NM.ExtHostQuickOpen,(0,W.$Ilc)(xe,gt,bt)),Si=xe.set(i.$NM.ExtHostSCM,new J.$Klc(xe,bt,Rt,mt)),Mi=xe.set(i.$NM.ExtHostQuickDiff,new V.$Hlc(xe,Ot)),Li=xe.set(i.$NM.ExtHostShare,new ze.$Llc(xe,Ot)),Vi=xe.set(i.$NM.ExtHostComments,(0,w.$gkc)(xe,bt,Rt)),qi=xe.set(i.$NM.ExtHostProgress,new Fe.$Glc(xe.getProxy(i.$MM.MainThreadProgress))),Gi=xe.set(i.$NM.ExtHostLabelService,new U.$ulc(xe)),Di=xe.set(i.$NM.ExtHostTheming,new Ye.$Ylc(xe)),Ni=xe.set(i.$NM.ExtHostTimeline,new se.$1lc(xe,bt)),Ci=xe.set(i.$NM.ExtHostWebviews,new It.$ukc(xe,$t.remote,gt,mt,Lt)),Pi=xe.set(i.$NM.ExtHostWebviewPanels,new Ft.$xkc(xe,Ci,gt)),Ki=xe.set(i.$NM.ExtHostCustomEditors,new y.$ykc(xe,Rt,Kt,Ci,Pi)),Ji=xe.set(i.$NM.ExtHostWebviewViews,new qt.$5lc(xe,Ci)),vi=xe.set(i.$NM.ExtHostTesting,new Ge.$Ulc(xe,mt,bt,Dt)),Qi=xe.set(i.$NM.ExtHostUriOpeners,new it.$3lc(xe)),un=xe.set(i.$NM.ExtHostProfileContentHandlers,new Re.$Flc(xe));xe.set(i.$NM.ExtHostInteractive,new _.$tlc(xe,je,Dt,bt,mt));const ln=xe.set(i.$NM.ExtHostInlineChat,new Ce.$glc(xe,bt,Rt,mt)),ki=xe.set(i.$NM.ExtHostChatAgents2,new l.$bkc(xe,mt,bt)),Oi=xe.set(i.$NM.ExtHostChatVariables,new c.$ckc(xe)),Yi=xe.set(i.$NM.ExtHostAiRelatedInformation,new r.$Zjc(xe)),hn=xe.set(i.$NM.ExtHostAiEmbeddingVector,new X.$dlc(xe)),Ti=xe.set(i.$NM.ExtHostStatusBar,new Xe.$Olc(xe,bt.converter)),dn=xe.set(i.$NM.ExtHostSpeech,new Ve.$Mlc(xe)),ji=Object.values(i.$NM);xe.assertRegistered(ji);const Xi=new d.$akc(xe,Dt),Zi=new h.$dkc(xe),Ii=new re.$wlc(xe,mt),xi=new j.$alc(xe);return s.$0jc.register(bt),function(He,di,fi){function at(ge){return(ve,Ue,ct)=>{const yt=ge(Mt=>{try{ve.call(Ue,Mt)}catch(Ui){N.$2(new Error(`[ExtensionListenerError] Extension '${He.identifier.value}' FAILED to handle event: ${Ui.toString()}`,{cause:Ui})),Bt.onExtensionError(He.identifier,Ui)}});return ct?.push(yt),yt}}const vt=function(){let ge=!He.isUnderDevelopment;function ve(){ge||(mt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ve();else{const yt=ct;typeof yt.scheme>"u"&&ve(),typeof yt.exclusive=="boolean"&&(0,et.$vG)(He,"documentFiltersExclusive")}return ct}}(),ci={getSession(ge,ve,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$vG)(He,"authLearnMore"),At.getSession(He,ge,ve,Ue)},getSessions(ge,ve){return(0,et.$vG)(He,"authGetSessions"),At.getSessions(He,ge,ve)},async hasSession(ge,ve){return(0,et.$vG)(He,"authSession"),!!await At.getSession(He,ge,ve,{silent:!0})},get onDidChangeSessions(){return at(At.onDidChangeSessions)},registerAuthenticationProvider(ge,ve,Ue,ct){return At.registerAuthenticationProvider(ge,ve,Ue,ct)}},Ai={registerCommand(ge,ve,Ue){return bt.registerCommand(!0,ge,ve,Ue,void 0,He)},registerTextEditorCommand(ge,ve,Ue){return bt.registerCommand(!0,ge,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return yt.edit(Mt=>{ve.apply(Ue,[yt,Mt,...ct])}).then(Mt=>{Mt||mt.warn("Edits from command "+ge+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+ge,Mt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,ve,Ue)=>((0,et.$vG)(He,"diffCommand"),bt.registerCommand(!0,ge,async(...ct)=>{const yt=Dt.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Mt=await Qe.getDiffInformation(yt.id);ve.apply(Ue,[Mt,...ct])},void 0,void 0,He)),executeCommand(ge,...ve){return bt.executeCommand(ge,...ve)},getCommands(ge=!1){return bt.getCommands(ge)}},Fi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$vG)(He,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$vG)(He,"telemetry"),at(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$qP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ve){return rt.$pP.validateSender(ge),Bt.instantiateLogger(He,ge,ve)},openExternal(ge,ve){return Ht.openUri(ge,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===$t.environment.appUriScheme)return ni.createAppUri(ge);try{return await Ht.asExternalUri(ge,{allowTunneling:!!$t.remote.authority})}catch(ve){if((0,M.$wg)(ge,M.Schemas.http)||(0,M.$wg)(ge,M.Schemas.https))return ge;throw ve}},get remoteName(){return(0,m.$zm)($t.remote.authority)},get remoteAuthority(){return(0,et.$vG)(He,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$vG)(He,"resolvers"),$t.quality},get appCommit(){return(0,et.$vG)(He,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Fi);const _i={createTestController(ge,ve,Ue){return vi.createTestController(He,ge,ve,Ue)},createTestObserver(){return(0,et.$vG)(He,"testObserver"),vi.createTestObserver()},runTests(ge){return(0,et.$vG)(He,"testObserver"),vi.runTests(ge)},get onDidChangeTestResults(){return(0,et.$vG)(He,"testObserver"),at(vi.onResultsChanged)},get testResults(){return(0,et.$vG)(He,"testObserver"),vi.results}},Ei=$t.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,en={getExtension(ge,ve){(0,et.$uG)(He,"extensionsAny")||(ve=!1);const Ue=di.mine.getExtensionDescription(ge);if(Ue)return new x.$2kc(zt,He.identifier,Ue,Ei,!1);if(ve){const ct=di.all.getExtensionDescription(ge);if(ct)return new x.$2kc(zt,He.identifier,ct,Ei,!0)}},get all(){const ge=[];for(const ve of di.mine.getAllExtensionDescriptions())ge.push(new x.$2kc(zt,He.identifier,ve,Ei,!1));return ge},get allAcrossExtensionHosts(){(0,et.$vG)(He,"extensionsAny");const ge=new E.$Jm(di.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of di.all.getAllExtensionDescriptions()){const ct=!ge.has(Ue.identifier);ve.push(new x.$2kc(zt,He.identifier,Ue,Ei,ct))}return ve},get onDidChange(){return(0,et.$uG)(He,"extensionsAny")?at(L.Event.any(di.mine.onDidChange,di.all.onDidChange)):at(di.mine.onDidChange)}},fn={createDiagnosticCollection(ge){return jt.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:ge=>jt.getDiagnostics(ge),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(ge,ve){return Xt.changeLanguage(ge.uri,ve)},match(ge,ve){const Ue=Ke.LanguageSelector.from(ge);let ct;return(0,A.$St)(Ue)&&(ct=je.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Mt=>Mt.document===ve))?.apiNotebook),(0,A.$Rt)(Ue,ve.uri,ve.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(ge,ve,Ue){return ut.registerCodeActionProvider(He,vt(ge),ve,Ue)},registerDocumentPasteEditProvider(ge,ve,Ue){return(0,et.$vG)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,vt(ge),ve,Ue)},registerCodeLensProvider(ge,ve){return ut.registerCodeLensProvider(He,vt(ge),ve)},registerDefinitionProvider(ge,ve){return ut.registerDefinitionProvider(He,vt(ge),ve)},registerDeclarationProvider(ge,ve){return ut.registerDeclarationProvider(He,vt(ge),ve)},registerImplementationProvider(ge,ve){return ut.registerImplementationProvider(He,vt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return ut.registerTypeDefinitionProvider(He,vt(ge),ve)},registerHoverProvider(ge,ve){return ut.registerHoverProvider(He,vt(ge),ve,He.identifier)},registerEvaluatableExpressionProvider(ge,ve){return ut.registerEvaluatableExpressionProvider(He,vt(ge),ve,He.identifier)},registerInlineValuesProvider(ge,ve){return ut.registerInlineValuesProvider(He,vt(ge),ve,He.identifier)},registerDocumentHighlightProvider(ge,ve){return ut.registerDocumentHighlightProvider(He,vt(ge),ve)},registerMultiDocumentHighlightProvider(ge,ve){return ut.registerMultiDocumentHighlightProvider(He,vt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return ut.registerLinkedEditingRangeProvider(He,vt(ge),ve)},registerReferenceProvider(ge,ve){return ut.registerReferenceProvider(He,vt(ge),ve)},registerRenameProvider(ge,ve){return ut.registerRenameProvider(He,vt(ge),ve)},registerNewSymbolNamesProvider(ge,ve){return(0,et.$vG)(He,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(He,vt(ge),ve)},registerDocumentSymbolProvider(ge,ve,Ue){return ut.registerDocumentSymbolProvider(He,vt(ge),ve,Ue)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,ve){return ut.registerDocumentFormattingEditProvider(He,vt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return ut.registerDocumentRangeFormattingEditProvider(He,vt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(He,vt(ge),ve,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(ge,ve,Ue){return ut.registerDocumentSemanticTokensProvider(He,vt(ge),ve,Ue)},registerDocumentRangeSemanticTokensProvider(ge,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(He,vt(ge),ve,Ue)},registerSignatureHelpProvider(ge,ve,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(He,vt(ge),ve,Ue):ut.registerSignatureHelpProvider(He,vt(ge),ve,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(ge,ve,...Ue){return ut.registerCompletionItemProvider(He,vt(ge),ve,Ue)},registerInlineCompletionItemProvider(ge,ve,Ue){return ve.handleDidShowCompletionItem&&(0,et.$vG)(He,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,et.$vG)(He,"inlineCompletionsAdditions"),Ue&&(0,et.$vG)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,vt(ge),ve,Ue)},registerInlineEditProvider(ge,ve){return(0,et.$vG)(He,"inlineEdit"),ut.registerInlineEditProvider(He,vt(ge),ve)},registerDocumentLinkProvider(ge,ve){return ut.registerDocumentLinkProvider(He,vt(ge),ve)},registerColorProvider(ge,ve){return ut.registerColorProvider(He,vt(ge),ve)},registerFoldingRangeProvider(ge,ve){return ut.registerFoldingRangeProvider(He,vt(ge),ve)},registerSelectionRangeProvider(ge,ve){return ut.registerSelectionRangeProvider(He,ge,ve)},registerCallHierarchyProvider(ge,ve){return ut.registerCallHierarchyProvider(He,ge,ve)},registerTypeHierarchyProvider(ge,ve){return ut.registerTypeHierarchyProvider(He,ge,ve)},setLanguageConfiguration:(ge,ve)=>ut.setLanguageConfiguration(He,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,et.$vG)(He,"tokenInformation"),Xt.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return ut.registerInlayHintsProvider(He,ge,ve)},createLanguageStatusItem(ge,ve){return Xt.createLanguageStatusItem(He,ge,ve)},registerDocumentDropEditProvider(ge,ve,Ue){return ut.registerDocumentOnDropEditProvider(He,ge,ve,(0,et.$uG)(He,"documentPaste")?Ue:void 0)}},tn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(ge,ve,Ue){p.URI.isUri(ge)&&ge.scheme===M.Schemas.vscodeRemote&&!ge.authority&&Lt.report("workspace.showTextDocument",He,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(p.URI.isUri(ge)?Promise.resolve(zi.openTextDocument(ge)):Promise.resolve(ge));return Qe.showTextDocument(ct,ve,Ue)},createTextEditorDecorationType(ge){return Qe.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,ve,Ue){return at(Qe.onDidChangeActiveTextEditor)(ge,ve,Ue)},onDidChangeVisibleTextEditors(ge,ve,Ue){return at(Qe.onDidChangeVisibleTextEditors)(ge,ve,Ue)},onDidChangeTextEditorSelection(ge,ve,Ue){return at(Qe.onDidChangeTextEditorSelection)(ge,ve,Ue)},onDidChangeTextEditorOptions(ge,ve,Ue){return at(Qe.onDidChangeTextEditorOptions)(ge,ve,Ue)},onDidChangeTextEditorVisibleRanges(ge,ve,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(ge,ve,Ue)},onDidChangeTextEditorViewColumn(ge,ve,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(ge,ve,Ue)},onDidCloseTerminal(ge,ve,Ue){return at(Ct.onDidCloseTerminal)(ge,ve,Ue)},onDidOpenTerminal(ge,ve,Ue){return at(Ct.onDidOpenTerminal)(ge,ve,Ue)},onDidChangeActiveTerminal(ge,ve,Ue){return at(Ct.onDidChangeActiveTerminal)(ge,ve,Ue)},onDidChangeTerminalDimensions(ge,ve,Ue){return(0,et.$vG)(He,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(ge,ve,Ue)},onDidChangeTerminalState(ge,ve,Ue){return at(Ct.onDidChangeTerminalState)(ge,ve,Ue)},onDidWriteTerminalData(ge,ve,Ue){return(0,et.$vG)(He,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(ge,ve,Ue)},onDidExecuteTerminalCommand(ge,ve,Ue){return(0,et.$vG)(He,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(ge,ve,Ue)},onDidChangeTerminalShellIntegration(ge,ve,Ue){return(0,et.$vG)(He,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(ge,ve,Ue)},onDidStartTerminalShellExecution(ge,ve,Ue){return(0,et.$vG)(He,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(ge,ve,Ue)},onDidEndTerminalShellExecution(ge,ve,Ue){return(0,et.$vG)(He,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(ge,ve,Ue)},get state(){return Ht.getState(He)},onDidChangeWindowState(ge,ve,Ue){return at(Ht.onDidChangeWindowState)(ge,ve,Ue)},showInformationMessage(ge,...ve){return Ii.showMessage(He,b.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return Ii.showMessage(He,b.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return Ii.showMessage(He,b.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,Ue){return bi.showQuickPick(He,ge,ve,Ue)},showWorkspaceFolderPick(ge){return bi.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return bi.showInput(ge,ve)},showOpenDialog(ge){return xi.showOpenDialog(He,ge)},showSaveDialog(ge){return xi.showSaveDialog(ge)},createStatusBarItem(ge,ve,Ue){let ct,yt,Mt;return typeof ge=="string"?(ct=ge,yt=ve,Mt=Ue):(yt=ge,Mt=ve),Ti.createStatusBarEntry(He,ct,yt,Mt)},setStatusBarMessage(ge,ve){return Ti.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Lt.report("window.withScmProgress",He,"Use 'withProgress' instead."),qi.withProgress(He,{location:Me.ProgressLocation.SourceControl},(ve,Ue)=>ge({report(ct){}}))},withProgress(ge,ve){return qi.withProgress(He,ge,ve)},createOutputChannel(ge,ve){return ai.createOutputChannel(ge,ve,He)},createWebviewPanel(ge,ve,Ue,ct){return Pi.createWebviewPanel(He,ge,ve,Ue,ct)},createWebviewTextEditorInset(ge,ve,Ue,ct){return(0,et.$vG)(He,"editorInsets"),Et.createWebviewEditorInset(ge,ve,Ue,ct,He)},createTerminal(ge,ve,Ue){return typeof ge=="object"?"pty"in ge?Ct.createExtensionTerminal(ge):Ct.createTerminalFromOptions(ge):Ct.createTerminal(ge,ve,Ue)},registerTerminalLinkProvider(ge){return Ct.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Ct.registerProfileProvider(He,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,et.$vG)(He,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(ge,He.identifier.value,ve)},registerTreeDataProvider(ge,ve){return ht.registerTreeDataProvider(ge,ve,He)},createTreeView(ge,ve){return ht.createTreeView(ge,ve,He)},registerWebviewPanelSerializer:(ge,ve)=>Pi.registerWebviewPanelSerializer(He,ge,ve),registerCustomEditorProvider:(ge,ve,Ue={})=>Ki.registerCustomEditorProvider(He,ge,ve,Ue),registerFileDecorationProvider(ge){return Pt.registerFileDecorationProvider(ge,He)},registerUriHandler(ge){return ni.registerUriHandler(He,ge)},createQuickPick(){return bi.createQuickPick(He)},createInputBox(){return bi.createInputBox(He)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,Ue){return at(Di.onDidChangeActiveColorTheme)(ge,ve,Ue)},registerWebviewViewProvider(ge,ve,Ue){return Ji.registerWebviewViewProvider(He,ge,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return je.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,Ue){return at(je.onDidChangeActiveNotebookEditor)(ge,ve,Ue)},get visibleNotebookEditors(){return je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ve,Ue){return at(ee.onDidChangeNotebookEditorSelection)(ge,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(ge,ve,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(ge,ve,Ue)},showNotebookDocument(ge,ve){return je.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,Ue){return(0,et.$vG)(He,"externalUriOpener"),Qi.registerExternalUriOpener(He.identifier,ge,ve,Ue)},registerProfileContentHandler(ge,ve){return(0,et.$vG)(He,"profileContentHandlers"),un.registerProfileContentHandler(He,ge,ve)},registerQuickDiffProvider(ge,ve,Ue,ct){return(0,et.$vG)(He,"quickDiffProvider"),Mi.registerQuickDiffProvider(vt(ge),ve,Ue,ct)},get tabGroups(){return Qt.tabGroups},registerShareProvider(ge,ve){return(0,et.$vG)(He,"shareProvider"),Li.registerShareProvider(vt(ge),ve)}},zi={get rootPath(){return Lt.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(ge){throw new N.$9("rootPath")},getWorkspaceFolder(ge){return gt.getWorkspaceFolder(ge)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(ge){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(ge){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(ge,ve,...Ue)=>gt.updateWorkspaceFolders(He,ge,ve||0,...Ue),onDidChangeWorkspaceFolders:function(ge,ve,Ue){return at(gt.onDidChangeWorkspace)(ge,ve,Ue)},asRelativePath:(ge,ve)=>gt.getRelativePath(ge,ve),findFiles:(ge,ve,Ue,ct)=>gt.findFiles(ge,ve,Ue,He.identifier,ct),findFiles2:(ge,ve,Ue)=>((0,et.$vG)(He,"findFiles2"),gt.findFiles2(ge,ve,He.identifier,Ue)),findTextInFiles:(ge,ve,Ue,ct)=>{(0,et.$vG)(He,"findTextInFiles");let yt,Mt;return typeof ve=="object"?(yt=ve,Mt=Ue):(yt={},Mt=ve,ct=Ue),gt.findTextInFiles(ge,yt||{},Mt,He.identifier,ct)},save:ge=>gt.save(ge),saveAs:ge=>gt.saveAs(ge),saveAll:ge=>gt.saveAll(ge),applyEdit(ge,ve){return Xi.applyWorkspaceEdit(ge,He,ve)},createFileSystemWatcher:(ge,ve,Ue,ct)=>{let yt;return typeof ve=="boolean"?yt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ve&&((0,et.$vG)(He,"createFileSystemWatcher"),yt={...ve,correlate:!0}),mi.createFileSystemWatcher(gt,He,ge,yt)},get textDocuments(){return Rt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new N.$9("textDocuments")},openTextDocument(ge){let ve;const Ue=ge;if(typeof ge=="string")ve=Promise.resolve(p.URI.file(ge));else if(p.URI.isUri(ge))ve=Promise.resolve(ge);else if(!Ue||typeof Ue=="object")ve=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Lt.report("workspace.openTextDocument",He,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(ge,ve,Ue)=>at(Rt.onDidAddDocument)(ge,ve,Ue),onDidCloseTextDocument:(ge,ve,Ue)=>at(Rt.onDidRemoveDocument)(ge,ve,Ue),onDidChangeTextDocument:(ge,ve,Ue)=>at(Rt.onDidChangeDocument)(ge,ve,Ue),onDidSaveTextDocument:(ge,ve,Ue)=>at(Rt.onDidSaveDocument)(ge,ve,Ue),onWillSaveTextDocument:(ge,ve,Ue)=>at(Ne.getOnWillSaveTextDocumentEvent(He))(ge,ve,Ue),get notebookDocuments(){return je.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let Ue;if(p.URI.isUri(ge))Ue=ge,await je.openNotebookDocument(ge);else if(typeof ge=="string")Ue=p.URI.revive(await je.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return je.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ge,ve,Ue){return at(ye.onDidSaveNotebookDocument)(ge,ve,Ue)},onDidChangeNotebookDocument(ge,ve,Ue){return at(ye.onDidChangeNotebookDocument)(ge,ve,Ue)},onWillSaveNotebookDocument(ge,ve,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(He))(ge,ve,Ue)},get onDidOpenNotebookDocument(){return at(je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(je.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ve,Ue,ct){return je.registerNotebookSerializer(He,ge,ve,Ue,(0,et.$uG)(He,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(ge,ve,Ue)=>at(fi.onDidChangeConfiguration)(ge,ve,Ue),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,fi.getConfiguration(ge,ve,He)},registerTextDocumentContentProvider(ge,ve){return yi.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Lt.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(He,ge,ve)),registerFileSystemProvider(ge,ve,Ue){return(0,R.$Rc)(Zt.registerFileSystemProvider(He,ge,ve,Ue),ti.addFileSystemProvider(ge,ve,Ue))},get fs(){return ti.value},registerFileSearchProvider:(ge,ve)=>((0,et.$vG)(He,"fileSearchProvider"),hi.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,et.$vG)(He,"textSearchProvider"),hi.registerTextSearchProvider(ge,ve)),registerAITextSearchProvider:(ge,ve)=>((0,et.$vG)(He,"aiTextSearchProvider"),(0,et.$vG)(He,"textSearchProvider"),hi.registerAITextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,et.$vG)(He,"resolvers"),zt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,et.$vG)(He,"resolvers"),Gi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,et.$vG)(He,"resolvers"),zt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ve,Ue)=>at(mi.onDidCreateFile)(ge,ve,Ue),onDidDeleteFiles:(ge,ve,Ue)=>at(mi.onDidDeleteFile)(ge,ve,Ue),onDidRenameFiles:(ge,ve,Ue)=>at(mi.onDidRenameFile)(ge,ve,Ue),onWillCreateFiles:(ge,ve,Ue)=>at(mi.getOnWillCreateFileEvent(He))(ge,ve,Ue),onWillDeleteFiles:(ge,ve,Ue)=>at(mi.getOnWillDeleteFileEvent(He))(ge,ve,Ue),onWillRenameFiles:(ge,ve,Ue)=>at(mi.getOnWillRenameFileEvent(He))(ge,ve,Ue),openTunnel:ge=>((0,et.$vG)(He,"tunnels"),Tt.openTunnel(He,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,et.$vG)(He,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(ge,ve,Ue)=>((0,et.$vG)(He,"tunnels"),at(Tt.onDidChangeTunnels)(ge,ve,Ue)),registerPortAttributesProvider:(ge,ve)=>((0,et.$vG)(He,"portsAttributes"),Tt.registerPortsAttributesProvider(ge,ve)),registerTunnelProvider:(ge,ve)=>((0,et.$vG)(He,"tunnelFactory"),Tt.registerTunnelProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,et.$vG)(He,"timeline"),Ni.registerTimelineProvider(ge,ve,He.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:ge=>((0,et.$vG)(He,"workspaceTrust"),gt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,Ue)=>at(gt.onDidGrantWorkspaceTrust)(ge,ve,Ue),registerEditSessionIdentityProvider:(ge,ve)=>((0,et.$vG)(He,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(ge,ve)),onWillCreateEditSessionIdentity:(ge,ve,Ue)=>((0,et.$vG)(He,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(He))(ge,ve,Ue)),registerCanonicalUriProvider:(ge,ve)=>((0,et.$vG)(He,"canonicalUriProvider"),gt.registerCanonicalUriProvider(ge,ve)),getCanonicalUri:(ge,ve,Ue)=>((0,et.$vG)(He,"canonicalUriProvider"),gt.provideCanonicalUri(ge,ve,Ue))},gn={get inputBox(){return Lt.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(He)},createSourceControl(ge,ve,Ue){return Si.createSourceControl(He,ge,ve,Ue)}},mn={createCommentController(ge,ve){return Vi.createCommentController(He,ge,ve)}},nn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,et.$uG)(He,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(ge,ve){return(0,et.$vG)(He,"debugVisualization"),kt.registerDebugVisualizationProvider(He,ge,ve)},registerDebugVisualizationTreeProvider(ge,ve){return(0,et.$vG)(He,"debugVisualization"),kt.registerDebugVisualizationTree(He,ge,ve)},onDidStartDebugSession(ge,ve,Ue){return at(kt.onDidStartDebugSession)(ge,ve,Ue)},onDidTerminateDebugSession(ge,ve,Ue){return at(kt.onDidTerminateDebugSession)(ge,ve,Ue)},onDidChangeActiveDebugSession(ge,ve,Ue){return at(kt.onDidChangeActiveDebugSession)(ge,ve,Ue)},onDidReceiveDebugSessionCustomEvent(ge,ve,Ue){return at(kt.onDidReceiveDebugSessionCustomEvent)(ge,ve,Ue)},onDidChangeBreakpoints(ge,ve,Ue){return at(kt.onDidChangeBreakpoints)(ge,ve,Ue)},onDidChangeActiveStackItem(ge,ve,Ue){return(0,et.$vG)(He,"debugFocus"),at(kt.onDidChangeActiveStackItem)(ge,ve,Ue)},registerDebugConfigurationProvider(ge,ve,Ue){return kt.registerDebugConfigurationProvider(ge,ve,Ue||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return kt.registerDebugAdapterDescriptorFactory(He,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return kt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?kt.startDebugging(ge,ve,{parentSession:Ue}):kt.startDebugging(ge,ve,Ue||{})},stopDebugging(ge){return kt.stopDebugging(ge)},addBreakpoints(ge){return kt.addBreakpoints(ge)},removeBreakpoints(ge){return kt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return kt.asDebugSourceUri(ge,ve)}},Bi={registerTaskProvider:(ge,ve)=>Yt.registerTaskProvider(He,ge,ve),fetchTasks:ge=>Yt.fetchTasks(ge),executeTask:ge=>Yt.executeTask(He,ge),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(ge,ve,Ue)=>at(Yt.onDidStartTask)(ge,ve,Ue),onDidEndTask:(ge,ve,Ue)=>at(Yt.onDidEndTask)(ge,ve,Ue),onDidStartTaskProcess:(ge,ve,Ue)=>at(Yt.onDidStartTaskProcess)(ge,ve,Ue),onDidEndTaskProcess:(ge,ve,Ue)=>at(Yt.onDidEndTaskProcess)(ge,ve,Ue)},rn={createNotebookController(ge,ve,Ue,ct,yt){return Oe.createNotebookController(He,ge,ve,Ue,ct,(0,et.$uG)(He,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>je.registerNotebookCellStatusBarItemProvider(He,ge,ve),createRendererMessaging(ge){return qe.createRendererMessaging(He,ge)},createNotebookControllerDetectionTask(ge){return(0,et.$vG)(He,"notebookKernelSource"),Oe.createNotebookControllerDetectionTask(He,ge)},registerKernelSourceActionProvider(ge,ve){return(0,et.$vG)(He,"notebookKernelSource"),Oe.registerKernelSourceActionProvider(He,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,Ue){return(0,et.$vG)(He,"notebookCellExecutionState"),at(Oe.onDidChangeNotebookCellExecutionState)(ge,ve,Ue)}},sn={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),Ue=!ge||typeof ge[0]!="object"?ge:ge[0];return pi.getMessage(He.identifier.value,{message:ve,args:Ue})}return pi.getMessage(He.identifier.value,ge[0])},get bundle(){return pi.getBundle(He.identifier.value)},get uri(){return pi.getBundleUri(He.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(ge,ve){return(0,et.$vG)(He,"interactive"),ln.registerProvider(He,ge,ve)},registerInteractiveSessionProvider(ge,ve){return(0,et.$vG)(He,"interactive"),R.$Uc.None},transferActiveChat(ge){return(0,et.$vG)(He,"interactive"),ki.transferActiveChat(ge)}},$n={getRelatedInformation(ge,ve){return(0,et.$vG)(He,"aiRelatedInformation"),Yi.getRelatedInformation(He,ge,ve)},registerRelatedInformationProvider(ge,ve){return(0,et.$vG)(He,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(He,ge,ve)},registerEmbeddingVectorProvider(ge,ve){return(0,et.$vG)(He,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider(He,ge,ve)}},pn={registerChatResponseProvider(ge,ve,Ue){return(0,et.$vG)(He,"chatProvider"),Nt.registerLanguageModel(He,ge,ve,Ue)},registerChatVariableResolver(ge,ve,Ue){return(0,et.$vG)(He,"chatVariableResolver"),Oi.registerVariableResolver(He,ge,ve,Ue)},registerMappedEditsProvider(ge,ve){return(0,et.$vG)(He,"mappedEditsProvider"),ut.registerMappedEditsProvider(He,ge,ve)},createChatParticipant(ge,ve){return(0,et.$vG)(He,"chatParticipant"),ki.createChatAgent(He,ge,ve)},createDynamicChatParticipant(ge,ve,Ue,ct){return(0,et.$vG)(He,"chatParticipantAdditions"),ki.createDynamicChatAgent(He,ge,ve,Ue,ct)}},an={get languageModels(){return(0,et.$vG)(He,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ve,Ue)=>((0,et.$vG)(He,"languageModels"),Nt.onDidChangeProviders(ge,ve,Ue)),sendChatRequest(ge,ve,Ue,ct){return(0,et.$vG)(He,"languageModels"),Nt.sendChatRequest(He,ge,ve,Ue,ct)}},cn={registerSpeechProvider(ge,ve){return(0,et.$vG)(He,"speech"),dn.registerProvider(He.identifier,ge,ve)}};return{version:$t.version,ai:$n,authentication:ci,commands:Ai,comments:mn,chat:pn,debug:nn,env:Fi,extensions:en,interactive:on,l10n:sn,languages:fn,lm:an,notebooks:rn,scm:gn,speech:cn,tasks:Bi,tests:_i,window:tn,workspace:zi,Breakpoint:Me.$ON,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$JO,CallHierarchyIncomingCall:Me.$aN,CallHierarchyItem:Me.$_M,CallHierarchyOutgoingCall:Me.$bN,CancellationError:N.$5,CancellationTokenSource:u.$je,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$9M,CodeActionKind:Me.$0M,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$cN,Color:Me.$pN,ColorInformation:Me.$qN,ColorPresentation:Me.$rN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$jN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$kN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$zN,DebugAdapterExecutable:Me.$SN,DebugAdapterInlineImplementation:Me.$VN,DebugAdapterNamedPipeServer:Me.$UN,DebugAdapterServer:Me.$TN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$_N,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$3M,DiagnosticRelatedInformation:Me.$2M,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$OM,DocumentHighlight:Me.$5M,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$6M,DocumentLink:Me.$oN,DocumentSymbol:Me.$8M,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$YN,InlineValueText:Me.$ZN,InlineValueVariableLookup:Me.$1N,InlineValueEvaluatableExpression:Me.$2N,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$_d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$bO,FileDecoration2:Me.$bO,FileSystemError:Me.$5N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$6N,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$QN,InlineCompletionItem:Me.$lN,InlineCompletionList:Me.$mN,Hover:Me.$4M,IndentAction:P.IndentAction,Location:Me.$1M,MarkdownString:Me.$dN,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Me.$eN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$PM,ProcessExecution:Me.$xN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$aO,Range:Me.$QM,RelativePattern:Me.$MN,Selection:Me.$RM,SelectionRange:Me.$$M,SemanticTokens:Me.$9N,SemanticTokensBuilder:Me.$8N,SemanticTokensEdit:Me.$0N,SemanticTokensEdits:Me.$$N,SemanticTokensLegend:Me.$7N,ShellExecution:Me.$yN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$gN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$fN,SnippetString:Me.$ZM,SourceBreakpoint:Me.$PN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$7M,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$AN,TaskGroup:Me.$wN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$sN,TerminalQuickFixTerminalCommand:Me.$uN,TerminalQuickFixOpener:Me.$tN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$vN,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$VM,SnippetTextEdit:Me.$XM,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$LN,ThemeIcon:Me.$KN,TreeItem:Me.$BN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$xO,UIKind:Gt.UIKind,Uri:p.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$YM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$HN,DocumentDropOrPasteEditKind:Me.$IN,DocumentPasteEdit:Me.$JN,InlayHint:Me.$iN,InlayHintLabelPart:Me.$hN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$UM,ResolvedAuthority:Me.$SM,ManagedResolvedAuthority:Me.$TM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$lO,NotebookRange:Me.$dO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$eO,NotebookData:Me.$fO,NotebookRendererScript:Me.$jO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$hO,NotebookCellOutputItem:Me.$gO,NotebookCellStatusBarItem:Me.$iO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$WM,NotebookKernelSourceAction:Me.$kO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$nO,LinkedEditingRanges:Me.$mO,TestResultState:Me.TestResultState,TestRunRequest:Me.$oO,TestMessage:Me.$pO,TestTag:Me.$qO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:Me.$GN,DataTransferItem:Me.$CN,TestCoverageCount:Me.$rO,FileCoverage:Me.$tO,StatementCoverage:Me.$uO,BranchCoverage:Me.$vO,DeclarationCoverage:Me.$wO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$yO,TabInputTextDiff:Me.$zO,TabInputTextMerge:Me.$AO,TabInputCustom:Me.$BO,TabInputNotebook:Me.$DO,TabInputNotebookDiff:Me.$EO,TabInputWebview:Me.$CO,TabInputTerminal:Me.$FO,TabInputInteractiveWindow:Me.$GO,TabInputChat:Me.$HO,TabInputTextMultiDiff:Me.$IO,TelemetryTrustedValue:o.$9o,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$WN,Thread:Me.$XN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$KO,ChatResponseFileTreePart:Me.$LO,ChatResponseAnchorPart:Me.$MO,ChatResponseProgressPart:Me.$NO,ChatResponseReferencePart:Me.$PO,ChatResponseTextEditPart:Me.$QO,ChatResponseCommandButtonPart:Me.$OO,ChatRequestTurn:Me.$RO,ChatResponseTurn:Me.$SO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$TO,LanguageModelChatUserMessage:Me.$UO,LanguageModelChatAssistantMessage:Me.$VO,LanguageModelSystemMessage:Me.$TO,LanguageModelUserMessage:Me.$UO,LanguageModelAssistantMessage:Me.$VO,LanguageModelError:Me.$WO,NewSymbolName:Me.$4N,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$XO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[381],Ee([1,0,84,157,43,151,44,33,72,42,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$ls)(l.$Vkc,l.$Ukc,1),(0,u.$ls)(f.$Uj,t.$9lc,1),(0,u.$ls)(a.$1jc,a.$2jc,1),(0,u.$ls)(b.$tP,b.$sP,0),(0,u.$ls)(h.$$jc,h.$_jc,0),(0,u.$ls)(g.$Pkc,g.$Qkc,0),(0,u.$ls)(M.$nkc,M.$lkc,0),(0,u.$ls)(o.$pkc,o.$okc,0),(0,u.$ls)(P.$6kc,P.$0kc,0),(0,u.$ls)(R.$_kc,R.$$kc,0),(0,u.$ls)(p.$iP,p.$hP,0),(0,u.$ls)(c.$Wkc,c.$Xkc,0),(0,u.$ls)(n.$5jc,n.$4jc,0),(0,u.$ls)(N.$Elc,N.$Dlc,1),(0,u.$ls)($.$plc,$.$qlc,0),(0,u.$ls)(E.$Ikc,E.$Hkc,0),(0,u.$ls)(A.$Rlc,A.$Qlc,0),(0,u.$ls)(S.$Lkc,S.$Okc,0),(0,u.$ls)(D.$Slc,D.$Tlc,0),(0,u.$ls)(v.$lCb,v.$mCb,0),(0,u.$ls)(m.$7lc,m.$6lc,0),(0,u.$ls)(L.$kkc,L.$jkc,0),(0,u.$ls)(i.$Skc,i.$Rkc,0),(0,u.$ls)(r.$rP,r.$oP,0),(0,u.$ls)(s.$zkc,s.$Akc,0),(0,u.$ls)(d.$4kc,d.$5kc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0,e.$mmc=M,e.$nmc=b;function M(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function b(P,$,E,v){const a=(0,u.$2b)(E,p),m=new L.$6K($,a,v),o=m.preview.matches;return{ranges:(0,u.$2b)(a,S),uri:P,preview:{text:m.preview.text,matches:(0,u.$2b)(o,S)}}}function p(P){return new L.$7K(P.start.line,P.start.character,P.end.line,P.end.character)}function S(P){return new R.$UK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor($,E){this.a=$,this.b=E}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$omc=A,e.$omc=A=Je([We(1,N.$Tj)],A)}),define(ke[382],Ee([1,0,53,17,76,34,11,14,122,383]),function(he,e,u,N,L,R,M,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=P,e.$qmc=m,e.$rmc=n;const A=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,r,s,t){const f=$(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function $(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const c=(0,p.$mmc)(l);if(f.push("-g",c),M.$j){const h=(0,L.$6l)(c);h!==c&&f.push("-g",h)}});const d=E([r],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,p.$mmc)(l)}`;if(f.push("-g",c),M.$j){const h=(0,L.$6l)(c);h!==c&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function E(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const c=Object.assign({},l.excludePattern||{},r||{}),h=a(c,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=a(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function a(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return N.$jc(r)?r:N.$kc(i,r)}function o(i){return i=b.$$e(i,"\\"),b.$$e(i,"/")}function n(i){return R.$jg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[384],Ee([1,0,53,52,17,385,19,47,35,76,34,11,39,14,18,31,36,382,132]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&p.$hk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$mr)(this.b).normalizedLowercase),this.u=l.excludePattern&&p.$hk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),g=c.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,A.$ng)(D,g)&&(h[L.$mc(g,D)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,c,h,g,D){if(this.m=$.$8d.create(!1),this.l)return D(null,this.j);c.forEach(w=>{const k=L.$oc(w.fsPath);this.u&&this.u(w.fsPath,k)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=$.$8d.create(!1),this.w(l,(w,k)=>{this.x(this.y,this,w,h,g,y=>{if(y){const C=(0,b.$$i)(y);console.error(C),this.q.push(C),k(y,void 0)}else k(null,void 0)})},(w,k)=>{this.m.stop();const y=w?M.$Hb(w)[0]:null;D(y,this.j)})}w(l,c,h){const g=new Array(l.length),D=new Array(l.length);let w=!1,k=0;if(l.length===0)return h(null,[]);l.forEach((y,C)=>{c(y,(I,z)=>{if(I?(w=!0,g[C]=null,D[C]=I):(g[C]=z,D[C]=null),++k===l.length)return h(w?D:null,g)})})}x(l,c,...h){try{l.apply(c,h)}catch(g){h[h.length-1](g)}}y(l,c,h,g){const D=l.folder.fsPath,w=P.$j,k=()=>j&&j.kill();i.add(k);let y=B=>{i.delete(k),y=()=>{},g(B)},C="";const I=this.D(),z=(0,o.$pmc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),j=z.cmd,F=!Object.keys(z.siblingClauses).length,O=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${z.rgDiskPath} ${O}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(j,"utf8",h,(B,H,X)=>{if(B){y(B);return}if(this.j){y();return}const Y=(C+(w?S.$5l(H||""):H)).split(`
`);if(X){const Z=Y.length;Y[Z-1]=Y[Z-1].trim(),Y[Z-1]||Y.pop()}else C=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Y.length,F){for(const Z of Y)if(this.J(c,{base:D,relativePath:Z,searchPath:this.N(l,Z)}),this.j){k();break}(X||this.j)&&y();return}this.G(l,I,D,Y,c),X&&(this.H(I,D,c),y())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),g=c.getPathTerms(),D=["-L","."];if(h.length||g.length){D.push("-not","(","(");for(const w of h)D.push("-name",w),D.push("-o");for(const w of g)D.push("-path",w),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,c,h){let g="";this.z(l,c,()=>{},(D,w,k)=>{if(D){h(D);return}g+=w,k&&h(null,g)})}z(l,c,h,g){let D=(y,C,I)=>{(y||I)&&(D=()=>{},this.r?.stop()),g(y,C,I)},w=!1;l.stdout?(this.A(l.stdout,c,D),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let k;l.stderr?k=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let C;!w&&(C=this.C(k,c))&&f(C)?D(new Error(`command failed with error code ${y}: ${this.C(k,c)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,c,h){const g=new R.StringDecoder(c);return l.on("data",D=>{h(null,g.write(D))}),g}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new R.StringDecoder(c);return l.map(g=>h.write(g)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,g,D){g.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=k=>{const y=L.$oc(k),C=L.$nc(k);let I=c[C];I||(I=c[C]=[],w(C)),I.push({base:h,relativePath:k,basename:y,searchPath:this.N(l,k)})};g.forEach(w)}H({rootEntries:l,pathToEntries:c},h,g){const D=this,w=this.t.get(h),k=this.b;function y(C){D.o++;const I=(0,m.$jL)(()=>C.map(z=>z.basename));for(let z=0,j=C.length;z<j;z++){const F=C[z],{relativePath:O,basename:T}=F;if(w.test(O,T,k!==T?I:void 0))continue;const B=c[O];if(B)y(B);else{if(D.p++,O===k)continue;D.J(g,F)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,g,D){const w=l.folder,k=(0,m.$jL)(()=>h);this.w(h,(y,C)=>{if(this.l||this.j)return C(null);const I=c?[c,y].join(L.sep):y;if(this.t.get(l.folder.fsPath).test(I,y,this.a.filePattern!==y?k:void 0))return C(null);const z=[w.fsPath,I].join(L.sep);N.lstat(z,(j,F)=>{if(j||this.l||this.j)return C(null);this.L(z,F,(O,T)=>O||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(z,F,(B,H)=>B||this.l||this.j||(H=H||"",this.v[H])?C(null):(this.v[H]=!0,a.Promises.readdir(z).then(X=>{if(this.l||this.j)return C(null);this.I(l,I,X,g,x=>C(x||null))},X=>{C(null)})))):(this.p++,I===this.b||this.h&&v.$5f(T.size)&&T.size>this.h||this.J(g,{base:w.fsPath,relativePath:I,searchPath:this.N(l,I)}),C(null,void 0)))})},y=>{const C=y&&M.$Hb(y);return D(C&&C.length>0?C[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,L.$oc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$eL)(l,this.c);if(this.b)return(0,m.$eL)(l,this.b,!1)}return!0}L(l,c,h){return c.isSymbolicLink()?N.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?N.realpath(l,(g,D)=>g?h(g):h(null,D)):h(null,l)}N(l,c){return l.folderName?L.$kc(l.folderName,c):c}}e.$smc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(g,D)=>{h(g,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$tmc=s;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(g=>l[g]).forEach(g=>{L.$jc(g)?(c=c||p.$ck(),c[g]=l[g]):(h=h||p.$ck(),h[g]=l[g])}),this.a=c&&p.$hk(c,{trimForExclusions:!0}),this.b=h&&p.$hk(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(L.$kc(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...p.$jk(this.a)),this.b&&l.push(...p.$jk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...p.$kk(this.a)),this.b&&l.push(...p.$kk(this.b)),l}}function f(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return E.$Sf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[386],Ee([1,0,98,21,193,22]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$XD=e.DecodeStreamErrorKind=e.$WD=e.$VD=e.$UD=e.$SD=e.$RD=e.$QD=e.$PD=void 0,e.$TD=M,e.$YD=v,e.$ZD=a,e.$1D=m,e.$2D=o,e.$3D=n,e.$4D=d,e.$5D=l,e.$PD="utf8",e.$QD="utf8bom",e.$RD="utf16be",e.$SD="utf16le";function M(c){return[e.$PD,e.$QD,e.$RD,e.$SD].some(h=>h===c)}e.$UD=[254,255],e.$VD=[255,254],e.$WD=[239,187,191];const b=512,p=512,S=512*8,A=512*128;var P;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class $ extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$XD=$;class E{static async create(h){let g;if(h!==e.$PD)g=(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;g={write(w){return D.decode(w,{stream:!0})},end(){return D.decode()}}}return new E(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(c,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?S:p;return new Promise((D,w)=>{const k=(0,u.$ne)(F=>F.join("")),y=[];let C=0,I;const z=new R.$je,j=async()=>{try{const F=await l({buffer:N.$ze.concat(y),bytesRead:C},h.guessEncoding);if(F.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);F.encoding=await h.overwriteEncoding(F.encoding),I=await E.create(F.encoding);const O=I.write(N.$ze.concat(y).buffer);k.write(O),y.length=0,C=0,D({stream:k,detected:F})}catch(F){z.cancel(),k.destroy(),w(F)}};(0,u.$re)(c,{onData:async F=>{I?k.write(I.write(F.buffer)):(y.push(F),C+=F.byteLength,C>=g&&(c.pause(),await j(),setTimeout(()=>c.resume())))},onError:F=>k.error(F),onEnd:async()=>{I||await j(),k.end(I?.end())}},z.token)})}async function a(c,h,g){const w=(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let k=!1,y=!1;return{read(){if(y)return null;const C=c.read();if(typeof C!="string"){if(y=!0,!k&&g?.addBOM)switch(h){case e.$PD:case e.$QD:return N.$ze.wrap(Uint8Array.from(e.$WD));case e.$RD:return N.$ze.wrap(Uint8Array.from(e.$UD));case e.$SD:return N.$ze.wrap(Uint8Array.from(e.$VD))}const I=w.end();return I&&I.length>0?(k=!0,N.$ze.wrap(I)):null}return k=!0,N.$ze.wrap(w.write(C))}}}async function m(c){return(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}function o(c){return c===e.$QD||c===null?e.$PD:c}function n(c,h){if(!c||h<e.$UD.length)return null;const g=c.readUInt8(0),D=c.readUInt8(1);if(g===e.$UD[0]&&D===e.$UD[1])return e.$RD;if(g===e.$VD[0]&&D===e.$VD[1])return e.$SD;if(h<e.$WD.length)return null;const w=c.readUInt8(2);return g===e.$WD[0]&&D===e.$WD[1]&&w===e.$WD[2]?e.$QD:null}const i=["ascii","utf-16","utf-32"];async function r(c){const h=await(0,L.$OD)("jschardet","dist/jschardet.min.js"),g=c.slice(0,A),D=f(g.buffer),w=h.detect(D);if(!w||!w.encoding)return null;const k=w.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(c){let h="";for(let g=0;g<c.length;g++)h+=String.fromCharCode(c[g]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}function l({buffer:c,bytesRead:h},g){let D=n(c,h),w=!1;if(D!==e.$RD&&D!==e.$SD&&c){let k=!0,y=!0,C=!1;for(let I=0;I<h&&I<b;I++){const z=I%2===1,j=c.readUInt8(I)===0;if(j&&(C=!0),k&&(z&&!j||!z&&j)&&(k=!1),y&&(z&&j||!z&&!j)&&(y=!1),j&&!k&&!y)break}C&&(k?D=e.$SD:y?D=e.$RD:w=!0)}return g&&!w&&!D&&c?r(c.slice(0,h)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:w,encoding:D}}e.$6D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,386,31,159]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;class R extends L.$llc{constructor(b,p,S=N,A="searchProcess"){super({query:b,provider:p},{readdir:P=>S.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,u.$4D)(P)},A)}}e.$Bmc=R}),define(ke[161],Ee([1,0,53,402,385,19,73,35,14,2,36,94,403,383,122]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=void 0,e.$wmc=t,e.$xmc=d,e.$ymc=c,e.$zmc=h,e.$Amc=D;const a=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(k){this.a=k}provideTextSearchResults(k,y,C,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,j)=>{I.onCancellationRequested(()=>Y());const F=t(k,y),O=y.folder.fsPath,T=F.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${a} ${T}
 - cwd: ${O}`);let B=u.spawn(a,F,{cwd:O});B.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),j((0,A.$aL)(new A.$$K(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let H=!1;const X=new i(y.maxResults,y.folder,y.previewOptions);X.on("result",Ce=>{H=!0,ce="",C.report(Ce)});let x=!1;const Y=()=>{x=!0,B?.kill(),X?.cancel()};let Z=!1;X.on("hitLimit",()=>{Z=!0,Y()});let ce="";B.stdout.on("data",Ce=>{X.handleData(Ce),H||(ce+=Ce)});let ie=!1;B.stdout.once("data",()=>ie=!0);let pe="";B.stderr.on("data",Ce=>{const _=Ce.toString();this.a.appendLine(_),pe.length+_.length<1e6&&(pe+=_)}),B.on("close",()=>{if(this.a.appendLine(ie?"Got data from stdout":"No data from stdout"),this.a.appendLine(H?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),x)z({limitHit:Z});else{X.flush(),B=null;let Ce;pe&&!ie&&(Ce=o(pe))?j((0,A.$aL)(new A.$$K(Ce.message,Ce.code))):z({limitHit:Z})}})})}}e.$umc=m;function o(w){const k=w.split(`
`),y=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$$K(n(k),A.SearchErrorCode.regexParseError);const C=y.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$$K(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$$K(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$$K(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$$K(y,A.SearchErrorCode.regexParseError)}function n(w){const k=["Regex parse error"],y=w.filter(C=>C.startsWith("PCRE2:"));if(y.length>=1){const C=y[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const I=C.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends N.EventEmitter{constructor(k,y,C){super(),this.g=k,this.h=y,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,y){return super.on(k,y),this}handleData(k){if(this.b)return;const y=typeof k=="string"?k:this.d.write(k);this.k(y)}k(k){let y=k.indexOf(`
`);const C=this.a+k;if(y>=0)y+=this.a.length;else{this.a=C;return}let I=0;for(;y>=0;)this.m(C.substring(I,y).trim()),I=y+1,y=C.indexOf(`
`,I);this.a=C.substring(I)}m(k){if(this.b||!k)return;let y;try{y=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(y.type==="match"){const C=r(y.data.path),I=S.URI.joinPath(this.h,C),z=this.n(y.data,I);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const C=r(y.data.path),I=S.URI.joinPath(this.h,C);this.o(y.data,I).forEach(j=>this.p(j))}}n(k,y){const C=k.line_number-1,I=r(k.lines),z=Buffer.from(I);let j=0,F=0,O=C;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(k.submatches.map((B,H)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=r(B.match),x=z.slice(j,B.start).toString(),Y=s(x),Z=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+F,ce=s(X),ie=Y.numLines+O,pe=ce.numLines+ie,Ce=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Z;return j=B.end,F=Ce,O=pe,new P.$UK(ie,Z,pe,Ce)}));return(0,v.$nmc)(y,I,T,this.j)}o(k,y){const C=r(k.lines),I=k.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((z,j)=>({text:z,uri:y,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$vmc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const k=/\n/g;let y=0,C=-1,I;for(;I=k.exec(w);)y++,C=I.index;const z=C>=0?w.length-C-1:w.length;return{numLines:y,lastLineLength:z}}function t(w,k){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:I}=(0,M.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(F=>{j.add(F)}),y.push("-g","!*"),j.forEach(F=>{f(F).map(v.$mmc).forEach(O=>{y.push("-g",O)})})}C&&C.length&&C.forEach(j=>{y.push("-g",j)}),k.excludes.map(v.$mmc).forEach(j=>y.push("-g",`!${j}`)),k.maxFileSize&&y.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),k.followSymlinks&&y.push("--follow"),k.encoding&&k.encoding!=="utf8"&&y.push("--encoding",k.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,p.$5e)(w.pattern),w.isRegExp=!0),k.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),y.push("--engine","auto"));let z;if(w.isWordMatch){const F=(0,p.$bf)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(w.isRegExp){let j=c(w.pattern);j=h(j),y.push("--regexp",j)}else z=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),k.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),k.beforeContext&&y.push("--before-context",k.beforeContext+""),k.afterContext&&y.push("--after-context",k.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function f(w){return D(w).flatMap(y=>{const C=(0,b.$fk)(y,"/");return C.map((I,z)=>C.slice(0,z+1).join("/"))})}function d(w){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(k);)w=w.replace(k,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let k;try{k=new $.RegExpParser().parsePattern(w)}catch{return w}let y="",C=0;const I=(F,O,T)=>{y+=w.slice(C,F)+T,C=O},z=[];return new $.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=z[0];if(!O)I(F.start,F.end,"\\r?\\n");else if(!z.some(l))if(O.type==="CharacterClass")if(O.negate){const T=w.slice(O.start+2,F.start)+w.slice(F.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=w.slice(O.start+1,F.start)+w.slice(F.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){z.unshift(F)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(F){z.unshift(F)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(F){z.unshift(F)},onCharacterClassLeave(){z.shift()},onAssertionEnter(F){l(F)&&z.push(F)},onAssertionLeave(F){z[0]===F&&z.shift()}}).visit(k),y+=w.slice(C),y}function h(w){return w.replace(/\n/g,"\\r?\\n")}function g(w){let k=!1,y=!1,C="",I="";for(let z=0;z<w.length;z++){const j=w[z];switch(j){case"\\":y?(k?I+="\\"+j:C+="\\"+j,y=!1):y=!0;break;case"{":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{strInBraces:C+"{"+I+"{"+w.substring(z+1)};k=!0}break;case"}":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{fixedStart:C,strInBraces:I,fixedEnd:w.substring(z+1)};C+=j}break;default:k?I+=(y?"\\":"")+j:C+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:C+(k?"{"+I:"")}}function D(w){const{fixedStart:k,strInBraces:y,fixedEnd:C}=g(w);if(k===void 0||C===void 0)return[y];let I=(0,b.$fk)(y,",");I.length||(I=[""]);const z=D(C);return I.flatMap(j=>{const F=k+j;return z.map(O=>F+O)})}}),define(ke[387],Ee([1,0,22,161,108,15]),function(he,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class M{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,A,P,$){const E=new N.$umc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},a=new L.$Wv(m=>P.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c($,m=>E.provideTextSearchResults(S,v,a,m))}else return this.c($,v=>E.provideTextSearchResults(S,A,P,v))}async c(S,A){const P=b(S);this.a.add(P);const $=await A(P.token);return this.a.delete(P),$}d(){this.a.forEach(S=>S.cancel())}}e.$Emc=M;function b(p){const S=new u.$je;return p.onCancellationRequested(()=>S.cancel()),S}}),define(ke[388],Ee([1,0,31,161,160]),function(he,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;class R{constructor(p){this.a=p}search(p,S,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(E){A({message:E})}},$=new L.$Bmc(this.a,new N.$umc(P),u);return new Promise((E,v)=>$.search(a=>{S(a.map(M))},p).then(a=>E({limitHit:a.limitHit,type:"success",stats:a.stats}),v))}}e.$Cmc=R;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((p,S)=>{if(S.ranges){const A=S;return p+(Array.isArray(A.ranges)?A.ranges.length:1)}else return p+1},0)}}}),define(ke[389],Ee([1,0,19,7,13,4,132,17,39,2,32,36,384,388]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new R.$_d({onDidAddFirstListener:()=>{s=(0,N.$ah)(d=>this.doFileSearchWithEngine($.$tmc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new R.$_d({onDidAddFirstListener:()=>{s=(0,N.$ah)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new E.$Cmc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$pl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine($.$tmc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=v.a){let l=0;const c=g=>{Array.isArray(g)?(l+=g.length,t(g.map(D=>this.h(D)))):g.relativePath?(l++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,c,f);if(!g){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(D);g=this.j(w,s,t,c,f)}return new Promise((D,w)=>{g.then(([k,y])=>{const C=y.map(I=>this.h(I));this.o(C,t,d),D(k)},w)})}const h=new r(s);return this.r(h,c,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new R.$_d;let c=(0,N.$ah)(g=>{let D=[];const w=k=>{Array.isArray(k)?D=k:(f(k),l.fire(k))};return this.r(r,w,-1,g).then(k=>[k,D])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const g={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=g,c.then(()=>{g.resolved=!0},D=>{delete h.resultsToSearchCache[s.filePattern||""]}),c=this.s(c)}return c.then(([g,D])=>{const w=h?h.scorerCache:Object.create(null),k=(typeof s.maxResults!="number"||s.maxResults>0)&&p.$8d.create(!1);return this.n(s,D,w,d).then(y=>{const C=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,c,h])=>{const g=p.$8d.create(!1);return this.n(r,c,f.scorerCache,t).then(D=>{const w=g.elapsed(),k={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:k},D]})})}n(r,s,t,f){const d=(0,M.$mr)(r.filePattern||""),l=(h,g)=>(0,M.$lr)(h,g,d,!0,m,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,c,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=p.$8d.create(!1),l=s.indexOf(b.sep)>=0;let c;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(b.sep)<0&&w!=="")continue;const k=r.resultsToSearchCache[w];c={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!c)return null;const h=d.elapsed(),g=p.$8d.create(!1),D=c.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),c.promise.then(([w,k])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const y=[],C=(0,M.$mr)(s).normalizedLowercase;for(const I of k)(0,P.$eL)(I,C)&&y.push(I);return[w,y,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:k.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let c=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(s(c),c=[])):s(h))},h=>{s(h)},(h,g)=>{c.length&&s(c),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$Dmc=v;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>S.URI.revive(r))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[390],Ee([1,0,3,15,2,31,12,28,20,97,67,36,389,387,122,160]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;let m=class extends S.$qlc{constructor(n,i,r,s){super(n,r,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$omc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$Emc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$omc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new E.$Emc(n))),this.A.add(this.C(N.Schemas.file,new $.$Dmc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,S.$rlc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,P.$dL)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new a.$Bmc(n,i,void 0,"textSearchProvider")}};e.$Fmc=m,e.$Fmc=m=Je([We(0,p.$0O),We(1,b.$nP),We(2,A.$hkc),We(3,M.$Tj)],m)}),define(ke[123],Ee([1,0,377,63,64,404,21,13,4,3,17,11,30,81,82]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$ei=e.$di=e.$ci=void 0,e.$fi=d,e.$gi=l,e.$ii=g,e.$ji=D;class a{traceSocketEvent(k,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,y)}constructor(k,y=""){this.f=!0,this.debugLabel=y,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const y=C=>{this.traceSocketEvent("read",C),k(M.$ze.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(k){const y=C=>{k({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(k){const y=()=>{k()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ci=a;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(o||(o={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,y){this.socket.traceSocketEvent(k,y)}constructor(k,y,C,I){super(),this.f=this.B(new p.$_d),this.g=this.B(new p.$_d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,y,C,I,this.f,(z,j)=>this.m(z,j))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$0h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let y=0;for(;y<k.byteLength;)this.a.writeMessage(k.slice(y,Math.min(y+262144,k.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(k,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const z=M.$ze.alloc(I),j=y?64:0,F=C&15;if(z.writeUInt8(128|j|F,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let O=1;z.writeUInt8(k.byteLength>>>8&255,++O),z.writeUInt8(k.byteLength>>>0&255,++O)}else{z.writeUInt8(127,1);let O=1;z.writeUInt8(0,++O),z.writeUInt8(0,++O),z.writeUInt8(0,++O),z.writeUInt8(0,++O),z.writeUInt8(k.byteLength>>>24&255,++O),z.writeUInt8(k.byteLength>>>16&255,++O),z.writeUInt8(k.byteLength>>>8&255,++O),z.writeUInt8(k.byteLength>>>0&255,++O)}this.socket.write(M.$ze.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),I=(C&128)>>>7,z=(C&64)>>>6,j=C&15,F=y.readUInt8(1),O=(F&128)>>>7,T=F&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),I=(C&128)>>>7;let z=C&127,j=1;z===126?z=y.readUInt8(++j)*2**8+y.readUInt8(++j):z===127&&(z=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let F=0;I&&(F=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=z,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$di=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$ze.alloc(0)}constructor(k,y,C,I,z,j){super(),this.n=k,this.r=z,this.s=j,this.a=this.B(new p.$_d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$_d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$_d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,I,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(k,y){this.g.push({data:k,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,k);this.s(C,y)}else this.s(k,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,y){return new Promise((C,I)=>{k.write(y),k.flush(z=>C(z))})}acceptFrame(k,y,C){this.h.push({data:k,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const y=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,y,C){return new Promise((I,z)=>{k.write(y),C&&k.write(M.$ze.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class r extends S.$Uc{get recordedInflateBytes(){return this.j?M.$ze.concat(this.f):M.$ze.alloc(0)}constructor(k,y,C,I){super(),this.h=k,this.j=y,this.a=this.B(new p.$_d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(M.$ze.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$ze.concat(this.g);this.g.length=0,k(y)})}}class s extends S.$Uc{constructor(k,y){super(),this.g=k,this.a=this.B(new p.$_d),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$ze.wrap(C))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$ze.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),k(y)})}}function t(w,k){if(k===0)return;const y=w.byteLength>>>2;for(let O=0;O<y;O++){const T=w.readUInt32BE(O*4);w.writeUInt32BE(T^k,O*4)}const C=y*4,I=w.byteLength-C,z=k>>>24&255,j=k>>>16&255,F=k>>>8&255;I>=1&&w.writeUInt8(w.readUInt8(C)^z,C),I>=2&&w.writeUInt8(w.readUInt8(C+1)^j,C+1),I>=3&&w.writeUInt8(w.readUInt8(C+2)^F,C+2)}e.$ei=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const w=(0,$.$Jg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const k=process.platform!=="darwin"&&e.$ei?e.$ei:(0,L.tmpdir)(),y=(0,A.$kc)(k,`vscode-ipc-${w}.sock`);return c(y),y}function l(w,k,y){const I=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${k}-sock`;const z=y.substr(0,4),j=k.substr(0,6);let F;return process.platform!=="darwin"&&e.$ei&&!process.env.VSCODE_PORTABLE?F=(0,A.$kc)(e.$ei,`vscode-${I}-${z}-${j}.sock`):F=(0,A.$kc)(w,`${z}-${j}.sock`),c(F),F}function c(w){const k=f[P.$u];typeof k=="number"&&w.length>=k&&console.warn(`WARNING: IPC handle "${w}" is longer than ${k} chars, try a shorter --user-data-dir`)}class h extends E.$4h{static b(k){const y=p.Event.fromNodeEventEmitter(k,"connection");return p.Event.map(y,C=>({protocol:new v.$$h(new a(C,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(C,"close"))}))}constructor(k){super(h.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hi=h;function g(w){return new Promise((k,y)=>{const C=(0,N.createServer)();C.on("error",y),C.listen(w,()=>{C.removeListener("error",y),k(new h(C))})})}function D(w,k){return new Promise((y,C)=>{const I=(0,N.createConnection)(w,()=>{I.removeListener("error",C),y(v.$_h.fromSocket(new a(I,`ipc-client${k}`),k))});I.once("error",C)})}}),define(ke[391],Ee([1,0,63,64,173,123,7,3,11,54,12,139,267,268,110,88,21]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=e.$tcc=e.$scc=void 0;async function o(t,f,d,l,c){let h;for(let g=3;g&&(h?.dispose(),h=await new n(t,f,d,l,c).waitForReady(),!(c&&L.$Mg[c]||!L.$Mg[h.tunnelLocalPort]));g--);return h}class n extends b.$Uc{constructor(f,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new M.$mh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,a.$0v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,L.$Ng)(f,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(f){f.pause();const d=(0,a.$8v)(this.tunnelRemoteHost)||(0,a.$0v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Jl)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),c.end()}),f.on("close",()=>c.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),c instanceof R.$ci?c.socket.destroy():c.end()}),c instanceof R.$ci?this.t(f,c):this.s(f,c),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),c.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(m.$ze.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$scc=n;let i=class extends a.$aw{constructor(f,d,l,c,h){super(d,h),this.v=f,this.w=l,this.y=c}isPortPrivileged(f){return(0,a.$$v)(f,this.m,p.OS,N.release())}t(f,d,l,c,h,g,D,w){const k=this.s(d,l);if(k)return++k.refcount,k.value;if((0,a.$4v)(f))return this.u(f,d,l,h,g,D,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=o(y,c,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,C),C}}};e.$tcc=i,e.$tcc=i=Je([We(0,E.$Dl),We(1,A.$Tj),We(2,v.$Gl),We(3,P.$ak),We(4,S.$Ti)],i);let r=class extends i{constructor(f,d,l,c,h){super(f,d,l,c,h)}};e.$ucc=r,e.$ucc=r=Je([We(0,E.$Dl),We(1,A.$Tj),We(2,v.$Gl),We(3,P.$ak),We(4,S.$Ti)],r);let s=class extends b.$Uc{constructor(f,d,l,c,h){super(),this.b=f,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(f,d,l,c,h,g,D,w,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${g}.`),!this.a.has(f)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,c,h,g,D,w,k)}};e.$vcc=s,e.$vcc=s=Je([We(0,E.$Dl),We(1,A.$Tj),We(2,P.$ak),We(3,v.$Gl),We(4,S.$Ti)],s)}),define(ke[392],Ee([1,0,123,287,52,33,2,12,41]),function(he,e,u,N,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$yP=void 0;class S{constructor($,E,v){this.b=$,this.c=E,this.f=v,this.a=N.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(E.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,E){const v=(m,o)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},a=[];$.setEncoding("utf8"),$.on("data",m=>a.push(m)),$.on("end",async()=>{try{const m=JSON.parse(a.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);v(500,o),this.c.error("Error while processing pipe request",m)}})}async i($){const{fileURIs:E,folderURIs:v,forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=$,f=[];if(Array.isArray(v))for(const h of v)try{f.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(E))for(const h of E)try{(0,p.$Si)(h)?f.push({workspaceUri:M.URI.parse(h)}):f.push({fileUri:M.URI.parse(h)})}catch{}const d=s?M.URI.file(s):void 0,c={forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,c)}async j($){for(const E of $.uris){const v=M.URI.parse(E),a=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k($){const E=a=>a?.map(m=>/\.vsix$/i.test(m)?M.URI.parse(m):m),v={list:$.list,install:E($.install),uninstall:E($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$yP=S;let A=class extends S{constructor($,E){super($,E,(0,u.$fi)())}};e.$zP=A,e.$zP=A=Je([We(0,R.$tP),We(1,b.$Tj)],A)}),define(ke[393],Ee([1,0,59,380,374,286,49,361,2,15,8,392,104,320,360]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;class a extends L.$_lc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,c){return d=t(d),n.a.has(d)?n.a.get(d).load(d,p.URI.file((0,$.$Vq)(l.filename)),h=>r.apply(this,[h,l,c])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class m extends M.$Zkc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(E.$Imc);const n=this.h.invokeFunction(N.$8lc);if(this.h.createInstance(b.$Hmc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(P.$zP);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$Jmc),await this.h.createInstance(a,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$Gmc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$Kmc=m}),define(ke[394],Ee([1,0,53,21,4,3,125,11,23,2,31,12,266,66,110,88,391,28,20,70,368]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0,e.$Lmc=s,e.$Mmc=t,e.$Nmc=f,e.$Omc=d,e.$Pmc=c,e.$Qmc=h,e.$Rmc=g;function s(k){const y=k.trim().split(`
`),C=[];return y.forEach(z=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((z,j)=>(z[j.socket]=j,z),{})}function t(...k){const y=[].concat(...k.map(d));return[...new Map(y.filter(C=>C.st==="0A").map(C=>{const I=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:f(I[0]),port:parseInt(I[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function f(k){let y="";if(k.length===8)for(let C=k.length-2;C>=0;C-=2)y+=parseInt(k.substr(C,2),16),C!==0&&(y+=".");else for(let C=0;C<k.length;C+=8){const I=k.substring(C,C+8);let z="";for(let j=8;j>=2;j-=2)z+=I.substring(j-2,j),(j===6||j===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",C+j!==k.length-6&&(y+=":"))}return y}function d(k){const y=k.trim().split(`
`),C=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((j,F,O)=>(j[C[O]||O]=F,j),{}))}function l(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function c(k){const y=k.trim().split(`
`),C=[];return y.forEach(I=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}async function h(k,y,C){const I=C.reduce((j,F)=>(j[F.pid]=F,j),{}),z=[];return k.forEach(({socket:j,ip:F,port:O})=>{const T=y[j]?y[j].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!l(B)&&z.push({host:F,port:O,detail:B,pid:T})}),z}function g(k,y,C){const I=new Map,z=c(y);for(const j of k){const F=C.get(j.port);if(F){I.set(j.port,F);continue}const O=z.find(T=>T.cmd.includes(`${j.port}`));if(O){let T=O,B;do B=z.find(H=>H.ppid===T.pid),B&&(T=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$mCb{constructor(y,C,I,z){super(y,C,I),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$vm;let z=0;for(;this.C;){const j=new Date().getTime(),F=(await this.I()).filter(B=>(0,a.$8v)(B.host)||(0,a.$0v)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),z++>3&&I.update(O),(!C||JSON.stringify(C)!==JSON.stringify(F))&&(C=F,await this.a.$onFoundNewCandidates(C));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",C="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(y,C),z=await new Promise(x=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,Z,ce)=>{x(Z)})}),j=s(z),F=await A.Promises.readdir("/proc"),O=[];for(const x of F)try{const Y=Number(x),Z=p.$1g(S.URI.file("/proc"),x);if((await A.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Y)){const ie=await A.Promises.readlink(p.$1g(Z,"cwd").fsPath),pe=await A.Promises.readFile(p.$1g(Z,"cmdline").fsPath,"utf8");O.push({pid:Y,cwd:ie,cmd:pe})}}catch{}const T=[],B=I.filter(x=>{const Y=j[x.socket];return Y||T.push(x),Y}),H=h(B,j,O);let X;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const x=await new Promise(Y=>{(0,u.exec)("ps -F -A -l | grep root",(Z,ce,ie)=>{Y(ce)})});this.z=g(T,x,this.z),X=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.map(Y=>Y.port).join(", ")}`)}return H.then(x=>X?x.concat(X):x)}w(y){return async C=>{const I=new m.$scc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,F,O,T){const B=await y.makeConnection();return w.connect(B,F,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$zl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await I.waitForReady();const z=new L.$_d;return{localAddress:(0,r.$aM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{I.dispose(),z.fire(),z.dispose()}}}}};e.$Smc=D,e.$Smc=D=Je([We(0,n.$0O),We(1,o.$nP),We(2,P.$Tj),We(3,v.$Gl)],D);class w extends $.$ksb{static connect(y,C,I,z){const j=new R.$Tc,F={onClose:j.add(new L.$_d),onData:j.add(new L.$_d),onEnd:j.add(new L.$_d)};j.add(y.onDidReceiveMessage(T=>F.onData.fire(N.$ze.wrap(T)))),j.add(y.onDidEnd(()=>F.onEnd.fire())),j.add(y.onDidClose(T=>F.onClose.fire({type:0,error:T,hadError:!!T})));const O=new w(y,z,F);return O.B(j),(0,$.$jsb)(O,C,I,z,F)}constructor(y,C,I){super(C,I),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[395],Ee([1,0,84,363,378,376,390,393,394,96,49,97,95,42,70,93,362,321,12,379,61,281,106,110,141]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$ls)(A.$1kc,b.$Kmc,0),(0,u.$ls)(n.$Uj,o.$Umc,1),(0,u.$ls)(n.$Tj,new t.$ki(s.$$lc,[!1],!0)),(0,u.$ls)(f.$Gl,d.$xcc,1),(0,u.$ls)(a.$qkc,m.$Tmc,0),(0,u.$ls)(S.$6kc,R.$lmc,0),(0,u.$ls)(P.$plc,M.$Fmc,0),(0,u.$ls)($.$Rlc,L.$dmc,0),(0,u.$ls)(E.$Lkc,N.$cmc,0),(0,u.$ls)(v.$lCb,p.$Smc,0),(0,u.$ls)(r.$4kc,i.$Vmc,0)}),define(ke[405],Ee([1,0,63,406,59,13,82,123,264,114,375,21,31,104,7,135,288,304,381,395]),function(he,e,u,N,L,R,M,b,p,S,A,P,$,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,g=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(g){if(h)i(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(g,D)}}let t=function(h){i()};function f(){const h=(0,o.$fn)(process.env);if(h.type===3)return new Promise((g,D)=>{const w=k=>{const y=k[0],C=new M.$ai;y.on("message",I=>C.fire(P.$ze.wrap(I.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),g({onMessage:C.event,send:I=>y.postMessage(I.buffer)})};process.parentPort.on("message",k=>w(k.ports))});if(h.type===2)return new Promise((g,D)=>{let w=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,C=3e5,I=new v.$Ah(()=>t("renderer disconnected for too long (1)"),y),z=new v.$Ah(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(F,O)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=P.$ze.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new b.$ci(O,"extHost-socket");else{const H=P.$ze.wrap(Buffer.from(F.inflateBytes,"base64"));B=new b.$di(new b.$ci(O,"extHost-socket"),F.permessageDeflate,H,!1)}w?(I.cancel(),z.cancel(),w.beginAcceptReconnection(B,T),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(k),w=new M.$bi({socket:B,initialChunk:T}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),g(w),w.onSocketClose(()=>{I.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;I.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const g=h.pipeName;return new Promise((D,w)=>{const k=u.createConnection(g,()=>{k.removeListener("error",w);const y=new M.$bi({socket:new b.$ci(k,"extHost-renderer")});y.sendResume(),D(y)});k.once("error",w),k.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new M.$ai,this.onMessage=this.a.event,this.b=!1,h.onMessage(g=>{(0,S.$Rm)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||h.send(g)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(g=>{const D=h.onMessage(w=>{D.dispose();const k=JSON.parse(w.toString()),y=k.commit,C=p.default.commit;if(y&&C&&y!==C&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(k.parentPid)}catch(j){(0,R.$1)(j)}}h.send((0,S.$Qm)(0)),g({protocol:h,initData:k})});h.send((0,S.$Qm)(1))})}async function c(){const h=[];process.on("unhandledRejection",(I,z)=>{h.push(z),setTimeout(()=>{const j=h.indexOf(z);j>=0&&z.catch(F=>{h.splice(j,1),(0,R.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const z=h.indexOf(I);z>=0&&h.splice(z,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const g=await d();L.mark("code/extHost/didConnectToRenderer");const D=await l(g);L.mark("code/extHost/didWaitForInitData");const{initData:w}=D;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,a.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return $.Promises.exists(z)}fsRealpath(z){return(0,E.$Uq)(z)}};let y=null;w.remote.authority&&n.transformURIs&&(y=(0,m.$ps)(w.remote.authority));const C=new A.$bmc(D.protocol,w,k,y);t=I=>C.terminate(I)}c().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ed6c6d3f28fa4cb66f6d73918365e41fb81db14c/core/vs/workbench/api/node/extensionHostProcess.js.map
