/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],I=0,N=ge.length;I<N;I++)e[I]=Re[ge[I]];return e};define(Re[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=N,e.$Sh=R,e.$Th=O;function I(M){return(m,g,E)=>{let T=null,k=null;if(typeof E.value=="function"?(T="value",k=E.value):typeof E.get=="function"&&(T="get",k=E.get),!k)throw new Error("not supported");E[T]=M(k,g)}}function N(M,m,g){let E=null,T=null;if(typeof g.value=="function"?(E="value",T=g.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(E="get",T=g.get),!T)throw new Error("not supported");const k=`$memoize$${m}`;g[E]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,u)}),this[k]}}function R(M,m,g){return I((E,T)=>{const k=`$debounce$${T}`,u=`$debounce$result$${T}`;return function(...b){this[u]||(this[u]=g?g():void 0),clearTimeout(this[k]),m&&(this[u]=m(this[u],...b),b=[this[u]]),this[k]=setTimeout(()=>{E.apply(this,b),this[u]=g?g():void 0},M)}})}function O(M,m,g){return I((E,T)=>{const k=`$throttle$timer$${T}`,u=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...n){if(this[u]||(this[u]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...n)),this[d])return;const o=this[b]+M;o<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[u]]),this[u]=g?g():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[b]=Date.now(),E.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}}),define(Re[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$cP=I,e.$dP=new I("id#")}),define(Re[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=M,e.$zn=k,e.$An=u,e.$Bn=b,e.$Cn=d,e.$Dn=n,e.$En=o,e.$Fn=s,e.$Gn=r,e.$Hn=i,e.$In=a,e.$Jn=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(t,v=!1){let c=0;const $=t.length;let w="",p=0,l=16,D=0;function f(q){let A=0,U=0;for(;A<q;){const K=t.charCodeAt(c);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;c++,A++}return A<q&&(U=-1),U}function S(q){c=q,w="",p=0,l=16,D=0}function y(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&E(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&E(t.charCodeAt(c)))for(c++;c<t.length&&E(t.charCodeAt(c));)c++;else return D=3,t.substring(q,c);let A=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&E(t.charCodeAt(c))){for(c++;c<t.length&&E(t.charCodeAt(c));)c++;A=c}else D=3;return t.substring(q,A)}function C(){let q="",A=c;for(;;){if(c>=$){q+=t.substring(A,c),D=2;break}const U=t.charCodeAt(c);if(U===34){q+=t.substring(A,c),c++;break}if(U===92){if(q+=t.substring(A,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=f(4);ie>=0?q+=String.fromCharCode(ie):D=4;break}default:D=5}A=c;continue}if(U>=0&&U<=31)if(g(U)){q+=t.substring(A,c),D=2;break}else D=6;c++}return q}function P(){if(w="",D=0,p=c,c>=$)return p=$,l=17;let q=t.charCodeAt(c);if(m(q)){do c++,w+=String.fromCharCode(q),q=t.charCodeAt(c);while(m(q));return l=15}if(g(q))return c++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,w+=`
`),l=14;switch(q){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,w=C(),l=10;case 47:{const A=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!g(t.charCodeAt(c));)c++;return w=t.substring(A,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const U=$-1;let K=!1;for(;c<U;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,D=1),w=t.substring(A,c),l=13}return w+=String.fromCharCode(q),c++,l=16}case 45:if(w+=String.fromCharCode(q),c++,c===$||!E(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),l=11;default:for(;c<$&&W(q);)c++,q=t.charCodeAt(c);if(p!==c){switch(w=t.substring(p,c),w){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return w+=String.fromCharCode(q),c++,l=16}}function W(q){if(m(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:v?V:P,getToken:()=>l,getTokenValue:()=>w,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,v){const c=[],$=new Object;let w;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(f,S,y,C){p.value=f,p.offset=S,p.length=y,p.type=C,p.colonOffset=void 0,w=p}try{i(t,{onObjectBegin:(f,S)=>{if(v<=f)throw $;w=void 0,l=v>f,c.push("")},onObjectProperty:(f,S,y)=>{if(v<S||(D(f,S,y,"property"),c[c.length-1]=f,v<=S+y))throw $},onObjectEnd:(f,S)=>{if(v<=f)throw $;w=void 0,c.pop()},onArrayBegin:(f,S)=>{if(v<=f)throw $;w=void 0,c.push(0)},onArrayEnd:(f,S)=>{if(v<=f)throw $;w=void 0,c.pop()},onLiteralValue:(f,S,y)=>{if(v<S||(D(f,S,y,h(f)),v<=S+y))throw $},onSeparator:(f,S,y)=>{if(v<=S)throw $;if(f===":"&&w&&w.type==="property")w.colonOffset=S,l=!1,w=void 0;else if(f===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(l=!0,c[c.length-1]=""),w=void 0}}})}catch(f){if(f!==$)throw f}return{path:c,previousNode:w,isAtPropertyKey:l,matches:f=>{let S=0;for(let y=0;S<f.length&&y<c.length;y++)if(f[S]===c[y]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}function u(t,v=[],c=O.DEFAULT){let $=null,w=[];const p=[];function l(f){Array.isArray(w)?w.push(f):$!==null&&(w[$]=f)}return i(t,{onObjectBegin:()=>{const f={};l(f),p.push(w),w=f,$=null},onObjectProperty:f=>{$=f},onObjectEnd:()=>{w=p.pop()},onArrayBegin:()=>{const f=[];l(f),p.push(w),w=f,$=null},onArrayEnd:()=>{w=p.pop()},onLiteralValue:l,onError:(f,S,y)=>{v.push({error:f,offset:S,length:y})}},c),w[0]}function b(t,v=[],c=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(f){$.type==="property"&&($.length=f-$.offset,$=$.parent)}function p(f){return $.children.push(f),f}i(t,{onObjectBegin:f=>{$=p({type:"object",offset:f,length:-1,parent:$,children:[]})},onObjectProperty:(f,S,y)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:f,offset:S,length:y,parent:$})},onObjectEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,w(f+S)},onArrayBegin:(f,S)=>{$=p({type:"array",offset:f,length:-1,parent:$,children:[]})},onArrayEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,w(f+S)},onLiteralValue:(f,S,y)=>{p({type:h(f),offset:S,length:y,parent:$,value:f}),w(S+y)},onSeparator:(f,S,y)=>{$.type==="property"&&(f===":"?$.colonOffset=S:f===","&&w(S))},onError:(f,S,y)=>{v.push({error:f,offset:S,length:y})}},c);const D=$.children[0];return D&&delete D.parent,D}function d(t,v){if(!t)return;let c=t;for(const $ of v)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],w=!0;break}if(!w)return}else{const w=$;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}function n(t){if(!t.parent||!t.parent.children)return[];const v=n(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;v.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&v.push(c)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(v[c.children[0].value]=o($))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,c=!1){return v>=t.offset&&v<t.offset+t.length||c&&v===t.offset+t.length}function r(t,v,c=!1){if(s(t,v,c)){const $=t.children;if(Array.isArray($))for(let w=0;w<$.length&&$[w].offset<=v;w++){const p=r($[w],v,c);if(p)return p}return t}}function i(t,v,c=O.DEFAULT){const $=M(t,!1);function w(re){return re?()=>re($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(re){return re?Se=>re(Se,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=w(v.onObjectBegin),D=p(v.onObjectProperty),f=w(v.onObjectEnd),S=w(v.onArrayBegin),y=w(v.onArrayEnd),C=p(v.onLiteralValue),P=p(v.onSeparator),W=w(v.onComment),V=p(v.onError),q=c&&c.disallowComments,A=c&&c.allowTrailingComma;function U(){for(;;){const re=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(re){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return re}}}function K(re,Se=[],Le=[]){if(V(re),Se.length+Le.length>0){let ne=$.getToken();for(;ne!==17;){if(Se.indexOf(ne)!==-1){U();break}else if(Le.indexOf(ne)!==-1)break;ne=U()}}}function ie(re){const Se=$.getTokenValue();return re?C(Se):D(Se),U(),!0}function ce(){switch($.getToken()){case 11:{let re=0;try{re=JSON.parse($.getTokenValue()),typeof re!="number"&&(K(2),re=0)}catch{K(2)}C(re);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return U(),!0}function we(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(P(":"),U(),pe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){l(),U();let re=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(re||K(4,[],[]),P(","),U(),$.getToken()===2&&A)break}else re&&K(6,[],[]);we()||K(4,[],[2,5]),re=!0}return f(),$.getToken()!==2?K(7,[2],[]):U(),!0}function ue(){S(),U();let re=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(re||K(4,[],[]),P(","),U(),$.getToken()===4&&A)break}else re&&K(6,[],[]);pe()||K(4,[],[4,5]),re=!0}return y(),$.getToken()!==4?K(8,[4],[]):U(),!0}function pe(){switch($.getToken()){case 3:return ue();case 1:return Ie();case 10:return ie(!0);default:return ce()}}return U(),$.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):pe()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,v){const c=M(t),$=[];let w,p=0,l;do switch(l=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),v!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,v)),p=c.getPosition();break}while(w!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Re[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,$e){for(var fe=0;fe<$e.length;fe++){var Q=$e[fe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ee,Q.key,Q)}}function I(Ee,$e,fe){return $e&&e(Ee.prototype,$e),fe&&e(Ee,fe),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function N(Ee,$e){if(Ee){if(typeof Ee=="string")return R(Ee,$e);var fe=Object.prototype.toString.call(Ee).slice(8,-1);if(fe==="Object"&&Ee.constructor&&(fe=Ee.constructor.name),fe==="Map"||fe==="Set")return Array.from(Ee);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(Ee,$e)}}function R(Ee,$e){($e==null||$e>Ee.length)&&($e=Ee.length);for(var fe=0,Q=new Array($e);fe<$e;fe++)Q[fe]=Ee[fe];return Q}function O(Ee,$e){var fe=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(fe)return(fe=fe.call(Ee)).next.bind(fe);if(Array.isArray(Ee)||(fe=N(Ee))||$e&&Ee&&typeof Ee.length=="number"){fe&&(Ee=fe);var Q=0;return function(){return Q>=Ee.length?{done:!0}:{done:!1,value:Ee[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function m(Ee){ge.defaults=Ee}var g=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function($e){return u[$e]};function d(Ee,$e){if($e){if(g.test(Ee))return Ee.replace(E,b)}else if(T.test(Ee))return Ee.replace(k,b);return Ee}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(n,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var s=/(^|[^\[])\^/g;function r(Ee,$e){Ee=typeof Ee=="string"?Ee:Ee.source,$e=$e||"";var fe={replace:function(X,le){return le=le.source||le,le=le.replace(s,"$1"),Ee=Ee.replace(X,le),fe},getRegex:function(){return new RegExp(Ee,$e)}};return fe}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,$e,fe){if(Ee){var Q;try{Q=decodeURIComponent(o(fe)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}$e&&!a.test(fe)&&(fe=w($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var t={},v=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Ee,$e){t[" "+Ee]||(v.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=f(Ee,"/",!0)),Ee=t[" "+Ee];var fe=Ee.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:Ee.replace(c,"$1")+$e:$e.charAt(0)==="/"?fe?$e:Ee.replace($,"$1")+$e:Ee+$e}var p={exec:function(){}};function l(Ee){for(var $e=1,fe,Q;$e<arguments.length;$e++){fe=arguments[$e];for(Q in fe)Object.prototype.hasOwnProperty.call(fe,Q)&&(Ee[Q]=fe[Q])}return Ee}function D(Ee,$e){var fe=Ee.replace(/\|/g,function(le,de,Te){for(var he=!1,Ce=de;--Ce>=0&&Te[Ce]==="\\";)he=!he;return he?"|":" |"}),Q=fe.split(/ \|/),X=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>$e)Q.splice($e);else for(;Q.length<$e;)Q.push("");for(;X<Q.length;X++)Q[X]=Q[X].trim().replace(/\\\|/g,"|");return Q}function f(Ee,$e,fe){var Q=Ee.length;if(Q===0)return"";for(var X=0;X<Q;){var le=Ee.charAt(Q-X-1);if(le===$e&&!fe)X++;else if(le!==$e&&fe)X++;else break}return Ee.slice(0,Q-X)}function S(Ee,$e){if(Ee.indexOf($e[1])===-1)return-1;for(var fe=Ee.length,Q=0,X=0;X<fe;X++)if(Ee[X]==="\\")X++;else if(Ee[X]===$e[0])Q++;else if(Ee[X]===$e[1]&&(Q--,Q<0))return X;return-1}function y(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ee,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=Ee),$e>>=1,Ee+=Ee;return fe+Ee}function P(Ee,$e,fe,Q){var X=$e.href,le=$e.title?d($e.title):null,de=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){Q.state.inLink=!0;var Te={type:"link",raw:fe,href:X,title:le,text:de,tokens:Q.inlineTokens(de)};return Q.state.inLink=!1,Te}return{type:"image",raw:fe,href:X,title:le,text:d(de)}}function W(Ee,$e){var fe=Ee.match(/^(\s+)(?:```)/);if(fe===null)return $e;var Q=fe[1];return $e.split(`
`).map(function(X){var le=X.match(/^\s+/);if(le===null)return X;var de=le[0];return de.length>=Q.length?X.slice(Q.length):X}).join(`
`)}var V=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.space=function(Q){var X=this.rules.block.newline.exec(Q);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},$e.code=function(Q){var X=this.rules.block.code.exec(Q);if(X){var le=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},$e.fences=function(Q){var X=this.rules.block.fences.exec(Q);if(X){var le=X[0],de=W(le,X[3]||"");return{type:"code",raw:le,lang:X[2]?X[2].trim():X[2],text:de}}},$e.heading=function(Q){var X=this.rules.block.heading.exec(Q);if(X){var le=X[2].trim();if(/#$/.test(le)){var de=f(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:le,tokens:this.lexer.inline(le)}}},$e.hr=function(Q){var X=this.rules.block.hr.exec(Q);if(X)return{type:"hr",raw:X[0]}},$e.blockquote=function(Q){var X=this.rules.block.blockquote.exec(Q);if(X){var le=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},$e.list=function(Q){var X=this.rules.block.list.exec(Q);if(X){var le,de,Te,he,Ce,Me,ze,z,L,G,H,ee,se=X[1].trim(),Oe=se.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(X=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if(le=X[0],Q=Q.substring(le.length),z=X[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(he=2,H=z.trimLeft()):(he=X[2].search(/[^ ]/),he=he>4?1:he,H=z.slice(he),he+=X[1].length),Me=!1,!z&&/^ *$/.test(L)&&(le+=L+`
`,Q=Q.substring(L.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(G=Q.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(z)||tt.test(z)||xe.test(z)||_e.test(Q)));){if(z.search(/[^ ]/)>=he||!z.trim())H+=`
`+z.slice(he);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),le+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(H),de&&(Te=de[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!de,checked:Te,loose:!1,text:H}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),ft=ct.every(function(Ue){for(var st=Ue.raw.split(""),Z=0,Y=O(st),me;!(me=Y()).done;){var He=me.value;if(He===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ct.length&&ft&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},$e.html=function(Q){var X=this.rules.block.html.exec(Q);if(X){var le={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(X[0]):d(X[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},$e.def=function(Q){var X=this.rules.block.def.exec(Q);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var le=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:X[0],href:X[2],title:X[3]}}},$e.table=function(Q){var X=this.rules.block.table.exec(Q);if(X){var le={type:"table",header:D(X[1]).map(function(ze){return{text:ze}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=X[0];var de=le.align.length,Te,he,Ce,Me;for(Te=0;Te<de;Te++)/^ *-+: *$/.test(le.align[Te])?le.align[Te]="right":/^ *:-+: *$/.test(le.align[Te])?le.align[Te]="center":/^ *:-+ *$/.test(le.align[Te])?le.align[Te]="left":le.align[Te]=null;for(de=le.rows.length,Te=0;Te<de;Te++)le.rows[Te]=D(le.rows[Te],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,he=0;he<de;he++)le.header[he].tokens=this.lexer.inline(le.header[he].text);for(de=le.rows.length,he=0;he<de;he++)for(Me=le.rows[he],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return le}}},$e.lheading=function(Q){var X=this.rules.block.lheading.exec(Q);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},$e.paragraph=function(Q){var X=this.rules.block.paragraph.exec(Q);if(X){var le=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:le,tokens:this.lexer.inline(le)}}},$e.text=function(Q){var X=this.rules.block.text.exec(Q);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},$e.escape=function(Q){var X=this.rules.inline.escape.exec(Q);if(X)return{type:"escape",raw:X[0],text:d(X[1])}},$e.tag=function(Q){var X=this.rules.inline.tag.exec(Q);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):d(X[0]):X[0]}},$e.link=function(Q){var X=this.rules.inline.link.exec(Q);if(X){var le=X[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=f(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Te=S(X[2],"()");if(Te>-1){var he=X[0].indexOf("!")===0?5:4,Ce=he+X[1].length+Te;X[2]=X[2].substring(0,Te),X[0]=X[0].substring(0,Ce).trim(),X[3]=""}}var Me=X[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=X[3]?X[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(le)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(X,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},$e.reflink=function(Q,X){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=X[de.toLowerCase()],!de||!de.href){var Te=le[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(le,de,le[0],this.lexer)}},$e.emStrong=function(Q,X,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(Q);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=de[1]||de[2]||"";if(!Te||Te&&(le===""||this.rules.inline.punctuation.exec(le))){var he=de[0].length-1,Ce,Me,ze=he,z=0,L=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,X=X.slice(-1*Q.length+he);(de=L.exec(X))!=null;)if(Ce=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ce){if(Me=Ce.length,de[3]||de[4]){ze+=Me;continue}else if((de[5]||de[6])&&he%3&&!((he+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(he,Me)%2){var G=Q.slice(1,he+de.index+Me);return{type:"em",raw:Q.slice(0,he+de.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,he+de.index+Me-1);return{type:"strong",raw:Q.slice(0,he+de.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(Q){var X=this.rules.inline.code.exec(Q);if(X){var le=X[2].replace(/\n/g," "),de=/[^ ]/.test(le),Te=/^ /.test(le)&&/ $/.test(le);return de&&Te&&(le=le.substring(1,le.length-1)),le=d(le,!0),{type:"codespan",raw:X[0],text:le}}},$e.br=function(Q){var X=this.rules.inline.br.exec(Q);if(X)return{type:"br",raw:X[0]}},$e.del=function(Q){var X=this.rules.inline.del.exec(Q);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},$e.autolink=function(Q,X){var le=this.rules.inline.autolink.exec(Q);if(le){var de,Te;return le[2]==="@"?(de=d(this.options.mangle?X(le[1]):le[1]),Te="mailto:"+de):(de=d(le[1]),Te=de),{type:"link",raw:le[0],text:de,href:Te,tokens:[{type:"text",raw:de,text:de}]}}},$e.url=function(Q,X){var le;if(le=this.rules.inline.url.exec(Q)){var de,Te;if(le[2]==="@")de=d(this.options.mangle?X(le[0]):le[0]),Te="mailto:"+de;else{var he;do he=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(he!==le[0]);de=d(le[0]),le[1]==="www."?Te="http://"+de:Te=de}return{type:"link",raw:le[0],text:de,href:Te,tokens:[{type:"text",raw:de,text:de}]}}},$e.inlineText=function(Q,X){var le=this.rules.inline.text.exec(Q);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):d(le[0]):le[0]:de=d(this.options.smartypants?X(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=r(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=r(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=r(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=r(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=r(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=r(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:r(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=r(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=r(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=r(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=r(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=r(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=r(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=r(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=r(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=r(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=r(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=r(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=l({},A),A.pedantic=l({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=l({},A.normal,{escape:r(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=r(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=l({},A.gfm,{br:r(A.br).replace("{2,}","*").getRegex(),text:r(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var $e="",fe,Q,X=Ee.length;for(fe=0;fe<X;fe++)Q=Ee.charCodeAt(fe),Math.random()>.5&&(Q="x"+Q.toString(16)),$e+="&#"+Q+";";return $e}var ie=function(){function Ee(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}Ee.lex=function(Q,X){var le=new Ee(X);return le.lex(Q)},Ee.lexInline=function(Q,X){var le=new Ee(X);return le.inlineTokens(Q)};var $e=Ee.prototype;return $e.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},$e.blockTokens=function(Q,X){var le=this;X===void 0&&(X=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var de,Te,he,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},Q,X))?(Q=Q.substring(de.raw.length),X.push(de),!0):!1}))){if(de=this.tokenizer.space(Q)){Q=Q.substring(de.raw.length),de.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(de);continue}if(de=this.tokenizer.code(Q)){Q=Q.substring(de.raw.length),Te=X[X.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(de);continue}if(de=this.tokenizer.fences(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.heading(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.hr(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.blockquote(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.list(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.html(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.def(Q)){Q=Q.substring(de.raw.length),Te=X[X.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.lheading(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=Q.slice(1),L=void 0;le.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(he=Q.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(he))){Te=X[X.length-1],Ce&&Te.type==="paragraph"?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(de),Ce=he.length!==Q.length,Q=Q.substring(de.raw.length);continue}if(de=this.tokenizer.text(Q)){Q=Q.substring(de.raw.length),Te=X[X.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(de);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,X},$e.inline=function(Q,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:Q,tokens:X}),X},$e.inlineTokens=function(Q,X){var le=this;X===void 0&&(X=[]);var de,Te,he,Ce=Q,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(de=H.call({lexer:le},Q,X))?(Q=Q.substring(de.raw.length),X.push(de),!0):!1}))){if(de=this.tokenizer.escape(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.tag(Q)){Q=Q.substring(de.raw.length),Te=X[X.length-1],Te&&de.type==="text"&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):X.push(de);continue}if(de=this.tokenizer.link(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(de.raw.length),Te=X[X.length-1],Te&&de.type==="text"&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):X.push(de);continue}if(de=this.tokenizer.emStrong(Q,Ce,z)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.codespan(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.br(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.del(Q)){Q=Q.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.autolink(Q,K)){Q=Q.substring(de.raw.length),X.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(Q,K))){Q=Q.substring(de.raw.length),X.push(de);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),se=void 0;le.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(he=Q.substring(0,H+1))}(),de=this.tokenizer.inlineText(he,U)){Q=Q.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(z=de.raw.slice(-1)),ze=!0,Te=X[X.length-1],Te&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):X.push(de);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return X},I(Ee,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),Ee}(),ce=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.code=function(Q,X,le){var de=(X||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Q,de);Te!=null&&Te!==Q&&(le=!0,Q=Te)}return Q=Q.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+d(de,!0)+'">'+(le?Q:d(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:d(Q,!0))+`</code></pre>
`},$e.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},$e.html=function(Q){return Q},$e.heading=function(Q,X,le,de){if(this.options.headerIds){var Te=this.options.headerPrefix+de.slug(le);return"<h"+X+' id="'+Te+'">'+Q+"</h"+X+`>
`}return"<h"+X+">"+Q+"</h"+X+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(Q,X,le){var de=X?"ol":"ul",Te=X&&le!==1?' start="'+le+'"':"";return"<"+de+Te+`>
`+Q+"</"+de+`>
`},$e.listitem=function(Q){return"<li>"+Q+`</li>
`},$e.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(Q){return"<p>"+Q+`</p>
`},$e.table=function(Q,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+X+`</table>
`},$e.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},$e.tablecell=function(Q,X){var le=X.header?"th":"td",de=X.align?"<"+le+' align="'+X.align+'">':"<"+le+">";return de+Q+("</"+le+`>
`)},$e.strong=function(Q){return"<strong>"+Q+"</strong>"},$e.em=function(Q){return"<em>"+Q+"</em>"},$e.codespan=function(Q){return"<code>"+Q+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(Q){return"<del>"+Q+"</del>"},$e.link=function(Q,X,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<a href="'+d(Q)+'"';return X&&(de+=' title="'+X+'"'),de+=">"+le+"</a>",de},$e.image=function(Q,X,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<img src="'+Q+'" alt="'+le+'"';return X&&(de+=' title="'+X+'"'),de+=this.options.xhtml?"/>":">",de},$e.text=function(Q){return Q},Ee}(),we=function(){function Ee(){}var $e=Ee.prototype;return $e.strong=function(Q){return Q},$e.em=function(Q){return Q},$e.codespan=function(Q){return Q},$e.del=function(Q){return Q},$e.html=function(Q){return Q},$e.text=function(Q){return Q},$e.link=function(Q,X,le){return""+le},$e.image=function(Q,X,le){return""+le},$e.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var $e=Ee.prototype;return $e.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(Q,X){var le=Q,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[Q];do de++,le=Q+"-"+de;while(this.seen.hasOwnProperty(le))}return X||(this.seen[Q]=de,this.seen[le]=0),le},$e.slug=function(Q,X){X===void 0&&(X={});var le=this.serialize(Q);return this.getNextSafeSlug(le,X.dryrun)},Ee}(),ue=function(){function Ee(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Ie}Ee.parse=function(Q,X){var le=new Ee(X);return le.parse(Q)},Ee.parseInline=function(Q,X){var le=new Ee(X);return le.parseInline(Q)};var $e=Ee.prototype;return $e.parse=function(Q,X){X===void 0&&(X=!0);var le="",de,Te,he,Ce,Me,ze,z,L,G,H,ee,se,Oe,Be,Qe,xe,_e,et,tt,nt=Q.length;for(de=0;de<nt;de++){if(H=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Ce=H.header.length,Te=0;Te<Ce;Te++)z+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(L+=this.renderer.tablerow(z),G="",Ce=H.rows.length,Te=0;Te<Ce;Te++){for(ze=H.rows[Te],z="",Me=ze.length,he=0;he<Me;he++)z+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:H.align[he]});G+=this.renderer.tablerow(z)}le+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,se=H.start,Oe=H.loose,Ce=H.items.length,G="",Te=0;Te<Ce;Te++)Qe=H.items[Te],xe=Qe.checked,_e=Qe.task,Be="",Qe.task&&(et=this.renderer.checkbox(xe),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(Qe.tokens,Oe),G+=this.renderer.listitem(Be,_e,xe);le+=this.renderer.list(G,ee,se);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;de+1<nt&&Q[de+1].type==="text";)H=Q[++de],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=X?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return le},$e.parseInline=function(Q,X){X=X||this.renderer;var le="",de,Te,he,Ce=Q.length;for(de=0;de<Ce;de++){if(Te=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(he=this.options.extensions.renderers[Te.type].call({parser:this},Te),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){le+=he||"";continue}switch(Te.type){case"escape":{le+=X.text(Te.text);break}case"html":{le+=X.html(Te.text);break}case"link":{le+=X.link(Te.href,Te.title,this.parseInline(Te.tokens,X));break}case"image":{le+=X.image(Te.href,Te.title,Te.text);break}case"strong":{le+=X.strong(this.parseInline(Te.tokens,X));break}case"em":{le+=X.em(this.parseInline(Te.tokens,X));break}case"codespan":{le+=X.codespan(Te.text);break}case"br":{le+=X.br();break}case"del":{le+=X.del(this.parseInline(Te.tokens,X));break}case"text":{le+=X.text(Te.text);break}default:{var Me='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return le},Ee}();function pe(Ee,$e,fe){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=l({},pe.defaults,$e||{}),y($e),fe){var Q=$e.highlight,X;try{X=ie.lex(Ee,$e)}catch(Ce){return fe(Ce)}var le=function(Me){var ze;if(!Me)try{$e.walkTokens&&pe.walkTokens(X,$e.walkTokens),ze=ue.parse(X,$e)}catch(z){Me=z}return $e.highlight=Q,Me?fe(Me):fe(null,ze)};if(!Q||Q.length<3||(delete $e.highlight,!X.length))return le();var de=0;pe.walkTokens(X,function(Ce){Ce.type==="code"&&(de++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Me,ze){if(Me)return le(Me);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Te(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Ce.message+"",!0)+"</pre>";throw Ce}try{var he=ie.lex(Ee,$e);if($e.walkTokens){if($e.async)return Promise.all(pe.walkTokens(he,$e.walkTokens)).then(function(){return ue.parse(he,$e)}).catch(Te);pe.walkTokens(he,$e.walkTokens)}return ue.parse(he,$e)}catch(Ce){Te(Ce)}}pe.options=pe.setOptions=function(Ee){return l(pe.defaults,Ee),m(pe.defaults),pe},pe.getDefaults=M,pe.defaults=ge.defaults,pe.use=function(){for(var Ee=arguments.length,$e=new Array(Ee),fe=0;fe<Ee;fe++)$e[fe]=arguments[fe];var Q=l.apply(void 0,[{}].concat($e)),X=pe.defaults.extensions||{renderers:{},childTokens:{}},le;$e.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=X.renderers?X.renderers[he.name]:null;Ce?X.renderers[he.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=he.renderer.apply(this,ze);return L===!1&&(L=Ce.apply(this,ze)),L}:X.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[he.level]?X[he.level].unshift(he.tokenizer):X[he.level]=[he.tokenizer],he.start&&(he.level==="block"?X.startBlock?X.startBlock.push(he.start):X.startBlock=[he.start]:he.level==="inline"&&(X.startInline?X.startInline.push(he.start):X.startInline=[he.start]))}he.childTokens&&(X.childTokens[he.name]=he.childTokens)})),de.renderer&&function(){var he=pe.defaults.renderer||new ce,Ce=function(z){var L=he[z];he[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=de.renderer[z].apply(he,H);return se===!1&&(se=L.apply(he,H)),se}};for(var Me in de.renderer)Ce(Me);Q.renderer=he}(),de.tokenizer&&function(){var he=pe.defaults.tokenizer||new V,Ce=function(z){var L=he[z];he[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=de.tokenizer[z].apply(he,H);return se===!1&&(se=L.apply(he,H)),se}};for(var Me in de.tokenizer)Ce(Me);Q.tokenizer=he}(),de.walkTokens){var Te=pe.defaults.walkTokens;Q.walkTokens=function(he){var Ce=[];return Ce.push(de.walkTokens.call(this,he)),Te&&(Ce=Ce.concat(Te.call(this,he))),Ce}}le&&(Q.extensions=X),pe.setOptions(Q)})},pe.walkTokens=function(Ee,$e){for(var fe=[],Q=function(){var Te=le.value;switch(fe=fe.concat($e.call(pe,Te)),Te.type){case"table":{for(var he=O(Te.header),Ce;!(Ce=he()).done;){var Me=Ce.value;fe=fe.concat(pe.walkTokens(Me.tokens,$e))}for(var ze=O(Te.rows),z;!(z=ze()).done;)for(var L=z.value,G=O(L),H;!(H=G()).done;){var ee=H.value;fe=fe.concat(pe.walkTokens(ee.tokens,$e))}break}case"list":{fe=fe.concat(pe.walkTokens(Te.items,$e));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Te.type]?pe.defaults.extensions.childTokens[Te.type].forEach(function(se){fe=fe.concat(pe.walkTokens(Te[se],$e))}):Te.tokens&&(fe=fe.concat(pe.walkTokens(Te.tokens,$e)))}},X=O(Ee),le;!(le=X()).done;)Q();return fe},pe.parseInline=function(Ee,$e){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");$e=l({},pe.defaults,$e||{}),y($e);try{var fe=ie.lexInline(Ee,$e);return $e.walkTokens&&pe.walkTokens(fe,$e.walkTokens),ue.parseInline(fe,$e)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Q.message+"",!0)+"</pre>";throw Q}},pe.Parser=ue,pe.parser=ue.parse,pe.Renderer=ce,pe.TextRenderer=we,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=V,pe.Slugger=Ie,pe.parse=pe;var re=pe.options,Se=pe.setOptions,Le=pe.use,ne=pe.walkTokens,j=pe.parseInline,x=pe,ve=ue.parse,Ne=ie.lex;ge.Lexer=ie,ge.Parser=ue,ge.Renderer=ce,ge.Slugger=Ie,ge.TextRenderer=we,ge.Tokenizer=V,ge.getDefaults=M,ge.lexer=Ne,ge.marked=pe,ge.options=re,ge.parse=x,ge.parseInline=j,ge.parser=ve,ge.setOptions=Se,ge.use=Le,ge.walkTokens=ne,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Re[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=I;function I(n){const o=O(n);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const R=new Uint32Array(10);function O(n){if(N=0,M(n,k,4352),N>0||(M(n,u,4449),N>0)||(M(n,b,4520),N>0)||(M(n,d,12593),N))return R.subarray(0,N);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,r=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(r<k.length?M(r,k,0):4352+r-12593<d.length&&M(4352+r,d,12593),i<u.length?M(i,u,0):4449+i-12593<d.length&&M(4449+i-12593,d,12593),a>=0&&(a<b.length?M(a,b,0):4520+a-12593<d.length&&M(4520+a-12593,d,12593)),N>0)return R.subarray(0,N)}}function M(n,o,s){n>=s&&n<s+o.length&&m(o[n-s])}function m(n){n!==0&&(R[N++]=n&255,n>>8&&(R[N++]=n>>8&255),n>>16&&(R[N++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var E;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(E||(E={}));var T;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(T||(T={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=I,e.rot=N;function I(m,g,E){return Math.min(Math.max(m,g),E)}function N(m,g){return(g+m%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$um=R;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=O;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const E=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=M}),function(){function ge(R){const O=[];typeof R=="number"&&O.push("code/timeOrigin",R);function M(g){O.push(g,Date.now())}function m(){const g=[];for(let E=0;E<O.length;E+=2)g.push({name:O[E],startTime:O[E+1]});return g}return{mark:M,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(R+M.startTime)});return O}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Re[127],Ae([1,0,46]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=void 0;const N=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(g,E,T){this.d(g,k=>k._value=E,T)}mutate(g,E){this.d(g,T=>T._value=E(T._value===N?void 0:T._value))}delete(g){const E=this.c(g);if(!E)return;let T=E.length-1;const k=E[T].node._value;if(k!==N){for(this.b--,E[T].node._value=N;T>0;T--){const{node:u,part:b}=E[T];if(u.children?.size||u._value!==N)break;E[T-1].node.children.delete(b)}return k}}*deleteRecursive(g){const E=this.c(g);if(!E)return;const T=E[E.length-1].node;for(let k=E.length-1;k>0;k--){const u=E[k-1];if(u.node.children.delete(E[k].part),u.node.children.size>0||u.node._value!==N)break}for(const k of O(T))k._value!==N&&(this.b--,yield k._value)}find(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return;E=k}return E._value===N?void 0:E._value}hasKeyOrParent(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;if(k._value!==N)return!0;E=k}return!1}hasKeyOrChildren(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;E=k}return!0}hasKey(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;E=k}return E._value!==N}c(g){const E=[{part:"",node:this.a}];let T=0;for(const k of g){const u=E[T].node.children?.get(k);if(!u)return;E.push({part:k,node:u}),T++}return E}d(g,E,T){let k=this.a;for(const d of g){if(k.children)if(k.children.has(d))k=k.children.get(d);else{const n=new M;k.children.set(d,n),k=n}else{const n=new M;k.children=new Map([[d,n]]),k=n}T?.(k)}const u=k._value===N?0:1;E(k);const b=k._value===N?0:1;this.b+=b-u}*values(){for(const{_value:g}of O(this.a))g!==N&&(yield g)}}e.$YO=R;function*O(m){const g=[m];for(;g.length>0;){const E=g.pop();if(yield E,E.children)for(const T of E.children.values())g.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(g){this._value=g===void 0?N:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:ge)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return ge[N].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(N,R,O){I.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:O})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,R){if(1&R&&(N=I(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var M in N)I.d(O,M,function(m){return N[m]}.bind(null,M));return O},I.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(R,"a",R),R},I.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(N){var R;e=ge.exports=Le,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],E=0,T=E++;g[T]="0|[1-9]\\d*";var k=E++;g[k]="[0-9]+";var u=E++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;g[b]="("+g[T]+")\\.("+g[T]+")\\.("+g[T]+")";var d=E++;g[d]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var n=E++;g[n]="(?:"+g[T]+"|"+g[u]+")";var o=E++;g[o]="(?:"+g[k]+"|"+g[u]+")";var s=E++;g[s]="(?:-("+g[n]+"(?:\\."+g[n]+")*))";var r=E++;g[r]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var i=E++;g[i]="[0-9A-Za-z-]+";var a=E++;g[a]="(?:\\+("+g[i]+"(?:\\."+g[i]+")*))";var h=E++,t="v?"+g[b]+g[s]+"?"+g[a]+"?";g[h]="^"+t+"$";var v="[v=\\s]*"+g[d]+g[r]+"?"+g[a]+"?",c=E++;g[c]="^"+v+"$";var $=E++;g[$]="((?:<|>)?=?)";var w=E++;g[w]=g[k]+"|x|X|\\*";var p=E++;g[p]=g[T]+"|x|X|\\*";var l=E++;g[l]="[v=\\s]*("+g[p]+")(?:\\.("+g[p]+")(?:\\.("+g[p]+")(?:"+g[s]+")?"+g[a]+"?)?)?";var D=E++;g[D]="[v=\\s]*("+g[w]+")(?:\\.("+g[w]+")(?:\\.("+g[w]+")(?:"+g[r]+")?"+g[a]+"?)?)?";var f=E++;g[f]="^"+g[$]+"\\s*"+g[l]+"$";var S=E++;g[S]="^"+g[$]+"\\s*"+g[D]+"$";var y=E++;g[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;g[C]="(?:~>?)";var P=E++;g[P]="(\\s*)"+g[C]+"\\s+",m[P]=new RegExp(g[P],"g");var W=E++;g[W]="^"+g[C]+g[l]+"$";var V=E++;g[V]="^"+g[C]+g[D]+"$";var q=E++;g[q]="(?:\\^)";var A=E++;g[A]="(\\s*)"+g[q]+"\\s+",m[A]=new RegExp(g[A],"g");var U=E++;g[U]="^"+g[q]+g[l]+"$";var K=E++;g[K]="^"+g[q]+g[D]+"$";var ie=E++;g[ie]="^"+g[$]+"\\s*("+v+")$|^$";var ce=E++;g[ce]="^"+g[$]+"\\s*("+t+")$|^$";var we=E++;g[we]="(\\s*)"+g[$]+"\\s*("+v+"|"+g[l]+")",m[we]=new RegExp(g[we],"g");var Ie=E++;g[Ie]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var ue=E++;g[ue]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var pe=E++;g[pe]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)R(re,g[re]),m[re]||(m[re]=new RegExp(g[re]));function Se(L,G){if(L instanceof Le)return L;if(typeof L!="string"||L.length>O||!(G?m[c]:m[h]).test(L))return null;try{return new Le(L,G)}catch{return null}}function Le(L,G){if(L instanceof Le){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Le))return new Le(L,G);R("SemVer",L,G),this.loose=G;var H=L.trim().match(G?m[c]:m[h]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<M)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Se,e.valid=function(L,G){var H=Se(L,G);return H?H.version:null},e.clean=function(L,G){var H=Se(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Le,Le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Le.prototype.toString=function(){return this.version},Le.prototype.compare=function(L){return R("SemVer.compare",this.version,this.loose,L),L instanceof Le||(L=new Le(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Le.prototype.compareMain=function(L){return L instanceof Le||(L=new Le(L,this.loose)),j(this.major,L.major)||j(this.minor,L.minor)||j(this.patch,L.patch)},Le.prototype.comparePre=function(L){if(L instanceof Le||(L=new Le(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=L.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return j(H,ee)}while(++G)},Le.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Le(L,H).inc(G,ee).version}catch{return null}},e.diff=function(L,G){if(Ee(L,G))return null;var H=Se(L),ee=Se(G);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=j;var ne=/^[0-9]+$/;function j(L,G){var H=ne.test(L),ee=ne.test(G);return H&&ee&&(L=+L,G=+G),H&&!ee?-1:ee&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Le(L,H).compare(new Le(G,H))}function ve(L,G,H){return x(L,G,H)>0}function Ne(L,G,H){return x(L,G,H)<0}function Ee(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function fe(L,G,H){return x(L,G,H)>=0}function Q(L,G,H){return x(L,G,H)<=0}function X(L,G,H,ee){var se;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L!==H;break;case"":case"=":case"==":se=Ee(L,H,ee);break;case"!=":se=$e(L,H,ee);break;case">":se=ve(L,H,ee);break;case">=":se=fe(L,H,ee);break;case"<":se=Ne(L,H,ee);break;case"<=":se=Q(L,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return se}function le(L,G){if(L instanceof le){if(L.loose===G)return L;L=L.value}if(!(this instanceof le))return new le(L,G);R("comparator",L,G),this.loose=G,this.parse(L),this.semver===de?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(L,G){return j(G,L)},e.major=function(L,G){return new Le(L,G).major},e.minor=function(L,G){return new Le(L,G).minor},e.patch=function(L,G){return new Le(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(L,G){return L.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=ve,e.lt=Ne,e.eq=Ee,e.neq=$e,e.gte=fe,e.lte=Q,e.cmp=X,e.Comparator=le;var de={};function Te(L,G){if(L instanceof Te)return L.loose===G?L:new Te(L.raw,G);if(L instanceof le)return new Te(L.value,G);if(!(this instanceof Te))return new Te(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function he(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,G,H,ee,se,Oe,Be,Qe,xe,_e,et,tt,nt){return((G=he(H)?"":he(ee)?">="+H+".0.0":he(se)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=he(xe)?"":he(_e)?"<"+(+xe+1)+".0.0":he(et)?"<"+xe+"."+(+_e+1)+".0":tt?"<="+xe+"."+_e+"."+et+"-"+tt:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(R(L[H].semver),L[H].semver!==de&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Te(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,ee){var se,Oe,Be,Qe,xe;switch(L=new Le(L,ee),G=new Te(G,ee),H){case">":se=ve,Oe=Q,Be=Ne,Qe=">",xe=">=";break;case"<":se=Ne,Oe=fe,Be=ve,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,ee))return!1;for(var _e=0;_e<G.set.length;++_e){var et=G.set[_e],tt=null,nt=null;if(et.forEach(function(ct){ct.semver===de&&(ct=new le(">=0.0.0")),tt=tt||ct,nt=nt||ct,se(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,nt.semver,ee)&&(nt=ct)}),tt.operator===Qe||tt.operator===xe||(!nt.operator||nt.operator===Qe)&&Oe(L,nt.semver)||nt.operator===xe&&Be(L,nt.semver))return!1}return!0}le.prototype.parse=function(L){var G=this.loose?m[ie]:m[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Le(H[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(L){return R("Comparator.test",L,this.loose),this.semver===de||(typeof L=="string"&&(L=new Le(L,this.loose)),X(L,this.operator,this.semver,this.loose))},le.prototype.intersects=function(L,G){if(!(L instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Te(this.value,G),ze(L.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Oe=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=X(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),xe=X(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||se||Oe&&Be||Qe||xe},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),R("range",L,G);var H=G?m[ue]:m[Ie];L=L.replace(H,Ce),R("hyphen replace",L),L=L.replace(m[we],"$1$2$3"),R("comparator trim",L,m[we]),L=(L=(L=L.replace(m[P],"$1~")).replace(m[A],"$1^")).split(/\s+/).join(" ");var ee=G?m[ie]:m[ce],se=L.split(" ").map(function(Oe){return function(Be,Qe){return R("comp",Be),Be=function(xe,_e){return xe.trim().split(/\s+/).map(function(et){return function(tt,nt){R("caret",tt,nt);var ct=nt?m[K]:m[U];return tt.replace(ct,function(ft,Ue,st,Z,Y){var me;return R("caret",tt,ft,Ue,st,Z,Y),he(Ue)?me="":he(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":he(Z)?me=Ue==="0"?">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+".0 <"+(+Ue+1)+".0.0":Y?(R("replaceCaret pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+Y+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+Y+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+Y+" <"+(+Ue+1)+".0.0"):(R("no pr"),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+" <"+(+Ue+1)+".0.0"),R("caret return",me),me})}(et,_e)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(xe,_e){return xe.trim().split(/\s+/).map(function(et){return function(tt,nt){var ct=nt?m[V]:m[W];return tt.replace(ct,function(ft,Ue,st,Z,Y){var me;return R("tilde",tt,ft,Ue,st,Z,Y),he(Ue)?me="":he(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":he(Z)?me=">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":Y?(R("replaceTilde pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),me=">="+Ue+"."+st+"."+Z+Y+" <"+Ue+"."+(+st+1)+".0"):me=">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0",R("tilde return",me),me})}(et,_e)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(xe,_e){return R("replaceXRanges",xe,_e),xe.split(/\s+/).map(function(et){return function(tt,nt){tt=tt.trim();var ct=nt?m[S]:m[f];return tt.replace(ct,function(ft,Ue,st,Z,Y,me){R("xRange",tt,ft,Ue,st,Z,Y,me);var He=he(st),ye=He||he(Z),ot=ye||he(Y);return Ue==="="&&ot&&(Ue=""),He?ft=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&ot?(ye&&(Z=0),ot&&(Y=0),Ue===">"?(Ue=">=",ye?(st=+st+1,Z=0,Y=0):ot&&(Z=+Z+1,Y=0)):Ue==="<="&&(Ue="<",ye?st=+st+1:Z=+Z+1),ft=Ue+st+"."+Z+"."+Y):ye?ft=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(ft=">="+st+"."+Z+".0 <"+st+"."+(+Z+1)+".0"),R("xRange return",ft),ft})}(et,_e)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(xe,_e){return R("replaceStars",xe,_e),xe.trim().replace(m[pe],"")}(Be,Qe),R("stars",Be),Be}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(ee)})),se=se.map(function(Oe){return new le(Oe,G)})},Te.prototype.intersects=function(L,G){if(!(L instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(se){return se.every(function(Oe){return ee.intersects(Oe,G)})})})})},e.toComparators=function(L,G){return new Te(L,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Le(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var ee=null,se=null;try{var Oe=new Te(G,H)}catch{return null}return L.forEach(function(Be){Oe.test(Be)&&(ee&&se.compare(Be)!==-1||(se=new Le(ee=Be,H)))}),ee},e.minSatisfying=function(L,G,H){var ee=null,se=null;try{var Oe=new Te(G,H)}catch{return null}return L.forEach(function(Be){Oe.test(Be)&&(ee&&se.compare(Be)!==1||(se=new Le(ee=Be,H)))}),ee},e.validRange=function(L,G){try{return new Te(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Se(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Te(L,H),G=new Te(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Le)return L;if(typeof L!="string")return null;var G=L.match(m[y]);return G==null?null:Se((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,N,R=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function m(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var g,E=[],T=!1,k=-1;function u(){T&&g&&(T=!1,g.length?E=g.concat(E):k=-1,E.length&&b())}function b(){if(!T){var o=m(u);T=!0;for(var s=E.length;s;){for(g=E,E=[];++k<s;)g&&g[k].run();k=-1,s=E.length}g=null,T=!1,function(r){if(N===clearTimeout)return clearTimeout(r);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(r);try{N(r)}catch{try{return N.call(null,r)}catch{return N.call(this,r)}}}(o)}}function d(o,s){this.fun=o,this.array=s}function n(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)s[r-1]=arguments[r];E.push(new d(o,s)),E.length!==1||T||m(b)},d.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=n,R.addListener=n,R.once=n,R.off=n,R.removeListener=n,R.removeAllListeners=n,R.emit=n,R.prependListener=n,R.prependOnceListener=n,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Re[128],Ae([1,0,14,6]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=R,e.$le=O,e.$me=M,e.$ne=m,e.$oe=E,e.$pe=T,e.$qe=k,e.$re=u,e.$se=b,e.$te=d,e.$ue=n,e.$ve=o,e.$we=s,e.$xe=r,e.$ye=i;function R(a){const h=a;return h?typeof h.read=="function":!1}function O(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function M(a){const h=a;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(a,h){return new g(a,h)}class g{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const c=v.indexOf(t);c>=0&&v.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,h){const t=[];let v;for(;(v=a.read())!==null;)t.push(v);return h(t)}function T(a,h,t){const v=[];let c;for(;(c=a.read())!==null&&v.length<t;)v.push(c);return c===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function k(a,h){return new Promise((t,v)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?v($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function b(a,h){return new Promise((t,v)=>{const c=new N.$Tc,$=[],w=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),v(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,N.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,N.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,N.$Sc)(()=>a.removeListener("data",w))),a.on("data",w)})}function d(a,h){const t=m(h);return t.end(a),t}function n(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const v=m(t);return u(a,{onData:c=>v.write(h.data(c)),onError:c=>v.error(h.error?h.error(c):c),onEnd:()=>v.end()}),v}function r(a,h,t){let v=!1;return{read:()=>{const c=h.read();return v?c:(v=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let v=!1;const c=m(t);return u(h,{onData:$=>v?c.write($):(v=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{v||(v=!0,c.write(a)),c.end()}}),c}}),define(Re[22],Ae([1,0,40,128]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=E,e.$Be=T,e.$Ce=k,e.$De=u,e.$Ee=b,e.$Fe=d,e.$Ge=n,e.$He=o,e.$Ie=s,e.$Je=r,e.$Ke=i,e.$Le=a,e.$Me=h,e.$Ne=t,e.$Oe=v,e.$Pe=c,e.$Qe=$,e.$Re=w,e.$Se=p,e.$Te=f;const R=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let M,m;class g{static alloc(y){return R?new g(Buffer.allocUnsafe(y)):new g(new Uint8Array(y))}static wrap(y){return R&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new g(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(y)):(M||(M=new TextEncoder),new g(M.encode(y)))}static fromByteArray(y){const C=g.alloc(y.length);for(let P=0,W=y.length;P<W;P++)C.buffer[P]=y[P];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let V=0,q=y.length;V<q;V++)C+=y[V].byteLength}const P=g.alloc(C);let W=0;for(let V=0,q=y.length;V<q;V++){const A=y[V];P.set(A,W),W+=A.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=g.alloc(this.byteLength);return y.set(this),y}toString(){return R?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,C){return new g(this.buffer.subarray(y,C))}set(y,C){if(y instanceof g)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){b(this.buffer,y,C)}readUInt32LE(y){return d(this.buffer,y)}writeUInt32LE(y,C){n(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof g?y.buffer:y,C)}}e.$ze=g;function E(S,y,C=0){const P=y.byteLength,W=S.byteLength;if(P===0)return 0;if(P===1)return S.indexOf(y[0]);if(P>W-C)return-1;const V=O.value;V.fill(y.length);for(let K=0;K<y.length;K++)V[y[K]]=y.length-K-1;let q=C+y.length-1,A=q,U=-1;for(;q<W;)if(S[q]===y[A]){if(A===0){U=q;break}q--,A--}else q+=Math.max(y.length-A,V[S[q]]),A=y.length-1;return U}function T(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function k(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function b(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function d(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function n(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function o(S,y){return S[y]}function s(S,y,C){S[C]=y}function r(S){return N.$oe(S,y=>g.concat(y))}function i(S){return N.$ve(S)}function a(S){return N.$qe(S,y=>g.concat(y))}async function h(S){return S.ended?g.concat(S.buffer):g.concat([...S.buffer,await a(S.stream)])}function t(S){return N.$te(S,y=>g.concat(y))}function v(S){return N.$we(S,{data:y=>typeof y=="string"?g.fromString(y):g.wrap(y)},y=>g.concat(y))}function c(S){return N.$ne(y=>g.concat(y),S)}function $(S,y){return N.$xe(S,y,C=>g.concat(C))}function w(S,y){return N.$ye(S,y,C=>g.concat(C))}function p(S){let y=0,C=0,P=0;const W=new Uint8Array(Math.floor(S.length/4*3)),V=A=>{switch(C){case 3:W[P++]=y|A,C=0;break;case 2:W[P++]=y|A>>>2,y=A<<6,C=3;break;case 1:W[P++]=y|A>>>4,y=A<<4,C=2;break;default:y=A<<2,C=1}};for(let A=0;A<S.length;A++){const U=S.charCodeAt(A);if(U>=65&&U<=90)V(U-65);else if(U>=97&&U<=122)V(U-97+26);else if(U>=48&&U<=57)V(U-48+52);else if(U===43||U===45)V(62);else if(U===47||U===95)V(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${S[A]}`)}}const q=P;for(;C>0;)V(0);return g.wrap(W).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:S},y=!0,C=!1){const P=C?D:l;let W="";const V=S.byteLength%3;let q=0;for(;q<S.byteLength-V;q+=3){const A=S[q+0],U=S[q+1],K=S[q+2];W+=P[A>>>2],W+=P[(A<<4|U>>>4)&63],W+=P[(U<<2|K>>>6)&63],W+=P[K&63]}if(V===1){const A=S[q+0];W+=P[A>>>2],W+=P[A<<4&63],y&&(W+="==")}else if(V===2){const A=S[q+0],U=S[q+1];W+=P[A>>>2],W+=P[(A<<4|U>>>4)&63],W+=P[U<<2&63],y&&(W+="=")}return W}}),define(Re[129],Ae([1,0,28,125,15]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.FuzzyScore=e.$pk=e.$ok=void 0,e.or=O,e.$qk=m,e.$rk=g,e.$sk=k,e.$tk=p,e.$uk=l,e.$vk=P,e.$wk=W,e.$xk=V,e.$yk=q,e.$zk=x,e.$Bk=$e,e.$Ck=X,e.$Dk=le;function O(...he){return function(Ce,Me){for(let ze=0,z=he.length;ze<z;ze++){const L=he[ze](Ce,Me);if(L)return L}return null}}e.$ok=M.bind(void 0,!1),e.$pk=M.bind(void 0,!0);function M(he,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return he?ze=R.$rf(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(he,Ce){const Me=Ce.toLowerCase().indexOf(he.toLowerCase());return Me===-1?null:[{start:Me,end:Me+he.length}]}function g(he,Ce){return E(he.toLowerCase(),Ce.toLowerCase(),0,0)}function E(he,Ce,Me,ze){if(Me===he.length)return[];if(ze===Ce.length)return null;if(he[Me]===Ce[ze]){let z=null;return(z=E(he,Ce,Me+1,ze+1))?a({start:ze,end:ze+1},z):null}return E(he,Ce,Me,ze+1)}function T(he){return 97<=he&&he<=122}function k(he){return 65<=he&&he<=90}function u(he){return 48<=he&&he<=57}function b(he){return he===32||he===9||he===10||he===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>d.add(he.charCodeAt(0)));function n(he){return b(he)||d.has(he)}function o(he,Ce){return he===Ce||n(he)&&n(Ce)}const s=new Map;function r(he){if(s.has(he))return s.get(he);let Ce;const Me=(0,N.$mk)(he);return Me&&(Ce=Me),s.set(he,Ce),Ce}function i(he){return T(he)||k(he)||u(he)}function a(he,Ce){return Ce.length===0?Ce=[he]:he.end===Ce[0].start?Ce[0].start=he.start:Ce.unshift(he),Ce}function h(he,Ce){for(let Me=Ce;Me<he.length;Me++){const ze=he.charCodeAt(Me);if(k(ze)||u(ze)||Me>0&&!i(he.charCodeAt(Me-1)))return Me}return he.length}function t(he,Ce,Me,ze){if(Me===he.length)return[];if(ze===Ce.length)return null;if(he[Me]!==Ce[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=t(he,Ce,Me+1,ze+1);!z&&(L=h(Ce,L))<Ce.length;)z=t(he,Ce,Me+1,L),L++;return z===null?null:a({start:ze,end:ze+1},z)}}function v(he){let Ce=0,Me=0,ze=0,z=0,L=0;for(let Oe=0;Oe<he.length;Oe++)L=he.charCodeAt(Oe),k(L)&&Ce++,T(L)&&Me++,i(L)&&ze++,u(L)&&z++;const G=Ce/he.length,H=Me/he.length,ee=ze/he.length,se=z/he.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function c(he){const{upperPercent:Ce,lowerPercent:Me}=he;return Me===0&&Ce>.6}function $(he){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=he;return Me>.2&&Ce<.8&&ze>.6&&z<.2}function w(he){let Ce=0,Me=0,ze=0,z=0;for(let L=0;L<he.length;L++)ze=he.charCodeAt(L),k(ze)&&Ce++,T(ze)&&Me++,b(ze)&&z++;return(Ce===0||Me===0)&&z===0?he.length<=30:Ce<=5}function p(he,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!w(he))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=v(Ce);if(!$(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(he=he.toLowerCase();z<Ce.length&&(ze=t(he,Ce,0,z))===null;)z=h(Ce,z+1);return ze}function l(he,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(he=he.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=D(he,Ce,0,z,Me),ze===null);)z=f(Ce,z+1);return ze}function D(he,Ce,Me,ze,z){let L=0;if(Me===he.length)return[];if(ze===Ce.length)return null;if(!o(he.charCodeAt(Me),Ce.charCodeAt(ze))){const ee=r(he.charCodeAt(Me));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ce.charCodeAt(ze+se)))return null;L+=ee.length-1}let G=null,H=ze+L+1;if(G=D(he,Ce,Me+1,H,z),!z)for(;!G&&(H=f(Ce,H))<Ce.length;)G=D(he,Ce,Me+1,H,z),H++;if(!G)return null;if(he.charCodeAt(Me)!==Ce.charCodeAt(ze)){const ee=r(he.charCodeAt(Me));if(!ee)return G;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(ze+se))return G}return a({start:ze,end:ze+L+1},G)}function f(he,Ce){for(let Me=Ce;Me<he.length;Me++)if(n(he.charCodeAt(Me))||Me>0&&n(he.charCodeAt(Me-1)))return Me;return he.length}const S=O(e.$pk,p,m),y=O(e.$pk,p,g),C=new I.$Ec(1e4);function P(he,Ce,Me=!1){if(typeof he!="string"||typeof Ce!="string")return null;let ze=C.get(he);ze||(ze=new RegExp(R.$_e(he),"i"),C.set(he,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Me?y(he,Ce):S(he,Ce)}function W(he,Ce){const Me=$e(he,he.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function V(he,Ce,Me,ze,z,L){const G=Math.min(13,he.length);for(;Me<G;Me++){const H=$e(he,Ce,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(he){if(typeof he>"u")return[];const Ce=[],Me=he[1];for(let ze=he.length-1;ze>1;ze--){const z=he[ze]+Me,L=Ce[Ce.length-1];L&&L.end===z?L.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const A=128;function U(){const he=[],Ce=[];for(let Me=0;Me<=A;Me++)Ce[Me]=0;for(let Me=0;Me<=A;Me++)he.push(Ce.slice(0));return he}function K(he){const Ce=[];for(let Me=0;Me<=he;Me++)Ce[Me]=0;return Ce}const ie=K(2*A),ce=K(2*A),we=U(),Ie=U(),ue=U(),pe=!1;function re(he,Ce,Me,ze,z){function L(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=he[H].slice(0,z+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return G}function Se(he,Ce,Me,ze){he=he.substr(Ce),Me=Me.substr(ze),console.log(re(Ie,he,he.length,Me,Me.length)),console.log(re(ue,he,he.length,Me,Me.length)),console.log(re(we,he,he.length,Me,Me.length))}function Le(he,Ce){if(Ce<0||Ce>=he.length)return!1;const Me=he.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Jf(Me)}}function ne(he,Ce){if(Ce<0||Ce>=he.length)return!1;switch(he.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function j(he,Ce,Me){return Ce[he]!==Me[he]}function x(he,Ce,Me,ze,z,L,G=!1){for(;Ce<Me&&z<L;)he[Ce]===ze[z]&&(G&&(ie[Ce]=z),Ce+=1),z+=1;return Ce===Me}var ve;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ne;(function(he){he.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}he.isDefault=Ce})(Ne||(e.FuzzyScore=Ne={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Ak=Ee;function $e(he,Ce,Me,ze,z,L,G=Ee.default){const H=he.length>A?A:he.length,ee=ze.length>A?A:ze.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Ce,Me,H,z,L,ee,!0))return;fe(H,ee,Me,L,Ce,z);let se=1,Oe=1,Be=Me,Qe=L;const xe=[!1];for(se=1,Be=Me;Be<H;se++,Be++){const ct=ie[Be],ft=ce[Be],Ue=Be+1<H?ce[Be+1]:ee;for(Oe=ct-L+1,Qe=ct;Qe<Ue;Oe++,Qe++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Qe<=ft&&(st=Q(he,Ce,Be,Me,ze,z,Qe,ee,L,we[se-1][Oe-1]===0,xe));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,Y=st+Ie[se-1][Oe-1]);const me=Qe>ct,He=me?Ie[se][Oe-1]+(we[se][Oe-1]>0?-5:0):0,ye=Qe>ct+1&&we[se][Oe-1]>0,ot=ye?Ie[se][Oe-2]+(we[se][Oe-2]>0?-5:0):0;if(ye&&(!me||ot>=He)&&(!Z||ot>=Y))Ie[se][Oe]=ot,ue[se][Oe]=3,we[se][Oe]=0;else if(me&&(!Z||He>=Y))Ie[se][Oe]=He,ue[se][Oe]=2,we[se][Oe]=0;else if(Z)Ie[se][Oe]=Y,ue[se][Oe]=1,we[se][Oe]=we[se-1][Oe-1]+1;else throw new Error("not possible")}}if(pe&&Se(he,Me,ze,L),!xe[0]&&!G.firstMatchCanBeWeak)return;se--,Oe--;const _e=[Ie[se][Oe],L];let et=0,tt=0;for(;se>=1;){let ct=Oe;do{const ft=ue[se][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);et>1&&Ce[Me+se-1]===z[L+Oe-1]&&!j(ct+L-1,ze,z)&&et+1>we[se][ct]&&(ct=Oe),ct===Oe?et++:et=1,tt||(tt=ct),se--,Oe=ct-1,_e.push(Oe)}ee===H&&G.boostFullMatch&&(_e[0]+=2);const nt=tt-H;return _e[0]-=nt,_e}function fe(he,Ce,Me,ze,z,L){let G=he-1,H=Ce-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function Q(he,Ce,Me,ze,z,L,G,H,ee,se,Oe){if(Ce[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=he[Me]===z[G]?7:5:j(G,z,L)&&(G===0||!j(G-1,z,L))?(Be=he[Me]===z[G]?7:5,Qe=!0):Le(L,G)&&(G===0||!Le(L,G-1))?Be=5:(Le(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Oe[0]=!0),Qe||(Qe=j(G,z,L)||Le(L,G-1)||ne(L,G-1)),Me===ze?G>ee&&(Be-=Qe?3:5):se?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function X(he,Ce,Me,ze,z,L,G){return de(he,Ce,Me,ze,z,L,!0,G)}function le(he,Ce,Me,ze,z,L,G){return de(he,Ce,Me,ze,z,L,!1,G)}function de(he,Ce,Me,ze,z,L,G,H){let ee=$e(he,Ce,Me,ze,z,L,H);if(ee&&!G)return ee;if(he.length>=3){const se=Math.min(7,he.length-1);for(let Oe=Me+1;Oe<se;Oe++){const Be=Te(he,Oe);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Te(he,Ce){if(Ce+1>=he.length)return;const Me=he[Ce],ze=he[Ce+1];if(Me!==ze)return he.slice(0,Ce)+ze+Me+he.slice(Ce+2)}}),define(Re[33],Ae([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const O="error",M="warning",m="warn",g="info",E="ignore";function T(u){return u?I.$qf(O,u)?R.Error:I.$qf(M,u)||I.$qf(m,u)?R.Warning:I.$qf(g,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function k(u){switch(u){case R.Error:return O;case R.Warning:return M;case R.Info:return g;default:return E}}R.toString=k}(N||(N={})),e.default=N}),define(Re[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(Re[52],Ae([1,0,18,15]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class R{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const d=b.charCodeAt(0),n=this.b.charCodeAt(this.c);return d-n}value(){return this.b[this.c]}}e.$pi=R;class O{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,N.$kf)(b,this.b,0,b.length,this.c,this.d):(0,N.$mf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=O;class M{constructor(b=!0,d=!0){this.f=b,this.g=d}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let d=b.length-1;d>=0;d--,this.c--){const n=this.b.charCodeAt(d);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,N.$kf)(b,this.b,0,b.length,this.d,this.e):(0,N.$mf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=M;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class g{constructor(b,d){this.f=b,this.g=d,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,N.$lf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,N.$lf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,N.$jf)(b,this.c.query);if(this.d[this.e]===5)return(0,N.$jf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=g;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(T||(T={}));class k{static forUris(b=()=>!1,d=()=>!1){return new k(new g(b,d))}static forPaths(b=!1){return new k(new M(void 0,!b))}static forStrings(){return new k(new R)}static forConfigKeys(){return new k(new O)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,d){if(d){const n=d.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o,b)}else{const n=b.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(b,d){const n=this.b.reset(b);let o;this.c||(this.c=new E,this.c.segment=n.value());const s=[];for(o=this.c;;){const i=n.cmp(o.segment);if(i>0)o.left||(o.left=new E,o.left.segment=n.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new E,o.right.segment=n.value()),s.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new E,o.mid.segment=n.value()),s.push([0,o]),o=o.mid;else break}const r=o.value;o.value=d,o.key=b;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=a.rotateLeft();else if(t===-1&&v===-1)s[i][1]=a.rotateRight();else if(t===1&&v===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&v===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const d=this.b.reset(b);let n=this.c;for(;n;){const o=d.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(d.hasNext())d.next(),n=n.mid;else break}return n}has(b){const d=this.d(b);return!(d?.value===void 0&&d?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,d){const n=this.b.reset(b),o=[];let s=this.c;for(;s;){const r=n.cmp(s.segment);if(r>0)o.push([-1,s]),s=s.left;else if(r<0)o.push([1,s]),s=s.right;else if(n.hasNext())n.next(),o.push([0,s]),s=s.mid;else break}if(s){if(d?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const r=this.f(s.right);if(r.key){const{key:i,value:a,segment:h}=r;this.e(r.key,!1),s.key=i,s.value=a,s.segment=h}}else{const r=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const i=o[r][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[r][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[r][1]=i.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const d=this.b.reset(b);let n=this.c,o;for(;n;){const s=d.cmp(n.segment);if(s>0)n=n.left;else if(s<0)n=n.right;else if(d.hasNext())d.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(b){return this.g(b,!1)}g(b,d){const n=this.b.reset(b);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):d?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[d,n]of this)b(n,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const d=[];return this.j(b,d),d[Symbol.iterator]()}j(b,d){b&&(b.left&&this.j(b.left,d),b.value&&d.push([b.key,b.value]),b.mid&&this.j(b.mid,d),b.right&&this.j(b.right,d))}_isBalanced(){const b=d=>{if(!d)return!0;const n=d.balanceFactor();return n<-1||n>1?!1:b(d.left)&&b(d.right)};return b(this.c)}}e.$ti=k}),define(Re[41],Ae([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Nj=R;var N;(function(M){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=m})(N||(e.ThemeColor=N={}));function R(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(r){const i=m.exec(r.id);if(!i)return g(I.$Mj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=g;function E(r){return g(r).join(" ")}M.asClassName=E;function T(r){return"."+g(r).join(".")}M.asCSSSelector=T;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||N.isThemeColor(r.color))}M.isThemeIcon=k;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function b(r){const i=u.exec(r);if(!i)return;const[,a]=i;return{id:a}}M.fromString=b;function d(r){return{id:r}}M.fromId=d;function n(r,i){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}M.modify=n;function o(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}M.getModifier=o;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}M.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Re[131],Ae([1,0,129,15,41]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=g,e.$Fk=T,e.$Gk=u,e.$Hk=b,e.$Ik=n,e.$Jk=o;const O="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${M.source}`,"g");function g(s){return s.replace(m,(r,i)=>i?r:`\\${r}`)}const E=new RegExp(`\\\\${M.source}`,"g");function T(s){return s.replace(E,r=>`\\${r}`)}const k=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(s){return s.indexOf(O)===-1?s:s.replace(k,(r,i,a,h)=>a?r:i||h||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(r,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){d.lastIndex=0;let r="";const i=[];let a=0;for(;;){const h=d.lastIndex,t=d.exec(s),v=s.substring(h,t?.index);if(v.length>0){r+=v;for(let c=0;c<v.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:r,iconOffsets:i}}function o(s,r,i=!1){const{text:a,iconOffsets:h}=r;if(!h||h.length===0)return(0,I.$vk)(s,a,i);const t=(0,N.$0e)(a," "),v=a.length-t.length,c=(0,I.$vk)(s,t,i);if(c)for(const $ of c){const w=h[$.start+v]+v;$.start+=w,$.end+=w}return c}}),define(Re[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return I.test(R)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const O=new Uint8Array(16),M=[];for(let m=0;m<256;m++)M.push(m.toString(16).padStart(2,"0"));return function(){R(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,E="";return E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E}}()}),define(Re[132],Ae([1,0,18,46,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=O,e.$Et=M,e.$Gt=E;function O(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}function M(k,u,b){const d={id:(0,R.$Jg)(),name:k,uri:u,data:b};return{asString:async()=>"",asFile:()=>d,value:void 0}}class m{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return N.Iterable.some(this,([d,n])=>n.asFile())&&b.push("files"),T(g(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const d=this.a.get(u);d?d.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const d of b)yield[u,d]}b(u){return g(u)}}e.$Ft=m;function g(k){return k.toLowerCase()}function E(k,u){return T(g(k),u.map(g))}function T(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[d,n,o]=b;return o==="*"?u.some(s=>s.startsWith(n+"/")):!1}e.$Ht=Object.freeze({create:k=>(0,I.$Mb)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Ht.split(k).filter(u=>!u.startsWith("#"))})}),define(Re[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=N;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(R){let O=0,M=0,m=0,g=0;for(let E=0,T=R.length;E<T;E++){const k=R.charCodeAt(E);k===13?(O===0&&(M=E),O++,E+1<T&&R.charCodeAt(E+1)===10?(g|=2,E++):g|=3,m=E+1):k===10&&(g|=1,O===0&&(M=E),O++,m=E+1)}return O===0&&(M=R.length),[O,M,R.length-m,g]}}),define(Re[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,E=m.notIn.length;g<E;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const E=m.findTokenIndexAtOffset(g-2),T=m.getStandardTokenType(E);return this.isOK(T)}g(m,g){for(let E=m;E<=g;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=N;class R{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)O(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),O(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),O(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),O(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&O(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$$t=R;function O(M,m,g){M.has(m)?M.get(m).push(g):M.set(m,[g])}}),define(Re[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.NodeColor=e.$nC=void 0,e.$pC=R,e.$qC=O,e.$rC=E,e.$sC=T,e.$tC=k,e.$uC=u,e.$vC=b,e.$wC=d;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oC)return R(this.right);let o=this;for(;o.parent!==e.$oC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$oC?e.$oC:o.parent}prev(){if(this.left!==e.$oC)return O(this.left);let o=this;for(;o.parent!==e.$oC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$oC?e.$oC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nC=I;var N;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$oC=new I(null,0),e.$oC.parent=e.$oC,e.$oC.left=e.$oC,e.$oC.right=e.$oC,e.$oC.color=0;function R(n){for(;n.left!==e.$oC;)n=n.left;return n}function O(n){for(;n.right!==e.$oC;)n=n.right;return n}function M(n){return n===e.$oC?0:n.size_left+n.piece.length+M(n.right)}function m(n){return n===e.$oC?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function g(){e.$oC.parent=e.$oC}function E(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$oC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$oC?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function T(n,o){const s=o.left;o.left=s.right,s.right!==e.$oC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$oC?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function k(n,o){let s,r;if(o.left===e.$oC?(r=o,s=r.right):o.right===e.$oC?(r=o,s=r.left):(r=R(o.right),s=r.right),r===n.root){n.root=s,s.color=0,o.detach(),g(),n.root.parent=e.$oC;return}const i=r.color===1;if(r===r.parent.left?r.parent.left=s:r.parent.right=s,r===o?(s.parent=r.parent,d(n,s)):(r.parent===o?s.parent=r:s.parent=r.parent,d(n,s),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$oC&&(r.left.parent=r),r.right!==e.$oC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,d(n,r)),o.detach(),s.parent.left===s){const h=M(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,b(n,s.parent,v,c)}}if(d(n,s.parent),i){g();return}let a;for(;s!==n.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,E(n,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,T(n,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,E(n,s.parent),s=n.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,T(n,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(n,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,T(n,s.parent),s=n.root));s.color=0,g()}function u(n,o){for(d(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(n,o)),o.parent.color=0,o.parent.parent.color=1,T(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(n,o)),o.parent.color=0,o.parent.parent.color=1,E(n,o.parent.parent))}n.root.color=0}function b(n,o,s,r){for(;o!==n.root&&o!==e.$oC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}function d(n,o){let s=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=M(o.left)-o.size_left,r=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=r;o!==n.root&&(s!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}}}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$GC=e.$FC=void 0,e.$DC=T,e.$EC=k;const m=65535;function g(s){let r;return s[s.length-1]<65536?r=new Uint16Array(s.length):r=new Uint32Array(s.length),r.set(s,0),r}class E{constructor(r,i,a,h,t){this.lineStarts=r,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function T(s,r=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:v===10&&(i[a++]=h+1)}return r?g(i):i}function k(s,r){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,v=!0;for(let $=0,w=r.length;$<w;$++){const p=r.charCodeAt($);p===13?$+1<w&&r.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):v&&p!==9&&(p<32||p>126)&&(v=!1)}const c=new E(g(s),a,h,t,v);return s.length=0,c}class u{constructor(r,i,a,h,t){this.bufferIndex=r,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$FC=u;class b{constructor(r,i){this.buffer=r,this.lineStarts=i}}e.$GC=b;class d{constructor(r,i){this.a=[],this.c=r,this.d=i,this.b=0,r.root!==O.$oC&&r.iterate(r.root,a=>(a!==O.$oC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=r){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(r,i,a){this.create(r,i,a)}create(r,i,a){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=O.$oC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,v=r.length;t<v;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=T(r[t].buffer));const c=new u(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),h=this.S(h,c)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const i=m,a=i-Math.floor(i/3),h=a*2;let t="",v=0;const c=[];if(this.iterate(this.root,$=>{const w=this.R($),p=w.length;if(v<=a||v+p<h)return t+=w,v+=p,!0;const l=t.replace(/\r\n|\r|\n/g,r);return c.push(new b(l,T(l))),t=w,v=p,!0}),v>0){const $=t.replace(/\r\n|\r|\n/g,r);c.push(new b($,T($)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new d(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===O.$oC)return!0;const t=this.R(h),v=t.length,c=r.G(i),$=r.G(i+v),w=r.getValueInRange2(c,$);return i+=v,t===w})}getOffsetAt(r,i){let a=0,h=this.root;for(;h!==O.$oC;)if(h.left!==O.$oC&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){a+=h.size_left;const t=this.B(h,r-h.lf_left-2);return a+=t+i-1}else r-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let i=this.root,a=0;const h=r;for(;i!==O.$oC;)if(i.size_left!==0&&i.size_left>=r)i=i.left;else if(i.size_left+i.piece.length>=r){const t=this.A(i,r-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(a+1,1),c=h-v;return new I.$gt(a+1,c+1)}return new I.$gt(a+1,t.remainder+1)}else if(r-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===O.$oC){const t=this.getOffsetAt(a+1,1),v=h-r-t;return new I.$gt(a+1,v+1)}else i=i.right;return new I.$gt(1,1)}getValueInRange(r,i){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(r,i){if(r.node===i.node){const c=r.node,$=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(w+r.remainder,w+i.remainder)}let a=r.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let v=h.substring(t+r.remainder,t+a.piece.length);for(a=a.next();a!==O.$oC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){v+=c.substring($,$+i.remainder);break}else v+=c.substr($,a.piece.length);a=a.next()}return v}getLinesContent(){const r=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===O.$oC)return!0;const v=t.piece;let c=v.length;if(c===0)return!0;const $=this.a[v.bufferIndex].buffer,w=this.a[v.bufferIndex].lineStarts,p=v.start.line,l=v.end.line;let D=w[p]+v.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),r[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,w[p+1]-this.e)):$.substring(D,w[p+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;for(let f=p+1;f<l;f++)a=this.f?$.substring(w[f],w[f+1]-this.e):$.substring(w[f],w[f+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;return!this.f&&$.charCodeAt(w[l]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:a=$.substr(w[l],v.end.column-1)):a=$.substr(w[l],v.end.column),!0}),h&&(r[i++]=a,a=""),r[i++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const i=r.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(r,i){const a=this.H(r,i+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const i=this.getOffsetAt(r,1);return this.getLength()-i}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const i=this.G(r);return this.l(i)}findMatchesInNode(r,i,a,h,t,v,c,$,w,p,l){const D=this.a[r.piece.bufferIndex],f=this.u(r.piece.bufferIndex,r.piece.start),S=this.u(r.piece.bufferIndex,t),y=this.u(r.piece.bufferIndex,v);let C;const P={line:0,column:0};let W,V;i._wordSeparators?(W=D.buffer.substring(S,y),V=q=>q+S,i.reset(0)):(W=D.buffer,V=q=>q,i.reset(S));do if(C=i.next(W),C){if(V(C.index)>=y)return p;this.s(r,V(C.index)-f,P);const q=this.t(r.piece.bufferIndex,t,P),A=P.line===t.line?P.column-t.column+h:P.column+1,U=A+C[0].length;if(l[p++]=(0,M.$zC)(new N.$ht(a+q,A,a+q,U),C,$),V(C.index)+C[0].length>=y||p>=w)return p}while(C);return p}findMatchesLineByLine(r,i,a,h){const t=[];let v=0;const c=new M.$CC(i.wordSeparators,i.regex);let $=this.H(r.startLineNumber,r.startColumn);if($===null)return[];const w=this.H(r.endLineNumber,r.endColumn);if(w===null)return[];let p=this.s($.node,$.remainder);const l=this.s(w.node,w.remainder);if($.node===w.node)return this.findMatchesInNode($.node,c,r.startLineNumber,r.startColumn,p,l,i,a,h,v,t),t;let D=r.startLineNumber,f=$.node;for(;f!==w.node;){const y=this.t(f.piece.bufferIndex,p,f.piece.end);if(y>=1){const P=this.a[f.piece.bufferIndex].lineStarts,W=this.u(f.piece.bufferIndex,f.piece.start),V=P[p.line+y],q=D===r.startLineNumber?r.startColumn:1;if(v=this.findMatchesInNode(f,c,D,q,p,this.s(f,V-W),i,a,h,v,t),v>=h)return t;D+=y}const C=D===r.startLineNumber?r.startColumn-1:0;if(D===r.endLineNumber){const P=this.getLineContent(D).substring(C,r.endColumn-1);return v=this.n(i,c,P,r.endLineNumber,C,v,t,a,h),t}if(v=this.n(i,c,this.getLineContent(D).substr(C),D,C,v,t,a,h),v>=h)return t;D++,$=this.H(D,1),f=$.node,p=this.s($.node,$.remainder)}if(D===r.endLineNumber){const y=D===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(D).substring(y,r.endColumn-1);return v=this.n(i,c,C,r.endLineNumber,y,v,t,a,h),t}const S=D===r.startLineNumber?r.startColumn:1;return v=this.findMatchesInNode(w.node,c,D,S,p,l,i,a,h,v,t),t}n(r,i,a,h,t,v,c,$,w){const p=r.wordSeparators;if(!$&&r.simpleSearch){const D=r.simpleSearch,f=D.length,S=a.length;let y=-f;for(;(y=a.indexOf(D,y+f))!==-1;)if((!p||(0,M.$BC)(p,a,S,y,f))&&(c[v++]=new R.$sv(new N.$ht(h,y+1+t,h,y+1+f+t),null),v>=w))return v;return v}let l;i.reset(0);do if(l=i.next(a),l&&(c[v++]=(0,M.$zC)(new N.$ht(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),v>=w))return v;while(l);return v}insert(r,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==O.$oC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(r),c=h.piece,$=c.bufferIndex,w=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&v+c.length===r&&i.length<m){this.F(h,i),this.y();return}if(v===r)this.o(i,h),this.h.validate(r);else if(v+h.piece.length>r){const p=[];let l=new u(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u($,c.end)-this.u($,w));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new u(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,w);else this.C(h,w);const D=this.w(i);l.length>0&&this.S(h,l);let f=h;for(let S=0;S<D.length;S++)f=this.S(f,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(r,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===O.$oC)return;const a=this.G(r),h=this.G(r+i),t=a.node,v=h.node;if(t===v){const D=this.s(t,a.remainder),f=this.s(t,h.remainder);if(a.nodeStartOffset===r){if(i===t.piece.length){const S=t.next();(0,O.$tC)(this,t),this.N(S),this.y();return}this.D(t,f),this.h.validate(r),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===r+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,f),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(r),t.piece.length===0&&c.push(t);const w=this.s(v,h.remainder);this.D(v,w),v.piece.length===0&&c.push(v);const p=t.next();for(let D=p;D!==O.$oC&&D!==v;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(r,i){const a=[];if(this.K()&&this.M(r)&&this.L(i)){const v=i.piece,c={line:v.start.line+1,column:0},$=new u(v.bufferIndex,c,v.end,this.t(v.bufferIndex,c,v.end),v.length-1);i.piece=$,r+=`
`,(0,O.$vC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(r);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(a)}q(r,i){this.Q(r,i)&&(r+=`
`);const a=this.w(r),h=this.S(i,a[0]);let t=h;for(let v=1;v<a.length;v++)t=this.S(t,a[v]);this.N(h)}s(r,i,a){const h=r.piece,t=r.piece.bufferIndex,v=this.a[t].lineStarts,$=v[h.start.line]+h.start.column+i;let w=h.start.line,p=h.end.line,l=0,D=0,f=0;for(;w<=p&&(l=w+(p-w)/2|0,f=v[l],l!==p);)if(D=v[l+1],$<f)p=l-1;else if($>=D)w=l+1;else break;return a?(a.line=l,a.column=$-f,null):{line:l,column:$-f}}t(r,i,a){if(a.column===0)return a.line-i.line;const h=this.a[r].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],v=h[a.line]+a.column;if(t>v+1)return a.line-i.line;const c=v-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(r,i){return this.a[r].lineStarts[i.line]+i.column}v(r){for(let i=0;i<r.length;i++)(0,O.$tC)(this,r[i])}w(r){if(r.length>m){const p=[];for(;r.length>m;){const D=r.charCodeAt(m-1);let f;D===13||D>=55296&&D<=56319?(f=r.substring(0,m-1),r=r.substring(m-1)):(f=r.substring(0,m),r=r.substring(m));const S=T(f);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:f.length-S[S.length-1]},S.length-1,f.length)),this.a.push(new b(f,S))}const l=T(r);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:r.length-l[l.length-1]},l.length-1,r.length)),this.a.push(new b(r,l)),p}let i=this.a[0].buffer.length;const a=T(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[v],$={line:v,column:c},w=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,i=0){let a=this.root,h="";const t=this.h.get2(r);if(t){a=t.node;const v=this.B(a,r-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===r)h=c.substring($+v,$+a.piece.length);else{const w=this.B(a,r-t.nodeStartLineNumber);return c.substring($+v,$+w-i)}}else{let v=0;const c=r;for(;a!==O.$oC;)if(a.left!==O.$oC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const $=this.B(a,r-a.lf_left-2),w=this.B(a,r-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:c-(r-1-a.lf_left)}),p.substring(l+$,l+w-i)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const $=this.B(a,r-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=w.substring(p+$,p+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==O.$oC;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=v.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=v.substr(c,a.piece.length)}a=a.next()}return h}y(){let r=this.root,i=1,a=0;for(;r!==O.$oC;)i+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=i,this.c=a,this.h.validate(this.c)}A(r,i){const a=r.piece,h=this.s(r,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const v=this.t(r.piece.bufferIndex,a.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(r,i){if(i<0)return 0;const a=r.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),v=i,c=this.u(a.bufferIndex,v),$=this.t(a.bufferIndex,a.start,v),w=$-h,p=c-t,l=a.length+p;r.piece=new u(a.bufferIndex,a.start,v,$,l),(0,O.$vC)(this,r,p,w)}D(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),v=i,c=this.t(a.bufferIndex,v,a.end),$=this.u(a.bufferIndex,v),w=c-h,p=t-$,l=a.length+p;r.piece=new u(a.bufferIndex,v,a.end,c,l),(0,O.$vC)(this,r,p,w)}E(r,i,a){const h=r.piece,t=h.start,v=h.end,c=h.length,$=h.lineFeedCnt,w=i,p=this.t(h.bufferIndex,h.start,w),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);r.piece=new u(h.bufferIndex,h.start,w,p,l),(0,O.$vC)(this,r,l-c,p-$);const D=new u(h.bufferIndex,a,v,this.t(h.bufferIndex,a,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,a)),f=this.S(r,D);this.N(f)}F(r,i){this.Q(i,r)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let f=0;f<t.length;f++)t[f]+=h;if(a){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[v],$={line:v,column:c},w=r.piece.length+i.length,p=r.piece.lineFeedCnt,l=this.t(0,r.piece.start,$),D=l-p;r.piece=new u(r.piece.bufferIndex,r.piece.start,$,l,w),this.g=$,(0,O.$vC)(this,r,i.length,D)}G(r){let i=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let h=0;for(;i!==O.$oC;)if(i.size_left>r)i=i.left;else if(i.size_left+i.piece.length>=r){h+=i.size_left;const t={node:i,remainder:r-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else r-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(r,i){let a=this.root,h=0;for(;a!==O.$oC;)if(a.left!==O.$oC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const t=this.B(a,r-a.lf_left-2),v=this.B(a,r-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const t=this.B(a,r-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else r-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==O.$oC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(r,i){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+i;return a.buffer.charCodeAt(h)}J(r){if(!r)return 0;let i=r.size_left;for(;r!==this.root;)r.parent.right===r&&(i+=r.parent.size_left+r.parent.piece.length),r=r.parent;return i}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===O.$oC||r.piece.lineFeedCnt===0)return!1;const i=r.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===O.$oC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const i=r.prev();this.M(i)&&this.P(i,r)}}O(r){if(this.K()&&this.M(r)){const i=r.next();this.L(i)&&this.P(r,i)}}P(r,i){const a=[],h=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const v=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,t,c,v),(0,O.$vC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const $={line:i.piece.start.line+1,column:0},w=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,w),(0,O.$vC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(r,l[0]);for(let D=0;D<a.length;D++)(0,O.$tC)(this,a[D])}Q(r,i){if(this.K()&&this.M(r)){const a=i.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,O.$tC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},v=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,v),(0,O.$vC)(this,a,-1,-1)}return!0}}return!1}iterate(r,i){if(r===O.$oC)return i(O.$oC);const a=this.iterate(r.left,i);return a&&i(r)&&this.iterate(r.right,i)}R(r){if(r===O.$oC)return"";const i=this.a[r.piece.bufferIndex],a=r.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(r){const i=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return i.buffer.substring(a,h)}S(r,i){const a=new O.$nC(i,1);if(a.left=O.$oC,a.right=O.$oC,a.parent=O.$oC,a.size_left=0,a.lf_left=0,this.root===O.$oC)this.root=a,a.color=0;else if(r.right===O.$oC)r.right=a,a.parent=r;else{const t=(0,O.$pC)(r.right);t.left=a,a.parent=t}return(0,O.$uC)(this,a),a}T(r,i){const a=new O.$nC(i,1);if(a.left=O.$oC,a.right=O.$oC,a.parent=O.$oC,a.size_left=0,a.lf_left=0,this.root===O.$oC)this.root=a,a.color=0;else if(r.left===O.$oC)r.left=a,a.parent=r;else{const h=(0,O.$qC)(r.left);h.right=a,a.parent=h}return(0,O.$uC)(this,a),a}U(r){let i="";return this.iterate(r,a=>(i+=this.R(a),!0)),i}}e.$HC=o}),define(Re[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0=e.$I0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$I0=I;class N{constructor(O){this.identifier=O}}e.$J0=N}),define(Re[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Re[139],Ae([1,0,5,6,138]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0,e.$0i=T;class O extends N.$Uc{constructor(u,b="",d="",n=!0,o){super(),this.h=this.B(new I.$_d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=d,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$5i=O;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$_d),this.onWillRun=this.f.event,this.m=this.B(new I.$_d),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,b)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,b){await u.run(b)}}e.$6i=M;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const d of u)d.length&&(b.length?b=[...b,new m,...d]:b=d);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$7i=m;class g{get actions(){return this.a}constructor(u,b,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=n,this.a=d}async run(){}}e.$8i=g;class E extends O{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$9i=E;function T(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...u)=>k.run(...u),tooltip:k.label}}}),define(Re[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Re[141],Ae([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=E,e.$Tm=T,e.$Um=k;const N=60,R=N*60,O=R*24,M=O*7,m=O*30,g=O*365;function E(u,b,d,n){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,I.localize)(1,null);let s;return o<N?(s=o,b?s===1?d?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):d?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?d?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):d?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/N),b?s===1?d?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):d?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?d?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):d?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<O?(s=Math.floor(o/R),b?s===1?d?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):d?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?d?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):d?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<M?(s=Math.floor(o/O),b?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<m?(s=Math.floor(o/M),b?s===1?d?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):d?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?d?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):d?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<g?(s=Math.floor(o/m),b?s===1?d?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):d?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?d?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):d?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/g),b?s===1?d?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):d?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?d?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):d?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function T(u,b){const d=Math.abs(u/1e3);return d<1?b?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):d<N?b?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):d<R?b?(0,I.localize)(58,null,Math.round(u/(1e3*N))):(0,I.localize)(59,null,Math.round(u/(1e3*N))):d<O?b?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*O)))}function k(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Re[42],Ae([1,0,18,17,142]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=g,e.$_i=E,e.$aj=T;function O(k,u){return u&&(k.stack||k.stacktrace)?R.localize(0,null,m(k),M(k.stack)||M(k.stacktrace)):m(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function g(k=null,u=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const b=I.$Hb(k),d=g(b[0],u);return b.length>1?R.localize(4,null,d,b.length):d}if(N.$1f(k))return k;if(k.detail){const b=k.detail;if(b.error)return O(b.error,u);if(b.exception)return O(b.exception,u)}return k.stack?O(k,u):k.message?k.message:R.localize(5,null)}function E(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}function T(k,u){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=u,b}}),define(Re[143],Ae([1,0,40,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=m,e.$9q=g,e.$0q=E,e.$$q=T,e.$_q=k,e.$ar=u,e.$br=b,e.$cr=d,e.$dr=n,e.$er=o,e.$fr=w,e.$gr=p,e.$hr=l;const R=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,f,S=!1){const y=D||"",C=f||"",P=R.value.collator.compare(y,C);return R.value.collatorIsNumeric&&P===0&&y!==C?y<C?-1:1:P}function g(D,f){const S=O.value.collator;return D=D||"",f=f||"",a(S,D,f)}function E(D,f){const S=O.value.collator;return D=D||"",f=f||"",c(D,f)||a(S,D,f)}function T(D,f){const S=O.value.collator;return D=D||"",f=f||"",v(D,f)||a(S,D,f)}function k(D,f){return D=D||"",f=f||"",D===f?0:D<f?-1:1}function u(D,f){const[S,y]=r(D),[C,P]=r(f);let W=R.value.collator.compare(y,P);if(W===0){if(R.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(W=R.value.collator.compare(S,C),R.value.collatorIsNumeric&&W===0&&S!==C)return S<C?-1:1}return W}function b(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=O.value.collator,P=M.value.collator;return a(P,S,y)||a(C,D,f)}function d(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=O.value.collator,P=M.value.collator;return a(P,S,y)||c(D,f)||a(C,D,f)}function n(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=O.value.collator,P=M.value.collator;return a(P,S,y)||v(D,f)||a(C,D,f)}function o(D,f){D=D||"",f=f||"";const S=i(D).toLowerCase(),y=i(f).toLowerCase();return S!==y?S<y?-1:1:D!==f?D<f?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function r(D,f=!1){const S=D?s.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return f&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const f=D?s.exec(D):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(D,f,S){const y=D.compare(f,S);return y!==0?y:f.length!==S.length?f.length<S.length?-1:1:0}function h(D){const f=D.charAt(0);return f.toLocaleUpperCase()!==f}function t(D){const f=D.charAt(0);return f.toLocaleLowerCase()!==f}function v(D,f){return h(D)&&t(f)?-1:t(D)&&h(f)?1:0}function c(D,f){return t(D)&&h(f)?-1:h(D)&&t(f)?1:0}function $(D,f,S=!1){return S||(D=D&&D.toLowerCase(),f=f&&f.toLowerCase()),D===f?0:D<f?-1:1}function w(D,f,S=!1){const y=D.split(N.sep),C=f.split(N.sep),P=y.length-1,W=C.length-1;let V,q;for(let A=0;;A++){if(V=P===A,q=W===A,V&&q)return m(y[A],C[A],S);if(V)return-1;if(q)return 1;const U=$(y[A],C[A],S);if(U!==0)return U}}function p(D,f,S){const y=D.toLowerCase(),C=f.toLowerCase(),P=l(D,f,S);if(P)return P;const W=y.endsWith(S),V=C.endsWith(S);if(W!==V)return W?-1:1;const q=m(y,C);return q!==0?q:y.localeCompare(C)}function l(D,f,S){const y=D.toLowerCase(),C=f.toLowerCase(),P=y.startsWith(S),W=C.startsWith(S);if(P!==W)return P?-1:1;if(P&&W){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Re[47],Ae([1,0,19,21,15,17]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=M,e.$hg=m,e.$ig=g,e.$jg=E,e.$kg=T,e.$lg=d,e.$mg=n,e.$ng=o,e.$og=s,e.$pg=r,e.$qg=i,e.$rg=a,e.$sg=h,e.$tg=t,e.$ug=v,e.$vg=w;function M(p){return p===47||p===92}function m(p){return p.replace(/[\\/]/g,I.$hc.sep)}function g(p){return p.indexOf("/")===-1&&(p=m(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function E(p,l=I.$hc.sep){if(!p)return"";const D=p.length,f=p.charCodeAt(0);if(M(f)){if(M(p.charCodeAt(1))&&!M(p.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!M(p.charCodeAt(y));y++);if(C!==y&&!M(p.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(p.charCodeAt(y)))return p.slice(0,y+1).replace(/[\\/]/g,l)}}return l}else if(s(f)&&p.charCodeAt(1)===58)return M(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(M(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function T(p){if(!N.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const f=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(f===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(p,l=N.$i){const D=l?k:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&b.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function n(p,l,D){const f=p===l;return!D||f?f:!p||!l?!1:(0,R.$qf)(p,l)}function o(p,l,D,f=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,R.$rf)(p,l))return!1;if(l.length===p.length)return!0;let y=l.length;return l.charAt(l.length-1)===f&&y--,p.charAt(y)===f}return l.charAt(l.length-1)!==f&&(l+=f),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function r(p,l){return N.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),N.$i?(p=(0,R.$$e)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,R.$$e)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return N.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=N.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=N.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function v(p){const l=p.split(":");let D,f,S;for(const y of l){const C=Number(y);(0,O.$5f)(C)?f===void 0?f=C:S===void 0&&(S=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(p,l,D=8){let f="";for(let y=0;y<D;y++){let C;y===0&&N.$i&&!l&&(D===3||D===4)?C=$:C=c,f+=C.charAt(Math.floor(Math.random()*C.length))}let S;return l?S=`${l}-${f}`:S=f,p?(0,I.$kc)(p,S):S}}),define(Re[69],Ae([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Fs=O,e.$Gs=M,e.$Hs=m,e.$Is=E,e.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const k=(0,I.$pc)(T),u=N[k.toLowerCase()];return u!==void 0?u:M(T)}function M(T){const k=(0,I.$pc)(T);return R[k.toLowerCase()]}function m(T){for(const k in R)if(R[k]===T)return k}const g=/^(.+)\/(.+?)(;.+)?$/;function E(T,k){const u=g.exec(T);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:T}}),define(Re[53],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=R,e.$Vh=O,e.$Wh=m;function R(g){return JSON.stringify(g,M)}function O(g){let E=JSON.parse(g);return E=m(E),E}function M(g,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function m(g,E=0){if(!g||E>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return N.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.$ze||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let T=0;T<g.length;++T)g[T]=m(g[T],E+1);else for(const T in g)Object.hasOwnProperty.call(g,T)&&(g[T]=m(g[T],E+1))}return g}}),define(Re[12],Ae([1,0,14,21,15,2,19]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=g,e.$xg=E,e.$Bg=k;var m;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(m||(e.Schemas=m={}));function g(d,n){return O.URI.isUri(d)?(0,R.$qf)(d.scheme,n):(0,R.$rf)(d,n+":")}function E(d,...n){return n.some(o=>g(d,o))}e.$yg="vscode-tkn",e.$zg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=k(n,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,m.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(h){return I.$1(h),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const r=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(a+=`&${e.$zg}=${encodeURIComponent(i)}`),O.URI.from({scheme:N.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${r}`,path:this.g,query:a})}}e.$Ag=new T;function k(d,n){return M.$hc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class u{static{this.a=e.$Gg}asBrowserUri(n){const o=this.b(n,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===m.vscodeRemote?e.$Ag.rewrite(n):n.scheme===m.file&&(N.$m||N.$q===`${m.vscodeFileResource}://${u.a}`)?n.with({scheme:m.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,ge);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===m.vscodeFileResource?n.with({scheme:m.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return O.URI.isUri(n)?n:O.URI.parse(o.toUrl(n))}}e.$Hg=new u;var b;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:O.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return n.get(h)}d.getHeadersFromQuery=s;function r(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}d.addSearchParam=r})(b||(e.COI=b={}))}),define(Re[23],Ae([1,0,47,12,19,21,15,2]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=g,e.$0g=T,e.$$g=u;function g(b){return(0,m.$xc)(b,!0)}class E{constructor(d){this.a=d}compare(d,n,o=!1){return d===n?0:(0,M.$jf)(this.getComparisonKey(d,o),this.getComparisonKey(n,o))}isEqual(d,n,o=!1){return d===n?!0:!d||!n?!1:this.getComparisonKey(d,o)===this.getComparisonKey(n,o)}getComparisonKey(d,n=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,n,o=!1){if(d.scheme===n.scheme){if(d.scheme===N.Schemas.file)return I.$ng(g(d),g(n),this.a(d))&&d.query===n.query&&(o||d.fragment===n.fragment);if((0,e.$6g)(d.authority,n.authority))return I.$ng(d.path,n.path,this.a(d),"/")&&d.query===n.query&&(o||d.fragment===n.fragment)}return!1}joinPath(d,...n){return m.URI.joinPath(d,...n)}basenameOrAuthority(d){return(0,e.$Xg)(d)||d.authority}basename(d){return R.$hc.basename(d.path)}extname(d){return R.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let n;return d.scheme===N.Schemas.file?n=m.URI.file(R.$nc(g(d))).path:(n=R.$hc.dirname(d.path),d.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),n="/")),d.with({path:n})}normalizePath(d){if(!d.path.length)return d;let n;return d.scheme===N.Schemas.file?n=m.URI.file(R.$ic(g(d))).path:n=R.$hc.normalize(d.path),d.with({path:n})}relativePath(d,n){if(d.scheme!==n.scheme||!(0,e.$6g)(d.authority,n.authority))return;if(d.scheme===N.Schemas.file){const r=R.$mc(g(d),g(n));return O.$i?I.$hg(r):r}let o=d.path||"/";const s=n.path||"/";if(this.a(d)){let r=0;for(const i=Math.min(o.length,s.length);r<i&&!(o.charCodeAt(r)!==s.charCodeAt(r)&&o.charAt(r).toLowerCase()!==s.charAt(r).toLowerCase());r++);o=s.substr(0,r)+o.substr(r)}return R.$hc.relative(o,s)}resolvePath(d,n){if(d.scheme===N.Schemas.file){const o=m.URI.file(R.$lc(g(d),n));return d.with({authority:o.authority,path:o.path})}return n=I.$ig(n),d.with({path:R.$hc.resolve(d.path,n)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,n){return d===n||d!==void 0&&n!==void 0&&(0,M.$qf)(d,n)}hasTrailingPathSeparator(d,n=R.sep){if(d.scheme===N.Schemas.file){const o=g(d);return o.length>I.$jg(o).length&&o[o.length-1]===n}else{const o=d.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,n=R.sep){return(0,e.$7g)(d,n)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,n=R.sep){let o=!1;if(d.scheme===N.Schemas.file){const s=g(d);o=s!==void 0&&s.length===I.$jg(s).length&&s[s.length-1]===n}else{n="/";const s=d.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$7g)(d,n)?d.with({path:d.path+"/"}):d}}e.$Pg=E,e.$Qg=new E(()=>!1),e.$Rg=new E(b=>b.scheme===N.Schemas.file?!O.$k:!0),e.$Sg=new E(b=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function T(b,d){const n=[];for(let o=0;o<b.length;o++){const s=d(b[o]);b.some((r,i)=>i===o?!1:(0,e.$Ug)(s,d(r)))||n.push(b[o])}return n}var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function d(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set(b.META_DATA_MIME,r),o}b.parseMetaData=d})(k||(e.DataUri=k={}));function u(b,d,n){if(d){let o=b.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),b.with({scheme:n,authority:d,path:o})}return b.with({scheme:n})}}),define(Re[11],Ae([1,0,24,14,5,6,23,21,130,40]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=T,e.$ah=k,e.$bh=u,e.$ch=b,e.$dh=d,e.$eh=n,e.$fh=o,e.$gh=s,e.$oh=p,e.$ph=l,e.$qh=D,e.$rh=f,e.$sh=S,e.$Hh=Ie,e.$Ph=Ee;function T(fe){return!!fe&&typeof fe.then=="function"}function k(fe){const Q=new I.$je,X=fe(Q.token),le=new Promise((de,Te)=>{const he=Q.token.onCancellationRequested(()=>{he.dispose(),Te(new N.$5)});Promise.resolve(X).then(Ce=>{he.dispose(),Q.dispose(),de(Ce)},Ce=>{he.dispose(),Q.dispose(),Te(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(de,Te){return le.then(de,Te)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function u(fe,Q,X){return new Promise((le,de)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),le(X)});fe.then(le,de).finally(()=>Te.dispose())})}function b(fe,Q){return new Promise((X,le)=>{const de=Q.onCancellationRequested(()=>{de.dispose(),le(new N.$5)});fe.then(X,le).finally(()=>de.dispose())})}async function d(fe){let Q=-1;const X=fe.map((le,de)=>le.then(Te=>(Q=de,Te)));try{return await Promise.race(X)}finally{fe.forEach((le,de)=>{de!==Q&&le.cancel()})}}function n(fe,Q,X){let le;const de=setTimeout(()=>{le?.(void 0),X?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(de)),new Promise(Te=>le=Te)])}function o(fe){return new Promise((Q,X)=>{const le=fe();T(le)?le.then(Q,X):Q(le)})}function s(){let fe,Q;return{promise:new Promise((le,de)=>{fe=le,Q=de}),resolve:fe,reject:Q}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const X=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(X,X).then(le)})}return new Promise((X,le)=>{this.b.then(X,le)})}return this.a=Q(),new Promise((X,le)=>{this.a.then(de=>{this.a=null,X(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$hh=r;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$ih=i;class a{constructor(){this.a=new Map}queue(Q,X){const de=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(Q)===de&&this.a.delete(Q)});return this.a.set(Q,de),de}}e.$jh=a;const h=(fe,Q)=>{let X=!0;const le=setTimeout(()=>{X=!1,Q()},fe);return{isTriggered:()=>X,dispose:()=>{clearTimeout(le),X=!1}}},t=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class v{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,X=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((de,Te)=>{this.d=de,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=X===g.$9d?t(le):h(X,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=v;class c{constructor(Q){this.a=new v(Q),this.b=new r}trigger(Q,X){return this.a.trigger(()=>this.b.queue(Q),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=c;class ${constructor(){this.a=!1,this.b=new Promise((Q,X)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=$;class w extends ${constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$nh=w;function p(fe,Q){return Q?new Promise((X,le)=>{const de=setTimeout(()=>{Te.dispose(),X()},fe),Te=Q.onCancellationRequested(()=>{clearTimeout(de),Te.dispose(),le(new N.$5)})}):k(X=>p(fe,X))}function l(fe,Q=0,X){const le=setTimeout(()=>{fe(),X&&de.dispose()},Q),de=(0,O.$Sc)(()=>{clearTimeout(le),X?.deleteAndLeak(de)});return X?.add(de),de}function D(fe){const Q=[];let X=0;const le=fe.length;function de(){return X<le?fe[X++]():null}function Te(he){he!=null&&Q.push(he);const Ce=de();return Ce?Ce.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}function f(fe,Q=le=>!!le,X=null){let le=0;const de=fe.length,Te=()=>{if(le>=de)return Promise.resolve(X);const he=fe[le++];return Promise.resolve(he()).then(Me=>Q(Me)?Promise.resolve(Me):Te())};return Te()}function S(fe,Q=le=>!!le,X=null){if(fe.length===0)return Promise.resolve(X);let le=fe.length;const de=()=>{le=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,he)=>{for(const Ce of fe)Ce.then(Me=>{--le>=0&&Q(Me)?(de(),Te(Me)):le===0&&Te(X)}).catch(Me=>{--le>=0&&(de(),he(Me))})})}class y{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$_d}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,le)=>{this.g.push({factory:Q,c:X,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const X=Q.factory();X.then(Q.c,Q.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=y;class C extends y{constructor(){super(1)}}e.$uh=C;class P{constructor(){this.a=new ue,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$vh=P;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new Se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,X=M.$Qg){const le=X.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,X,le=M.$Qg){const de=le.getComparisonKey(Q);let Te=this.a.get(de);if(!Te){Te=new C;const he=this.f++,Ce=R.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(he,Ce),this.a.set(de,Te)}return Te.queue(X)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=W;class V{constructor(Q,X){this.a=-1,typeof Q=="function"&&typeof X=="number"&&this.setIfNotSet(Q,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},X)}setIfNotSet(Q,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},X))}}e.$xh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,X,le=globalThis){this.cancel();const de=le.setInterval(()=>{Q()},X);this.d=(0,O.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$yh=q;class A{constructor(Q,X){this.b=-1,this.a=Q,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=A;class U{constructor(Q,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=Q,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=U;class K extends A{constructor(Q,X){super(Q,X),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Bh=K;class ie extends O.$Uc{constructor(Q,X){super(),this.g=Q,this.h=X,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of Q)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(fe,Q)=>{(0,m.$B)(()=>{if(X)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$Eh=(fe,Q,X)=>{const le=fe.requestIdleCallback(Q,typeof X=="number"?{timeout:X}:void 0);let de=!1;return{dispose(){de||(de=!0,fe.cancelIdleCallback(le))}}},e.$Dh=fe=>(0,e.$Eh)(globalThis,fe)}();class ce{constructor(Q,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Eh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=ce;class we extends ce{constructor(Q){super(globalThis,Q)}}e.$Gh=we;async function Ie(fe,Q,X){let le;for(let de=0;de<X;de++)try{return await fe()}catch(Te){le=Te,await p(Q)}throw le}class ue{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,X,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:X},X.then(()=>this.d(Q),()=>this.d(Q)),X}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:X,resolve:le,reject:de}=s();this.b={run:Q,promise:X,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=ue;class pe{constructor(Q,X=()=>Date.now()){this.d=Q,this.f=X,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Jh=pe;var re;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(re||(re={}));class Se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,X)=>{this.a=Q,this.b=X})}complete(Q){return new Promise(X=>{this.a(Q),this.d={outcome:0,value:Q},X()})}error(Q){return new Promise(X=>{this.b(Q),this.d={outcome:1,value:Q},X()})}cancel(){return this.error(new N.$5)}}e.$Kh=Se;var Le;(function(fe){async function Q(le){let de;const Te=await Promise.all(le.map(he=>he.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de<"u")throw de;return Te}fe.settled=Q;function X(le){return new Promise(async(de,Te)=>{try{await le(de,Te)}catch(he){Te(he)}})}fe.withAsyncBody=X})(Le||(e.Promises=Le={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=ne;class j{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=j;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(X=>{X.emitMany(Q)})}static fromPromise(Q){return new ve(async X=>{X.emitMany(await Q)})}static fromPromises(Q){return new ve(async X=>{await Promise.all(Q.map(async le=>X.emitOne(await le)))})}static merge(Q){return new ve(async X=>{await Promise.all(Q.map(async le=>{for await(const de of le)X.emitOne(de)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new R.$_d,queueMicrotask(async()=>{const X={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(Q(X)),this.j()}catch(le){this.k(le)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,X){return new ve(async le=>{for await(const de of Q)le.emitOne(X(de))})}map(Q){return ve.map(this,Q)}static filter(Q,X){return new ve(async le=>{for await(const de of Q)X(de)&&le.emitOne(de)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,X=>!!X)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const X=[];for await(const le of Q)X.push(le);return X}toPromise(){return ve.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$Nh=ve;class Ne extends ve{constructor(Q,X){super(X),this.l=Q}cancel(){this.l.cancel()}}e.$Oh=Ne;function Ee(fe){const Q=new I.$je,X=fe(Q.token);return new Ne(Q,async le=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Q.dispose(),le.reject(new N.$5)});try{for await(const Te of X){if(Q.token.isCancellationRequested)return;le.emitOne(Te)}de.dispose(),Q.dispose()}catch(Te){de.dispose(),Q.dispose(),le.reject(Te)}})}class $e{constructor(){this.a=new Se,this.b=new ve(le=>{if(Q){le.reject(Q);return}return X&&le.emitMany(X),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let Q,X;this.f=le=>{X||(X=[]),X.push(le)},this.d=le=>{Q||(Q=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Qh=$e}),define(Re[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=E,e.$fk=d,e.$gk=C,e.$hk=P,e.$ik=W,e.$jk=V,e.$kk=q,e.$lk=ie;function E(){return Object.create(null)}e.$dk="**",e.$ek="/";const T="[/\\\\]",k="[^/\\\\]",u=/\//g;function b(ce,we){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${we?`|${T}${k}+`:""})*?`}}function d(ce,we){if(!ce)return[];const Ie=[];let ue=!1,pe=!1,re="";for(const Se of ce){switch(Se){case we:if(!ue&&!pe){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}re+=Se}return re&&Ie.push(re),Ie}function n(ce){if(!ce)return"";let we="";const Ie=d(ce,e.$ek);if(Ie.every(ue=>ue===e.$dk))we=".*";else{let ue=!1;Ie.forEach((pe,re)=>{if(pe===e.$dk){if(ue)return;we+=b(2,re===Ie.length-1)}else{let Se=!1,Le="",ne=!1,j="";for(const x of pe){if(x!=="}"&&Se){Le+=x;continue}if(ne&&(x!=="]"||!j)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!j?ve="^":x===e.$ek?ve="":ve=(0,g.$5e)(x),j+=ve;continue}switch(x){case"{":Se=!0;continue;case"[":ne=!0;continue;case"}":{const Ne=`(?:${d(Le,",").map(Ee=>n(Ee)).join("|")})`;we+=Ne,Se=!1,Le="";break}case"]":{we+="["+j+"]",ne=!1,j="";break}case"?":we+=k;continue;case"*":we+=b(1);continue;default:we+=(0,g.$5e)(x)}}re<Ie.length-1&&(Ie[re+1]!==e.$dk||re+2<Ie.length)&&(we+=T)}ue=pe===e.$dk})}return we}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),v=function(){return!1},c=function(){return null};function $(ce,we){if(!ce)return c;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!we.trimForExclusions}`;let pe=t.get(ue);if(pe)return w(pe,ce);let re;return o.test(Ie)?pe=l(Ie.substr(4),Ie):(re=s.exec(p(Ie,we)))?pe=D(re[1],Ie):(we.trimForExclusions?i:r).test(Ie)?pe=f(Ie,we):(re=a.exec(p(Ie,we)))?pe=S(re[1].substr(1),Ie,!0):(re=h.exec(p(Ie,we)))?pe=S(re[1],Ie,!1):pe=y(Ie),t.set(ue,pe),w(pe,ce)}function w(ce,we){if(typeof we=="string")return ce;const Ie=function(ue,pe){return(0,R.$ng)(ue,we.base,!m.$k)?ce((0,g.$0e)(ue.substr(we.base.length),M.sep),pe):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function p(ce,we){return we.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function l(ce,we){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?we:null}}function D(ce,we){const Ie=`/${ce}`,ue=`\\${ce}`,pe=function(Se,Le){return typeof Se!="string"?null:Le?Le===ce?we:null:Se===ce||Se.endsWith(Ie)||Se.endsWith(ue)?we:null},re=[ce];return pe.basenames=re,pe.patterns=[we],pe.allBasenames=re,pe}function f(ce,we){const Ie=K(ce.slice(1,-1).split(",").map(Le=>$(Le,we)).filter(Le=>Le!==c),ce),ue=Ie.length;if(!ue)return c;if(ue===1)return Ie[0];const pe=function(Le,ne){for(let j=0,x=Ie.length;j<x;j++)if(Ie[j](Le,ne))return ce;return null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function S(ce,we,Ie){const ue=M.sep===M.$hc.sep,pe=ue?ce:ce.replace(u,M.sep),re=M.sep+pe,Se=M.$hc.sep+ce;let Le;return Ie?Le=function(ne,j){return typeof ne=="string"&&(ne===pe||ne.endsWith(re)||!ue&&(ne===ce||ne.endsWith(Se)))?we:null}:Le=function(ne,j){return typeof ne=="string"&&(ne===pe||!ue&&ne===ce)?we:null},Le.allPaths=[(Ie?"*/":"./")+ce],Le}function y(ce){try{const we=new RegExp(`^${n(ce)}$`);return function(Ie){return we.lastIndex=0,typeof Ie=="string"&&we.test(Ie)?ce:null}}catch{return c}}function C(ce,we,Ie){return!ce||typeof we!="string"?!1:P(ce)(we,void 0,Ie)}function P(ce,we={}){if(!ce)return v;if(typeof ce=="string"||W(ce)){const Ie=$(ce,we);if(Ie===c)return v;const ue=function(pe,re){return!!Ie(pe,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return A(ce,we)}function W(ce){const we=ce;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,we){const Ie=K(Object.getOwnPropertyNames(ce).map(Le=>U(Le,ce[Le],we)).filter(Le=>Le!==c)),ue=Ie.length;if(!ue)return c;if(!Ie.some(Le=>!!Le.requiresSiblings)){if(ue===1)return Ie[0];const Le=function(x,ve){let Ne;for(let Ee=0,$e=Ie.length;Ee<$e;Ee++){const fe=Ie[Ee](x,ve);if(typeof fe=="string")return fe;(0,N.$_g)(fe)&&(Ne||(Ne=[]),Ne.push(fe))}return Ne?(async()=>{for(const Ee of Ne){const $e=await Ee;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Le.allBasenames=ne.allBasenames);const j=Ie.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return j.length&&(Le.allPaths=j),Le}const pe=function(Le,ne,j){let x,ve;for(let Ne=0,Ee=Ie.length;Ne<Ee;Ne++){const $e=Ie[Ne];$e.requiresSiblings&&j&&(ne||(ne=(0,M.$oc)(Le)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Le).length)));const fe=$e(Le,ne,x,j);if(typeof fe=="string")return fe;(0,N.$_g)(fe)&&(ve||(ve=[]),ve.push(fe))}return ve?(async()=>{for(const Ne of ve){const Ee=await Ne;if(typeof Ee=="string")return Ee}return null})():null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function U(ce,we,Ie){if(we===!1)return c;const ue=$(ce,Ie);if(ue===c)return c;if(typeof we=="boolean")return ue;if(we){const pe=we.when;if(typeof pe=="string"){const re=(Se,Le,ne,j)=>{if(!j||!ue(Se,Le))return null;const x=pe.replace("$(basename)",()=>ne),ve=j(x);return(0,N.$_g)(ve)?ve.then(Ne=>Ne?ce:null):ve?ce:null};return re.requiresSiblings=!0,re}}return ue}function K(ce,we){const Ie=ce.filter(Le=>!!Le.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Le,ne)=>{const j=ne.basenames;return j?Le.concat(j):Le},[]);let pe;if(we){pe=[];for(let Le=0,ne=ue.length;Le<ne;Le++)pe.push(we)}else pe=Ie.reduce((Le,ne)=>{const j=ne.patterns;return j?Le.concat(j):Le},[]);const re=function(Le,ne){if(typeof Le!="string")return null;if(!ne){let x;for(x=Le.length;x>0;x--){const ve=Le.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Le.substr(x)}const j=ue.indexOf(ne);return j!==-1?pe[j]:null};re.basenames=ue,re.patterns=pe,re.allBasenames=ue;const Se=ce.filter(Le=>!Le.basenames);return Se.push(re),Se}function ie(ce,we){return(0,I.$ub)(ce,we,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Re[54],Ae([1,0,14,131,23,15,2]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.MarkdownStringTextNewlineStyle=void 0,e.$Lk=E,e.$Mk=T,e.$Nk=k,e.$Ok=u,e.$Pk=b,e.$Qk=d,e.$Rk=n,e.$Sk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(r="",i=!1){if(this.value=r,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(r,i=0){return this.value+=u(this.supportThemeIcons?(0,N.$Ek)(r):r).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,i){return this.value+=`
${b(i,r)}
`,this}appendLink(r,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,i){const a=new RegExp((0,O.$5e)(i),"g");return r.replace(a,(h,t)=>r.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Kk=g;function E(s){return T(s)?!s.value:Array.isArray(s)?s.every(E):!0}function T(s){return s instanceof g?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function k(s,r){return s===r?!0:!s||!r?!1:s.value===r.value&&s.isTrusted===r.isTrusted&&s.supportThemeIcons===r.supportThemeIcons&&s.supportHtml===r.supportHtml&&(s.baseUri===r.baseUri||!!s.baseUri&&!!r.baseUri&&(0,R.$Tg)(M.URI.from(s.baseUri),M.URI.from(r.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,r){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${r}`,s,`${"`".repeat(a)}`].join(`
`)}function d(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const r=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),v=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),w=isFinite(parseInt(v));$&&r.push(`width="${c}"`),w&&r.push(`height="${v}"`)}return{href:s,dimensions:r}}}),define(Re[96],Ae([1,0,18,47,19,21,23,15]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=g,e.$mw=T,e.$nw=u,e.$ow=b,e.$pw=s,e.$qw=i,e.$rw=a,e.$sw=h,e.$tw=t,e.$uw=v;function g($,w){const{os:p,tildify:l,relative:D}=w;if(D){const y=E($,D,p);if(typeof y=="string")return y}let f=$.fsPath;if(p===1&&!O.$i?f=f.replace(/\//g,"\\"):p!==1&&O.$i&&(f=f.replace(/\\/g,"/")),p!==1&&l?.userHome){const y=l.userHome.fsPath;let C;$.scheme!==l.userHome.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep?C=l.userHome.with({path:$.path}).fsPath:C=f,f=u(C,y,p)}return(p===1?R.$gc:R.$hc).normalize(T(f,p===1))}function E($,w,p){const l=p===1?R.$gc:R.$hc,D=p===3?M.$Qg:M.$Sg,f=w.getWorkspace(),S=(0,I.$Ob)(f.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep&&($=S.uri.with({path:$.path}));const y=w.getWorkspaceFolder($);if(!y)return;let C;if(D.isEqual(y.uri,$)?C="":C=D.relativePath(y.uri,$)??"",C&&(C=l.normalize(C)),f.folders.length>1&&!w.noPrefix){const P=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T($,w=O.$i){return(0,N.$rg)($,w)?$.charAt(0).toUpperCase()+$.slice(1):$}let k=Object.create(null);function u($,w,p=O.OS){if(p===1||!$||!w)return $;let l=k.original===w?k.normalized:void 0;l||(l=w,O.$i&&(l=(0,N.$hg)(l)),l=`${(0,m.$$e)(l,R.$hc.sep)}${R.$hc.sep}`,k={original:w,normalized:l});let D=$;return O.$i&&(D=(0,N.$hg)(D)),(p===3?D.startsWith(l):(0,m.$rf)(D,l))?`~/${D.substr(l.length)}`:$}function b($,w){return $.replace(/^~($|\/|\\)/,`${w}$1`)}const d="\u2026",n="\\\\",o="~";function s($,w=R.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const f=$[D];if(f===""){p[D]=`.${w}`;continue}if(!f){p[D]=f;continue}l=!0;let S="",y=f;y.indexOf(n)===0?(S=y.substr(0,y.indexOf(n)+n.length),y=y.substr(y.indexOf(n)+n.length)):y.indexOf(w)===0?(S=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(w);for(let P=1;l&&P<=C.length;P++)for(let W=C.length-P;l&&W>=0;W--){l=!1;let V=C.slice(W,W+P).join(w);for(let q=0;!l&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(V)>-1){const A=W+P===C.length,U=W>0&&$[q].indexOf(w)>-1?w+V:V,K=$[q].endsWith(U);l=!A||K}if(!l){let q="";(C[0].endsWith(":")||S!=="")&&(W===1&&(W=0,P++,V=C[0]+w+V),W>0&&(q=C[0]+w),q=S+q),W>0&&(q=q+d+w),q=q+V,W+P<C.length&&(q=q+w+d),p[D]=q}}l&&(p[D]=f)}return p}var r;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function i($,w=Object.create(null)){const p=[];let l=!1,D="";for(const f of $)if(f==="$"||l&&f==="{")D&&p.push({value:D,type:r.TEXT}),D="",l=!0;else if(f==="}"&&l){const S=w[D];if(typeof S=="string")S.length&&p.push({value:S,type:r.VARIABLE});else if(S){const y=p[p.length-1];(!y||y.type!==r.SEPARATOR)&&p.push({value:S.label,type:r.SEPARATOR})}D="",l=!1}else D+=f;return D&&!l&&p.push({value:D,type:r.TEXT}),p.filter((f,S)=>{if(f.type===r.SEPARATOR){const y=p[S-1],C=p[S+1];return[y,C].every(P=>P&&(P.type===r.VARIABLE||P.type===r.TEXT)&&P.value.length>0)}return!0}).map(f=>f.value).join("")}function a($,w){return O.$j||w?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,w){return O.$j||w?$.replace(/\(&&\w\)|&&/g,""):O.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function v($){if($.endsWith("]")){const w=$.lastIndexOf(" [",$.length-2);if(w!==-1){const p=c($.substring(0,w)),l=$.substring(w);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const w=$.indexOf("/")!==-1?R.$hc:R.$gc,p=w.basename($),l=w.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Re[144],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=m,e.$sn=E,e.$tn=T;function R(k){return k.toJSON()}class O{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:R(N.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:R(N.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:N.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$pn=O,e.$qn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function M(k,u,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return u.transformOutgoing(k);for(const d in k)if(Object.hasOwnProperty.call(k,d)){const n=M(k[d],u,b+1);n!==null&&(k[d]=n)}}return null}function m(k,u){const b=M(k,u,0);return b===null?k:b}function g(k,u,b,d){if(!k||d>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?N.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof I.$ze)return null;for(const n in k)if(Object.hasOwnProperty.call(k,n)){const o=g(k[n],u,b,d+1);o!==null&&(k[n]=o)}}return null}function E(k,u){const b=g(k,u,!1,0);return b===null?k:b}function T(k,u){const b=g(k,u,!0,0);return b===null?k:b}}),define(Re[145],Ae([1,0,15,21,22]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=T,e.$rt=k;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let E;function T(){return E||(E=N.$D()?M():g()),E}function k(d,n,o){const s=new Uint16Array(d.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?u(d,n,o):M().decode(s)}function u(d,n,o){const s=[];let r=0;for(let i=0;i<o;i++){const a=R.$Be(d,n);n+=2,s[r++]=String.fromCharCode(a)}return s.join("")}class b{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return T().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||I.$uf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$st=b}),define(Re[146],Ae([1,0,22,145]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,k,u){this.oldPosition=E,this.oldText=T,this.newPosition=k,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,k){const u=T.length;I.$Ee(E,u,k),k+=4;for(let b=0;b<u;b++)I.$Ce(E,T.charCodeAt(b),k),k+=2;return k}static d(E,T){const k=I.$De(E,T);return T+=4,(0,N.$rt)(E,T,k)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(E,T){return I.$Ee(E,this.oldPosition,T),T+=4,I.$Ee(E,this.newPosition,T),T+=4,T=O.c(E,this.oldText,T),T=O.c(E,this.newText,T),T}static read(E,T,k){const u=I.$De(E,T);T+=4;const b=I.$De(E,T);T+=4;const d=O.d(E,T);T+=O.a(d);const n=O.d(E,T);return T+=O.a(n),k.push(new O(u,d,b,n)),T}}e.$tt=O;function M(g,E){return g===null||g.length===0?E:new m(g,E).compress()}class m{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,k=this.n(E),u=this.l(T);for(;E<this.f||T<this.h;){if(k===null){this.k(u),u=this.l(++T);continue}if(u===null){this.m(k),k=this.n(++E);continue}if(u.oldEnd<=k.newPosition){this.k(u),u=this.l(++T);continue}if(k.newEnd<=u.oldPosition){this.m(k),k=this.n(++E);continue}if(u.oldPosition<k.newPosition){const[s,r]=m.r(u,k.newPosition-u.oldPosition);this.k(s),u=r;continue}if(k.newPosition<u.oldPosition){const[s,r]=m.q(k,u.oldPosition-k.newPosition);this.m(s),k=r;continue}let n,o;if(u.oldEnd===k.newEnd)n=k,o=u,k=this.n(++E),u=this.l(++T);else if(u.oldEnd<k.newEnd){const[s,r]=m.q(k,u.oldLength);n=s,o=u,k=r,u=this.l(++T)}else{const[s,r]=m.r(u,k.newLength);n=k,o=s,k=this.n(++E),u=r}this.d[this.e++]=new O(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const b=m.s(this.d);return m.t(b)}k(E){this.d[this.e++]=m.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=m.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new O(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new O(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const k=E.newText.substr(0,T),u=E.newText.substr(T);return[new O(E.oldPosition,E.oldText,E.newPosition,k),new O(E.oldEnd,"",E.newPosition+T,u)]}static r(E,T){const k=E.oldText.substr(0,T),u=E.oldText.substr(T);return[new O(E.oldPosition,k,E.newPosition,E.newText),new O(E.oldPosition+T,u,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let k=0,u=E[0];for(let b=1;b<E.length;b++){const d=E[b];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(T[k++]=u,u=d)}return T[k++]=u,T}static t(E){if(E.length===0)return E;const T=[];let k=0;for(let u=0;u<E.length;u++){const b=E[u];b.oldText!==b.newText&&(T[k++]=b)}return T}}}),define(Re[147],Ae([1,0,36,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=R,e.$St=O;function R(M,m,g,E,T,k){if(Array.isArray(M)){let u=0;for(const b of M){const d=R(b,m,g,E,T,k);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof M=="string")return E?M==="*"?5:M===g?10:0:0;if(M){const{language:u,pattern:b,scheme:d,hasAccessToAllModels:n,notebookType:o}=M;if(!E&&!n)return 0;o&&T&&(m=T);let s=0;if(d)if(d===m.scheme)s=10;else if(d==="*")s=5;else return 0;if(u)if(u===g)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===k)s=10;else if(o==="*"&&k!==void 0)s=Math.max(s,5);else return 0;if(b){let r;if(typeof b=="string"?r=b:r={...b,base:(0,N.$ic)(b.base)},r===m.fsPath||(0,I.$gk)(r,m.fsPath))s=10;else return 0}return s}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Re[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class T extends E.$Uc{constructor(u,b,d,n,o,s,r){super(),this.m=this.B(new I.$_d),this.onDidChangeContent=this.m.event,this.f=b,this.j=!s,this.g=n,this.h=o,this.c=new M.$HC(u,d,r)}equals(u){return!(u instanceof T)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const d=u+b,n=this.getPositionAt(u),o=this.getPositionAt(d);return new R.$ht(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const d=this.n(b);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(b),r=this.getEOL();if(s.length!==r.length){const i=s.length-r.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return n-d+o}getCharacterCountInRange(u,b=0){if(this.j){let d=0;const n=u.startLineNumber,o=u.endLineNumber;for(let s=n;s<=o;s++){const r=this.getLineContent(s),i=s===n?u.startColumn-1:0,a=s===o?u.endColumn-1:r.length;for(let h=i;h<a;h++)N.$uf(r.charCodeAt(h))?(d=d+1,h=h+1):d=d+1}return d+=this.n(b).length*(o-n),d}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=N.$ff(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=N.$hf(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,d){let n=this.g,o=this.h,s=this.j,r=!0,i=[];for(let w=0;w<u.length;w++){const p=u[w];r&&p._isTracked&&(r=!1);const l=p.range;if(p.text){let C=!0;s||(C=!N.$Ff(p.text),s=C),!n&&C&&(n=N.$Ef(p.text)),!o&&C&&(o=N.$Hf(p.text))}let D="",f=0,S=0,y=0;if(p.text){let C;[f,S,y,C]=(0,m.$Kt)(p.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,P)}i[w]={sortIndex:w,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:f,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(T.u);let a=!1;for(let w=0,p=i.length-1;w<p;w++){const l=i[w].range.getEndPosition(),D=i[w+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(i=this.s(i));const h=d||b?T._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const p=i[w],l=h[w];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let f="";D===l.startLineNumber&&(f=this.getLineContent(p.range.startLineNumber),N.$ff(f)!==-1)||t.push({lineNumber:D,oldContent:f})}}let v=null;if(d){let w=0;v=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],f=this.getValueInRange(l.range),S=l.rangeOffset+w;w+=l.text.length-f.length,v[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:f,textChange:new g.$tt(l.rangeOffset,f,S,l.text)}}a||v.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=n,this.h=o,this.j=s;const c=this.t(i);let $=null;if(b&&t.length>0){t.sort((w,p)=>p.lineNumber-w.lineNumber),$=[];for(let w=0,p=t.length;w<p;w++){const l=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===l)continue;const D=t[w].oldContent,f=this.getLineContent(l);f.length===0||f===D||N.$ff(f)!==-1||$.push(l)}}return this.m.fire(),new O.$wv(v,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const d=u[0].range,n=u[u.length-1].range,o=new R.$ht(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let s=d.startLineNumber,r=d.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const w=u[c],p=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new R.$ht(s,r,p.startLineNumber,p.startColumn))),w.text.length>0&&i.push(w.text),s=p.endLineNumber,r=p.endColumn}const a=i.join(""),[h,t,v]=(0,m.$Kt)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(T.w);const b=[];for(let d=0;d<u.length;d++){const n=u[d],o=n.range.startLineNumber,s=n.range.startColumn,r=n.range.endLineNumber,i=n.range.endColumn;if(o===r&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const a=new R.$ht(o,s,r,i);b.push({range:a,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,d,n){return this.c.findMatchesLineByLine(u,b,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const d=u.startLineNumber,n=u.startColumn,[o,s,r]=(0,m.$Kt)(b);let i;if(b.length>0){const a=o+1;a===1?i=new R.$ht(d,n,d,n+s):i=new R.$ht(d,n,d+a-1,r+1)}else i=new R.$ht(d,n,d,n);return i}static _getInverseEditRanges(u){const b=[];let d=0,n=0,o=null;for(let s=0,r=u.length;s<r;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=d,h=n+(i.range.startColumn-o.range.endColumn)):(a=d+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new R.$ht(a,h,a,h+i.firstLineLength):t=new R.$ht(a,h,a+v-1,i.lastLineLength+1)}else t=new R.$ht(a,h,a,h);d=t.endLineNumber,n=t.endColumn,b.push(t),o=i}return b}static u(u,b){const d=R.$ht.compareRangesUsingEnds(u.range,b.range);return d===0?u.sortIndex-b.sortIndex:d}static w(u,b){const d=R.$ht.compareRangesUsingEnds(u.range,b.range);return d===0?b.sortIndex-u.sortIndex:-d}}e.$IC=T}),define(Re[149],Ae([1,0,15,92,148]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=void 0;class O{constructor(g,E,T,k,u,b,d,n,o){this.a=g,this.b=E,this.c=T,this.d=k,this.e=u,this.f=b,this.g=d,this.h=n,this.j=o}k(g){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?g===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(g){const E=this.k(g),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let u=0,b=T.length;u<b;u++){const d=T[u].buffer.replace(/\r\n|\r|\n/g,E),n=(0,N.$DC)(d);T[u]=new N.$GC(d,n)}const k=new R.$IC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&I.$Of(g)&&(this.b=I.$Nf,g=g.substr(1));const E=g.charCodeAt(g.length-1);E===13||E>=55296&&E<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=E):(this.m(g,!1),this.c=!1,this.d=E)}m(g,E){!E&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const E=(0,N.$EC)(this.e,g);this.a.push(new N.$GC(g,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Ef(g)),this.k||(this.k=I.$Hf(g)))}finish(g=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const E=(0,N.$DC)(g.buffer);g.lineStarts=E,this.d===13&&this.f++}}}e.$JC=M}),define(Re[97],Ae([1,0,22,21]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbb=g,e.$ebb=T;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function O(k){for(let u=0,b=k.length;u<b;u+=4){const d=k[u+0],n=k[u+1],o=k[u+2],s=k[u+3];k[u+0]=s,k[u+1]=o,k[u+2]=n,k[u+3]=d}}function M(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return N.$D()||O(u),I.$ze.wrap(u)}function m(k){const u=k.buffer;if(N.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function g(k){const u=new Uint32Array(E(k));let b=0;if(u[b++]=k.id,k.type==="full")u[b++]=1,u[b++]=k.data.length,u.set(k.data,b),b+=k.data.length;else{u[b++]=2,u[b++]=k.deltas.length;for(const d of k.deltas)u[b++]=d.start,u[b++]=d.deleteCount,d.data?(u[b++]=d.data.length,u.set(d.data,b),b+=d.data.length):u[b++]=0}return M(u)}function E(k){let u=0;if(u+=2,k.type==="full")u+=1+k.data.length;else{u+=1,u+=3*k.deltas.length;for(const b of k.deltas)b.data&&(u+=b.data.length)}return u}function T(k){const u=m(k);let b=0;const d=u[b++];if(u[b++]===1){const r=u[b++],i=u.subarray(b,b+r);return b+=r,{id:d,type:"full",data:i}}const o=u[b++],s=[];for(let r=0;r<o;r++){const i=u[b++],a=u[b++],h=u[b++];let t;h>0&&(t=u.subarray(b,b+h),b+=h),s[r]={start:i,deleteCount:a,data:t}}return{id:d,type:"delta",deltas:s}}}),define(Re[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Re[151],Ae([1,0,18,26,21,134,152,150]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=a,e.stringSet=v,e.cursorStyleToString=y,e.filterValidationDecorations=de;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(Y,me,He,ye){this.id=Y,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Y,me){return b(Y,me)}compute(Y,me,He){return He}}class u{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=u;function b(Z,Y){if(typeof Z!="object"||typeof Y!="object"||!Z||!Y)return new u(Y,Z!==Y);if(Array.isArray(Z)||Array.isArray(Y)){const He=Array.isArray(Z)&&Array.isArray(Y)&&I.$ub(Z,Y);return new u(Y,!He)}let me=!1;for(const He in Y)if(Y.hasOwnProperty(He)){const ye=b(Z[He],Y[He]);ye.didChange&&(Z[He]=ye.newValue,me=!0)}return new u(Z,me)}class d{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return b(Y,me)}validate(Y){return this.defaultValue}}class n{constructor(Y,me,He,ye){this.id=Y,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Y,me){return b(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,He){return He}}function o(Z,Y){return typeof Z>"u"?Y:Z==="false"?!1:!!Z}class s extends n{constructor(Y,me,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Y,me,He,ye)}validate(Y){return o(Y,this.defaultValue)}}function r(Z,Y,me,He){if(typeof Z>"u")return Y;let ye=parseInt(Z,10);return isNaN(ye)?Y:(ye=Math.max(me,ye),ye=Math.min(He,ye),ye|0)}class i extends n{static clampedInt(Y,me,He,ye){return r(Y,me,He,ye)}constructor(Y,me,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Y,me,He,dt),this.minimum=ye,this.maximum=ot}validate(Y){return i.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function a(Z,Y,me,He){if(typeof Z>"u")return Y;const ye=h.float(Z,Y);return h.clamp(ye,me,He)}class h extends n{static clamp(Y,me,He){return Y<me?me:Y>He?He:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const He=parseFloat(Y);return isNaN(He)?me:He}constructor(Y,me,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Y,me,He,ot),this.validationFn=ye}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class t extends n{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Y,me,He,ye)}validate(Y){return t.string(Y,this.defaultValue)}}function v(Z,Y,me,He){return typeof Z!="string"?Y:He&&Z in He?He[Z]:me.indexOf(Z)===-1?Y:Z}class c extends n{constructor(Y,me,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Y,me,He,ot),this.c=ye}validate(Y){return v(Y,this.defaultValue,this.c)}}class $ extends k{constructor(Y,me,He,ye,ot,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=ot,Pt.default=ye),super(Y,me,He,Pt),this.c=ot,this.d=dt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,He){return He===0?Y.accessibilitySupport:He}}class l extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function f(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(Z){switch(Z){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(Z){switch(Z){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class P extends d{constructor(){super(142)}compute(Y,me,He){const ye=["monaco-editor"];return me.get(39)&&ye.push(me.get(39)),Y.extraEditorClassName&&ye.push(Y.extraEditorClassName),me.get(74)==="default"?ye.push("mouse-default"):me.get(74)==="copy"&&ye.push("mouse-copy"),me.get(111)&&ye.push("showUnused"),me.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Y,me,He){return He&&Y.emptySelectionClipboard}}class V extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:m.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:m.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":v(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":v(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?q.OFF:Y==="true"?q.ON:Y:Y?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?A.OFF:Y==="true"?A.TRANSLATE:Y:Y?A.TRANSLATE:A.OFF}compute(Y,me,He){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends d{constructor(){super(50)}compute(Y,me,He){return Y.fontInfo}}class K extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Y){const me=h.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Y,me,He){return Y.fontInfo.fontSize}}class ie extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(i.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:He,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:He,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:He,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:He,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:He,description:m.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:v(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??v(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??v(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??v(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??v(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??v(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:m.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends d{constructor(){super(145)}compute(Y,me,He){return ue.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,He=Math.floor(Y.paddingTop/Y.lineHeight);let ye=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(ye=Math.max(ye,me-1));const ot=(He+Y.viewLineCount+ye)/(Y.pixelRatio*Y.height),dt=Math.floor(Y.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Y,me){const He=Y.outerWidth,ye=Y.outerHeight,ot=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=me.stableMinimapLayoutInput,Pt=dt&&Y.outerHeight===dt.outerHeight&&Y.lineHeight===dt.lineHeight&&Y.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===dt.pixelRatio&&Y.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Y.paddingTop===dt.paddingTop&&Y.paddingBottom===dt.paddingBottom&&Y.minimap.enabled===dt.minimap.enabled&&Y.minimap.side===dt.minimap.side&&Y.minimap.size===dt.minimap.size&&Y.minimap.showSlider===dt.minimap.showSlider&&Y.minimap.renderCharacters===dt.minimap.renderCharacters&&Y.minimap.maxColumn===dt.minimap.maxColumn&&Y.minimap.scale===dt.minimap.scale&&Y.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Y.isViewportWrapping===dt.isViewportWrapping,Bt=Y.lineHeight,Xt=Y.typicalHalfwidthCharacterWidth,qt=Y.scrollBeyondLastLine,xt=Y.minimap.renderCharacters;let Et=ot>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Vt=Y.minimap.maxColumn,Ht=Y.minimap.size,Ze=Y.minimap.side,ri=Y.verticalScrollbarWidth,_t=Y.viewLineCount,ht=Y.remainingWidth,$t=Y.isViewportWrapping,ei=xt?2:3;let ti=Math.floor(ot*ye);const Lt=ti/ot;let gt=!1,zt=!1,ii=ei*Et,Tt=Et/ot,Ke=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Jt,desiredRatio:oi,minimapLineCount:Ct}=ue.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:qt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:ye,lineHeight:Bt,pixelRatio:ot});if(_t/Ct>1)gt=!0,zt=!0,Et=1,ii=1,Tt=Et/ot;else{let It=!1,Dt=Et+1;if(Ht==="fit"){const vt=Math.ceil((Kt+_t+Jt)*ii);$t&&Pt&&ht<=me.stableFitRemainingWidth?(It=!0,Dt=me.stableFitMaxMinimapScale):It=vt>ti}if(Ht==="fill"||It){gt=!0;const vt=Et;ii=Math.min(Bt*ot,Math.max(1,Math.floor(1/oi))),$t&&Pt&&ht<=me.stableFitRemainingWidth&&(Dt=me.stableFitMaxMinimapScale),Et=Math.min(Dt,Math.max(1,Math.floor(ii/ei))),Et>vt&&(Ke=Math.min(2,Et/vt)),Tt=Et/ot/Ke,ti=Math.ceil(Math.max(Ut,Kt+_t+Jt)*ii),$t?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const si=Math.floor(Vt*Tt),Gt=Math.min(si,Math.max(0,Math.floor((ht-ri-2)*Tt/(Xt+Tt)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(ot*Gt);const mt=jt/ot;jt=Math.floor(jt*Ke);const Ot=xt?1:2,Mt=Ze==="left"?0:He-Gt-ri;return{renderMinimap:Ot,minimapLeft:Mt,minimapWidth:Gt,minimapHeightIsEditorHeight:gt,minimapIsSampling:zt,minimapScale:Et,minimapLineHeight:ii,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:ti,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Lt}}static computeLayout(Y,me){const He=me.outerWidth|0,ye=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Bt=me.maxDigitWidth,Xt=me.pixelRatio,qt=me.viewLineCount,xt=Y.get(137),Et=xt==="inherit"?Y.get(136):xt,Vt=Et==="inherit"?Y.get(132):Et,Ht=Y.get(135),Ze=me.isDominatedByLongLines,ri=Y.get(57),_t=Y.get(68).renderType!==0,ht=Y.get(69),$t=Y.get(105),ei=Y.get(84),ti=Y.get(73),Lt=Y.get(103),gt=Lt.verticalScrollbarSize,zt=Lt.verticalHasArrows,ii=Lt.arrowSize,Tt=Lt.horizontalScrollbarSize,Ke=Y.get(43),si=Y.get(110)!=="never";let Gt=Y.get(66);Ke&&si&&(Gt+=16);let jt=0;if(_t){const li=Math.max(dt,ht);jt=Math.round(li*Bt)}let mt=0;ri&&(mt=ot*me.glyphMarginDecorationLaneCount);let Ot=0,Mt=Ot+mt,Ut=Mt+jt,Kt=Ut+Gt;const Jt=He-mt-jt-Gt;let oi=!1,Ct=!1,Nt=-1;Et==="inherit"&&Ze?(oi=!0,Ct=!0):Vt==="on"||Vt==="bounded"?Ct=!0:Vt==="wordWrapColumn"&&(Nt=Ht);const It=ue.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Xt,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:ti,verticalScrollbarWidth:gt,viewLineCount:qt,remainingWidth:Jt,isViewportWrapping:Ct},me.memory||new T);It.renderMinimap!==0&&It.minimapLeft===0&&(Ot+=It.minimapWidth,Mt+=It.minimapWidth,Ut+=It.minimapWidth,Kt+=It.minimapWidth);const Dt=Jt-It.minimapWidth,vt=Math.max(1,Math.floor((Dt-gt-2)/Pt)),St=zt?ii:0;return Ct&&(Nt=Math.max(1,vt),Vt==="bounded"&&(Nt=Math.min(Nt,Ht))),{width:He,height:ye,glyphMarginLeft:Ot,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:jt,decorationsLeft:Ut,decorationsWidth:Gt,contentLeft:Kt,contentWidth:Dt,minimap:It,viewportColumn:vt,isWordWrapMinified:oi,isViewportWrapping:Ct,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Tt,overviewRuler:{top:St,width:gt,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class pe extends k{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Y){return v(Y,"simple",["simple","advanced"])}compute(Y,me,He){return me.get(2)===2?"advanced":He}}var re;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class Se extends k{constructor(){const Y={enabled:re.On};super(65,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:Y.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:v(Y.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class Le extends k{constructor(){const Y={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:m.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:m.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:v(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class j extends k{constructor(){super(66,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):i.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,me,He){return He<0?i.clampedInt(-He*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:m.localize(66,null)})}compute(Y,me,He){return Y.fontInfo.lineHeight}}class ve extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Y.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:m.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Y.showRegionSectionHeaders,description:m.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Y.showMarkSectionHeaders,description:m.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Y.sectionHeaderFontSize,description:m.localize(80,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:v(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(me.side,this.defaultValue.side,["right","left"]),showSlider:v(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ne(Z){return Z==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends k{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(82,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class $e extends k{constructor(){const Y={enabled:!0,cycle:!0};super(86,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:m.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:m.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class fe extends d{constructor(){super(143)}compute(Y,me,He){return Y.pixelRatio}}class Q extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)]}];super(89,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:m.localize(88,null)},comments:{anyOf:me,default:Y.comments,description:m.localize(89,null)},other:{anyOf:me,default:Y.other,description:m.localize(90,null)}},default:Y,markdownDescription:m.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Xt=Y?"on":"off";return{comments:Xt,strings:Xt,other:Xt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:He,strings:ye}=Y,ot=["on","inline","off"];let dt,Pt,Bt;return typeof me=="boolean"?dt=me?"on":"off":dt=v(me,this.defaultValue.other,ot),typeof He=="boolean"?Pt=He?"on":"off":Pt=v(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Bt=ye?"on":"off":Bt=v(ye,this.defaultValue.strings,ot),{other:dt,comments:Pt,strings:Bt}}}var X;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class le extends k{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:"on",description:m.localize(96,null)})}validate(Y){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,He=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function de(Z){const Y=Z.get(98);return Y==="editable"?Z.get(91):Y!=="on"}class Te extends k{constructor(){const Y=[],me={type:"number",description:m.localize(97,null)};super(102,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(98,null),format:"color-hex"}}}]},default:Y,description:m.localize(99,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const He of Y)if(typeof He=="number")me.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;me.push({column:i.clampedInt(ye.column,0,0,1e4),color:ye.color})}return me.sort((He,ye)=>He.column-ye.column),me}return this.defaultValue}}class he extends k{constructor(){super(92,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Ce(Z,Y){if(typeof Z!="string")return Y;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:"auto",description:m.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(104,null),m.localize(105,null),m.localize(106,null)],default:"auto",description:m.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:m.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:m.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:m.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:m.localize(111,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,He=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:i.clampedInt(me.verticalSliderSize,ye,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:m.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:m.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:m.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:m.localize(118,null)}})}applyUpdate(Y,me){let He=!1;me.allowedCharacters&&Y&&(N.$Xn(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Y&&(N.$Xn(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},He=!0));const ye=super.applyUpdate(Y,me);return He?new u(ye.newValue,!0):ye}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,me){if(typeof Y!="object"||!Y)return me;const He={};for(const[ye,ot]of Object.entries(Y))ot===!0&&(He[ye]=!0);return He}}class z extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:m.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],description:m.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:m.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:m.localize(125,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:v(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends k{constructor(){const Y={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Y,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Y.enabled,description:m.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],description:m.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Y.fontFamily,description:m.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Y.backgroundColoring,description:m.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends k{constructor(){const Y={enabled:O.$Rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:m.localize(134,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:Y.bracketPairs,description:m.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null)],default:Y.bracketPairsHorizontal,description:m.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:m.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:m.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:Y.highlightActiveIndentation,description:m.localize(148,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,Y,me){const He=me.indexOf(Z);return He===-1?Y:me[He]}class se extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(149,null),m.localize(150,null)],default:Y.insertMode,description:m.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:m.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:m.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:m.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(155,null),m.localize(156,null),m.localize(157,null),m.localize(158,null)],default:Y.selectionMode,markdownDescription:m.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:m.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:m.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:m.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:m.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:m.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(196,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:v(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:v(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends k{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(198,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Y.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends k{constructor(){const Y=[];super(130,"wordSegmenterLocales",Y,{anyOf:[{description:m.localize(199,null),type:"string"},{description:m.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Y){if(typeof Y=="string"&&(Y=[Y]),Array.isArray(Y)){const me=[];for(const He of Y)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class xe extends k{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(201,null),m.localize(202,null),m.localize(203,null),m.localize(204,null)],description:m.localize(205,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,me,He){return me.get(2)===2?0:He}}class _e extends d{constructor(){super(146)}compute(Y,me,He){const ye=me.get(145);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class et extends k{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(208,null),m.localize(209,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:v(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends k{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(212,null),m.localize(213,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:v(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?ft:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(214,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(215,null),""],markdownDescription:m.localize(216,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(226,null),""],description:m.localize(227,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(228,null),""],description:m.localize(229,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),autoIndent:Ue(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null),""],description:m.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:m.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(247,null)})),colorDecoratorActivatedOn:Ue(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(253,null)})),comments:Ue(new l),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(254,null)})),cursorBlinking:Ue(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),cursorStyle:Ue(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:m.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],markdownDescription:m.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Le),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(272,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(280,null)})),fontInfo:Ue(new U),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new A),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(284,null)})),hover:Ue(new we),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(285,null)})),lightbulb:Ue(new Se),lineDecorationsWidth:Ue(new j),lineHeight:Ue(new x),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:m.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:m.localize(287,null)})),matchBrackets:Ue(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(288,null)})),minimap:Ue(new ve),mouseStyle:Ue(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?m.localize(290,null):m.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(292,null)})),multiCursorModifier:Ue(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ne,{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorPaste:Ue(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(299,null)})),occurrencesHighlight:Ue(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],markdownDescription:m.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:m.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new Ee),pasteAs:Ue(new tt),parameterHints:Ue(new $e),peekWidgetDefaultFocus:Ue(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(305,null),m.localize(306,null)],description:m.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new he),renameOnType:Ue(new s(93,"renameOnType",!1,{description:m.localize(310,null),markdownDeprecationMessage:m.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:m.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new c(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(313,null)})),renderLineHighlight:Ue(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(314,null)],description:m.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(316,null)})),renderValidationDecorations:Ue(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(317,null),m.localize(318,null),m.localize(319,null),""],description:m.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:m.localize(321,null)})),rulers:Ue(new Te),scrollbar:Ue(new Me),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:m.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:m.localize(325,null),included:R.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:m.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:m.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:m.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(333,null),m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:m.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new se),inlineSuggest:Ue(new z),inlineEdit:Ue(new L),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(342,null)})),suggestSelection:Ue(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),tabCompletion:Ue(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null)],description:m.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new ze),unusualLineTerminators:Ue(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(351,null),m.localize(352,null),m.localize(353,null)],description:m.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:m.localize(355,null)})),wordBreak:Ue(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(356,null),m.localize(357,null)],description:m.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",M.$Ss,{description:m.localize(359,null)})),wordWrap:Ue(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(360,null),m.localize(361,null),m.localize(362,null),m.localize(363,null)],description:m.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(365,null)})),wordWrapOverride1:Ue(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(366,null)})),pixelRatio:Ue(new fe),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(367,null)})),layoutInfo:Ue(new ue),wrappingInfo:Ue(new _e),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new pe)}}),define(Re[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Re[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Re[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Re[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Re[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Re[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Re[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Re[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Re[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Re[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Re[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[187],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[188],Ae([1,0,14,155]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),m=(0,N.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const k=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:T}),this.f.push(b)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const k=this.c.substring(this.d,this.e),u=g.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,k=!1,u=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(m);return}const d=this.c.charCodeAt(T);if(k)k=!1;else if(d===47&&!u){T++;break}else d===91?u=!0:d===92?k=!0:d===93&&(u=!1);T++}for(;T<this.c.length&&g.a.has(this.c.charCodeAt(T));)T++;this.e=T;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=g}),define(Re[189],Ae([1,0,23,33,157,301]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=g,e.$yp=E,e.$zp=T,e.$Ap=k,e.$Bp=u,e.$Cp=b,e.$Dp=d;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(s){return s=s.trim(),s==="*"||M.test(s)}function E(s){if(!g(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=s.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function T(s){if(!s)return null;const r=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(r===0||(h=!1),v=!1);let c=0;if(s.preRelease){const $=m.exec(s.preRelease);if($){const[,w,p,l]=$;c=Date.UTC(Number(w),Number(p)-1,Number(l))}}return{majorBase:r,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:c}}function k(s,r,i){let a;typeof s=="string"?a=T(E(s)):a=s;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!a||!t)return!1;const v=a.majorBase,c=a.minorBase,$=a.patchBase;let w=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let f=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?v>w?!0:v<w?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(v===1&&w===0&&(!f||!S||!y)&&(w=1,p=0,l=0,f=!0,S=!1,y=!1),v<w?!1:v>w?!f:c<p?!1:c>p?!S:$<l?!1:$>l?!y:!(h&&h<D))}function u(s,r,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof a.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!a.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const $=(0,I.$1g)(i,a.main);(0,I.$Ug)($,i)||t.push([N.default.Warning,R.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const $=(0,I.$1g)(i,a.browser);(0,I.$Ug)($,i)||t.push([N.default.Warning,R.localize(12,null,$.path,i.path)])}}if(!O.valid(a.version))return t.push([N.default.Error,R.localize(13,null)]),t;const v=[];if(!b(s,r,a,h,v))for(const $ of v)t.push([N.default.Error,$]);return t}function b(s,r,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:n(s,r,i.engines.vscode,h)}function d(s,r,i){return s==="*"||n(r,i,s)}function n(s,r,i,a=[]){const h=T(E(i));if(!h)return a.push(R.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(R.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(R.localize(16,null,i)),!1;return k(s,r,h)?!0:(a.push(R.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let r=0,i=s.length;r<i;r++)if(typeof s[r]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class I{constructor(R,O=[],M=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$ki=I}),define(Re[55],Ae([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=O,e.$ms=M;const N=[];var R;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function O(m,g,E){g instanceof I.$ki||(g=new I.$ki(g,[],!!E)),N.push([m,g])}function M(){return N}}),define(Re[190],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$2q=I;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const m=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const m of this.a.values())m.outgoing.delete(M),m.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let m=this.a.get(M);return m||(m=new I(M,O),this.a.set(M,m)),m}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,m]of this.a)O.push(`${M}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const m=new Set([O]),g=this.c(M,m);if(g)return g}}c(O,M){for(const[m,g]of O.outgoing){if(M.has(m))return[...M,m].join(" -> ");M.add(m);const E=this.c(g,M);if(E)return E;M.delete(m)}}}e.$3q=N}),define(Re[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=R,e.$oi=O;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=m})(I||(e._util=I={})),e.$mi=R("instantiationService");function N(M,m,g){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:M,index:g}):(m[I.DI_DEPENDENCIES]=[{id:M,index:g}],m[I.DI_TARGET]=m)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const m=function(g,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(m,g,T)};return m.toString=()=>M,I.serviceIds.set(M,m),m}function O(M){return M}}),define(Re[48],Ae([1,0,17,2,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=O,e.$Vi=M,e.$Wi=g,e.$Xi=E,e.$Yi=T,e.$Zi=k,e.$1i=u,e.$2i=d,e.$3i=n,e.$4i=o,e.$Ti=(0,R.$ni)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function T(s,r){const i=Object.create(null);for(const a in s)k(i,a,s[a],r);return i}function k(s,r,i,a){const h=r.split("."),t=h.pop();let v=s;for(let c=0;c<h.length;c++){const $=h[c];let w=v[$];switch(typeof w){case"undefined":w=v[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}v=w}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(v)}`)}function u(s,r){const i=r.split(".");b(s,i)}function b(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(b(a,r),Object.keys(a).length===0&&delete s[i])}}function d(s,r,i){function a(v,c){let $=v;for(const w of c){if(typeof $!="object"||$===null)return;$=$[w]}return $}const h=r.split("."),t=a(s,h);return typeof t>"u"?i:t}function n(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?I.$3f(s[a])&&I.$3f(r[a])?n(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Re[31],Ae([1,0,21,15,188,3,154,14]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=E,e.$mj=v,e.$nj=c,e.$Gj=re;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.$j),g.set("isLinux",I.$k),g.set("isWindows",I.$i),g.set("isWeb",I.$o),g.set("isMacNative",I.$j&&!I.$o),g.set("isEdge",I.$H),g.set("isFirefox",I.$F),g.set("isChrome",I.$E),g.set("isSafari",I.$G);function E(ne,j){if(g.get(ne)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ne,j)}const T=Object.prototype.hasOwnProperty;var k;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},b=(0,M.localize)(0,null),d=(0,M.localize)(1,null),n=(0,M.localize)(2,null),o=(0,M.localize)(3,null),s=(0,M.localize)(4,null),r=(0,M.localize)(5,null),i=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=u){this.k=j,this.d=new R.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Ne=ve.type===17?r:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:R.$ij.getLexeme(ve),additionalInfo:Ne}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const x=this.o();j.push(x)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const x=this.s();j.push(x)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=j.lexeme;if(this.z(),this.y(9)){const Ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ne.type!==10)throw this.B("REGEX",Ne);const Ee=Ne.lexeme,$e=Ee.lastIndexOf("/"),fe=$e===Ee.length-1?void 0:this.w(Ee.substring($e+1));let Q;try{Q=new RegExp(Ee.substring(1,$e),fe)}catch{throw this.B("REGEX",Ne)}return U.create(x,Q)}switch(Ne.type){case 10:case 19:{const Ee=[Ne.lexeme];this.z();let $e=this.D(),fe=0;for(let Te=0;Te<Ne.lexeme.length;Te++)Ne.lexeme.charCodeAt(Te)===40?fe++:Ne.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<$e.lexeme.length;Te++)$e.lexeme.charCodeAt(Te)===40?fe++:Ne.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;Ee.push(R.$ij.getLexeme($e)),this.z(),$e=this.D()}const Q=Ee.join(""),X=Q.lastIndexOf("/"),le=X===Q.length-1?void 0:this.w(Q.substring(X+1));let de;try{de=new RegExp(Q.substring(1,X),le)}catch{throw this.B("REGEX",Ne)}return t.regex(x,de)}case 18:{const Ee=Ne.lexeme;this.z();let $e=null;if(!(0,N.$Ze)(Ee)){const fe=Ee.indexOf("/"),Q=Ee.lastIndexOf("/");if(fe!==Q&&fe>=0){const X=Ee.slice(fe+1,Q),le=Ee[Q+1]==="i"?"i":"";try{$e=new RegExp(X,le)}catch{throw this.B("REGEX",Ne)}}}if($e===null)throw this.B("REGEX",Ne);return U.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Ne=this.u();return t.notIn(x,Ne)}switch(this.D().type){case 3:{this.z();const Ne=this.u();if(this.x().type===18)return t.equals(x,Ne);switch(Ne){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Ne)}}case 4:{this.z();const Ne=this.u();if(this.x().type===18)return t.notEquals(x,Ne);switch(Ne){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Ne)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:j.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,x){if(this.C(j))return this.z();throw this.B(x,this.D())}B(j,x,ve){const Ne=(0,M.localize)(8,null,j,R.$ij.getLexeme(x)),Ee=x.offset,$e=R.$ij.getLexeme(x);return this.h.push({message:Ne,offset:Ee,lexeme:$e,additionalInfo:ve}),h.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=h;class t{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(j){return l.create(j)}static equals(j,x){return D.create(j,x)}static notEquals(j,x){return y.create(j,x)}static regex(j,x){return U.create(j,x)}static in(j,x){return f.create(j,x)}static notIn(j,x){return S.create(j,x)}static not(j){return C.create(j)}static and(...j){return ce.create(j,null,!0)}static or(...j){return we.create(j,null,!0)}static greater(j,x){return W.create(j,x)}static greaterEquals(j,x){return V.create(j,x)}static smaller(j,x){return q.create(j,x)}static smallerEquals(j,x){return A.create(j,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$lj=t;function v(ne){const j=new h({regexParsingWithErrorRecovery:!1});return ne.map(x=>(j.parse(x),j.lexingErrors.length>0?j.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,M.localize)(9,null,ve.additionalInfo):(0,M.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function c(ne,j){const x=ne?ne.substituteConstants():void 0,ve=j?j.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function $(ne,j){return ne.cmp(j)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return p.INSTANCE}}e.$oj=w;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return w.INSTANCE}}e.$pj=p;class l{static create(j,x=null){const ve=g.get(j);return typeof ve=="boolean"?ve?p.INSTANCE:w.INSTANCE:new l(j,x)}constructor(j,x){this.key=j,this.c=x,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=g.get(this.key);return typeof j=="boolean"?j?p.INSTANCE:w.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$qj=l;class D{static create(j,x,ve=null){if(typeof x=="boolean")return x?l.create(j,ve):C.create(j,ve);const Ne=g.get(j);return typeof Ne=="boolean"?x===(Ne?"true":"false")?p.INSTANCE:w.INSTANCE:new D(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=g.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?p.INSTANCE:w.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$rj=D;class f{static create(j,x){return new f(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.f),ve=j.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?T.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$sj=f;class S{static create(j,x){return new S(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=11,this.c=f.create(j,x)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=S;class y{static create(j,x,ve=null){if(typeof x=="boolean")return x?C.create(j,ve):l.create(j,ve);const Ne=g.get(j);return typeof Ne=="boolean"?x===(Ne?"true":"false")?w.INSTANCE:p.INSTANCE:new y(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=g.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?w.INSTANCE:p.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$uj=y;class C{static create(j,x=null){const ve=g.get(j);return typeof ve=="boolean"?ve?w.INSTANCE:p.INSTANCE:new C(j,x)}constructor(j,x){this.c=j,this.d=x,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=g.get(this.c);return typeof j=="boolean"?j?w.INSTANCE:p.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$vj=C;function P(ne,j){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?j(ne):w.INSTANCE}class W{static create(j,x,ve=null){return P(x,Ne=>new W(j,Ne,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$wj=W;class V{static create(j,x,ve=null){return P(x,Ne=>new V(j,Ne,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$xj=V;class q{static create(j,x,ve=null){return P(x,Ne=>new q(j,Ne,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$yj=q;class A{static create(j,x,ve=null){return P(x,Ne=>new A(j,Ne,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$zj=A;class U{static create(j,x){return new U(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return x<ve?-1:x>ve?1:0}equals(j){if(j.type===this.type){const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return this.d===j.d&&x===ve}return!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Aj=U;class K{static create(j){return new K(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new K(this.c.map(j))}negate(){return this.c}}e.$Bj=K;function ie(ne){let j=null;for(let x=0,ve=ne.length;x<ve;x++){const Ne=ne[x].substituteConstants();if(ne[x]!==Ne&&j===null){j=[];for(let Ee=0;Ee<x;Ee++)j[Ee]=ne[Ee]}j!==null&&(j[x]=Ne)}return j===null?ne:j}class ce{static create(j,x,ve){return ce.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Ne=$(this.expr[x],j.expr[x]);if(Ne!==0)return Ne}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:ce.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(j))return!1;return!0}static d(j,x,ve){const Ne=[];let Ee=!1;for(const $e of j)if($e){if($e.type===1){Ee=!0;continue}if($e.type===0)return w.INSTANCE;if($e.type===6){Ne.push(...$e.expr);continue}Ne.push($e)}if(Ne.length===0&&Ee)return p.INSTANCE;if(Ne.length!==0){if(Ne.length===1)return Ne[0];Ne.sort($);for(let $e=1;$e<Ne.length;$e++)Ne[$e-1].equals(Ne[$e])&&(Ne.splice($e,1),$e--);if(Ne.length===1)return Ne[0];for(;Ne.length>1;){const $e=Ne[Ne.length-1];if($e.type!==9)break;Ne.pop();const fe=Ne.pop(),Q=Ne.length===0,X=we.create($e.expr.map(le=>ce.create([le,fe],null,ve)),null,Q);X&&(Ne.push(X),Ne.sort($))}if(Ne.length===1)return Ne[0];if(ve){for(let $e=0;$e<Ne.length;$e++)for(let fe=$e+1;fe<Ne.length;fe++)if(Ne[$e].negate().equals(Ne[fe]))return w.INSTANCE;if(Ne.length===1)return Ne[0]}return new ce(Ne,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ce(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());this.c=we.create(j,this,!0)}return this.c}}e.$Cj=ce;class we{static create(j,x,ve){return we.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Ne=$(this.expr[x],j.expr[x]);if(Ne!==0)return Ne}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:we.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(j))return!0;return!1}static d(j,x,ve){let Ne=[],Ee=!1;if(j){for(let $e=0,fe=j.length;$e<fe;$e++){const Q=j[$e];if(Q){if(Q.type===0){Ee=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Ne=Ne.concat(Q.expr);continue}Ne.push(Q)}}if(Ne.length===0&&Ee)return w.INSTANCE;Ne.sort($)}if(Ne.length!==0){if(Ne.length===1)return Ne[0];for(let $e=1;$e<Ne.length;$e++)Ne[$e-1].equals(Ne[$e])&&(Ne.splice($e,1),$e--);if(Ne.length===1)return Ne[0];if(ve){for(let $e=0;$e<Ne.length;$e++)for(let fe=$e+1;fe<Ne.length;fe++)if(Ne[$e].negate().equals(Ne[fe]))return p.INSTANCE;if(Ne.length===1)return Ne[0]}return new we(Ne,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new we(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());for(;j.length>1;){const x=j.shift(),ve=j.shift(),Ne=[];for(const Ee of Le(x))for(const $e of Le(ve))Ne.push(ce.create([Ee,$e],null,!1));j.unshift(we.create(Ne,null,!1))}this.c=we.create(j,this,!0)}return this.c}}e.$Dj=we;class Ie extends l{static{this.d=[]}static all(){return Ie.d.values()}constructor(j,x,ve){super(j,null),this.f=x,typeof ve=="object"?Ie.d.push({...ve,key:j}):ve!==!0&&Ie.d.push({key:j,description:ve,type:x!=null?typeof x:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return D.create(this.key,j)}notEqualsTo(j){return y.create(this.key,j)}}e.$Ej=Ie,e.$Fj=(0,O.$ni)("contextKeyService");function ue(ne,j){return ne<j?-1:ne>j?1:0}function pe(ne,j,x,ve){return ne<x?-1:ne>x?1:j<ve?-1:j>ve?1:0}function re(ne,j){if(ne.type===0||j.type===1)return!0;if(ne.type===9)return j.type===9?Se(ne.expr,j.expr):!1;if(j.type===9){for(const x of j.expr)if(re(ne,x))return!0;return!1}if(ne.type===6){if(j.type===6)return Se(j.expr,ne.expr);for(const x of ne.expr)if(re(x,j))return!0;return!1}return ne.equals(j)}function Se(ne,j){let x=0,ve=0;for(;x<ne.length&&ve<j.length;){const Ne=ne[x].cmp(j[ve]);if(Ne<0)return!1;Ne===0&&x++,ve++}return x===ne.length}function Le(ne){return ne.type===9?ne.expr:[ne]}}),define(Re[191],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,I.$ni)("environmentService"),e.$vi=(0,I.$oi)(e.$ui)}),define(Re[98],Ae([1,0,156,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=R,e.$Ro=O,e.$So=M,e.$To=m,e.$Uo=g,e.$Vo=E,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function g(i,a,h){return m(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Wo=(0,N.$ni)("extensionGalleryService");var d;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var n;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Xo=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class r extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Yo=r,e.$Zo=(0,N.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,N.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,N.$ni)("IExtensionTipsService"),e.$5o=(0,I.localize2)(0,"Extensions"),e.$6o=(0,I.localize2)(1,"Preferences")}),define(Re[43],Ae([1,0,52,19,15,17,2,158,3,21,12,40]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=u,e.$Vk=n,e.$Wk=s,e.$Xk=r,e.$Yk=i,e.$Zk=a,e.$1k=h,e.$2k=t,e.$3k=v,e.$4k=c,e.$5k=$,e.$7k=l,e.$8k=D,e.$9k=f,e.$0k=S,e.$$k=y,e.$bl=q,e.$nl=we,e.$ol=Ie,e.$ql=pe,e.$Tk=(0,g.$ni)("fileService");function u(re){return re.create===!0}var b;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function n(re){const Se=re;return!!Se&&typeof Se.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(re){return!!(re.capabilities&2)}function r(re){return!!(re.capabilities&8)}function i(re){return!!(re.capabilities&131072)}function a(re){return!!(re.capabilities&4)}function h(re){return!!(re.capabilities&16)}function t(re){return s(re)?!!(re.capabilities&16384):!1}function v(re){return s(re)?!!(re.capabilities&32768):!1}function c(re){return!!(re.capabilities&65536)}function $(re){return!!(re.capabilities&2048)}var w;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class p extends Error{static create(Se,Le){const ne=new p(Se.toString(),Le);return f(ne,Le),ne}constructor(Se,Le){super(Se),this.code=Le}}e.$6k=p;function l(re,Se){return p.create(re,Se)}function D(re){return re||l((0,m.localize)(0,null),w.Unknown)}function f(re,Se){return re.name=Se?`${Se} (FileSystemError)`:"FileSystemError",re}function S(re){if(!re)return w.Unknown;if(re instanceof p)return re.code;const Se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Se)return w.Unknown;switch(Se[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function y(re){if(re instanceof A)return re.fileOperationResult;switch(S(re)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}var C;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class P{constructor(Se,Le,ne){this.resource=Se,this.operation=Le,this.target=ne}isOperation(Se){return this.operation===Se}}e.$_k=P;var W;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class V{static{this.a=null}constructor(Se,Le){this.c=Le,this.b=void 0,this.d=new k.$V(()=>{const ne=I.$ti.forUris(()=>this.c);return ne.fill(this.rawAdded.map(j=>[j,!0])),ne}),this.f=new k.$V(()=>{const ne=I.$ti.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(j=>[j,!0])),ne}),this.g=new k.$V(()=>{const ne=I.$ti.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(j=>[j,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Se){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==V.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Se,...Le){return this.h(Se,{includeChildren:!1},...Le)}affects(Se,...Le){return this.h(Se,{includeChildren:!0},...Le)}h(Se,Le,...ne){if(!Se)return!1;const j=ne.length>0;return!!((!j||ne.includes(1))&&(this.d.value.get(Se)||Le.includeChildren&&this.d.value.findSuperstr(Se))||(!j||ne.includes(0))&&(this.f.value.get(Se)||Le.includeChildren&&this.f.value.findSuperstr(Se))||(!j||ne.includes(2))&&(this.g.value.findSubstr(Se)||Le.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$al=V;function q(re,Se,Le){return!re||!Se||re===Se||Se.length>re.length?!1:(Se.charAt(Se.length-1)!==N.sep&&(Se+=N.sep),Le?(0,R.$rf)(re,Se):re.indexOf(Se)===0)}class A extends Error{constructor(Se,Le,ne){super(Se),this.fileOperationResult=Le,this.options=ne}}e.$cl=A;class U extends A{constructor(Se,Le,ne,j){super(Se,Le,j),this.fileOperationResult=Le,this.size=ne}}e.$dl=U;class K extends A{constructor(Se,Le,ne){super(Se,2,ne),this.stat=Le}}e.$el=K;var ie;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var ce;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$ml="";function we(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Ie(re,Se){if(!Se.hasProvider(M.URI.from({scheme:re.scheme})))return new Promise(Le=>{const ne=Se.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===re.scheme&&j.added&&(ne.dispose(),Le())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Se){return(0,O.$5f)(Se)||(Se=0),Se<ue.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<ue.MB?(0,m.localize)(2,null,(Se/ue.KB).toFixed(2)):Se<ue.GB?(0,m.localize)(3,null,(Se/ue.MB).toFixed(2)):Se<ue.TB?(0,m.localize)(4,null,(Se/ue.GB).toFixed(2)):(0,m.localize)(5,null,(Se/ue.TB).toFixed(2))}}e.$pl=ue;function pe(re){const Se=typeof re=="string"||re?.scheme===T.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===T.Schemas.file?1024*ue.MB:Se?10*ue.MB:E.$o?50*ue.MB:1024*ue.MB}}),define(Re[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class I{constructor(...R){this.a=new Map;for(const[O,M]of R)this.set(O,M)}set(R,O){const M=this.a.get(R);return this.a.set(R,O),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$li=I}),define(Re[192],Ae([1,0,11,14,6,70,190,3,71,193]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const T=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$li,s=!1,r,i=T){this.i=o,this.j=s,this.k=r,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(m.$mi,this),this._globalGraph=i?r?._globalGraph??new M.$3q(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends u{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const r=d.traceInvocation(this.l,o);let i=!1;try{return o({get:h=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,r.stop()}}createInstance(o,...s){this.m();let r,i;return o instanceof O.$ki?(r=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(s),r)):(r=d.traceCreation(this.l,o),i=this.o(o,s,r)),r.stop(),i}o(o,s=[],r){const i=m._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),a=[];for(const t of i){const v=this.s(t.id,r);v||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}q(o,s){if(this.i.get(o)instanceof O.$ki)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.r(o);return r instanceof O.$ki?this.u(o,r,s.branch(o,!0)):(s.branch(o,!1),r)}u(o,s,r){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,r)}finally{this.t.delete(o)}}v(o,s,r){const i=new M.$3q(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:r}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new k(i);for(const v of m._util.getServiceDependencies(t.desc.ctor)){const c=this.r(v.id);if(c||this.y(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),c instanceof O.$ki){const $={id:v.id,desc:c,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new k(i);break}for(const{data:v}of t){if(this.r(v.id)instanceof O.$ki){const $=this.w(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.q(v.id,$)}i.removeNode(v)}}return this.r(o)}w(o,s,r=[],i,a){if(this.i.get(o)instanceof O.$ki)return this.x(o,s,r,i,a,this.g);if(this.k)return this.k.w(o,s,r,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,r=[],i,a,h){if(i){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const v=new Map,c=new I.$Gh(()=>{const $=t.o(s,r,a);for(const[w,p]of v){const l=$[w];if(typeof l=="function")for(const D of p)D.disposable=l.apply($,D.listener)}return v.clear(),h.add($),$});return new Proxy(Object.create(null),{get($,w){if(!c.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let D=v.get(w);return D||(D=new E.$5c,v.set(w,D)),(S,y,C)=>{if(c.isInitialized)return c.value[w](S,y,C);{const P={listener:[S,y,C],disposable:void 0},W=D.push(P);return(0,R.$Sc)(()=>{W(),P.disposable?.dispose()})}}}if(w in $)return $[w];const p=c.value;let l=p[w];return typeof l!="function"||(l=l.bind(p),$[w]=l),l},set($,w,p){return c.value[w]=p,!0},getPrototypeOf($){return s.prototype}})}else{const t=this.o(s,r,a);return h.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$4q=u;var b;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(b||(b={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new d(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,s){return o?new d(1,s.name):d.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const r=new d(3,o.toString());return this.h.push([o,s,r]),r}stop(){const o=Date.now()-this.g;d.f+=o;let s=!1;function r(a,h){const t=[],v=new Array(a+1).join("	");for(const[c,$,w]of h.h)if($&&w){s=!0,t.push(`${v}CREATES -> ${c}`);const p=r(a+1,w);p&&t.push(p)}else t.push(`${v}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||s)&&d.all.add(i.join(`
`))}}e.$5q=d}),define(Re[13],Ae([1,0,159,42,5,99,6,28,21,23,17,2,31,3]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=n,e.log=s,e.$8j=l,e.$9j=D,e.$0j=f,e.$$j=S,e.$Tj=(0,b.$ni)("logService"),e.$Uj=(0,b.$ni)("loggerService");function d(){return new Date().toISOString()}function n(y){return(0,T.$5f)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Wj=o.Info;function s(y,C,P){switch(C){case o.Trace:y.trace(P);break;case o.Debug:y.debug(P);break;case o.Info:y.info(P);break;case o.Warning:y.warn(P);break;case o.Error:y.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function r(y,C=!1){let P="";for(let W=0;W<y.length;W++){let V=y[W];if(V instanceof Error&&(V=(0,N.$$i)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}P+=(W>0?" ":"")+V}return P}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new R.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$Yj=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,r([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,r([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,r([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,r([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(o.Error,r(W))}else this.g(o.Error,r([C,...P]))}flush(){}}e.$Zj=a;class h extends i{constructor(C=e.$Wj){super(),this.setLevel(C),this.g=!g.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,C,...P):console.warn(`[main ${d()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,C,...P):console.error(`[main ${d()}]`,C,...P))}flush(){}}e.$1j=h;class t extends i{constructor(C=e.$Wj,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$2j=t;class v extends i{constructor(C,P=e.$Wj){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$$i)(C,this.f(o.Trace))}flush(){}}e.$3j=v;class c extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const W of this.g)W.trace(C,...P)}debug(C,...P){for(const W of this.g)W.debug(C,...P)}info(C,...P){for(const W of this.g)W.info(C,...P)}warn(C,...P){for(const W of this.g)W.warn(C,...P)}error(C,...P){for(const W of this.g)W.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$4j=c;class $ extends M.$Uc{constructor(C,P,W){if(super(),this.h=C,this.j=P,this.b=new m.$Bc,this.c=this.B(new R.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$_d),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,T.$1f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const W=this.n(C),V=(0,T.$1f)(C)?C:P?.id??(0,O.$bj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...P,id:V}));const U={logger:q,info:{resource:W,id:V,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(U.info),this.b.set(W,U),q}n(C){return(0,T.$1f)(C)?(0,E.$1g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(k.URI.isUri(C)){const W=C,V=P,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const W=this.m(C);W&&P!==!W.info.hidden&&(W.info.hidden=!P,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=$;class w{constructor(){this.onDidChangeLogLevel=new R.$_d().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$6j=w;class p extends w{}e.$7j=p;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Wj}function D(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$_j=new u.$Ej("logLevel",D(o.Info))}),define(Re[194],Ae([1,0,6,13]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class R extends I.$Uc{constructor(M,m=[]){super(),this.a=new N.$4j([M,...m]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...m){this.a.trace(M,...m)}debug(M,...m){this.a.debug(M,...m)}info(M,...m){this.a.info(M,...m)}warn(M,...m){this.a.warn(M,...m)}error(M,...m){this.a.error(M,...m)}flush(){this.a.flush()}}e.$vQ=R}),define(Re[100],Ae([1,0,33,160,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function E(d,n){return n-d}g.compare=E;const T=Object.create(null);T[g.Error]=(0,N.localize)(0,null),T[g.Warning]=(0,N.localize)(1,null),T[g.Info]=(0,N.localize)(2,null);function k(d){return T[d]||""}g.toString=k;function u(d){switch(d){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=u;function b(d){switch(d){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=b}(M||(e.MarkerSeverity=M={}));var m;(function(g){const E="";function T(u){return k(u,!0)}g.makeKey=T;function k(u,b){const d=[E];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(E),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(E),u.severity!==void 0&&u.severity!==null?d.push(M.toString(u.severity)):d.push(E),u.message&&b?d.push(u.message.replace("\xA6","\\\xA6")):d.push(E),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(E),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(E),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(E),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(E),d.push(E),d.join("\xA6")}g.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$Qt=(0,R.$ni)("markerService")}),define(Re[195],Ae([1,0,5,33,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qv=e.Severity=void 0,e.$Rv=m,e.Severity=N.default,e.$Qv=(0,R.$ni)("notificationService");var O;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function m(k){if(k){const u=k;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class E{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Sv=E;class T{infinite(){}done(){}total(u){}worked(u){}}e.$Tv=T}),define(Re[196],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,I.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,N){var R=arguments.length,O=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,I,N);else for(var m=ge.length-1;m>=0;m--)(M=ge[m])&&(O=(R<3?M(O):R>3?M(e,I,O):M(e,I))||O);return R>3&&O&&Object.defineProperty(e,I,O),O},We=this&&this.__param||function(ge,e){return function(I,N){e(I,N,ge)}};define(Re[101],Ae([1,0,11,24,6,3]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.ProgressLocation=e.$Uv=void 0,e.$Uv=(0,O.$ni)("progressService");var M;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Vv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Wv=m;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$Xv=g;let E=class extends R.$Uc{constructor(u,b){super(),this.a=new I.$Kh,b.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Yv=E,e.$Yv=E=Je([We(1,e.$Uv)],E);class T extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const b=++this.a,d=new N.$je;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>d.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:d.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Zv=T,e.$1v=(0,O.$ni)("editorProgressService")}),define(Re[30],Ae([1,0,56,17]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class R{constructor(){this.a=new Map}add(M,m){I.ok(N.$1f(M)),I.ok(N.$3f(m)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,m)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$6n=new R}),define(Re[72],Ae([1,0,5,30]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function R(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class O{constructor(){this.b=new I.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,E){this.a[R(g)]=E,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;N.$6n.add(e.$7n.JSONContribution,M)}),define(Re[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=n,e.$ko=o,e.$lo=s,e.$mo=i,e.$no=a;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$$n={Configuration:"base.contributions.configuration"};var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const k=g.$6n.as(m.$7n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new N.$_d,this.onDidSchemaChange=this.i.event,this.j=new N.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const c=new Set;this.n(t,v,c),k.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const v=new Set;this.o(t,v),k.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const c=new Set;this.o(v,c),this.n(t,!1,c),k.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const c=[];for(const{overrides:$,source:w}of t)for(const p in $)if(v.add(p),e.$io.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(w)for(const C of Object.keys($[p]))D.set(C,w);const f={...l?.value||{},...$[p]};this.a.set(p,{source:w,value:f,valuesSources:D});const S=(0,M.$4i)(p),y={type:"object",default:f,description:O.localize(1,null,S),$ref:e.$fo,defaultDefaultValue:f,source:R.$1f(w)?void 0:w,defaultValueSource:w};c.push(...n(p)),this.d[p]=y,this.b.properties[p]=y}else{this.a.set(p,{value:$[p],source:w});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:c,source:$}of t)for(const w in c){const p=this.a.get(w),l=R.$1f($)?$:$?.id,D=R.$1f(p?.source)?p?.source:p?.source?.id;if(l===D)if(v.add(w),this.a.delete(w),e.$io.test(w))delete this.d[w],delete this.b.properties[w];else{const f=this.d[w];f&&(this.w(w,f),this.r(w,f))}}this.u()}deltaConfiguration(t){let v=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,c){t.forEach($=>{this.p($,v,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,v){const c=$=>{if($.properties)for(const w in $.properties){v.add(w);const p=this.d[w];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[w],this.s(w,$.properties[w])}$.allOf?.forEach(w=>c(w))};for(const $ of t){c($);const w=this.c.indexOf($);w!==-1&&this.c.splice(w,1)}}p(t,v=!0,c,$,w=3,p){w=R.$0f(t.scope)?w:t.scope;const l=t.properties;if(l)for(const f in l){const S=l[f];if(v&&i(f,S)){delete l[f];continue}if(S.source=c,S.defaultDefaultValue=l[f].default,this.w(f,S),e.$io.test(f)?S.scope=void 0:(S.scope=R.$0f(S.scope)?w:S.scope,S.restricted=R.$0f(S.restricted)?!!$?.includes(f):S.restricted),l[f].hasOwnProperty("included")&&!l[f].included){this.f[f]=l[f],delete l[f];continue}else this.d[f]=l[f],l[f].policy?.name&&this.e.set(l[f].policy.name,f);!l[f].deprecationMessage&&l[f].markdownDeprecationMessage&&(l[f].deprecationMessage=l[f].markdownDeprecationMessage),p.add(f)}const D=t.allOf;if(D)for(const f of D)this.p(f,v,c,$,w,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$_n.properties[t]=v,v.scope){case 1:e.$ao.properties[t]=v;break;case 2:e.$bo.properties[t]=v;break;case 6:e.$co.properties[t]=v;break;case 3:e.$do.properties[t]=v;break;case 4:e.$eo.properties[t]=v;break;case 5:e.$eo.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$_n.properties[t],v.scope){case 1:delete e.$ao.properties[t];break;case 2:delete e.$bo.properties[t];break;case 6:delete e.$co.properties[t];break;case 3:delete e.$do.properties[t];break;case 4:case 5:delete e.$eo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,c={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$fo};this.w(v,c),e.$_n.properties[v]=c,e.$ao.properties[v]=c,e.$bo.properties[v]=c,e.$co.properties[v]=c,e.$do.properties[v]=c,e.$eo.properties[v]=c}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=t,e.$ao.patternProperties[e.$ho]=t,e.$bo.patternProperties[e.$ho]=t,e.$co.patternProperties[e.$ho]=t,e.$do.patternProperties[e.$ho]=t,e.$eo.patternProperties[e.$ho]=t,this.i.fire()}w(t,v){const c=this.a.get(t);let $=c?.value,w=c?.source;R.$8f($)&&($=v.defaultDefaultValue,w=void 0),R.$8f($)&&($=s(v.type)),v.default=$,v.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",d=new RegExp(b,"g");e.$ho=`^(${b})+$`,e.$io=new RegExp(e.$ho);function n(h){const t=[];if(e.$io.test(h)){let v=d.exec(h);for(;v?.length;){const c=v[1].trim();c&&t.push(c),v=d.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new u;g.$6n.add(e.$$n.Configuration,r);function i(h,t){return h.trim()?e.$io.test(h)?O.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function a(){const h=[],t=r.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Re[197],Ae([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=i;function b(v){return Object.isFrozen(v)?v:m.$Un(v)}class d{constructor(c={},$=[],w=[],p){this.b=c,this.c=$,this.d=w,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof d)return $;const w=new n("");return w.parseRaw($),w.configurationModel});this.f=c.reduce(($,w)=>w===$?w:$.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,T.$2i)(this.contents,c):this.contents}inspect(c,$){const w=this;return{get value(){return b(w.rawConfiguration.getValue(c))},get override(){return $?b(w.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return b($?w.rawConfiguration.override($).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:f}of w.rawConfiguration.overrides){const S=new d(l,f).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?b(p):void 0}}}getOverrideValue(c,$){const w=this.i($);return w?c?(0,T.$2i)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const w of this.overrides)w.identifiers.includes(c)&&$.push(...w.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=m.$Tn(this.contents),w=m.$Tn(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const f of D.overrides){const[S]=w.filter(y=>I.$ub(y.identifiers,f.identifiers));S?(this.h(S.contents,f.contents),S.keys.push(...f.keys),S.keys=I.$Mb(S.keys)):w.push(m.$Tn(f))}for(const f of D.keys)p.indexOf(f)===-1&&p.push(f)}return new d($,p,w,l.every(D=>D instanceof d)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const w={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=m.$Tn(l),this.h(l,D)):l=D),w[p]=l}return new d(w,this.keys,this.overrides)}h(c,$){for(const w of Object.keys($)){if(w in c&&g.$3f(c[w])&&g.$3f($[w])){this.h(c[w],$[w]);continue}c[w]=m.$Tn($[w])}}i(c){let $=null,w=null;const p=l=>{l&&(w?this.h(w,l):w=m.$Tn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,T.$1i)(this.contents,c),k.$io.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>I.$ub(w.identifiers,(0,k.$jo)(c))),1))}j(c,$,w){(0,T.$Zi)(this.contents,c,$,p=>console.error(p)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),k.$io.test(c)&&this.overrides.push({identifiers:(0,k.$jo)(c),keys:Object.keys(this.contents[c]),contents:(0,T.$Yi)(this.contents[c],p=>console.error(p))})}}e.$oo=d;class n{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!g.$0f(c)){const w=this.g(c);this.parseRaw(w,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:w,keys:p,overrides:l,restricted:D,hasExcludedProperties:f}=this.h(c,$);this.b=new d(w,p,l,f?[c]:void 0),this.c=D||[]}g(c){let $={},w=null,p=[];const l=[],D=[];function f(y){Array.isArray(p)?p.push(y):w!==null&&(p[w]=y)}const S={onObjectBegin:()=>{const y={};f(y),l.push(p),p=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const y=[];f(y),l.push(p),p=y,w=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:f,onError:(y,C,P)=>{D.push({error:y,offset:C,length:P})}};if(c)try{R.$Hn(c,S),$=p[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}h(c,$){const w=u.$6n.as(k.$$n.Configuration).getConfigurationProperties(),p=this.i(c,w,!0,$);c=p.raw;const l=(0,T.$Yi)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),f=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:f,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,w,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},f=[];for(const S in c)if(k.$io.test(S)&&w){const y=this.i(c[S],$,!1,p);D[S]=y.raw,l=l||y.hasExcludedProperties,f.push(...y.restricted)}else{const y=$[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&f.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(C===void 0||p.scopes===void 0||p.scopes.includes(C))&&!(p.skipRestricted&&y?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:f,hasExcludedProperties:l}}j(c,$){const w=[];for(const p of Object.keys(c))if(k.$io.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];w.push({identifiers:(0,k.$jo)(p),keys:Object.keys(l),contents:(0,T.$Yi)(l,$)})}return w}}e.$po=n;class o extends O.$Uc{constructor(c,$,w,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new N.$_d),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&w.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=o;class s{constructor(c,$,w,p,l,D,f,S,y,C,P,W,V){this.a=c,this.b=$,this.c=w,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=f,this.h=S,this.i=y,this.j=C,this.k=P,this.l=W,this.m=V}get value(){return b(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,$,w,p,l=new d,D=new d,f=new M.$Bc,S=new d,y=new M.$Bc){this.c=c,this.d=$,this.f=w,this.g=p,this.h=l,this.i=D,this.j=f,this.l=S,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(c,$,w){return this.p(c,$,w).getValue(c)}updateValue(c,$,w={}){let p;w.resource?(p=this.m.get(w.resource),p||(p=new d,this.m.set(w.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),w.resource||(this.a=null)}inspect(c,$,w){const p=this.p(c,$,w),l=this.t($.resource,w),D=$.resource?this.m.get($.resource)||this.l:this.l,f=new Set;for(const S of p.overrides)for(const y of S.identifiers)p.getOverrideValue(c,y)!==void 0&&f.add(y);return new s(c,$,p.getValue(c),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const w=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,k.$jo)(p)){const D=this.c.getKeysForOverrideIdentifier(l),f=c.getKeysForOverrideIdentifier(l),S=[...f.filter(y=>D.indexOf(y)===-1),...D.filter(y=>f.indexOf(y)===-1),...D.filter(y=>!m.$Xn(this.c.override(l).getValue(y),c.override(l).getValue(y)))];w.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:w,removed:p}=h(this.d,c),l=[...$,...w,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const w=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:f}=h(w,$),S=[...p,...l,...D];return(S.length||!w)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...w,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,w){let p=this.q($,w);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let w=this.r();if($&&c){const p=$.getFolder(c);p&&(w=this.s(p.uri)||w);const l=this.m.get(c);l&&(w=w.merge(l))}return w}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const w=this.r(),p=this.j.get(c);p?($=w.merge(p),this.b.set(c,$)):$=w}return $}t(c,$){if($&&c){const w=$.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:w,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:w,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(w=>c.add(w))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),w=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),f=c.folders.reduce((S,y)=>(S.set(E.URI.revive(y[0]),this.w(y[1])),S),new M.$Bc);return new r($,w,p,l,new d,D,f,new d,new M.$Bc)}static w(c){return new d(c.contents,c.keys,c.overrides)}}e.$ro=r;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const c=new Set,$=new Map;for(const p of v)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const f=(0,M.$yc)($,l,new Set);D.forEach(S=>f.add(S))});const w=[];return $.forEach((p,l)=>w.push([l,[...p.values()]])),{keys:[...c.values()],overrides:w}}class a{constructor(c,$,w,p){this.change=c,this.f=$,this.g=w,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,$){const w=this.a+c,p=this.d.indexOf(w);if(p<0)return!1;const l=p+w.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!m.$Xn(f,S)}return!0}}e.$to=a;function h(v,c){const{added:$,removed:w,updated:p}=t(c?.rawConfiguration,v?.rawConfiguration),l=[],D=v?.getAllOverrideIdentifiers()||[],f=c?.getAllOverrideIdentifiers()||[];if(c){const S=f.filter(y=>!D.includes(y));for(const y of S)l.push([y,c.getKeysForOverrideIdentifier(y)])}if(v){const S=D.filter(y=>!f.includes(y));for(const y of S)l.push([y,v.getKeysForOverrideIdentifier(y)])}if(c&&v){for(const S of D)if(f.includes(S)){const y=t({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:w,updated:p,overrides:l}}function t(v,c){const $=v?c?v.keys.filter(l=>c.keys.indexOf(l)===-1):[...v.keys]:[],w=c?v?c.keys.filter(l=>v.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(v&&c){for(const l of c.keys)if(v.keys.indexOf(l)!==-1){const D=(0,T.$2i)(c.contents,l),f=(0,T.$2i)(v.contents,l);m.$Xn(D,f)||p.push(l)}}return{added:$,removed:w,updated:p}}}),define(Re[102],Ae([1,0,14,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=E,e.$yl=(0,N.$ni)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class O{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=O;class M{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=M;var m;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends I.$bb{static isNotAvailable(k){return k instanceof g&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,u=m.Unknown,b){super(k),this._message=k,this._code=u,this._detail=b,this.isHandled=u===m.NotAvailable&&b===!0,Object.setPrototypeOf(this,g.prototype)}}e.$Bl=g;function E(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}}),define(Re[58],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=N,e.$zm=R,e.$Am=O,e.$Bm=M;function N(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const E=g.indexOf("+");return E<0?g:g.substr(0,E)}function O(g){const{host:E,port:T}=m(g);if(typeof T>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function M(g,E){let{host:T,port:k}=m(g);return typeof k>"u"&&(k=E),{host:T,port:k}}function m(g){const E=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=g.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const k=g.match(/(.*):(\d+)$/);return k?{host:k[1],port:parseInt(k[2],10)}:{host:g,port:void 0}}}),define(Re[20],Ae([1,0,15,3,58]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=O,e.$Lm=k,e.$Mm=u,e.$Nm=b,e.$Om=d,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function O(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(M||(e.ExtensionType=M={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const r=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$qf(r,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Im=g;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Jm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,s){this.c.set(g.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=T;function k(n){return u(n)}function u(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}function b(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}function d(n,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$zm)(o)}`;return!!n.activationEvents?.includes(s)}return!1}e.$Pm=(0,N.$ni)("IBuiltinExtensionsScannerService")}),define(Re[103],Ae([1,0,14,20]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,m){this.a.set(M,m)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const m=Object.create(null);for(const g of M){const E=this.readActivationEvents(g);E.length>0&&(m[N.$Im.toKey(g.identifier)]=E)}return m}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const m=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${N.$Im.toKey(M.identifier)}`);if(!M.contributes)return m;for(const g in M.contributes){const E=this.a.get(g);if(!E)continue;const T=M.contributes[g],k=Array.isArray(T)?T:[T];try{E(k,m)}catch(u){(0,I.$1)(u)}}return m}}e.$_F=R,e.$aG=new R}),define(Re[198],Ae([1,0,21,73,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=M,e.$8o=m;function O(g){if(I.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,E,T,k,u,b,d,n,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=d,s.sessionID=(0,R.$Jg)()+Date.now(),s.commitHash=k,s.version=u,s["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=N.$ec,s["common.nodeArch"]=T,s["common.product"]=o||"desktop",n&&(s["common.msftInternal"]=n);let r=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=O(E);return a&&(s["common.platformDetail"]=a),s}function m(g){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return g.some(k=>T===k)}}),define(Re[199],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,I.$ni)("telemetryService"),e.$Tl=(0,I.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Re[59],Ae([1,0,26,17,58,198,199]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=T,e.$ep=k,e.$fp=u,e.$gp=b,e.$hp=n,e.$ip=s,e.$jp=r,e.$kp=h;class m{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$9o=m;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=g,e.$$o=new g;class E{async publicLog(v,c,$){}async publicLogError(v,c,$){}}e.$_o=E,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function k(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const v=t.getValue(M.$1l),c=t.getValue(M.$2l);if(t.getValue(M.$3l)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const v={},c={},$={};o(t,$);for(let w in $){w=w.length>150?w.substr(w.length-149):w;const p=$[w];typeof p=="number"?c[w]=p:typeof p=="boolean"?c[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),v[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[w]=p)}return{properties:v,measurements:c}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(t){if(!t)return"none";const v=(0,R.$zm)(t);return d.has(v)?v:"other"}function o(t,v,c=0,$){if(t)for(const w of Object.getOwnPropertyNames(t)){const p=t[w],l=$?$+w:w;Array.isArray(p)?v[l]=(0,I.$Yn)(p):p instanceof Date?v[l]=p.toISOString():(0,N.$3f)(p)?c<2?o(p,v,c+1,l+"."):v[l]=(0,I.$Yn)(p):v[l]=p}}function s(t,v){const c=t.msftInternalDomains||[],$=v.getValue("telemetry.internalTesting");return(0,O.$8o)(c)||$}function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of v)for(;;){const f=D.exec(t);if(!f)break;$.push([f.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const f=$.some(([S,y])=>D.index<y&&S<p.lastIndex);!w.test(D[0])&&!f&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of v)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,v){return(0,I.$Vn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,v);for(const w of v)$=$.replace(w,"");return $=a($),$}})}}),define(Re[200],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=T,e.$np=d,e.$op=n,e.$pp=o,e.$qp=s,e.$rp=r,e.$sp=i,e.$tp=a,e.$vp=h,e.$wp=v;function T(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$lf)(c.id,$.id)===0}const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const w=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,w,p)}static parse($){const w=k.exec($);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor($,w,p="undefined"){this.version=w,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?T(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$mp=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(c){const $=b.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function n(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(n(c??R.$Em,$))}function r(c,$){const w=[],p=l=>{for(const D of w)if(D.some(f=>T($(f),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):w.push([l])}return w}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new E.$9o(c.identifier.id),name:new E.$9o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$up=new R.$Im("pprice.better-merge");function h(c,$){const w=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&w.every(D=>!T(D.identifier,{id:l}))){const D=c.filter(f=>T(f.identifier,{id:l}));D.length===1&&(w.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(c,$){if(!O.$k)return!1;let w;try{w=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,m.$0)(l))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(c,$){const w=await t(c,$),p=(0,N.$So)(w?"alpine":O.$u,g.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Re[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=I,e.$as=N,e.$bs=R,e.$cs=O,e.$ds=M,e.$es=m;function I(g){return[...g.entries()]}function N(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function O(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(E=>[E[0],I(E[1].map),N(E[1].descriptionMap)])}function m(g){return new Map(g.map(E=>[E[0],{map:R(E[1]),descriptionMap:O(E[2])}]))}}),define(Re[202],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Csb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,O,M=5){const m=O(g=>{const E=typeof g=="string"?g:g.data;let T=this.a.get(R);if(T){T.data.push(E);return}const k=setTimeout(()=>this.flushBuffer(R),M);T={data:[E],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(R),m.dispose()}},this.a.set(R,T)});return m}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const O=this.a.get(R);O&&(this.a.delete(R),this.b(R,O.data.join("")))}}e.$Csb=I}),define(Re[203],Ae([1,0,11,91,302,41,5,17,2,161,72,30]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$6w=e.$5w=e.$4w=e.$3w=e.$2w=e.IconFontDefinition=e.IconContribution=e.$Yw=void 0,e.$Zw=o,e.$1w=s,e.$Yw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(v,c){let $=v.defaults;for(;O.ThemeIcon.isThemeIcon($);){const w=n.getIcon($.id);if(!w)return;$=w.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var b;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function v(c){const $=w=>(0,m.$1f)(w)?w:void 0;if(c&&Array.isArray(c.src)&&c.src.every(w=>(0,m.$1f)(w.format)&&(0,m.$1f)(w.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(w=>({format:w.format,location:g.URI.parse(w.location)}))}}h.fromJSONObject=v})(b||(e.IconFontDefinition=b={}));class d{constructor(){this.a=new M.$_d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,c,$){const w=this.b[t];if(w){if(c&&!w.description){w.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return w}const p={id:t,description:c,defaults:v,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const c=this.f[t];return c||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,p)=>w.id.localeCompare(p.id),v=w=>{for(;O.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(w=>this.b[w]);for(const w of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|${O.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const w of $.filter(p=>!O.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|`);return c.join(`
`)}}const n=new d;k.$6n.add(e.$Yw.IconContribution,n);function o(h,t,v,c){return n.registerIcon(h,t,v,c)}function s(){return n}function r(){const h=(0,R.$Ij)();for(const t in h){const v="\\"+h[t].toString(16);n.registerIcon(t,{fontCharacter:v})}}r(),e.$2w="vscode://schemas/icons";const i=k.$6n.as(T.$7n.JSONContribution);i.registerSchema(e.$2w,n.getIconSchema());const a=new I.$zh(()=>i.notifySchemaChanged(e.$2w),200);n.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$3w=o("widget-close",N.$Mj.close,(0,E.localize)(2,null)),e.$4w=o("goto-previous-location",N.$Mj.arrowUp,(0,E.localize)(3,null)),e.$5w=o("goto-next-location",N.$Mj.arrowDown,(0,E.localize)(4,null)),e.$6w=O.ThemeIcon.modify(N.$Mj.sync,"spin"),e.$7w=O.ThemeIcon.modify(N.$Mj.loading,"spin")}),define(Re[204],Ae([1,0,5,2,48,3,13]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=E,e.$5v=k,e.$6v=u,e.$8v=b,e.$0v=d,e.$$v=n,e.$2v=(0,O.$ni)("tunnelService"),e.$3v=(0,O.$ni)("sharedTunnelsService");var m;(function(r){r.Http="http",r.Https="https"})(m||(e.TunnelProtocol=m={}));var g;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(g||(e.TunnelPrivacyId=g={}));function E(r){return!!r.forwardPort}var T;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function k(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}function u(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const i=r.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=k(N.URI.parse(h));if(t)return t}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(r){return e.$7v.indexOf(r)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(r){return e.$9v.indexOf(r)>=0}function n(r,i,a,h){if(a===1)return!1;if(a===2&&d(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return r<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$_d,this.onTunnelOpened=this.a.event,this.b=new I.$_d,this.onTunnelClosed=this.b.event,this.c=new I.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const v of t){const c=await v.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,v){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(d(i)||b(i))&&(i=e.$7v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,v,c=!1,$,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${v}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,v,c,$,w);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];b(i)?(h.push(...e.$7v),h.push(...e.$9v)):d(i)&&h.push(...e.$9v);const t=h.map(v=>this.e.get(v));for(const v of t){const c=v?.get(a);if(c)return c}}canTunnel(i){return!!k(i)}u(i,a,h,t,v,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const w=h;this.j.add(w);const p=t===void 0?h:t,l={elevationRequired:v?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==g.Private:void 0,protocol:$},f=i.forwardPort(D,l);return f?(this.q(a,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),f}};e.$aw=s,e.$aw=s=Je([We(0,M.$Tj),We(1,R.$Ti)],s)}),define(Re[205],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bw=void 0,e.$bw=(0,I.$ni)("editSessionIdentityService");var N;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Re[206],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=N,e.$kM=R,e.$lM=O,e.$mM=M,e.$nM=m;function N(g){return g.scheme!==I.Schemas.file&&g.scheme!==I.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(E=>N(E.uri))?g.folders[0].uri:void 0;if(g.configuration&&N(g.configuration))return g.configuration}function O(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function m(g){return R(g)!==void 0}}),define(Re[49],Ae([1,0,162,19,52,23,2,3,12]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=E,e.$yi=T,e.$Bi=k,e.$Ci=u,e.$Di=b,e.$Ei=n,e.$Fi=o,e.$Ii=i,e.$Ni=a,e.$Oi=h,e.$Qi=t,e.$Ri=v,e.$Si=c,e.$wi=(0,m.$ni)("contextService");function E($){const w=$;return typeof w?.id=="string"&&M.URI.isUri(w.uri)}function T($){return typeof $?.id=="string"&&!E($)&&!u($)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function k($,w){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,N.$oc)($)}:w?e.$zi:e.$Ai;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const w=$;return typeof w?.id=="string"&&M.URI.isUri(w.configPath)}function b($){const w=$;if(w?.uri)return{id:w.id,uri:M.URI.revive(w.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:M.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var d;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n($){const w=$;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function o($){const w=$;return!!(w&&typeof w=="object"&&M.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class s{constructor(w,p,l,D,f){this.h=w,this.j=l,this.k=D,this.l=f,this.c=R.$ti.forUris(this.l,()=>!0),this.folders=p}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=R.$ti.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=s;class r{constructor(w,p){this.raw=p,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,O.$1g)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=r;function i($){return new r({uri:$,index:0,name:(0,O.$Wg)($)},{uri:$.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,I.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function a($,w){return O.$Rg.isEqualOrParent($,w.untitledWorkspacesHome)}function h($){let w;return M.URI.isUri($)?w=$:w=$.configuration,w?.scheme===g.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Pi}function v($,w){return!a($,w)&&!h($)}function c($){return(typeof $=="string"?(0,N.$pc)($):(0,O.$Yg)($))===e.$Ki}}),define(Re[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const O=this.c++;return this.b.set(O,R),this.e(),O}get(R,O){return this.b.has(R)?this.b.get(R)[O]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Yjc=I}),define(Re[44],Ae([1,0,12,23,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Pg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$4jc=O,e.$5jc=(0,R.$ni)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=void 0,e.$nP=(0,I.$ni)("IExtHostInitDataService")}),define(Re[207],Ae([1,0,168,13,194,27]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let M=class extends R.$vQ{constructor(g,E,T){const k=T.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=T.remote.isRemote?(0,I.localize)(0,null):g?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(k,{name:u}))}};e.$$lc=M,e.$$lc=M=Je([We(1,N.$Uj),We(2,O.$nP)],M)}),define(Re[208],Ae([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class N{constructor(M,m,g){this.h=new Map,this.a=M,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$zh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const k of E.values())k.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,m){let g=this.f[M];return typeof g>"u"&&(g=m),g}update(M,m){this.f[M]=m;const g=this.h.get(M);if(g!==void 0)return g.p;const E=new I.$Kh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Jkc=N;class R extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,m){super(M.identifier.value,!0,m),this.j=M}}e.$Kkc=R}),define(Re[209],Ae([1,0,5,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class R{constructor(M){this.c=M,this.a=new I.$_d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$_d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,m,g,E){const k=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(m.value,g,E);this.b.fire(k)}$acceptDirtyStateChanged(M,m){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(m)}$acceptModelSaved(M){const m=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(m.apiNotebook)}}e.$ylc=R}),define(Re[16],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0,e.$0O=(0,I.$ni)("IExtHostRpcService");class N{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$$O=N}),define(Re[210],Ae([1,0,20,5]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class R{#e;constructor(M,m){this.b=new N.$_d,this.onDidChange=this.b.event,this.a=I.$Im.toKey(M.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,m){return this.#e.store(this.a,M,m)}delete(M){return this.#e.delete(this.a,M)}}e.$Tkc=R}),define(Re[60],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0,e.$hkc=(0,I.$ni)("IURITransformerService");class N{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$ikc=N}),define(Re[211],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnb=R,e.$Unb=M;class N{constructor(){this.buffers=[]}add(g){let E=this.buffers.indexOf(g);return E<0&&(E=this.buffers.length,this.buffers.push(g)),E}}function R(m,g){if(g.serializeBuffersForPostMessage){const E=new N,k=JSON.stringify(m,(b,d)=>{if(d instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(d)};if(ArrayBuffer.isView(d)){const n=O(d);if(n)return{$$vscode_array_buffer_reference$$:!0,index:E.add(d.buffer),view:{type:n,byteLength:d.byteLength,byteOffset:d.byteOffset}}}return d}),u=E.buffers.map(b=>{const d=new Uint8Array(b);return I.$ze.wrap(d)});return{message:k,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}function O(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(m,g){const E=g.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),T=g.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const d=b,{index:n}=d,o=E[n];if(d.view)switch(d.view.type){case 1:return new Int8Array(o,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(m,T),arrayBuffers:E}}}),define(Re[104],Ae([1,0,177,17,2,6,3,30,43,12,42,139,33]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$yF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$pF=e.EditorInputCapabilities=e.$oF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0,e.$fF=n,e.$gF=o,e.$hF=s,e.$iF=r,e.$jF=i,e.$kF=a,e.$lF=h,e.$mF=t,e.$nF=v,e.$qF=D,e.$rF=S,e.$sF=y,e.$tF=C,e.$uF=P,e.$vF=W,e.$wF=V,e.$xF=ce,e.$zF=ue,e.$AF=re,e.$BF=Se,e.$CF=Le,e.$aF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$cF="workbench.editor.sidebysideEditor",e.$dF="workbench.editors.textDiffEditor",e.$eF="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var d;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(ne){const j=ne;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}function o(ne){const j=ne;return!!j&&typeof j.getScrollPosition=="function"&&typeof j.setScrollPosition=="function"&&!!j.onDidChangeScroll}function s(ne,j,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===j&&ne.matches(ve.input))return ve.getViewState()}function r(ne){if(D(ne))return!1;const j=ne;return R.URI.isUri(j?.resource)}function i(ne){if(D(ne))return!1;const j=ne;return j?.original!==void 0&&j.modified!==void 0}function a(ne){if(D(ne))return!1;const j=ne;return!j||j.resources&&!Array.isArray(j.resources)?!1:!!j.resources||!!j.multiDiffSource}function h(ne){if(D(ne)||i(ne))return!1;const j=ne;return j?.primary!==void 0&&j.secondary!==void 0}function t(ne){if(D(ne))return!1;const j=ne;return j?j.resource===void 0||j.resource.scheme===E.Schemas.untitled||j.forceUntitled===!0:!1}function v(ne){if(D(ne))return!1;const j=ne;return R.URI.isUri(j?.base?.resource)&&R.URI.isUri(j?.input1?.resource)&&R.URI.isUri(j?.input2?.resource)&&R.URI.isUri(j?.result?.resource)}var c;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var $;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class w{constructor(){this.a=new Map}registerSource(j,x){let ve=this.a.get(j);return ve||(ve={source:j,label:x},this.a.set(j,ve)),ve.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.$oF=new w;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class l extends O.$Uc{}e.$pF=l;function D(ne){return ne instanceof l}function f(ne){const j=ne;return R.URI.isUri(j?.preferredResource)}function S(ne){const j=ne;return D(j?.primary)&&D(j?.secondary)}function y(ne){const j=ne;return D(j?.modified)&&D(j?.original)}function C(ne,j,x,ve,Ne){return Le(ve,[(0,k.$0i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(j,Ee)}}),(0,k.$0i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Ne.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function P(ne){return D(ne?.editor)}function W(ne){const j=ne;return P(ne)&&j?.group!==void 0}function V(ne){const j=ne;return typeof j?.groupId=="number"&&D(j.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var U;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(j,x){if(!j)return;if(v(j))return e.$yF.getOriginalUri(j.result,x);if(x?.supportSideBySide){const{primary:Ne,secondary:Ee}=this.a(j);if(Ne&&Ee){if(x?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Ne,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getOriginalUri(Ne,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Ne:Ee}}if(i(j)||a(j)||h(j)||v(j))return;const ve=f(j)?j.preferredResource:j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(j){return S(j)||h(j)?{primary:j.primary,secondary:j.secondary}:y(j)||i(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,x){if(!j)return;if(v(j))return e.$yF.getCanonicalUri(j.result,x);if(x?.supportSideBySide){const{primary:Ne,secondary:Ee}=this.a(j);if(Ne&&Ee){if(x?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Ne,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getCanonicalUri(Ne,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Ne:Ee}}if(i(j)||a(j)||h(j)||v(j))return;const ve=j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(j,x){if(Array.isArray(x)){if(x.some(ve=>j.scheme===ve))return j}else if(x===j.scheme)return j}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,j,x,ve){if(!ne.isSticky(j))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$yF=new K;var we;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(we||(e.CloseDirection=we={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(j){const x=this.a=j.get(M.$mi);for(const[ve,Ne]of this.c)this.e(ve,Ne,x);this.c.clear()}e(j,x,ve){const Ne=ve.createInstance(x);this.d.set(j,Ne)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,N.$_f)(this.b)}registerEditorSerializer(j,x){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,x,this.a):this.c.set(j,x),(0,O.$Sc)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}m.$6n.add(e.$aF.EditorFactory,new Ie);async function ue(ne,j,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Ne=R.URI.revive(ve.fileUri);if(!Ne){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await j.canHandleResource(Ne)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let $e=ve.exists,fe=ve.type;if(typeof $e!="boolean"||typeof fe!="number")try{fe=(await j.stat(Ne)).isDirectory?g.FileType.Directory:g.FileType.Unknown,$e=!0}catch(X){x.error(X),$e=!1}if(!$e&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return $e?{resource:Ne,options:Q}:{resource:Ne,options:Q,forceUntitled:!0}}))}var pe;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function re(ne){const j=ne;if(!j)return!1;const x=j;if(x.modified)return re(x.modified);const ve=j;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Se(ne){return(0,T.$_i)(ne)}function Le(ne,j,x){const ve=(0,T.$aj)(ne,j);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Re[212],Ae([1,0,5,178,3,6,28,30,18,26,91,203]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IF=e.ViewContentGroups=e.$GF=e.ViewContainerLocation=e.Extensions=e.$FF=e.$EF=e.$DF=void 0,e.$HF=d,e.$DF="views",e.$EF=(0,N.localize)(0,null),e.$FF=(0,k.$Zw)("default-view-icon",T.$Mj.window,(0,N.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$GF=[0,1,2];function d(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class n extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$_d),this.onDidRegister=this.c.event,this.f=this.B(new I.$_d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(c,$,w){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,M.$yc)(this.g,$,[]).push(l),w?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const w=this.g.get($),p=w?.indexOf(c);if(p!==-1){w?.splice(p,1),w.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}m.$6n.add(u.ViewContainersRegistry,new n);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,c){const $=v.group??o.More,w=c.group??o.More;return $!==w?$.localeCompare(w):(v.order??5)-(c.order??5)}class r extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$_d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$_d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$_d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$_d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:w})=>this.r($,w)),this.c.fire(c)}deregisterViews(c,$){const w=this.s(c,$);w.length&&this.f.fire({views:w,viewContainer:$})}moveViews(c,$){for(const w of this.m.keys())if(w!==$){const p=this.s(c,w);p.length&&(this.r(p,$),this.g.fire({views:p,from:w,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const w=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,O.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const w=new Map;for(const[p,l]of $)this.n.add(c,l),w.set(p,(0,O.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,w=>$.push(w)),$.sort(s)}r(c,$){let w=this.m.get($);w||(w=[],this.m.set($,w),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,N.localize)(2,null,p.id));w.push(p)}}s(c,$){const w=this.m.get($);if(!w)return[];const p=[],l=[];for(const D of w)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}m.$6n.add(u.ViewsRegistry,new r),e.$IF=(0,R.$ni)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,E.$Wn)(this,c),this.d=!!$,this.resolve=async w=>{if($&&!this.c){const p=await $(w);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JF=h;class t extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$KF=t}),define(Re[213],Ae([1,0,179,31]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0,e.$OF=new N.$Ej("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$PF=new N.$Ej("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$QF=new N.$Ej("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$RF=new N.$Ej("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$SF=new N.$Ej("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$TF=new N.$Ej("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$UF=new N.$Ej("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$VF=new N.$Ej("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$WF=new N.$Ej("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$XF=new N.$Ej("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$YF=new N.$Ej("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$ZF=new N.$Ej("hasChatProvider",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$1F=new N.$Ej("chatCursorAtTop",!1),e.$2F=new N.$Ej("chatInputHasAgent",!1),e.$3F=new N.$Ej("chatLocation",void 0)}),define(Re[214],Ae([1,0,5,46,6,31,3,213]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=e.$ZG=e.ChatAgentLocation=void 0;var g;(function(k){k.Panel="panel",k.Terminal="terminal",k.Notebook="notebook",k.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(k){function u(b){switch(b){case"panel":return k.Panel;case"terminal":return k.Terminal;case"notebook":return k.Notebook;case"editor":return k.Editor}return k.Panel}k.fromRaw=u}(g||(e.ChatAgentLocation=g={})),e.$ZG=(0,M.$ni)("chatAgentService");let E=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$_d,this.onDidChangeAgents=this.d.event,this.e=m.$ZF.bindTo(this.f)}registerAgent(u,b){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const n=this,o=b.slashCommands;b={...b,get slashCommands(){return o.filter(r=>!r.when||n.f.contextMatchesRules(O.$lj.deserialize(r.when)))}};const s={data:b};return this.b.push(s),(0,R.$Sc)(()=>{this.b=this.b.filter(r=>r!==s),this.d.fire(void 0)})}registerAgentImplementation(u,b){const d=this.g(u);if(!d)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(d.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return d.data.isDefault&&this.e.set(!0),d.impl=b,this.d.fire(new T(d.data,b)),(0,R.$Sc)(()=>{d.impl=void 0,this.d.fire(void 0),d.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,b){const d={data:u,impl:b};return this.b.push(d),this.d.fire(new T(u,b)),(0,R.$Sc)(()=>{this.b=this.b.filter(n=>n!==d),this.d.fire(void 0)})}updateAgent(u,b){const d=this.g(u);if(!d?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);d.data.metadata={...d.data.metadata,...b},this.d.fire(new T(d.data,d.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(b=>!!b.isDefault&&b.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(b=>!!b.isDefault&&b.locations.includes(u))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(b=>b.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new T(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(b=>b.name===u)}async invokeAgent(u,b,d,n,o){const s=this.g(u);if(!s?.impl)throw new Error(`No activated agent with id ${u}`);return await s.impl.invoke(b,d,n,o)}async getFollowups(u,b,d,n,o){const s=this.g(u);if(!s?.impl)throw new Error(`No activated agent with id ${u}`);return s.impl?.provideFollowups?s.impl.provideFollowups(b,d,n,o):[]}};e.$1G=E,e.$1G=E=Je([We(0,O.$Fj)],E);class T{constructor(u,b){this.b=u,this.d=b}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,b,d,n){return this.d.invoke(u,b,d,n)}async provideFollowups(u,b,d,n){return this.d.provideFollowups?this.d.provideFollowups(u,b,d,n):[]}provideWelcomeMessage(u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u)}provideSampleQuestions(u){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u)}}e.$2G=T}),define(Re[215],Ae([1,0,2,29,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.$0F=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$8F=O,e.$9F=M;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$ht.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var m;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$0F=(0,R.$ni)("IChatService"),e.$$F="accessibility.voice.keywordActivation"}),define(Re[216],Ae([1,0,5,11,180]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oob=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$_d,this.o=new I.$_d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,g,E,T){const k={command:m};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.u("request",k),typeof T=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,R.localize)(0,null,T,m)};b(d)}},T)}return E&&this.f.set(k.seq,E),k.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,g){return m.type!=="event"||g.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,N.$oh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,E=this.f.get(g.request_seq);E&&(this.f.delete(g.request_seq),E(g));break}}}}u(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,E)=>m.set(E,g)),await(0,N.$oh)(500),m.forEach((g,E)=>{g({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$oob=O}),define(Re[217],Ae([1,0,2,181,31,3]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$fJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$dJ=e.MemoryRangeType=e.State=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=void 0,e.$cJ=g,e.$eJ=T,e.$3H="workbench.view.debug",e.$4H="workbench.debug.variablesView",e.$5H="workbench.debug.watchExpressionsView",e.$6H="workbench.debug.callStackView",e.$7H="workbench.debug.loadedScriptsView",e.$8H="workbench.debug.breakPointsView",e.$9H="workbench.debug.disassemblyView",e.$0H="workbench.panel.repl",e.$$H="workbench.panel.repl.view",e.$_H=new R.$Ej("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$aI=new R.$Ej("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$bI=new R.$Ej("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$cI="debugUx",e.$dI=new R.$Ej(e.$cI,"default",{type:"string",description:N.localize(3,null)}),e.$eI=new R.$Ej("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$fI=new R.$Ej("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$gI=new R.$Ej("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$hI=new R.$Ej("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$iI=new R.$Ej("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$jI=new R.$Ej("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$kI=new R.$Ej("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$lI=new R.$Ej("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$mI=new R.$Ej("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$nI=new R.$Ej("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$oI=new R.$Ej("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$pI=new R.$Ej("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$qI=new R.$Ej("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$rI=new R.$Ej("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$sI=new R.$Ej("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$tI=new R.$Ej("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$uI=new R.$Ej("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$vI=new R.$Ej("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$wI=new R.$Ej("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$xI=new R.$Ej("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$yI=new R.$Ej("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$zI=new R.$Ej("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$AI=new R.$Ej("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$BI=new R.$Ej("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$CI=new R.$Ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$DI=new R.$Ej("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$EI=new R.$Ej("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$FI=new R.$Ej("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$GI=new R.$Ej("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$HI=new R.$Ej("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$II=new R.$Ej("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$JI=new R.$Ej("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$KI=new R.$Ej("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$LI=new R.$Ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$MI=new R.$Ej("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$NI=new R.$Ej("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$OI=new R.$Ej("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$PI=new R.$Ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$QI=new R.$Ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$RI=new R.$Ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$SI=new R.$Ej("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$TI=new R.$Ej("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$UI=new R.$Ej("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$VI=new R.$Ej("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$WI=new R.$Ej("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$XI=new R.$Ej("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$YI=new R.$Ej("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$ZI=new R.$Ej("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$1I=new R.$Ej("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$2I=new R.$Ej("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$3I=new R.$Ej("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$4I=new R.$Ej("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$5I=new R.$Ej("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$6I=new R.$Ej("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$7I=new R.$Ej("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$8I=new R.$Ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$9I=new R.$Ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$0I=M,e.$$I="editor.contrib.debug",e.$_I="editor.contrib.breakpoint",e.$aJ="debug",e.$bJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var m;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(m||(e.State=m={}));function g(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$dJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var k;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(k||(e.DataBreakpointSetType=k={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var b;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$fJ=(0,O.$ni)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(s||(e.IDebugVisualizationTreeItem=s={}));var r;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(r||(e.IDebugVisualization=r={}))}),define(Re[218],Ae([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eH=void 0,e.$5G=k,e.$6G=u,e.$7G=b,e.$8G=d,e.$9G=n,e.$0G=o,e.$$G=s,e.$_G=i,e.$aH=t,e.$bH=v,e.$cH=$,e.$dH=p;const T=/{([^}]+)}/g;function k(D,f,S){return D.replace(T,function(y,C){return f&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function u(D){const f={};for(const S of Object.keys(D))S.startsWith("!")||(f[S]=D[S]);return f}function b(D){return D.configuration.request==="attach"&&!d(D)&&(!D.parentSession||b(D.parentSession))}function d(D){let f=D.configuration.type;if(f)return f==="vslsShare"&&(f=D.configuration.adapterProxy.configuration.type),(0,I.$qf)(f,"extensionhost")||(0,I.$qf)(f,"pwa-extensionhost")?D:D.parentSession?d(D.parentSession):void 0}function n(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,f,S){let y,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=P.exec(D);){const V=W.index+1,q=V+W[0].length;if(V<=f&&q>=S){y=W[0],C=V;break}}if(y){const V=/\w+/g;let q=null;for(;(q=V.exec(y))&&!(q.index+1+C+q[0].length>=S););q&&(y=y.substring(0,V.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(D,f,S,y){if(D.evaluatableExpressionProvider.has(f)){const C=D.evaluatableExpressionProvider.ordered(f),P=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(f,S,y??g.CancellationToken.None)}catch{return}})));if(P.length>0){let W=P[0].expression;const V=P[0].range;return W||(W=f.getLineContent(S.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=f.getLineContent(S.lineNumber),{start:P,end:W}=o(C,S.column,S.column),V=C.substring(P-1,W);return{matchingExpression:V,range:new m.$ht(S.lineNumber,P,S.lineNumber,P+V.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(r))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,R.$jc)(D.path))return N.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const f=N.URI.revive(D.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return D.path}function t(D,f){const S=f?a:h,y=(0,O.$Tn)(D);return c(y,(C,P)=>{C&&P&&(P.path=S(P))}),y}function v(D,f){const S=f?a:h,y=(0,O.$Tn)(D);return c(y,(C,P)=>{!C&&P&&(P.path=S(P))}),y}function c(D,f){switch(D.type){case"event":{const S=D;switch(S.event){case"output":f(!1,S.body.source);break;case"loadedSource":f(!1,S.body.source);break;case"breakpoint":f(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":f(!0,S.arguments.source);break;case"breakpointLocations":f(!0,S.arguments.source);break;case"source":f(!0,S.arguments.source);break;case"gotoTargets":f(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>f(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>f(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>f(!1,y));break;case"scopes":S.body.scopes.forEach(y=>f(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>f(!1,C.location));break;default:break}break}}}function $(D){return D.filter(f=>!f.presentation?.hidden).sort((f,S)=>f.presentation?S.presentation?f.presentation.group?S.presentation.group?f.presentation.group!==S.presentation.group?f.presentation.group.localeCompare(S.presentation.group):w(f.presentation.order,S.presentation.order):-1:S.presentation.group?1:w(f.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function w(D,f){return typeof D!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:D-f}async function p(D,f){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(S!=="none"&&(await f.saveAll(),S==="allEditorsInActiveGroup")){const y=f.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const l=(D,f)=>!D||!f?D===f:D.name===f.name&&D.path===f.path&&D.sourceReference===f.sourceReference;e.$eH=l}),define(Re[219],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.CellExecutionUpdateType=void 0;var N;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$sK=(0,I.$ni)("INotebookExecutionService")}),define(Re[220],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iib=e.$hib=e.ProxyKernelState=e.$gib=void 0,e.$gib=100;var N;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$hib=(0,I.$ni)("INotebookKernelService"),e.$iib=(0,I.$ni)("INotebookKernelHistoryService")}),define(Re[221],Ae([1,0,6,29,149,95]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Vb=void 0;class M extends I.$Uc{constructor(g,E,T){super(),this._source=g,this.b=E,this.c=T,this.a=void 0}f(g){const E=g.getLineCount();return new N.$ht(1,1,E,this.g(g,E))}g(g,E){if(E<1||E>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const g=new R.$JC;g.acceptChunk(this._source);const E=g.finish(!0),{textBuffer:T,disposable:k}=E.create(1);this.b=T,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const E=new R.$JC;E.acceptChunk(g);const T=E.finish(!0),{textBuffer:k,disposable:u}=T.create(1);return this.B(u),k})),this.a}findInInputs(g){const T=new O.$xC(g,!1,!1,null).parseSearchRequest();if(!T)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,T,!0,5e3)}findInOutputs(g){const T=new O.$xC(g,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(k=>{const u=k.findMatchesLineByLine(this.f(k),T,!0,5e3);if(u.length!==0)return{textBuffer:k,matches:u}}).filter(k=>!!k):[]}}e.$$Vb=M}),define(Re[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class R{static fromExtHostTestItem(M,m,g=M.parent){if(M._isRoot)return new R([m]);const E=[M.id];for(let T=g;T&&T.id!==m;T=T.parent)E.push(T.id);return E.push(m),new R(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const m=M.indexOf("\0");return m===-1?M:M.slice(0,m)}static fromString(M){return new R(M.split("\0"))}static join(M,m){return new R([...M.path,m])}static joinToString(M,m){return M.toString()+"\0"+m}static parentId(M){const m=M.lastIndexOf("\0");return m===-1?void 0:M.slice(0,m)}static localId(M){const m=M.lastIndexOf("\0");return m===-1?M:M.slice(m+1)}static isChild(M,m){return m.startsWith(M)&&m[M.length]==="\0"}static compare(M,m){return M===m?0:R.isChild(M,m)?2:R.isChild(m,M)?3:1}constructor(M,m=M.length){if(this.path=M,this.d=m,M.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let m=0;m<M.d&&m<this.d;m++)if(M.path[m]!==this.path[m])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$yL=R}),define(Re[61],Ae([1,0,2,93,29,50]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$GL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$FL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$EL=e.$DL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$CL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$BL=e.$AL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$zL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$zL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$AL=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$BL=E;var T;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({range:R.$ht.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var k;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(k||(e.TestMessageType=k={}));var u;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&T.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(U,K.location)})})(u||(e.ITestErrorMessage=u={}));const b=(A,U)=>`${U?"s":"e"}${A}`;e.$CL=b;var d;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&T.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(U,K.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(A){A.serialize=U=>U.type===0?u.serialize(U):d.serialize(U),A.deserialize=(U,K)=>K.type===0?u.deserialize(U,K):d.deserialize(U,K)})(n||(e.ITestMessage=n={}));var o;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(n.serialize)}),A.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>n.deserialize(U,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",r=(A,U)=>A+s+U;e.$DL=r;const i=A=>{const U=A.indexOf(s);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.$EL=i;var a;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$ht.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(A){A.serialize=U=>({expand:U.expand,item:a.serialize(U.item)}),A.deserialize=(U,K)=>({controllerId:O.$yL.root(K.item.extId),expand:K.expand,item:a.deserialize(U,K.item)})})(t||(e.InternalTestItem=t={}));var v;(function(A){A.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},A.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?R.$ht.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(v||(e.ITestItemUpdate=v={}));const c=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.$FL=c;var $;(function(A){A.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),A.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),A.deserialize=(U,K)=>({...t.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(U,ie)),retired:!0})})($||(e.TestResultItem=$={}));var w;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(w||(e.ICoverageCount=w={}));var p;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function l(A){return{...A,location:A.location?.toJSON()}}function D(A){return A.location=A.location?N.$gt.isIPosition(A.location)?N.$gt.lift(A.location):R.$ht.lift(A.location):void 0,A}e.$GL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var S;(function(A){A.serialize=U=>U.type===0?C.serialize(U):P.serialize(U),A.deserialize=U=>U.type===0?C.deserialize(U):P.deserialize(U)})(S||(e.CoverageDetails=S={}));var y;(function(A){A.serialize=l,A.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(A){A.serialize=l,A.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var P;(function(A){A.serialize=U=>({...l(U),branches:U.branches?.map(y.serialize)}),A.deserialize=U=>({...D(U),branches:U.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(U,K)=>K.op===0?{op:K.op,item:t.deserialize(U,K.item)}:K.op===1?{op:K.op,item:v.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:v.serialize(U.item)}:U})(V||(e.TestsDiffOp=V={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const ie of U)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(v.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(U,K){const ie=O.$yL.parentId(U.item.extId)?.toString();let ce;if(!ie)ce=this.w(U),this.g.add(ce),this.f.set(U.item.extId,ce);else if(this.f.has(ie)){const we=this.f.get(ie);we.children.add(U.item.extId),ce=this.w(U,we),this.f.set(U.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ce),U.expand===2&&this.h++,ce}o(U,K){const ie=this.f.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$FL)(ie,U),K.update?.(ie),ie}p(U,K){const ie=this.f.get(U);if(!ie)return;const ce=O.$yL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const we=[[U]];for(;we.length;)for(const Ie of we.pop()){const ue=this.f.get(Ie);ue&&(we.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==ie),ue.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$HL=q}),define(Re[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.TestItemEventOp=void 0;var g;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const E=(r,i)=>r===i,k=Object.entries({range:(r,i)=>r===i?!0:!r||!i?!1:r.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(r,i)=>!(r.length!==i.length||r.some(a=>!i.includes(a)))}),u=(r,i)=>{let a;for(const[h,t]of k)t(r[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class b extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$zh(()=>this.flushDiff(),200)),this.g=this.B(new N.$_d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,M.$FL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,M.$FL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(m.$yL.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,O.$cd)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=m.$yL.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,a);return}if(v.actual===i){this.H(i,v,a);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(v.actual),$=v.actual,w=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,v.actual=i,v.resolveBarrier=void 0,v.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete w.tags),this.w(v,{op:4,update:w})),this.I(i,v,a);for(const[l,D]of c)this.s.getChildren(i).get(D.id)||this.O(m.$yL.joinToString(h,D.id));const p=v.expandLevels;p!==void 0&&queueMicrotask(()=>{v.expand===1&&(v.expandLevels=void 0,this.expand(h.toString(),p))}),this.y(v.actual.uri)}C(i,a,h){const t=new Set(a.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,M.$DL)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$DL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$DL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(a,v),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,v]of this.s.getChildren(i))this.z(v,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const c=this.expand(m.$yL.joinToString(i.fullId,v.id),a);(0,I.$_g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new I.$mh;return v.open(),v}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$mh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,I.$_g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$yL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$ZO=b;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$1O=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2O=n;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$3O=o;const s=(r,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const c of h.values())t.call(v,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const w of t){if(!(w instanceof a))throw new n(w.id);const p=i(w).controllerId;if(p!==r.controllerId)throw new o(w.id,p,r.controllerId);if(v.has(w.id))throw new d(w.id);v.set(w.id,w),c.delete(w.id),$.ops.push({op:0,item:w})}for(const w of c.keys())$.ops.push({op:3,id:w});r.listener?.($),h=v},add(t){if(!(t instanceof a))throw new n(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$4O=s}),define(Re[105],Ae([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;const N=new WeakMap,R=(M,m)=>{const g={controllerId:m};return N.set(M,g),g};e.$5O=R;const O=M=>{const m=N.get(M);if(!m)throw new I.$2O(M?.id||"<unknown>");return m};e.$6O=O}),define(Re[76],Ae([1,0,12,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cxb=e.$Bxb=e.$Axb=void 0,e.$Dxb=R,e.$Exb=M,e.$Axb="vscode-cdn.net",e.$Bxb=`vscode-resource.${e.$Axb}`,e.$Cxb=`'self' https://*.${e.$Axb}`;function R(m,g){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===I.Schemas.file&&(m=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:g.authority,path:m.path})),N.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${O(m.authority)}.${e.$Bxb}`,path:m.path,fragment:m.fragment,query:m.query}))}function O(m){return m.replace(/./g,g=>{const E=g.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?g:"-"+E.toString(16).padStart(4,"0")})}function M(m){return m.replace(/-([0-9a-f]{4})/g,(g,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Re[222],Ae([1,0,5,6,76]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class O{constructor(m,g,E){this.d=m,this.e=g,this.f=E,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const T=g.getVisibleTextEditors();for(const k of this.c.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,E,T,k){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){u=i;break}if(!u)throw new Error("not a visible editor");const b=this,d=this.a++,n=new I.$_d,o=new I.$_d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$Dxb)(i,b.f)}get cspSource(){return R.$Cxb}set options(i){this.b=i,b.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return b.d.$postMessage(d,i)}},r=new class{constructor(){this.editor=m,this.line=g,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){b.c.has(d)&&(b.c.delete(d),b.d.$disposeEditorInset(d),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,g+1,E,T||{},k.identifier,k.extensionLocation),this.c.set(d,{editor:m,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$fkc=O}),define(Re[106],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.$OL=void 0,e.$OL="__",e.$PL=(0,I.$ni)("IAuthenticationService"),e.$QL=(0,I.$ni)("IAuthenticationExtensionsService")}),define(Re[223],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.VariableKind=e.$VP=void 0,e.$VP=(0,I.$ni)("configurationResolverService");var N;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class R extends Error{constructor(M,m){super(m),this.variable=M}}e.$WP=R}),define(Re[224],Ae([1,0,19,73,17,26,21,96,184,223,15]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,d,n,o){this.h=new Map,this.a=b,this.b=d,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(b){if(M.$i){const d=Object.create(null);return Object.keys(b).forEach(n=>{d[n.toLowerCase()]=b[n]}),d}return b}resolveWithEnvironment(b,d,n){return this.l({env:this.i(b),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(b,d){const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,d)}async j(b,d,n,o){const s=O.$Tn(d);M.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):M.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):M.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,s,n,o)}async resolveAnyAsync(b,d,n){return this.j(b,d,n)}async resolveAnyMap(b,d,n){const o=new Map;return{newConfig:await this.j(b,d,n,o),resolvedVariables:o}}resolveWithInteractionReplace(b,d,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,d,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,d){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,d)}async l(b,d,n,o,s){if(R.$1f(n))return this.m(b,d,n,o,s);if(Array.isArray(n))return Promise.all(n.map(r=>this.l(b,d,r,o,s)));if(R.$3f(n)){const r=Object.create(null),i=await Promise.all(Object.keys(n).map(async a=>[await this.m(b,d,a,o,s),await this.l(b,d,n[a],o,s)]));for(const[a,h]of i)r[a]=h;return r}return n}m(b,d,n,o,s){return(0,T.$if)(n,k.VARIABLE_REGEXP,async(r,i)=>{if(i.includes(k.VARIABLE_LHS))return r;let a=await this.o(b,r,i,d,o);return s?.set(i,a),a!==r&&R.$1f(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m(b,d,a,o,s)),a})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,d,n,o,s){let r;const i=n.split(":");i.length>1&&(n=i[0],r=i[1]);const a=v=>{const c=this.a.getFilePath();if(c)return(0,m.$mw)(c);throw new E.$WP(v,(0,g.localize)(0,null,d))},h=v=>{const c=a(v);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,m.$mw)($)}throw new E.$WP(v,(0,g.localize)(1,null,d,I.$oc(c)))},t=v=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new E.$WP(v,(0,g.localize)(2,null,d,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$WP(v,(0,g.localize)(3,null,d)):new E.$WP(v,(0,g.localize)(4,null,d))};switch(n){case"env":if(r){if(b.env){const v=b.env[M.$i?r.toLowerCase():r];if(R.$1f(v))return v}return""}throw new E.$WP(E.VariableKind.Env,(0,g.localize)(5,null,d));case"config":if(r){const v=this.a.getConfigurationValue(o,r);if(R.$0f(v))throw new E.$WP(E.VariableKind.Config,(0,g.localize)(6,null,d,r));if(R.$3f(v))throw new E.$WP(E.VariableKind.Config,(0,g.localize)(7,null,d,r));return v}throw new E.$WP(E.VariableKind.Config,(0,g.localize)(8,null,d));case"command":return this.p(E.VariableKind.Command,d,r,s,"command");case"input":return this.p(E.VariableKind.Input,d,r,s,"input");case"extensionInstallFolder":if(r){const v=await this.a.getExtension(r);if(!v)throw new E.$WP(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,d,r));return this.n(v.extensionLocation)}throw new E.$WP(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$mw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,m.$mw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$mw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new E.$WP(E.VariableKind.UserHome,(0,g.localize)(11,null,d))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new E.$WP(E.VariableKind.LineNumber,(0,g.localize)(12,null,d))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new E.$WP(E.VariableKind.SelectedText,(0,g.localize)(13,null,d))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?I.$mc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.$nc(a(E.VariableKind.RelativeFileDirname));if(o||r){const c=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),v);return c.length===0?".":c}return v}case"fileDirname":return I.$nc(a(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.$oc(a(E.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.$pc(v).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||d}case"execInstallFolder":{const v=this.a.getAppRoot();return v||d}case"pathSeparator":case"/":return I.sep;default:try{const v=r?`${n}:${r}`:n;return this.p(E.VariableKind.Unknown,d,v,s,void 0)}catch{return d}}}}p(b,d,n,o,s){if(n&&o){const r=s===void 0?o[n]:o[s+":"+n];if(typeof r=="string")return r;throw new E.$WP(b,(0,g.localize)(14,null,d))}return d}}e.$_P=k}),define(Re[107],Ae([1,0,3,104]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FD=void 0,e.$GD=E,e.$HD=u,e.$ID=b,e.$FD=(0,I.$ni)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var m;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function E(d){const n=d;return(0,N.$qF)(n?.editor)&&(0,N.$qF)(n?.replacement)}var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function b(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Re[225],Ae([1,0,3,107]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$ND=R,e.$JD=(0,I.$ni)("editorService"),e.$KD=-1,e.$LD=-2,e.$MD=-3;function R(O){const M=O;return typeof O=="number"||(0,N.$HD)(M)}}),define(Re[226],Ae([1,0,3,191]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=void 0,e.$0L=(0,I.$oi)(N.$ui)}),define(Re[108],Ae([1,0,20,5,19,6,11]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=e.$C$b=e.$B$b=e.$A$b=void 0;class m{constructor(r,i){this.versionId=r,this.removedDueToLooping=i}}e.$A$b=m;class g{static isHostExtension(r,i,a){if(i.getExtensionDescription(r))return!1;const h=a.getExtensionDescription(r);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(r,i){this.j=r,this.c=new N.$_d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new I.$Km,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const i=this.j.readActivationEvents(r);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,i){this.e=o(this.e,i),this.e=this.e.concat(r);const a=g.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const w=i.getArcs(c);for(let p=0;p<w.length;p++)if(!$.has(w[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Km;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Im.toKey(c.identifier),I.$Im.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let v;do{v=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),v=!0)}}while(v);return t.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.h.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const i=this.f.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.g)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$B$b=g;class E{constructor(r,i){this.versionId=r,this.extensions=i}}e.$C$b=E;class T{constructor(r){this.d=new b,this.c=new g(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new k(this,i)}deltaExtensions(r,i,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$D$b=T;class k extends O.$Uc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$E$b=k;class u{constructor(r){this.name=r;const i=(0,M.$gh)();this.promise=i.promise,this.c=i.resolve}resolve(r){this.c(r)}}class b{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new u(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};r.resolve((0,O.$Sc)(h))}}var d;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(d||(d={}));function n(s,r){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=R.$hc.basename(s.extensionLocation.path),t=R.$hc.basename(r.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,r){const i=new I.$Jm(r);return s.filter(a=>!i.has(a.identifier))}}),define(Re[77],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Qm=M,e.$Rm=m;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var O;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(E){const T=I.$ze.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function m(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var g;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Re[62],Ae([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$pP=e.$oP=void 0,e.$qP=n;let b=class extends k.$Uc{constructor(s,r){super(),this.s=s,this.t=r,this.a=this.B(new N.$_d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$_d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:g.$bp,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(i=>{(0,R.$Vj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,r,i){const a=this.getTelemetryDetails(),h=new d(r,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,r,i){this.f=s,this.g=r,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const r=Object.create(null);switch(r["common.extname"]=`${s.publisher}.${s.name}`,r["common.extversion"]=s.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,m.$zm)((0,g.$hp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const r=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,r){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$oP=b,e.$oP=b=Je([We(0,O.$nP),We(1,R.$Uj)],b);class d{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,r,i,a,h,t,v){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new N.$_d,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,r){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let r="properties"in s?s.properties??{}:s;return r=(0,g.$kp)(r,[]),this.c&&(r=(0,E.$Wn)(r,this.c)),this.b||(r=(0,E.$Wn)(r,this.j)),"properties"in s?s.properties=r:s=r,s}k(s,r){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(s,r),this.h.trace(s,r))}logUsage(s,r){this.d.isUsageEnabled&&this.k(s,r)}logError(s,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,r);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,g.$kp)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const s=this,r={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$pP=d;function n(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$rP=(0,I.$ni)("IExtHostTelemetry")}),define(Re[25],Ae([1,0,5,2,200,103,20,3]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.ActivationKind=e.$xG=e.$wG=e.$tG=e.ExtensionHostStartup=e.$sG=e.$rG=e.$qG=e.$pG=void 0,e.$uG=u,e.$vG=b,e.$yG=s,e.$zG=r,e.$pG=Object.freeze({identifier:new M.$Im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qG="extensions.webWorker",e.$rG=(0,m.$ni)("extensionService");class g{constructor(h){this.dependency=h}}e.$sG=g;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$aG.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],w=[],p=[],l=k(this.d),D=k(t),f=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=D.get(W.identifier);if(!V){c.push(W.identifier),l.delete(W.identifier);continue}if(!f(W,V)){c.push(W.identifier),l.delete(W.identifier);continue}}for(const W of t){const V=l.get(W.identifier);if(!V){$.push(W);continue}if(!f(V,W)){c.push(V.identifier),l.delete(V.identifier);continue}}const S=new M.$Jm(this.e),y=new M.$Jm(v);for(const W of this.e)y.has(W)||w.push(W);for(const W of v)S.has(W)||p.push(W);const C=O.$aG.createActivationEventsMap($),P={versionId:h,toRemove:c,toAdd:$,addActivationEvents:C,myToRemove:w,myToAdd:p};return this.delta(P),P}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:c,myToAdd:$}=h,w=new M.$Jm(t),p=new M.$Jm(c);for(let l=0;l<this.d.length;l++)w.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of v)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$Im.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=O.$aG.readActivationEvents(t);for(const c of v)h.add(c)}return h}}e.$tG=T;function k(a){const h=new M.$Km;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function b(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class d{constructor(h,t,v,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=c}}e.$wG=d;class n{constructor(h,t){this.description=h,this.value=t}}e.$xG=n;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.$qp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function r(a,h){return{identifier:new M.$Im((0,R.$op)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AG=i}),define(Re[227],Ae([1,0,14,108,20,25,13,11]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=e.$Bkc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(s,r,i,a){this.startup=s,this.codeLoadingTime=r,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Bkc=g;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,r){return s===-1||r===-1?-1:r-s}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ckc=E;class T{constructor(s,r,i,a,h,t){this.activationFailed=s,this.activationFailedError=r,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Dkc=T;class k extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ekc=k;class u extends T{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=u;class b extends T{constructor(s){super(!0,s,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(s,r,i,a){this.g=a,this.a=s,this.b=r,this.c=i,this.d=new R.$Km,this.f=Object.create(null)}dispose(){for(const[s,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const s=[];for(const[r,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const r=this.d.get(s);return!!(r&&r.value)}getActivatedExtension(s){const r=this.d.get(s);if(!r||!r.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return r.value}async activateByEvent(s,r){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,r){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:r}])}async h(s){const r=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(r.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const r=this.a.getExtensionDescription(s.id);if(!r){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new b(h));return this.c.onExtensionActivationError(s.id,h,new O.$sG(s.id.value)),t}const i=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const c=r.displayName||r.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),w=this.k(s,r.displayName,[],new b($));return this.c.onExtensionActivationError(r.identifier,$,new O.$sG(h)),w}return this.k(s,r.displayName,i,null)}k(s,r,i,a){const h=new n(s.id,r,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return N.$B$b.isHostExtension(s,this.a,this.b)}m(s){const r=this.b.getExtensionDescription(s);return r?!r.main&&!r.browser:!1}};e.$Gkc=d,e.$Gkc=d=Je([We(3,M.$Tj)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,r,i,a,h,t,v){this.c=s,this.d=r,this.f=i,this.g=a,this.h=h,this.j=t,this.k=v,this.a=new m.$mh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const r=this.g[s];if(r.value&&!r.value.activationFailed){this.g.splice(s,1),s--;continue}if(r.value&&r.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);i.detail=r.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const r=new Error;if(s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this.h=new b(r),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=Je([We(6,M.$Tj)],n)}),define(Re[228],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[229],Ae([1,0,186,14,33,98,72,30,20,228,196,103]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0;const u=m.$6n.as(M.$7n.JSONContribution);class b{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$jG=b;class d{static a(h){const t=new g.$Jm;for(let v=0,c=h.length;v<c;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new d(t,[]);if(!t||!t.length)return new d([],h);const v=this.a(h),c=this.a(t),$=t.filter(p=>!v.has(p.description.identifier)),w=h.filter(p=>!c.has(p.description.identifier));return new d($,w)}constructor(h,t){this.added=h,this.removed=t}}e.$kG=d;class n{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=d.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,N.$1)(h)}}}e.$lG=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$mG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Hm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Ko}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Ko}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&k.$aG.register(h.extensionPoint,h.activationEventsGenerator),e.$mG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$mG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$nG=r;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$6n.add(i.ExtensionsRegistry,new r),e.$oG=m.$6n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$mG),u.registerSchema(T.$bk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Re[230],Ae([1,0,182,17,26,229,31,5]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(u){function b(d,n,o){if(!d)return;const s=N.$1f(d.type)?d.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const r=[];if(Array.isArray(d.required))for(const i of d.required)N.$1f(i)&&r.push(i);return{extensionId:n.value,taskType:s,required:r,properties:d.properties?R.$Tn(d.properties):{},when:d.when?M.$lj.deserialize(d.when):void 0}}u.from=b})(E||(E={}));const T=O.$oG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const d of u)d.type&&b.push(`onTaskType:${d.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new m.$_d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,d)=>{T.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const r=s.value;for(const i of r)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const r=s.value;for(const i of r){const a=E.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=R.$Tn(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},b.push(n)}this.c={oneOf:b}}return this.c}}e.$RH=new k}),define(Re[231],Ae([1,0,183,17,23,26,31,230]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2H=e.JsonSchemaVersion=e.ExecutionEngine=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VH=e.ShellQuoting=e.$UH=e.$TH=e.$SH=void 0,e.$SH="settings",e.$TH=new M.$Ej("taskRunning",!1,I.localize(0,null)),e.$UH=I.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$VH="$customized",function(A){function U(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(g||(e.ShellQuoting=g={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(T||(e.RevealKind=T={}));var k;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(k||(e.RevealProblemKind=k={}));var u;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(u||(e.PanelKind=u={})),function(A){function U(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(u||(e.PanelKind=u={}));var b;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var d;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(d||(e.RuntimeType=d={})),function(A){function U(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(d||(e.RuntimeType=d={}));var n;(function(A){function U(K){return N.$1f(K)?K:K.value}A.value=U})(n||(e.CommandString=n={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=U;function K(ie){if(ie!==void 0)return N.$1f(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(o||(e.TaskGroup=o={}));var s;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var r;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(r||(e.TaskSourceKind=r={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(U,K,ie,ce,we,Ie){this._label="",this._id=U,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=we,this._source=Ie}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(N.$1f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$WH=t;class v extends t{constructor(U,K,ie,ce,we,Ie,ue,pe){super(U,ie,void 0,ue,pe,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,we&&(this.command=we)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case d.Shell:K="shell";break;case d.Process:K="process";break;case d.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof v}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$SH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$VH,folder:U,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Xg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new v(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$XH=v;class c extends t{constructor(U,K,ie,ce,we,Ie,ue){super(U,ie,ce,Ie,ue,K),this._source=K,this.configures=we}static is(U){return U instanceof c}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Xg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$SH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$VH,folder:U,id:K};return JSON.stringify(ie)}}e.$YH=c;class $ extends t{constructor(U,K,ie,ce,we,Ie,ue,pe,re){super(U,ie,ce,pe,re,K),this.defines=we,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof $}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new $(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$ZH=$;class w extends t{constructor(U,K,ie,ce,we,Ie){super(U,ie,ce,we,Ie,K),this._source=K}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new w(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$1H=w;var p;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(A){A._default=A.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const ie=U.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let we=this.c.get(ie.uri.toString());we=we===void 0?0:we+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,we===Ie?U._label.localeCompare(K._label):we-Ie}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$2H=D;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var S;(function(A){A.SingleRun="singleRun",A.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(A){function U(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function K(pe,re,Se){return{...U(pe),kind:"start",terminalId:re,resolvedVariables:Se}}A.start=K;function ie(pe,re,Se){return{...U(pe),kind:"processStarted",terminalId:re,processId:Se}}A.processStarted=ie;function ce(pe,re,Se){return{...U(pe),kind:"processEnded",terminalId:re,exitCode:Se}}A.processEnded=ce;function we(pe,re,Se){return{...U(pe),kind:"terminated",exitReason:Se,terminalId:re}}A.terminated=we;function Ie(pe,re,Se){return{...U(re),kind:pe,terminalId:Se}}A.general=Ie;function ue(){return{kind:"changed"}}A.changed=ue})(C||(e.TaskEvent=C={}));var P;(function(A){function U(ie){const ce=Object.keys(ie).sort();let we="";for(const Ie of ce){let ue=ie[Ie];ue instanceof Object?ue=U(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),we+=Ie+","+ue+","}return we}function K(ie){const we={_key:U(ie),type:ie.taskType};return Object.assign(we,ie),we}A.create=K})(P||(e.KeyedTaskIdentifier=P={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function U(K,ie){const ce=m.$RH.get(K.type);if(ce===void 0){const pe=O.$Tn(K);return delete pe._key,P.create(pe)}const we=Object.create(null);we.type=ce.taskType;const Ie=new Set;ce.required.forEach(pe=>Ie.add(pe));const ue=ce.properties;for(const pe of Object.keys(ue)){const re=K[pe];if(re!=null)we[pe]=re;else if(Ie.has(pe)){const Se=ue[pe];if(Se.default!==void 0)we[pe]=O.$Tn(Se.default);else switch(Se.type){case"boolean":we[pe]=!1;break;case"number":case"integer":we[pe]=0;break;case"string":we[pe]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),pe));return}}}return P.create(we)}A.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Re[232],Ae([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,m)=>{this.b=M,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,m){return this.j().then(M,m)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$F$b=N;class R extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$G$b=R}),define(Re[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$gw=void 0,e.$hw=R,e.$iw=O;class I{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++I.count}}e.$gw=I;const N=[];function R(m){const g=new I(m);return N[g.nid]=g,g}function O(m){return N[m].sid}class M{constructor(g){this.value=g}}e.$jw=M}),define(Re[4],Ae([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$LM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var R;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var E;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$LM=k;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$MM={MainThreadAuthentication:(0,I.$hw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$hw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$hw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$hw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$hw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$hw)("MainThreadClipboard"),MainThreadCommands:(0,I.$hw)("MainThreadCommands"),MainThreadComments:(0,I.$hw)("MainThreadComments"),MainThreadConfiguration:(0,I.$hw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$hw)("MainThreadConsole"),MainThreadDebugService:(0,I.$hw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$hw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$hw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$hw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$hw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$hw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$hw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$hw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$hw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$hw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$hw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$hw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$hw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$hw)("MainThreadLanguages"),MainThreadLogger:(0,I.$hw)("MainThreadLogger"),MainThreadMessageService:(0,I.$hw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$hw)("MainThreadOutputService"),MainThreadProgress:(0,I.$hw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$hw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$hw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$hw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$hw)("MainThreadSecretState"),MainThreadStorage:(0,I.$hw)("MainThreadStorage"),MainThreadSpeech:(0,I.$hw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$hw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$hw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$hw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$hw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$hw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$hw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$hw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$hw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$hw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$hw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$hw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$hw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$hw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$hw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$hw)("MainThreadSCM"),MainThreadSearch:(0,I.$hw)("MainThreadSearch"),MainThreadShare:(0,I.$hw)("MainThreadShare"),MainThreadTask:(0,I.$hw)("MainThreadTask"),MainThreadWindow:(0,I.$hw)("MainThreadWindow"),MainThreadLabelService:(0,I.$hw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$hw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$hw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$hw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$hw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$hw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$hw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$hw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$hw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$hw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$hw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$hw)("MainThreadTimeline"),MainThreadTesting:(0,I.$hw)("MainThreadTesting"),MainThreadLocalization:(0,I.$hw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$hw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$hw)("MainThreadAiEmbeddingVector")},e.$NM={ExtHostCommands:(0,I.$hw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$hw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$hw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$hw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$hw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$hw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$hw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$hw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$hw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$hw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$hw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$hw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$hw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$hw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$hw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$hw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$hw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$hw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$hw)("ExtHostStatusBar"),ExtHostShare:(0,I.$hw)("ExtHostShare"),ExtHostExtensionService:(0,I.$hw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$hw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$hw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$hw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$hw)("ExtHostSCM"),ExtHostSearch:(0,I.$hw)("ExtHostSearch"),ExtHostTask:(0,I.$hw)("ExtHostTask"),ExtHostWorkspace:(0,I.$hw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$hw)("ExtHostWindow"),ExtHostWebviews:(0,I.$hw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$hw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$hw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$hw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$hw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$hw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$hw)("ExtHostProgress"),ExtHostComments:(0,I.$hw)("ExtHostComments"),ExtHostSecretState:(0,I.$hw)("ExtHostSecretState"),ExtHostStorage:(0,I.$hw)("ExtHostStorage"),ExtHostUrls:(0,I.$hw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$hw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$hw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$hw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$hw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$hw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$hw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$hw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$hw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$hw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$hw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$hw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$hw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$hw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$hw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$hw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$hw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$hw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$hw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$hw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$hw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$hw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$hw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$hw)("ExtHostTimeline"),ExtHostTesting:(0,I.$hw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$hw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$hw)("ExtHostLocalization")}}),define(Re[78],Ae([1,0,3,13,4,16]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=e.$1jc=void 0,e.$1jc=(0,I.$ni)("IExtHostApiDeprecationService");let M=class{constructor(g,E){this.c=E,this.a=new Set,this.b=g.getProxy(R.$MM.MainThreadTelemetry)}report(g,E,T){const k=this.d(g,E);this.a.has(k)||(this.a.add(k),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:g}))}d(g,E){return`${g}-${E.identifier.value}`}};e.$2jc=M,e.$2jc=M=Je([We(0,O.$0O),We(1,N.$Tj)],M),e.$3jc=Object.freeze(new class{report(m,g,E){}})}),define(Re[233],Ae([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class N{constructor(O){const M=O.getProxy(I.$MM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(m){return M.$writeText(m)}})}}e.$dkc=N}),define(Re[234],Ae([1,0,26,4,27,16]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let M=class{constructor(T,k){this.a=T.getProxy(N.$MM.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,k){const u=this,b=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){u.e(T,k,b,arguments)}})}e(T,k,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(b,this.b)}),this.c&&this.f(T,u,b)}};e.$0lc=M,e.$0lc=M=Je([We(0,O.$0O),We(1,R.$nP)],M);const m=1e5;function g(E,T){const k=[];if(E.length)for(let u=0;u<E.length;u++){let b=E[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const d=b;d.stack?b=d.stack:b=d.toString()}k.push(b)}if(T){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Yn)(k);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[235],Ae([1,0,2,4,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class O{constructor(m){this.a=m.getProxy(N.$MM.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,R.$vG)(m,"showLocal"),this.a.$showOpenDialog(g).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?I.URI.revive(g):void 0)}}e.$alc=O}),define(Re[236],Ae([1,0,6,4]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(N.$MM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$ulc=R}),define(Re[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0;let T=class{constructor(u,b,d){this.f=d,this.d=new Map,this.a=b.getProxy(m.$MM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,b){const{message:d,args:n,comment:o}=b;if(this.c)return(0,N.$2e)(d,n??{});let s=d;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(u)?.contents[s];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$2e)(r??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),o=JSON.parse(n);b=u.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:d})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(b)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ukc=T,e.$Ukc=T=Je([We(0,g.$nP),We(1,E.$0O),We(2,M.$Tj)],T),e.$Vkc=(0,O.$ni)("IExtHostLocalizationService")}),define(Re[237],Ae([1,0,13,4,27,16,2,53]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;let g=class extends I.$5j{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,m.$Wh)(b))),this.r=k.getProxy(N.$MM.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(M.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.r.$setVisibility(k,u)}s(k,u,b){return new E(this.r,k,u,b)}};e.$9lc=g,e.$9lc=g=Je([We(0,O.$0O),We(1,R.$nP)],g);class E extends I.$Zj{constructor(k,u,b,d){super(d?.logLevel==="always"),this.r=k,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(k,u){const b=[[k,u]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,4,3,6,16,22]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0,e.$Wkc=(0,N.$ni)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(I.$MM.MainThreadManagedSockets)}setFactory(k,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,b=await this.c.makeConnection(),d=new R.$Tc;return this.d.set(u,new E(u,b,d)),d.add((0,R.$Sc)(()=>this.d.delete(u))),d.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(b.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(b.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,M.$ze.wrap(n)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Xkc=m,e.$Xkc=m=Je([We(0,O.$0O)],m);class g{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class E extends R.$Uc{constructor(k,u,b){super(),this.socketId=k,this.actual=u,this.B(b)}}}),define(Re[238],Ae([1,0,4,13,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;function O(m){return m&&m.title}let M=class{constructor(g,E){this.b=E,this.a=g.getProxy(I.$MM.MainThreadMessageService)}showMessage(g,E,T,k,u){const b={source:{identifier:g.identifier,label:g.displayName||g.name}};let d;typeof k=="string"||O(k)?d=[k,...u]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,d=u),b.useCustom&&(0,R.$vG)(g,"resolvers");const n=[];let o=!1;for(let s=0;s<d.length;s++){const r=d[s];if(typeof r=="string")n.push({title:r,handle:s,isCloseAffordance:!1});else if(typeof r=="object"){const{title:i,isCloseAffordance:a}=r;n.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,r)}return this.a.$showMessage(E,T,b,n).then(s=>{if(typeof s=="number")return d[s]})}};e.$wlc=M,e.$wlc=M=Je([We(1,N.$Tj)],M)}),define(Re[239],Ae([1,0,6,17,2,25,4]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class m{constructor(E){this.b=new Map,this.a=E.getProxy(M.$MM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,k){if((0,O.$vG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,k),this.a.$registerProfileContentHandler(T,k.name,k.description,E.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,k,u){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.saveProfile(T,k,u)}async $readProfile(E,T,k){const u=this.b.get(E);if(!u)throw new Error(`Unknown handler with id: ${E}`);return u.readProfile((0,N.$1f)(T)?T:R.URI.revive(T),k)}}e.$Flc=m}),define(Re[81],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=void 0;class O{constructor(m){this.b=new N.$_d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(I.$MM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,E){return this.a.$setPassword(m,g,E)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Rkc=O,e.$Skc=(0,R.$ni)("IExtHostSecretState")}),define(Re[240],Ae([1,0,24,6,4]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class O{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(R.$MM.MainThreadSpeech)}async $createSpeechToTextSession(m,g,E){const T=this.c.get(m);if(!T)return;const k=new N.$Tc,u=new I.$je;this.d.set(g,u);const b=k.add(T.provideSpeechToTextSession(u.token,E?{language:E}:void 0));k.add(b.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,d)})),k.add(u.token.onCancellationRequested(()=>k.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,g){const E=this.c.get(m);if(!E)return;const T=new N.$Tc,k=new I.$je;this.d.set(g,k);const u=T.add(E.provideKeywordRecognitionSession(k.token));T.add(u.onDidChange(b=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,b)})),T.add(k.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,E){const T=O.a++;return this.c.set(T,E),this.b.$registerProvider(T,g,{extension:m,displayName:m.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Mlc=O}),define(Re[82],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;class O{constructor(m,g){this.c=g,this.b=new N.$_d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(I.$MM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,E){const T=await this.a.$initializeExtensionStorage(m,g);let k;return T&&(k=this.d(m,g,T)),k||E}setValue(m,g,E){return this.a.$setValue(m,g,E)}$acceptValue(m,g,E){const T=this.d(m,g,E);T&&this.b.fire({shared:m,key:g,value:T})}d(m,g,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${T}`)}}}e.$Hkc=O,e.$Ikc=(0,R.$ni)("IExtHostStorage")}),define(Re[241],Ae([1,0,6,12,2,4]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(O.$MM.MainThreadUriOpeners)}registerExternalUriOpener(g,E,T,k){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const u=k.schemes.find(b=>!M.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,k.schemes,g,k.label),(0,I.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(g,E,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const u=R.URI.revive(E);return k.canOpenExternalUri(u,T)}async $openUri(g,E,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},T)}}e.$3lc=M}),define(Re[242],Ae([1,0,4,2,6,14,20]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class m{static{this.a=0}constructor(E){this.c=new M.$Jm,this.d=new Map,this.b=E.getProxy(I.$MM.MainThreadUrls)}registerUriHandler(E,T){const k=E.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=m.a++;return this.c.add(k),this.d.set(u,T),this.b.$registerUriHandler(u,k,E.displayName||E.name),(0,R.$Sc)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(E,T){const k=this.d.get(E);if(!k)return Promise.resolve(void 0);try{k.handleUri(N.URI.revive(T))}catch(u){(0,O.$1)(u)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$4lc=m}),define(Re[63],Ae([1,0,5,6,12,26,2,189,211,76,4]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=e.$skc=void 0,e.$tkc=u,e.$vkc=n,e.$wkc=o;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,v,c,$,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$_d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$_d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=v,this.#s=c,this.#r=$,this.#l=u($),this.#d=b($),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$Dxb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===R.Schemas.https||a.scheme===R.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$Cxb}return E.$Cxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),O.$Xn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,g.$Tnb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=M.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),f=(0,E.$Dxb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=M.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),f=(0,E.$Dxb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`})}}e.$skc=k;function u(i){try{const a=(0,m.$zp)((0,m.$yp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function b(i){try{const a=(0,m.$zp)((0,m.$yp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class d extends N.$Uc{constructor(a,h,t,v,c){super(),this.c=h,this.f=t,this.g=v,this.h=c,this.b=new Map,this.a=a.getProxy(T.$MM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const v=this.j(a);if(v){const{message:c}=(0,g.$Unb)(h,t.value);v._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const v=new k(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,v);const c=v._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$ukc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>M.URI.from(a))}}function r(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Re[109],Ae([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0;let k=class{static{T=this}static{this.a={focused:!0,active:!0}}getState(b){const d=this.d;return{get focused(){return d.focused},get active(){return(0,E.$vG)(b,"windowActivity"),d.active}}}constructor(b){this.c=new I.$_d,this.onDidChangeWindowState=this.c.event,this.d=T.a,this.b=b.getProxy(N.$MM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:d,isActive:n})=>{this.onDidChangeWindowProperty("focused",d),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,d){d!==this.d[b]&&(this.d={...this.d,[b]:d},this.c.fire(this.d))}openUri(b,d){let n;if(typeof b=="string"){n=b;try{b=R.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,M.$Ze)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,n,d)}async asExternalUri(b,d){if((0,M.$Ze)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(b,d);return R.URI.from(n)}};e.$6lc=k,e.$6lc=k=T=Je([We(0,g.$0O)],k),e.$7lc=(0,m.$ni)("IExtHostWindow")}),define(Re[243],Ae([1,0,234,27,16]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;let O=class extends I.$0lc{constructor(m,g){super(m,g)}f(m,g,E){g.apply(console,E)}};e.$foc=O,e.$foc=O=Je([We(0,R.$0O),We(1,N.$nP)],O)}),define(Re[244],Ae([1,0,11,22,24,14,5,6,144,232,34]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$H$b=o,e.$I$b=s;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const b="$$ref$$",d={[b]:-1};class n{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(y,C=null,P=!1){const W=[];return{jsonString:(P?u:JSON.stringify)(y,(q,A)=>{if(typeof A>"u")return d;if(typeof A=="object"){if(A instanceof N.$ze){const U=W.push(A)-1;return{[b]:U}}if(C)return C(q,A)}return A}),referencedBuffers:W}}function s(y,C,P){return JSON.parse(y,(W,V)=>{if(V){const q=V[b];if(typeof q=="number")return C[q];if(P&&V.$mid===1)return P.transformIncoming(V)}return V})}function r(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends m.$Uc{static{k=v}static{this.a=3*1e3}constructor(C,P=null,W=null){super(),this[k]=!0,this.b=this.B(new M.$_d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$gw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$zh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,g.$sn)(C,this.g):C}getProxy(C){const{nid:P,sid:W}=C;return this.s[P]||(this.s[P]=this.J(P,W)),this.s[P]}J(C,P){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(C,q,A)),q===c?P:V[q])};return new Proxy(Object.create(null),W)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,W=C.length;P<W;P++){const V=C[P];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,W=p.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:U,args:K}=D.deserializeRequestJSONArgs(W);this.g&&(K=(0,g.$sn)(K,this.g)),this.M(P,q,A,U,K,V===2);break}case 3:case 4:{let{rpcId:A,method:U,args:K}=D.deserializeRequestMixedArgs(W);this.g&&(K=(0,g.$sn)(K,this.g)),this.M(P,q,A,U,K,V===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=D.deserializeReplyOKJSON(W);this.g&&(A=(0,g.$sn)(A,this.g)),this.O(P,q,A);break}case 10:{const A=D.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(P,q,A);break}case 8:{const A=D.deserializeReplyOKVSBuffer(W);this.O(P,q,A);break}case 11:{let A=D.deserializeReplyErrError(W);this.g&&(A=(0,g.$sn)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,W,V,q,A){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$iw)(W)}.${V}(`,q);const U=String(P);let K,ie;if(A){const we=new R.$je;q.push(we.token),K=this.Q(W,V,q),ie=()=>we.cancel()}else K=this.Q(W,V,q),ie=t;this.u[U]=ie;const ce=D.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(we=>{delete this.u[U];const Ie=D.serializeReplyOK(P,we,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",we),this.c.send(Ie)},we=>{delete this.u[U];const Ie=D.serializeReplyErr(P,we);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",we),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const W=String(P);this.u[W]?.()}O(C,P,W){this.f?.logIncoming(C,P,0,"receiveReply:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,P,W){this.f?.logIncoming(C,P,0,"receiveReplyErr:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(C,P,W){try{return Promise.resolve(this.S(C,P,W))}catch(V){return Promise.reject(V)}}S(C,P,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,T.$iw)(C));const q=V[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$iw)(C));return q.apply(V,W)}U(C,P,W){if(this.j)return new E.$G$b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$6());const q=D.serializeRequestArguments(W,this.h),A=++this.t,U=String(A),K=new E.$F$b,ie=new m.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const we=D.serializeCancel(A);this.f?.logOutgoing(we.byteLength,A,0,"cancel"),this.c.send(D.serializeCancel(A))})),this.w[U]=new w(K,ie),this.F(A);const ce=D.serializeRequest(A,C,P,q,!!V);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,T.$iw)(C)}.${P}(`,W),this.c.send(ce),K}}e.$J$b=$;class w{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class p{static alloc(C,P,W){const V=new p(N.$ze.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(P),V}static read(C,P){return new p(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,W=C.length;P<W;P++){const V=C[P];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:P[W]=this.readLongString();break;case 2:P[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());P[W]=new T.$jw(s(A,U,null));break}case 4:P[W]=void 0;break}return P}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class D{static a(C){for(let P=0,W=C.length;P<W;P++)if(C[P]instanceof N.$ze||C[P]instanceof T.$jw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const A=C[V];if(A instanceof N.$ze)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof T.$jw){const{jsonString:U,referencedBuffers:K}=o(A.value,P);W[V]={type:3,value:N.$ze.fromString(U),buffers:K}}else W[V]={type:1,value:N.$ze.fromString(r(A,P))}}return{type:1,args:W}}return{type:0,args:r(C,P)}}static serializeRequest(C,P,W,V,q){switch(V.type){case 0:return this.b(C,P,W,V.args,q);case 1:return this.c(C,P,W,V.args,q)}}static b(C,P,W,V,q){const A=N.$ze.fromString(W),U=N.$ze.fromString(V);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(A),K+=p.sizeLongString(U);const ie=p.alloc(q?2:1,C,K);return ie.writeUInt8(P),ie.writeShortString(A),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:P,method:W,args:JSON.parse(V)}}static c(C,P,W,V,q){const A=N.$ze.fromString(W);let U=0;U+=p.sizeUInt8(),U+=p.sizeShortString(A),U+=p.sizeMixedArray(V);const K=p.alloc(q?4:3,C,U);return K.writeUInt8(P),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let A=0,U=V.length;A<U;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:P,method:W,args:q}}static serializeAcknowledged(C){return p.alloc(5,C,0).buffer}static serializeCancel(C){return p.alloc(6,C,0).buffer}static serializeReplyOK(C,P,W){if(typeof P>"u")return this.d(C);if(P instanceof N.$ze)return this.e(C,P);if(P instanceof T.$jw){const{jsonString:V,referencedBuffers:q}=o(P.value,W,!0);return this.g(C,V,q)}else return this.f(C,u(P,W))}static d(C){return p.alloc(7,C,0).buffer}static e(C,P){let W=0;W+=p.sizeVSBuffer(P);const V=p.alloc(8,C,W);return V.writeVSBuffer(P),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const W=N.$ze.fromString(P);let V=0;V+=p.sizeLongString(W);const q=p.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,P,W){const V=N.$ze.fromString(P);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(V);for(const U of W)q+=p.sizeVSBuffer(U);const A=p.alloc(10,C,q);A.writeUInt32(W.length),A.writeLongString(V);for(const U of W)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let A=0;A<W;++A)q.push(C.readVSBuffer());return new T.$jw(s(V,q,P))}static serializeReplyErr(C,P){const W=P?u(O.$3(P),null):void 0;if(typeof W!="string")return this.h(C);const V=N.$ze.fromString(W);let q=0;q+=p.sizeLongString(V);const A=p.alloc(11,C,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return p.alloc(12,C,0).buffer}}var f;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Re[245],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;const I=function(O){const M=m=>{globalThis.removeEventListener("message",M);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){g.postMessage(E,T)}},onmessage:{get(){return g.onmessage},set(E){g.onmessage=E}}}),g.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(O,M,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${I})('${M}'))`,E=new Blob([g],{type:"application/javascript"}),T=URL.createObjectURL(E),k=new MessageChannel,u=T,b={type:"_newWorker",id:u,port:k.port2,url:T,options:m};O(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(d){k.port1.onmessage=d}},onmessageerror:{get(){return k.port1.onmessageerror},set(d){k.port1.onmessageerror=d}}}),k.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),k.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),k.port1.start()}}e.$hoc=N}),define(Re[246],Ae([1,0,22,28,12,55,3]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=void 0,e.$pK=T,e.$qK=k,e.$oK=(0,M.$ni)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${m.join("")}]+`),E=7;function T(b){if(b.scheme!==R.Schemas.vscodeNotebookCell)return;const d=b.fragment.indexOf("s");if(d<0)return;const n=parseInt(b.fragment.substring(0,d).replace(g,""),E),o=(0,I.$Se)(b.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:b.with({scheme:o,fragment:null})}}function k(b,d){const n=d.toString(E),s=`${n.length<m.length?m[n.length-1]:"z"}${n}s${(0,I.$Te)(I.$ze.fromString(b.scheme),!0,!0)}`;return b.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new N.$Bc}getNotebook(d){if(d.scheme===R.Schemas.vscodeNotebookCell){const n=T(d);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$rK=u,(0,O.$ls)(e.$oK,u,1)}),define(Re[83],Ae([1,0,22,36,46,69,12,19,21,31,246]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$IK=e.CellStatusbarAlignment=e.$HK=e.NotebookEditorPriority=e.$EK=e.$DK=e.$BK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AK=e.$zK=e.$yK=e.$xK=e.CellKind=e.$wK=e.$vK=e.$uK=void 0,e.$CK=v,e.$FK=$,e.$GK=w,e.$JK=D,e.$KK=S,e.$uK="workbench.editor.notebook",e.$vK="workbench.editor.notebookTextDiffEditor",e.$wK="workbench.editor.interactive";var k;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(k||(e.CellKind=k={})),e.$xK=["application/json","application/javascript","text/html","image/svg+xml",O.$Es.latex,O.$Es.markdown,"image/png","image/jpeg",O.$Es.text],e.$yK=[O.$Es.latex,O.$Es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Es.text],e.$zK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var d;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var r;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function ie(re,Se){return(0,T.$qK)(re,Se)}K.generate=ie;function ce(re){return(0,T.$pK)(re)}K.parse=ce;function we(re,Se){return re.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${re.scheme!==M.Schemas.file?re.scheme:""}`})}K.generateCellOutputUri=we;function Ie(re){if(re.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!Se)return;const Le=Se[1]&&Se[1]!==""?Se[1]:void 0,ne=Se[2];return{outputId:Le,notebook:re.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(re,Se,Le){return K.generate(re,Se).with({scheme:Le})}K.generateCellPropertyUri=ue;function pe(re,Se){if(re.scheme===Se)return K.parse(re.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$xK){this.e=ce,this.d=[...new Set(ie)].map(we=>({pattern:we,matches:N.$hk(h(we))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,Ie=>[Ie,h(Ie)]));let we=[];for(const{matches:Ie}of this.d)for(const[ue,pe]of ce)if(Ie(pe)){we.push(ue),ce.delete(ue);break}return ce.size&&(we=we.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),we}prioritize(ie,ce){const we=this.f(ie);if(we===-1){this.d.unshift({pattern:ie,matches:N.$hk(h(ie))});return}const Ie=new Set(ce.map(pe=>this.f(pe,we)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(we+1,0,...ue.map(pe=>this.d[pe]));for(let pe=ue.length-1;pe>=0;pe--)this.d.splice(ue[pe],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const we=h(ie);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(we))return Ie;return-1}}e.$BK=t;function v(K,ie,ce,we=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Se,Le,ne){if(Le===0&&ne.length===0)return;const j=Ie[Ie.length-1];j&&j.start+j.deleteCount===Se?(j.deleteCount+=Le,j.toInsert.push(...ne)):Ie.push({start:Se,deleteCount:Le,toInsert:ne})}let pe=0,re=0;for(;;){if(pe===K.length){ue(pe,0,ie.slice(re));break}if(re===ie.length){ue(pe,K.length-pe,[]);break}const Se=K[pe],Le=ie[re];if(we(Se,Le)){pe+=1,re+=1;continue}ce(Le)?(ue(pe,1,[]),pe+=1):(ue(pe,0,[Le]),re+=1)}return Ie}e.$DK=new E.$Ej("notebookEditorCursorAtBoundary","none"),e.$EK=new E.$Ej("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(K){const ie=K;return!!((typeof ie.include=="string"||N.$ik(ie.include))&&(typeof ie.exclude=="string"||N.$ik(ie.exclude)))}function w(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const we=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$gk(we,(0,m.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&N.$gk(Ie,(0,m.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$HK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.$IK=l;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function S(K){const ie=[];let ce=!1;for(const pe of K)(ie.length===0||ce)&&(ie.push(pe),ce=!0);let we=P(ie);const Ie=I.$ze.concat(ie.map(pe=>I.$ze.wrap(pe))),ue=U(Ie);return we=we||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:we}}e.$LK="\x1B[A";const y=e.$LK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let ie=!1;return K.forEach((ce,we)=>{if(we===0||ce.length<e.$LK.length)return;const Ie=K[we-1],ue=ce.subarray(0,e.$LK.length);if(ue[0]===y[0]&&ue[1]===y[1]&&ue[2]===y[2]){const pe=Ie.lastIndexOf(C);if(pe===-1)return;ie=!0,K[we-1]=Ie.subarray(0,pe),K[we]=ce.subarray(e.$LK.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$ze.fromString(V(W(f.decode(K.buffer))))}}),define(Re[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,43,102,83]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d){"use strict";var n,o,s,r,i,a,h,t,v,c,$,w,p,l,D,f,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$XO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$WO=e.$VO=e.$UO=e.$TO=e.ChatLocation=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$JO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$wO=e.$vO=e.$uO=e.$tO=e.$rO=e.$qO=e.$pO=e.$oO=e.TestRunProfileKind=e.TestResultState=e.$nO=e.$mO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$lO=e.NotebookVariablesRequestKind=e.$kO=e.$jO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$iO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.ColorThemeKind=e.$cO=e.$bO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$aO=e.$_N=e.DebugConsoleMode=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$6N=e.$5N=e.FileChangeType=e.$4N=e.NewSymbolNameTag=e.$3N=e.$2N=e.$1N=e.$ZN=e.InlineCompletionTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$MN=e.ConfigurationTarget=e.$LN=e.$KN=e.$JN=e.$IN=e.DocumentPasteTriggerKind=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BN=e.ViewBadge=e.ProgressLocation=e.$AN=e.$zN=e.TaskScope=e.ShellQuoting=e.$yN=e.$xN=e.$wN=e.TaskPanelKind=e.TaskRevealKind=e.$vN=e.TerminalLocation=e.$uN=e.$tN=e.$sN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rN=e.$qN=e.$pN=e.$oN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iN=e.$hN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.LanguageStatusSeverity=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.CodeActionTriggerKind=e.$8M=e.$7M=e.SymbolTag=e.SymbolKind=e.$6M=e.$5M=e.DocumentHighlightKind=e.$4M=e.$3M=e.$2M=e.$1M=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZM=e.$YM=e.FileEditType=e.$XM=e.$WM=e.$VM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$nN=dt,e.$NN=ae,e.$sO=bt;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=te;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let W=n=class{static from(...F){let te=F;return new n(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$OM=W,e.$OM=W=n=Je([y],W);let V=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,N.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,N.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$PM=V,e.$PM=V=o=Je([y],V);let q=s=class{static isRange(F){return F instanceof s?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ge){let Xe,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Xe=new V(F,te),lt=new V(De,Ge)):V.isPosition(F)&&V.isPosition(te)&&(Xe=V.of(F),lt=V.of(te)),!Xe||!lt)throw new Error("Invalid arguments");Xe.isBefore(lt)?(this.c=Xe,this.e=lt):(this.c=lt,this.e=Xe)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=V.Max(F.start,this.c),De=V.Min(F.end,this.e);if(!te.isAfter(De))return new s(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=V.Min(F.start,this.c),De=V.Max(F.end,this.end);return new s(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,N.$7)();let De;return F?V.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new s(De,te)}toJSON(){return[this.start,this.end]}};e.$QM=q,e.$QM=q=s=Je([y],q);let A=r=class extends q{static isSelection(F){return F instanceof r?!0:F?q.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ge){let Xe,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Xe=new V(F,te),lt=new V(De,Ge)):V.isPosition(F)&&V.isPosition(te)&&(Xe=V.of(F),lt=V.of(te)),!Xe||!lt)throw new Error("Invalid arguments");super(Xe,lt),this.f=Xe,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$RM=A,e.$RM=A=r=Je([y],A);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof De<"u"&&U(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$SM=K;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$TM=ie;class ce extends Error{static NotAvailable(F,te){return new ce(F,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,ce.prototype)}}e.$UM=ce;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=i=class{static isTextEdit(F){return F instanceof i?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new q(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,N.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,N.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,N.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VM=ue,e.$VM=ue=i=Je([y],ue);let pe=a=class{static isNotebookCellEdit(F){return F instanceof a?!0:F?fi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new a(F,te)}static insertCells(F,te){return new a(new fi(F,F),te)}static deleteCells(F){return new a(F,[])}static updateCellMetadata(F,te){const De=new a(new fi(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new a(new fi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$WM=pe,e.$WM=pe=a=Je([y],pe);class re{static isSnippetTextEdit(F){return F instanceof re?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new re(F,te)}static insert(F,te){return re.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$XM=re;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let Le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ge){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ge})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ge){const Xe=te.start,lt=te.end;(Xe!==lt||De.length>0)&&this.c.push({_type:5,uri:F,index:Xe,count:lt-Xe,cells:De,metadata:Ge})}g(F,te,De,Ge){this.c.push({_type:3,metadata:Ge,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ge){this.c.push({_type:2,uri:F,edit:new ue(te,De),metadata:Ge})}insert(F,te,De,Ge){this.replace(F,new q(te,te),De,Ge)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ge,Xe;Array.isArray(De)?(Ge=De[0],Xe=De[1]):Ge=De,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(F,Ge.range.start,Ge.newCellMetadata,Xe):Ge.newNotebookMetadata?this.e(F,Ge.newNotebookMetadata,Xe):this.f(F,Ge.range,Ge.newCells,Xe):re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:F,range:Ge.range,edit:Ge.snippet,metadata:Xe}):this.c.push({_type:2,uri:F,edit:Ge,metadata:Xe})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YM=Le,e.$YM=Le=Je([y],Le);let ne=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new h;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new h;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$ZM=ne,e.$ZM=ne=h=Je([y],ne);var j;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(F){return F instanceof t?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1M=ve,e.$1M=ve=t=Je([y],ve);let Ne=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$2M=Ne,e.$2M=Ne=Je([y],Ne);let Ee=class{constructor(F,te,De=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Ne.isEqual)}};e.$3M=Ee,e.$3M=Ee=Je([y],Ee);let $e=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$4M=$e,e.$4M=$e=Je([y],$e);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let Q=class{constructor(F,te=fe.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$5M=Q,e.$5M=Q=Je([y],Q);let X=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$6M=X,e.$6M=X=Je([y],X);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Te=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ge,Xe){this.name=F,this.kind=te,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),Ge instanceof ve?this.location=Ge:De instanceof q&&(this.location=new ve(Ge,De)),v.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$7M=Te,e.$7M=Te=v=Je([y],Te);let he=c=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(c.validate)}constructor(F,te,De,Ge,Xe){this.name=F,this.detail=te,this.kind=De,this.range=Ge,this.selectionRange=Xe,this.children=[],c.validate(this)}};e.$8M=he,e.$8M=he=c=Je([y],he);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(F,te){this.title=F,this.kind=te}};e.$9M=Me,e.$9M=Me=Je([y],Me);let ze=class{static{$=this}static{this.c="."}constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};e.$0M=ze,e.$0M=ze=$=Je([y],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$M=z,e.$$M=z=Je([y],z);class L{constructor(F,te,De,Ge,Xe,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Xe,this.selectionRange=lt}}e.$_M=L;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$aN=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$bN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$cN=se,e.$cN=se=Je([y],se);let Oe=w=class{#e;static isMarkdownString(F){return F instanceof w?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new R.$Kk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$dN=Oe,e.$dN=Oe=w=Je([y],Oe);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$eN=Be,e.$eN=Be=Je([y],Be);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$fN=Qe,e.$fN=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gN=xe,e.$gN=xe=Je([y],xe);var _e;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var et;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let tt=class{constructor(F){this.value=F}};e.$hN=tt,e.$hN=tt=Je([y],tt);let nt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$iN=nt,e.$iN=nt=Je([y],nt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jN=st,e.$jN=st=Je([y],st);let Z=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$kN=Z,e.$kN=Z=Je([y],Z);let Y=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$lN=Y,e.$lN=Y=Je([y],Y);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$mN=me,e.$mN=me=Je([y],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${k.$Im.toKey(B)}.${F}`}var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Bt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var Xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var qt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(qt||(e.TextEditorSelectionChangeKind=qt={}));var xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Et;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Et||(e.DecorationRangeBehavior=Et={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(qt||(e.TextEditorSelectionChangeKind=qt={}));var Vt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Vt||(e.SyntaxTokenType=Vt={}));let Ht=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.target=te}};e.$oN=Ht,e.$oN=Ht=Je([y],Ht);let Ze=class{constructor(F,te,De,Ge){this.red=F,this.green=te,this.blue=De,this.alpha=Ge}};e.$pN=Ze,e.$pN=Ze=Je([y],Ze);let ri=class{constructor(F,te){if(te&&!(te instanceof Ze))throw(0,N.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.color=te}};e.$qN=ri,e.$qN=ri=Je([y],ri);let _t=class{constructor(F){if(!F||typeof F!="string")throw(0,N.$7)("label");this.label=F}};e.$rN=_t,e.$rN=_t=Je([y],_t);var ht;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ht||(e.ColorFormat=ht={}));var $t;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));class ti{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$sN=ti;class Lt{constructor(F){this.uri=F}}e.$tN=Lt;class gt{constructor(F){this.terminalCommand=F}}e.$uN=gt;var zt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(zt||(e.TerminalLocation=zt={}));class ii{constructor(F){if(this.options=F,typeof F!="object")throw(0,N.$7)("options")}}e.$vN=ii;var Tt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var Ke;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Ke||(e.TaskPanelKind=Ke={}));let si=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=F}get id(){return this.c}};e.$wN=si,e.$wN=si=p=Je([y],si);function Gt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let jt=class{constructor(F,te,De){if(typeof F!="string")throw(0,N.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,N.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Gt(F)}};e.$xN=jt,e.$xN=jt=Je([y],jt);let mt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,N.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Gt(F)}};e.$yN=mt,e.$yN=mt=Je([y],mt);var Ot;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Ot||(e.ShellQuoting=Ot={}));var Mt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Mt||(e.TaskScope=Mt={}));class Ut{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Jg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$zN=Ut;let Kt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ge,Xe,lt){this.k=!1,this.l=this.definition=F;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ge,pt=Xe,this.k=!0):te===Mt.Global||te===Mt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Xe,pt=lt):(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Xe,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof mt?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,T.$Jg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,N.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$AN=Kt,e.$AN=Kt=l=Je([y],Kt);var Jt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var oi;(function(B){function F(te){const De=te;return(0,g.$5f)(De.value)?De.tooltip&&!(0,g.$1f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=F})(oi||(e.ViewBadge=oi={}));let Ct=D=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ge=(0,g.$5f)(De.checkboxState)?De.checkboxState:(0,g.$3f)(De.checkboxState)&&(0,g.$5f)(De.checkboxState.state)?De.checkboxState.state:void 0,Xe=!(0,g.$5f)(De.checkboxState)&&(0,g.$3f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==It.Checked&&Ge!==It.Unchecked||Xe!==void 0&&!(0,g.$1f)(Xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof D)return!0;if(De.label!==void 0&&!(0,g.$1f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$1f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$1f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$1f)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,g.$1f)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,g.$1f)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$1f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$1f)(De.tooltip)&&!(De.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Nt.None&&De.collapsibleState>Nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$1f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=Nt.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$BN=Ct,e.$BN=Ct=D=Je([y],Ct);var Nt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Nt||(e.TreeItemCollapsibleState=Nt={}));var It;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$CN=Dt,e.$CN=Dt=Je([y],Dt);class vt extends Dt{}e.$DN=vt;class St extends vt{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$EN=St;class li{constructor(F,te,De,Ge){this.name=F,this.uri=te,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$FN=li;let yt=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ge]of this.#e)for(const Xe of Ge)F.call(te,Xe,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$GN=yt,e.$GN=yt=Je([y],yt);let hi=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$HN=hi,e.$HN=hi=Je([y],hi);var Qt;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Qt||(e.DocumentPasteTriggerKind=Qt={}));class ai{static{this.c="."}constructor(F){this.value=F}append(...F){return new ai((this.value?[this.value,...F]:F).join(ai.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ai.c)}}e.$IN=ai,ai.Empty=new ai("");class pi{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}}e.$JN=pi;let ni=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$KN=ni,e.$KN=ni=Je([y],ni),ni.File=new ni("file"),ni.Folder=new ni("folder");let Rt=class{constructor(F){this.id=F}};e.$LN=Rt,e.$LN=Rt=Je([y],Rt);var yi;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let be=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$MN=be,e.$MN=be=Je([y],be);const Pe=new WeakMap;function ae(B,F){Pe.set(B,F)}let J=class{constructor(F,te,De,Ge,Xe){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof Xe=="string"&&(this.mode=Xe)}get id(){return this.c||(this.c=Pe.get(this)??(0,T.$Jg)()),this.c}};e.$ON=J,e.$ON=J=Je([y],J);let ke=class extends J{constructor(F,te,De,Ge,Xe,lt){if(super(te,De,Ge,Xe,lt),F===null)throw(0,N.$7)("location");this.location=F}};e.$PN=ke,e.$PN=ke=Je([y],ke);let Ve=class extends J{constructor(F,te,De,Ge,Xe,lt){super(te,De,Ge,Xe,lt),this.functionName=F}};e.$QN=Ve,e.$QN=Ve=Je([y],Ve);let Ye=class extends J{constructor(F,te,De,Ge,Xe,lt,pt,Wt){if(super(Ge,Xe,lt,pt,Wt),!te)throw(0,N.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$RN=Ye,e.$RN=Ye=Je([y],Ye);let qe=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$SN=qe,e.$SN=qe=Je([y],qe);let ut=class{constructor(F,te){this.port=F,this.host=te}};e.$TN=ut,e.$TN=ut=Je([y],ut);let kt=class{constructor(F){this.path=F}};e.$UN=kt,e.$UN=kt=Je([y],kt);let Ft=class{constructor(F){this.implementation=F}};e.$VN=Ft,e.$VN=Ft=Je([y],Ft);class Yt{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$WN=Yt;class at{constructor(F,te){this.session=F,this.threadId=te}}e.$XN=at;let Zt=class{constructor(F,te){this.range=F,this.expression=te}};e.$YN=Zt,e.$YN=Zt=Je([y],Zt);var mi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let vi=class{constructor(F,te){this.range=F,this.text=te}};e.$ZN=vi,e.$ZN=vi=Je([y],vi);let Di=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$1N=Di,e.$1N=Di=Je([y],Di);let Mi=class{constructor(F,te){this.range=F,this.expression=te}};e.$2N=Mi,e.$2N=Mi=Je([y],Mi);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$3N=Ni,e.$3N=Ni=Je([y],Ni);var qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));class Hi{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$4N=Hi;var Gi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Si=f=class extends Error{static FileExists(F){return new f(F,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(F){return new f(F,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(F){return new f(F,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(F){return new f(F,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,u.$9k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$5N=Si,e.$5N=Si=f=Je([y],Si);let Ti=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$6N=Ti,e.$6N=Ti=Je([y],Ti);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Pi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Pi||(e.CommentThreadCollapsibleState=Pi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Ji;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$7N=un;function ln(B){return typeof B>"u"||(0,g.$2f)(B)}class ki{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ge,Xe){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.q(F,te,De,Ge,Xe);if(q.isRange(F)&&typeof te=="string"&&ln(De))return this.o(F,te,De);throw(0,N.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=F.start.line,Xe=F.start.character,lt=F.end.character-F.start.character,pt=this.k.get(te);let Wt=0;if(De)for(const ui of De){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(ui);Wt|=1<<gi>>>0}this.q(Ge,Xe,lt,pt,Wt)}q(F,te,De,Ge,Xe){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Wt=this.g.length/5|0;let ui=0,gi=0;for(let $i=0;$i<Wt;$i++){let wi=this.g[5*$i],Vi=this.g[5*$i+1];wi===0?(wi=ui,Vi+=gi):wi+=ui,this.g[5*$i]=wi,this.g[5*$i+1]=Vi,ui=wi,gi=Vi}}let lt=F,pt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=Xe,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let pt=0;pt<De;pt++)te[pt]=pt;te.sort((pt,Wt)=>{const ui=F[5*pt],gi=F[5*Wt];if(ui===gi){const $i=F[5*pt+1],wi=F[5*Wt+1];return $i-wi}return ui-gi});const Ge=new Uint32Array(F.length);let Xe=0,lt=0;for(let pt=0;pt<De;pt++){const Wt=5*te[pt],ui=F[Wt+0],gi=F[Wt+1],$i=F[Wt+2],wi=F[Wt+3],Vi=F[Wt+4],Mn=ui-Xe,or=Mn===0?gi-lt:gi,Wi=5*pt;Ge[Wi+0]=Mn,Ge[Wi+1]=or,Ge[Wi+2]=$i,Ge[Wi+3]=wi,Ge[Wi+4]=Vi,Xe=ui,lt=gi}return Ge}build(F){return this.f?new Oi(new Uint32Array(this.g),F):new Oi(ki.r(this.g),F)}}e.$8N=ki;class Oi{constructor(F,te){this.resultId=te,this.data=F}}e.$9N=Oi;class Yi{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$0N=Yi;class hn{constructor(F,te){this.resultId=te,this.edits=F}}e.$$N=hn;var Fi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Fi||(e.DebugConsoleMode=Fi={}));class dn{constructor(F){this.name=F}}e.$_N=dn;let Li=class{static{this.Back={iconPath:new ni("arrow-left")}}constructor(){}};e.$aO=Li,e.$aO=Li=Je([y],Li);var Zi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var Ci;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ci||(e.ExtensionKind=Ci={}));class xi{static validate(F){if(typeof F.badge=="string"){let te=(0,m.$Af)(F.badge,0);if(te<F.badge.length&&(te+=(0,m.$Af)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ni.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$bO=xi;let je=class{constructor(F){this.kind=F}};e.$cO=je,e.$cO=je=Je([y],je);var di;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(di||(e.ColorThemeKind=di={}));class fi{static isNotebookRange(F){return F instanceof fi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new fi(te,De)}}e.$dO=fi;class it{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>it.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ge,Xe,lt,pt){this.kind=F,this.value=te,this.languageId=De,this.mime=Ge,this.outputs=Xe??[],this.metadata=lt,this.executionSummary=pt,it.validate(this)}}e.$eO=it;class wt{constructor(F){this.cells=F}}e.$fO=wt;class ci{static isNotebookCellOutputItem(F){return F instanceof ci?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ci.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ci.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ci.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ci(F,te)}static#e=new TextEncoder;static text(F,te=M.$Es.text){const De=ci.#e.encode(String(F));return new ci(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return ci.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,M.$Is)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$gO=ci;class Ri{static isNotebookCellOutput(F){return F instanceof Ri?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ge=new Set;for(let Xe=0;Xe<F.length;Xe++){const lt=F[Xe],pt=(0,M.$Is)(lt.mime);if(!De.has(pt)||(0,d.$JK)(pt)){De.add(pt);continue}Ge.add(Xe),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?F:F.filter((Xe,lt)=>!Ge.has(lt))}constructor(F,te,De){this.items=Ri.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Jg)(),this.metadata=te??De)}}e.$hO=Ri;var zi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(zi||(e.NotebookCellKind=zi={}));var _i;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Ei;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ei||(e.NotebookCellStatusBarAlignment=Ei={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(F,te){this.text=F,this.alignment=te}}e.$iO=fn;var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var ji;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ji||(e.NotebookControllerAffinity2=ji={}));class gn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$jO=gn;class mn{constructor(F){this.label=F}}e.$kO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Ui=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$lO=Ui,e.$lO=Ui=Je([y],Ui);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$mO=$n;class pn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$nO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let _=class{constructor(F=void 0,te=void 0,De=void 0,Ge=!1){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ge}};e.$oO=_,e.$oO=_=Je([y],_);let oe=S=class{static diff(F,te,De){const Ge=new S(F);return Ge.expectedOutput=te,Ge.actualOutput=De,Ge}constructor(F){this.message=F}};e.$pO=oe,e.$pO=oe=S=Je([y],oe);let Fe=class{constructor(F){this.id=F}};e.$qO=Fe,e.$qO=Fe=Je([y],Fe);class rt{constructor(F,te){this.covered=F,this.total=te,bt(this)}}e.$rO=rt;function bt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class At{static fromDetails(F,te){const De=new rt(0,0),Ge=new rt(0,0),Xe=new rt(0,0);for(const pt of te)if("branches"in pt){De.total+=1,De.covered+=pt.executed?1:0;for(const Wt of pt.branches)Ge.total+=1,Ge.covered+=Wt.executed?1:0}else Xe.total+=1,Xe.covered+=pt.executed?1:0;const lt=new At(F,De,Ge.total>0?Ge:void 0,Xe.total>0?Xe:void 0);return lt.detailedCoverage=te,lt}constructor(F,te,De,Ge){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ge}}e.$tO=At;class Bi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$uO=Bi;class Nn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$vO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$wO=Tn;var vn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var wn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var bn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class On{constructor(F,te,De,Ge,Xe,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Xe,this.selectionRange=lt}}e.$xO=On;class Fn{constructor(F){this.uri=F}}e.$yO=Fn;class Ln{constructor(F,te){this.original=F,this.modified=te}}e.$zO=Ln;class zn{constructor(F,te,De,Ge){this.base=F,this.input1=te,this.input2=De,this.result=Ge}}e.$AO=zn;class jn{constructor(F,te){this.uri=F,this.viewType=te}}e.$BO=jn;class Un{constructor(F){this.viewType=F}}e.$CO=Un;class Bn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$DO=Bn;class Vn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$EO=Vn;class Wn{constructor(){}}e.$FO=Wn;class qn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$GO=qn;class Hn{constructor(){}}e.$HO=Hn;class Gn{constructor(F){this.textDiffs=F}}e.$IO=Gn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Kn{constructor(F,te){this.label=F,this.values=te}}e.$JO=Kn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Jn{constructor(F){this.value=typeof F=="string"?new Oe(F):F}}e.$KO=Jn;class Qn{constructor(F,te){this.value=F,this.baseUri=te}}e.$LO=Qn;class Yn{constructor(F,te){this.value=F,this.title=te}}e.$MO=Yn;class Zn{constructor(F){this.value=F}}e.$NO=Zn;class Xn{constructor(F){this.value=F}}e.$OO=Xn;class xn{constructor(F){this.value=F}}e.$PO=xn;class _n{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$QO=_n;class er{constructor(F,te,De,Ge){this.prompt=F,this.command=te,this.variables=De,this.participant=Ge}}e.$RO=er;class tr{constructor(F,te,De,Ge){this.response=F,this.result=te,this.participant=De,this.command=Ge}}e.$SO=tr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class ir{constructor(F){this.content=F}}e.$TO=ir;class nr{constructor(F,te){this.content=F,this.name=te}}e.$UO=nr;class rr{constructor(F,te){this.content=F,this.name=te}}e.$VO=rr;class Ai extends Error{static NotFound(F){return new Ai(F,Ai.NotFound.name)}static NoPermissions(F){return new Ai(F,Ai.NoPermissions.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$WO=Ai;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class sr{constructor(F,te){this.text=F,this.range=te}}e.$XO=sr;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Re[247],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$MM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(m,g)??[]}getRelatedInformation(M,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(M,m,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiRelatedInformationProvider(E,m),new N.$OM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Zjc=R}),define(Re[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=void 0,e.$$jc=(0,m.$ni)("IExtHostAuthentication");let E=class{constructor(u){this.b=new Map,this.c=new I.$_d,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=u.getProxy(N.$MM.MainThreadAuthentication)}async getSession(u,b,d,n={}){const o=O.$Im.toKey(u.identifier),s=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${s}`,async()=>{await this.a.$ensureProvider(b);const r=u.displayName||u.name;return this.a.$getSession(b,d,o,r,n)})}async getSessions(u,b,d){const n=O.$Im.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${n} ${o}`,async()=>{await this.a.$ensureProvider(b);const s=u.displayName||u.name;return this.a.$getSessions(b,d,n,s)})}async removeSession(u,b){const d=this.b.get(u);return d?d.provider.removeSession(b):this.a.$removeSession(u,b)}registerAuthenticationProvider(u,b,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:b,provider:d,options:n??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,b,n?.supportsMultipleAccounts??!1),new R.$OM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,b,d){const n=this.b.get(u);if(n)return Promise.resolve(n.provider.createSession(b,d));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,b){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,b){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,b){return u.startsWith(M.$OL)||this.c.fire({provider:{id:u,label:b}}),Promise.resolve()}};e.$_jc=E,e.$_jc=E=Je([We(0,g.$0O)],E);class T{constructor(){this.a=new Map}getOrCreate(u,b){const d=this.a.get(u);if(d)return d;const n=b().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Re[110],Ae([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=e.$$kc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(N.$MM.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=u.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,g.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,E.$6e)(c.path,"/")})),t=(0,g.$zb)(h,(c,$)=>c.rank-$.rank||(0,E.$jf)(c.uri.path,$.uri.path)),v=[];e:for(const c of t){let $;for(const w of c){const p=(0,T.$nc)(w.uri.path);if($!==p&&($=p,v.push(w.uri)>=u.d))break e}}this.g.$onDidChange(s,v)});return new R.$OM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{R.$bO.validate(c),c.badge&&typeof c.badge!="string"&&(0,k.$vG)(a,"codiconDecoration"),r[v]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),r}};e.$$kc=b,e.$$kc=b=u=Je([We(0,M.$0O),We(1,m.$Tj)],b),e.$_kc=(0,O.$ni)("IExtHostDecorations")}),define(Re[248],Ae([1,0,14,2,7,4,12,24,15]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class E{static{this.a=0}constructor(k,u,b){this.d=u,this.e=b,this.b=new Map,this.c=k.getProxy(O.$MM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(M.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=E.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,k);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(b,o).then(async r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,g.$df)(r);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,r)}).catch(I.$1).finally(()=>{n===s&&(n=void 0)});n=s})}return new R.$OM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,u){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(N.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$blc=E}),define(Re[111],Ae([1,0,56,12,15,303,152,7,18]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$_O=T;const E=new Map;function T(d,n){n?E.set(d,n):E.delete(d)}function k(d){return E.get(d)}class u extends O.$Mv{constructor(n,o,s,r,i,a,h){super(o,s,r,i),this.c=n,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,g.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===N.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,I.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,I.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,r=o.start.line,i=o.end.line,a=[];a.push(this.f[r].substring(o.start.character));for(let h=r+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(n){let o;if(n instanceof m.$PM?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new m.$PM(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof m.$QM))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new m.$QM(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof m.$PM))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,r=!1;if(o<0)o=0,s=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,r=!0;else{const i=this.f[o].length;s<0?(s=0,r=!0):s>i&&(s=i,r=!0)}return r?new m.$PM(o,s):n}y(n,o){const s=this.x(n);if(!o)o=k(this.m);else if((0,R.$cf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,M.$Ws)(s.character+1,(0,M.$Us)(o),this.f[s.line],0);if(r)return new m.$QM(s.line,r.startColumn-1,s.line,r.endColumn-1)}}e.$aP=u;class b{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$QM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$QM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bP=b}),define(Re[249],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$MM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(m,g);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,m,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiEmbeddingVectorProvider(m,E),new N.$OM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$dlc=R}),define(Re[64],Ae([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=void 0;let d=b=class{constructor(o,s){this.b=new Map,this.c=new T.$wh,this.a=o.getProxy(I.$MM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(i){try{let a;const h=r.b.get(i.scheme);return h?(await r.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await r.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===N.FilePermission.Readonly?1:void 0}}catch(a){b.e(a)}},async readDirectory(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await r.a.$readdir(i)}catch(a){return b.e(a)}},async createDirectory(i){try{const a=r.b.get(i.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(a.impl,a.extUri,i)):await r.a.$mkdir(i)}catch(a){return b.e(a)}},async readFile(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await r.a.$readFile(i)).buffer}catch(a){return b.e(a)}},async writeFile(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(i)),await r.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(i,O.$ze.wrap(a))}catch(h){return b.e(h)}},async delete(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await r.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return b.e(h)}},async rename(i,a,h){try{return await r.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},async copy(i,a,h){try{return await r.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,r){const i=[];for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&N.FileType.Directory))throw R.$5N.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(N.$0k(a)!==N.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(r)),r=s.dirname(r)}for(let a=i.length-1;a>=0;a--){r=s.joinPath(r,i[a]);try{await o.createDirectory(r)}catch(h){if(N.$0k(h)!==N.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$5N)throw o;if(o instanceof N.$6k)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw R.$5N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$5N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$5N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$5N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$5N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$5N.Unavailable(o.message);default:throw new R.$5N(o.message,o.name)}if(!(o instanceof Error))throw new R.$5N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$5N.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw R.$5N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$5N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$5N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$5N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$5N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$5N.Unavailable(o.message);default:throw new R.$5N(o.message,o.name)}}addFileSystemProvider(o,s,r){return this.b.set(o,{impl:s,extUri:r?.isCaseSensitive?k.$Qg:k.$Sg,isReadonly:!!r?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$Qg}};e.$okc=d,e.$okc=d=b=Je([We(0,m.$0O),We(1,g.$5jc)],d),e.$pkc=(0,M.$ni)("IExtHostConsumerFileSystem")}),define(Re[85],Ae([1,0,3,27,13,64,2]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0,e.$qkc=(0,I.$ni)("IExtensionStoragePaths");let m=class{constructor(E,T,k){this.d=T,this.f=k,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$rkc=m,e.$rkc=m=Je([We(0,N.$nP),We(1,R.$Tj),We(2,O.$pkc)],m)}),define(Re[250],Ae([1,0,7,16,5]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;let O=class{constructor(m){this.a=new I.$cO(I.ColorThemeKind.Dark),this.b=new R.$_d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=I.ColorThemeKind.Light;break;case"hcDark":g=I.ColorThemeKind.HighContrast;break;case"hcLight":g=I.ColorThemeKind.HighContrastLight;break;default:g=I.ColorThemeKind.Dark}this.a=new I.$cO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ylc=O,e.$Ylc=O=Je([We(0,N.$0O)],O)}),define(Re[86],Ae([1,0,24,5,6,174,3,13,204,4,27,16,7]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mCb=e.$lCb=e.TunnelDtoConverter=void 0;class b extends g.$_v{}var d;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function r(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==g.TunnelPrivacyId.ConstantPrivate&&i.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=r})(d||(e.TunnelDtoConverter=d={})),e.$lCb=(0,M.$ni)("IExtHostTunnelService");let n=class extends R.$Uc{constructor(s,r,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$_d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$MM.MainThreadTunnelService)}async openTunnel(s,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const i=await this.a.$openTunnel(r,s.displayName);if(i){const a=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,r){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:r}),this.a.$registerPortsAttributesProvider(s,i),new u.$OM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,r,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(r.map(async w=>{let p;try{p=await $.provider.providePortAttributes({port:w,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(w,i,a,h)}return{providedAttributes:p,port:w}})))}const v=t.filter(c=>!!c.providedAttributes);return v.length>0?v.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,r){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(r?this.w(r):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,r){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(r&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),d.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const r=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$mCb=n,e.$mCb=n=Je([We(0,k.$0O),We(1,T.$nP),We(2,m.$Tj)],n)}),define(Re[8],Ae([1,0,18,22,132,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,214,83,50,61,225,25,7]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v,c,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$7O=K,e.$8O=ce,e.$9O=we;var l;(function(be){function Pe(J){const{selectionStartLineNumber:ke,selectionStartColumn:Ve,positionLineNumber:Ye,positionColumn:qe}=J,ut=new p.$PM(ke-1,Ve-1),kt=new p.$PM(Ye-1,qe-1);return new p.$RM(ut,kt)}be.to=Pe;function ae(J){const{anchor:ke,active:Ve}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}be.from=ae})(l||(e.Selection=l={}));var D;(function(be){function Pe(J){if(!J)return;const{start:ke,end:Ve}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}be.from=Pe;function ae(J){if(!J)return;const{startLineNumber:ke,startColumn:Ve,endLineNumber:Ye,endColumn:qe}=J;return new p.$QM(ke-1,Ve-1,Ye-1,qe-1)}be.to=ae})(D||(e.Range=D={}));var f;(function(be){function Pe(J){return{uri:J.uri,range:D.from(J.range)}}be.from=Pe;function ae(J){return new p.$1M(n.URI.revive(J.uri),D.to(J.range))}be.to=ae})(f||(e.Location=f={}));var S;(function(be){function Pe(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}be.to=Pe})(S||(e.TokenType=S={}));var y;(function(be){function Pe(J){return new p.$PM(J.lineNumber-1,J.column-1)}be.to=Pe;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=ae})(y||(e.Position=y={}));var C;(function(be){function Pe(ke,Ve,Ye){return(0,I.$Hb)((0,I.$3b)(ke).map(qe=>ae(qe,Ve,Ye)))}be.from=Pe;function ae(ke,Ve,Ye){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ye?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Ve),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ye?.isBuiltin}}function J(ke,Ve){return Ve&&typeof ke=="string"?Ve.transformOutgoingScheme(ke):ke}})(C||(e.DocumentSelector=C={}));var P;(function(be){function Pe(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}be.from=Pe;function ae(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}be.to=ae})(P||(e.DiagnosticTag=P={}));var W;(function(be){function Pe(J){let ke;return J.code&&((0,d.$1f)(J.code)||(0,d.$5f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...D.from(J.range),message:J.message,source:J.source,code:ke,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(P.from)):void 0}}be.from=Pe;function ae(J){const ke=new p.$3M(D.to(J),J.message,q.to(J.severity));return ke.source=J.source,ke.code=(0,d.$1f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(P.to)),ke}be.to=ae})(W||(e.Diagnostic=W={}));var V;(function(be){function Pe(J){return{...D.from(J.location.range),message:J.message,resource:J.location.uri}}be.from=Pe;function ae(J){return new p.$2M(new p.$1M(J.resource,D.to(J)),J.message)}be.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(be){function Pe(J){switch(J){case p.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}be.from=Pe;function ae(J){switch(J){case r.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}be.to=ae})(q||(e.DiagnosticSeverity=q={}));var A;(function(be){function Pe(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?$.$LD:$.$KD}be.from=Pe;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(A||(e.ViewColumn=A={}));function U(be){return typeof be.range<"u"}function K(be){return be.length===0?!0:!!U(be[0])}var ie;(function(be){function Pe(qe){return qe.map(be.from)}be.fromMany=Pe;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:at,value:Zt}=qe;ut={value:"```"+at+`
`+Zt+"\n```\n"}}else p.$dN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ft=at=>{try{let Zt=n.URI.parse(at,!0);Zt=Zt.with({query:ke(Zt.query,kt)}),kt[at]=Zt}catch{}return""},Yt=new g.marked.Renderer;return Yt.link=Ft,Yt.image=at=>typeof at=="string"?Ft(M.$Sk(at).href):"",(0,g.marked)(ut.value,{renderer:Yt}),ut}be.from=J;function ke(qe,ut){if(!qe)return qe;let kt;try{kt=(0,E.$Vh)(qe)}catch{}if(!kt)return qe;let Ft=!1;return kt=(0,k.$Vn)(kt,Yt=>{if(n.URI.isUri(Yt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=Yt,Ft=!0,at}else return}),Ft?JSON.stringify(kt):qe}function Ve(qe){const ut=new p.$dN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?n.URI.from(qe.baseUri):void 0,ut}be.to=Ve;function Ye(qe){if(qe)return typeof qe=="string"?qe:be.from(qe)}be.fromStrict=Ye})(ie||(e.MarkdownString=ie={}));function ce(be){return K(be)?be.map(Pe=>({range:D.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?ie.fromMany(Pe.hoverMessage):Pe.hoverMessage?ie.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):be.map(Pe=>({range:D.from(Pe)}))}function we(be){return typeof be>"u"?be:typeof be=="string"?n.URI.file(be):be}var Ie;(function(be){function Pe(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?we(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Pe})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var ue;(function(be){function Pe(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?we(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}be.from=Pe})(ue||(e.ThemableDecorationRenderOptions=ue={}));var pe;(function(be){function Pe(ae){if(typeof ae>"u")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Pe})(pe||(e.DecorationRangeBehavior=pe={}));var re;(function(be){function Pe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?pe.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ue.from(ae.light):void 0,dark:ae.dark?ue.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?we(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}be.from=Pe})(re||(e.DecorationRenderOptions=re={}));var Se;(function(be){function Pe(J){return{text:J.newText,eol:J.newEol&&ft.from(J.newEol),range:D.from(J.range)}}be.from=Pe;function ae(J){const ke=new p.$VM(D.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:ft.to(J.eol),ke}be.to=ae})(Se||(e.TextEdit=Se={}));var Le;(function(be){function Pe(J,ke){const Ve={edits:[]};if(J instanceof p.$YM){const Ye=new m.$Cc;for(const qe of J._allEntries())qe._type===1&&n.URI.isUri(qe.to)&&qe.from===void 0&&Ye.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$Te)(N.$ze.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Se.from(qe.edit),versionId:Ye.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:D.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ye.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(qt.from)}})}return Ve}be.from=Pe;function ae(J){const ke=new p.$YM,Ve=new m.$Bc;for(const Ye of J.edits)if(Ye.textEdit){const qe=Ye,ut=n.URI.revive(qe.resource),kt=D.to(qe.textEdit.range),Ft=qe.textEdit.text,Yt=qe.textEdit.insertAsSnippet;let at;Yt?at=p.$XM.replace(kt,new p.$ZM(Ft)):at=p.$VM.replace(kt,Ft);const Zt=Ve.get(ut);Zt?Zt.push(at):Ve.set(ut,[at])}else ke.renameFile(n.URI.revive(Ye.oldResource),n.URI.revive(Ye.newResource),Ye.options);for(const[Ye,qe]of Ve)ke.set(Ye,qe);return ke}be.to=ae})(Le||(e.WorkspaceEdit=Le={}));var ne;(function(be){const Pe=Object.create(null);Pe[p.SymbolKind.File]=0,Pe[p.SymbolKind.Module]=1,Pe[p.SymbolKind.Namespace]=2,Pe[p.SymbolKind.Package]=3,Pe[p.SymbolKind.Class]=4,Pe[p.SymbolKind.Method]=5,Pe[p.SymbolKind.Property]=6,Pe[p.SymbolKind.Field]=7,Pe[p.SymbolKind.Constructor]=8,Pe[p.SymbolKind.Enum]=9,Pe[p.SymbolKind.Interface]=10,Pe[p.SymbolKind.Function]=11,Pe[p.SymbolKind.Variable]=12,Pe[p.SymbolKind.Constant]=13,Pe[p.SymbolKind.String]=14,Pe[p.SymbolKind.Number]=15,Pe[p.SymbolKind.Boolean]=16,Pe[p.SymbolKind.Array]=17,Pe[p.SymbolKind.Object]=18,Pe[p.SymbolKind.Key]=19,Pe[p.SymbolKind.Null]=20,Pe[p.SymbolKind.EnumMember]=21,Pe[p.SymbolKind.Struct]=22,Pe[p.SymbolKind.Event]=23,Pe[p.SymbolKind.Operator]=24,Pe[p.SymbolKind.TypeParameter]=25;function ae(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}be.from=ae;function J(ke){for(const Ve in Pe)if(Pe[Ve]===ke)return Number(Ve);return p.SymbolKind.Property}be.to=J})(ne||(e.SymbolKind=ne={}));var j;(function(be){function Pe(J){switch(J){case p.SymbolTag.Deprecated:return 1}}be.from=Pe;function ae(J){switch(J){case 1:return p.SymbolTag.Deprecated}}be.to=ae})(j||(e.SymbolTag=j={}));var x;(function(be){function Pe(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(j.from),containerName:J.containerName,location:fe.from(J.location)}}be.from=Pe;function ae(J){const ke=new p.$7M(J.name,ne.to(J.kind),J.containerName,fe.to(J.location));return ke.tags=J.tags&&J.tags.map(j.to),ke}be.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(be){function Pe(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:D.from(J.range),selectionRange:D.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(j.from)??[]};return J.children&&(ke.children=J.children.map(Pe)),ke}be.from=Pe;function ae(J){const ke=new p.$8M(J.name,J.detail,ne.to(J.kind),D.to(J.range),D.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(j.to)),J.children&&(ke.children=J.children.map(ae)),ke}be.to=ae})(ve||(e.DocumentSymbol=ve={}));var Ne;(function(be){function Pe(J){const ke=new p.$_M(ne.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Pe;function ae(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(j.from)}}be.from=ae})(Ne||(e.CallHierarchyItem=Ne={}));var Ee;(function(be){function Pe(ae){return new p.$aN(Ne.to(ae.from),ae.fromRanges.map(J=>D.to(J)))}be.to=Pe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var $e;(function(be){function Pe(ae){return new p.$bN(Ne.to(ae.to),ae.fromRanges.map(J=>D.to(J)))}be.to=Pe})($e||(e.CallHierarchyOutgoingCall=$e={}));var fe;(function(be){function Pe(J){return{range:J.range&&D.from(J.range),uri:J.uri}}be.from=Pe;function ae(J){return new p.$1M(n.URI.revive(J.uri),D.to(J.range))}be.to=ae})(fe||(e.location=fe={}));var Q;(function(be){function Pe(J){const ke=J,Ve=J;return{originSelectionRange:ke.originSelectionRange?D.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ve.uri,range:D.from(ke.targetRange?ke.targetRange:Ve.range),targetSelectionRange:ke.targetSelectionRange?D.from(ke.targetSelectionRange):void 0}}be.from=Pe;function ae(J){return{targetUri:n.URI.revive(J.uri),targetRange:D.to(J.range),targetSelectionRange:J.targetSelectionRange?D.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?D.to(J.originSelectionRange):void 0}}be.to=ae})(Q||(e.DefinitionLink=Q={}));var X;(function(be){function Pe(J){return{range:D.from(J.range),contents:ie.fromMany(J.contents)}}be.from=Pe;function ae(J){return new p.$4M(J.contents.map(ie.to),D.to(J.range))}be.to=ae})(X||(e.Hover=X={}));var le;(function(be){function Pe(J){return{range:D.from(J.range),expression:J.expression}}be.from=Pe;function ae(J){return new p.$YN(D.to(J.range),J.expression)}be.to=ae})(le||(e.EvaluatableExpression=le={}));var de;(function(be){function Pe(J){if(J instanceof p.$ZN)return{type:"text",range:D.from(J.range),text:J.text};if(J instanceof p.$1N)return{type:"variable",range:D.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$2N)return{type:"expression",range:D.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Pe;function ae(J){switch(J.type){case"text":return{range:D.to(J.range),text:J.text};case"variable":return{range:D.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:D.to(J.range),expression:J.expression}}}be.to=ae})(de||(e.InlineValue=de={}));var Te;(function(be){function Pe(J){return{frameId:J.frameId,stoppedLocation:D.from(J.stoppedLocation)}}be.from=Pe;function ae(J){return new p.$3N(J.frameId,D.to(J.stoppedLocation))}be.to=ae})(Te||(e.InlineValueContext=Te={}));var he;(function(be){function Pe(J){return{range:D.from(J.range),kind:J.kind}}be.from=Pe;function ae(J){return new p.$5M(D.to(J.range),J.kind)}be.to=ae})(he||(e.DocumentHighlight=he={}));var Ce;(function(be){function Pe(J){return{uri:J.uri,highlights:J.highlights.map(he.from)}}be.from=Pe;function ae(J){return new p.$6M(n.URI.revive(J.uri),J.highlights.map(he.to))}be.to=ae})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(be){function Pe(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}be.to=Pe})(Me||(e.CompletionTriggerKind=Me={}));var ze;(function(be){function Pe(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Pe})(ze||(e.CompletionContext=ze={}));var z;(function(be){function Pe(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}be.from=Pe;function ae(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}be.to=ae})(z||(e.CompletionItemTag=z={}));var L;(function(be){const Pe=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Ve){return Pe.get(Ve)??9}be.from=ae;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function ke(Ve){return J.get(Ve)??p.CompletionItemKind.Property}be.to=ke})(L||(e.CompletionItemKind=L={}));var G;(function(be){function Pe(ae,J){const ke=new p.$jN(ae.label);return ke.insertText=ae.insertText,ke.kind=L.to(ae.kind),ke.tags=ae.tags?.map(z.to),ke.detail=ae.detail,ke.documentation=M.$Mk(ae.documentation)?ie.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,o.$ht.isIRange(ae.range)?ke.range=D.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:D.to(ae.range.insert),replacing:D.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ke.insertText=new p.$ZM(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof p.$QM?new p.$VM(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(Ve=>Se.to(Ve))),ke.command=J&&ae.command?J.fromInternal(ae.command):void 0,ke}be.to=Pe})(G||(e.CompletionItem=G={}));var H;(function(be){function Pe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}be.from=Pe;function ae(J){return{label:J.label,documentation:M.$Mk(J.documentation)?ie.to(J.documentation):J.documentation}}be.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(be){function Pe(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}be.from=Pe;function ae(J){return{label:J.label,documentation:M.$Mk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}be.to=ae})(ee||(e.SignatureInformation=ee={}));var se;(function(be){function Pe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}be.from=Pe;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}be.to=ae})(se||(e.SignatureHelp=se={}));var Oe;(function(be){function Pe(ae,J){const ke=new p.$iN(y.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Qe.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Se.to),ke.tooltip=M.$Mk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}be.to=Pe})(Oe||(e.InlayHint=Oe={}));var Be;(function(be){function Pe(ae,J){const ke=new p.$hN(J.label);return ke.tooltip=M.$Mk(J.tooltip)?ie.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=ae.fromInternal(J.command)),J.location&&(ke.location=fe.to(J.location)),ke}be.to=Pe})(Be||(e.InlayHintLabelPart=Be={}));var Qe;(function(be){function Pe(J){return J}be.from=Pe;function ae(J){return J}be.to=ae})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(be){function Pe(J){return{range:D.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=Pe;function ae(J){let ke;if(J.url)try{ke=typeof J.url=="string"?n.URI.parse(J.url,!0):n.URI.revive(J.url)}catch{}return new p.$oN(D.to(J.range),ke)}be.to=ae})(xe||(e.DocumentLink=xe={}));var _e;(function(be){function Pe(J){const ke=new p.$rN(J.label);return J.textEdit&&(ke.textEdit=Se.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Ve=>Se.to(Ve))),ke}be.to=Pe;function ae(J){return{label:J.label,textEdit:J.textEdit?Se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Se.from(ke)):void 0}}be.from=ae})(_e||(e.ColorPresentation=_e={}));var et;(function(be){function Pe(J){return new p.$pN(J[0],J[1],J[2],J[3])}be.to=Pe;function ae(J){return[J.red,J.green,J.blue,J.alpha]}be.from=ae})(et||(e.Color=et={}));var tt;(function(be){function Pe(J){return{range:D.from(J.range)}}be.from=Pe;function ae(J){return new p.$$M(D.to(J.range))}be.to=ae})(tt||(e.SelectionRange=tt={}));var nt;(function(be){function Pe(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}be.to=Pe})(nt||(e.TextDocumentSaveReason=nt={}));var ct;(function(be){function Pe(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Pe;function ae(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}be.to=ae})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(be){function Pe(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}be.from=Pe;function ae(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}be.to=ae})(ft||(e.EndOfLine=ft={}));var Ue;(function(be){function Pe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Pe})(Ue||(e.ProgressLocation=Ue={}));var st;(function(be){function Pe(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=Z.from(J.kind)),ke}be.from=Pe;function ae(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=Z.to(J.kind)),ke}be.to=ae})(st||(e.FoldingRange=st={}));var Z;(function(be){function Pe(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return s.$3t.Comment;case p.FoldingRangeKind.Imports:return s.$3t.Imports;case p.FoldingRangeKind.Region:return s.$3t.Region}}be.from=Pe;function ae(J){if(J)switch(J.value){case s.$3t.Comment.value:return p.FoldingRangeKind.Comment;case s.$3t.Imports.value:return p.FoldingRangeKind.Imports;case s.$3t.Region.value:return p.FoldingRangeKind.Region}}be.to=ae})(Z||(e.FoldingRangeKind=Z={}));var Y;(function(be){function Pe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?D.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$bF.id:void 0}}be.from=Pe})(Y||(e.TextEditorOpenOptions=Y={}));var me;(function(be){function Pe(Ve){return Ve instanceof p.$MN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new p.$MN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}be.from=Pe;function ae(Ve){const Ye=Ve;return Ye?n.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(Ve){const Ye=Ve;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function ke(Ve){return typeof Ve=="string"?Ve:new p.$MN(n.URI.revive(Ve.baseUri),Ve.pattern)}be.to=ke})(me||(e.GlobPattern=me={}));var He;(function(be){function Pe(ae){if(ae){if(Array.isArray(ae))return ae.map(Pe);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}be.from=Pe})(He||(e.LanguageSelector=He={}));var ye;(function(be){function Pe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&n.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ye=>Ye instanceof p.$QM)))}be.is=Pe;function ae(J){return{documents:J.documents.map(ke=>ke.map(Ve=>({uri:n.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ye=>D.from(Ye))})))}}be.from=ae})(ye||(e.MappedEditsContext=ye={}));var ot;(function(be){function Pe(J){return{start:J.start,end:J.end}}be.from=Pe;function ae(J){return new p.$dO(J.start,J.end)}be.to=ae})(ot||(e.NotebookRange=ot={}));var dt;(function(be){function Pe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=Pe;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}be.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(be){function Pe(ae){if(ae===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ae===t.NotebookCellExecutionState.Pending)return;if(ae===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Pe})(Pt||(e.NotebookCellExecutionState=Pt={}));var Bt;(function(be){function Pe(J){switch(J){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=Pe;function ae(J){switch(J){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}be.to=ae})(Bt||(e.NotebookCellKind=Bt={}));var Xt;(function(be){function Pe(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$eO.validate(Ve),ke.cells.push(qt.from(Ve));return ke}be.from=Pe;function ae(J){const ke=new p.$fO(J.cells.map(qt.to));return(0,d.$bg)(J.metadata)||(ke.metadata=J.metadata),ke}be.to=ae})(Xt||(e.NotebookData=Xt={}));var qt;(function(be){function Pe(J){return{cellKind:Bt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}be.from=Pe;function ae(J){return new p.$eO(Bt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}be.to=ae})(qt||(e.NotebookCellData=qt={}));var xt;(function(be){function Pe(J){return{mime:J.mime,valueBytes:N.$ze.wrap(J.data)}}be.from=Pe;function ae(J){return new p.$gO(J.valueBytes.buffer,J.mime)}be.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var Et;(function(be){function Pe(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}be.from=Pe;function ae(J){const ke=J.items.map(xt.to);return new p.$hO(ke,J.outputId,J.metadata)}be.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Vt;(function(be){function Pe(ke){return J(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}be.from=Pe;function ae(ke){return J(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}be.to=ae;function J(ke){const Ve=ke;return Ve?!(0,d.$0f)(Ve.include)&&!(0,d.$0f)(Ve.exclude):!1}})(Vt||(e.NotebookExclusiveDocumentPattern=Vt={}));var Ht;(function(be){function Pe(ae,J,ke){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Pe})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ze;(function(be){function Pe(ae,J,ke){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Pe})(Ze||(e.NotebookKernelSourceAction=Ze={}));var ri;(function(be){function Pe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Pe})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(be){function Pe(J){return{uri:J.uri,provides:J.provides}}be.from=Pe;function ae(J){return new p.$jO(n.URI.revive(J.uri),J.provides)}be.to=ae})(_t||(e.NotebookRendererScript=_t={}));var ht;(function(be){function Pe(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:D.from(J.location.range),uri:J.location.uri}}}be.from=Pe;function ae(J){const ke=new p.$pO(typeof J.message=="string"?J.message:ie.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?fe.to(J.location):void 0,ke}be.to=ae})(ht||(e.TestMessage=ht={}));var $t;(function(be){be.namespace=c.$DL,be.denamespace=c.$EL})($t||(e.TestTag=$t={}));var ei;(function(be){function Pe(J){const ke=(0,i.$6O)(J).controllerId;return{extId:v.$yL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:n.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>$t.namespace(ke,Ve.id)),range:o.$ht.lift(D.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}be.from=Pe;function ae(J){return{parent:void 0,error:void 0,id:v.$yL.fromString(J.extId).localId,label:J.label,uri:n.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Ve}=$t.denamespace(ke);return new p.$qO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}be.toPlain=ae})(ei||(e.TestItem=ei={})),function(be){function Pe(J){return{id:J.id}}be.from=Pe;function ae(J){return new p.$qO(J.id)}be.to=ae}($t||(e.TestTag=$t={}));var ti;(function(be){const Pe=(J,ke)=>{const Ve=J.value;if(!Ve)return;const Ye={...ei.toPlain(Ve.item),parent:ke,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Pe(qe,Ye);ut&&Ye.children.push(ut)}return Ye};function ae(J){const ke=new u.$YO;for(const qe of J.items)ke.insert(v.$yL.fromString(qe.item.extId).path,qe);const Ve=[ke.nodes],Ye=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Ye.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Ye.map(qe=>Pe(qe)).filter(d.$9f)}}be.to=ae})(ti||(e.TestResults=ti={}));var Lt;(function(be){function Pe(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?y.from(Ve):D.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ae(Ye.location),label:Ye.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}be.fromDetails=J;function ke(Ve,Ye){return p.$sO(Ye.statementCoverage),p.$sO(Ye.branchCoverage),p.$sO(Ye.declarationCoverage),{id:Ve,uri:Ye.uri,statement:Pe(Ye.statementCoverage),branch:Ye.branchCoverage&&Pe(Ye.branchCoverage),declaration:Ye.declarationCoverage&&Pe(Ye.declarationCoverage)}}be.fromFile=ke})(Lt||(e.TestCoverage=Lt={}));var gt;(function(be){function Pe(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}be.to=Pe})(gt||(e.CodeActionTriggerKind=gt={}));var zt;(function(be){function Pe(J){const ke=new p.$xO(ne.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Pe;function ae(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(j.from)}}be.from=ae})(zt||(e.TypeHierarchyItem=zt={}));var ii;(function(be){function Pe(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Pe})(ii||(e.ViewBadge=ii={}));var Tt;(function(be){function Pe(Ve,Ye,qe){const ut=Ye.fileData;return ut?new p.$EN(new p.$FN(ut.name,n.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):Ve===T.$Es.uriList&&Ye.uriListData?new p.$DN(ke(Ye.uriListData)):new p.$DN(Ye.asString)}be.to=Pe;async function ae(Ve,Ye){const qe=await Ye.asString();if(Ve===T.$Es.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ye.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}be.from=ae;function J(Ve){return R.$Ht.split(Ve).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return n.URI.parse(Ye)}catch{}return Ye})}function ke(Ve){return R.$Ht.create(Ve.map(Ye=>typeof Ye=="string"?Ye:n.URI.revive(Ye)))}})(Tt||(e.DataTransferItem=Tt={}));var Ke;(function(be){function Pe(J,ke){const Ve=J.items.map(([Ye,qe])=>[Ye,Tt.to(Ye,qe,ke)]);return new p.$GN(Ve)}be.toDataTransfer=Pe;async function ae(J){const ke={items:[]},Ve=[];for(const[Ye,qe]of J)Ve.push((async()=>{ke.items.push([Ye,await Tt.from(Ye,qe)])})());return await Promise.all(Ve),ke}be.from=ae})(Ke||(e.DataTransfer=Ke={}));var si;(function(be){function Pe(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}be.from=Pe;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}be.to=ae})(si||(e.ChatFollowup=si={}));var Gt;(function(be){function Pe(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Pe})(Gt||(e.ChatInlineFollowup=Gt={}));var jt;(function(be){function Pe(J){switch(J.role){case 0:return new p.$TO(J.content);case 1:return new p.$UO(J.content);case 2:return new p.$VO(J.content)}}be.to=Pe;function ae(J){if(J instanceof p.$TO)return{role:0,content:J.content};if(J instanceof p.$UO)return{role:1,content:J.content};if(J instanceof p.$VO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(jt||(e.LanguageModelMessage=jt={}));var mt;(function(be){function Pe(ke){const Ve={};for(const Ye of Object.keys(ke))Ve[Ye]=ke[Ye].map(be.to);return Ve}be.objectTo=Pe;function ae(ke){return{level:Ot.to(ke.level),kind:ke.kind,value:(0,n.$wc)(ke.value)?n.URI.revive(ke.value):ke.value,description:ke.description}}be.to=ae;function J(ke){return{level:Ot.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=J})(mt||(e.ChatVariable=mt={}));var Ot;(function(be){function Pe(J){switch(J){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}be.to=Pe;function ae(J){switch(J){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}be.from=ae})(Ot||(e.ChatVariableLevel=Ot={}));var Mt;(function(be){function Pe(ae){switch(ae){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Pe})(Mt||(e.InteractiveEditorResponseFeedbackKind=Mt={}));var Ut;(function(be){function Pe(J){return{kind:"markdownContent",content:ie.from(J.value)}}be.from=Pe;function ae(J){return new p.$KO(ie.to(J.content))}be.to=ae})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var Kt;(function(be){function Pe(J){const{value:ke,baseUri:Ve}=J;function Ye(qe,ut){return qe.map(kt=>{const Ft=n.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ft,children:kt.children&&Ye(kt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,b.$Xg)(Ve),uri:Ve,children:Ye(ke,Ve)}}}be.from=Pe;function ae(J){const ke=(0,E.$Wh)(J.treeData);function Ve(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&Ve(kt.children)}))}const Ye=ke.uri,qe=ke.children?Ve(ke.children):[];return new p.$LO(qe,Ye)}be.to=ae})(Kt||(e.ChatResponseFilesPart=Kt={}));var Jt;(function(be){function Pe(J){return{kind:"inlineReference",name:J.title,inlineReference:n.URI.isUri(J.value)?J.value:f.from(J.value)}}be.from=Pe;function ae(J){const ke=(0,E.$Wh)(J);return new p.$MO(n.URI.isUri(ke.inlineReference)?ke.inlineReference:f.to(ke.inlineReference),J.name)}be.to=ae})(Jt||(e.ChatResponseAnchorPart=Jt={}));var oi;(function(be){function Pe(J){return{kind:"progressMessage",content:ie.from(J.value)}}be.from=Pe;function ae(J){return new p.$NO(J.content.value)}be.to=ae})(oi||(e.ChatResponseProgressPart=oi={}));var Ct;(function(be){function Pe(J,ke,Ve){return{kind:"command",command:ke.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}be.from=Pe;function ae(J,ke){return new p.$OO(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}be.to=ae})(Ct||(e.ChatResponseCommandButtonPart=Ct={}));var Nt;(function(be){function Pe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Se.from(ke))}}be.from=Pe;function ae(J){return new p.$QO(n.URI.revive(J.uri),J.edits.map(ke=>Se.to(ke)))}be.to=ae})(Nt||(e.ChatResponseTextEditPart=Nt={}));var It;(function(be){function Pe(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:n.URI.isUri(J.value.value)||!J.value.value?J.value.value:f.from(J.value.value)}}:{kind:"reference",reference:n.URI.isUri(J.value)?J.value:f.from(J.value)}}be.from=Pe;function ae(J){const ke=(0,E.$Wh)(J),Ve=Ye=>n.URI.isUri(Ye)?Ye:f.to(Ye);return new p.$PO("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Ve(ke.reference.value)}:Ve(ke.reference))}be.to=ae})(It||(e.ChatResponseReferencePart=It={}));var Dt;(function(be){function Pe(ke,Ve,Ye){return ke instanceof p.$KO?Ut.from(ke):ke instanceof p.$MO?Jt.from(ke):ke instanceof p.$PO?It.from(ke):ke instanceof p.$NO?oi.from(ke):ke instanceof p.$LO?Kt.from(ke):ke instanceof p.$OO?Ct.from(ke,Ve,Ye):ke instanceof p.$QO?Nt.from(ke):{kind:"content",content:""}}be.from=Pe;function ae(ke,Ve){switch(ke.kind){case"reference":return It.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Ve)}}be.to=ae;function J(ke,Ve){switch(ke.kind){case"markdownContent":return Ut.to(ke);case"inlineReference":return Jt.to(ke);case"progressMessage":return;case"treeData":return Kt.to(ke);case"command":return Ct.to(ke,Ve)}}be.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var vt;(function(be){function Pe(J,ke){return"markdownContent"in ke?((0,w.$vG)(J,"chatParticipantAdditions"),{content:ie.from(ke.markdownContent),kind:"markdownContent"}):"content"in ke?"vulnerabilities"in ke&&ke.vulnerabilities?((0,w.$vG)(J,"chatParticipantAdditions"),{content:ke.content,vulnerabilities:ke.vulnerabilities,kind:"vulnerability"}):typeof ke.content=="string"?{content:ke.content,kind:"content"}:((0,w.$vG)(J,"chatParticipantAdditions"),{content:ie.from(ke.content),kind:"markdownContent"}):"documents"in ke?{documents:ke.documents.map(Ve=>({uri:Ve.uri,version:Ve.version,ranges:Ve.ranges.map(Ye=>D.from(Ye))})),kind:"usedContext"}:"reference"in ke?{reference:"uri"in ke.reference?{uri:ke.reference.uri,range:D.from(ke.reference.range)}:ke.reference,kind:"reference"}:"inlineReference"in ke?{inlineReference:"uri"in ke.inlineReference?{uri:ke.inlineReference.uri,range:D.from(ke.inlineReference.range)}:ke.inlineReference,name:ke.title,kind:"inlineReference"}:"participant"in ke?((0,w.$vG)(J,"chatParticipantAdditions"),{agentId:ke.participant,command:ke.command,kind:"agentDetection"}):"message"in ke?{content:ie.from(ke.message),kind:"progressMessage"}:void 0}be.from=Pe;function ae(J,ke){switch(J.kind){case"markdownContent":return{content:J.content.value};case"inlineReference":return{inlineReference:(0,n.$wc)(J.inlineReference)?n.URI.revive(J.inlineReference):f.to(J.inlineReference),title:J.name};case"command":return{command:ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title}};default:return}}be.toProgressContent=ae})(vt||(e.ChatResponseProgress=vt={}));var St;(function(be){function Pe(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map(yt.to),location:li.to(ae.location)}}be.to=Pe})(St||(e.ChatAgentRequest=St={}));var li;(function(be){function Pe(ae){switch(ae){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}be.to=Pe})(li||(e.ChatLocation=li={}));var yt;(function(be){function Pe(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(mt.to)}}be.to=Pe})(yt||(e.ChatAgentResolvedVariable=yt={}));var hi;(function(be){function Pe(ae){return{label:ae.label,values:ae.values.map(mt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Pe})(hi||(e.ChatAgentCompletionItem=hi={}));var Qt;(function(be){function Pe(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Pe})(Qt||(e.ChatAgentResult=Qt={}));var ai;(function(be){function Pe(ae,J,ke){if(J.action.kind==="vote")return;const Ve=Qt.to(ae);return J.action.kind==="command"?{action:{kind:"command",commandButton:vt.toProgressContent(J.action.commandButton,ke)},result:Ve}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:si.to(J.action.followup)},result:Ve}:{action:J.action,result:Ve}}be.to=Pe})(ai||(e.ChatAgentUserActionEvent=ai={}));var pi;(function(be){function Pe(ae,J,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,ke)}be.from=Pe})(pi||(e.TerminalQuickFix=pi={}));var ni;(function(be){function Pe(ae){return{kind:Rt.to(ae.kind)}}be.to=Pe})(ni||(e.PartialAcceptInfo=ni={}));var Rt;(function(be){function Pe(ae){switch(ae){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}be.to=Pe})(Rt||(e.PartialAcceptTriggerKind=Rt={}));var yi;(function(be){function Pe(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Pe})(yi||(e.DebugTreeItem=yi={}))}),define(Re[252],Ae([1,0,4,16,8,34]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;let M=class{constructor(g,E){this.a=g.getProxy(I.$MM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,E,T){const k=new O.$jw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(k,void 0,T?.isRefactoring??!1)}};e.$akc=M,e.$akc=M=Je([We(0,N.$0O)],M)}),define(Re[253],Ae([1,0,18,11,42,5,46,6,65,17,2,163,20,4,8,7,215,25]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class r{constructor(t,v,c,$,w,p){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.n=p,this.b=g.$8d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function($){if(t.c){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,$),w}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){v(this.markdown);const w=new n.$KO($),p=d.ChatResponseMarkdownPart.from(w);return c(p),this},filetree($,w){v(this.filetree);const p=new n.$LO($,w),l=d.ChatResponseFilesPart.from(p);return c(l),this},anchor($,w){v(this.anchor);const p=new n.$MO($,w),l=d.ChatResponseAnchorPart.from(p);return c(l),this},button($){v(this.anchor);const w=new n.$OO($),p=d.ChatResponseCommandButtonPart.from(w,t.m,t.n);return c(p),this},progress($){v(this.progress);const w=new n.$NO($),p=d.ChatResponseProgressPart.from(w);return c(p),this},reference($){if(v(this.reference),"variableName"in $&&!$.value){const w=t.j.variables.variables.find(p=>p.name===$.variableName);if(w){let p;if(w.references?.length)p=w.references.map(l=>({kind:"reference",reference:{variableName:$.variableName,value:l.reference}}));else{const l=new n.$PO($);p=[d.ChatResponseReferencePart.from(l)]}return p.forEach(l=>c(l)),this}}else{const w=new n.$PO($),p=d.ChatResponseReferencePart.from(w);c(p)}return this},textEdit($,w){v(this.textEdit),(0,s.$vG)(t.i,"chatParticipantAdditions");const p=new n.$QO($,w),l=d.ChatResponseTextEditPart.from(p);return c(l),this},push($){if(v(this.push),$ instanceof n.$QO&&(0,s.$vG)(t.i,"chatParticipantAdditions"),$ instanceof n.$PO)this.reference($.value);else{const w=d.ChatResponsePart.from($,t.m,t.n);c(w)}return this},report($){if(v(this.report),"placeholder"in $&&"resolvedContent"in $)return;const w=d.ChatResponseProgress.from(t.i,$);if(!w){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(w),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,c){this.i=v,this.j=c,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(b.$MM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,v,c){const $=i.b++,w=new a(t,v,this.d,$,c);return this.c.set($,w),this.d.$registerAgent($,t.identifier,v,{},void 0),w.apiAgent}createDynamicChatAgent(t,v,c,$,w){const p=i.b++,l=new a(t,v,this.d,p,w);return this.c.set(p,l),this.d.$registerAgent(p,t.identifier,v,{isSticky:!0},{name:c,description:$}),l.apiAgent}async $invokeAgent(t,v,c,$){const w=this.c.get(t);if(!w)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(v.sessionId);p||(p=new m.$Tc,this.g.set(v.sessionId,p));const l=new r(w.extension,v,this.d,this.i,this.j.converter,p);try{const D=await this.k(v.agentId,c),f=w.invoke(d.ChatAgentRequest.to(v),{history:D},l.apiObject,$);return await(0,N.$bh)(Promise.resolve(f).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${w.extension.identifier.value}] [@${w.id}] ${C}`,w.extension),{errorDetails:{message:C},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,w.extension),{errorDetails:{message:(0,k.localize)(0,null,(0,R.$$i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,v){const c=[];for(const $ of v.history){const w=d.ChatAgentResult.to($.result),p=t===$.request.agentId?w:{...w,metadata:void 0};c.push(new n.$RO($.request.message,$.request.command,$.request.variables.variables.map(d.ChatAgentResolvedVariable.to),$.request.agentId));const l=(0,I.$Hb)($.response.map(D=>d.ChatResponsePart.toContent(D,this.j.converter)));c.push(new n.$SO(l,p,$.request.agentId,$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,c,$,w){const p=this.c.get(v);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=d.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},w)).filter(f=>{const S=!f.participant||M.Iterable.some(this.c.values(),y=>y.id===f.participant&&u.$Im.equals(y.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),S}).map(f=>d.ChatFollowup.from(f,t))}$acceptFeedback(t,v,c,$){const w=this.c.get(t);if(!w)return;const p=d.ChatAgentResult.to(v);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=n.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=n.ChatResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,v,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const w=d.ChatAgentUserActionEvent.to(v,c,this.j.converter);w&&$.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(t,v,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(v,c)).map(d.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v)).map($=>d.ChatFollowup.from($,void 0))}}e.$bkc=i;class a{constructor(t,v,c,$,w){this.extension=t,this.id=v,this.u=c,this.w=$,this.x=w,this.n=new O.$_d,this.o=new O.$_d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,v){return this.q?await this.q.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,v,c);return $?$.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const v=await this.s.provideWelcomeMessage(t);return v?v.map(c=>typeof c=="string"?c:d.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const v=await this.s.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const c=()=>{t||v||(v=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof n.$KN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:d.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),v=!1}))},$=this;return{get id(){return $.id},get fullName(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.c??$.extension.displayName??$.extension.name},set fullName(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.c=w,c()},get iconPath(){return $.d},set iconPath(w){$.d=w,c()},get requestHandler(){return $.x},set requestHandler(w){(0,E.$$f)(typeof w=="function","Invalid request handler"),$.x=w},get followupProvider(){return $.b},set followupProvider(w){$.b=w,c()},get isDefault(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.g},set isDefault(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.g=w,c()},get helpTextPrefix(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.i},set helpTextPrefix(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.i=w,c()},get helpTextVariablesPrefix(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.j},set helpTextVariablesPrefix(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.j=w,c()},get helpTextPostfix(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.k},set helpTextPostfix(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.k=w,c()},get isSecondary(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.m},set isSecondary(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.m=w,c()},get sampleRequest(){return $.l},set sampleRequest(w){$.l=w,c()},get supportIssueReporting(){return(0,s.$vG)($.extension,"chatParticipantAdditions"),$.p},set supportIssueReporting(w){(0,s.$vG)($.extension,"chatParticipantAdditions"),$.p=w,c()},get onDidReceiveFeedback(){return $.n.event},set participantVariableProvider(w){if((0,s.$vG)($.extension,"chatParticipantAdditions"),$.q=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");$.u.$registerAgentCompletionsProvider($.w,w.triggerCharacters)}else $.u.$unregisterAgentCompletionsProvider($.w)},get participantVariableProvider(){return(0,s.$vG)($.extension,"chatParticipantAdditions"),$.q},set welcomeMessageProvider(w){(0,s.$vG)($.extension,"defaultChatParticipant"),$.s=w,c()},get welcomeMessageProvider(){return(0,s.$vG)($.extension,"defaultChatParticipant"),$.s},onDidPerformAction:(0,s.$uG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(w){$.t=w,c()},get requester(){return $.t},dispose(){t=!0,$.b=void 0,$.n.dispose(),$.u.$unregisterAgent($.w)}}}invoke(t,v,c,$){return this.x(t,v,c,$)}}}),define(Re[254],Ae([1,0,14,6,4,8,7,25]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class g{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(R.$MM.MainThreadChatVariables)}async $resolveVariable(k,u,b,d){const n=this.b.get(k);if(n)try{if(n.resolver.resolve2){(0,m.$vG)(n.extension,"chatParticipantAdditions");const o=new E(u,this.c),s=await n.resolver.resolve2(n.data.name,{prompt:b},o.apiObject,d);if(s)return s.map(O.ChatVariable.from)}else{const o=await n.resolver.resolve(n.data.name,{prompt:b},d);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(k,u,b,d){const n=g.a++;return this.b.set(n,{extension:k,data:{name:u,description:b},resolver:d}),this.c.$registerVariable(n,{name:u,description:b}),(0,N.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$ckc=g;class E{constructor(k,u){this.c=k,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(d){if(k.a){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,d),n}};const k=this,b=d=>{this.d.$handleProgressChunk(this.c,d)};this.b={progress(d){u(this.progress);const n=new M.$NO(d),o=O.ChatResponseProgressPart.from(n);return b(o),this},reference(d){u(this.reference);const n=new M.$PO(d),o=O.ChatResponseReferencePart.from(n);return b(o),this},push(d){return u(this.push),d instanceof M.$PO?b(O.ChatResponseReferencePart.from(d)):d instanceof M.$NO&&b(O.ChatResponseProgressPart.from(d)),this}}}return this.b}}}),define(Re[255],Ae([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=b;function b(d,n,o){const s=d.getProxy(k.$MM.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Km,n.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,f=this.b.get(D.commentControlHandle);if(!f)return D;const S=f.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);return f?l.$mid===8?f.value:{thread:f.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.commentUniqueId,y=f.getCommentByUniqueId(S);return y||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.text,y=l.commentUniqueId,C=f.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new T.$dN(S),C):l}return l}})}createCommentController(l,D,f){const S=r.a++,y=new a(l,S,D,f);this.b.set(y.handle,y);const C=this.c.get(l.identifier)||[];return C.push(y),this.c.set(l.identifier,C),y.value}async $createCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,f)}async $setActiveComment(l,D){const f=this.b.get(l);f&&f.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,f)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,f){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(M.URI.revive(D));return(0,I.$fh)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,f);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),P})}$toggleReaction(l,D,f,S,y){const C=this.b.get(l);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$fh)(()=>{const P=C.getCommentThread(D);if(P){const W=P.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,v(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$vG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,f,S,y,C,P,W){this.m=D,this.n=f,this.o=S,this.p=y,this.q=C,this.extensionDescription=P,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$_d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const l=f=>Object.prototype.hasOwnProperty.call(this.b,f),D={};l("range")&&(D.range=E.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=w(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const f=D[0],S=D[1];if(l===S)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,N.$Sh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$vG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$vG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$vG)(this.h,"activeComment"),this.f}constructor(l,D,f,S){this.h=l,this.i=D,this.j=f,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,f,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,P,W){return y.createCommentThread(C,P,W).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,f){D===void 0&&(0,u.$vG)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,f,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const f=new i(this.id,this.handle,void 0,M.URI.revive(l),E.Range.to(D),[],this.h,!0);return f.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(l,D){const f=this.a.get(l);f&&(f.range=E.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,f){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$vG)(f,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$vG)(f,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$9O(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?M.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case T.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function w(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case T.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new r}}),define(Re[256],Ae([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class b{constructor(v,c){this.document=v,this.b=c,this.a=1,this.c=new T.$Yjc("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,c){await this.f(v).undo(),c||this.disposeBackup()}async redo(v,c){await this.f(v).redo(),c||this.disposeBackup()}disposeEdits(v){for(const c of v)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,M.$1g)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const c=this.c.get(v,0);if(!c)throw new Error("No edit found");return c}}class d{constructor(){this.a=new Map}get(v,c){return this.a.get(this.b(v,c))}add(v,c,$){const w=this.b(v,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${v} resource:${c.uri}`);const p=new b(c,$);return this.a.set(w,p),p}delete(v,c){const $=this.b(v,c.uri);this.a.delete($)}b(v,c){return`${v}@@@${c}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(v,c,$){return this.b(0,v,c,$)}addCustomProvider(v,c,$){return this.b(1,v,c,$)}get(v){return this.a.get(v)}b(v,c,$,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:v,extension:$,provider:w}),new u.$OM(()=>this.a.delete(c))}}class s{constructor(v,c,$,w,p){this.d=c,this.f=$,this.g=w,this.h=p,this.b=new o,this.c=new d,this.a=v.getProxy(k.$MM.MainThreadCustomEditors)}registerCustomEditorProvider(v,c,$,w){const p=new R.$Tc;return i($)?(p.add(this.b.addTextProvider(c,v,$)),this.a.$registerTextEditorProvider((0,E.$vkc)(v),c,w.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,E.$tkc)(v))):(p.add(this.b.addCustomProvider(c,v,$)),r($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const f=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,f,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,E.$vkc)(v),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,E.$tkc)(v))),u.$OM.from(p,new u.$OM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(v,c,$,w,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=m.URI.revive(v),f=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:w?.buffer},p);let S;return r(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,f,S),{editable:r(l.provider)}}async $disposeCustomDocument(v,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=m.URI.revive(v),{document:p}=this.i(c,w);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(v,c,$,w,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const f=g.ViewColumn.to(p),S=this.g.createNewWebview(c,w.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,$,w.title,f,w.options,S,w.active),C=m.URI.revive(v);switch(D.type){case 1:{const{document:P}=this.i($,C);return D.provider.resolveCustomEditor(P,y,l)}case 0:{const P=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(P,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,c,$){this.i(c,v).disposeEdits($)}async $onMoveCustomEditor(v,c,$){const w=this.b.get($);if(!w)throw new Error(`No provider found for '${$}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(v);if(!p)throw new Error("No webview found");const l=m.URI.revive(c),D=this.d.getDocument(l);await w.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(v,c,$,w){return this.i(c,v).undo($,w)}async $redo(v,c,$,w){return this.i(c,v).redo($,w)}async $revert(v,c,$){const w=this.i(c,v);await this.j(c).revertCustomDocument(w.document,$),w.disposeBackup()}async $onSave(v,c,$){const w=this.i(c,v);await this.j(c).saveCustomDocument(w.document,$),w.disposeBackup()}async $onSaveAs(v,c,$,w){const p=this.i(c,v);return this.j(c).saveCustomDocumentAs(p.document,m.URI.revive($),w)}async $backup(v,c,$){const w=this.i(c,v),l=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},$);return w.updateBackup(l),l.id}i(v,c){const $=this.c.get(v,m.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(v){const $=this.b.get(v)?.provider;if(!$||!r($))throw new Error("Custom document is not editable");return $}}e.$ykc=s;function r(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,N.$bj)(v)+""}}),define(Re[257],Ae([1,0,164,100,2,4,7,8,5,13,28,44]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class b{#e;#t;#i;constructor(o,s,r,i,a,h,t,v){this.d=o,this.e=s,this.f=r,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,r),this.#i=new T.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let r=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),r=[o]}else if(Array.isArray(o)){r=[];let h;o=[...o].sort(b.k);for(const t of o){const[v,c]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,r.push(v),this.#i.set(v,[])),c)this.#i.get(v)?.push(...c);else{const $=this.#i.get(v);$&&($.length=0)}}}if(this.#t.fire(r),!this.#e)return;const i=[];let a=0;for(const h of r){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const w of v)if(w.severity===c[$]&&t.push({...m.Diagnostic.from(w),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[r,i]of this)o.call(s,r,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$6jc=b;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new T.$Bc;for(const r of o)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,r,i){this.j=s,this.k=r,this.l=i,this.g=new Map,this.h=new g.$de({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(O.$MM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:r,f:i,h:a,j:h,k:t,l:v}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!r.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(r.has($))}return new class extends b{constructor(){super(s,$,u.e,u.d,p=>v.getDocument(p)?.version,t.extUri,c,a),r.set($,this)}dispose(){super.dispose(),r.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,r=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=r.length,s.set(a.toString(),t),r.push([a,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(o){let s=[];for(const r of this.g.values())r.has(o)&&(s=s.concat(r.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",r=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,r),this.n=r}for(const[s,r]of o)this.n.set(R.URI.revive(s),r.map(m.Diagnostic.to))}};e.$7jc=d,e.$7jc=d=u=Je([We(1,E.$Tj),We(2,k.$5jc)],d)}),define(Re[258],Ae([1,0,2,14,7,8,193,34]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class g{constructor(T,k,u,b={timeout:1500,errors:3}){this.c=T,this.d=k,this.f=u,this.g=b,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(k,u,b)=>{const n={dispose:this.a.push([k,u,T])};return Array.isArray(b)&&b.push(n),n}}async $participateInSave(T,k){const u=I.URI.revive(T);let b=!1;const d=setTimeout(()=>b=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(b)break;const s=this.d.getDocument(u),r=await this.h(o,{document:s,reason:O.TextDocumentSaveReason.to(k)});n.push(r)}}finally{clearTimeout(d)}return n}h([T,k,u],b){const d=this.b.get(T);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,T,k,b).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,k,u,b){const d=[],n=Date.now(),{document:o,reason:s}=b,{version:r}=o,i=Object.freeze({document:o,reason:s,waitUntil(a){if(Object.isFrozen(d))throw(0,N.$8)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{k.apply(u,[i])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,h)=>{const t=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(d).then(v=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(t),a(v)}).catch(v=>{clearTimeout(t),h(v)})}).then(a=>{const h={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(v=>v instanceof R.$VM))for(const{newText:v,newEol:c,range:$}of t)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&O.Range.from($),text:v,eol:c&&O.EndOfLine.from(c)}});if(h.edits.length!==0)return r===o.version?this.f.$tryApplyWorkspaceEdit(new m.$jw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$clc=g}),define(Re[259],Ae([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class k{constructor(b,d){this.a=new I.$_d,this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=b.getProxy(O.$MM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const d=this.g.getDocument(b);if(d)return d}getDocument(b){const d=this.getDocumentData(b);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return d.document}ensureDocumentData(b){const d=this.g.getDocument(b);if(d)return Promise.resolve(d);let n=this.h.get(b.toString());return n||(n=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const s=R.URI.revive(o);return(0,g.$_f)(this.g.getDocument(s))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),n)),n}createDocumentData(b){return this.f.$tryCreateDocument(b).then(d=>R.URI.revive(d))}$acceptModelLanguageChanged(b,d){const n=R.URI.revive(b),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(b){const d=R.URI.revive(b),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(b,d){const n=R.URI.revive(b),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,d,n){const o=R.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents(d);let r;d.isUndoing?r=T.TextDocumentChangeReason.Undo:d.isRedoing&&(r=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Un)({document:s.document,contentChanges:d.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:r}))}setWordDefinitionFor(b,d){(0,M.$_O)(b,d)}}e.$8jc=k}),define(Re[66],Ae([1,0,260,5,17,2,3,4,16,8,7]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=e.$zkc=void 0,e.$zkc=(0,M.$ni)("IExtHostEditorTabs");class k{constructor(o,s,r){this.e=r,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$yO(O.URI.revive(this.b.input.uri));case 2:return new T.$zO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new T.$AO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new T.$BO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$CO(this.b.input.viewType);case 4:return new T.$DO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$EO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$FO;case 9:return new T.$GO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$HO;case 11:return new T.$IO(this.b.input.diffEditors.map(o=>new T.$zO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new k(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const s=this.c.find(r=>r.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new N.$_d,this.c=new N.$_d,this.e=[],this.a=o.getProxy(m.$MM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,R.$_f)(o.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,i)=>{const a=Array.isArray(r)?r:[r];return a.length?d(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),r=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,r),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const v=(0,R.$_f)(o.find(c=>c.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(r=>r.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const r=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const s of this.e)for(const r of s.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const r=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,s)}async j(o,s){const r=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,s)}};e.$Akc=b,e.$Akc=b=Je([We(0,g.$0O)],b);function d(n){return n.tabs!==void 0}}),define(Re[261],Ae([1,0,2,4,6,7,8,304,15,22,25,54]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class u{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let s,r,i=14,a=14;for(const h of n){let t=s?(0,g.$sf)(s,h):0;for(t===0?r=1:r=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([r,h.toUpperCase().charCodeAt(t),a]),o.push([r,h.toLowerCase().charCodeAt(t),a]),r=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$W2(o)}}provideDocumentLinks(n){this.c();const o=[],s=m.$X2.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of s){const i=M.DocumentLink.to(r);i.target&&o.push(i)}return o}}class b{constructor(n,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(N.$MM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,s,r={}){if(b.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,T.$vG)(n,"fsChunks"),a+=4);let h;r.isReadonly&&(0,k.$Mk)(r.isReadonly)&&r.isReadonly.value!==""&&(h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const c=[];for(const $ of v){const{uri:w,type:p}=$;if(w.scheme!==o)continue;let l;switch(p){case O.FileChangeType.Changed:l=0;break;case O.FileChangeType.Created:l=1;break;case O.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:l})}this.a.$onFileSystemChange(i,c)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:s,mtime:r,size:i,permissions:a}=n;return{type:o,ctime:s,mtime:r,size:i,permissions:a}}$stat(n,o){return Promise.resolve(this.l(n).stat(I.URI.revive(o))).then(s=>b.k(s))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(I.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(I.URI.revive(o))).then(s=>E.$ze.wrap(s))}$writeFile(n,o,s,r){return Promise.resolve(this.l(n).writeFile(I.URI.revive(o),s.buffer,r))}$delete(n,o,s){return Promise.resolve(this.l(n).delete(I.URI.revive(o),s))}$rename(n,o,s,r){return Promise.resolve(this.l(n).rename(I.URI.revive(o),I.URI.revive(s),r))}$copy(n,o,s,r){const i=this.l(n);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(I.URI.revive(o)))}$watch(n,o,s,r){const i=this.l(n).watch(I.URI.revive(s),r);this.f.set(o,i)}$unwatch(n,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(n,o,s){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(I.URI.revive(o),s))}$close(n,o){const s=this.l(n);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(n,o,s,r){const i=this.l(n);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$ze.alloc(r);return Promise.resolve(i.read(o,s,a.buffer,0,r)).then(h=>a.slice(0,h))}$write(n,o,s,r){const i=this.l(n);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$elc=b}),define(Re[262],Ae([1,0,5,36,2,4,8,7,40]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,d,n,o,s,r){this.a=Math.random(),this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$hk)(s),a=typeof s=="string",h=r?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!r?.ignoreCreateEvents)for(const c of v.created){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.b.fire($)}if(!r?.ignoreChangeEvents)for(const c of v.changed){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.c.fire($)}if(!r?.ignoreDeleteEvents)for(const c of v.deleted){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=m.$OM.from(this.i(b,n,s,r,r?.correlate),this.b,this.c,this.d,t)}i(b,d,n,o,s){const r=m.$OM.from();if(typeof n=="string")return r;const i=b.getProxy(O.$MM.MainThreadFileSystemEventService);let a=!1;return(n.pattern.includes(N.$dk)||n.pattern.includes(N.$ek))&&(a=!0),i.$watch(d.identifier.value,this.a,n.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.$OM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(b){this.a=b,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,d,n){this.j=b,this.k=d,this.l=n,this.a=new I.$_d,this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.g=new I.$be,this.h=new I.$be,this.i=new I.$be,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,d,n,o){return new E(this.j,b,d,this.a.event,M.GlobPattern.from(n),o)}$onFileEvent(b){this.a.fire(new T(b))}$onDidRunFileOperation(b,d){switch(b){case 2:this.b.fire(Object.freeze({files:d.map(n=>({oldUri:R.URI.revive(n.source),newUri:R.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:d.map(n=>R.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:d.map(n=>R.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,d){return(n,o,s)=>{const r=function(a){n.call(o,a)};return r.extension=b,d.event(r,void 0,s)}}async $onWillRunFileOperation(b,d,n,o){switch(b){case 2:return await this.n(this.g,{files:d.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},n,o);case 1:return await this.n(this.i,{files:d.map(s=>R.URI.revive(s.target))},n,o);case 0:case 3:return await this.n(this.h,{files:d.map(s=>R.URI.revive(s.target))},n,o)}}async n(b,d,n,o){const s=new Set,r=[];if(await b.fireAsync(d,o,async(a,h)=>{const t=Date.now(),v=await Promise.resolve(a);v instanceof m.$YM&&(r.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,a]of r){const{edits:h}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$flc=k}),define(Re[263],Ae([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class c{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof a.$8M?H.map(i.DocumentSymbol.from):c.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const L=[],G=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),L.push(ee);break}const se=G[G.length-1];if(b.$ht.containsRange(se.range,ee.range)&&!b.$ht.equalsRange(se.range,ee.range)){se.children?.push(ee),G.push(ee);break}G.pop()}}return L}}class ${constructor(z,L,G,H,ee,se){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.l=se,this.d=new t.$Yjc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Tc;this.e.set(ee,se);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,se)});return Oe}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function w(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class p{constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDefinition(H,ee,G);return w(se)}}class l{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDeclaration(H,ee,G);return w(se)}}class D{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideImplementation(H,ee,G);return w(se)}}class f{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideTypeDefinition(H,ee,G);return w(se)}}class S{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideHover(H,ee,G);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new a.$QM(ee,ee)),i.Hover.from(se)}}class y{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideEvaluatableExpression(H,ee,G);if(se)return i.EvaluatableExpression.from(se)}}class C{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const ee=this.d.getDocument(z),se=await this.e.provideInlineValues(ee,i.Range.to(L),i.InlineValueContext.to(G),H);if(Array.isArray(se))return se.map(Oe=>i.InlineValue.from(Oe))}}class P{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const ee=this.d.getDocument(z),se=G.map(Qe=>this.d.getDocument(Qe)),Oe=i.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,se,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideLinkedEditingRanges(H,ee,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const ee=this.d.getDocument(z),se=i.Position.to(L),Oe=await this.e.provideReferences(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class A{static{this.d=1e3}constructor(z,L,G,H,ee,se,Oe){this.g=z,this.h=L,this.j=G,this.k=H,this.l=ee,this.m=se,this.n=Oe,this.e=new t.$Yjc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const ee=this.g.getDocument(z),se=d.$jt.isISelection(L)?i.Selection.to(L):i.Range.to(L),Oe=[];for(const tt of this.j.getDiagnostics(z))if(se.intersection(tt.range)&&Oe.push(tt)>A.d)break;const Be={diagnostics:Oe,only:G.only?new a.$0M(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,se,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),_e=new m.$Tc;this.f.set(xe,_e);const et=[];for(let tt=0;tt<Qe.length;tt++){const nt=Qe[tt];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,_e)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];et.push({cacheId:[xe,tt],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,_e),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$uG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$uG)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:xe,actions:et}}async resolveCodeAction(z,L){const[G,H]=z,ee=this.e.get(G,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,L)??ee;let Oe;se.edit&&(Oe=i.WorkspaceEdit.from(se.edit,void 0));let Be;if(se.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(se.command,Qe))}return{edit:Oe,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class U{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new t.$Yjc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(z),se=L.map(Qe=>i.Range.to(Qe)),Oe=i.DataTransfer.toDataTransfer(G,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,se,Oe,H),H.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof a.$DN));return i.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(L),Be=G.map(et=>i.Range.to(et)),Qe=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,z,et)).buffer),xe=await this.g.provideDocumentPasteEdits(Oe,Be,Qe,{only:ee.only?new a.$IN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const _e=this.d.add(xe);return xe.map((et,tt)=>({_cacheId:[_e,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const ee=this.d.getDocument(z),se=i.Range.to(L),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,k.$$f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),se=L.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,ee){const se=this.d.getDocument(z),Oe=i.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(se,Oe,G,H,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class we{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Yjc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let se=0;se<G.length;se++){const Oe=G[se];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,g.$Wn)(z,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const ee=this.d.getDocument(z),se=i.Position.to(L);try{const Oe=await this.e.provideRenameEdits(ee,se,G,H);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Ie.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=i.Position.to(L);try{const se=await this.e.prepareRename(H,ee,G);let Oe,Be;if(a.$QM.isRange(se)?(Oe=se,Be=H.getText(se)):(0,k.$3f)(se)&&(Oe=se.range,Be=se.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:Be}}catch(se){const Oe=Ie.g(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),ee=i.Range.to(L);try{const se=await this.e.provideNewSymbolNames(H,ee,G);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class pe{constructor(z,L){this.resultId=z,this.tokens=L}}class re{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),ee=L!==0?this.d.get(L):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(L),se?(se=re.h(se),this.o(re.n(ee,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new a.$9N(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new a.$$N(z.edits.map(L=>new a.$0N(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!re.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,ee=L.data,se=ee.length;let Oe=0;const Be=Math.min(H,se);for(;Oe<Be&&G[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===se)return new a.$$N([],L.resultId);let Qe=0;const xe=Be-Oe;for(;Qe<xe&&G[H-Qe-1]===ee[se-Qe-1];)Qe++;return new a.$$N([{start:Oe,deleteCount:H-Oe-Qe,data:ee.subarray(Oe,se-Qe)}],L.resultId)}o(z,L){if(re.j(z)){const G=this.e++;return this.d.set(G,new pe(z.resultId,z.data)),(0,o.$dbb)({id:G,type:"full",data:z.data})}if(re.l(z)){const G=this.e++;return re.j(L)?this.d.set(G,new pe(L.resultId,L.data)):this.d.set(G,new pe(z.resultId)),(0,o.$dbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(L),G);return ee?this.f(ee):null}f(z){return(0,o.$dbb)({id:0,type:"full",data:z.data})}}class Le{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new t.$Yjc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const ee=this.f.getDocument(z),se=i.Position.to(L),Oe=ee.getWordRangeAtPosition(se)||new a.$QM(se,se),Be=Oe.with({end:se}),Qe=new E.$8d,xe=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(G));if(!xe||H.isCancellationRequested)return;const _e=Array.isArray(xe)?new a.$kN(xe):xe,et=Le.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),tt=new m.$Tc;this.e.set(et,tt);const nt=[],ct={x:et,b:nt,a:{replace:i.Range.from(Oe),insert:i.Range.from(Be)},c:_e.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<_e.items.length;ft++){const Ue=_e.items[ft],st=this.l(Ue,[et,ft],Be,Oe);nt.push(st)}return ct}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),ee=await this.h.resolveCompletionItem(G,L);if(!ee)return;const se=this.l(ee,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,g.$Xn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,ee),Oe={x:L,a:z.label,b:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(i.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof a.$ZM&&(Oe.h=z.insertText.value,Oe.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),a.$QM.isRange(Be)?Oe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Oe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Oe}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class j extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new ve,this.e=(0,h.$uG)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$uG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const ee=this.g.getDocument(z),se=i.Position.to(L),Oe=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Be}),items:Be.map((tt,nt)=>{let ct;tt.command&&(_e||(_e=new m.$Tc),ct=this.j.toInternal(tt.command,_e));const ft=tt.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Qe.map(tt=>(_e||(_e=new m.$Tc),this.j.toInternal(tt,_e))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const ee=this.d.get(z)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let se;const Oe=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Be;ee.accepted&&(se||(se=new m.$Tc),Be=this.h.toInternal(ee.accepted,se));let Qe;return ee.rejected&&(se||(se=new m.$Tc),Qe=this.h.toInternal(ee.rejected,se)),{pid:Oe,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new ve,this.e={[n.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Ne{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Yjc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const ee=this.e.getDocument(z),se=i.Position.to(L),Oe=this.g(G),Be=await this.f.provideSignatureHelp(ee,se,H,Oe);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=i.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class Ee{constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new t.$Yjc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),ee=i.Range.to(L),se=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(se);this.e.set(Oe,new m.$Tc);const Be={hints:[],cacheId:Oe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],ee)&&Be.hints.push(this.m(se[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$1M.isLocation(se.location)&&(Oe.location=i.location.from(se.location)),se.command&&(Oe.command=this.g.toInternal(se.command,G)),ee.push(Oe)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Yjc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!$e.g(H[Oe]))continue;const Be=i.DocumentLink.from(H[Oe]);Be.cacheId=[ee,Oe],se.links.push(Be)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return i.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class fe{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),ee=i.Range.to(L.range),se=i.Color.to(L.color),Oe=await this.e.provideColorPresentations(se,{document:H,range:ee},G);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class Q{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class X{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),ee=L.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Oe.push(Qe);let xe=ee[Be],_e=se[Be];for(;;){if(!_e.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(_e)),!_e.parent)break;xe=_e.range,_e=_e.parent}}return Oe}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$cP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=i.Position.to(L),se=await this.g.prepareCallHierarchy(H,ee,G);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Be=>this.h(Oe,Be)):[this.h(Oe,se)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class de{constructor(z,L){this.f=z,this.g=L,this.d=new M.$cP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=i.Position.to(L),se=await this.g.prepareTypeHierarchy(H,ee,G);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Be=>this.h(Oe,Be)):[this.h(Oe,se)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(se=>this.h(z,se))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Te{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new t.$Yjc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,ee){const se=this.f.getDocument(L),Oe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,et)).buffer),Qe=await this.g.provideDocumentDropEdits(se,Oe,Be,ee);if(!Qe)return;const xe=(0,I.$3b)(Qe),_e=this.d.add(xe);return xe.map((et,tt)=>({_cacheId:[_e,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const se=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class he{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const ee=u.URI.revive(z),se=this.d.getDocument(ee),Oe=G.documents.map(xe=>xe.map(_e=>({uri:u.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(et=>i.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,L,Be,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,ee,se,Oe,Be){this.g=L,this.h=G,this.j=H,this.k=ee,this.l=se,this.m=Oe,this.n=Be,this.f=new Map,this.e=z.getProxy(v.$MM.MainThreadLanguageFeatures)}o(z,L){return i.DocumentSelector.from(z,this.g,L)}p(z){return new a.$OM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,ee,se=!1){const Oe=this.f.get(z);if(!Oe||!(Oe.adapter instanceof L))return H;const Be=Date.now();se||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(xe=>{(0,O.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,N.$ch)(Qe,ee):Qe}t(z,L){const G=this.q();return this.f.set(G,new Ce(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const ee=this.t(new c(this.h,G),z),se=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,z),se),this.p(ee)}$provideDocumentSymbols(z,L,G){return this.s(z,c,H=>H.provideDocumentSymbols(u.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new $(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),ee);let se=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));se=a.$OM.from(se,Oe)}return se}$provideCodeLenses(z,L,G){return this.s(z,$,H=>H.provideCodeLenses(u.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,$,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,$,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new p(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,p,ee=>ee.provideDefinition(u.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new l(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,l,ee=>ee.provideDeclaration(u.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new D(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,D,ee=>ee.provideImplementation(u.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new f(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,f,ee=>ee.provideTypeDefinition(u.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const ee=this.t(new S(this.h,G),z);return this.e.$registerHoverProvider(ee,this.o(L,z)),this.p(ee)}$provideHover(z,L,G,H){return this.s(z,S,ee=>ee.provideHover(u.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const ee=this.t(new y(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,z)),this.p(ee)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,y,ee=>ee.provideEvaluatableExpression(u.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new C(this.h,G),z);this.e.$registerInlineValuesProvider(se,this.o(L,z),ee);let Oe=this.p(se);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Oe=a.$OM.from(Oe,Be)}return Oe}$provideInlineValues(z,L,G,H,ee){return this.s(z,C,se=>se.provideInlineValues(u.URI.revive(L),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new P(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,P,ee=>ee.provideDocumentHighlights(u.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,ee){return this.s(z,W,se=>se.provideMultiDocumentHighlights(u.URI.revive(L),G,H.map(Oe=>u.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,V,async ee=>{const se=await ee.provideLinkedEditingRanges(u.URI.revive(L),G,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Me.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,ee){return this.s(z,q,se=>se.provideReferences(u.URI.revive(L),G,H,ee),void 0,ee)}registerCodeActionProvider(z,L,G,H){const ee=new m.$Tc,se=this.t(new A(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Me.u(z),!!G.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(z,L,G,H,ee){return this.s(z,A,se=>se.provideCodeActions(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCodeAction(z,L,G){return this.s(z,A,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,A,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),z);return this.e.$registerRangeFormattingSupport(ee,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,L,G,H,ee){return this.s(z,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,L,G,H,ee){return this.s(z,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,L,G,H){const ee=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,L,G,H,ee,se){return this.s(z,ce,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(L),G,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new we(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,we,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,we,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,we,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,ee){return this.s(z,Ie,se=>se.provideRenameEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(u.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(u.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const ee=this.t(new re(this.h,G),z),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,z),H,se);let Oe=this.p(ee);if(se){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Oe=a.$OM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,re,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,re,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const ee=this.t(new Se(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Se,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const ee=this.t(new Le(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(L,z),H,Le.supportsResolving(G),z.identifier),this.p(ee)}$provideCompletionItems(z,L,G,H,ee){return this.s(z,Le,se=>se.provideCompletionItems(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCompletionItem(z,L,G){return this.s(z,Le,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Le,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const ee=new j(z,this.h,G,this.j.converter),se=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(se,this.o(L,z),ee.supportsHandleEvents,r.$Im.toKey(z.identifier.value),H?.yieldTo?.map(Oe=>r.$Im.toKey(Oe))||[]),this.p(se)}$provideInlineCompletions(z,L,G,H,ee){return this.s(z,ne,se=>se.provideInlineCompletions(u.URI.revive(L),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async ee=>{ee.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,ee){this.s(z,ne,async se=>{se.handlePartialAccept(L,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(L,z),z.identifier),this.p(ee)}$provideInlineEdit(z,L,G,H){return this.s(z,x,ee=>ee.provideInlineEdits(u.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Ne(this.h,G),z);return this.e.$registerSignatureHelpProvider(se,this.o(L,z),ee),this.p(se)}$provideSignatureHelp(z,L,G,H,ee){return this.s(z,Ne,se=>se.provideSignatureHelp(u.URI.revive(L),G,H,ee),void 0,ee)}$releaseSignatureHelp(z,L){this.s(z,Ne,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let se=this.p(ee);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));se=a.$OM.from(se,Oe)}return se}$provideInlayHints(z,L,G,H){return this.s(z,Ee,ee=>ee.provideInlayHints(u.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,Ee,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,Ee,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(u.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new fe(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,fe,H=>H.provideColors(u.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,fe,ee=>ee.provideColorPresentations(u.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,ee);let se=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=a.$OM.from(se,Oe)}return se}$provideFoldingRanges(z,L,G,H){return this.s(z,Q,ee=>ee.provideFoldingRanges(u.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new X(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,X,ee=>ee.provideSelectionRanges(u.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,le,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,le,ee=>ee.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,le,ee=>ee.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,de,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,de,ee=>ee.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,de,ee=>ee.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,de,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Te(this.e,this.h,G,ee,z),z)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,z),(0,h.$uG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,L,G,H,ee,se){return this.s(z,Te,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(L,u.URI.revive(G),H,ee,se)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Te,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Te,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,ee){return this.s(z,he,se=>Promise.resolve(se.provideMappedEdits(L,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new U(this.e,this.h,G,ee,z),z)),this.e.$registerPasteEditProvider(ee,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,L,G,H,ee){return this.s(z,U,se=>se.prepareDocumentPaste(u.URI.revive(L),G,H,ee),void 0,ee)}$providePasteEdits(z,L,G,H,ee,se,Oe){return this.s(z,U,Be=>Be.providePasteEdits(L,u.URI.revive(G),H,ee,se,Oe),void 0,Oe)}$resolvePasteEdit(z,L,G){return this.s(z,U,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,U,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>a.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,T.$cf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,se),this.p(ee)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$9jc=Me}),define(Re[88],Ae([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=e.$Pkc=void 0,e.$Pkc=(0,b.$ni)("IExtHostLanguageModels");class r{constructor(t,v){this.option=t,this.stream=new g.$Qh,this.stream=v??new g.$Qh}}class i{constructor(){this.a=new Map,this.b=new g.$Qh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new r(t.index,this.b):v=new r(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,v,c){this.j=v,this.k=c,this.c=new E.$_d,this.d=new E.$_d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Km,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$MM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,c,$){const w=s.a++;this.f.set(w,{extension:t.identifier,provider:c,languageModelId:v});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(w,v,{extension:t.identifier,identifier:v,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(w),this.b.$unregisterProvider(w)})}async $provideLanguageModelResponse(t,v,c,$,w,p){const l=this.f.get(t);if(!l)return;const D=new M.$Wv(async f=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:f.index,part:f.part})});return l.provider.provideLanguageModelResponse2($.map(R.LanguageModelMessage.to),w,m.$Im.toKey(c),D,p)}$updateLanguageModels(t){const v=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),v.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[w,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(w))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:c,to:$,enabled:w}of t){const p=this.h.get(c)??new m.$Jm;if(p.has($)!==w){w?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};v.push(D),this.c.fire(D)}}}async sendChatRequest(t,v,c,$,w){const p=t.identifier,l=await this.b.$prepareChatAccess(p,v,$.justification);if(!l||!this.g.has(v))throw O.$WO.NotFound(`Language model '${v}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw O.$WO.NoPermissions(`Language model '${v}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,f=this.b.$fetchResponse(p,v,D,c.map(R.LanguageModelMessage.from),$.modelOptions??{},w),S=new g.$mh,y=new i;this.i.set(D,{languageModelId:v,res:y});let C;if(f.catch(P=>{S.isOpen()?y.reject(P):C=P}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),C)throw new O.$WO(`Language model '${v}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,v){const c=this.i.get(t);c&&c.res.handleFragment(v)}async l(t,v,c,$){const w=k.$OL+v.identifier.value;if(await this.k.getSession(t,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,T.localize)(0,null,v.displayName,c):(0,T.localize)(1,null,v.displayName);return await this.k.getSession(t,w,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!m.$Im.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,c=E.Event.signal(E.Event.filter(this.c.event,w=>m.$Im.equals(w.from,t.identifier))),$=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,$)},canSendRequest(w){const p=v.g.get(w);if(!p)return;if(!v.m(t.identifier,p))return!0;const l=v.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$Qkc=a,e.$Qkc=a=s=Je([We(0,d.$0O),We(1,o.$Tj),We(2,n.$$jc)],a)}),define(Re[264],Ae([1,0,4,8,7,33,11,6,25]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class E{constructor(k,u,b,d){this.c=u,this.d=b,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(I.$MM.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,u){await this.a.$changeLanguage(k,u);const b=this.c.getDocumentData(k);if(!b)throw new Error(`document '${k.toString()}' NOT found`);return b.document}async tokenAtPosition(k,u){const b=k.version,d=N.Position.from(u),n=await this.a.$tokensAtPosition(k.uri,d),o={type:R.StandardTokenType.Other,range:k.getWordRangeAtPosition(u)??new R.$QM(u.line,u.character,u.line,u.character)};if(!n)return o;const s={range:N.Range.to(n.range),type:N.TokenType.to(n.type)};return!s.range.contains(u)||b!==k.version?o:s}createLanguageStatusItem(k,u,b){const d=this.f++,n=this.a,o=this.g,s=`${k.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const r={selector:b,id:u,name:k.displayName??k.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$ph)(()=>{a.clear(),this.a.$setLanguageStatus(d,{id:s,name:r.name??k.displayName??k.name,source:k.displayName??k.name,selector:N.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===R.LanguageStatusSeverity.Error?O.default.Error:r.severity===R.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),n.$removeLanguageStatus(d),o.delete(s)},get id(){return r.id},get name(){return r.name},set name(v){r.name=v,h()},get selector(){return r.selector},set selector(v){r.selector=v,h()},get text(){return r.text},set text(v){r.text=v,h()},set text2(v){(0,g.$vG)(k,"languageStatusText"),r.text=v,h()},get text2(){return(0,g.$vG)(k,"languageStatusText"),r.text},get detail(){return r.detail},set detail(v){r.detail=v,h()},get severity(){return r.severity},set severity(v){r.severity=v,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(v){r.accessibilityInformation=v,h()},get command(){return r.command},set command(v){r.command=v,h()},get busy(){return r.busy},set busy(v){r.busy=v,h()}};return h(),t}}e.$vlc=E}),define(Re[265],Ae([1,0,12,2,8,7,83]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=e.$hlc=void 0;class m{constructor(k,u,b,d){this.start=k,this.deletedCount=u,this.deletedItems=b,this.items=d}asApiEvent(){return{range:new O.$dO(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k){return{EOL:k.eol,lines:k.source,languageId:k.language,uri:k.uri,isDirty:!1,versionId:1}}constructor(k,u,b){this.notebook=k,this.h=u,this.j=b,this.handle=b.handle,this.uri=N.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(R.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(d){k.g=d},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(R.NotebookCellOutput.to)}setOutputItems(k,u,b){const d=b.map(R.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===k);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(o=>M.$JK(o.mime)))){const o=new Map,s=[];n.items.forEach(r=>{let i;o.has(r.mime)?i=o.get(r.mime):(i=[],o.set(r.mime,i),s.push(r.mime)),i.push(r.data)}),n.items.length=0,s.forEach(r=>{const i=M.$KK(o.get(r));n.items.push({mime:r,data:i.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$hlc=g;class E{static{this.a=0}constructor(k,u,b,d,n){this.k=k,this.l=u,this.m=b,this.uri=d,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===I.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(n=>n.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,b){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const d={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},n=[];for(const s of k.rawEvents)s.kind===M.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,d.contentChanges):s.kind===M.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,d.contentChanges):s.kind===M.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===M.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const r=n[s],i=o.get(r.cell);if(i===void 0){const a=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,a-1)}else d.cellChanges[i]={...d.cellChanges[i],...r}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,b=k.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),k.with({start:u,end:b})}p(k){k=this.o(k);const u=[];for(let b=k.start;b<k.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,b){if(this.j)return;const d=[],n=[],o=[];if(k.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new g(this,this.l,t);return u||n.push(g.asModelAddData(t)),v}),a=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);d.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),b)for(const s of d)b.push(s.asApiEvent())}s(k,u,b,d){const n=this.b.splice(k,u);this.b.splice(b,0,...n);const o=[new m(k,u,n.map(s=>s.apiCell),[]),new m(b,0,[],n)];for(const s of o)d.push(s.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,b,d){this.b[k].setOutputItems(u,b,d)}v(k,u){const b=this.b[k];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(k,u){const b=this.b[k];b.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$ilc=E}),define(Re[266],Ae([1,0,5,2,8,7,34]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class m{constructor(E,T,k,u={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=k,this.f=u,this.a=new I.$be}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,k,u)=>{const b=function(n){T.call(k,n)};return b.extension=E,this.a.event(b,void 0,u)}}async $participateInSave(E,T,k){const u=N.URI.revive(E),b=this.c.getNotebookDocument(u);if(!b)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},k,async(o,s)=>{const r=Date.now(),i=await await Promise.resolve(o);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!k.isCancellationRequested&&i&&(i instanceof O.$YM?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),k.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const o of d){const{edits:s}=R.WorkspaceEdit.from(o);n.edits=n.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new M.$jw(n))}}e.$xlc=m}),define(Re[112],Ae([1,0,14,8,7]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,E,T,k,u){this.id=m,this.f=g,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=T,this.c=u}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$dO.isNotebookRange))throw(0,I.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,E){m.f.$tryRevealRange(m.id,N.NotebookRange.from(g),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(N.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$jlc=O}),define(Re[267],Ae([1,0,5,13,8]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;let O=class{constructor(m,g){this.c=m,this.d=g,this.a=new I.$_d,this.b=new I.$_d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,g);const E=this.d.getEditorById(m);g.visibleRanges&&E._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&E._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const g in m)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(m[g]))}};e.$zlc=O,e.$zlc=O=Je([We(0,N.$Tj)],O)}),define(Re[268],Ae([1,0,5,4,112]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class O{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(N.$MM.MainThreadNotebookRenderers)}$postRendererMessage(m,g,E){const T=this.c.getEditorById(m);this.a.get(g)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(T=>T.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(T,k,u)=>this.d(g).event(T,k,u),postMessage:(T,k)=>{R.$jlc.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const u=k&&R.$jlc.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,g,T)}}}d(m){let g=this.a.get(m);return g||(g=new I.$_d({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Clc=O}),define(Re[269],Ae([1,0,8,101,24,68,14]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,u,b){const d=this.b++,{title:n,location:o,cancellable:s}=u,r={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(d,{location:I.ProgressLocation.from(o),title:n,source:r,cancellable:s},k.isUnderDevelopment?void 0:k.identifier.value).catch(M.$2),this.d(d,b,!!s)}d(k,u,b){let d;b&&(d=new R.$je,this.c.set(k,d));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),d?.dispose()};let o;try{o=u(new E(this.a,k),b&&d?d.token:R.CancellationToken.None)}catch(s){throw n(k),s}return o.then(s=>n(k),s=>n(k)),o}$acceptProgressCanceled(k){const u=this.c.get(k);u&&(u.cancel(),this.c.delete(k))}}e.$Glc=m;function g(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class E extends N.$Wv{constructor(k,u){super(b=>this.throttledReport(b)),this.c=k,this.d=u}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,O.$Th)(100,(T,k)=>g(T,k),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Re[270],Ae([1,0,2,4,11,8]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class M{static{this.a=0}constructor(g,E){this.d=E,this.c=new Map,this.b=g.getProxy(N.$MM.MainThreadQuickDiff)}$provideOriginalResource(g,E,T){const k=I.URI.revive(E),u=this.c.get(g);return u?(0,R.$fh)(()=>u.provideOriginalResource(k,T)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(g,E,T,k){const u=M.a++;return this.c.set(u,E),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(g,this.d),T,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Hlc=M}),define(Re[271],Ae([1,0,24,5,6,4,2,7,14,18,33,41,25,8]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=d;function d(n,o,s){const r=n.getProxy(O.$MM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,f,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,P=r.$show(C,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},S),W={},V=P.then(()=>W);return Promise.race([V,y]).then(q=>{if(q===W)return;const A=(0,u.$uG)(l,"quickPickItemTooltip");return y.then(U=>{const K=[];for(let ie=0;ie<U.length;ie++){const ce=U[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===m.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const we=ce.iconPath?c(ce.iconPath):void 0;K.push({label:ce.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?b.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=ie=>{f.onDidSelectItem(U[ie])}),r.$setItems(C,K),P.then(ie=>{if(typeof ie=="number")return U[ie];if(Array.isArray(ie))return ie.map(ce=>U[ce])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return r.$setError(C,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,r.$input(l,typeof this.d=="function",D).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let f;switch(D.severity){case m.InputBoxValidationSeverity.Info:f=T.default.Info;break;case m.InputBoxValidationSeverity.Warning:f=T.default.Warning;break;case m.InputBoxValidationSeverity.Error:f=T.default.Error;break;default:f=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:f}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!f)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===f.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new w(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,f){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,f)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$_d,this.q=new N.$_d,this.r=new N.$_d,this.s=new N.$_d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,f)=>{const S=D===m.$aO.Back?-1:f;this.o.set(S,D)}),this.z({buttons:l.map((D,f)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===m.$aO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const f=l[D];this.u[D]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof m.$KN)return{id:p.id};const l=v(p),D=t(p);return{dark:typeof l=="string"?M.URI.file(l):l,light:typeof D=="string"?M.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function v(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,f;return"id"in l?f=k.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:f}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$_d,this.L=[],this.M=new N.$_d,this.N=new N.$_d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,u.$uG)(this.O,"quickPickItemTooltip"),f=[];for(let S=0;S<l.length;S++){const y=l[S];if(y.kind===m.QuickPickItemKind.Separator)f.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;f.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,W)=>({...c(P.iconPath),tooltip:P.tooltip,handle:W}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const f=this.C.get(l);if(!f||!f.buttons||!f.buttons.length)return;const S=f.buttons[D];S&&this.N.fire({button:S,item:f})}}class w extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:T.default.Error}):this.z({validationMessage:l.message,severity:l.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(o,s)}}),define(Re[272],Ae([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;function r(C){return C instanceof I.URI}function i(C,P){return C.scheme===n.Schemas.file&&P.scheme===n.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$fr)(W,V)}function v(C,P){let W=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(W=t(C,P),W!==0)return W;if(C.light&&P.light)W=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(W!==0)return W;if(C.dark&&P.dark)W=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return W}function c(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=P.arguments[W];if(V!==q&&!(r(V)&&r(q)&&i(V,q)))return V<q?-1:1}return 0}function $(C,P){let W=(0,E.$fr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&P.command)W=c(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(W!==0)return W;if(C.decorations&&P.decorations)W=v(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)W=(0,E.$fr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)W=(0,E.$fr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return W}function w(C,P){for(let W=0;W<C.length;W++)if(C[W]!==P[W])return!1;return!0}function p(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?w(C.arguments,P.arguments):C.arguments===P.arguments)}function l(C,P){return(0,g.$ub)(C,P,p)}class D{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,d.$vG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,d.$vG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,d.$vG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,W,V,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new N.$_d,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(P,W){(0,d.$vG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,W)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Jlc=D;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,W,V,q,A,U,K){this.q=P,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$_d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$_d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,W){const V=this.h.get(P);return V?(0,M.$fh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort($),V=(0,g.$Db)(this.o,P,$).map(U=>{const K=U.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const we=ie.resourceUri;let Ie;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const fe=new O.$Tc;Ie=this.s.converter.toInternal(ie.command,fe),this.j.set(ce,fe)}else this.h.set(ce,ie.command);const ue=(0,d.$uG)(this.w,"scmMultiDiffEditor"),pe=ue?ie.multiDiffEditorOriginalUri:void 0,re=ue?ie.multiFileDiffEditorModifiedUri:void 0,Se=a(ie.decorations),Le=ie.decorations&&a(ie.decorations.light)||Se,ne=ie.decorations&&a(ie.decorations.dark)||Se,j=[Le,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Ne=ie.decorations&&!!ie.decorations.faded,Ee=ie.contextValue||"";return{rawResource:[ce,we,j,x,ve,Ne,Ee,Ie,pe,re],handle:ce}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=V.map(({start:U,deleteCount:K,toInsert:ie})=>[U,K,ie.map(ce=>ce.rawResource)]),A=V.reverse();for(const{start:U,deleteCount:K,toInsert:ie}of A){const ce=ie.map(Ie=>Ie.handle),we=this.n.splice(U,K,...ce);for(const Ie of we)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let W;(0,d.$uG)(this.x,"quickDiffProvider")&&(W=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:W})}get historyProvider(){return(0,d.$vG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,d.$vG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new O.$Tc,this.o=P;const W=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,d.$vG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,d.$vG)(this.x,"scmActionButton"),this.p.value=new O.$Tc,this.q=P;const W=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&l(this.t,P))return;this.s.value=new O.$Tc,this.t=P;const W=(P||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(P,W,V,q,A,U,K){this.x=P,this.y=q,this.z=A,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.m=void 0,this.n=new O.$Vc,this.o=void 0,this.p=new O.$Vc,this.s=new O.$Vc,this.t=void 0,this.u=!1,this.v=new N.$_d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(P,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,U,K,ie)}createResourceGroup(P,W,V){const q=(0,d.$uG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,P,W,q,this.x),U=N.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});N.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),P.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const U=V._takeResourceStateSnapshot();U.length>0&&W.push([V.handle,U]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,P,W),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&P.push([W.handle,V])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Sh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Sh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new k.$Km,this.j=new N.$_d,this.e=P.getProxy(m.$MM.MainThreadSCM),this.f=P.getProxy(m.$MM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this.g.get(A.sourceControlHandle);if(!U)return A;const K=U.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this.g.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this.g.get(A.handle);return U||A}return A}})}createSourceControl(P,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=s.d++,U=new S(P,this.m,this.e,this.l,W,V,q);this.g.set(A,U);const K=this.h.get(P.identifier)||[];return K.push(U),this.h.set(P.identifier,K),U}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const W=this.h.get(P.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(P,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$fh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(U=>U||null)}$onInputBoxValueChange(P,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const V=this.g.get(P);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(P,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,W,V);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(W);return U?U.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(P,W,V){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$fh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const U=b.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,W,V,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(P,W,V,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(P,W,V,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(W,V,q);return U?{...U,icon:h(U)}:void 0}async $provideHistoryItemChanges(P,W,V,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Klc=y,e.$Klc=y=s=Je([We(3,T.$Tj)],y)}),define(Re[273],Ae([1,0,4,8,2]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class O{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(I.$MM.MainThreadShare)}async $provideShare(m,g,E){return await this.c.get(m)?.provideShare({selection:N.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},E)??void 0}registerShareProvider(m,g){const E=O.a++;return this.c.set(E,g),this.b.$registerShareProvider(E,N.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Llc=O}),define(Re[274],Ae([1,0,7,4,170,6,8,17]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=e.$Nlc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$LN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$LN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,d,n,o,s=I.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=u,this.#t=b,o&&n){this.c=(0,I.$nN)(n.identifier,o);const i=d.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,r=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(g.a++);this.e=n,this.f=o,this.g=s,this.h=this.u(r)}u(u){if((0,m.$5f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,R.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=g.b.get(this.o.id));const n=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,n,this.r?.internal,d,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Nlc=g;class E{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new I.$OM(()=>{const d=this.b.indexOf(b);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(u,b){this.e=new Map,this.a=u.getProxy(N.$MM.MainThreadStatusBar),this.b=b,this.c=new E(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,d,n){return new g(this.a,this.b,this.e,u,b,d,n)}setStatusBarMessage(u,b){const d=this.c.setMessage(u);let n;return typeof b=="number"?n=setTimeout(()=>d.dispose(),b):typeof b<"u"&&b.then(()=>d.dispose(),()=>d.dispose()),new I.$OM(()=>{d.dispose(),clearTimeout(n)})}}e.$Olc=T}),define(Re[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=void 0;const E=(i,a,h,t)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(c){if(!h(v,c)){const $=v;v=c,i.listener?.(t(c,$))}}}},T=(i,a)=>i===a,k={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),b=(i,a)=>({range:(()=>{let h;const t=u(v=>({range:I.$ht.lift(m.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),k.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:E(i,a,k.label,u(h=>({label:h}))),description:E(i,void 0,k.description,u(h=>({description:h}))),sortText:E(i,void 0,k.sortText,u(h=>({sortText:h}))),canResolveChildren:E(i,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:E(i,!1,k.busy,u(h=>({busy:h}))),error:E(i,void 0,k.error,u(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:E(i,[],k.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),d=i=>{const a=R.$yL.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,g.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,M.$EL)(t).tagId})),h},n=i=>{let a;for(const h of i.tests){const t=d(h.item);(0,N.$6O)(t).parent=a,a=t}return a};e.$jP=n;class o{constructor(a,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,N.$5O)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,O.$4O)(c,N.$6O,o),enumerable:!0,writable:!1},...b(c,t)})}}e.$kP=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$lP=s;class r extends O.$ZO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:N.$6O,getChildren:v=>v.children,root:new s(a,h),toITestItem:m.TestItem.from})}}e.$mP=r}),define(Re[32],Ae([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,34,42,65,59,62,35]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=void 0;let c=class{#e;#t;#i;constructor(f,S,y){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$MM.MainThreadCommands),this.d=S,this.#i=y,this.#t=f.getProxy(M.$MM.MainThreadTelemetry),this.converter=new $(this,C=>{const P=this.c.get(C);return P?.result===p.Void?P:void 0},S),this.f=[{processArgument(C){return(0,E.$Wh)(C)}},{processArgument(C){return(0,O.$Vn)(C,function(P){if(T.$ht.isIRange(P))return R.Range.to(P);if(k.$gt.isIPosition(P))return R.Position.to(P);if(T.$ht.isIRange(P.range)&&u.URI.isUri(P.uri))return R.location.to(P);if(P instanceof s.$ze)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const S=this.registerCommand(!1,f.id,async(...y)=>{const C=f.args.map((W,V)=>{if(!W.validate(y[V]))throw new Error(`Invalid argument '${W.name}' when running '${f.id}', received: ${typeof y[V]=="object"?JSON.stringify(y[V],null,"	"):y[V]} `);return W.convert(y[V])}),P=await this.executeCommand(f.internalId,...C);return f.result.convert(P,y,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new N.$OM(()=>{S.dispose(),this.c.delete(f.id)})}registerCommand(f,S,y,C,P,W){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:P,extension:W}),f&&this.#e.$registerCommand(S),new N.$OM(()=>{this.b.delete(S)&&f&&this.#e.$unregisterCommand(S)})}executeCommand(f,...S){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,S,!0)}async g(f,S,y){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,S,!1);{let C=!1;const P=(0,O.$Vn)(S,function(W){if(W instanceof N.$PM)return R.Position.from(W);if(W instanceof N.$QM)return R.Range.from(W);if(W instanceof N.$1M)return R.location.from(W);if(N.$dO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,s.$ze.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,s.$ze.wrap(W);if(W instanceof s.$ze)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(f,C?new r.$jw(P):P,y);return(0,E.$Wh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(f,S,!1);throw W}}}async h(f,S,y){const C=this.b.get(f);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:V}=C;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,I.$fg)(S[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=a.$8d.create();try{return await P.apply(W,S)}catch(A){if(f===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...S);U&&(f=U.command)}if(this.d.error(A,f,C.extension?.identifier),!y)throw A;if(C.extension?.identifier){const U=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",U,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$$i)(A)),this.id=f,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,f,q.elapsed())}}j(f,S,y){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$9o(S),duration:y})}$executeContributedCommand(f,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const y=this.b.get(f);return y?(S=S.map(C=>this.f.reduce((P,W)=>W.processArgument(P,y.extension?.identifier),C)),this.h(f,S,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(S=>(f&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(f[S]=C)}return Promise.resolve(f)}};e.$sP=c,e.$sP=c=Je([We(0,n.$0O),We(1,g.$Tj),We(2,t.$rP)],c),e.$tP=(0,d.$ni)("IExtHostCommands");class ${constructor(f,S,y){this.d=f,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,v.$Jg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,S){if(!f)return;const y={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return y;const C=this.f(f.command);if(C)y.id=C.internalId,y.arguments=C.args.map((P,W)=>P.convert(f.arguments&&f.arguments[W]));else if((0,m.$Lb)(f.arguments)){const P=`${f.command} /${++this.c}`;this.b.set(P,f),S.add((0,b.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",f.command,P)}return y}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const S=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$uP=$;class w{static{this.Uri=new w("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new w("position","A position in a text document",f=>N.$PM.isPosition(f),R.Position.from)}static{this.Range=new w("range","A range in a text document",f=>N.$QM.isRange(f),R.Range.from)}static{this.Selection=new w("selection","A selection in a text document",f=>N.$RM.isSelection(f),R.Selection.from)}static{this.Number=new w("number","",f=>typeof f=="number",f=>f)}static{this.String=new w("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=w.Arr(w.String)}static Arr(f){return new w(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,S=>Array.isArray(S)&&S.every(y=>f.validate(y)),S=>S.map(y=>f.convert(y)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",f=>f instanceof N.$_M,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",f=>f instanceof N.$xO,R.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",f=>f instanceof o.$kP,R.TestItem.from)}constructor(f,S,y,C){this.name=f,this.description=S,this.validate=y,this.convert=C}optional(){return new w(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,S){return new w(f??this.name,S??this.description,this.validate,this.convert)}}e.$vP=w;class p{static{this.Void=new p("no result",f=>f)}constructor(f,S){this.description=f,this.convert=S}}e.$wP=p;class l{constructor(f,S,y,C,P){this.id=f,this.internalId=S,this.description=y,this.args=C,this.result=P}}e.$xP=l}),define(Re[275],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;const k=[new g.$xP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of DocumentHighlight-instances.",b(E.DocumentHighlight.to))),new g.$xP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$vP.Uri],new g.$wP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,I.$Kb)(n))return;class s extends T.$7M{static to(i){const a=new s(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$1M(o[0],E.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=E.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return n.map(s.to)})),new g.$xP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$vP.Uri,new g.$vP("options","Formatting options",n=>!0,n=>n)],new g.$wP("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new g.$xP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$vP.Uri,g.$vP.Range,new g.$vP("options","Formatting options",n=>!0,n=>n)],new g.$wP("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new g.$xP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$vP.Uri,g.$vP.Position,new g.$vP("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$vP("options","Formatting options",n=>!0,n=>n)],new g.$wP("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new g.$xP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$xP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$xP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$xP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$xP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Location-instances.",b(E.location.to))),new g.$xP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of Hover-instances.",b(E.Hover.to))),new g.$xP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$vP.Uri,new g.$vP("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>T.$PM.isPosition(o)),n=>n.map(E.Position.from))],new g.$wP("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const r of o.reverse())s=new T.$$M(E.Range.to(r),s);return s}))),new g.$xP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$vP.String.with("query","Search string")],new g.$wP("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(E.WorkspaceSymbol.to))),new g.$xP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(E.CallHierarchyItem.to))),new g.$xP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$vP.CallHierarchyItem],new g.$wP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(E.CallHierarchyIncomingCall.to))),new g.$xP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$vP.CallHierarchyItem],new g.$wP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(E.CallHierarchyOutgoingCall.to))),new g.$xP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:E.Range.to(n.range),placeholder:n.text}})),new g.$xP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$vP.Uri,g.$vP.Position,g.$vP.String.with("newName","The new symbol name")],new g.$wP("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return E.WorkspaceEdit.to(n)}})),new g.$xP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$vP.Uri,g.$vP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$wP("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(E.DocumentLink.to))),new g.$xP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$vP.Uri],new g.$wP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$7N(n.tokenTypes,n.tokenModifiers)})),new g.$xP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$vP.Uri],new g.$wP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$ebb)(n);if(o.type==="full")return new T.$9N(o.data,void 0)})),new g.$xP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$vP.Uri,g.$vP.Range.optional()],new g.$wP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$7N(n.tokenTypes,n.tokenModifiers)})),new g.$xP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$vP.Uri,g.$vP.Range],new g.$wP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$ebb)(n);if(o.type==="full")return new T.$9N(o.data,void 0)})),new g.$xP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$vP.Uri,g.$vP.Position,g.$vP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$vP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$wP("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new T.$kN([]);const r=n.suggestions.map(i=>E.CompletionItem.to(i,s));return new T.$kN(r,n.incomplete)})),new g.$xP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$vP.Uri,g.$vP.Position,g.$vP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$wP("A promise that resolves to SignatureHelp.",n=>{if(n)return E.SignatureHelp.to(n)})),new g.$xP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$vP.Uri,g.$vP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$wP("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>b(r=>new T.$cN(E.Range.to(r.range),r.command&&s.fromInternal(r.command)))(n))),new g.$xP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$vP.Uri,new g.$vP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>T.$QM.isRange(n),n=>T.$RM.isSelection(n)?E.Selection.from(n):E.Range.from(n)),g.$vP.String.with("kind","Code action kind to return code actions for").optional(),g.$vP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$wP("A promise that resolves to an array of Command-instances.",(n,o,s)=>b(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(r.command)}else{const i=new T.$9M(r.title,r.kind?new T.$0M(r.kind):void 0);return r.edit&&(i.edit=E.WorkspaceEdit.to(r.edit)),r.command&&(i.command=s.fromInternal(r.command)),i.isPreferred=r.isPreferred,i}})(n))),new g.$xP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$vP.Uri],new g.$wP("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new T.$qN(E.Range.to(o.range),E.Color.to(o.color))):[])),new g.$xP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$vP("color","The color to show and insert",n=>n instanceof T.$pN,E.Color.from),new g.$vP("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:E.Range.from(n.range)}))],new g.$wP("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(E.ColorPresentation.to):[])),new g.$xP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$vP.Uri,g.$vP.Range],new g.$wP("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(E.InlayHint.to.bind(void 0,s)))),new g.$xP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$vP.Uri],new g.$wP("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(E.FoldingRange.to)})),new g.$xP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$wP("A promise that resolves to an array of NotebookContentProvider static info objects.",b(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new g.$xP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$vP.Uri,g.$vP.Range,new g.$vP("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof T.$QM,n=>E.InlineValueContext.from(n))],new g.$wP("A promise that resolves to an array of InlineValue objects",n=>n.map(E.InlineValue.to))),new g.$xP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$vP("uriOrString","Uri-instance or string (only http/https)",n=>R.URI.isUri(n)||typeof n=="string"&&(0,N.$xg)(n,N.Schemas.http,N.Schemas.https),n=>n),new g.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional(),g.$vP.String.with("label","").optional()],g.$wP.Void),new g.$xP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$vP.Uri.with("resource","Resource to open"),g.$vP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional()],g.$wP.Void),new g.$xP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$vP.Uri.with("left","Left-hand side resource of the diff editor"),g.$vP.Uri.with("right","Right-hand side resource of the diff editor"),g.$vP.String.with("title","Human readable title for the diff editor").optional(),new g.$vP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)]).optional()],g.$wP.Void),new g.$xP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$vP.String.with("title","Human readable title for the changes editor"),new g.$vP("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,r,i]=o;if(!R.URI.isUri(s)||!R.URI.isUri(r)&&r!==void 0&&r!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],g.$wP.Void),new g.$xP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$vP.Uri,g.$vP.Position],new g.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$xP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$vP.TypeHierarchyItem],new g.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$xP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$vP.TypeHierarchyItem],new g.$wP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$xP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$vP.TestItem],g.$wP.Void),new g.$xP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$vP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$wP.Void),new g.$xP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$vP.String.with("name","The context key name"),new g.$vP("value","The context key value",()=>!0,n=>n)],g.$wP.Void),new g.$xP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$vP.Uri,g.$vP.StringArray,new g.$vP("MappedEditsContext","Mapped Edits Context",n=>E.MappedEditsContext.is(n),n=>E.MappedEditsContext.from(n))],new g.$wP("A promise that resolves to a workspace edit or null",n=>n?E.WorkspaceEdit.to(n):null))];class u{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$mj)}}e.$0jc=u;function b(n){return o=>{if(Array.isArray(o))return o.map(n)}}function d(n){if(!Array.isArray(n))return;const o=[];for(const s of n)O.$Yt(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Re[276],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class E{static{this.a=0}constructor(b,d){this.extension=b,this.provider=d,this.handle=E.a++}}class T{constructor(b){this.session=b,this.responses=[]}}class k{static{this.a=0}constructor(b,d,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(O.$MM.MainThreadInlineChat),d.registerApiCommand(new M.$xP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$vP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:g.$RM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],M.$wP.Void))}registerProvider(b,d,n){const o=new E(b,d);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??b.displayName??b.name,b.identifier,typeof d.handleInteractiveEditorResponseFeedback=="function",typeof d.provideFollowups=="function",n?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,d,n,o){const s=this.b.get(b);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(R.URI.revive(d)),i=m.Selection.to(n),a=await s.provider.prepareInteractiveEditorSession({document:r,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new T(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(b,d,n,o){const s=this.b.get(b);if(!s)return;const r=this.d.get(d.id);if(!r)return;const i={prompt:n.prompt,selection:m.Selection.to(n.selection),wholeRange:m.Range.to(n.wholeRange),attempt:n.attempt,live:n.live,previewDocument:this.f.getDocument(R.URI.revive(n.previewDocument)),withIntentDetection:n.withIntentDetection};let a=!1;const h={report:async D=>{if(!n.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:g.$dN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(r.session,i,h,o));let v;try{v=await(0,I.$bh)(t,o)}finally{a=!0}if(!v)return;const c=r.responses.push(v)-1,$={wholeRange:m.Range.from(v.wholeRange),placeholder:v.placeholder};if(!k.h(v))return{...$,id:c,type:"editorEdit",message:m.MarkdownString.from(v.contents),edits:[]};const{edits:w,contents:p}=v,l=p!==void 0?m.MarkdownString.from(p):void 0;return w instanceof g.$YM?{...$,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(w),message:l}:{...$,id:c,type:"editorEdit",edits:w.map(m.TextEdit.from),message:l}}async $provideFollowups(b,d,n,o){const s=this.b.get(b),r=this.d.get(d),i=r?.responses[n];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(r.session,i,o));return(await(0,I.$bh)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(b,d,n,o){const s=this.b.get(b),r=this.d.get(d),i=r?.responses[n];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(r.session,i,a)}}$releaseSession(b,d){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$glc=k}),define(Re[277],Ae([1,0,2,32]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class R{constructor(M,m,g,E,T){this.a=m,this.b=g,this.c=E;const k=new N.$xP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$vP("showOptions","Show Options",u=>!0,u=>u),new N.$vP("resource","Interactive resource Uri",u=>!0,u=>u),new N.$vP("controllerId","Notebook controller Id",u=>!0,u=>u),new N.$vP("title","Interactive editor title",u=>!0,u=>u)],new N.$wP("Notebook and input URI",u=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(M,m,g,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$tlc=R}),define(Re[278],Ae([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,219,25,34,220]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0,e.$Blc=w;let a=class{constructor(l,D,f,S,y){this.m=D,this.n=f,this.o=S,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$_d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(k.$MM.MainThreadNotebookKernels);const C=new u.$xP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$vP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],u.$wP.Void),P=new u.$xP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$vP.Uri],new u.$wP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(l,D,f,S,y,C){for(const Se of this.j.values())if(Se.controller.id===D&&E.$Im.equals(l.identifier,Se.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const P=this.k++,W=this;this.q.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${D}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let q=!1;const A=new O.$_d,U=new O.$_d,K={id:w(l.identifier,D),notebookType:f,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let ie=y??V,ce,we;this.a.$addKernel(P,K).catch(Se=>{console.log(Se),q=!0});let Ie=0;const ue=()=>{if(q)return;const Se=++Ie;Promise.resolve().then(()=>{Se===Ie&&this.a.$updateKernel(P,K)})},pe=new m.$Bc,re={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(Se){K.label=Se??l.displayName??l.name,ue()},get detail(){return K.detail??""},set detail(Se){K.detail=Se,ue()},get description(){return K.description??""},set description(Se){K.description=Se,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Se){K.supportedLanguages=Se,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){K.supportsExecutionOrder=Se,ue()},get rendererScripts(){return K.preloads?K.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??V},get interruptHandler(){return ce},set interruptHandler(Se){ce=Se,K.supportsInterrupt=!!Se,ue()},set variableProvider(Se){(0,s.$vG)(l,"notebookVariableProvider"),we=Se,K.hasVariableProvider=!!Se,Se?.onDidChangeVariables(Le=>W.a.$variablesUpdated(Le.uri)),ue()},get variableProvider(){return we},createNotebookCellExecution(Se){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.notebook.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return W._createNotebookCellExecution(Se,w(l.identifier,this.id))},createNotebookExecution(Se){if((0,s.$vG)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return W._createNotebookExecution(Se,w(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Se,Le){Le===d.NotebookControllerAffinity2.Hidden&&(0,s.$vG)(l,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,Se.uri,Le)},onDidReceiveMessage:U.event,postMessage(Se,Le){return(0,s.$vG)(l,"notebookMessaging"),W.a.$postMessage(P,Le&&W.n.getIdByEditor(Le),Se)},asWebviewUri(Se){return(0,s.$vG)(l,"notebookMessaging"),(0,n.$Dxb)(Se,W.m.remote)}};return this.j.set(P,{extensionId:l.identifier,controller:re,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:pe}),re}getIdByController(l){for(const[D,f]of this.j)if(f.controller===l)return w(f.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const f=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(f,D);const y={dispose:()=>{this.f.delete(f),S.a.$removeKernelDetectionTask(f)}};return this.f.set(f,y),y}registerKernelSourceActionProvider(l,D,f){const S=this.i++,y=typeof f.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,f),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let P;return y!==void 0&&(P=f.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),P?.dispose()}}}async $provideKernelSourceActions(l,D){const f=this.h.get(l);if(f){const S=new M.$Tc;return(await f.provideNotebookKernelSourceActions(D)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,f){const S=this.j.get(l);if(S){const y=this.n.getNotebookDocument(g.URI.revive(D));f?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),f),S.onDidChangeSelection.fire({selected:f,notebook:y.apiNotebook})}}async $executeCells(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(D)),C=[];for(const P of f){const W=y.getCell(P);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(P){this.q.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of f){const P=y.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);f.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(l,D,f,S,y,C,P){const W=this.j.get(l);if(!W)return;const V=this.n.getNotebookDocument(g.URI.revive(f)),q=W.controller.variableProvider;if(!q)return;let A;if(S!==void 0){if(A=this.s[S],!A)return}else this.s={};const U=y==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,U,C,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const we={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[we.id]=ce.variable,this.a.$receiveVariable(D,we),ie++>=i.$gib)return}}$acceptKernelMessageFromRenderer(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:f}))}$cellExecutionChanged(l,D,f){const y=this.n.getNotebookDocument(g.URI.revive(l)).getCell(D);if(y){const C=f?b.NotebookCellExecutionState.to(f):d.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(l,D){const f=this.n.getNotebookDocument(l.uri),S=l.getCells().find(P=>{const W=f.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const y=new c(D,f,this.a),C=y.onDidChangeState(()=>{y.state===v.Resolved&&(y.dispose(),C.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[y,C]),y.asApiObject()}};e.$Alc=a,e.$Alc=a=Je([We(4,T.$Tj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.m=D,this.n=f,this.b=t.a++,this.c=new O.$_d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$je),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new r.$jw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const f=d.$hO.ensureUniqueMimeTypes(D.items,!0);return f===D.items?b.NotebookCellOutput.from(D):b.NotebookCellOutput.from({items:f,id:D.id,metadata:D.metadata})})}async z(l,D,f){const S=this.w(D),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:f,outputs:y})}async C(l,D,f){return l=d.$hO.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:D.id,append:f})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(f){l.j=f,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(f){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,S,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new r.$jw({runEndTime:S,lastRunSuccess:f,error:C}))},clearOutput(f){return l.t(),l.z([],f,!1)},appendOutput(f,S){return l.t(),l.z(f,S,!0)},replaceOutput(f,S){return l.t(),l.z(f,S,!1)},appendOutputItems(f,S){return l.t(),l.C(f,S,!0)},replaceOutputItems(f,S){return l.t(),l.C(f,S,!1)}})}}var v;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(v||(v={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.h=D,this.j=f,this.b=c.a++,this.c=new O.$_d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new R.$je),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new N.$Kh,this.b=Date.now(),(0,N.$oh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function w(p,l){return`${p.value}/${l}`}}),define(Re[51],Ae([1,0,5,4,3,2,16,6,7,172,14,201,24,35,202,41,11,8,32]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,R.$ni)("IExtHostTerminalService");class i extends m.$Uc{constructor(f,S,y,C){super(),this.u=f,this._id=S,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$_d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(W,V=!0){P.C(),P.u.$sendText(P._id,W,V)},show(W){P.C(),P.u.$show(P._id,W)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??S?.cwd??void 0,env:f.env??void 0,icon:w(f.iconPath)??void 0,color:n.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(f.location,S?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,S,y,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:n.ThemeColor.isThemeColor(P)?P.id:void 0,location:S?.location||this.z(f,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,S){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in f?{viewColumn:s.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,S){this.j=Object.freeze({code:f,reason:S})}setDimensions(f,S){return f===this.f&&S===this.h||f===0||S===0?!1:(this.f=f,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(S=>{S!==f&&(this.b=Promise.resolve(f))})}}e.$Mkc=i;class a{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$_d,this.onProcessData=this.a.event,this.b=new I.$_d,this.d=new I.$_d,this.onDidChangeProperty=this.d.event,this.f=new I.$_d,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,S){this.g.setDimensions?.({columns:f,rows:S})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$_d,this.onDidCloseTerminal=this.H.event,this.I=new I.$_d,this.onDidOpenTerminal=this.I.event,this.J=new I.$_d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$_d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$_d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$_d,this.onDidChangeShell=this.N.event,this.O=new I.$_d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$_d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$MM.MainThreadTerminalService),this.y=new d.$Csb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:C=>{const P=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=P(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,S){const y=new i(this.a,(0,b.$Jg)(),f,f.name),C=new a(f.pty);return y.createExtensionTerminal(f.location,S,this.R(f,S).resolvedExtHostIdentifier,w(f.iconPath),p(f.color)).then(P=>{const W=this.S(P,C);this.h[P]=W}),this.f.push(y),y.value}R(f,S){if(S=S||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const y=f.location.parentTerminal;if(y){const C=this.f.find(P=>P.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?S.location=f.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(f,S){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new a(S),P=this.S(f,C);this.h[f]=P}async $acceptActiveTerminalChanged(f){const S=this.b;if(f===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(f);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,S){const y=this.getTerminalById(f);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(f,S,y){const C=this.getTerminalById(f);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(f,S){const y=this.getTerminalById(f);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(f,S,y){this.g.get(f)?.resize(S,y)}async $acceptTerminalTitleChange(f,S){const y=this.getTerminalById(f);y&&(y.name=S)}async $acceptTerminalClosed(f,S,y){const C=this.X(this.f,f);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(S,y),this.H.fire(P.value)}}$acceptTerminalOpened(f,S,y,C){if(S){const V=this.X(this.f,S);if(V!==null){this.f[V]._id=f,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new i(this.a,f,P,y);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,S){this.getTerminalById(f)?._setProcessId(S)}async $startExtensionTerminal(f,S){const y=this.getTerminalById(f);if(!y)return{message:(0,E.localize)(0,null,f)};y.isOpen||await new Promise(P=>{const W=this.onDidOpenTerminal(async V=>{V===y.value&&(W.dispose(),P())})});const C=this.g.get(f);C?C.startSendingEvents(S):this.j[f]={initialDimensions:S}}S(f,S){const y=new m.$Tc;y.add(S.onProcessReady(P=>this.a.$sendProcessReady(f,P.pid,P.cwd,P.windowsPty))),y.add(S.onDidChangeProperty(P=>this.a.$sendProcessProperty(f,P))),this.y.startBuffering(f,S.onProcessData),y.add(S.onProcessExit(P=>this.U(f,P))),this.g.set(f,S);const C=this.j[f];return C&&S instanceof a&&(S.startSendingEvents(C.initialDimensions),delete this.j[f]),y}$acceptProcessAckDataEvent(f,S){this.g.get(f)?.acknowledgeDataEvent(S)}$acceptProcessInput(f,S){this.g.get(f)?.input(S)}$acceptTerminalInteraction(f){const S=this.getTerminalById(f);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(f,S){this.getTerminalById(f)?.setSelection(S)}$acceptProcessResize(f,S,y){try{this.g.get(f)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,S){this.g.get(f)?.shutdown(S)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(S=>this.a.$sendProcessProperty(f,{type:"cwd",value:S}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$OM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,f.identifier.value),new g.$OM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(f,S,y){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,y),this.a.$registerQuickFixProvider(f,S),new g.$OM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,S){const y=new u.$je().token;if(y.isCancellationRequested)return;const C=this.D.get(f);if(!C)return;const P=await C.provideTerminalQuickFixes(S,y);if(P===null||Array.isArray(P)&&P.length===0)return;const W=new m.$Tc;if(this.w.value=W,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this.Q.converter,W):void 0;const V=[];for(const q of P){const A=s.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal(f,S){const y=new u.$je().token;let C=await this.C.get(f)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(f,S){const y=this.getTerminalById(f);if(!y)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const P=new u.$je;this.G.set(f,P);const W=[],V={terminal:y.value,line:S},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const U=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:h++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return U.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(f,U),W}$activateLink(f,S){const y=this.F.get(f)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(f,S){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const y=this.h[f];y&&(y.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,S)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const S=this.f.findIndex(y=>y.value===f);return S>=0?S:null}W(f,S){const y=this.X(f,S);return y!==null?f[y]:null}X(f,S){const y=f.findIndex(C=>C._id===S);return y>=0?y:null}getEnvironmentVariableCollection(f){let S=this.n.get(f.identifier.value);return S||(S=new v,this.Z(f.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(f,S){const y=(0,k.$_r)(S.map),C=(0,k.$as)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(f,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(f){f.forEach(S=>{const y=S[0],C=new v(S[1]);this.Z(y,C)})}$acceptDefaultProfile(f,S){const y=this.s;this.s=f,this.u=S,y?.path!==f.path&&this.N.fire(f.path)}Z(f,S){this.n.set(f,S),S.onDidChangeCollection(()=>{this.Y(f,S)})}};e.$Nkc=t,e.$Nkc=t=Je([We(1,r.$tP),We(2,M.$0O)],t);class v{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$_d,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const S=this.h(f);let y=this.a.get(S);return y||(y=new c(this,f),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(f,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(f,S.scope),C=this.map.get(y),P=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const W=this.g(f,S.scope),V={variable:f,...S,options:P};this.map.set(W,V),this.d.fire()}}get(f,S){const y=this.g(f,S),C=this.map.get(y);return C?l(C):void 0}g(f,S){const y=this.h(S);return y.length?`${f}:::${y}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(f)&&S.set(C.variable,l(C));return S}delete(f,S){const y=this.g(f,S);this.map.delete(y),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(S);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==f){let P;typeof f=="string"?P=f:P=f?.value.split(`

`)[0];const W={description:P,scope:S};this.descriptionMap.set(y,W),this.d.fire()}}getDescription(f){const S=this.h(f);return this.descriptionMap.get(S)?.description}k(f){const S=this.h(f);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,S){this.b=f,this.d=S,this.a=new I.$_d}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,S,y){this.b.replace(f,S,y,this.d)}append(f,S,y){this.b.append(f,S,y,this.d)}prepend(f,S,y){this.b.prepend(f,S,y,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,S){this.b.getVariableMap(this.d).forEach((y,C)=>f.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(f,S){super(!1,f,S)}createTerminal(f,S,y){throw new T.$_}createTerminalFromOptions(f,S){throw new T.$_}};e.$Okc=$,e.$Okc=$=Je([We(0,r.$tP),We(1,M.$0O)],$);function w(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return n.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Re[114],Ae([1,0,6,3,4,16,51,5,2,11]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=void 0,e.$Slc=(0,N.$ni)("IExtHostTerminalShellIntegration");let T=class extends I.$Uc{constructor(n,o){super(),this.h=o,this.b=new Map,this.c=new m.$_d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$_d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$_d,this.onDidEndTerminalShellExecution=this.g.event,this.a=n.getProxy(R.$MM.MainThreadTerminalShellIntegration),this.B((0,I.$Sc)(()=>{for(const[s,r]of this.b)r.dispose();this.b.clear()}))}$shellIntegrationChange(n){const o=this.h.getTerminalById(n);if(!o)return;const s=o.value;let r=this.b.get(n);r||(r=new k(o.value,this.f),this.b.set(n,r),r.store.add(o.onWillDispose(()=>this.b.get(n)?.dispose())),r.store.add(r.onDidRequestShellExecution(i=>this.a.$executeCommand(n,i))),r.store.add(r.onDidRequestEndExecution(i=>this.g.fire(i))),r.store.add(r.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),o.shellIntegration=r.value),this.c.fire({terminal:s,shellIntegration:r.value})}$shellExecutionStart(n,o,s){this.b.has(n)||this.$shellIntegrationChange(n),this.b.get(n)?.startShellExecution(o,s)}$shellExecutionEnd(n,o,s){this.b.get(n)?.endShellExecution(o,s)}$shellExecutionData(n,o){this.b.get(n)?.emitData(o)}$cwdChange(n,o){this.b.get(n)?.setCwd(o)}$closeTerminal(n){this.b.get(n)?.dispose(),this.b.delete(n)}};e.$Tlc=T,e.$Tlc=T=Je([We(0,O.$0O),We(1,M.$Lkc)],T);class k extends I.$Uc{get currentExecution(){return this.a}constructor(n,o){super(),this.j=n,this.m=o,this.b=!1,this.store=this.B(new I.$Tc),this.f=this.B(new m.$_d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$_d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$_d),this.onDidRequestEndExecution=this.h.event;const s=this;this.value={get cwd(){return s.c},executeCommand(r){s.g.fire(r);const i=s.startShellExecution(r,s.c,!0).value;return s.b=!0,i}}}startShellExecution(n,o,s){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const r=this.a=new u(this.j,n,o);s?queueMicrotask(()=>this.m.fire(r.value)):this.m.fire(this.a.value)}return this.a}emitData(n){this.currentExecution?.emitData(n)}endShellExecution(n,o){this.a&&(this.a.endExecution(n,o),this.h.fire({execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(n){let o=!1;g.URI.isUri(this.c)?o=!g.URI.isUri(n)||this.c.toString()!==n.toString():this.c!==n&&(o=!0),o&&(this.c=n,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class u{constructor(n,o,s){this.terminal=n,this.c=o,this.cwd=s,this.b=!1;const r=this;this.value={get terminal(){return r.terminal},get commandLine(){return r.c},get cwd(){return r.cwd},readData(){return r.d()}}}d(){if(!this.a){if(this.b)return E.$Nh.EMPTY;this.a=new b}return this.a.createIterable()}emitData(n){this.a?.emitData(n)}endExecution(n,o){n&&(this.c=n),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends I.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const n=this.a=new E.$mh;return new E.$Nh(async s=>{this.b.push(s),await n.wait()})}emitData(n){for(const o of this.b)o.emitOne(n)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[279],Ae([1,0,11,22,24,5,251,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=e.$Vlc=e.$Ulc=void 0;let a=class extends g.$Uc{constructor(P,W,V,q){super(),this.w=q,this.f=this.B(new O.$_d),this.g=new Map,this.s=this.B(new O.$_d),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(u.$MM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const U=A,K=U.tests[U.tests.length-1].item.extId;return this.g.get(s.$yL.root(K))?.collection.tree.get(K)?.actual??(0,d.$jP)(A)}case 18:{const{test:U,message:K}=A,ie=U.item.extId;return{test:this.g.get(s.$yL.root(ie))?.collection.tree.get(ie)?.actual??(0,d.$jP)({$mid:16,tests:[U]}),message:n.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),U=K=>{const ie=this.g.get(s.$yL.root(K));if(ie)return s.$yL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:A?.include.map(U).filter(E.$9f)||[],exclude:A?.exclude.map(U).filter(E.$9f)||[]}})}createTestController(P,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new g.$Tc,U=A.add(new d.$mP(W,V,this.w));U.root.label=V;const K=new Map,ie=new Set,ce=this.h,we={items:U.root.children,get label(){return V},set label(ue){V=ue,U.root.label=ue,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,pe,re,Se,Le,ne)=>{let j=(0,m.$bj)(ue);for(;K.has(j);)j++;return new S(this.h,K,ie,this.s.event,W,j,ue,pe,re,Se,Le,ne)},createTestItem(ue,pe,re){return new d.$kP(W,ue,pe,re)},createTestRun:(ue,pe,re=!0)=>this.j.createTestRun(W,U,ue,pe,re),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const pe=ue instanceof Array?ue:[ue];this.h.$markTestRetired(pe.map(re=>s.$yL.fromExtHostTestItem(re,W).toString()))}},set resolveHandler(ue){U.resolveHandler=ue},get resolveHandler(){return U.resolveHandler},dispose:()=>{A.dispose()}};ce.$registerTestController(W,V,!!q),A.add((0,g.$Sc)(()=>ce.$unregisterTestController(W)));const Ie={controller:we,collection:U,profiles:K,extension:P,activeProfiles:ie};return this.g.set(W,Ie),A.add((0,g.$Sc)(()=>this.g.delete(W))),A.add(U.onDidGenerateDiff(ue=>ce.$publishDiff(W,ue.map(i.TestsDiffOp.serialize)))),we}createTestObserver(){return this.m.checkout()}async runTests(P,W=R.CancellationToken.None){const V=$(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(A=>s.$yL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,W){return(await this.j.getCoverageDetails(P,W))?.map(n.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,W){this.g.get(P)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(P){const W=new Map;for(const[V,q]of Object.entries(P)){const A=this.g.get(V);if(!A)continue;const U=new Map,K=q.filter(ce=>!A.activeProfiles.has(ce)),ie=[...A.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)U.set(ce,!0),A.activeProfiles.add(ce);for(const ce of ie)U.set(ce,!1),A.activeProfiles.delete(ce);U.size&&W.set(V,U)}this.s.fire(W)}async $refreshTests(P,W){await this.g.get(P)?.controller.refreshHandler?.(W)}$publishTestResults(P){this.results=Object.freeze(P.map(n.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,W){const V=this.g.get(s.$yL.fromString(P).controllerId)?.collection;V&&(await V.expand(P,W<0?1/0:W),V.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(P,W){return Promise.all(P.map(V=>this.y(V,!1,W)))}async $startContinuousRun(P,W){const V=new R.$je(W),q=await Promise.all(P.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(P,W,V){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:A,profiles:U}=q,K=U.get(P.profileId);if(!K)return{};const ie=P.testIds.map(ue=>A.tree.get(ue)).filter(E.$9f),ce=P.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(E.$9f).filter(ue=>ie.some(pe=>pe.fullId.compare(ue.fullId)===2));if(!ie.length)return{};const we=new o.$oO(ie.some(ue=>ue.actual instanceof d.$lP)?void 0:ie.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,W),Ie=(0,i.$BL)(P)&&this.j.prepareForMainThreadTestRun(we,w.fromInternal(P,q.collection),K,V);try{return await K.runHandler(we,V),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!V.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$Ulc=a,e.$Ulc=a=Je([We(0,b.$0O),We(1,k.$Tj)],a);const h=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class v extends g.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,W,V,q,A){super(),this.y=P,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$_d),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$je(A));const U=this.B(new I.$zh(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>U.schedule()));const K=new O.$_d;this.s=K.event,this.B((0,g.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,W){const[,V,q]=s.$yL.fromString(P).path,A=this.w.get(q);if(!A)return[];const U=this.g.get(V);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,A,W)??[]}createRun(P){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Jg)(),A=ce=>(we,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.y.isIncluded(we)&&(this.H(we),ce(we,...Ie))},U=(ce,we)=>{const Ie=we instanceof Array?we.map(n.TestMessage.from):[n.TestMessage.from(we)];if(ce.uri&&ce.range){const ue={range:n.Range.from(ce.range),uri:ce.uri};for(const pe of Ie)pe.location=pe.location||ue}this.z.$appendTestMessagesInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),Ie)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const we=ce.uri.toString(),Ie=new s.$yL([W,q,we]).toString();this.w.set(we,ce),this.z.$appendCoverage(W,q,n.TestCoverage.fromFile(Ie,ce))},enqueued:A(ce=>{this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),1)}),skipped:A(ce=>{this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),5)}),started:A(ce=>{this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),2)}),errored:A((ce,we,Ie)=>{U(ce,we),this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),6,Ie)}),failed:A((ce,we,Ie)=>{U(ce,we),this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,V).toString(),4,Ie)}),passed:A((ce,we)=>{this.z.$updateTestStateInRun(W,q,s.$yL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,we)}),appendOutput:(ce,we,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(W,q,N.$ze.fromString(ce),we&&n.location.from(we),Ie&&s.$yL.fromExtHostTestItem(Ie,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:P,running:!0}),ie}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof d.$kP))throw new r.$2O(P.id);if(this.h.has(s.$yL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=n.TestItem.from(P);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===V))break;P=P.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(P,W){this.g=P,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(P,W){const V=s.$yL.root(P);return this.f.get(V)?.getCoverageDetails(P,W)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[W,{id:V}]of this.c)V===P&&this.c.delete(W)}prepareForMainThreadTestRun(P,W,V,q){return this.j(P,W,V,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,W,V,q,A){const U=this.c.get(V);if(U)return U.createRun(q);const K=w.fromPublic(P,W,V,A),ie=$(V);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:ie&&{group:y[ie.kind],id:ie.profileId},exclude:V.exclude?.map(we=>s.$yL.fromExtHostTestItem(we,W.root.id).toString())??[],id:K.id,include:V.include?.map(we=>s.$yL.fromExtHostTestItem(we,W.root.id).toString())??[W.root.id],persist:A});const ce=this.j(V,K,V.profile);return O.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,W,V,q){const A=new v(W,this.g,this.h,V,q);return this.c.set(P,A),this.f.set(A.id,A),A}}e.$Vlc=c;const $=C=>{if(C.profile){if(!(C.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class w{static fromPublic(P,W,V,q){return new w(P,(0,T.$Jg)(),V.include?.map(A=>s.$yL.fromExtHostTestItem(A,P).toString())??[P],V.exclude?.map(A=>s.$yL.fromExtHostTestItem(A,P).toString())??[],q,W)}static fromInternal(P,W){return new w(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,W)}constructor(P,W,V,q,A,U){this.controllerId=P,this.id=W,this.isPersisted=A,this.colllection=U,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const W=s.$yL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$Wlc=w;class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,n.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const W=s.$yL.parentId(P.item.extId);if(W&&this.h.has(W.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:W,g:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends i.$HL{constructor(){super(...arguments),this.s=new O.$_d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,W){return{...P,revived:n.TestItem.toPlain(P.item),depth:W?W.depth+1:0,children:new Set}}v(){return new p(this.s)}}class D{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new l({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const f=(C,P,W,V)=>{W?Object.assign(W,V):P.$updateTestRunConfig(C.controllerId,C.profileId,V)};class S{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,f(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,f(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,f(this,this.#e,this.#n,{tag:P?n.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,f(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$9f))}constructor(P,W,V,q,A,U,K,ie,ce,we=!1,Ie=void 0,ue=!1){this.controllerId=A,this.profileId=U,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=P,this.#s=W,this.#t=V,this.#i=q,W.set(U,this);const pe=y[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);we&&V.add(U),this.#n={profileId:U,controllerId:A,tag:Ie?n.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:pe,isDefault:we,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Xlc=S;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Re[115],Ae([1,0,56,14,90,8,7]),function(ge,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=e.$eP=void 0;class m{static{this.c=new R.$cP("TextEditorDecorationType")}constructor(u,b,d){const n=m.c.nextId();u.$registerTextEditorDecorationType(b.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$eP=m;class g{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let d=null;if(u instanceof M.$PM)d=new M.$QM(u,u);else if(u instanceof M.$QM)d=u;else throw new Error("Unrecognized location");this.l(d,b,!1)}insert(u,b){this.k(),this.l(new M.$QM(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof M.$QM)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,d){const n=this.c.validateRange(u);this.g.push({range:n,text:b,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=u}}class E{constructor(u,b,d,n){this.c=u,this.d=b,this._accept(d),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}n(u){const b=this.m(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}p(u){const b=this.o(u);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const b=this.q(u);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,b.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,b.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,b.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,b.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,b.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,b.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,b.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(u,b){b.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$fP=E;class T{constructor(u,b,d,n,o,s,r,i){this.id=u,this.j=b,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,d),this.e=r,this.f=i;const a=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new N.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof M.$RM))throw(0,N.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$RM)))throw(0,N.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new N.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new N.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new g(n.value,t);return h(v),a.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>O.Range.from($));else if(t instanceof M.$PM){const{lineNumber:$,column:w}=O.Position.from(t);c=[{startLineNumber:$,startColumn:w,endLineNumber:$,endColumn:w}]}else if(t instanceof M.$QM)c=[O.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof M.$QM)c.push(O.Range.from($));else{const{lineNumber:w,column:p}=O.Position.from($);c.push({startLineNumber:w,startColumn:p,endLineNumber:w,endColumn:p})}}return b.$tryInsertSnippet(u,n.value.version,h.value,c,v)},setDecorations(h,t){const v=t.length===0;v&&!a.h.has(h.key)||(v?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(O.$7O(t))return b.$trySetDecorations(u,h.key,O.$8O(t));{const c=new Array(4*t.length);for(let $=0,w=t.length;$<w;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return b.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>b.$tryRevealRange(u,O.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(u,O.ViewColumn.from(h))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const d=b.edits.map(o=>o.range);d.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=d.length-1;o<s;o++){const r=d[o].end;if(d[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=b.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,n,{setEndOfLine:typeof b.setEndOfLine=="number"?O.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$gP=T}),define(Re[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,46,40]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new N.$_d,this.e=new N.$_d,this.f=new N.$_d,this.g=new N.$_d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],v=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=O.URI.revive(c),w=this.c.get($);w?.unref()&&(this.c.delete($),h.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=O.URI.revive(c.uri);let w=this.c.get($);if(w&&$.scheme!==d.Schemas.vscodeNotebookCell&&$.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);w||(w=new s(new g.$aP(this.h.getProxy(m.$MM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,w),t.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&v.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=O.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get($).value,p=new T.$gP(c.id,this.h.getProxy(m.$MM.MainThreadTextEditors),this.i,new o.$V(()=>w.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map(l=>k.Range.to(l)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,R.$Pc)(h),(0,R.$Pc)(v),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return n.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$hP=r,e.$hP=r=Je([We(0,E.$0O),We(1,u.$Tj)],r),e.$iP=(0,M.$ni)("IExtHostDocumentsAndEditors")}),define(Re[280],Ae([1,0,18,5,4,115,8,7]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class g{constructor(T,k){this.i=k,this.a=new N.$_d,this.b=new N.$_d,this.c=new N.$_d,this.d=new N.$_d,this.f=new N.$_d,this.g=new N.$_d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$MM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const k=this.i.allEditors();return T?k:k.map(u=>u.value)}async showTextDocument(T,k,u){let b;typeof k=="number"?b={position:M.ViewColumn.from(k),preserveFocus:u}:typeof k=="object"?b={position:M.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?M.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:b={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(T.uri,b),n=d&&this.i.getEditor(d);if(n)return n.value;throw d?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,k){return new O.$eP(this.h,T,k).value}$acceptEditorPropertiesChanged(T,k){const u=this.i.getEditor(T);if(!u)throw new Error("unknown text editor");if(k.options&&u._acceptOptions(k.options),k.selections){const b=k.selections.selections.map(M.Selection.to);u._acceptSelections(b)}if(k.visibleRanges){const b=I.$Hb(k.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(b)}if(k.options&&this.b.fire({textEditor:u.value,options:{...k.options,lineNumbers:M.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const b=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:d,kind:b})}if(k.visibleRanges){const b=I.$Hb(k.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const k in T){const u=this.i.getEditor(k);if(!u)throw new Error("Unknown text editor");const b=M.ViewColumn.to(T[k]);u.value.viewColumn!==b&&(u._acceptViewColumn(b),this.d.fire({textEditor:u.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$ekc=g}),define(Re[281],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=e.$Zlc=void 0,e.$Zlc=(0,N.$ni)("IExtHostTimeline");class T{constructor(b,d){this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$MM.MainThreadTimeline),d.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&g.$Im.equals(o,this.b.get(n.source)?.extension)){const s=n.uri===void 0?void 0:I.URI.revive(n.uri);return this.c.get(n.source)?.get(k(s))?.get(n.handle)}else return;return n}})}async $getTimeline(b,d,n,o){return this.b.get(b)?.provider.provideTimeline(I.URI.revive(d),n,o)}registerTimelineProvider(b,d,n,o){const s=new O.$Tc,r=this.d(d.id,o,s).bind(this);let i;d.onDidChange&&(i=d.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:d.id}),this));const a=this.c;return this.f({...d,scheme:b,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),a.get(d.id)?.clear());const c=await d.provideTimeline(h,t,v);if(c==null)return;const $=r(h,t);return{...c,source:d.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(d.id)?.clear();i?.dispose(),s.dispose()}},n)}d(b,d,n){return(o,s)=>{let r;if(s?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const a=k(o);r=i.get(a),r===void 0&&(r=new Map,i.set(a,r))}return i=>{const{iconPath:a,...h}=i,t=`${b}|${i.id??i.timestamp}`;r?.set(t,i);let v,c,$;i.iconPath&&(a instanceof M.$KN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,c=a):{light:v,dark:c}=a);let w;return M.$dN.isMarkdownString(h.tooltip)?w=m.MarkdownString.from(h.tooltip):(0,E.$1f)(h.tooltip)?w=h.tooltip:M.$dN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=m.MarkdownString.from(h.detail)):(0,E.$1f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.detail),{...h,id:h.id??void 0,handle:t,source:b,command:i.command?d.toInternal(i.command,n):void 0,icon:v,iconDark:c,themeIcon:$,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,d){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:d}),(0,O.$Sc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$1lc=T;function k(u){return u?.toString()}}),define(Re[282],Ae([1,0,173,23,2,5,6,212,11,7,17,18,8,54,24,137,25]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;function s(a,h){if((0,T.$1f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class r extends M.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new n.$I0;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(w=>c(w)?this.r(w):w):$})}registerTreeDataProvider(h,t,v){const c=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>c.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,v),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:w,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$vG)(v,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$vG)(v,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,b.$Mk)(y)&&(0,o.$vG)(v,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,C)=>l.reveal(y,C),dispose:async()=>{await f,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new m.$KF(h))}async $handleDrop(h,t,v,c,$,w,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new m.$KF(h));const f=u.DataTransfer.toDataTransfer(v,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(f,D,l,$,w),D.onDrop(f,c,$)}async j(h,t,v,c,$){const w=this.b.removeDragOperationTransfer($);if(w)(await w)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(v,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,v,c){const $=this.a.get(h);if(!$)return Promise.reject(new m.$KF(h));const w=await this.j(new E.$GN,$,t,c,v);if(!(!w||c.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$KF(h);return t.hasResolve}$resolve(h,t,v){const c=this.a.get(h);if(!c)throw new m.$KF(h);return c.resolveTreeItem(t,v)}$setExpanded(h,t,v){const c=this.a.get(h);if(!c)throw new m.$KF(h);c.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const c=this.a.get(h);if(!c)throw new m.$KF(h);c.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new m.$KF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new m.$KF(h);v.setCheckboxState(t)}m(h,t,v){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$2lc=r;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,T.$0f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,c,$,w){if(super(),this.I=h,this.J=v,this.L=c,this.M=$,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$_d),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$_d),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$_d),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$_d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$_d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$_d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$_d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$je,w.contributes&&w.contributes.views)for(const f in w.contributes.views)for(const S of w.contributes.views[f])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let p,l;const D=O.Event.debounce(this.F.event,(f,S)=>(f||(f={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(y=>l=y),this.G=this.G.then(()=>p)),Array.isArray(S.element)?f.elements.push(...S.element):f.elements.push(S.element)),S.message&&(f.message=!0),f),200,!0);this.B(D(({message:f,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=l;return p=null,this.$(S).then(()=>y())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,T.$0f)(t.select)?!0:t.select,c=(0,T.$0f)(t.focus)?!1:t.focus,$=(0,T.$0f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(w=>this.W(h,w[w.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:w.map(l=>l.item)},{select:v,focus:c,expand:$})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:v,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,k.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const c=this.getExtensionElement(v.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const c=[];for(const $ of h){const w=this.getExtensionElement($);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,g.$fh)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const c=this.m.get(v);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,v,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,g.$fh)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,g.$fh)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const w=this.m.get($);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new d.$je(this.Z.token);try{const v=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,k.$Hb)(c||[]),w=await Promise.all((0,k.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=w.map((l,D)=>l?this.db($[D],l,v):null);return(0,k.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new d.$je,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map($=>this.m.get($));for(const $ of v)if($&&!t.has($.item.handle)){let w=$;for(;w&&w.parent&&v.findIndex(p=>w&&w.parent&&p&&p.item.handle===w.parent.item.handle)===-1;){const p=this.j.get(w.parent.item.handle);w=p?this.m.get(p):void 0}w&&!w.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const w=this.j.get($);if(w){const p=this.m.get(w);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(c=>{c&&(t[v]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,g.$fh)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,v.parent);return this.pb(t,$,v,v.parent),v.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,v){const c=this.ib(h,t,v);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,v),c}eb(h){return E.$dN.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:c}}hb(h){if(!E.$BN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const c=this.B(new M.$Tc),$=this.kb(h,t,v),w=this.lb(t);return{item:{handle:$,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,T.$0f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof E.$KN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:c},$,w){if(t)return`${i.b}/${t}`;const p=s(v,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,N.$Xg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let y,C=0;do{if(y=`${l}/${C}:${D}`,w||!this.j.has(y)||f===y)break;C++}while(C<=S.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$KN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$KN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const $=this.X(c)||[],w=$.filter(p=>p.item.handle===v.item.handle)[0];w&&$.splice($.indexOf(w),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[283],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,N,R,O,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;class T extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$_d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$_d),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,R.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:M.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends N.$Uc{static c(){return(0,O.$Jg)()}constructor(d,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(g.$MM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,o,s,r={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$tkc)(d),t=k.c();this.f.$createWebviewPanel((0,m.$vkc)(d),t,n,{title:o,panelOptions:u(r),webviewOptions:(0,m.$wkc)(d,this.m,r),serializeBuffersForPostMessage:h},a);const v=this.j.createNewWebview(t,r,d);return this.createNewWebviewPanel(t,n,o,i,r,v,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((o,s)=>{const r=d[o],i=d[s];return r.active?1:i.active?-1:+r.visible-+i.visible});for(const o of n){const s=this.getWebviewPanel(o);if(!s)continue;const r=d[o];s._updateViewState({active:r.active,visible:r.visible,viewColumn:M.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,m.$tkc)(d)}),new E.$OM(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,o,s){const r=this.h.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:a}=r,h=this.j.createNewWebview(d,o.webviewOptions,a),t=this.createNewWebviewPanel(d,n,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,n,o,s,r,i,a){const h=new T(d,this.f,i,{viewType:n,title:o,viewColumn:s,panelOptions:r,active:a});return this.g.set(d,h),h}getWebviewPanel(d){return this.g.get(d)}}e.$xkc=k;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Re[284],Ae([1,0,5,6,63,8,4,7]),function(ge,e,I,N,R,O,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class g extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,u,b,d,n,o){super(),this.#s=!1,this.#u=this.B(new I.$_d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$_d),this.onDidDispose=this.#l.event,this.#i=b,this.#a=d,this.#e=k,this.#t=u,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(k,u){this.d=u,this.b=new Map,this.c=new Map,this.a=k.getProxy(M.$MM.MainThreadWebviewViews)}registerWebviewViewProvider(k,u,b,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,R.$vkc)(k),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$tkc)(k)}),new m.$OM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(k,u,b,d,n){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:r}=o,i=this.d.createNewWebview(k,{},r),a=new g(k,this.a,u,b,i,!0);this.c.set(k,a),await s.resolveWebviewView(a,{state:d},n)}async $onDidChangeWebviewViewVisibility(k,u){this.e(k)._setVisible(u)}async $disposeWebviewView(k){const u=this.e(k);this.c.delete(k),u.dispose(),this.d.deleteWebview(k)}e(k){const u=this.c.get(k);if(!u)throw new Error("No webview found");return u}}e.$5lc=E}),define(Re[285],Ae([1,0,5,30,31,3]),function(ge,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=e.OutputChannelUpdateMode=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0,e.$UL="text/x-code-output",e.$VL="output",e.$WL="Log",e.$XL="text/x-code-log-output",e.$YL="log",e.$ZL="workbench.panel.output",e.$1L=new R.$Ej("inOutput",!1),e.$2L=new R.$Ej("activeLogOutput",!1),e.$3L=new R.$Ej("activeLogOutput.levelSettable",!1),e.$4L=new R.$Ej("activeLogOutput.level",""),e.$5L=new R.$Ej("activeLogOutput.levelIsDefault",!1),e.$6L=new R.$Ej("outputView.scrollLock",!1),e.$7L=(0,O.$ni)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$8L={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new I.$_d,this.onDidRegisterChannel=this.b.event,this.c=new I.$_d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$6n.add(e.$8L.OutputChannels,new m),e.$9L=new R.$Ej("activeOutputChannel","")}),define(Re[116],Ae([1,0,4,3,16,20,13,285,64,27,44,141,22,17,43,5,6]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=e.$Dlc=void 0;class s extends M.$Zj{get disposed(){return this.n}constructor(h,t,v,c,$){super(),this.id=h,this.name=t,this.r=v,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ze.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,c,$,w){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$MM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,b.$1f)(t)?t:void 0;if((0,b.$1f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const p=this.i.environment.extensionLogLevel?.find(([D])=>O.$Im.equals(v.identifier,D))?.[1];p&&(w=(0,M.$$j)(p));const l=c?this.o(h,w,v):this.n(h,$,v);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,w??this.m.getLevel(),l):this.q(h,l)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,v.identifier.value);return new s(p,h,w,this.a,v)}async o(h,t,v){const c=await this.p(v),$=h.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${$}.log`),p=`${v.identifier.value}.${$}`,l=this.l.createLogger(w,{id:p,name:h,logLevel:t,extensionId:v.identifier.value});return new r(p,h,l,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(c){if((0,d.$0k)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}return v})())}return t}q(h,t){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(w=>w.append($))},appendLine($){c(),t.then(w=>w.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(w=>w.replace($))},show($,w){c(),t.then(p=>p.show($,w))},hide(){c(),t.then($=>$.hide())},dispose(){v=!0,t.then($=>$.dispose())}}}r(h,t,v){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new n.$_d);function p(l){t=l,w.fire(l)}return v.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(l,...D){$(),v.then(f=>f.trace(l,...D))},debug(l,...D){$(),v.then(f=>f.debug(l,...D))},info(l,...D){$(),v.then(f=>f.info(l,...D))},warn(l,...D){$(),v.then(f=>f.warn(l,...D))},error(l,...D){$(),v.then(f=>f.error(l,...D))},dispose(){c.dispose()}}}};e.$Dlc=i,e.$Dlc=i=Je([We(0,R.$0O),We(1,E.$nP),We(2,g.$pkc),We(3,T.$5jc),We(4,M.$Uj),We(5,M.$Tj)],i),e.$Elc=(0,N.$ni)("IExtHostOutputService")}),define(Re[117],Ae([1,0,3,11]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$0m=(0,I.$ni)("remoteAgentService"),e.$$m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let O=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await R.getRoundTripTime();if(g===void 0)return;O=Math.min(O,g/2),await(0,N.$oh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[286],Ae([1,0,176,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$nJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$oJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$pJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$qJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$rJ={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new g.$_d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const d=new b;R.$6n.add(e.$rJ.ConfigurationMigration,d);let n=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,i){super(),this.a=r,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,d.migrations)})),this.c(d.migrations),this.B(d.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const i of this.b.getWorkspace().folders)await this.f(i,r)}async f(r,i){await Promise.all([i.map(a=>this.g(a,r?.uri))])}async g(r,i){const a=this.a.inspect(r.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const w=await this.h(r,t,c.value,i,void 0);for(const p of w??[])$.push([p,[]])}for(const{identifiers:w,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(r,t,p,i,w);for(const D of l??[])$.push([D,w])}$.length&&await Promise.allSettled($.map(async([[w,p],l])=>this.a.updateValue(w,p.value,{resource:i,overrideIdentifiers:l},v)))}}async h(r,i,a,h,t){const v=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,k.$Xn)(l,t))?.value:p.value},c=await r.migrateFn(a,v);return Array.isArray(c)?c:[[r.key,c]]}};e.$sJ=n,e.$sJ=n=Je([We(0,M.$Ti),We(1,O.$wi)],n);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$Kh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$6n.as(N.$$n.Configuration).registerConfiguration({...e.$pJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$tJ=o,e.$tJ=o=Je([We(0,E.$0m)],o)}),define(Re[287],Ae([1,0,36,12,19,23,185,286,57,3,30]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$ggb=e.$fgb=void 0,e.$hgb=n,e.$igb=o,e.$fgb=(0,E.$ni)("editorResolverService"),e.$ggb="workbench.editorAssociations";const k=T.$6n.as(g.$$n.Configuration),u={...m.$oJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(u);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var d;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,r){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof s=="string"&&s.indexOf(R.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,O.$Xg)(r);return I.$gk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Re[288],Ae([1,0,47,12,19,21,23,2,3,206,49,226,117]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=void 0,e.$oM=(0,g.$ni)("pathService");let d=b=class{constructor(o,s,r,i){this.d=o,this.e=s,this.f=r,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,r){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,r)}h(o,s,r){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$lg)(r??(0,M.$Xg)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const r=(0,E.$lM)(s.getWorkspace());if(r)return r;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:N.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$pM=d,e.$pM=d=b=Je([We(1,u.$0m),We(2,k.$0L),We(3,T.$wi)],d)}),define(Re[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$UK=e.$TK=void 0;class I{constructor(M,m){this.line=M,this.character=m}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,m){return new I(0,0)}with(M){return new I(0,0)}}e.$TK=I;class N{constructor(M,m,g,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,m),this.end=new I(g,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$UK=N;var R;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Re[45],Ae([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,N,R,O,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$fL=e.$$K=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$8K=e.$7K=e.$6K=e.$5K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.TextSearchCompleteMessageType=void 0,e.$2K=s,e.$3K=r,e.$4K=i,e.$9K=l,e.$0K=D,e.$_K=y,e.$aL=C,e.$bL=P,e.$cL=W,e.$dL=V,e.$eL=q,e.$gL=U,e.$iL=ce,e.$jL=we,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$VK="workbench.view.search",e.$WK="workbench.panel.search",e.$XK="workbench.view.search",e.$YK="search-result",e.$ZK="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",d=(u.length+b.length+5)*2;e.$1K=(0,m.$ni)("searchService");var n;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(ue){return!!ue.preview}function r(ue){return!!ue.resource}function i(ue){return!!ue.message}var a;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor(pe){this.resource=pe,this.results=[]}}e.$5K=h;class t{constructor(pe,re,Se,Le){this.ranges=re,this.webviewIndex=Le;const ne=Array.isArray(re)?re:[re];if(Se&&Se.matchLines===1&&v(ne)){pe=(0,M.$Tf)(pe,Se.matchLines);let j="",x=0,ve=0;const Ne=Math.floor(Se.charsPerLine/5),Ee=[];for(const $e of ne){const fe=Math.max($e.startColumn-Ne,0),Q=$e.startColumn+Se.charsPerLine;if(fe>ve+Ne+d){const X=u+(fe-ve)+b;j+=X+pe.slice(fe,Q),x+=fe-(ve+X.length)}else j+=pe.slice(ve,Q);Ee.push(new $(0,$e.startColumn-x,$e.endColumn-x)),ve=Q}this.preview={text:j,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const j=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,I.$2b)(re,x=>new c(x.startLineNumber-j,x.startColumn,x.endLineNumber-j,x.endColumn))}}}}e.$6K=t;function v(ue){const pe=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class c{constructor(pe,re,Se,Le){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Se,this.endColumn=Le}}e.$7K=c;class $ extends c{constructor(pe,re,Se){super(pe,re,pe,Se)}}e.$8K=$;var w;(function(ue){ue.List="list",ue.Tree="tree"})(w||(e.ViewMode=w={}));var p;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(ue,pe=!0){const re=ue&&ue.files&&ue.files.exclude,Se=pe&&ue&&ue.search&&ue.search.exclude;if(!re&&!Se)return;if(!re||!Se)return re||Se;let Le=Object.create(null);return Le=R.$Wn(Le,R.$Tn(re)),Le=R.$Wn(Le,R.$Tn(Se),!0),Le}function D(ue,pe){return ue.excludePattern&&N.$gk(ue.excludePattern,pe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&N.$gk(ue.includePattern,pe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const Se=re.folder.fsPath;if(O.$ng(pe,Se)){const Le=g.$mc(Se,pe);return!re.includePattern||!!N.$gk(re.includePattern,Le)}else return!1}):!1:!0}var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class S extends Error{constructor(pe,re){super(pe),this.code=re}}e.$$K=S;function y(ue){const pe=ue.message;if((0,E.$4)(ue))return new S(pe,f.canceled);try{const re=JSON.parse(pe);return new S(re.message,re.code)}catch{return new S(pe,f.other)}}function C(ue){const pe={message:ue.message,code:ue.code};return new Error(JSON.stringify(pe))}function P(ue){return ue.type==="error"?!0:ue.type==="success"}function W(ue){return ue.type==="success"}function V(ue){return!!ue.path}function q(ue,pe,re=!0){const Se=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,M.$Qf)(Se,pe):N.$gk(pe,Se)}class A{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fL=A;function U(ue,pe){const re={...ue||{},...pe||{}};return Object.keys(re).filter(Se=>{const Le=re[Se];return typeof Le=="boolean"&&Le})}class K{constructor(pe,re){this.c=null,this.a={...pe.excludePattern||{},...re.excludePattern||{}},this.b=N.$hk(this.a);let Se=pe.includePattern;re.includePattern&&(Se?Se={...Se,...re.includePattern}:Se=re.includePattern),Se&&(this.c=N.$hk(Se))}matchesExcludesSync(pe,re,Se){return!!(this.b&&this.b(pe,re,Se))}includedInQuerySync(pe,re,Se){return!(this.b&&this.b(pe,re,Se)||this.c&&!this.c(pe,re,Se))}includedInQuery(pe,re,Se){const Le=this.b(pe,re,Se),ne=()=>this.c?!!this.c(pe,re,Se):!0;return(0,k.$_g)(Le)?Le.then(j=>j?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$hL=K;function ie(ue){for(const pe in ue)if(typeof ue[pe]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let pe;return re=>(pe||(pe=(ue()||Promise.resolve([])).then(Se=>Se?Ie(Se):{})),pe.then(Se=>!!Se[re]))}function we(ue){if(!ue)return;let pe;return re=>{if(!pe){const Se=ue();pe=Se?Ie(Se):{}}return!!pe[re]}}function Ie(ue){const pe={};for(const re of ue)pe[re]=!0;return pe}}),define(Re[37],Ae([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,195,49,44,27,16,8,7,60,45,4,53]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v,c,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0;function p(W,V,q){return new T.$Pg(A=>S(A,q)).isEqual(W,V)}function l(W,V,q){return p(W.uri,V.uri,q)?0:(0,k.$jf)(W.uri.toString(),V.uri.toString())}function D(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:p(W.uri,V.uri,q)?(0,k.$jf)(W.name,V.name):(0,k.$jf)(W.uri.toString(),V.uri.toString())}function f(W,V,q,A){const U=W.slice(0).sort((ie,ce)=>q(ie,ce,A)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,A));return(0,I.$Eb)(U,K,(ie,ce)=>q(ie,ce,A))}function S(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class y extends s.$Gi{static toExtHostWorkspace(V,q,A,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:we,transient:Ie,isUntitled:ue}=V,pe=[],re=q;q?ce.forEach((j,x)=>{const ve=u.URI.revive(j.uri),Ne=y.o(A||q,ve,U);Ne?(Ne.name=j.name,Ne.index=j.index,pe.push(Ne)):pe.push({uri:ve,name:j.name,index:x})}):pe.push(...ce.map(({uri:j,name:x,index:ve})=>({uri:u.URI.revive(j),name:x,index:ve}))),pe.sort((j,x)=>j.index<x.index?-1:1);const Se=new y(K,ie,pe,!!Ie,we?u.URI.revive(we):null,!!ue,j=>S(j,U)),{added:Le,removed:ne}=f(re?re.workspaceFolders:[],Se.workspaceFolders,l,U);return{workspace:Se,added:Le,removed:ne}}static o(V,q,A){for(let U=0;U<V.folders.length;U++){const K=V.workspaceFolders[U];if(p(K.uri,q,A))return K}}constructor(V,q,A,U,K,ie,ce){super(V,A.map(we=>new s.$Hi(we)),U,K,ce),this.t=q,this.u=ie,this.q=[],this.s=m.$ti.forUris(ce),A.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$Zg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,A,U,K){this.c=new O.$_d,this.onDidChangeWorkspace=this.c.event,this.g=new O.$_d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$be,this.C=new Map,this.h=U,this.s=A,this.t=K,this.j=new E.$um,this.k=new N.$mh,this.o=V.getProxy($.$MM.MainThreadWorkspace),this.q=V.getProxy($.$MM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>S(ce,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,T.$Xg)((0,T.$Zg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...U){const K=[];if(Array.isArray(U)&&U.forEach(ue=>{u.URI.isUri(ue.uri)&&!K.some(pe=>p(pe.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,T.$Wg)(ue.uri)})}),this.n||[q,A].some(ue=>typeof ue!="number"||ue<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,A,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,T.$Wg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const pe=ce[ue];if(ce.some((re,Se)=>Se!==ue&&p(pe.uri,re.uri,this.s)))return!1}ce.forEach((ue,pe)=>ue.index=pe);const{added:we,removed:Ie}=f(ie,ce,D,this.s);if(we.length===0&&Ie.length===0)return!1;if(this.o){const ue=V.displayName||V.name;this.o.$updateWorkspaceFolders(ue,q,A,K).then(void 0,pe=>{this.n=void 0;const re={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,ue,pe.toString()),re,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,U="";if(typeof V=="string"?(A=u.URI.file(V),U=V):typeof V<"u"&&(A=V,U=V.fsPath),!A)return U;const K=this.getWorkspaceFolder(A,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$3g)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:U}=y.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:U}))}findFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,U=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,U)}async z(V,q,A,U=R.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:we,folder:Ie}=P(h.GlobPattern.from(V));ce=Ie,ie.includePattern=we}else{const{includePattern:we,folder:Ie}=P(h.GlobPattern.from(q));ce=Ie,ie.filePattern=we}return this.o.$startFileSearch(ce??null,ie,U).then(we=>Array.isArray(we)?we.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:we,folder:Ie}=P(h.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,pe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:we,excludePattern:ue},re=!1;if(this.u[ie]=Se=>{if(re)return;const Le=u.URI.revive(Se.resource);Se.results.forEach(ne=>{const j=(0,w.$Wh)(ne);(0,c.$2K)(j)?A({uri:Le,preview:{text:j.preview.text,matches:(0,I.$2b)(j.preview.matches,x=>new t.$QM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(j.ranges,x=>new t.$QM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Le,text:j.text,lineNumber:j.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(V,Ie??null,pe,ie,K);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return u.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return u.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,A),(0,M.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,A,U);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,U)=>{const K=function(ce){q.call(A,ce)};return K.extension=V,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(V,q,A){const U=await this.resolveWorkspaceFolder(u.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerCanonicalUriProvider(U,A),(0,M.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,q,A){const U=this.C.get(V.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(u.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:q},A)}};e.$jkc=C,e.$jkc=C=Je([We(0,a.$0O),We(1,i.$nP),We(2,r.$5jc),We(3,n.$Tj),We(4,v.$hkc)],C),e.$kkc=(0,d.$ni)("IExtHostWorkspace");function P(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=u.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Re[38],Ae([1,0,26,5,37,4,7,197,57,17,11,3,16,13,2]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=e.$lkc=void 0;function n(v,c){if(c){const $=c.split(".");let w=v;for(let p=0;w&&p<$.length;p++)w=w[$[p]];return w}}function o(v){return v instanceof d.URI}function s(v){return v&&v.uri instanceof d.URI&&v.languageId&&typeof v.languageId=="string"}function r(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof d.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(r(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(c,$,w){this.a=c.getProxy(O.$MM.MainThreadConfiguration),this.c=$,this.b=w,this.d=new T.$mh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,$))}};e.$lkc=h,e.$lkc=h=Je([We(0,u.$0O),We(1,R.$kkc),We(2,b.$Tj)],h);class t{constructor(c,$,w,p){this.a=new N.$_d,this.b=c,this.f=p,this.c=$,this.e=m.$ro.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$ro.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,w))}getConfiguration(c,$,w){const p=a($)||{},l=this.g(c?n(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,w?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(S){return typeof n(l,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,p,w?.identifier);let C=n(l,S);if(typeof C>"u")C=y;else{let P;const W=(V,q)=>{if((0,E.$3f)(V)){let A;const U=()=>{P=P||(0,I.$Tn)(l),A=A||n(P,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>A;if(P)return A=A||n(P,q),A[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(U(),A&&(A[ie]=ce),!0),deleteProperty:(K,ie)=>(U(),A&&delete A[ie],!0),defineProperty:(K,ie,ce)=>(U(),A&&Object.defineProperty(A,ie,ce),!0)})}return Array.isArray(V)?(0,I.$Tn)(V):V};C=W(C,S)}return C},update:(S,y,C,P)=>{S=c?`${c}.${S}`:S;const W=D(C);return y!==void 0?this.b.$updateConfigurationOption(W,S,y,p,P):this.b.$removeConfigurationOption(W,S,p,P)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,p,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$Tn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Tn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Tn)(y.workspace?.value),workspaceFolderValue:(0,I.$Tn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Tn)(y.default?.override),globalLanguageValue:(0,I.$Tn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Tn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Tn)(y.workspaceFolder?.override),languageIds:(0,I.$Tn)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Wn)(f,l,!1),Object.freeze(f)}g(c){const $=w=>(0,E.$3f)(w)?new Proxy(w,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return $(c)}h(c,$,w){const p=g.$io.test(c)?4:this.d.get(c),l=w?`[${w.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const w=new m.$to(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>w.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,w)=>($.set(w[0],w[1]),$),new Map)}}e.$mkc=t,e.$nkc=(0,k.$ni)("IExtHostConfiguration")}),define(Re[119],Ae([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,231,14]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=e.$Qlc=e.$Plc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(h||(h={}));var t;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(t||(t={}));var v;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(v||(v={}));var c;(function(W){function V(U){if(U){const K=U;return K&&!!K.process}else return!1}W.is=V;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=v.from(U.options)),K}W.from=q;function A(U){if(U!=null)return new M.$xN(U.process,U.args,U.options)}W.to=A})(c||(c={}));var $;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})($||($={}));var w;(function(W){function V(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=$.from(U.options)),K}W.from=q;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$yN(U.commandLine,U.options):new M.$yN(U.command,U.args?U.args:[],U.options)}W.to=A})(w||(w={}));var p;(function(W){function V(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(U){return{customExecution:"customExecution"}}W.from=q;function A(U,K){return K.get(U)}W.to=A})(p||(e.CustomExecutionDTO=p={}));var l;(function(W){function V(q,A){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=i.$SH),{id:q._id,workspaceFolder:U}}W.from=V})(l||(e.TaskHandleDTO=l={}));var D;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(D||(D={}));var f;(function(W){function V(U,K){if(U==null)return[];const ie=[];for(const ce of U){const we=q(ce,K);we&&ie.push(we)}return ie}W.fromMany=V;function q(U,K){if(U==null)return;let ie;U.execution instanceof M.$xN?ie=c.from(U.execution):U.execution instanceof M.$yN?ie=w.from(U.execution):U.execution&&U.execution instanceof M.$zN&&(ie=p.from(U.execution));const ce=h.from(U.definition);let we;return U.scope?typeof U.scope=="number"?we=U.scope:we=U.scope.uri:we=M.TaskScope.Workspace,!ce||!we?void 0:{_id:U._id,definition:ce,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:we},execution:ie,isBackground:U.isBackground,group:D.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=q;async function A(U,K,ie){if(U==null)return;let ce;c.is(U.execution)?ce=c.to(U.execution):w.is(U.execution)?ce=w.to(U.execution):p.is(U.execution)&&(ce=p.to(U._id,ie));const we=h.to(U.definition);let Ie;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Ie=U.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):Ie=M.TaskScope.Workspace),!we||!Ie)return;const ue=new M.$AN(we,Ie,U.name,U.source.label,ce,U.problemMatchers);return U.isBackground!==void 0&&(ue.isBackground=U.isBackground),U.group!==void 0&&(ue.group=M.$wN.from(U.group._id),ue.group&&U.group.isDefault&&(ue.group=new M.$wN(ue.group.id,ue.group.label),U.group.isDefault===!0&&(ue.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ue.presentationOptions=t.to(U.presentationOptions)),U._id&&(ue._id=U._id),U.detail&&(ue.detail=U.detail),ue}W.to=A})(f||(e.TaskDTO=f={}));var S;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(S||(S={}));class y{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,A,U,K,ie,ce,we){this.q=new R.$_d,this.r=new R.$_d,this.s=new R.$_d,this.u=new R.$_d,this.a=V.getProxy(O.$MM.MainThreadTask),this.b=A,this.c=U,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new M.$OM(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(U,q),new M.$OM(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(S.from(V)).then(async q=>{const A=[];for(const U of q){const K=await f.to(U,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const U=this.m.get(V.id);U&&(this.o.set(V.id,U),this.e.attachPtyToTerminal(q,await U.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const U=[],K=(0,N.$fh)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,U,A,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(U).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await f.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(U,T.CancellationToken.None);if(!K)return;this.A(K,A);const ie=f.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,A){const U=await this.a.$createTaskId(V);!A&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let U;return q?U=Promise.resolve(new y(this,V.id,q)):U=f.to(V.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,V.id,K)}),this.l.set(V.id,U),U.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let U=A.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=A.next()}};e.$Plc=C,e.$Plc=C=Je([We(0,u.$0O),We(1,b.$nP),We(2,m.$kkc),We(3,g.$iP),We(4,E.$nkc),We(5,k.$Lkc),We(6,s.$Tj),We(7,r.$1jc)],C);let P=class extends C{constructor(V,q,A,U,K,ie,ce,we){super(V,q,A,U,K,ie,ce,we),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,V);if(A===void 0)throw new Error("Task is not valid");if(p.is(A.execution))await this.y(A,q,!1);else throw new a.$_;const U=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),U}v(V,q,A,U){const K=[];if(U)for(const ie of U){if(this.A(ie,A),!ie.definition||!V[ie.definition.type]){const we=ie.source?ie.source:"No task source";this.f.warn(`The task [${we}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(ie,A.extension);ce&&p.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if(p.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$Qlc=P,e.$Qlc=P=Je([We(0,u.$0O),We(1,b.$nP),We(2,m.$kkc),We(3,g.$iP),We(4,E.$nkc),We(5,k.$Lkc),We(6,s.$Tj),We(7,r.$1jc)],P),e.$Rlc=(0,d.$ni)("IExtHostTask")}),define(Re[289],Ae([1,0,45,29]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=void 0,e.$pL=R,e.$rL=O;function R(M){return"cellResults"in M}e.$qL="rawCell#";function O(M,m){let g=-1;const E=[];let T=[];return M.forEach(u=>{u.range.startLineNumber!==g&&T.length>0&&(E.push([...T]),T=[]),T.push(u),g=u.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(u=>{const b=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let o=d;o<=n;o++)b.push(m.getLineContent(o));return new I.$6K(b.join(`
`)+`
`,u.map(o=>new N.$ht(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Re[290],Ae([1,0,169,22,5,6,28,15,17,2,43,74,4,32,8,7,34,265,112,26,12,221,289,287]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,p,l,D,f,S){this.q=l,this.r=D,this.s=f,this.t=S,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$_d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$_d,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$_d,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$_d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Yjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(u.$MM.MainThreadNotebook),this.c=w.getProxy(u.$MM.MainThreadNotebookDocuments),this.d=w.getProxy(u.$MM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,P=y.cell.handle,V=this.g.get(C)?.getCell(P);if(V)return V.apiCell}if(y&&y.$mid===14){const C=y.uri,P=this.g.get(C);if(P)return P.apiNotebook}return y}}),c.B(p)}getEditorById(w){const p=this.h.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(w){for(const[p,l]of this.h)if(l.apiEditor===w)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,p){const l=this.g.get(w);if(!l&&!p)throw new Error(`NO notebook document for '${w}'`);return l}static u(w,p){if(!p)return;const l=p.filenamePattern.map(D=>d.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,p,l){const D=c.a++,f=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,f,p);let S;return f!==void 0&&(S=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(f))),new n.$OM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,f),S?.dispose()})}async createNotebookDocument(w){const p=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&d.NotebookData.from(w.content)});return E.URI.revive(p)}async openNotebookDocument(w){const p=this.g.get(w);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(w),D=this.g.get(E.URI.revive(l));return(0,g.$_f)(D?.apiNotebook)}async showNotebookDocument(w,p){E.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let l;typeof p=="object"?l={position:d.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(d.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,l),f=D&&this.h.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,p,l,D){const f=this.f.get(w),S=E.URI.revive(p),y=this.g.get(S);if(!y||!f)return;const C=y.getCellFromIndex(l);if(!C)return;const P=await f.provideCellStatusBarItems(C.apiCell,D);if(!P)return;const W=new O.$Tc,V=this.p.add([W]),A=(Array.isArray(P)?P:[P]).map(U=>d.NotebookStatusBarItem.from(U,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,p,l,D,f){if((0,m.$Ze)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:w.identifier,location:w.extensionLocation},p,d.NotebookDocumentContentOptions.from(D),c.u(w,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$jw(d.NotebookData.from(f))}async $notebookToData(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(d.NotebookData.to(p.value),l);return N.$ze.wrap(f)}async $saveNotebook(w,p,l,D,f){const S=E.URI.revive(p),y=this.x.get(w);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new T.$cl((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const P={metadata:(0,i.$2n)(C.apiNotebook.metadata,U=>!(y.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of C.apiNotebook.getCells()){const K=new n.$eO(U.kind,U.document.getText(),U.document.languageId,U.mime,y.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,i.$2n)(U.metadata,ie=>!(y.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}const W=await y.serializer.serializeNotebook(P,f);await this.s.value.writeFile(S,W);const V=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:V.basename(S),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$nl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,p,l,D,f){const S=this.x.get(w)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(q,A,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,A,we=>{we.forEach(Ie=>{y.has(Ie)||D.some(pe=>K.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(re=>(0,v.$igb)(re,Ie)))||y.add(Ie)})}).catch(we=>{if(we.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw we})}))))})(l,f,p);const P=new M.$Bc;let W=!1;const V=Array.from(y).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if(p.maxResults&&[...P.values()].reduce((ce,we)=>ce+we.cellResults.length,0)>p.maxResults){W=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(we=>U.push({input:we.document.getText(),outputs:we.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),we=N.$ze.fromString(ce.toString()),Ie=await S.deserializeNotebook(we.buffer,f);if(f.isCancellationRequested)return;d.NotebookData.from(Ie).cells.forEach(pe=>U.push({input:pe.source,outputs:pe.outputs.flatMap(re=>re.items.map(Se=>Se.valueBytes.toString()))}))}if(f.isCancellationRequested)return;U.forEach((ce,we)=>{const Ie=p.contentPattern.pattern,ue=new h.$$Vb(ce.input,void 0,ce.outputs),pe=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),Se=re.flatMap(Le=>(0,t.$rL)(Le.matches,Le.textBuffer)).map((Le,ne)=>(Le.webviewIndex=ne,Le));if(pe.length>0||re.length>0){const Le={index:we,contentResults:(0,t.$rL)(pe,ue.inputTextBuffer),webviewResults:Se};A.push(Le)}});const ie={resource:q,cellResults:A};P.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...P.values()]}}async y(w,p){const l=await this.s.value.stat(w);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$ml&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==T.$nl({mtime:p.mtime,size:l.size}))throw new T.$cl((0,I.localize)(1,null),3,p)}z(w){return w.scheme===a.Schemas.file?w.fsPath:w.toString()}A(w,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new r.$jlc(p,this.d,w,l.visibleRanges.map(d.NotebookRange.to),l.selections.map(d.NotebookRange.to),typeof l.viewColumn=="number"?d.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const l of w.value.removedDocuments){const D=E.URI.revive(l),f=this.g.get(D);f&&(f.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(f.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(w.value.addedDocuments){const l=[];for(const D of w.value.addedDocuments){const f=E.URI.revive(D.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const S=new s.$ilc(this.c,this.q,this.r,f,D);l.push(...D.cells.map(y=>s.$hlc.asModelAddData(y))),this.g.get(f)?.dispose(),this.g.set(f,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(w.value.addedEditors)for(const l of w.value.addedEditors){if(this.h.has(l.id))return;const D=E.URI.revive(l.documentUri),f=this.g.get(D);f&&this.A(f,l.id,l)}const p=[];if(w.value.removedEditors)for(const l of w.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const f=l.has(D.id);D._acceptVisibility(f)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const p=b.$vP.String.with("notebookType","A notebook type"),l=new b.$xP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new b.$vP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>N.$ze.wrap(f))],new b.$wP("Notebook Data",f=>d.NotebookData.to(f.value))),D=new b.$xP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new b.$vP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$jw(d.NotebookData.from(f)))],new b.$wP("Bytes",f=>f.buffer));w.registerApiCommand(l),w.registerApiCommand(D)}}e.$slc=c}),define(Re[291],Ae([1,0,19,24,42,36,23,65,45]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class E{constructor(u,b,d){this.k=u,this.l=b,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$hk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$hk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((d,n)=>{const o=s=>{this.f++,u(s)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const r=s.toString(),i=I.$oc(r);this.j&&this.j(r,i)||this.v(o,{base:s,basename:i})}),Promise.all(b.map(s=>this.p(s,o))).then(s=>{d({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,R.$$i)(s)))})})}async p(u,b){const d=new N.$je,n=this.q(u),o=this.r(),s=new g.$hL(this.k,u),r=!s.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=m.$8d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),h=i.elapsed(),t=m.$8d.create();return this.g&&!this.e||(a&&a.forEach(v=>{const c=I.$hc.relative(u.folder.path,v.path);if(r){const $=I.$oc(v.path);this.v(b,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,b)}),this.g&&!this.e)?null:(this.u(o,s,b),{providerTime:h,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const b=(0,g.$gL)(this.k.includePattern,u.includePattern),d=(0,g.$gL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,d,n){if(d===this.a){const s=I.$oc(this.a);this.v(n,{base:b,relativePath:this.a,basename:s})}function o(s){const r=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:b,relativePath:s,basename:r})}o(d)}u({rootEntries:u,pathToEntries:b},d,n){const o=this,s=this.a;function r(i){const a=(0,g.$jL)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:c,basename:$}=v;if(d.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const w=b[c];if(w)r(w);else{if(c===s)continue;o.v(n,v)}if(o.e)break}}r(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,d,n){const o=this.c(u.cacheKey),s=new E(u,b,o&&o.token);let r=0;const i=a=>{r+=a.length,d(a.map(h=>this.d(h)))};return this.e(s,T.a,i,n).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new N.$je),this.b.get(u)}d(u){return u.relativePath?{resource:M.$1g(u.base,u.relativePath)}:{resource:u.base}}e(u,b,d,n){const o=n.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(r.push(i),b>0&&r.length>=b&&(d(r),r=[]))};let r=[];return u.search(s).then(i=>(r.length&&d(r),o.dispose(),i),i=>(r.length&&d(r),o.dispose(),Promise.reject(i)))}}e.$klc=T}),define(Re[292],Ae([1,0,18,260,36,96,28,12,19,23,15,17,2,95,187,48,13,49,107,288,45]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$rM=D;let h=class{constructor(S,y,C,P,W){this.a=S,this.b=y,this.c=C,this.d=P,this.e=W}text(S,y,C={}){S=this.f(S,C);const P=this.a.getValue(),W=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Ii),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const P={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(P.isCaseSensitive=!0),this.k(S)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(w):w(S),y?this.parseSearchPaths(S):{pattern:v(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),W=S.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(U=>this.q(U,y,P)):S.map(U=>this.r(U,y,P,W))).filter(U=>!!U),q={_reason:y._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ce=>(0,a.$0K)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=y.extraFileResources&&y.extraFileResources.filter(U=>(0,a.$0K)(q,U.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(S){const y=[],C=new M.$Bc,P={};let W=!1;return S.forEach(V=>{if(V.scheme===m.Schemas.walkThrough)return;if((0,E.$5g)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:g.$nc(V.fsPath)});let U=C.get(A);U||(W=!0,U={folder:A,includePattern:{}},y.push(U),C.set(A,U));const K=g.$mc(A.fsPath,V.fsPath);(0,k.$_f)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,P[V.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(T.$Rf(S.pattern,!0))return!0}else if(T.$Rf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.$yC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ie=>g.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(S)?S:c(S)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$ow)(ie,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):ie}),W=N.$K(P,ie=>y(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$$e(ie,"/")).map(ie=>T.$$e(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const U=I.$Rb(V),K=v(...U);return K&&(q.pattern=K),q}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$9K)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(P=>{let{pathPortion:W,globPortion:V}=t(P);return V&&(V=p(V)),this.n(W).flatMap(A=>this.o(A,V))}),C=new Map;return y.forEach(P=>{const W=P.searchPath.toString(),V=C.get(W);V?P.pattern&&(V.pattern=V.pattern||{},V.pattern[P.pattern]=!0):C.set(W,{searchPath:P.searchPath,pattern:P.pattern?v(P.pattern):void 0})}),Array.from(C.values())}n(S){if(g.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(g.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=w(S),S.startsWith("../")||S===".."){const P=g.$hc.resolve(y.path,S);return[{searchPath:y.with({path:P})}]}const C=p(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(W=>{const V=y.match(new RegExp(`^${T.$5e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(k.$9f);if(P.length)return P.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&p(V)}});{const W=S.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:S,q=d.localize(0,null,V);throw new Error(q)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,P=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:S.searchPath,pattern:C+"/**"}),P}q(S,y,C){const P=this.r((0,s.$Ii)(S.searchPath),y,C,!1);return P?{...P,includePattern:S.pattern}:null}r(S,y,C,P){let W;const V=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,E.$Tg)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),U={...this.l(q,y)||{},...W||{}},K=u.URI.isUri(S)?(0,E.$Xg)(S):S.name;return{folder:V,folderName:P?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$qM=h,e.$qM=h=Je([We(0,n.$Ti),We(1,s.$wi),We(2,r.$FD),We(3,o.$Tj),We(4,i.$oM)],h);function t(f){const S=f.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=f.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let P=f.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:f.substr((C.index||0)+1)}}}return{pathPortion:f}}function v(...f){return f.length?f.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(f){return R.$fk(f,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(f){return[`**/${f}/**`,`**/${f}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(f){return f.replace(/\\/g,"/")}function p(f){return w(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(f){return f.replace(/([?*[\]])/g,"[$1]")}function D(f,S){f=I.$Mb(f,P=>P.toString());const y=[],C=S.getWorkspace();return f&&f.forEach(P=>{let W;if(S.getWorkbenchState()===2)W=(0,E.$3g)(C.folders[0].uri,P),W&&W!=="."&&(W="./"+W);else{const V=S.getWorkspaceFolder(P);if(V){const q=V.name;if(C.folders.filter(U=>U.name===q).length===1){const U=(0,E.$3g)(V.uri,P);U===""?W=`./${V.name}`:W=`./${V.name}/${U}`}else W=P.fsPath}}W&&y.push(l(W))}),y}}),define(Re[293],Ae([1,0,23,2,24,14,3,292,45,49,11]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jtb=u,e.$ktb=n;const k=7e3;function u(o,s){const r=s.activationEvents;if(!r)return Promise.resolve(void 0);const i=[],a=[];for(const w of r)if(/^workspaceContains:/.test(w)){const p=w.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,T.$gh)(),v=w=>t({activationEvent:w}),c=Promise.all(i.map(w=>b(o,w,v))).then(()=>{}),$=d(o,s.identifier,a,v);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function b(o,s,r){for(const i of o.folders)if(await o.exists(I.$1g(N.URI.revive(i),s))){r(`workspaceContains:${s}`);return}}async function d(o,s,r,i){if(r.length===0)return Promise.resolve(void 0);const a=new R.$je,h=o.checkExists(o.folders,r,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},k);let v=!1;try{v=await h}catch(c){O.$4(c)||O.$1(c)}a.dispose(),clearTimeout(t),v&&i(`workspaceContains:${r.join(",")}`)}function n(o,s,r,i){const a=o.get(M.$mi),h=o.get(g.$1K),v=a.createInstance(m.$qM).file(s.map(c=>(0,E.$Ii)(N.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return h.fileSearch(v,i).then(c=>!!c.limitHit,c=>O.$4(c)?!1:Promise.reject(c))}}),define(Re[39],Ae([1,0,165,19,89,23,11,6,52,2,13,4,38,227,82,37,25,108,14,20,22,208,7,102,3,27,85,16,71,86,51,88,5,293,81,210,12,79,65,21,80]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v,c,$,w,p,l,D,f,S,y,C,P,W,V,q,A,U,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=e.$1kc=e.$Zkc=e.$Ykc=void 0,e.$Ykc=(0,c.$ni)("IHostUtils");let ce=ie=class extends m.$Uc{constructor(j,x,ve,Ne,Ee,$e,fe,Q,X,le,de,Te,he){super(),this.Y=Te,this.Z=he,this.a=this.B(new y.$_d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=fe,this.j=Ne,this.m=Ee,this.s=$e,this.t=X,this.u=le,this.w=de,this.y=this.g.getProxy(k.$MM.MainThreadWorkspace),this.z=this.g.getProxy(k.$MM.MainThreadTelemetry),this.C=this.g.getProxy(k.$MM.MainThreadExtensionService),this.D=new M.$mh,this.F=new M.$mh,this.G=new M.$mh,this.H=new M.$mh,this.I=new Le(this.f.extensions.activationEvents),this.L=new s.$B$b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Jm(this.f.extensions.myExtensions);this.J=new s.$B$b(this.I,re(this.L,Ce)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new d.$Hkc(this.g,this.s),this.N=new P.$Rkc(this.g),this.O=Q,this.h=j.createChild(new l.$li([d.$Ikc,this.M],[P.$Skc,this.N])),this.P=this.B(new b.$Gkc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,r.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(s.$B$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new b.$Fkc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(j){r.$1(j)}}async $(){this.O.onWillDeactivateAll();let j=[];try{j=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(j)}terminate(j,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${j}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Ne=>{this.s.error(Ne)}),this.g.dispose();const ve=this.$();Promise.race([(0,M.$oh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(j){return this.G.isOpen()?this.P.isActivated(j):!1}async getExtension(j){const x=await this.C.$getExtension(j);return x&&{...x,identifier:new i.$Im(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(j,x){return this.P.activateByEvent(j,x)}bb(j,x){return this.P.activateById(j,x)}activateByIdWithErrors(j,x){return this.bb(j,x).then(()=>{const ve=this.P.getActivatedExtension(j);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(j=>this.J)}getExtensionExports(j){if(this.G.isOpen())return this.P.getActivatedExtension(j).exports;try{return this.P.getActivatedExtension(j).exports}catch{return null}}async cb(j){if(j.scheme===V.Schemas.file&&this.c.fsRealpath){const x=j.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return j}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(j=>new Se(j))),this.Q}async db(j){const x=g.$ti.forUris(ve=>O.$Rg.ignorePathCasing(ve));return await Promise.all(j.map(async ve=>{if(this.wb(ve)){const Ne=await this.cb(ve.extensionLocation);x.set(Ne,ve)}})),x}eb(j){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(j))return x;const ve=this.P.getActivatedExtension(j);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Ne=>(this.s.error(Ne),Promise.resolve(void 0))))}catch(Ne){this.s.error(`An error occurred when deactivating the extension '${j.value}':`),this.s.error(Ne)}try{(0,m.$Pc)(ve.subscriptions)}catch(Ne){this.s.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.s.error(Ne)}return x}async fb(j,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(j.identifier):await this.C.$onWillActivateExtension(j.identifier),this.hb(j,x).then(ve=>{const Ne=ve.activationTimes;return this.C.$onDidActivateExtension(j.identifier,Ne.codeLoadingTime,Ne.activateCallTime,Ne.activateResolvedTime,x),this.gb(j,x,"success",Ne),ve},ve=>{throw this.gb(j,x,"failure"),ve})}gb(j,x,ve,Ne){const Ee=Ie(j,x);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Ne||{},outcome:ve})}hb(j,x){const ve=Ie(j,x);this.z.$publicLog2("activatePlugin",ve);const Ne=this.wb(j);if(!Ne)return Promise.resolve(new b.$Ekc(b.$Bkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${j.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const Ee=new b.$Ckc(x.startup);return Promise.all([this.xb(j,(0,O.$1g)(j.extensionLocation,Ne),Ee),this.ib(j)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),ie.jb(this.s,j.identifier,$e[0],$e[1],Ee))).then($e=>(R.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),$e))}ib(j){const x=this.Z.createLanguageModelAccessInformation(j),ve=new h.$Kkc(j,this.M),Ne=new h.$Jkc(j.identifier.value,!1,this.M),Ee=new W.$Tkc(j,this.N),$e=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([ve.whenReady,Ne.whenReady,this.O.whenReady]).then(()=>{const Q=this;let X,le;const de=(0,o.$uG)(j,"ipc")?this.f.messagePorts?.get(i.$Im.toKey(j.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Ne,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Te){return N.$kc(j.extensionLocation.fsPath,Te)},get storagePath(){return Q.O.workspaceValue(j)?.fsPath},get globalStoragePath(){return Q.O.globalValue(j).fsPath},get logPath(){return N.$kc(Q.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,j.identifier.value)},get storageUri(){return Q.O.workspaceValue(j)},get globalStorageUri(){return Q.O.globalValue(j)},get extensionMode(){return $e},get extension(){return X===void 0&&(X=new pe(Q,j.identifier,j,fe,!1)),X},get extensionRuntime(){return(0,o.$vG)(j,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!le){if(!de)return;const Te=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),le={onDidReceiveMessage:Te,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(j,x,ve,Ne,Ee){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(j,x,ve,Ne,Ee).then($e=>new b.$Dkc(!1,null,Ee.build(),ve,$e,Ne.subscriptions))}static kb(j,x,ve,Ne,Ee){if(typeof ve.activate=="function")try{Ee.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,fe=ve.activate.apply($e,[Ne]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(fe).then(Q=>(Ee.activateResolveStop(),Q))}catch($e){return Promise.reject($e)}else return Promise.resolve(ve)}lb(j,x){this.bb(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(j,x=0){const Ne=Date.now();(0,U.$B)(()=>{for(let Ee=x;Ee<j.length;Ee+=1){const $e=j[Ee];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Ne>50){this.mb(j,Ee);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(j=>{const x=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Ne of ve)if(Ne.activationEvents)for(const Ee of Ne.activationEvents)Ee==="onStartupFinished"&&this.lb(Ne,Ee)})}ob(){const j=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Ne=this.rb(),Ee=Promise.all([Ne,j,ve]).then(()=>{});return Promise.race([Ee,(0,M.$oh)(1e4)]).then(()=>{this.nb()}),Ee}pb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(j,x))).then(()=>{})}async qb(j,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Ne={logService:this.s,folders:j.map($e=>$e.uri),forceUsingSearch:ve||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,Q)=>this.y.$checkExists($e,fe,Q)},Ee=await(0,C.$jtb)(Ne,x);if(Ee)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Ee.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(j){throw console.error(j),j}}async sb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:x}=this.f.environment;if(!j||!x)throw new Error(I.localize(0,null));const ve=await this.xb(null,x,new b.$Ckc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Ne,Ee)=>{const $e=(X,le)=>{X?(U.$t&&this.s.error("Test runner called back with error",X),Ee(X)):(U.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Ne(typeof le=="number"&&le>0?1:0))},fe=(0,O.$Og)(x),Q=ve.run(fe,$e);Q&&Q.then&&Q.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Ne(0)}).catch(X=>{U.$t&&this.s.error("Test runner finished with error",X),Ee(X instanceof Error&&X.stack?X.stack:String(X))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$oh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,x){return this.S[j]=x,(0,m.$Sc)(()=>{delete this.S[j]})}async getRemoteExecServer(j){const{resolver:x}=await this.ub(j);return x?.resolveExecServer?.(j,{resolveAttempt:0})}async ub(j){const x=j.indexOf("+");if(x===-1)throw new t.$UM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=j.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(j,x){const ve=A.$8d.create(!1),Ne=()=>`[resolveAuthority(${(0,v.$Cl)(j)},${x})][${ve.elapsed()}ms] `,Ee=L=>this.s.info(`${Ne()}${L}`),$e=L=>this.s.warn(`${Ne()}${L}`),fe=(L,G=void 0)=>this.s.error(`${Ne()}${L}`,G),Q=L=>{if(L instanceof t.$UM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},X=async L=>{Ee(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw fe(`no resolver for ${H}`),new t.$UM(`No remote extension installed to resolve ${H}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},le=j.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(X)).catch(async L=>{if(!(L instanceof t.$UM)||L._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await X(j)]})}catch(L){return Q(L)}const Te=new M.$yh;Te.cancelAndSet(()=>Ee("waiting..."),1e3);let he,Ce;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of de.entries())try{if(L===de.length-1)Ee("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),he=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$TM.isManagedResolvedAuthority(he)?he:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$UM(`Exec server was not available for ${ee}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(se){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",se),Te.dispose(),Q(se)}Te.dispose();const Me={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${t.$TM.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let z;if(t.$TM.isManagedResolvedAuthority(he)){const L=x;this.Y.setFactory(L,he.makeConnection),z={authority:j,connectTo:new v.$zl(L),connectionToken:he.connectionToken}}else z={authority:j,connectTo:new v.$Al(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(j,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$Cl)(j)})`);const{resolver:ve}=await this.ub(j);if(!ve)return null;const Ne=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Ne;const Ee=await(0,M.$fh)(()=>ve.getCanonicalURI(Ne));return Ee||Ne}async $startExtensionHost(j){j.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:ve}=we(this.I,this.L,this.J,j),Ne=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(j,x){return x===1?this.D.wait().then(ve=>this.ab(j,!1)):this.G.wait().then(ve=>this.ab(j,!1))}async $activate(j,x){return await this.G.wait(),this.J.getExtensionDescription(j)?(await this.bb(j,x),!0):!1}async $deltaExtensions(j){j.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:ve}=we(this.I,this.L,this.J,j),Ne=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const x=a.$ze.alloc(j),ve=Math.random()%256;for(let Ne=0;Ne<j;Ne++)x.writeUInt8(ve,Ne);return x}async $updateRemoteConnectionData(j){this.X=j,this.a.fire()}};e.$Zkc=ce,e.$Zkc=ce=ie=Je([We(0,c.$mi),We(1,e.$Ykc),We(2,p.$0O),We(3,n.$kkc),We(4,u.$nkc),We(5,T.$Tj),We(6,$.$nP),We(7,w.$qkc),We(8,D.$lCb),We(9,f.$Lkc),We(10,q.$Vkc),We(11,K.$Wkc),We(12,S.$Pkc)],ce);function we(ne,j,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Ne=new s.$B$b(ne,j.getAllExtensionDescriptions());Ne.deltaExtensions(ve.toAdd,ve.toRemove);const Ee=new i.$Jm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of ve.myToRemove)Ee.delete(fe);for(const fe of ve.myToAdd)Ee.add(fe);const $e=re(Ne,Ee);return{globalRegistry:Ne,myExtensions:$e}}function Ie(ne,j){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.$1kc=(0,c.$ni)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(j,x,ve,Ne,Ee){this.#e=j,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=N.$ic((0,O.$Og)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Ne,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$2kc=pe;function re(ne,j){return ne.getAllExtensionDescriptions().filter(x=>j.has(x.identifier))}class Se{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$3kc=Se;class Le{constructor(j){this.a=new i.$Km,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)??[]}addActivationEvents(j){for(const x of Object.keys(j))this.a.set(x,j[x])}}}),define(Re[294],Ae([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let n=class{constructor(a,h,t,v,c,$,w){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.h=$,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$_lc=n,e.$_lc=n=Je([We(2,T.$mi),We(3,O.$nkc),We(4,k.$1kc),We(5,E.$nP),We(6,u.$Tj)],n);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&d.a.size){const h=(0,b.$5e)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,v,c]=h,$=d.a.get(v);if($!==void 0)return console.warn(`${v} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=d=Je([We(0,E.$nP)],o);class s{constructor(a,h,t,v,c){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Km}load(a,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((c,$)=>v+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(M.$pG,this.e,this.f)}return this.b}}let r=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$MM.MainThreadTelemetry);const v=t.getProxy(R.$MM.MainThreadWindow);this.c=(c,$)=>{const w=N.URI.parse(c);return $?this.g(c,$):w.scheme==="http"||w.scheme==="https"?v.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?v.$openUri(w,c,{}):this.g(c,$)}}load(a,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Je([We(2,g.$0O)],r)}),define(Re[120],Ae([1,0,40,6,19,73,3,67,66,39,7,37,224,38]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,M.$ni)("IExtHostVariableResolverProvider");class d extends u.$_P{constructor(s,r,i,a,h,t,v){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const w=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof T.$zO||w.input instanceof T.$EO)return w.input.modified;if(w.input instanceof T.$yO||w.input instanceof T.$DO||w.input instanceof T.$BO)return w.input.uri}}}super({getFolderUri:$=>{const w=t.folders.filter(p=>p.name===$);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,w)=>h.getConfiguration(void 0,$).get(w),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return R.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const $=c();if($){const w=r.getWorkspaceFolder($);if(w)return R.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(O.env))}}let n=class extends N.$Uc{constructor(s,r,i,a,h){super(),this.b=s,this.c=r,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$5kc=n,e.$5kc=n=Je([We(0,E.$1kc),We(1,k.$kkc),We(2,m.$iP),We(3,b.$nkc),We(4,g.$zkc)],n)}),define(Re[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,216,218,38,120,6,41,32,8]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=e.$8kc=e.$7kc=e.$6kc=void 0,e.$6kc=(0,M.$ni)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,f,S,y,C,P){this.N=D,this.O=f,this.P=S,this.Q=y,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$_d,this.o=new N.$_d,this.q=new N.$_d,this.w=new N.$_d,this.l=l.getProxy(m.$MM.MainThreadDebugService),this.A=new N.$_d,this.C=new N.$_d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(l,D){const f=this.W(D);if(!f)return;const S=await this.H.get(l)?.getTreeItem?.(f);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,f){const S=O.$Im.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,f),this.l.$registerDebugVisualizerTree(y,!!f.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const f=this.J.get(D)?.item;return f?(await this.H.get(l)?.getChildren?.(f))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,D){const f=this.J.get(l);if(!f)return;const S=await this.H.get(f.provider)?.editItem?.(f.item,D);return this.U(f.provider,S||f.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const f=[D.children];for(const S of f)if(S)for(const y of S)f.push(this.J.get(y)?.children),this.J.delete(y)}U(l,D){let f=this.I.get(D);return f||(f=this.F++,this.I.set(D,f),this.J.set(f,{provider:l,item:D})),a.DebugTreeItem.from(D,f)}asDebugSourceUri(l,D){const f=l;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${f.sourceReference}`,R.URI.parse(S)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const f of l.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,d.$9G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const f=this.L.get(l);if(!f)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:y,extensionId:C}=f;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,f.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const f=D.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,f,S){const y=this.W(f),C=this.jb(l,D),P=this.G.get(C);if(!y||!P)return[];const W=await P.provideDebugVisualization(y,S);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:P,extensionId:l});const A=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(l,V.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,f){if(!l.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=O.$Im.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,f),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const f=[],S=new Map;for(const y of D)if(y instanceof k.$PN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),f.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof k.$QN&&f.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(l){const D=l.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const f=D.filter(C=>C instanceof k.$PN).map(C=>C.id),S=D.filter(C=>C instanceof k.$QN).map(C=>C.id),y=D.filter(C=>C instanceof k.$RN).map(C=>C.id);return this.l.$unregisterBreakpoints(f,S,y)}startDebugging(l,D,f){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,f){if(!D)return new k.$OM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,f,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new k.$OM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,f){if(!f)return new k.$OM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new k.$OM(()=>{this.h=this.h.filter(y=>y.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new k.$OM(()=>{});const f=this.j++;return this.k.push({type:l,handle:f,factory:D}),new k.$OM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let f;const S=await this.ib(l);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const f=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),P=this.X(C,S);if(!P)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const W=P;return this.D.set(l,W),this.db(S).then(V=>(V&&this.E.set(l,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,U={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);U.body={signature:K},W.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,W.sendResponse(U)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,d.$bH)(q,!0),f.l.$acceptDAMessage(l,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(l,D){D=(0,d.$aH)(D,!1);const f=this.E.get(l);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const f=this.D.get(l);return this.D.delete(l),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],f=[],S=[];if(l.added)for(const y of l.added){const C=y.id;if(C&&!this.z.has(C)){let P;if(y.type==="function")P=new k.$QN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new k.$RN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const W=R.URI.revive(y.uri);P=new k.$PN(new k.$1M(W,new k.$PM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,k.$NN)(P,C),this.z.set(C,P),D.push(P)}}if(l.removed)for(const y of l.removed){const C=this.z.get(y);C&&(this.z.delete(y),f.push(C))}if(l.changed){for(const y of l.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof k.$QN&&y.type==="function"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(C instanceof k.$PN&&y.type==="source"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new k.$1M(R.URI.revive(y.uri),new k.$PM(y.line,y.character))}S.push(C)}}}this.gb(D,f,S)}async $acceptStackFrameFocus(l){let D;if(l){const f=await this.hb(l.sessionId);l.kind==="thread"?D=new k.$XN(f.api,l.threadId):D=new k.$WN(f.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,f){return(0,I.$fh)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,f,S){return(0,I.$fh)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,f,S){return(0,I.$fh)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,f,S)})}async $provideDebugAdapter(l,D){const f=this.ab(l);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(f,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof k.$SN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.$TN)return{type:"server",port:l.port,host:l.host};if(l instanceof k.$UN)return{type:"pipeServer",path:l.path};if(l instanceof k.$VN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(f=>f.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(f=>f.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(f=>f.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const f=l.configuration.type,S=this.k.filter(y=>y.type===f||y.type==="*").map(y=>(0,I.$fh)(()=>y.factory.createDebugAdapterTracker(l.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(P=>!!P);if(C.length>0)return new c(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,D){const f=D.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.$TN(f));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$fh)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,f){(l.length>0||D.length>0||f.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:f}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const f=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,f,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=R.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let f,S;return"id"in D?S=r.ThemeIcon.asClassName(D):f=D,{iconPath:f,iconClass:S}}mb(l){if(l instanceof k.$KN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,f=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof f=="string"?R.URI.file(f):f}}};e.$7kc=h,e.$7kc=h=Je([We(0,T.$0O),We(1,u.$kkc),We(2,E.$1kc),We(3,n.$nkc),We(4,g.$zkc),We(5,o.$4kc),We(6,i.$tP)],h);class t{constructor(l,D,f,S,y,C,P){this.f=l,this.g=D,this.h=f,this.j=S,this.k=y,this.l=C,this.m=P}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,f){return l.f.$customDebugAdapterRequest(l.g,D,f)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$8kc=t;class v{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$9kc=v;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(f=>f.onExit?f.onExit(l,D):void 0)}}class $ extends b.$oob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends h{constructor(l,D,f,S,y,C,P){super(l,D,f,S,y,C,P)}};e.$0kc=w,e.$0kc=w=Je([We(0,T.$0O),We(1,u.$kkc),We(2,E.$1kc),We(3,n.$nkc),We(4,g.$zkc),We(5,o.$4kc),We(6,i.$tP)],w)}),define(Re[295],Ae([1,0,14,89,2,4,244,13,55,71,27,192,16,60,39,62]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.$Tj),t=i.get(u.$0O).getProxy(O.$MM.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const c=I.$3(v);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.$Tj),h=i.get(u.$0O),t=i.get(d.$1kc),v=i.get(n.$rP),c=h.getProxy(O.$MM.MainThreadExtensionService),$=h.getProxy(O.$MM.MainThreadErrors),w=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,y){if(p.has(S))return p.get(S).stack;let C="",P,W;for(const q of y)C+=`
	at ${q.toString()}`,W=q.getFileName(),!P&&W&&(P=w.findSubstr(R.URI.file(W)));const V=`${S.name||"Error"}: ${S.message||""}${C}`;return p.set(S,{extensionIdentifier:P?.identifier,stack:V}),V}const D=Symbol("prepareStackTrace wrapped");let f=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(S){if(S===l||!S||S[D]){f=S||l;return}f=function(y,C){return l(y,C),S.call(Error,y,C)},Object.assign(f,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),C=p.get(S);if(!C?.extensionIdentifier){$.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const P=v.onExtensionError(C.extensionIdentifier,S);a.trace("forwarded error to extension?",P,C)})}}e.$amc=o;class s{constructor(i,a,h,t,v){this.a=h,this.b=new M.$J$b(i,null,t),a=s.e(a,this.b);const c=new E.$li(...(0,g.$ms)());c.set(T.$nP,{_serviceBrand:void 0,...a,messagePorts:v}),c.set(u.$0O,new u.$$O(this.b)),c.set(b.$hkc,new b.$ikc(t)),c.set(d.$Ykc,h);const $=new k.$4q(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(w=>w.get(m.$Tj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(w=>w.get(d.$1kc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(O.$MM.MainThreadExtensionService);return R.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>R.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$bmc=s}),define(Re[296],Ae([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$mlc=e.$llc=void 0,e.$nlc=n;class k{constructor(r,i,a){this.d=r,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,i){const a=this.g.folderQueries||[],h=new R.$je(i);return new Promise((t,v)=>{this.a=new b(r);let c=!1;const $=(w,p)=>{if(!c&&!this.b){const l=this.h(w);n(w)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!n(w))&&this.a.add(w,p)}};Promise.all(a.map((w,p)=>this.k(w,l=>$(l,p),h.token))).then(w=>{h.dispose(),this.a.flush();const p=w.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(w.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},w=>{h.dispose();const p=(0,O.$$i)(w);v(new Error(p))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,i){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:r.preview.text},uri:r.uri}}async k(r,i,a){const h=new T.$hL(this.g,r),t=[],v={report:w=>{if(!this.l(w))return;const p=r.folder.scheme===M.Schemas.file?(0,T.$iL)(()=>this.e.readdir(g.$Zg(w.uri))):void 0,l=g.$3g(r.folder,w.uri);if(l){const D=h.includedInQuery(l,m.$oc(l),p);(0,N.$_g)(D)?t.push(D.then(f=>{f&&i(w)})):D&&i(w)}}},c=this.n(r);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,v,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,v,a),t.length&&await Promise.all(t),$}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const i=(0,T.$gL)(this.g.includePattern,r.includePattern),a=(0,T.$gL)(this.g.excludePattern,r.excludePattern),h={folder:E.URI.from(r.folder),excludes:a,includes:i,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$llc=k;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(r,i){this.d&&(this.b!==i||!g.$Tg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:r.uri,results:[]}),this.d.results.push(d(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$mlc=b;function d(s){return n(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(r,i){this.g=r,this.h=i,this.c=0,this.d=[],this.e=0}addItem(r,i){r&&this.j(r,i)}addItems(r,i){r&&this.k(r,i)}j(r,i){this.d.push(r),this.e+=i,this.l()}k(r,i){this.d=this.d.concat(r),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$olc=o}),define(Re[122],Ae([1,0,6,4,3,291,16,60,13,2,296]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=void 0,e.$rlc=u,e.$plc=(0,R.$ni)("IExtHostSearch");let k=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(N.$MM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$klc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,r){const i=u(s),a=this.j.get(n);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(n,o,h.map(t=>t.resource))},r);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,r){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${n}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$provideAITextSearchResults(n,o,s,r){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${n}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$enableExtensionHostSearch(){}t(n,o){return new T.$llc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new T.$llc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$qlc=k,e.$qlc=k=Je([We(0,M.$0O),We(1,m.$hkc),We(2,g.$Tj)],k);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(b),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>E.URI.revive(n))}}function b(d){return{...d,folder:E.URI.revive(d.folder)}}}),define(Re[297],Ae([1,0,24,14,5,6,12,33,2,151,147,135,94,20,43,13,58,59,205,4,247,275,78,84,252,253,254,233,222,32,255,38,256,121,110,257,235,248,258,259,67,66,249,39,261,64,262,44,27,276,277,236,263,88,264,79,80,238,290,266,209,267,278,268,116,239,269,270,271,16,272,122,81,273,240,274,82,85,119,62,51,114,279,280,250,281,282,86,8,7,241,60,242,63,283,284,109,37,217,77,25,118]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v,c,$,w,p,l,D,f,S,y,C,P,W,V,q,A,U,K,ie,ce,we,Ie,ue,pe,re,Se,Le,ne,j,x,ve,Ne,Ee,$e,fe,Q,X,le,de,Te,he,Ce,Me,ze,z,L,G,H,ee,se,Oe,Be,Qe,xe,_e,et,tt,nt,ct,ft,Ue,st,Z,Y,me,He,ye,ot,dt,Pt,Bt,Xt,qt,xt,Et,Vt,Ht,Ze,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=_t;function _t(ht){const $t=ht.get(Se.$nP),ei=ht.get(re.$5jc),ti=ht.get(ue.$pkc),Lt=ht.get(we.$1kc),gt=ht.get(Et.$kkc),zt=ht.get(tt.$rP),ii=ht.get(S.$nkc),Tt=ht.get(dt.$hkc),Ke=ht.get(G.$0O),si=ht.get(xe.$Ikc),Gt=ht.get(_e.$qkc),jt=ht.get(n.$Uj),mt=ht.get(n.$Tj),Ot=ht.get(me.$lCb),Mt=ht.get(t.$1jc),Ut=ht.get(xt.$7lc),Kt=ht.get(se.$Skc),Jt=ht.get(ie.$zkc),oi=ht.get($e.$Wkc),Ct=ht.get(v.$$jc),Nt=ht.get(ve.$Pkc);Ke.set(i.$NM.ExtHostFileSystemInfo,ei),Ke.set(i.$NM.ExtHostLogLevelServiceShape,jt),Ke.set(i.$NM.ExtHostWorkspace,gt),Ke.set(i.$NM.ExtHostConfiguration,ii),Ke.set(i.$NM.ExtHostExtensionService,Lt),Ke.set(i.$NM.ExtHostStorage,si),Ke.set(i.$NM.ExtHostTunnelService,Ot),Ke.set(i.$NM.ExtHostWindow,Ut),Ke.set(i.$NM.ExtHostSecretState,Kt),Ke.set(i.$NM.ExtHostTelemetry,zt),Ke.set(i.$NM.ExtHostEditorTabs,Jt),Ke.set(i.$NM.ExtHostManagedSockets,oi),Ke.set(i.$NM.ExtHostAuthentication,Ct),Ke.set(i.$NM.ExtHostChatProvider,Nt);const It=Ke.set(i.$NM.ExtHostDecorations,ht.get(P.$_kc)),Dt=Ke.set(i.$NM.ExtHostDocumentsAndEditors,ht.get(K.$iP)),vt=Ke.set(i.$NM.ExtHostCommands,ht.get(D.$tP)),St=Ke.set(i.$NM.ExtHostTerminalService,ht.get(nt.$Lkc)),li=Ke.set(i.$NM.ExtHostTerminalShellIntegration,ht.get(ct.$Slc)),yt=Ke.set(i.$NM.ExtHostDebugService,ht.get(C.$6kc)),hi=Ke.set(i.$NM.ExtHostSearch,ht.get(ee.$plc)),Qt=Ke.set(i.$NM.ExtHostTask,ht.get(et.$Rlc)),ai=Ke.set(i.$NM.ExtHostOutputService,ht.get(Ce.$Elc)),pi=Ke.set(i.$NM.ExtHostLocalization,ht.get(Ee.$Vkc)),ni=Ke.set(i.$NM.ExtHostUrls,new Pt.$4lc(Ke)),Rt=Ke.set(i.$NM.ExtHostDocuments,new U.$8jc(Ke,Dt)),yi=Ke.set(i.$NM.ExtHostDocumentContentProviders,new q.$blc(Ke,Dt,mt)),be=Ke.set(i.$NM.ExtHostDocumentSaveParticipant,new A.$clc(mt,Rt,Ke.getProxy(i.$MM.MainThreadBulkEdits))),Pe=Ke.set(i.$NM.ExtHostNotebook,new Q.$slc(Ke,vt,Dt,Rt,ti,hi)),ae=Ke.set(i.$NM.ExtHostNotebookDocuments,new le.$ylc(Pe)),J=Ke.set(i.$NM.ExtHostNotebookEditors,new de.$zlc(mt,Pe)),ke=Ke.set(i.$NM.ExtHostNotebookKernels,new Te.$Alc(Ke,$t,Pe,vt,mt)),Ve=Ke.set(i.$NM.ExtHostNotebookRenderers,new he.$Clc(Ke,Pe)),Ye=Ke.set(i.$NM.ExtHostNotebookDocumentSaveParticipant,new X.$xlc(mt,Pe,Ke.getProxy(i.$MM.MainThreadBulkEdits))),qe=Ke.set(i.$NM.ExtHostEditors,new Ue.$ekc(Ke,Dt)),ut=Ke.set(i.$NM.ExtHostTreeViews,new Y.$2lc(Ke.getProxy(i.$MM.MainThreadTreeViews),vt,mt)),kt=Ke.set(i.$NM.ExtHostEditorInsets,new l.$fkc(Ke.getProxy(i.$MM.MainThreadEditorInsets),qe,$t.remote)),Ft=Ke.set(i.$NM.ExtHostDiagnostics,new W.$7jc(Ke,mt,ei,Dt)),Yt=Ke.set(i.$NM.ExtHostLanguages,new Ne.$vlc(Ke,Rt,vt.converter,Tt)),at=Ke.set(i.$NM.ExtHostLanguageFeatures,new x.$9jc(Ke,Tt,Rt,vt,Ft,mt,Mt,zt)),Zt=Ke.set(i.$NM.ExtHostFileSystem,new Ie.$elc(Ke,at)),mi=Ke.set(i.$NM.ExtHostFileSystemEventService,new pe.$flc(Ke,mt,Dt)),vi=Ke.set(i.$NM.ExtHostQuickOpen,(0,L.$Ilc)(Ke,gt,vt)),Di=Ke.set(i.$NM.ExtHostSCM,new H.$Klc(Ke,vt,Rt,mt)),Mi=Ke.set(i.$NM.ExtHostQuickDiff,new z.$Hlc(Ke,Tt)),Ni=Ke.set(i.$NM.ExtHostShare,new Oe.$Llc(Ke,Tt)),qi=Ke.set(i.$NM.ExtHostComments,(0,f.$gkc)(Ke,vt,Rt)),Hi=Ke.set(i.$NM.ExtHostProgress,new ze.$Glc(Ke.getProxy(i.$MM.MainThreadProgress))),Gi=Ke.set(i.$NM.ExtHostLabelService,new j.$ulc(Ke)),Si=Ke.set(i.$NM.ExtHostTheming,new st.$Ylc(Ke)),Ti=Ke.set(i.$NM.ExtHostTimeline,new Z.$1lc(Ke,vt)),Ii=Ke.set(i.$NM.ExtHostWebviews,new Bt.$ukc(Ke,$t.remote,gt,mt,Mt)),Pi=Ke.set(i.$NM.ExtHostWebviewPanels,new Xt.$xkc(Ke,Ii,gt)),Ki=Ke.set(i.$NM.ExtHostCustomEditors,new y.$ykc(Ke,Rt,Gt,Ii,Pi)),Ji=Ke.set(i.$NM.ExtHostWebviewViews,new qt.$5lc(Ke,Ii)),bi=Ke.set(i.$NM.ExtHostTesting,new ft.$Ulc(Ke,mt,vt,Dt)),Qi=Ke.set(i.$NM.ExtHostUriOpeners,new ot.$3lc(Ke)),un=Ke.set(i.$NM.ExtHostProfileContentHandlers,new Me.$Flc(Ke));Ke.set(i.$NM.ExtHostInteractive,new ne.$tlc(Ke,Pe,Dt,vt,mt));const ln=Ke.set(i.$NM.ExtHostInlineChat,new Le.$glc(Ke,vt,Rt,mt)),ki=Ke.set(i.$NM.ExtHostChatAgents2,new $.$bkc(Ke,mt,vt)),Oi=Ke.set(i.$NM.ExtHostChatVariables,new w.$ckc(Ke)),Yi=Ke.set(i.$NM.ExtHostAiRelatedInformation,new a.$Zjc(Ke)),hn=Ke.set(i.$NM.ExtHostAiEmbeddingVector,new ce.$dlc(Ke)),Fi=Ke.set(i.$NM.ExtHostStatusBar,new Qe.$Olc(Ke,vt.converter)),dn=Ke.set(i.$NM.ExtHostSpeech,new Be.$Mlc(Ke)),Li=Object.values(i.$NM);Ke.assertRegistered(Li);const Zi=new c.$akc(Ke,Dt),Xi=new p.$dkc(Ke),Ci=new fe.$wlc(Ke,mt),xi=new V.$alc(Ke);return h.$0jc.register(vt),function(je,di,fi){function it(_){return(oe,Fe,rt)=>{const bt=_(At=>{try{oe.call(Fe,At)}catch(Bi){N.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Bi.toString()}`,{cause:Bi})),zt.onExtensionError(je.identifier,Bi)}});return rt?.push(bt),bt}}const wt=function(){let _=!je.isUnderDevelopment;function oe(){_||(mt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")oe();else{const bt=rt;typeof bt.scheme>"u"&&oe(),typeof bt.exclusive=="boolean"&&(0,Ze.$vG)(je,"documentFiltersExclusive")}return rt}}(),ci={getSession(_,oe,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$vG)(je,"authLearnMore"),Ct.getSession(je,_,oe,Fe)},getSessions(_,oe){return(0,Ze.$vG)(je,"authGetSessions"),Ct.getSessions(je,_,oe)},async hasSession(_,oe){return(0,Ze.$vG)(je,"authSession"),!!await Ct.getSession(je,_,oe,{silent:!0})},get onDidChangeSessions(){return it(Ct.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Fe,rt){return Ct.registerAuthenticationProvider(_,oe,Fe,rt)}},Ri={registerCommand(_,oe,Fe){return vt.registerCommand(!0,_,oe,Fe,void 0,je)},registerTextEditorCommand(_,oe,Fe){return vt.registerCommand(!0,_,(...rt)=>{const bt=qe.getActiveTextEditor();if(!bt){mt.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(At=>{oe.apply(Fe,[bt,At,...rt])}).then(At=>{At||mt.warn("Edits from command "+_+" were not applied.")},At=>{mt.warn("An error occurred while running command "+_,At)})},void 0,void 0,je)},registerDiffInformationCommand:(_,oe,Fe)=>((0,Ze.$vG)(je,"diffCommand"),vt.registerCommand(!0,_,async(...rt)=>{const bt=Dt.activeEditor(!0);if(!bt){mt.warn("Cannot execute "+_+" because there is no active text editor.");return}const At=await qe.getDiffInformation(bt.id);oe.apply(Fe,[At,...rt])},void 0,void 0,je)),executeCommand(_,...oe){return vt.executeCommand(_,...oe)},getCommands(_=!1){return vt.getCommands(_)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Xi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return it(St.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return it(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$vG)(je,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$vG)(je,"telemetry"),it(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$qP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$pP.validateSender(_),zt.instantiateLogger(je,_,oe)},openExternal(_,oe){return Ut.openUri(_,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===$t.environment.appUriScheme)return ni.createAppUri(_);try{return await Ut.asExternalUri(_,{allowTunneling:!!$t.remote.authority})}catch(oe){if((0,M.$wg)(_,M.Schemas.http)||(0,M.$wg)(_,M.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$zm)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$vG)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return it(mt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$vG)(je,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$vG)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const _i={createTestController(_,oe,Fe){return bi.createTestController(je,_,oe,Fe)},createTestObserver(){return(0,Ze.$vG)(je,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Ze.$vG)(je,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$vG)(je,"testObserver"),it(bi.onResultsChanged)},get testResults(){return(0,Ze.$vG)(je,"testObserver"),bi.results}},Ei=$t.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,en={getExtension(_,oe){(0,Ze.$uG)(je,"extensionsAny")||(oe=!1);const Fe=di.mine.getExtensionDescription(_);if(Fe)return new we.$2kc(Lt,je.identifier,Fe,Ei,!1);if(oe){const rt=di.all.getExtensionDescription(_);if(rt)return new we.$2kc(Lt,je.identifier,rt,Ei,!0)}},get all(){const _=[];for(const oe of di.mine.getAllExtensionDescriptions())_.push(new we.$2kc(Lt,je.identifier,oe,Ei,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$vG)(je,"extensionsAny");const _=new b.$Jm(di.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),oe=[];for(const Fe of di.all.getAllExtensionDescriptions()){const rt=!_.has(Fe.identifier);oe.push(new we.$2kc(Lt,je.identifier,Fe,Ei,rt))}return oe},get onDidChange(){return(0,Ze.$uG)(je,"extensionsAny")?it(R.Event.any(di.mine.onDidChange,di.all.onDidChange)):it(di.mine.onDidChange)}},fn={createDiagnosticCollection(_){return Ft.createDiagnosticCollection(je.identifier,_)},get onDidChangeDiagnostics(){return it(Ft.onDidChangeDiagnostics)},getDiagnostics:_=>Ft.getDiagnostics(_),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(_,oe){return Yt.changeLanguage(_.uri,oe)},match(_,oe){const Fe=He.LanguageSelector.from(_);let rt;return(0,T.$St)(Fe)&&(rt=Pe.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(At=>At.document===oe))?.apiNotebook),(0,T.$Rt)(Fe,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Fe){return at.registerCodeActionProvider(je,wt(_),oe,Fe)},registerDocumentPasteEditProvider(_,oe,Fe){return(0,Ze.$vG)(je,"documentPaste"),at.registerDocumentPasteEditProvider(je,wt(_),oe,Fe)},registerCodeLensProvider(_,oe){return at.registerCodeLensProvider(je,wt(_),oe)},registerDefinitionProvider(_,oe){return at.registerDefinitionProvider(je,wt(_),oe)},registerDeclarationProvider(_,oe){return at.registerDeclarationProvider(je,wt(_),oe)},registerImplementationProvider(_,oe){return at.registerImplementationProvider(je,wt(_),oe)},registerTypeDefinitionProvider(_,oe){return at.registerTypeDefinitionProvider(je,wt(_),oe)},registerHoverProvider(_,oe){return at.registerHoverProvider(je,wt(_),oe,je.identifier)},registerEvaluatableExpressionProvider(_,oe){return at.registerEvaluatableExpressionProvider(je,wt(_),oe,je.identifier)},registerInlineValuesProvider(_,oe){return at.registerInlineValuesProvider(je,wt(_),oe,je.identifier)},registerDocumentHighlightProvider(_,oe){return at.registerDocumentHighlightProvider(je,wt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return at.registerMultiDocumentHighlightProvider(je,wt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return at.registerLinkedEditingRangeProvider(je,wt(_),oe)},registerReferenceProvider(_,oe){return at.registerReferenceProvider(je,wt(_),oe)},registerRenameProvider(_,oe){return at.registerRenameProvider(je,wt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$vG)(je,"newSymbolNamesProvider"),at.registerNewSymbolNamesProvider(je,wt(_),oe)},registerDocumentSymbolProvider(_,oe,Fe){return at.registerDocumentSymbolProvider(je,wt(_),oe,Fe)},registerWorkspaceSymbolProvider(_){return at.registerWorkspaceSymbolProvider(je,_)},registerDocumentFormattingEditProvider(_,oe){return at.registerDocumentFormattingEditProvider(je,wt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return at.registerDocumentRangeFormattingEditProvider(je,wt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Fe,...rt){return at.registerOnTypeFormattingEditProvider(je,wt(_),oe,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Fe){return at.registerDocumentSemanticTokensProvider(je,wt(_),oe,Fe)},registerDocumentRangeSemanticTokensProvider(_,oe,Fe){return at.registerDocumentRangeSemanticTokensProvider(je,wt(_),oe,Fe)},registerSignatureHelpProvider(_,oe,Fe,...rt){return typeof Fe=="object"?at.registerSignatureHelpProvider(je,wt(_),oe,Fe):at.registerSignatureHelpProvider(je,wt(_),oe,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(_,oe,...Fe){return at.registerCompletionItemProvider(je,wt(_),oe,Fe)},registerInlineCompletionItemProvider(_,oe,Fe){return oe.handleDidShowCompletionItem&&(0,Ze.$vG)(je,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$vG)(je,"inlineCompletionsAdditions"),Fe&&(0,Ze.$vG)(je,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(je,wt(_),oe,Fe)},registerInlineEditProvider(_,oe){return(0,Ze.$vG)(je,"inlineEdit"),at.registerInlineEditProvider(je,wt(_),oe)},registerDocumentLinkProvider(_,oe){return at.registerDocumentLinkProvider(je,wt(_),oe)},registerColorProvider(_,oe){return at.registerColorProvider(je,wt(_),oe)},registerFoldingRangeProvider(_,oe){return at.registerFoldingRangeProvider(je,wt(_),oe)},registerSelectionRangeProvider(_,oe){return at.registerSelectionRangeProvider(je,_,oe)},registerCallHierarchyProvider(_,oe){return at.registerCallHierarchyProvider(je,_,oe)},registerTypeHierarchyProvider(_,oe){return at.registerTypeHierarchyProvider(je,_,oe)},setLanguageConfiguration:(_,oe)=>at.setLanguageConfiguration(je,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$vG)(je,"tokenInformation"),Yt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return at.registerInlayHintsProvider(je,_,oe)},createLanguageStatusItem(_,oe){return Yt.createLanguageStatusItem(je,_,oe)},registerDocumentDropEditProvider(_,oe,Fe){return at.registerDocumentOnDropEditProvider(je,_,oe,(0,Ze.$uG)(je,"documentPaste")?Fe:void 0)}},tn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,oe,Fe){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Mt.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(ji.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,oe,Fe)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(je,_)},onDidChangeActiveTextEditor(_,oe,Fe){return it(qe.onDidChangeActiveTextEditor)(_,oe,Fe)},onDidChangeVisibleTextEditors(_,oe,Fe){return it(qe.onDidChangeVisibleTextEditors)(_,oe,Fe)},onDidChangeTextEditorSelection(_,oe,Fe){return it(qe.onDidChangeTextEditorSelection)(_,oe,Fe)},onDidChangeTextEditorOptions(_,oe,Fe){return it(qe.onDidChangeTextEditorOptions)(_,oe,Fe)},onDidChangeTextEditorVisibleRanges(_,oe,Fe){return it(qe.onDidChangeTextEditorVisibleRanges)(_,oe,Fe)},onDidChangeTextEditorViewColumn(_,oe,Fe){return it(qe.onDidChangeTextEditorViewColumn)(_,oe,Fe)},onDidCloseTerminal(_,oe,Fe){return it(St.onDidCloseTerminal)(_,oe,Fe)},onDidOpenTerminal(_,oe,Fe){return it(St.onDidOpenTerminal)(_,oe,Fe)},onDidChangeActiveTerminal(_,oe,Fe){return it(St.onDidChangeActiveTerminal)(_,oe,Fe)},onDidChangeTerminalDimensions(_,oe,Fe){return(0,Ze.$vG)(je,"terminalDimensions"),it(St.onDidChangeTerminalDimensions)(_,oe,Fe)},onDidChangeTerminalState(_,oe,Fe){return it(St.onDidChangeTerminalState)(_,oe,Fe)},onDidWriteTerminalData(_,oe,Fe){return(0,Ze.$vG)(je,"terminalDataWriteEvent"),it(St.onDidWriteTerminalData)(_,oe,Fe)},onDidExecuteTerminalCommand(_,oe,Fe){return(0,Ze.$vG)(je,"terminalExecuteCommandEvent"),it(St.onDidExecuteTerminalCommand)(_,oe,Fe)},onDidChangeTerminalShellIntegration(_,oe,Fe){return(0,Ze.$vG)(je,"terminalShellIntegration"),it(li.onDidChangeTerminalShellIntegration)(_,oe,Fe)},onDidStartTerminalShellExecution(_,oe,Fe){return(0,Ze.$vG)(je,"terminalShellIntegration"),it(li.onDidStartTerminalShellExecution)(_,oe,Fe)},onDidEndTerminalShellExecution(_,oe,Fe){return(0,Ze.$vG)(je,"terminalShellIntegration"),it(li.onDidEndTerminalShellExecution)(_,oe,Fe)},get state(){return Ut.getState(je)},onDidChangeWindowState(_,oe,Fe){return it(Ut.onDidChangeWindowState)(_,oe,Fe)},showInformationMessage(_,...oe){return Ci.showMessage(je,m.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Ci.showMessage(je,m.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Ci.showMessage(je,m.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Fe){return vi.showQuickPick(je,_,oe,Fe)},showWorkspaceFolderPick(_){return vi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return vi.showInput(_,oe)},showOpenDialog(_){return xi.showOpenDialog(je,_)},showSaveDialog(_){return xi.showSaveDialog(_)},createStatusBarItem(_,oe,Fe){let rt,bt,At;return typeof _=="string"?(rt=_,bt=oe,At=Fe):(bt=_,At=oe),Fi.createStatusBarEntry(je,rt,bt,At)},setStatusBarMessage(_,oe){return Fi.setStatusBarMessage(_,oe)},withScmProgress(_){return Mt.report("window.withScmProgress",je,"Use 'withProgress' instead."),Hi.withProgress(je,{location:ye.ProgressLocation.SourceControl},(oe,Fe)=>_({report(rt){}}))},withProgress(_,oe){return Hi.withProgress(je,_,oe)},createOutputChannel(_,oe){return ai.createOutputChannel(_,oe,je)},createWebviewPanel(_,oe,Fe,rt){return Pi.createWebviewPanel(je,_,oe,Fe,rt)},createWebviewTextEditorInset(_,oe,Fe,rt){return(0,Ze.$vG)(je,"editorInsets"),kt.createWebviewEditorInset(_,oe,Fe,rt,je)},createTerminal(_,oe,Fe){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,oe,Fe)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return St.registerProfileProvider(je,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$vG)(je,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,je.identifier.value,oe)},registerTreeDataProvider(_,oe){return ut.registerTreeDataProvider(_,oe,je)},createTreeView(_,oe){return ut.createTreeView(_,oe,je)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(je,_,oe),registerCustomEditorProvider:(_,oe,Fe={})=>Ki.registerCustomEditorProvider(je,_,oe,Fe),registerFileDecorationProvider(_){return It.registerFileDecorationProvider(_,je)},registerUriHandler(_){return ni.registerUriHandler(je,_)},createQuickPick(){return vi.createQuickPick(je)},createInputBox(){return vi.createInputBox(je)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Fe){return it(Si.onDidChangeActiveColorTheme)(_,oe,Fe)},registerWebviewViewProvider(_,oe,Fe){return Ji.registerWebviewViewProvider(je,_,oe,Fe?.webviewOptions)},get activeNotebookEditor(){return Pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Fe){return it(Pe.onDidChangeActiveNotebookEditor)(_,oe,Fe)},get visibleNotebookEditors(){return Pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return it(Pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Fe){return it(J.onDidChangeNotebookEditorSelection)(_,oe,Fe)},onDidChangeNotebookEditorVisibleRanges(_,oe,Fe){return it(J.onDidChangeNotebookEditorVisibleRanges)(_,oe,Fe)},showNotebookDocument(_,oe){return Pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Fe){return(0,Ze.$vG)(je,"externalUriOpener"),Qi.registerExternalUriOpener(je.identifier,_,oe,Fe)},registerProfileContentHandler(_,oe){return(0,Ze.$vG)(je,"profileContentHandlers"),un.registerProfileContentHandler(je,_,oe)},registerQuickDiffProvider(_,oe,Fe,rt){return(0,Ze.$vG)(je,"quickDiffProvider"),Mi.registerQuickDiffProvider(wt(_),oe,Fe,rt)},get tabGroups(){return Jt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$vG)(je,"shareProvider"),Ni.registerShareProvider(wt(_),oe)}},ji={get rootPath(){return Mt.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return gt.getWorkspaceFolder(_)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(_){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Fe)=>gt.updateWorkspaceFolders(je,_,oe||0,...Fe),onDidChangeWorkspaceFolders:function(_,oe,Fe){return it(gt.onDidChangeWorkspace)(_,oe,Fe)},asRelativePath:(_,oe)=>gt.getRelativePath(_,oe),findFiles:(_,oe,Fe,rt)=>gt.findFiles(_,oe,Fe,je.identifier,rt),findFiles2:(_,oe,Fe)=>((0,Ze.$vG)(je,"findFiles2"),gt.findFiles2(_,oe,je.identifier,Fe)),findTextInFiles:(_,oe,Fe,rt)=>{(0,Ze.$vG)(je,"findTextInFiles");let bt,At;return typeof oe=="object"?(bt=oe,At=Fe):(bt={},At=oe,rt=Fe),gt.findTextInFiles(_,bt||{},At,je.identifier,rt)},save:_=>gt.save(_),saveAs:_=>gt.saveAs(_),saveAll:_=>gt.saveAll(_),applyEdit(_,oe){return Zi.applyWorkspaceEdit(_,je,oe)},createFileSystemWatcher:(_,oe,Fe,rt)=>{let bt;return typeof oe=="boolean"?bt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Ze.$vG)(je,"createFileSystemWatcher"),bt={...oe,correlate:!0}),mi.createFileSystemWatcher(gt,je,_,bt)},get textDocuments(){return Rt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let oe;const Fe=_;if(typeof _=="string")oe=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))oe=Promise.resolve(_);else if(!Fe||typeof Fe=="object")oe=Rt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Mt.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(_,oe,Fe)=>it(Rt.onDidAddDocument)(_,oe,Fe),onDidCloseTextDocument:(_,oe,Fe)=>it(Rt.onDidRemoveDocument)(_,oe,Fe),onDidChangeTextDocument:(_,oe,Fe)=>it(Rt.onDidChangeDocument)(_,oe,Fe),onDidSaveTextDocument:(_,oe,Fe)=>it(Rt.onDidSaveDocument)(_,oe,Fe),onWillSaveTextDocument:(_,oe,Fe)=>it(be.getOnWillSaveTextDocumentEvent(je))(_,oe,Fe),get notebookDocuments(){return Pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Fe;if(g.URI.isUri(_))Fe=_,await Pe.openNotebookDocument(_);else if(typeof _=="string")Fe=g.URI.revive(await Pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return Pe.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(_,oe,Fe){return it(ae.onDidSaveNotebookDocument)(_,oe,Fe)},onDidChangeNotebookDocument(_,oe,Fe){return it(ae.onDidChangeNotebookDocument)(_,oe,Fe)},onWillSaveNotebookDocument(_,oe,Fe){return it(Ye.getOnWillSaveNotebookDocumentEvent(je))(_,oe,Fe)},get onDidOpenNotebookDocument(){return it(Pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return it(Pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Fe,rt){return Pe.registerNotebookSerializer(je,_,oe,Fe,(0,Ze.$uG)(je,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Fe)=>it(fi.onDidChangeConfiguration)(_,oe,Fe),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,fi.getConfiguration(_,oe,je)},registerTextDocumentContentProvider(_,oe){return yi.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Mt.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(je,_,oe)),registerFileSystemProvider(_,oe,Fe){return(0,O.$Rc)(Zt.registerFileSystemProvider(je,_,oe,Fe),ti.addFileSystemProvider(_,oe,Fe))},get fs(){return ti.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$vG)(je,"fileSearchProvider"),hi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$vG)(je,"textSearchProvider"),hi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$vG)(je,"aiTextSearchProvider"),(0,Ze.$vG)(je,"textSearchProvider"),hi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$vG)(je,"resolvers"),Lt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$vG)(je,"resolvers"),Gi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$vG)(je,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Fe)=>it(mi.onDidCreateFile)(_,oe,Fe),onDidDeleteFiles:(_,oe,Fe)=>it(mi.onDidDeleteFile)(_,oe,Fe),onDidRenameFiles:(_,oe,Fe)=>it(mi.onDidRenameFile)(_,oe,Fe),onWillCreateFiles:(_,oe,Fe)=>it(mi.getOnWillCreateFileEvent(je))(_,oe,Fe),onWillDeleteFiles:(_,oe,Fe)=>it(mi.getOnWillDeleteFileEvent(je))(_,oe,Fe),onWillRenameFiles:(_,oe,Fe)=>it(mi.getOnWillRenameFileEvent(je))(_,oe,Fe),openTunnel:_=>((0,Ze.$vG)(je,"tunnels"),Ot.openTunnel(je,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$vG)(je,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(_,oe,Fe)=>((0,Ze.$vG)(je,"tunnels"),it(Ot.onDidChangeTunnels)(_,oe,Fe)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$vG)(je,"portsAttributes"),Ot.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$vG)(je,"tunnelFactory"),Ot.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$vG)(je,"timeline"),Ti.registerTimelineProvider(_,oe,je.identifier,vt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:_=>((0,Ze.$vG)(je,"workspaceTrust"),gt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Fe)=>it(gt.onDidGrantWorkspaceTrust)(_,oe,Fe),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$vG)(je,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Fe)=>((0,Ze.$vG)(je,"editSessionIdentityProvider"),it(gt.getOnWillCreateEditSessionIdentityEvent(je))(_,oe,Fe)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$vG)(je,"canonicalUriProvider"),gt.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Fe)=>((0,Ze.$vG)(je,"canonicalUriProvider"),gt.provideCanonicalUri(_,oe,Fe))},gn={get inputBox(){return Mt.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(je)},createSourceControl(_,oe,Fe){return Di.createSourceControl(je,_,oe,Fe)}},mn={createCommentController(_,oe){return qi.createCommentController(je,_,oe)}},nn={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){if((0,Ze.$uG)(je,"debugFocus"))return yt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$vG)(je,"debugVisualization"),yt.registerDebugVisualizationProvider(je,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$vG)(je,"debugVisualization"),yt.registerDebugVisualizationTree(je,_,oe)},onDidStartDebugSession(_,oe,Fe){return it(yt.onDidStartDebugSession)(_,oe,Fe)},onDidTerminateDebugSession(_,oe,Fe){return it(yt.onDidTerminateDebugSession)(_,oe,Fe)},onDidChangeActiveDebugSession(_,oe,Fe){return it(yt.onDidChangeActiveDebugSession)(_,oe,Fe)},onDidReceiveDebugSessionCustomEvent(_,oe,Fe){return it(yt.onDidReceiveDebugSessionCustomEvent)(_,oe,Fe)},onDidChangeBreakpoints(_,oe,Fe){return it(yt.onDidChangeBreakpoints)(_,oe,Fe)},onDidChangeActiveStackItem(_,oe,Fe){return(0,Ze.$vG)(je,"debugFocus"),it(yt.onDidChangeActiveStackItem)(_,oe,Fe)},registerDebugConfigurationProvider(_,oe,Fe){return yt.registerDebugConfigurationProvider(_,oe,Fe||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return yt.registerDebugAdapterDescriptorFactory(je,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return yt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?yt.startDebugging(_,oe,{parentSession:Fe}):yt.startDebugging(_,oe,Fe||{})},stopDebugging(_){return yt.stopDebugging(_)},addBreakpoints(_){return yt.addBreakpoints(_)},removeBreakpoints(_){return yt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return yt.asDebugSourceUri(_,oe)}},Ui={registerTaskProvider:(_,oe)=>Qt.registerTaskProvider(je,_,oe),fetchTasks:_=>Qt.fetchTasks(_),executeTask:_=>Qt.executeTask(je,_),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(_,oe,Fe)=>it(Qt.onDidStartTask)(_,oe,Fe),onDidEndTask:(_,oe,Fe)=>it(Qt.onDidEndTask)(_,oe,Fe),onDidStartTaskProcess:(_,oe,Fe)=>it(Qt.onDidStartTaskProcess)(_,oe,Fe),onDidEndTaskProcess:(_,oe,Fe)=>it(Qt.onDidEndTaskProcess)(_,oe,Fe)},rn={createNotebookController(_,oe,Fe,rt,bt){return ke.createNotebookController(je,_,oe,Fe,rt,(0,Ze.$uG)(je,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>Pe.registerNotebookCellStatusBarItemProvider(je,_,oe),createRendererMessaging(_){return Ve.createRendererMessaging(je,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$vG)(je,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(je,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$vG)(je,"notebookKernelSource"),ke.registerKernelSourceActionProvider(je,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Fe){return(0,Ze.$vG)(je,"notebookCellExecutionState"),it(ke.onDidChangeNotebookCellExecutionState)(_,oe,Fe)}},sn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Fe=!_||typeof _[0]!="object"?_:_[0];return pi.getMessage(je.identifier.value,{message:oe,args:Fe})}return pi.getMessage(je.identifier.value,_[0])},get bundle(){return pi.getBundle(je.identifier.value)},get uri(){return pi.getBundleUri(je.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Ze.$vG)(je,"interactive"),ln.registerProvider(je,_,oe)},registerInteractiveSessionProvider(_,oe){return(0,Ze.$vG)(je,"interactive"),O.$Uc.None},transferActiveChat(_){return(0,Ze.$vG)(je,"interactive"),ki.transferActiveChat(_)}},$n={getRelatedInformation(_,oe){return(0,Ze.$vG)(je,"aiRelatedInformation"),Yi.getRelatedInformation(je,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$vG)(je,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(je,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$vG)(je,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider(je,_,oe)}},pn={registerChatResponseProvider(_,oe,Fe){return(0,Ze.$vG)(je,"chatProvider"),Nt.registerLanguageModel(je,_,oe,Fe)},registerChatVariableResolver(_,oe,Fe){return(0,Ze.$vG)(je,"chatVariableResolver"),Oi.registerVariableResolver(je,_,oe,Fe)},registerMappedEditsProvider(_,oe){return(0,Ze.$vG)(je,"mappedEditsProvider"),at.registerMappedEditsProvider(je,_,oe)},createChatParticipant(_,oe){return(0,Ze.$vG)(je,"chatParticipant"),ki.createChatAgent(je,_,oe)},createDynamicChatParticipant(_,oe,Fe,rt){return(0,Ze.$vG)(je,"chatParticipantAdditions"),ki.createDynamicChatAgent(je,_,oe,Fe,rt)}},an={get languageModels(){return(0,Ze.$vG)(je,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Fe)=>((0,Ze.$vG)(je,"languageModels"),Nt.onDidChangeProviders(_,oe,Fe)),sendChatRequest(_,oe,Fe,rt){return(0,Ze.$vG)(je,"languageModels"),Nt.sendChatRequest(je,_,oe,Fe,rt)}},cn={registerSpeechProvider(_,oe){return(0,Ze.$vG)(je,"speech"),dn.registerProvider(je.identifier,_,oe)}};return{version:$t.version,ai:$n,authentication:ci,commands:Ri,comments:mn,chat:pn,debug:nn,env:zi,extensions:en,interactive:on,l10n:sn,languages:fn,lm:an,notebooks:rn,scm:gn,speech:cn,tasks:Ui,tests:_i,window:tn,workspace:ji,Breakpoint:ye.$ON,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$JO,CallHierarchyIncomingCall:ye.$aN,CallHierarchyItem:ye.$_M,CallHierarchyOutgoingCall:ye.$bN,CancellationError:N.$5,CancellationTokenSource:I.$je,CandidatePortSource:i.CandidatePortSource,CodeAction:ye.$9M,CodeActionKind:ye.$0M,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$cN,Color:ye.$pN,ColorInformation:ye.$qN,ColorPresentation:ye.$rN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$jN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$kN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$zN,DebugAdapterExecutable:ye.$SN,DebugAdapterInlineImplementation:ye.$VN,DebugAdapterNamedPipeServer:ye.$UN,DebugAdapterServer:ye.$TN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$_N,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$3M,DiagnosticRelatedInformation:ye.$2M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$OM,DocumentHighlight:ye.$5M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$6M,DocumentLink:ye.$oN,DocumentSymbol:ye.$8M,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$YN,InlineValueText:ye.$ZN,InlineValueVariableLookup:ye.$1N,InlineValueEvaluatableExpression:ye.$2N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:R.$_d,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$bO,FileDecoration2:ye.$bO,FileSystemError:ye.$5N,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:ye.$6N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$QN,InlineCompletionItem:ye.$lN,InlineCompletionList:ye.$mN,Hover:ye.$4M,IndentAction:k.IndentAction,Location:ye.$1M,MarkdownString:ye.$dN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ye.$eN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$PM,ProcessExecution:ye.$xN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$aO,Range:ye.$QM,RelativePattern:ye.$MN,Selection:ye.$RM,SelectionRange:ye.$$M,SemanticTokens:ye.$9N,SemanticTokensBuilder:ye.$8N,SemanticTokensEdit:ye.$0N,SemanticTokensEdits:ye.$$N,SemanticTokensLegend:ye.$7N,ShellExecution:ye.$yN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$gN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$fN,SnippetString:ye.$ZM,SourceBreakpoint:ye.$PN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$7M,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$AN,TaskGroup:ye.$wN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$sN,TerminalQuickFixTerminalCommand:ye.$uN,TerminalQuickFixOpener:ye.$tN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$vN,TerminalExitReason:ye.TerminalExitReason,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$VM,SnippetTextEdit:ye.$XM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$LN,ThemeIcon:ye.$KN,TreeItem:ye.$BN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$xO,UIKind:Ht.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$YM,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$HN,DocumentDropOrPasteEditKind:ye.$IN,DocumentPasteEdit:ye.$JN,InlayHint:ye.$iN,InlayHintLabelPart:ye.$hN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$UM,ResolvedAuthority:ye.$SM,ManagedResolvedAuthority:ye.$TM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$lO,NotebookRange:ye.$dO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$eO,NotebookData:ye.$fO,NotebookRendererScript:ye.$jO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$hO,NotebookCellOutputItem:ye.$gO,NotebookCellStatusBarItem:ye.$iO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$WM,NotebookKernelSourceAction:ye.$kO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$nO,LinkedEditingRanges:ye.$mO,TestResultState:ye.TestResultState,TestRunRequest:ye.$oO,TestMessage:ye.$pO,TestTag:ye.$qO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:ye.$GN,DataTransferItem:ye.$CN,TestCoverageCount:ye.$rO,FileCoverage:ye.$tO,StatementCoverage:ye.$uO,BranchCoverage:ye.$vO,DeclarationCoverage:ye.$wO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$yO,TabInputTextDiff:ye.$zO,TabInputTextMerge:ye.$AO,TabInputCustom:ye.$BO,TabInputNotebook:ye.$DO,TabInputNotebookDiff:ye.$EO,TabInputWebview:ye.$CO,TabInputTerminal:ye.$FO,TabInputInteractiveWindow:ye.$GO,TabInputChat:ye.$HO,TabInputTextMultiDiff:ye.$IO,TelemetryTrustedValue:s.$9o,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$WN,Thread:ye.$XN,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$KO,ChatResponseFileTreePart:ye.$LO,ChatResponseAnchorPart:ye.$MO,ChatResponseProgressPart:ye.$NO,ChatResponseReferencePart:ye.$PO,ChatResponseTextEditPart:ye.$QO,ChatResponseCommandButtonPart:ye.$OO,ChatRequestTurn:ye.$RO,ChatResponseTurn:ye.$SO,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$TO,LanguageModelChatUserMessage:ye.$UO,LanguageModelChatAssistantMessage:ye.$VO,LanguageModelSystemMessage:ye.$TO,LanguageModelUserMessage:ye.$UO,LanguageModelAssistantMessage:ye.$VO,LanguageModelError:ye.$WO,NewSymbolName:ye.$4N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$XO,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Re[298],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,44,81,62,66,237,13,120,79,80,84,88,114]),function(ge,e,I,N,R,O,M,m,g,E,T,k,u,b,d,n,o,s,r,i,a,h,t,v,c,$,w,p,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$ls)($.$Vkc,$.$Ukc,1),(0,I.$ls)(v.$Uj,t.$9lc,1),(0,I.$ls)(n.$1jc,n.$2jc,1),(0,I.$ls)(m.$tP,m.$sP,0),(0,I.$ls)(p.$$jc,p.$_jc,0),(0,I.$ls)(l.$Pkc,l.$Qkc,0),(0,I.$ls)(M.$nkc,M.$lkc,0),(0,I.$ls)(s.$pkc,s.$okc,0),(0,I.$ls)(k.$6kc,k.$0kc,0),(0,I.$ls)(O.$_kc,O.$$kc,0),(0,I.$ls)(g.$iP,g.$hP,0),(0,I.$ls)(w.$Wkc,w.$Xkc,0),(0,I.$ls)(r.$5jc,r.$4jc,0),(0,I.$ls)(N.$Elc,N.$Dlc,1),(0,I.$ls)(u.$plc,u.$qlc,0),(0,I.$ls)(b.$Ikc,b.$Hkc,0),(0,I.$ls)(T.$Rlc,T.$Qlc,0),(0,I.$ls)(E.$Lkc,E.$Okc,0),(0,I.$ls)(D.$Slc,D.$Tlc,0),(0,I.$ls)(d.$lCb,d.$mCb,0),(0,I.$ls)(o.$7lc,o.$6lc,0),(0,I.$ls)(R.$kkc,R.$jkc,0),(0,I.$ls)(i.$Skc,i.$Rkc,0),(0,I.$ls)(a.$rP,a.$oP,0),(0,I.$ls)(h.$zkc,h.$Akc,0),(0,I.$ls)(c.$4kc,c.$5kc,0)}),define(Re[299],Ae([1,0,297,39,2,294,7,11,243]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;class E extends O.$_lc{j(){}getModule(b,d){for(const n of this.b){const o=n(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$Zkc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$foc);const b=this.h.invokeFunction(I.$8lc);this.r=this.h.createInstance(E,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,d,n){d=d.with({path:k(d.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(d)),r=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const i=await r.text(),a=`${d.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(w){throw console.error(o?`Loading code for extension ${o} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${d.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const v={},c={exports:v},$=w=>{const p=this.r.getModule(w,d);if(p===void 0)throw new Error(`Cannot load module '${w}'`);return p};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,v,$),c.exports!==v?c.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+b;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,m.$oh)(10)}}e.$goc=T;function k(u,b){return u.endsWith(b)?u:u+b}}),define(Re[300],Ae([1,0,70,55,13,39,207,85,299]),function(ge,e,I,N,R,O,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$ls)(R.$Tj,new I.$ki(M.$$lc,[!0],!0)),(0,N.$ls)(O.$1kc,g.$goc,0),(0,N.$ls)(m.$qkc,m.$rkc,0)}),define(Re[306],Ae([1,0,22,5,77,295,245,19,89,12,2,298,300]),function(ge,e,I,N,R,O,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function n(t){self.fetch=async function(v,c){return v instanceof Request||b(String(v))&&(v=(await t(T.URI.parse(String(v)))).toString(!0)),d(v,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,c,$,w,p){(async()=>(b(c.toString())&&(c=(await t(T.URI.parse(c.toString()))).toString(!0)),super.open(v,c,$??!0,w,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,c){if(/^file:/i.test(v.toString()))v=E.$Hg.uriToBrowserUri(T.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(f){function S(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const y=fetch.bind(self);self.fetch=function(P,W){return P instanceof Request?y(P,W):y(S(P),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,W,V,q,A){return super.open(P,S(W),V??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(S))},C(f)}.toString()}('${v}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$oc(v.toString())}`;const p=new Blob([w],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends M.$hoc{constructor(t,v){super(u,t,{name:m.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){k()}};class s{constructor(){const v=new MessageChannel,c=new N.$_d;let $=!1;u(v.port2,[v.port2]),v.port1.onmessage=w=>{const{data:p}=w;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$ze.wrap(new Uint8Array(p,0,p.byteLength));if((0,R.$Rm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:w=>{if(!$){const p=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);v.port1.postMessage(p,[p])}}}}}function r(t){return new Promise(v=>{const c=t.onMessage($=>{c.dispose();const w=JSON.parse($.toString());t.send((0,R.$Qm)(0)),v({protocol:t,initData:w})});t.send((0,R.$Qm)(1))})}let i=t=>k();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){a(v)&&r(t.protocol).then(c=>{g.mark("code/extHost/didWaitForInitData");const $=new O.$bmc(c.protocol,c.initData,o,null,v.data);n(w=>$.asBrowserUri(w)),i=w=>$.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ed6c6d3f28fa4cb66f6d73918365e41fb81db14c/core/vs/workbench/api/worker/extensionHostWorker.js.map
